/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ee=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/base/common/types","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/errors","electron","vs/base/common/network","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/product/common/productService","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/base/node/pfs","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","os","vs/base/common/strings","vs/platform/environment/electron-main/environmentMainService","vs/platform/workspace/common/workspace","vs/platform/windows/electron-main/windows","vs/base/common/uuid","vs/base/common/extpath","vs/platform/environment/common/environment","vs/platform/state/electron-main/state","vs/base/common/map","vs/base/common/process","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/objects","fs","vs/base/parts/ipc/electron-main/ipcMain","vs/base/common/json","vs/base/common/errorMessage","vs/base/common/labels","child_process","vs/base/parts/ipc/common/ipc","vs/platform/dialogs/common/dialogs","vs/platform/update/common/update","vs/base/common/functional","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/remote/common/remoteHosts","vs/platform/request/common/request","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/theme/electron-main/themeMainService","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/platform/window/common/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/normalization","crypto","net","vs/base/common/processes","vs/base/common/severity","vs/base/node/id","vs/base/node/processes","vs/base/parts/ipc/node/ipc.net","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensions/common/extensions","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/update/electron-main/abstractUpdateService","vs/platform/storage/common/storage","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/common/linkedList","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/common/encryptionService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/shell/node/shellEnv","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/symbols","vs/base/common/codicons","vs/base/common/themables","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/credentials/common/credentialsMainService","vs/platform/encryption/node/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/state/electron-main/stateMainService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetryUtils","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/launch/electron-main/launchMainService","vs/platform/utilityProcess/electron-main/utilityProcess","string_decoder","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/backup/electron-main/backupMainService","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","vs/platform/policy/node/nativePolicyService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","minimist","assert","graceful-fs","https","vscode-policy-watcher","zlib","vs/code/electron-main/main"],te=function(G){for(var e=[],I=0,A=G.length;I<A;I++)e[I]=ee[G[I]];return e};define(ee[122],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function I(P,f){const h=Math.pow(10,f);return Math.round(P*h)/h}class A{constructor(f,h,b,v=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,f))|0,this.g=Math.min(255,Math.max(0,h))|0,this.b=Math.min(255,Math.max(0,b))|0,this.a=I(Math.max(Math.min(1,v),0),3)}static equals(f,h){return f.r===h.r&&f.g===h.g&&f.b===h.b&&f.a===h.a}}e.RGBA=A;class n{constructor(f,h,b,v){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=I(Math.max(Math.min(1,h),0),3),this.l=I(Math.max(Math.min(1,b),0),3),this.a=I(Math.max(Math.min(1,v),0),3)}static equals(f,h){return f.h===h.h&&f.s===h.s&&f.l===h.l&&f.a===h.a}static fromRGBA(f){const h=f.r/255,b=f.g/255,v=f.b/255,y=f.a,g=Math.max(h,b,v),m=Math.min(h,b,v);let w=0,o=0;const u=(m+g)/2,p=g-m;if(p>0){switch(o=Math.min(u<=.5?p/(2*u):p/(2-2*u),1),g){case h:w=(b-v)/p+(b<v?6:0);break;case b:w=(v-h)/p+2;break;case v:w=(h-b)/p+4;break}w*=60,w=Math.round(w)}return new n(w,o,u,y)}static i(f,h,b){return b<0&&(b+=1),b>1&&(b-=1),b<1/6?f+(h-f)*6*b:b<1/2?h:b<2/3?f+(h-f)*(2/3-b)*6:f}static toRGBA(f){const h=f.h/360,{s:b,l:v,a:y}=f;let g,m,w;if(b===0)g=m=w=v;else{const o=v<.5?v*(1+b):v+b-v*b,u=2*v-o;g=n.i(u,o,h+1/3),m=n.i(u,o,h),w=n.i(u,o,h-1/3)}return new A(Math.round(g*255),Math.round(m*255),Math.round(w*255),y)}}e.HSLA=n;class C{constructor(f,h,b,v){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=I(Math.max(Math.min(1,h),0),3),this.v=I(Math.max(Math.min(1,b),0),3),this.a=I(Math.max(Math.min(1,v),0),3)}static equals(f,h){return f.h===h.h&&f.s===h.s&&f.v===h.v&&f.a===h.a}static fromRGBA(f){const h=f.r/255,b=f.g/255,v=f.b/255,y=Math.max(h,b,v),g=Math.min(h,b,v),m=y-g,w=y===0?0:m/y;let o;return m===0?o=0:y===h?o=((b-v)/m%6+6)%6:y===b?o=(v-h)/m+2:o=(h-b)/m+4,new C(Math.round(o*60),w,y,f.a)}static toRGBA(f){const{h,s:b,v,a:y}=f,g=v*b,m=g*(1-Math.abs(h/60%2-1)),w=v-g;let[o,u,p]=[0,0,0];return h<60?(o=g,u=m):h<120?(o=m,u=g):h<180?(u=g,p=m):h<240?(u=m,p=g):h<300?(o=m,p=g):h<=360&&(o=g,p=m),o=Math.round((o+w)*255),u=Math.round((u+w)*255),p=Math.round((p+w)*255),new A(o,u,p,y)}}e.HSVA=C;class D{static fromHex(f){return D.Format.CSS.parseHex(f)||D.red}static equals(f,h){return!f&&!h?!0:!f||!h?!1:f.equals(h)}get hsla(){return this.i?this.i:n.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:C.fromRGBA(this.rgba)}constructor(f){if(f)if(f instanceof A)this.rgba=f;else if(f instanceof n)this.i=f,this.rgba=n.toRGBA(f);else if(f instanceof C)this.j=f,this.rgba=C.toRGBA(f);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(f){return!!f&&A.equals(this.rgba,f.rgba)&&n.equals(this.hsla,f.hsla)&&C.equals(this.hsva,f.hsva)}getRelativeLuminance(){const f=D.k(this.rgba.r),h=D.k(this.rgba.g),b=D.k(this.rgba.b),v=.2126*f+.7152*h+.0722*b;return I(v,4)}static k(f){const h=f/255;return h<=.03928?h/12.92:Math.pow((h+.055)/1.055,2.4)}getContrastRatio(f){const h=this.getRelativeLuminance(),b=f.getRelativeLuminance();return h>b?(h+.05)/(b+.05):(b+.05)/(h+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(f){const h=this.getRelativeLuminance(),b=f.getRelativeLuminance();return h>b}isDarkerThan(f){const h=this.getRelativeLuminance(),b=f.getRelativeLuminance();return h<b}lighten(f){return new D(new n(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*f,this.hsla.a))}darken(f){return new D(new n(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*f,this.hsla.a))}transparent(f){const{r:h,g:b,b:v,a:y}=this.rgba;return new D(new A(h,b,v,y*f))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new D(new A(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(f){const h=f.rgba,b=this.rgba.a,v=h.a,y=b+v*(1-b);if(y<1e-6)return D.transparent;const g=this.rgba.r*b/y+h.r*v*(1-b)/y,m=this.rgba.g*b/y+h.g*v*(1-b)/y,w=this.rgba.b*b/y+h.b*v*(1-b)/y;return new D(new A(g,m,w,y))}makeOpaque(f){if(this.isOpaque()||f.rgba.a!==1)return this;const{r:h,g:b,b:v,a:y}=this.rgba;return new D(new A(f.rgba.r-y*(f.rgba.r-h),f.rgba.g-y*(f.rgba.g-b),f.rgba.b-y*(f.rgba.b-v),1))}flatten(...f){const h=f.reduceRight((b,v)=>D.o(v,b));return D.o(this,h)}static o(f,h){const b=1-f.rgba.a;return new D(new A(b*h.rgba.r+f.rgba.a*f.rgba.r,b*h.rgba.g+f.rgba.a*f.rgba.g,b*h.rgba.b+f.rgba.a*f.rgba.b))}toString(){return this.u||(this.u=D.Format.CSS.format(this)),this.u}static getLighterColor(f,h,b){if(f.isLighterThan(h))return f;b=b||.5;const v=f.getRelativeLuminance(),y=h.getRelativeLuminance();return b=b*(y-v)/y,f.lighten(b)}static getDarkerColor(f,h,b){if(f.isDarkerThan(h))return f;b=b||.5;const v=f.getRelativeLuminance(),y=h.getRelativeLuminance();return b=b*(v-y)/v,f.darken(b)}}e.Color=D,D.white=new D(new A(255,255,255,1)),D.black=new D(new A(0,0,0,1)),D.red=new D(new A(255,0,0,1)),D.blue=new D(new A(0,0,255,1)),D.green=new D(new A(0,255,0,1)),D.cyan=new D(new A(0,255,255,1)),D.lightgrey=new D(new A(211,211,211,1)),D.transparent=new D(new A(0,0,0,0)),function(P){let f;(function(h){let b;(function(v){function y(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:P.Format.CSS.formatRGBA(t)}v.formatRGB=y;function g(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}v.formatRGBA=g;function m(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:P.Format.CSS.formatHSLA(t)}v.formatHSL=m;function w(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}v.formatHSLA=w;function o(t){const a=t.toString(16);return a.length!==2?"0"+a:a}function u(t){return`#${o(t.rgba.r)}${o(t.rgba.g)}${o(t.rgba.b)}`}v.formatHex=u;function p(t,a=!1){return a&&t.rgba.a===1?P.Format.CSS.formatHex(t):`#${o(t.rgba.r)}${o(t.rgba.g)}${o(t.rgba.b)}${o(Math.round(t.rgba.a*255))}`}v.formatHexA=p;function k(t){return t.isOpaque()?P.Format.CSS.formatHex(t):P.Format.CSS.formatRGBA(t)}v.format=k;function E(t){const a=t.length;if(a===0||t.charCodeAt(0)!==35)return null;if(a===7){const i=16*M(t.charCodeAt(1))+M(t.charCodeAt(2)),r=16*M(t.charCodeAt(3))+M(t.charCodeAt(4)),c=16*M(t.charCodeAt(5))+M(t.charCodeAt(6));return new P(new A(i,r,c,1))}if(a===9){const i=16*M(t.charCodeAt(1))+M(t.charCodeAt(2)),r=16*M(t.charCodeAt(3))+M(t.charCodeAt(4)),c=16*M(t.charCodeAt(5))+M(t.charCodeAt(6)),l=16*M(t.charCodeAt(7))+M(t.charCodeAt(8));return new P(new A(i,r,c,l/255))}if(a===4){const i=M(t.charCodeAt(1)),r=M(t.charCodeAt(2)),c=M(t.charCodeAt(3));return new P(new A(16*i+i,16*r+r,16*c+c))}if(a===5){const i=M(t.charCodeAt(1)),r=M(t.charCodeAt(2)),c=M(t.charCodeAt(3)),l=M(t.charCodeAt(4));return new P(new A(16*i+i,16*r+r,16*c+c,(16*l+l)/255))}return null}v.parseHex=E;function M(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(b=h.CSS||(h.CSS={}))})(f=P.Format||(P.Format={}))}(D=e.Color||(e.Color={}))}),define(ee[55],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function I(D){return(P,f,h)=>{let b=null,v=null;if(typeof h.value=="function"?(b="value",v=h.value):typeof h.get=="function"&&(b="get",v=h.get),!v)throw new Error("not supported");h[b]=D(v,f)}}function A(D,P,f){let h=null,b=null;if(typeof f.value=="function"?(h="value",b=f.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(h="get",b=f.get),!b)throw new Error("not supported");const v=`$memoize$${P}`;f[h]=function(...y){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:b.apply(this,y)}),this[v]}}e.memoize=A;function n(D,P,f){return I((h,b)=>{const v=`$debounce$${b}`,y=`$debounce$result$${b}`;return function(...g){this[y]||(this[y]=f?f():void 0),clearTimeout(this[v]),P&&(this[y]=P(this[y],...g),g=[this[y]]),this[v]=setTimeout(()=>{h.apply(this,g),this[y]=f?f():void 0},D)}})}e.debounce=n;function C(D,P,f){return I((h,b)=>{const v=`$throttle$timer$${b}`,y=`$throttle$result$${b}`,g=`$throttle$lastRun$${b}`,m=`$throttle$pending$${b}`;return function(...w){if(this[y]||(this[y]=f?f():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),P&&(this[y]=P(this[y],...w)),this[m])return;const o=this[g]+D;o<=Date.now()?(this[g]=Date.now(),h.apply(this,[this[y]]),this[y]=f?f():void 0):(this[m]=!0,this[v]=setTimeout(()=>{this[m]=!1,this[g]=Date.now(),h.apply(this,[this[y]]),this[y]=f?f():void 0},o-Date.now()))}})}e.throttle=C}),define(ee[13],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class I{constructor(){this.b=[],this.a=function(a){setTimeout(()=>{throw a.stack?E.isErrorNoTelemetry(a)?new E(a.message+`

`+a.stack):new Error(a.message+`

`+a.stack):a},0)}}addListener(a){return this.b.push(a),()=>{this.d(a)}}c(a){this.b.forEach(i=>{i(a)})}d(a){this.b.splice(this.b.indexOf(a),1)}setUnexpectedErrorHandler(a){this.a=a}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(a){this.a(a),this.c(a)}onUnexpectedExternalError(a){this.a(a)}}e.ErrorHandler=I,e.errorHandler=new I;function A(t){e.errorHandler.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=A;function n(t){if(!t||typeof t!="object")return!1;const a=t;return a.code==="EPIPE"&&a.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=n;function C(t){h(t)||e.errorHandler.onUnexpectedError(t)}e.onUnexpectedError=C;function D(t){h(t)||e.errorHandler.onUnexpectedExternalError(t)}e.onUnexpectedExternalError=D;function P(t){if(t instanceof Error){const{name:a,message:i}=t,r=t.stacktrace||t.stack;return{$isError:!0,name:a,message:i,stack:r,noTelemetry:E.isErrorNoTelemetry(t)}}return t}e.transformErrorForSerialization=P;const f="Canceled";function h(t){return t instanceof b?!0:t instanceof Error&&t.name===f&&t.message===f}e.isCancellationError=h;class b extends Error{constructor(){super(f),this.name=this.message}}e.CancellationError=b;function v(){const t=new Error(f);return t.name=t.message,t}e.canceled=v;function y(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.illegalArgument=y;function g(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.illegalState=g;function m(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=m;function w(t){const a=new Error(`${t} has been disposed`);return a.name="DISPOSED",a}e.disposed=w;function o(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.getErrorMessage=o;class u extends Error{constructor(a){super("NotImplemented"),a&&(this.message=a)}}e.NotImplementedError=u;class p extends Error{constructor(a){super("NotSupported"),a&&(this.message=a)}}e.NotSupportedError=p;class k extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=k;class E extends Error{constructor(a){super(a),this.name="CodeExpectedError"}static fromError(a){if(a instanceof E)return a;const i=new E;return i.message=a.message,i.stack=a.stack,i}static isErrorNoTelemetry(a){return a.name==="CodeExpectedError"}}e.ErrorNoTelemetry=E;class M extends Error{constructor(a){super(a||"An unexpected bug occurred."),Object.setPrototypeOf(this,M.prototype);debugger}}e.BugIndicatingError=M}),define(ee[25],te([0,1,13]),function(G,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function A(j,$=0){return j[j.length-(1+$)]}e.tail=A;function n(j){if(j.length===0)throw new Error("Invalid tail call");return[j.slice(0,j.length-1),j[j.length-1]]}e.tail2=n;function C(j,$,q=(oe,de)=>oe===de){if(j===$)return!0;if(!j||!$||j.length!==$.length)return!1;for(let oe=0,de=j.length;oe<de;oe++)if(!q(j[oe],$[oe]))return!1;return!0}e.equals=C;function D(j,$){const q=j.length-1;$<q&&(j[$]=j[q]),j.pop()}e.removeFastWithoutKeepingOrder=D;function P(j,$,q){return f(j.length,oe=>q(j[oe],$))}e.binarySearch=P;function f(j,$){let q=0,oe=j-1;for(;q<=oe;){const de=(q+oe)/2|0,pe=$(de);if(pe<0)q=de+1;else if(pe>0)oe=de-1;else return de}return-(q+1)}e.binarySearch2=f;function h(j,$){let q=0,oe=j.length;if(oe===0)return 0;for(;q<oe;){const de=Math.floor((q+oe)/2);$(j[de])?oe=de:q=de+1}return q}e.findFirstInSorted=h;function b(j,$,q){if(j=j|0,j>=$.length)throw new TypeError("invalid index");const oe=$[Math.floor($.length*Math.random())],de=[],pe=[],ye=[];for(const Le of $){const Fe=q(Le,oe);Fe<0?de.push(Le):Fe>0?pe.push(Le):ye.push(Le)}return j<de.length?b(j,de,q):j<de.length+ye.length?ye[0]:b(j-(de.length+ye.length),pe,q)}e.quickSelect=b;function v(j,$){const q=[];let oe;for(const de of j.slice(0).sort($))!oe||$(oe[0],de)!==0?(oe=[de],q.push(oe)):oe.push(de);return q}e.groupBy=v;function y(j,$,q){const oe=[];function de(Le,Fe,Te){if(Fe===0&&Te.length===0)return;const we=oe[oe.length-1];we&&we.start+we.deleteCount===Le?(we.deleteCount+=Fe,we.toInsert.push(...Te)):oe.push({start:Le,deleteCount:Fe,toInsert:Te})}let pe=0,ye=0;for(;;){if(pe===j.length){de(pe,0,$.slice(ye));break}if(ye===$.length){de(pe,j.length-pe,[]);break}const Le=j[pe],Fe=$[ye],Te=q(Le,Fe);Te===0?(pe+=1,ye+=1):Te<0?(de(pe,1,[]),pe+=1):Te>0&&(de(pe,0,[Fe]),ye+=1)}return oe}e.sortedDiff=y;function g(j,$,q){const oe=y(j,$,q),de=[],pe=[];for(const ye of oe)de.push(...j.slice(ye.start,ye.start+ye.deleteCount)),pe.push(...ye.toInsert);return{removed:de,added:pe}}e.delta=g;function m(j,$,q){if(q===0)return[];const oe=j.slice(0,q).sort($);return o(j,$,oe,q,j.length),oe}e.top=m;function w(j,$,q,oe,de){return q===0?Promise.resolve([]):new Promise((pe,ye)=>{(async()=>{const Le=j.length,Fe=j.slice(0,q).sort($);for(let Te=q,we=Math.min(q+oe,Le);Te<Le;Te=we,we=Math.min(we+oe,Le)){if(Te>q&&await new Promise(Ce=>setTimeout(Ce)),de&&de.isCancellationRequested)throw new I.CancellationError;o(j,$,Fe,Te,we)}return Fe})().then(pe,ye)})}e.topAsync=w;function o(j,$,q,oe,de){for(const pe=q.length;oe<de;oe++){const ye=j[oe];if($(ye,q[pe-1])<0){q.pop();const Le=h(q,Fe=>$(ye,Fe)<0);q.splice(Le,0,ye)}}}function u(j){return j.filter($=>!!$)}e.coalesce=u;function p(j){let $=0;for(let q=0;q<j.length;q++)j[q]&&(j[$]=j[q],$+=1);j.length=$}e.coalesceInPlace=p;function k(j,$,q){j.splice(q,0,j.splice($,1)[0])}e.move=k;function E(j){return!Array.isArray(j)||j.length===0}e.isFalsyOrEmpty=E;function M(j){return Array.isArray(j)&&j.length>0}e.isNonEmptyArray=M;function t(j,$=q=>q){const q=new Set;return j.filter(oe=>{const de=$(oe);return q.has(de)?!1:(q.add(de),!0)})}e.distinct=t;function a(j){const $=new Set;return q=>{const oe=j(q);return $.has(oe)?!1:($.add(oe),!0)}}e.uniqueFilter=a;function i(j,$){const q=r(j,$);if(q!==-1)return j[q]}e.findLast=i;function r(j,$){for(let q=j.length-1;q>=0;q--){const oe=j[q];if($(oe))return q}return-1}e.lastIndex=r;function c(j,$){return j.length>0?j[0]:$}e.firstOrDefault=c;function l(j,$){return j.length>0?j[j.length-1]:$}e.lastOrDefault=l;function s(j,$,q=(oe,de)=>oe===de){let oe=0;for(let de=0,pe=Math.min(j.length,$.length);de<pe&&q(j[de],$[de]);de++)oe++;return oe}e.commonPrefixLength=s;function d(j){return[].concat(...j)}e.flatten=d;function S(j,$){let q=typeof $=="number"?j:0;typeof $=="number"?q=j:(q=0,$=j);const oe=[];if(q<=$)for(let de=q;de<$;de++)oe.push(de);else for(let de=q;de>$;de--)oe.push(de);return oe}e.range=S;function R(j,$,q){return j.reduce((oe,de)=>(oe[$(de)]=q?q(de):de,oe),Object.create(null))}e.index=R;function O(j,$){return j.push($),()=>N(j,$)}e.insert=O;function N(j,$){const q=j.indexOf($);if(q>-1)return j.splice(q,1),$}e.remove=N;function K(j,$,q){const oe=j.slice(0,$),de=j.slice($);return oe.concat(q,de)}e.arrayInsert=K;function V(j,$){let q;if(typeof $=="number"){let oe=$;q=()=>{const de=Math.sin(oe++)*179426549;return de-Math.floor(de)}}else q=Math.random;for(let oe=j.length-1;oe>0;oe-=1){const de=Math.floor(q()*(oe+1)),pe=j[oe];j[oe]=j[de],j[de]=pe}}e.shuffle=V;function X(j,$){const q=j.indexOf($);q>-1&&(j.splice(q,1),j.unshift($))}e.pushToStart=X;function ie(j,$){const q=j.indexOf($);q>-1&&(j.splice(q,1),j.push($))}e.pushToEnd=ie;function re(j,$){for(const q of $)j.push(q)}e.pushMany=re;function ce(j,$){return Array.isArray(j)?j.map($):$(j)}e.mapArrayOrNot=ce;function fe(j){return Array.isArray(j)?j:[j]}e.asArray=fe;function ge(j){return j[Math.floor(Math.random()*j.length)]}e.getRandomElement=ge;function x(j,$){for(const q of j){const oe=$(q);if(oe!==void 0)return oe}}e.mapFind=x;function F(j,$,q){const oe=z(j,$),de=j.length,pe=q.length;j.length=de+pe;for(let ye=de-1;ye>=oe;ye--)j[ye+pe]=j[ye];for(let ye=0;ye<pe;ye++)j[ye+oe]=q[ye]}e.insertInto=F;function W(j,$,q,oe){const de=z(j,$),pe=j.splice(de,q);return F(j,de,oe),pe}e.splice=W;function z(j,$){return $<0?Math.max($+j.length,0):Math.min($,j.length)}var J;(function(j){function $(de){return de<0}j.isLessThan=$;function q(de){return de>0}j.isGreaterThan=q;function oe(de){return de===0}j.isNeitherLessOrGreaterThan=oe,j.greaterThan=1,j.lessThan=-1,j.neitherLessOrGreaterThan=0})(J=e.CompareResult||(e.CompareResult={}));function ne(j,$){return(q,oe)=>$(j(q),j(oe))}e.compareBy=ne;function se(...j){return($,q)=>{for(const oe of j){const de=oe($,q);if(!J.isNeitherLessOrGreaterThan(de))return de}return J.neitherLessOrGreaterThan}}e.tieBreakComparators=se;const Z=(j,$)=>j-$;e.numberComparator=Z;function U(j,$){if(j.length===0)return;let q=j[0];for(let oe=1;oe<j.length;oe++){const de=j[oe];$(de,q)>0&&(q=de)}return q}e.findMaxBy=U;function L(j,$){if(j.length===0)return;let q=j[0];for(let oe=1;oe<j.length;oe++){const de=j[oe];$(de,q)>=0&&(q=de)}return q}e.findLastMaxBy=L;function T(j,$){return U(j,(q,oe)=>-$(q,oe))}e.findMinBy=T;class B{constructor($){this.f=$,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile($){let q=this.c;for(;q<this.f.length&&$(this.f[q]);)q++;const oe=q===this.c?null:this.f.slice(this.c,q);return this.c=q,oe}takeFromEndWhile($){let q=this.d;for(;q>=0&&$(this.f[q]);)q--;const oe=q===this.d?null:this.f.slice(q+1,this.d+1);return this.d=q,oe}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const $=this.f[this.c];return this.c++,$}removeLast(){const $=this.f[this.d];return this.d--,$}takeCount($){const q=this.f.slice(this.c,this.c+$);return this.c+=$,q}}e.ArrayQueue=B;class H{constructor($){this.iterate=$}forEach($){this.iterate(q=>($(q),!0))}toArray(){const $=[];return this.iterate(q=>($.push(q),!0)),$}filter($){return new H(q=>this.iterate(oe=>$(oe)?q(oe):!0))}map($){return new H(q=>this.iterate(oe=>q($(oe))))}some($){let q=!1;return this.iterate(oe=>(q=$(oe),!q)),q}findFirst($){let q;return this.iterate(oe=>$(oe)?(q=oe,!1):!0),q}findLast($){let q;return this.iterate(oe=>($(oe)&&(q=oe),!0)),q}findLastMaxBy($){let q,oe=!0;return this.iterate(de=>((oe||J.isGreaterThan($(de,q)))&&(oe=!1,q=de),!0)),q}}e.CallbackIterable=H,H.empty=new H(j=>{})}),define(ee[123],te([0,1,13]),function(G,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function A(f,h){if(!f)throw new Error(h?`Assertion failed (${h})`:"Assertion Failed")}e.ok=A;function n(f,h="Unreachable"){throw new Error(h)}e.assertNever=n;function C(f){if(!f)throw new I.BugIndicatingError("Assertion Failed")}e.assert=C;function D(f){if(!f()){debugger;f(),(0,I.onUnexpectedError)(new I.BugIndicatingError("Assertion Failed"))}}e.assertFn=D;function P(f,h){let b=0;for(;b<f.length-1;){const v=f[b],y=f[b+1];if(!h(v,y))return!1;b++}return!0}e.checkAdjacentItems=P}),define(ee[50],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function I(A){const n=this;let C=!1,D;return function(){return C||(C=!0,D=A.apply(n,arguments)),D}}e.once=I}),define(ee[70],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var I;(function(A){function n(E){return E&&typeof E=="object"&&typeof E[Symbol.iterator]=="function"}A.is=n;const C=Object.freeze([]);function D(){return C}A.empty=D;function*P(E){yield E}A.single=P;function f(E){return n(E)?E:P(E)}A.wrap=f;function h(E){return E||C}A.from=h;function b(E){return!E||E[Symbol.iterator]().next().done===!0}A.isEmpty=b;function v(E){return E[Symbol.iterator]().next().value}A.first=v;function y(E,M){for(const t of E)if(M(t))return!0;return!1}A.some=y;function g(E,M){for(const t of E)if(M(t))return t}A.find=g;function*m(E,M){for(const t of E)M(t)&&(yield t)}A.filter=m;function*w(E,M){let t=0;for(const a of E)yield M(a,t++)}A.map=w;function*o(...E){for(const M of E)for(const t of M)yield t}A.concat=o;function u(E,M,t){let a=t;for(const i of E)a=M(a,i);return a}A.reduce=u;function*p(E,M,t=E.length){for(M<0&&(M+=E.length),t<0?t+=E.length:t>E.length&&(t=E.length);M<t;M++)yield E[M]}A.slice=p;function k(E,M=Number.POSITIVE_INFINITY){const t=[];if(M===0)return[t,E];const a=E[Symbol.iterator]();for(let i=0;i<M;i++){const r=a.next();if(r.done)return[t,A.empty()];t.push(r.value)}return[t,{[Symbol.iterator](){return a}}]}A.consume=k})(I=e.Iterable||(e.Iterable={}))}),define(ee[43],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var I;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(I=e.ScanError||(e.ScanError={}));var A;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(A=e.SyntaxKind||(e.SyntaxKind={}));var n;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(n=e.ParseErrorCode||(e.ParseErrorCode={}));var C;(function(t){t.DEFAULT={allowTrailingComma:!0}})(C=e.ParseOptions||(e.ParseOptions={}));function D(t,a=!1){let i=0;const r=t.length;let c="",l=0,s=16,d=0;function S(ie){let re=0,ce=0;for(;re<ie;){const fe=t.charCodeAt(i);if(fe>=48&&fe<=57)ce=ce*16+fe-48;else if(fe>=65&&fe<=70)ce=ce*16+fe-65+10;else if(fe>=97&&fe<=102)ce=ce*16+fe-97+10;else break;i++,re++}return re<ie&&(ce=-1),ce}function R(ie){i=ie,c="",l=0,s=16,d=0}function O(){const ie=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&h(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&h(t.charCodeAt(i)))for(i++;i<t.length&&h(t.charCodeAt(i));)i++;else return d=3,t.substring(ie,i);let re=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&h(t.charCodeAt(i))){for(i++;i<t.length&&h(t.charCodeAt(i));)i++;re=i}else d=3;return t.substring(ie,re)}function N(){let ie="",re=i;for(;;){if(i>=r){ie+=t.substring(re,i),d=2;break}const ce=t.charCodeAt(i);if(ce===34){ie+=t.substring(re,i),i++;break}if(ce===92){if(ie+=t.substring(re,i),i++,i>=r){d=2;break}switch(t.charCodeAt(i++)){case 34:ie+='"';break;case 92:ie+="\\";break;case 47:ie+="/";break;case 98:ie+="\b";break;case 102:ie+="\f";break;case 110:ie+=`
`;break;case 114:ie+="\r";break;case 116:ie+="	";break;case 117:{const ge=S(4);ge>=0?ie+=String.fromCharCode(ge):d=4;break}default:d=5}re=i;continue}if(ce>=0&&ce<=31)if(f(ce)){ie+=t.substring(re,i),d=2;break}else d=6;i++}return ie}function K(){if(c="",d=0,l=i,i>=r)return l=r,s=17;let ie=t.charCodeAt(i);if(P(ie)){do i++,c+=String.fromCharCode(ie),ie=t.charCodeAt(i);while(P(ie));return s=15}if(f(ie))return i++,c+=String.fromCharCode(ie),ie===13&&t.charCodeAt(i)===10&&(i++,c+=`
`),s=14;switch(ie){case 123:return i++,s=1;case 125:return i++,s=2;case 91:return i++,s=3;case 93:return i++,s=4;case 58:return i++,s=6;case 44:return i++,s=5;case 34:return i++,c=N(),s=10;case 47:{const re=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<r&&!f(t.charCodeAt(i));)i++;return c=t.substring(re,i),s=12}if(t.charCodeAt(i+1)===42){i+=2;const ce=r-1;let fe=!1;for(;i<ce;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,fe=!0;break}i++}return fe||(i++,d=1),c=t.substring(re,i),s=13}return c+=String.fromCharCode(ie),i++,s=16}case 45:if(c+=String.fromCharCode(ie),i++,i===r||!h(t.charCodeAt(i)))return s=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=O(),s=11;default:for(;i<r&&V(ie);)i++,ie=t.charCodeAt(i);if(l!==i){switch(c=t.substring(l,i),c){case"true":return s=8;case"false":return s=9;case"null":return s=7}return s=16}return c+=String.fromCharCode(ie),i++,s=16}}function V(ie){if(P(ie)||f(ie))return!1;switch(ie){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function X(){let ie;do ie=K();while(ie>=12&&ie<=15);return ie}return{setPosition:R,getPosition:()=>i,scan:a?X:K,getToken:()=>s,getTokenValue:()=>c,getTokenOffset:()=>l,getTokenLength:()=>i-l,getTokenError:()=>d}}e.createScanner=D;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function f(t){return t===10||t===13||t===8232||t===8233}function h(t){return t>=48&&t<=57}var b;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(b||(b={}));function v(t,a){const i=[],r=new Object;let c;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let s=!1;function d(S,R,O,N){l.value=S,l.offset=R,l.length=O,l.type=N,l.colonOffset=void 0,c=l}try{k(t,{onObjectBegin:(S,R)=>{if(a<=S)throw r;c=void 0,s=a>S,i.push("")},onObjectProperty:(S,R,O)=>{if(a<R||(d(S,R,O,"property"),i[i.length-1]=S,a<=R+O))throw r},onObjectEnd:(S,R)=>{if(a<=S)throw r;c=void 0,i.pop()},onArrayBegin:(S,R)=>{if(a<=S)throw r;c=void 0,i.push(0)},onArrayEnd:(S,R)=>{if(a<=S)throw r;c=void 0,i.pop()},onLiteralValue:(S,R,O)=>{if(a<R||(d(S,R,O,M(S)),a<=R+O))throw r},onSeparator:(S,R,O)=>{if(a<=R)throw r;if(S===":"&&c&&c.type==="property")c.colonOffset=R,s=!1,c=void 0;else if(S===","){const N=i[i.length-1];typeof N=="number"?i[i.length-1]=N+1:(s=!0,i[i.length-1]=""),c=void 0}}})}catch(S){if(S!==r)throw S}return{path:i,previousNode:c,isAtPropertyKey:s,matches:S=>{let R=0;for(let O=0;R<S.length&&O<i.length;O++)if(S[R]===i[O]||S[R]==="*")R++;else if(S[R]!=="**")return!1;return R===S.length}}}e.getLocation=v;function y(t,a=[],i=C.DEFAULT){let r=null,c=[];const l=[];function s(S){Array.isArray(c)?c.push(S):r!==null&&(c[r]=S)}return k(t,{onObjectBegin:()=>{const S={};s(S),l.push(c),c=S,r=null},onObjectProperty:S=>{r=S},onObjectEnd:()=>{c=l.pop()},onArrayBegin:()=>{const S=[];s(S),l.push(c),c=S,r=null},onArrayEnd:()=>{c=l.pop()},onLiteralValue:s,onError:(S,R,O)=>{a.push({error:S,offset:R,length:O})}},i),c[0]}e.parse=y;function g(t,a=[],i=C.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(S){r.type==="property"&&(r.length=S-r.offset,r=r.parent)}function l(S){return r.children.push(S),S}k(t,{onObjectBegin:S=>{r=l({type:"object",offset:S,length:-1,parent:r,children:[]})},onObjectProperty:(S,R,O)=>{r=l({type:"property",offset:R,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:S,offset:R,length:O,parent:r})},onObjectEnd:(S,R)=>{r.length=S+R-r.offset,r=r.parent,c(S+R)},onArrayBegin:(S,R)=>{r=l({type:"array",offset:S,length:-1,parent:r,children:[]})},onArrayEnd:(S,R)=>{r.length=S+R-r.offset,r=r.parent,c(S+R)},onLiteralValue:(S,R,O)=>{l({type:M(S),offset:R,length:O,parent:r,value:S}),c(R+O)},onSeparator:(S,R,O)=>{r.type==="property"&&(S===":"?r.colonOffset=R:S===","&&c(R))},onError:(S,R,O)=>{a.push({error:S,offset:R,length:O})}},i);const d=r.children[0];return d&&delete d.parent,d}e.parseTree=g;function m(t,a){if(!t)return;let i=t;for(const r of a)if(typeof r=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let c=!1;for(const l of i.children)if(Array.isArray(l.children)&&l.children[0].value===r){i=l.children[1],c=!0;break}if(!c)return}else{const c=r;if(i.type!=="array"||c<0||!Array.isArray(i.children)||c>=i.children.length)return;i=i.children[c]}return i}e.findNodeAtLocation=m;function w(t){if(!t.parent||!t.parent.children)return[];const a=w(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;a.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&a.push(i)}return a}e.getNodePath=w;function o(t){switch(t.type){case"array":return t.children.map(o);case"object":{const a=Object.create(null);for(const i of t.children){const r=i.children[1];r&&(a[i.children[0].value]=o(r))}return a}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=o;function u(t,a,i=!1){return a>=t.offset&&a<t.offset+t.length||i&&a===t.offset+t.length}e.contains=u;function p(t,a,i=!1){if(u(t,a,i)){const r=t.children;if(Array.isArray(r))for(let c=0;c<r.length&&r[c].offset<=a;c++){const l=p(r[c],a,i);if(l)return l}return t}}e.findNodeAtOffset=p;function k(t,a,i=C.DEFAULT){const r=D(t,!1);function c(ne){return ne?()=>ne(r.getTokenOffset(),r.getTokenLength()):()=>!0}function l(ne){return ne?se=>ne(se,r.getTokenOffset(),r.getTokenLength()):()=>!0}const s=c(a.onObjectBegin),d=l(a.onObjectProperty),S=c(a.onObjectEnd),R=c(a.onArrayBegin),O=c(a.onArrayEnd),N=l(a.onLiteralValue),K=l(a.onSeparator),V=c(a.onComment),X=l(a.onError),ie=i&&i.disallowComments,re=i&&i.allowTrailingComma;function ce(){for(;;){const ne=r.scan();switch(r.getTokenError()){case 4:fe(14);break;case 5:fe(15);break;case 3:fe(13);break;case 1:ie||fe(11);break;case 2:fe(12);break;case 6:fe(16);break}switch(ne){case 12:case 13:ie?fe(10):V();break;case 16:fe(1);break;case 15:case 14:break;default:return ne}}}function fe(ne,se=[],Z=[]){if(X(ne),se.length+Z.length>0){let U=r.getToken();for(;U!==17;){if(se.indexOf(U)!==-1){ce();break}else if(Z.indexOf(U)!==-1)break;U=ce()}}}function ge(ne){const se=r.getTokenValue();return ne?N(se):d(se),ce(),!0}function x(){switch(r.getToken()){case 11:{let ne=0;try{ne=JSON.parse(r.getTokenValue()),typeof ne!="number"&&(fe(2),ne=0)}catch{fe(2)}N(ne);break}case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return ce(),!0}function F(){return r.getToken()!==10?(fe(3,[],[2,5]),!1):(ge(!1),r.getToken()===6?(K(":"),ce(),J()||fe(4,[],[2,5])):fe(5,[],[2,5]),!0)}function W(){s(),ce();let ne=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(ne||fe(4,[],[]),K(","),ce(),r.getToken()===2&&re)break}else ne&&fe(6,[],[]);F()||fe(4,[],[2,5]),ne=!0}return S(),r.getToken()!==2?fe(7,[2],[]):ce(),!0}function z(){R(),ce();let ne=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(ne||fe(4,[],[]),K(","),ce(),r.getToken()===4&&re)break}else ne&&fe(6,[],[]);J()||fe(4,[],[4,5]),ne=!0}return O(),r.getToken()!==4?fe(8,[4],[]):ce(),!0}function J(){switch(r.getToken()){case 3:return z();case 1:return W();case 10:return ge(!0);default:return x()}}return ce(),r.getToken()===17?i.allowEmptyContent?!0:(fe(4,[],[]),!1):J()?(r.getToken()!==17&&fe(9,[],[]),!0):(fe(4,[],[]),!1)}e.visit=k;function E(t,a){const i=D(t),r=[];let c,l=0,s;do switch(s=i.getPosition(),c=i.scan(),c){case 12:case 13:case 17:l!==s&&r.push(t.substring(l,s)),a!==void 0&&r.push(i.getTokenValue().replace(/[^\r\n]/g,a)),l=i.getPosition();break}while(c!==17);return r.join("")}e.stripComments=E;function M(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=M}),define(ee[124],te([0,1,43]),function(G,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function A(h,b,v){let y,g,m,w,o;if(b){for(w=b.offset,o=w+b.length,m=w;m>0&&!f(h,m-1);)m--;let s=o;for(;s<h.length&&!f(h,s);)s++;g=h.substring(m,s),y=D(g,v)}else g=h,y=0,m=0,w=0,o=h.length;const u=P(v,h);let p=!1,k=0,E;v.insertSpaces?E=C(" ",v.tabSize||4):E="	";const M=(0,I.createScanner)(g,!1);let t=!1;function a(){return u+C(E,y+k)}function i(){let s=M.scan();for(p=!1;s===15||s===14;)p=p||s===14,s=M.scan();return t=s===16||M.getTokenError()!==0,s}const r=[];function c(s,d,S){!t&&d<o&&S>w&&h.substring(d,S)!==s&&r.push({offset:d,length:S-d,content:s})}let l=i();if(l!==17){const s=M.getTokenOffset()+m,d=C(E,y);c(d,m,s)}for(;l!==17;){let s=M.getTokenOffset()+M.getTokenLength()+m,d=i(),S="";for(;!p&&(d===12||d===13);){const O=M.getTokenOffset()+m;c(" ",s,O),s=M.getTokenOffset()+M.getTokenLength()+m,S=d===12?a():"",d=i()}if(d===2)l!==1&&(k--,S=a());else if(d===4)l!==3&&(k--,S=a());else{switch(l){case 3:case 1:k++,S=a();break;case 5:case 12:S=a();break;case 13:p?S=a():S=" ";break;case 6:S=" ";break;case 10:if(d===6){S="";break}case 7:case 8:case 9:case 11:case 2:case 4:d===12||d===13?S=" ":d!==5&&d!==17&&(t=!0);break;case 16:t=!0;break}p&&(d===12||d===13)&&(S=a())}const R=M.getTokenOffset()+m;c(S,s,R),l=d}return r}e.format=A;function n(h,b){const v=JSON.stringify(h,void 0,b.insertSpaces?b.tabSize||4:"	");return b.eol!==void 0?v.replace(/\r\n|\r|\n/g,b.eol):v}e.toFormattedString=n;function C(h,b){let v="";for(let y=0;y<b;y++)v+=h;return v}function D(h,b){let v=0,y=0;const g=b.tabSize||4;for(;v<h.length;){const m=h.charAt(v);if(m===" ")y++;else if(m==="	")y+=g;else break;v++}return Math.floor(y/g)}function P(h,b){for(let v=0;v<b.length;v++){const y=b.charAt(v);if(y==="\r")return v+1<b.length&&b.charAt(v+1)===`
`?`\r
`:"\r";if(y===`
`)return`
`}return h&&h.eol||`
`}e.getEOL=P;function f(h,b){return`\r
`.indexOf(h.charAt(b))!==-1}e.isEOL=f}),define(ee[125],te([0,1,43,124]),function(G,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function n(h,b,v){return C(h,b,void 0,v)}e.removeProperty=n;function C(h,b,v,y,g){const m=b.slice(),w=[],o=(0,I.parseTree)(h,w);let u,p;for(;m.length>0&&(p=m.pop(),u=(0,I.findNodeAtLocation)(o,m),u===void 0&&v!==void 0);)typeof p=="string"?v={[p]:v}:v=[v];if(u)if(u.type==="object"&&typeof p=="string"&&Array.isArray(u.children)){const k=(0,I.findNodeAtLocation)(u,[p]);if(k!==void 0)if(v===void 0){if(!k.parent)throw new Error("Malformed AST");const E=u.children.indexOf(k.parent);let M,t=k.parent.offset+k.parent.length;if(E>0){const a=u.children[E-1];M=a.offset+a.length}else M=u.offset+1,u.children.length>1&&(t=u.children[1].offset);return D(h,{offset:M,length:t-M,content:""},y)}else return D(h,{offset:k.offset,length:k.length,content:JSON.stringify(v)},y);else{if(v===void 0)return[];const E=`${JSON.stringify(p)}: ${JSON.stringify(v)}`,M=g?g(u.children.map(a=>a.children[0].value)):u.children.length;let t;if(M>0){const a=u.children[M-1];t={offset:a.offset+a.length,length:0,content:","+E}}else u.children.length===0?t={offset:u.offset+1,length:0,content:E}:t={offset:u.offset+1,length:0,content:E+","};return D(h,t,y)}}else if(u.type==="array"&&typeof p=="number"&&Array.isArray(u.children))if(v!==void 0){const k=`${JSON.stringify(v)}`;let E;if(u.children.length===0||p===0)E={offset:u.offset+1,length:0,content:u.children.length===0?k:k+","};else{const M=p===-1||p>u.children.length?u.children.length:p,t=u.children[M-1];E={offset:t.offset+t.length,length:0,content:","+k}}return D(h,E,y)}else{const k=p,E=u.children[k];let M;if(u.children.length===1)M={offset:u.offset+1,length:u.length-2,content:""};else if(u.children.length-1===k){const t=u.children[k-1],a=t.offset+t.length,i=u.offset+u.length;M={offset:a,length:i-2-a,content:""}}else M={offset:E.offset,length:u.children[k+1].offset-E.offset,content:""};return D(h,M,y)}else throw new Error(`Can not add ${typeof p!="number"?"index":"property"} to parent of type ${u.type}`);else{if(v===void 0)throw new Error("Can not delete in empty document");return D(h,{offset:o?o.offset:0,length:o?o.length:0,content:JSON.stringify(v)},y)}}e.setProperty=C;function D(h,b,v){let y=P(h,b),g=b.offset,m=b.offset+b.content.length;if(b.length===0||b.content.length===0){for(;g>0&&!(0,A.isEOL)(y,g-1);)g--;for(;m<y.length&&!(0,A.isEOL)(y,m);)m++}const w=(0,A.format)(y,{offset:g,length:m-g},v);for(let u=w.length-1;u>=0;u--){const p=w[u];y=P(y,p),g=Math.min(g,p.offset),m=Math.max(m,p.offset+p.length),m+=p.content.length-p.length}const o=h.length-(y.length-m)-g;return[{offset:g,length:o,content:y.substring(g,m)}]}e.withFormatting=D;function P(h,b){return h.substring(0,b.offset)+b.content+h.substring(b.offset+b.length)}e.applyEdit=P;function f(h,b){const v=b.slice(0).sort((g,m)=>{const w=g.offset-m.offset;return w===0?g.length-m.length:w});let y=h.length;for(let g=v.length-1;g>=0;g--){const m=v[g];if(m.offset+m.length<=y)h=P(h,m);else throw new Error("Overlapping edit");y=m.offset}return h}e.applyEdits=f}),define(ee[126],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class I{constructor(n){this.d=n,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(n){this.c=n}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=I}),define(ee[2],te([0,1,50,70]),function(G,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const n=!1;let C=null;function D(l){C=l}if(e.setDisposableTracker=D,n){const l="__is_disposable_tracked__";D(new class{trackDisposable(s){const d=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[l]||console.log(d)},3e3)}setParent(s,d){if(s&&s!==p.None)try{s[l]=!0}catch{}}markAsDisposed(s){if(s&&s!==p.None)try{s[l]=!0}catch{}}markAsSingleton(s){}})}function P(l){return C?.trackDisposable(l),l}function f(l){C?.markAsDisposed(l)}function h(l,s){C?.setParent(l,s)}function b(l,s){if(!!C)for(const d of l)C.setParent(d,s)}function v(l){return C?.markAsSingleton(l),l}e.markAsSingleton=v;function y(l){return typeof l.dispose=="function"&&l.dispose.length===0}e.isDisposable=y;function g(l){if(A.Iterable.is(l)){const s=[];for(const d of l)if(d)try{d.dispose()}catch(S){s.push(S)}if(s.length===1)throw s[0];if(s.length>1)throw new AggregateError(s,"Encountered errors while disposing of store");return Array.isArray(l)?[]:l}else if(l)return l.dispose(),l}e.dispose=g;function m(l){for(const s of l)y(s)&&s.dispose();return[]}e.disposeIfDisposable=m;function w(...l){const s=o(()=>g(l));return b(l,s),s}e.combinedDisposable=w;function o(l){const s=P({dispose:(0,I.once)(()=>{f(s),l()})});return s}e.toDisposable=o;class u{constructor(){this.c=new Set,this.f=!1,P(this)}dispose(){this.f||(f(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{g(this.c)}finally{this.c.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return h(s,this),this.f?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(s),s}}e.DisposableStore=u,u.DISABLE_DISPOSED_WARNING=!1;class p{constructor(){this.q=new u,P(this),h(this.q,this)}dispose(){f(this),this.q.dispose()}B(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(s)}}e.Disposable=p,p.None=Object.freeze({dispose(){}});class k{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(s){this.b||s===this.a||(this.a?.dispose(),s&&h(s,this),this.a=s)}clear(){this.value=void 0}dispose(){this.b=!0,f(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const s=this.a;return this.a=void 0,s&&h(s,null),s}}e.MutableDisposable=k;class E{constructor(s){this.b=s,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=E;class M{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(s){let d=s;return this.unset=()=>d=void 0,this.isset=()=>d!==void 0,this.dispose=()=>{d&&(d(),d=void 0,f(this))},this}}e.SafeDisposable=M;class t{constructor(){this.a=new Map}acquire(s,...d){let S=this.a.get(s);S||(S={counter:0,object:this.b(s,...d)},this.a.set(s,S));const{object:R}=S,O=(0,I.once)(()=>{--S.counter===0&&(this.c(s,S.object),this.a.delete(s))});return S.counter++,{object:R,dispose:O}}}e.ReferenceCollection=t;class a{constructor(s){this.a=s}async acquire(s,...d){const S=this.a.acquire(s,...d);try{return{object:await S.object,dispose:()=>S.dispose()}}catch(R){throw S.dispose(),R}}}e.AsyncReferenceCollection=a;class i{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=i;function r(l){const s=new u;try{l(s)}finally{s.dispose()}}e.disposeOnReturn=r;class c{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){f(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{g(this.a.values())}finally{this.a.clear()}}has(s){return this.a.has(s)}get(s){return this.a.get(s)}set(s,d,S=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),S||this.a.get(s)?.dispose(),this.a.set(s,d)}deleteAndDispose(s){this.a.get(s)?.dispose(),this.a.delete(s)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=c}),define(ee[99],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class I{constructor(C){this.element=C,this.next=I.Undefined,this.prev=I.Undefined}}I.Undefined=new I(void 0);class A{constructor(){this.a=I.Undefined,this.b=I.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===I.Undefined}clear(){let C=this.a;for(;C!==I.Undefined;){const D=C.next;C.prev=I.Undefined,C.next=I.Undefined,C=D}this.a=I.Undefined,this.b=I.Undefined,this.c=0}unshift(C){return this.d(C,!1)}push(C){return this.d(C,!0)}d(C,D){const P=new I(C);if(this.a===I.Undefined)this.a=P,this.b=P;else if(D){const h=this.b;this.b=P,P.prev=h,h.next=P}else{const h=this.a;this.a=P,P.next=h,h.prev=P}this.c+=1;let f=!1;return()=>{f||(f=!0,this.e(P))}}shift(){if(this.a!==I.Undefined){const C=this.a.element;return this.e(this.a),C}}pop(){if(this.b!==I.Undefined){const C=this.b.element;return this.e(this.b),C}}e(C){if(C.prev!==I.Undefined&&C.next!==I.Undefined){const D=C.prev;D.next=C.next,C.next.prev=D}else C.prev===I.Undefined&&C.next===I.Undefined?(this.a=I.Undefined,this.b=I.Undefined):C.next===I.Undefined?(this.b=this.b.prev,this.b.next=I.Undefined):C.prev===I.Undefined&&(this.a=this.a.next,this.a.prev=I.Undefined);this.c-=1}*[Symbol.iterator](){let C=this.a;for(;C!==I.Undefined;)yield C.element,C=C.next}}e.LinkedList=A}),define(ee[35],te([0,1]),function(G,e){"use strict";var I,A,n;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function C(m,w,o){let u=m.get(w);return u===void 0&&(u=o,m.set(w,u)),u}e.getOrSet=C;function D(m){const w=[];return m.forEach((o,u)=>{w.push(`${u} => ${o}`)}),`Map(${m.size}) {${w.join(", ")}}`}e.mapToString=D;function P(m){const w=[];return m.forEach(o=>{w.push(o)}),`Set(${m.size}) {${w.join(", ")}}`}e.setToString=P;class f{constructor(w,o){this.uri=w,this.value=o}}class h{constructor(w,o){this[I]="ResourceMap",w instanceof h?(this.b=new Map(w.b),this.c=o??h.a):(this.b=new Map,this.c=w??h.a)}set(w,o){return this.b.set(this.c(w),new f(w,o)),this}get(w){return this.b.get(this.c(w))?.value}has(w){return this.b.has(this.c(w))}get size(){return this.b.size}clear(){this.b.clear()}delete(w){return this.b.delete(this.c(w))}forEach(w,o){typeof o<"u"&&(w=w.bind(o));for(const[u,p]of this.b)w(p.value,p.uri,this)}*values(){for(const w of this.b.values())yield w.value}*keys(){for(const w of this.b.values())yield w.uri}*entries(){for(const w of this.b.values())yield[w.uri,w.value]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(const[,w]of this.b)yield[w.uri,w.value]}}e.ResourceMap=h,h.a=m=>m.toString();class b{constructor(w,o){this[A]="ResourceSet",!w||typeof w=="function"?this.a=new h(w):(this.a=new h(o),w.forEach(this.add,this))}get size(){return this.a.size}add(w){return this.a.set(w,w),this}clear(){this.a.clear()}delete(w){return this.a.delete(w)}forEach(w,o){this.a.forEach((u,p)=>w.call(o,p,p,this))}has(w){return this.a.has(w)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=b;var v;(function(m){m[m.None=0]="None",m[m.AsOld=1]="AsOld",m[m.AsNew=2]="AsNew"})(v=e.Touch||(e.Touch={}));class y{constructor(){this[n]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(w){return this.a.has(w)}get(w,o=0){const u=this.a.get(w);if(!!u)return o!==0&&this.j(u,o),u.value}set(w,o,u=0){let p=this.a.get(w);if(p)p.value=o,u!==0&&this.j(p,u);else{switch(p={key:w,value:o,next:void 0,previous:void 0},u){case 0:this.h(p);break;case 1:this.g(p);break;case 2:this.h(p);break;default:this.h(p);break}this.a.set(w,p),this.d++}return this}delete(w){return!!this.remove(w)}remove(w){const o=this.a.get(w);if(!!o)return this.a.delete(w),this.i(o),this.d--,o.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const w=this.b;return this.a.delete(w.key),this.i(w),this.d--,w.value}forEach(w,o){const u=this.e;let p=this.b;for(;p;){if(o?w.bind(o)(p.value,p.key,this):w(p.value,p.key,this),this.e!==u)throw new Error("LinkedMap got modified during iteration.");p=p.next}}keys(){const w=this,o=this.e;let u=this.b;const p={[Symbol.iterator](){return p},next(){if(w.e!==o)throw new Error("LinkedMap got modified during iteration.");if(u){const k={value:u.key,done:!1};return u=u.next,k}else return{value:void 0,done:!0}}};return p}values(){const w=this,o=this.e;let u=this.b;const p={[Symbol.iterator](){return p},next(){if(w.e!==o)throw new Error("LinkedMap got modified during iteration.");if(u){const k={value:u.value,done:!1};return u=u.next,k}else return{value:void 0,done:!0}}};return p}entries(){const w=this,o=this.e;let u=this.b;const p={[Symbol.iterator](){return p},next(){if(w.e!==o)throw new Error("LinkedMap got modified during iteration.");if(u){const k={value:[u.key,u.value],done:!1};return u=u.next,k}else return{value:void 0,done:!0}}};return p}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(w){if(w>=this.size)return;if(w===0){this.clear();return}let o=this.b,u=this.size;for(;o&&u>w;)this.a.delete(o.key),o=o.next,u--;this.b=o,this.d=u,o&&(o.previous=void 0),this.e++}g(w){if(!this.b&&!this.c)this.c=w;else if(this.b)w.next=this.b,this.b.previous=w;else throw new Error("Invalid list");this.b=w,this.e++}h(w){if(!this.b&&!this.c)this.b=w;else if(this.c)w.previous=this.c,this.c.next=w;else throw new Error("Invalid list");this.c=w,this.e++}i(w){if(w===this.b&&w===this.c)this.b=void 0,this.c=void 0;else if(w===this.b){if(!w.next)throw new Error("Invalid list");w.next.previous=void 0,this.b=w.next}else if(w===this.c){if(!w.previous)throw new Error("Invalid list");w.previous.next=void 0,this.c=w.previous}else{const o=w.next,u=w.previous;if(!o||!u)throw new Error("Invalid list");o.previous=u,u.next=o}w.next=void 0,w.previous=void 0,this.e++}j(w,o){if(!this.b||!this.c)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(w===this.b)return;const u=w.next,p=w.previous;w===this.c?(p.next=void 0,this.c=p):(u.previous=p,p.next=u),w.previous=void 0,w.next=this.b,this.b.previous=w,this.b=w,this.e++}else if(o===2){if(w===this.c)return;const u=w.next,p=w.previous;w===this.b?(u.previous=void 0,this.b=u):(u.previous=p,p.next=u),w.next=void 0,w.previous=this.c,this.c.next=w,this.c=w,this.e++}}}toJSON(){const w=[];return this.forEach((o,u)=>{w.push([u,o])}),w}fromJSON(w){this.clear();for(const[o,u]of w)this.set(o,u)}}e.LinkedMap=y;class g extends y{constructor(w,o=1){super(),this.k=w,this.l=Math.min(Math.max(0,o),1)}get limit(){return this.k}set limit(w){this.k=w,this.m()}get ratio(){return this.l}set ratio(w){this.l=Math.min(Math.max(0,w),1),this.m()}get(w,o=2){return super.get(w,o)}peek(w){return super.get(w,0)}set(w,o){return super.set(w,o,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=g}),define(ee[80],te([0,1,35]),function(G,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const A=new I.LRUCache(1e4);function n(h){return f(h,"NFC",A)}e.normalizeNFC=n;const C=new I.LRUCache(1e4);function D(h){return f(h,"NFD",C)}e.normalizeNFD=D;const P=/[^\u0000-\u0080]/;function f(h,b,v){if(!h)return h;const y=v.get(h);if(y)return y;let g;return P.test(h)?g=h.normalize(b):g=h,v.set(h,g),g}e.removeAccents=function(){const h=/[\u0300-\u036f]/g;return function(b){return D(b).replace(h,"")}}()}),define(ee[127],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function I(P,f,h){return Math.min(Math.max(P,f),h)}e.clamp=I;function A(P,f){return(f+P%f)%f}e.rot=A;class n{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=n;class C{constructor(){this.a=1,this.b=0}update(f){return this.b=this.b+(f-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=C;class D{constructor(f){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(f),this.c.fill(0,0,f)}update(f){const h=this.c[this.d];return this.c[this.d]=f,this.d=(this.d+1)%this.c.length,this.e-=h,this.e+=f,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=D}),function(){function G(n){const C=[];typeof n=="number"&&C.push("code/timeOrigin",n);function D(f){C.push(f,Date.now())}function P(){const f=[];for(let h=0;h<C.length;h+=2)f.push({name:C[h],startTime:C[h+1]});return f}return{mark:D,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?G():{mark(n){performance.mark(n)},getMarks(){let n=performance.timeOrigin;typeof n!="number"&&(n=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(n)}];for(const D of performance.getEntriesByType("mark"))C.push({name:D.name,startTime:Math.round(n+D.startTime)});return C}};if(typeof process=="object"){const n=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return G(n)}else return console.trace("perf-util loaded in UNKNOWN environment"),G()}function I(n){return n.MonacoPerformanceMarks||(n.MonacoPerformanceMarks=e()),n.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=I(A))}(),function(G,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var A in I)(typeof exports=="object"?exports:G)[A]=I[A]}}(typeof self<"u"?self:this,function(){return function(G){var e={};function I(A){if(e[A])return e[A].exports;var n=e[A]={i:A,l:!1,exports:{}};return G[A].call(n.exports,n,n.exports,I),n.l=!0,n.exports}return I.m=G,I.c=e,I.d=function(A,n,C){I.o(A,n)||Object.defineProperty(A,n,{enumerable:!0,get:C})},I.r=function(A){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},I.t=function(A,n){if(1&n&&(A=I(A)),8&n||4&n&&typeof A=="object"&&A&&A.__esModule)return A;var C=Object.create(null);if(I.r(C),Object.defineProperty(C,"default",{enumerable:!0,value:A}),2&n&&typeof A!="string")for(var D in A)I.d(C,D,function(P){return A[P]}.bind(null,D));return C},I.n=function(A){var n=A&&A.__esModule?function(){return A.default}:function(){return A};return I.d(n,"a",n),n},I.o=function(A,n){return Object.prototype.hasOwnProperty.call(A,n)},I.p="",I(I.s=0)}([function(G,e,I){(function(A){var n;e=G.exports=Z,n=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var Q=Array.prototype.slice.call(arguments,0);Q.unshift("SEMVER"),console.log.apply(console,Q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var C=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],f=e.src=[],h=0,b=h++;f[b]="0|[1-9]\\d*";var v=h++;f[v]="[0-9]+";var y=h++;f[y]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var g=h++;f[g]="("+f[b]+")\\.("+f[b]+")\\.("+f[b]+")";var m=h++;f[m]="("+f[v]+")\\.("+f[v]+")\\.("+f[v]+")";var w=h++;f[w]="(?:"+f[b]+"|"+f[y]+")";var o=h++;f[o]="(?:"+f[v]+"|"+f[y]+")";var u=h++;f[u]="(?:-("+f[w]+"(?:\\."+f[w]+")*))";var p=h++;f[p]="(?:-?("+f[o]+"(?:\\."+f[o]+")*))";var k=h++;f[k]="[0-9A-Za-z-]+";var E=h++;f[E]="(?:\\+("+f[k]+"(?:\\."+f[k]+")*))";var M=h++,t="v?"+f[g]+f[u]+"?"+f[E]+"?";f[M]="^"+t+"$";var a="[v=\\s]*"+f[m]+f[p]+"?"+f[E]+"?",i=h++;f[i]="^"+a+"$";var r=h++;f[r]="((?:<|>)?=?)";var c=h++;f[c]=f[v]+"|x|X|\\*";var l=h++;f[l]=f[b]+"|x|X|\\*";var s=h++;f[s]="[v=\\s]*("+f[l]+")(?:\\.("+f[l]+")(?:\\.("+f[l]+")(?:"+f[u]+")?"+f[E]+"?)?)?";var d=h++;f[d]="[v=\\s]*("+f[c]+")(?:\\.("+f[c]+")(?:\\.("+f[c]+")(?:"+f[p]+")?"+f[E]+"?)?)?";var S=h++;f[S]="^"+f[r]+"\\s*"+f[s]+"$";var R=h++;f[R]="^"+f[r]+"\\s*"+f[d]+"$";var O=h++;f[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var N=h++;f[N]="(?:~>?)";var K=h++;f[K]="(\\s*)"+f[N]+"\\s+",P[K]=new RegExp(f[K],"g");var V=h++;f[V]="^"+f[N]+f[s]+"$";var X=h++;f[X]="^"+f[N]+f[d]+"$";var ie=h++;f[ie]="(?:\\^)";var re=h++;f[re]="(\\s*)"+f[ie]+"\\s+",P[re]=new RegExp(f[re],"g");var ce=h++;f[ce]="^"+f[ie]+f[s]+"$";var fe=h++;f[fe]="^"+f[ie]+f[d]+"$";var ge=h++;f[ge]="^"+f[r]+"\\s*("+a+")$|^$";var x=h++;f[x]="^"+f[r]+"\\s*("+t+")$|^$";var F=h++;f[F]="(\\s*)"+f[r]+"\\s*("+a+"|"+f[s]+")",P[F]=new RegExp(f[F],"g");var W=h++;f[W]="^\\s*("+f[s]+")\\s+-\\s+("+f[s]+")\\s*$";var z=h++;f[z]="^\\s*("+f[d]+")\\s+-\\s+("+f[d]+")\\s*$";var J=h++;f[J]="(<|>)?=?\\s*\\*";for(var ne=0;ne<35;ne++)n(ne,f[ne]),P[ne]||(P[ne]=new RegExp(f[ne]));function se(Q,ae){if(Q instanceof Z)return Q;if(typeof Q!="string"||Q.length>C||!(ae?P[i]:P[M]).test(Q))return null;try{return new Z(Q,ae)}catch{return null}}function Z(Q,ae){if(Q instanceof Z){if(Q.loose===ae)return Q;Q=Q.version}else if(typeof Q!="string")throw new TypeError("Invalid Version: "+Q);if(Q.length>C)throw new TypeError("version is longer than "+C+" characters");if(!(this instanceof Z))return new Z(Q,ae);n("SemVer",Q,ae),this.loose=ae;var he=Q.trim().match(ae?P[i]:P[M]);if(!he)throw new TypeError("Invalid Version: "+Q);if(this.raw=Q,this.major=+he[1],this.minor=+he[2],this.patch=+he[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");he[4]?this.prerelease=he[4].split(".").map(function(Pe){if(/^[0-9]+$/.test(Pe)){var Me=+Pe;if(Me>=0&&Me<D)return Me}return Pe}):this.prerelease=[],this.build=he[5]?he[5].split("."):[],this.format()}e.parse=se,e.valid=function(Q,ae){var he=se(Q,ae);return he?he.version:null},e.clean=function(Q,ae){var he=se(Q.trim().replace(/^[=v]+/,""),ae);return he?he.version:null},e.SemVer=Z,Z.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Z.prototype.toString=function(){return this.version},Z.prototype.compare=function(Q){return n("SemVer.compare",this.version,this.loose,Q),Q instanceof Z||(Q=new Z(Q,this.loose)),this.compareMain(Q)||this.comparePre(Q)},Z.prototype.compareMain=function(Q){return Q instanceof Z||(Q=new Z(Q,this.loose)),L(this.major,Q.major)||L(this.minor,Q.minor)||L(this.patch,Q.patch)},Z.prototype.comparePre=function(Q){if(Q instanceof Z||(Q=new Z(Q,this.loose)),this.prerelease.length&&!Q.prerelease.length)return-1;if(!this.prerelease.length&&Q.prerelease.length)return 1;if(!this.prerelease.length&&!Q.prerelease.length)return 0;var ae=0;do{var he=this.prerelease[ae],Pe=Q.prerelease[ae];if(n("prerelease compare",ae,he,Pe),he===void 0&&Pe===void 0)return 0;if(Pe===void 0)return 1;if(he===void 0)return-1;if(he!==Pe)return L(he,Pe)}while(++ae)},Z.prototype.inc=function(Q,ae){switch(Q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ae);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ae);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ae),this.inc("pre",ae);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ae),this.inc("pre",ae);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var he=this.prerelease.length;--he>=0;)typeof this.prerelease[he]=="number"&&(this.prerelease[he]++,he=-2);he===-1&&this.prerelease.push(0)}ae&&(this.prerelease[0]===ae?isNaN(this.prerelease[1])&&(this.prerelease=[ae,0]):this.prerelease=[ae,0]);break;default:throw new Error("invalid increment argument: "+Q)}return this.format(),this.raw=this.version,this},e.inc=function(Q,ae,he,Pe){typeof he=="string"&&(Pe=he,he=void 0);try{return new Z(Q,he).inc(ae,Pe).version}catch{return null}},e.diff=function(Q,ae){if(j(Q,ae))return null;var he=se(Q),Pe=se(ae);if(he.prerelease.length||Pe.prerelease.length){for(var Me in he)if((Me==="major"||Me==="minor"||Me==="patch")&&he[Me]!==Pe[Me])return"pre"+Me;return"prerelease"}for(var Me in he)if((Me==="major"||Me==="minor"||Me==="patch")&&he[Me]!==Pe[Me])return Me},e.compareIdentifiers=L;var U=/^[0-9]+$/;function L(Q,ae){var he=U.test(Q),Pe=U.test(ae);return he&&Pe&&(Q=+Q,ae=+ae),he&&!Pe?-1:Pe&&!he?1:Q<ae?-1:Q>ae?1:0}function T(Q,ae,he){return new Z(Q,he).compare(new Z(ae,he))}function B(Q,ae,he){return T(Q,ae,he)>0}function H(Q,ae,he){return T(Q,ae,he)<0}function j(Q,ae,he){return T(Q,ae,he)===0}function $(Q,ae,he){return T(Q,ae,he)!==0}function q(Q,ae,he){return T(Q,ae,he)>=0}function oe(Q,ae,he){return T(Q,ae,he)<=0}function de(Q,ae,he,Pe){var Me;switch(ae){case"===":typeof Q=="object"&&(Q=Q.version),typeof he=="object"&&(he=he.version),Me=Q===he;break;case"!==":typeof Q=="object"&&(Q=Q.version),typeof he=="object"&&(he=he.version),Me=Q!==he;break;case"":case"=":case"==":Me=j(Q,he,Pe);break;case"!=":Me=$(Q,he,Pe);break;case">":Me=B(Q,he,Pe);break;case">=":Me=q(Q,he,Pe);break;case"<":Me=H(Q,he,Pe);break;case"<=":Me=oe(Q,he,Pe);break;default:throw new TypeError("Invalid operator: "+ae)}return Me}function pe(Q,ae){if(Q instanceof pe){if(Q.loose===ae)return Q;Q=Q.value}if(!(this instanceof pe))return new pe(Q,ae);n("comparator",Q,ae),this.loose=ae,this.parse(Q),this.semver===ye?this.value="":this.value=this.operator+this.semver.version,n("comp",this)}e.rcompareIdentifiers=function(Q,ae){return L(ae,Q)},e.major=function(Q,ae){return new Z(Q,ae).major},e.minor=function(Q,ae){return new Z(Q,ae).minor},e.patch=function(Q,ae){return new Z(Q,ae).patch},e.compare=T,e.compareLoose=function(Q,ae){return T(Q,ae,!0)},e.rcompare=function(Q,ae,he){return T(ae,Q,he)},e.sort=function(Q,ae){return Q.sort(function(he,Pe){return e.compare(he,Pe,ae)})},e.rsort=function(Q,ae){return Q.sort(function(he,Pe){return e.rcompare(he,Pe,ae)})},e.gt=B,e.lt=H,e.eq=j,e.neq=$,e.gte=q,e.lte=oe,e.cmp=de,e.Comparator=pe;var ye={};function Le(Q,ae){if(Q instanceof Le)return Q.loose===ae?Q:new Le(Q.raw,ae);if(Q instanceof pe)return new Le(Q.value,ae);if(!(this instanceof Le))return new Le(Q,ae);if(this.loose=ae,this.raw=Q,this.set=Q.split(/\s*\|\|\s*/).map(function(he){return this.parseRange(he.trim())},this).filter(function(he){return he.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Q);this.format()}function Fe(Q){return!Q||Q.toLowerCase()==="x"||Q==="*"}function Te(Q,ae,he,Pe,Me,Ae,Ue,He,Ne,$e,Ge,We,Ve){return((ae=Fe(he)?"":Fe(Pe)?">="+he+".0.0":Fe(Me)?">="+he+"."+Pe+".0":">="+ae)+" "+(He=Fe(Ne)?"":Fe($e)?"<"+(+Ne+1)+".0.0":Fe(Ge)?"<"+Ne+"."+(+$e+1)+".0":We?"<="+Ne+"."+$e+"."+Ge+"-"+We:"<="+He)).trim()}function we(Q,ae){for(var he=0;he<Q.length;he++)if(!Q[he].test(ae))return!1;if(ae.prerelease.length){for(he=0;he<Q.length;he++)if(n(Q[he].semver),Q[he].semver!==ye&&Q[he].semver.prerelease.length>0){var Pe=Q[he].semver;if(Pe.major===ae.major&&Pe.minor===ae.minor&&Pe.patch===ae.patch)return!0}return!1}return!0}function Ce(Q,ae,he){try{ae=new Le(ae,he)}catch{return!1}return ae.test(Q)}function Re(Q,ae,he,Pe){var Me,Ae,Ue,He,Ne;switch(Q=new Z(Q,Pe),ae=new Le(ae,Pe),he){case">":Me=B,Ae=oe,Ue=H,He=">",Ne=">=";break;case"<":Me=H,Ae=q,Ue=B,He="<",Ne="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ce(Q,ae,Pe))return!1;for(var $e=0;$e<ae.set.length;++$e){var Ge=ae.set[$e],We=null,Ve=null;if(Ge.forEach(function(Y){Y.semver===ye&&(Y=new pe(">=0.0.0")),We=We||Y,Ve=Ve||Y,Me(Y.semver,We.semver,Pe)?We=Y:Ue(Y.semver,Ve.semver,Pe)&&(Ve=Y)}),We.operator===He||We.operator===Ne||(!Ve.operator||Ve.operator===He)&&Ae(Q,Ve.semver)||Ve.operator===Ne&&Ue(Q,Ve.semver))return!1}return!0}pe.prototype.parse=function(Q){var ae=this.loose?P[ge]:P[x],he=Q.match(ae);if(!he)throw new TypeError("Invalid comparator: "+Q);this.operator=he[1],this.operator==="="&&(this.operator=""),he[2]?this.semver=new Z(he[2],this.loose):this.semver=ye},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(Q){return n("Comparator.test",Q,this.loose),this.semver===ye||(typeof Q=="string"&&(Q=new Z(Q,this.loose)),de(Q,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(Q,ae){if(!(Q instanceof pe))throw new TypeError("a Comparator is required");var he;if(this.operator==="")return he=new Le(Q.value,ae),Ce(this.value,he,ae);if(Q.operator==="")return he=new Le(this.value,ae),Ce(Q.semver,he,ae);var Pe=!(this.operator!==">="&&this.operator!==">"||Q.operator!==">="&&Q.operator!==">"),Me=!(this.operator!=="<="&&this.operator!=="<"||Q.operator!=="<="&&Q.operator!=="<"),Ae=this.semver.version===Q.semver.version,Ue=!(this.operator!==">="&&this.operator!=="<="||Q.operator!==">="&&Q.operator!=="<="),He=de(this.semver,"<",Q.semver,ae)&&(this.operator===">="||this.operator===">")&&(Q.operator==="<="||Q.operator==="<"),Ne=de(this.semver,">",Q.semver,ae)&&(this.operator==="<="||this.operator==="<")&&(Q.operator===">="||Q.operator===">");return Pe||Me||Ae&&Ue||He||Ne},e.Range=Le,Le.prototype.format=function(){return this.range=this.set.map(function(Q){return Q.join(" ").trim()}).join("||").trim(),this.range},Le.prototype.toString=function(){return this.range},Le.prototype.parseRange=function(Q){var ae=this.loose;Q=Q.trim(),n("range",Q,ae);var he=ae?P[z]:P[W];Q=Q.replace(he,Te),n("hyphen replace",Q),Q=Q.replace(P[F],"$1$2$3"),n("comparator trim",Q,P[F]),Q=(Q=(Q=Q.replace(P[K],"$1~")).replace(P[re],"$1^")).split(/\s+/).join(" ");var Pe=ae?P[ge]:P[x],Me=Q.split(" ").map(function(Ae){return function(Ue,He){return n("comp",Ue),Ue=function(Ne,$e){return Ne.trim().split(/\s+/).map(function(Ge){return function(We,Ve){n("caret",We,Ve);var Y=Ve?P[fe]:P[ce];return We.replace(Y,function(le,ue,me,Se,Oe){var ze;return n("caret",We,le,ue,me,Se,Oe),Fe(ue)?ze="":Fe(me)?ze=">="+ue+".0.0 <"+(+ue+1)+".0.0":Fe(Se)?ze=ue==="0"?">="+ue+"."+me+".0 <"+ue+"."+(+me+1)+".0":">="+ue+"."+me+".0 <"+(+ue+1)+".0.0":Oe?(n("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),ze=ue==="0"?me==="0"?">="+ue+"."+me+"."+Se+Oe+" <"+ue+"."+me+"."+(+Se+1):">="+ue+"."+me+"."+Se+Oe+" <"+ue+"."+(+me+1)+".0":">="+ue+"."+me+"."+Se+Oe+" <"+(+ue+1)+".0.0"):(n("no pr"),ze=ue==="0"?me==="0"?">="+ue+"."+me+"."+Se+" <"+ue+"."+me+"."+(+Se+1):">="+ue+"."+me+"."+Se+" <"+ue+"."+(+me+1)+".0":">="+ue+"."+me+"."+Se+" <"+(+ue+1)+".0.0"),n("caret return",ze),ze})}(Ge,$e)}).join(" ")}(Ue,He),n("caret",Ue),Ue=function(Ne,$e){return Ne.trim().split(/\s+/).map(function(Ge){return function(We,Ve){var Y=Ve?P[X]:P[V];return We.replace(Y,function(le,ue,me,Se,Oe){var ze;return n("tilde",We,le,ue,me,Se,Oe),Fe(ue)?ze="":Fe(me)?ze=">="+ue+".0.0 <"+(+ue+1)+".0.0":Fe(Se)?ze=">="+ue+"."+me+".0 <"+ue+"."+(+me+1)+".0":Oe?(n("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),ze=">="+ue+"."+me+"."+Se+Oe+" <"+ue+"."+(+me+1)+".0"):ze=">="+ue+"."+me+"."+Se+" <"+ue+"."+(+me+1)+".0",n("tilde return",ze),ze})}(Ge,$e)}).join(" ")}(Ue,He),n("tildes",Ue),Ue=function(Ne,$e){return n("replaceXRanges",Ne,$e),Ne.split(/\s+/).map(function(Ge){return function(We,Ve){We=We.trim();var Y=Ve?P[R]:P[S];return We.replace(Y,function(le,ue,me,Se,Oe,ze){n("xRange",We,le,ue,me,Se,Oe,ze);var tt=Fe(me),Qe=tt||Fe(Se),Ke=Qe||Fe(Oe);return ue==="="&&Ke&&(ue=""),tt?le=ue===">"||ue==="<"?"<0.0.0":"*":ue&&Ke?(Qe&&(Se=0),Ke&&(Oe=0),ue===">"?(ue=">=",Qe?(me=+me+1,Se=0,Oe=0):Ke&&(Se=+Se+1,Oe=0)):ue==="<="&&(ue="<",Qe?me=+me+1:Se=+Se+1),le=ue+me+"."+Se+"."+Oe):Qe?le=">="+me+".0.0 <"+(+me+1)+".0.0":Ke&&(le=">="+me+"."+Se+".0 <"+me+"."+(+Se+1)+".0"),n("xRange return",le),le})}(Ge,$e)}).join(" ")}(Ue,He),n("xrange",Ue),Ue=function(Ne,$e){return n("replaceStars",Ne,$e),Ne.trim().replace(P[J],"")}(Ue,He),n("stars",Ue),Ue}(Ae,ae)}).join(" ").split(/\s+/);return this.loose&&(Me=Me.filter(function(Ae){return!!Ae.match(Pe)})),Me=Me.map(function(Ae){return new pe(Ae,ae)})},Le.prototype.intersects=function(Q,ae){if(!(Q instanceof Le))throw new TypeError("a Range is required");return this.set.some(function(he){return he.every(function(Pe){return Q.set.some(function(Me){return Me.every(function(Ae){return Pe.intersects(Ae,ae)})})})})},e.toComparators=function(Q,ae){return new Le(Q,ae).set.map(function(he){return he.map(function(Pe){return Pe.value}).join(" ").trim().split(" ")})},Le.prototype.test=function(Q){if(!Q)return!1;typeof Q=="string"&&(Q=new Z(Q,this.loose));for(var ae=0;ae<this.set.length;ae++)if(we(this.set[ae],Q))return!0;return!1},e.satisfies=Ce,e.maxSatisfying=function(Q,ae,he){var Pe=null,Me=null;try{var Ae=new Le(ae,he)}catch{return null}return Q.forEach(function(Ue){Ae.test(Ue)&&(Pe&&Me.compare(Ue)!==-1||(Me=new Z(Pe=Ue,he)))}),Pe},e.minSatisfying=function(Q,ae,he){var Pe=null,Me=null;try{var Ae=new Le(ae,he)}catch{return null}return Q.forEach(function(Ue){Ae.test(Ue)&&(Pe&&Me.compare(Ue)!==1||(Me=new Z(Pe=Ue,he)))}),Pe},e.validRange=function(Q,ae){try{return new Le(Q,ae).range||"*"}catch{return null}},e.ltr=function(Q,ae,he){return Re(Q,ae,"<",he)},e.gtr=function(Q,ae,he){return Re(Q,ae,">",he)},e.outside=Re,e.prerelease=function(Q,ae){var he=se(Q,ae);return he&&he.prerelease.length?he.prerelease:null},e.intersects=function(Q,ae,he){return Q=new Le(Q,he),ae=new Le(ae,he),Q.intersects(ae)},e.coerce=function(Q){if(Q instanceof Z)return Q;if(typeof Q!="string")return null;var ae=Q.match(P[O]);return ae==null?null:se((ae[1]||"0")+"."+(ae[2]||"0")+"."+(ae[3]||"0"))}}).call(this,I(1))},function(G,e){var I,A,n=G.exports={};function C(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function P(o){if(I===setTimeout)return setTimeout(o,0);if((I===C||!I)&&setTimeout)return I=setTimeout,setTimeout(o,0);try{return I(o,0)}catch{try{return I.call(null,o,0)}catch{return I.call(this,o,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:C}catch{I=C}try{A=typeof clearTimeout=="function"?clearTimeout:D}catch{A=D}})();var f,h=[],b=!1,v=-1;function y(){b&&f&&(b=!1,f.length?h=f.concat(h):v=-1,h.length&&g())}function g(){if(!b){var o=P(y);b=!0;for(var u=h.length;u;){for(f=h,h=[];++v<u;)f&&f[v].run();v=-1,u=h.length}f=null,b=!1,function(p){if(A===clearTimeout)return clearTimeout(p);if((A===D||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(p);try{A(p)}catch{try{return A.call(null,p)}catch{return A.call(this,p)}}}(o)}}function m(o,u){this.fun=o,this.array=u}function w(){}n.nextTick=function(o){var u=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)u[p-1]=arguments[p];h.push(new m(o,u)),h.length!==1||b||P(g)},m.prototype.run=function(){this.fun.apply(null,this.array)},n.title="browser",n.browser=!0,n.env={},n.argv=[],n.version="",n.versions={},n.on=w,n.addListener=w,n.once=w,n.off=w,n.removeListener=w,n.removeAllListeners=w,n.emit=w,n.prependListener=w,n.prependOnceListener=w,n.listeners=function(o){return[]},n.binding=function(o){throw new Error("process.binding is not supported")},n.cwd=function(){return"/"},n.chdir=function(o){throw new Error("process.chdir is not supported")},n.umask=function(){return 0}}])}),define(ee[128],te([0,1]),function(G,e){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class A{constructor(P,f,h){this.level=P,this.key=f,this.value=h,this.forward=[]}}const n=void 0;class C{constructor(P,f=2**16){this.comparator=P,this[I]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(f)|0),this.e=new A(this.c,n,n)}get size(){return this.f}clear(){this.e=new A(this.c,n,n)}has(P){return Boolean(C.g(this,P,this.comparator))}get(P){return C.g(this,P,this.comparator)?.value}set(P,f){return C.h(this,P,f,this.comparator)&&(this.f+=1),this}delete(P){const f=C.k(this,P,this.comparator);return f&&(this.f-=1),f}forEach(P,f){let h=this.e.forward[0];for(;h;)P.call(f,h.value,h.key,this),h=h.forward[0]}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",f=this.e.forward[0];for(;f;)P+=`node(${f.key}, ${f.value}, lvl:${f.level})`,f=f.forward[0];return P}static g(P,f,h){let b=P.e;for(let v=P.d-1;v>=0;v--)for(;b.forward[v]&&h(b.forward[v].key,f)<0;)b=b.forward[v];if(b=b.forward[0],b&&h(b.key,f)===0)return b}static h(P,f,h,b){const v=[];let y=P.e;for(let g=P.d-1;g>=0;g--){for(;y.forward[g]&&b(y.forward[g].key,f)<0;)y=y.forward[g];v[g]=y}if(y=y.forward[0],y&&b(y.key,f)===0)return y.value=h,!1;{const g=C.j(P);if(g>P.d){for(let m=P.d;m<g;m++)v[m]=P.e;P.d=g}y=new A(g,f,h);for(let m=0;m<g;m++)y.forward[m]=v[m].forward[m],v[m].forward[m]=y;return!0}}static j(P,f=.5){let h=1;for(;Math.random()<f&&h<P.c;)h+=1;return h}static k(P,f,h){const b=[];let v=P.e;for(let y=P.d-1;y>=0;y--){for(;v.forward[y]&&h(v.forward[y].key,f)<0;)v=v.forward[y];b[y]=v}if(v=v.forward[0],!v||h(v.key,f)!==0)return!1;for(let y=0;y<P.d&&b[y].forward[y]===v;y++)b[y].forward[y]=v.forward[y];for(;P.d>0&&P.e.forward[P.d-1]===n;)P.d-=1;return!0}}e.SkipList=C}),define(ee[60],te([0,1,13,2]),function(G,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function n(E){const M=E;return M?typeof M.read=="function":!1}e.isReadable=n;function C(E){const M=E;return M?[M.on,M.pause,M.resume,M.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=C;function D(E){const M=E;return M?C(M.stream)&&Array.isArray(M.buffer)&&typeof M.ended=="boolean":!1}e.isReadableBufferedStream=D;function P(E,M){return new f(E,M)}e.newWriteableStream=P;class f{constructor(M,t){this.e=M,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(M){if(!this.a.destroyed){if(this.a.flowing)this.g(M);else if(this.b.data.push(M),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(M){this.a.destroyed||(this.a.flowing?this.h(M):this.b.error.push(M))}end(M){this.a.destroyed||(typeof M<"u"&&this.write(M),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(M){this.c.data.slice(0).forEach(t=>t(M))}h(M){this.c.error.length===0?(0,I.onUnexpectedError)(M):this.c.error.slice(0).forEach(t=>t(M))}i(){this.c.end.slice(0).forEach(M=>M())}on(M,t){if(!this.a.destroyed)switch(M){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(M,t){if(this.a.destroyed)return;let a;switch(M){case"data":a=this.c.data;break;case"end":a=this.c.end;break;case"error":a=this.c.error;break}if(a){const i=a.indexOf(t);i>=0&&a.splice(i,1)}}j(){if(this.b.data.length>0){const M=this.e(this.b.data);this.g(M),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(a=>a())}}k(){if(this.c.error.length>0){for(const M of this.b.error)this.h(M);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function h(E,M){const t=[];let a;for(;(a=E.read())!==null;)t.push(a);return M(t)}e.consumeReadable=h;function b(E,M,t){const a=[];let i;for(;(i=E.read())!==null&&a.length<t;)a.push(i);return i===null&&a.length>0?M(a):{read:()=>{if(a.length>0)return a.shift();if(typeof i<"u"){const r=i;return i=void 0,r}return E.read()}}}e.peekReadable=b;function v(E,M){return new Promise((t,a)=>{const i=[];y(E,{onData:r=>{M&&i.push(r)},onError:r=>{M?a(r):t(void 0)},onEnd:()=>{t(M?M(i):void 0)}})})}e.consumeStream=v;function y(E,M){let t=!1;return E.on("error",a=>{t||M.onError(a)}),E.on("end",()=>{t||M.onEnd()}),E.on("data",a=>{t||M.onData(a)}),(0,A.toDisposable)(()=>t=!0)}e.listenStream=y;function g(E,M){return new Promise((t,a)=>{const i=new A.DisposableStore,r=[],c=d=>{if(r.push(d),r.length>M)return i.dispose(),E.pause(),t({stream:E,buffer:r,ended:!1})},l=d=>a(d),s=()=>t({stream:E,buffer:r,ended:!0});i.add((0,A.toDisposable)(()=>E.removeListener("error",l))),E.on("error",l),i.add((0,A.toDisposable)(()=>E.removeListener("end",s))),E.on("end",s),i.add((0,A.toDisposable)(()=>E.removeListener("data",c))),E.on("data",c)})}e.peekStream=g;function m(E,M){const t=P(M);return t.end(E),t}e.toStream=m;function w(){const E=P(()=>{throw new Error("not supported")});return E.end(),E}e.emptyStream=w;function o(E){let M=!1;return{read:()=>M?null:(M=!0,E)}}e.toReadable=o;function u(E,M,t){const a=P(t);return y(E,{onData:i=>a.write(M.data(i)),onError:i=>a.error(M.error?M.error(i):i),onEnd:()=>a.end()}),a}e.transform=u;function p(E,M,t){let a=!1;return{read:()=>{const i=M.read();return a?i:(a=!0,i!==null?t([E,i]):E)}}}e.prefixedReadable=p;function k(E,M,t){let a=!1;const i=P(t);return y(M,{onData:r=>a?i.write(r):(a=!0,i.write(t([E,r]))),onError:r=>i.error(r),onEnd:()=>{a||(a=!0,i.write(E)),i.end()}}),i}e.prefixedStream=k}),define(ee[17],te([0,1,60]),function(G,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const A=typeof Buffer<"u";let n,C;class D{static alloc(d){return A?new D(Buffer.allocUnsafe(d)):new D(new Uint8Array(d))}static wrap(d){return A&&!Buffer.isBuffer(d)&&(d=Buffer.from(d.buffer,d.byteOffset,d.byteLength)),new D(d)}static fromString(d,S){return!(S?.dontUseNodeBuffer||!1)&&A?new D(Buffer.from(d)):(n||(n=new TextEncoder),new D(n.encode(d)))}static fromByteArray(d){const S=D.alloc(d.length);for(let R=0,O=d.length;R<O;R++)S.buffer[R]=d[R];return S}static concat(d,S){if(typeof S>"u"){S=0;for(let N=0,K=d.length;N<K;N++)S+=d[N].byteLength}const R=D.alloc(S);let O=0;for(let N=0,K=d.length;N<K;N++){const V=d[N];R.set(V,O),O+=V.byteLength}return R}constructor(d){this.buffer=d,this.byteLength=this.buffer.byteLength}clone(){const d=D.alloc(this.byteLength);return d.set(this),d}toString(){return A?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(d,S){return new D(this.buffer.subarray(d,S))}set(d,S){if(d instanceof D)this.buffer.set(d.buffer,S);else if(d instanceof Uint8Array)this.buffer.set(d,S);else if(d instanceof ArrayBuffer)this.buffer.set(new Uint8Array(d),S);else if(ArrayBuffer.isView(d))this.buffer.set(new Uint8Array(d.buffer,d.byteOffset,d.byteLength),S);else throw new Error("Unknown argument 'array'")}readUInt32BE(d){return h(this.buffer,d)}writeUInt32BE(d,S){b(this.buffer,d,S)}readUInt32LE(d){return v(this.buffer,d)}writeUInt32LE(d,S){y(this.buffer,d,S)}readUInt8(d){return g(this.buffer,d)}writeUInt8(d,S){m(this.buffer,d,S)}}e.VSBuffer=D;function P(s,d){return s[d+0]<<0>>>0|s[d+1]<<8>>>0}e.readUInt16LE=P;function f(s,d,S){s[S+0]=d&255,d=d>>>8,s[S+1]=d&255}e.writeUInt16LE=f;function h(s,d){return s[d]*2**24+s[d+1]*2**16+s[d+2]*2**8+s[d+3]}e.readUInt32BE=h;function b(s,d,S){s[S+3]=d,d=d>>>8,s[S+2]=d,d=d>>>8,s[S+1]=d,d=d>>>8,s[S]=d}e.writeUInt32BE=b;function v(s,d){return s[d+0]<<0>>>0|s[d+1]<<8>>>0|s[d+2]<<16>>>0|s[d+3]<<24>>>0}e.readUInt32LE=v;function y(s,d,S){s[S+0]=d&255,d=d>>>8,s[S+1]=d&255,d=d>>>8,s[S+2]=d&255,d=d>>>8,s[S+3]=d&255}e.writeUInt32LE=y;function g(s,d){return s[d]}e.readUInt8=g;function m(s,d,S){s[S]=d}e.writeUInt8=m;function w(s){return I.consumeReadable(s,d=>D.concat(d))}e.readableToBuffer=w;function o(s){return I.toReadable(s)}e.bufferToReadable=o;function u(s){return I.consumeStream(s,d=>D.concat(d))}e.streamToBuffer=u;async function p(s){return s.ended?D.concat(s.buffer):D.concat([...s.buffer,await u(s.stream)])}e.bufferedStreamToBuffer=p;function k(s){return I.toStream(s,d=>D.concat(d))}e.bufferToStream=k;function E(s){return I.transform(s,{data:d=>typeof d=="string"?D.fromString(d):D.wrap(d)},d=>D.concat(d))}e.streamToBufferReadableStream=E;function M(s){return I.newWriteableStream(d=>D.concat(d),s)}e.newWriteableBufferStream=M;function t(s,d){return I.prefixedReadable(s,d,S=>D.concat(S))}e.prefixedBufferReadable=t;function a(s,d){return I.prefixedStream(s,d,S=>D.concat(S))}e.prefixedBufferStream=a;function i(s){let d=0,S=0,R=0;const O=new Uint8Array(Math.floor(s.length/4*3)),N=V=>{switch(S){case 3:O[R++]=d|V,S=0;break;case 2:O[R++]=d|V>>>2,d=V<<6,S=3;break;case 1:O[R++]=d|V>>>4,d=V<<4,S=2;break;default:d=V<<2,S=1}};for(let V=0;V<s.length;V++){const X=s.charCodeAt(V);if(X>=65&&X<=90)N(X-65);else if(X>=97&&X<=122)N(X-97+26);else if(X>=48&&X<=57)N(X-48+52);else if(X===43||X===45)N(62);else if(X===47||X===95)N(63);else{if(X===61)break;throw new SyntaxError(`Unexpected base64 character ${s[V]}`)}}const K=R;for(;S>0;)N(0);return D.wrap(O).slice(0,K)}e.decodeBase64=i;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function l({buffer:s},d=!0,S=!1){const R=S?c:r;let O="";const N=s.byteLength%3;let K=0;for(;K<s.byteLength-N;K+=3){const V=s[K+0],X=s[K+1],ie=s[K+2];O+=R[V>>>2],O+=R[(V<<4|X>>>4)&63],O+=R[(X<<2|ie>>>6)&63],O+=R[ie&63]}if(N===1){const V=s[K+0];O+=R[V>>>2],O+=R[V<<4&63],d&&(O+="==")}else if(N===2){const V=s[K+0],X=s[K+1];O+=R[V>>>2],O+=R[(V<<4|X>>>4)&63],O+=R[X<<2&63],d&&(O+="=")}return O}e.encodeBase64=l}),define(ee[129],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(ee[10],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function I(a){return typeof a=="string"}e.isString=I;function A(a){return Array.isArray(a)&&a.every(i=>I(i))}e.isStringArray=A;function n(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.isObject=n;function C(a){const i=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof i}e.isTypedArray=C;function D(a){return typeof a=="number"&&!isNaN(a)}e.isNumber=D;function P(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.isIterable=P;function f(a){return a===!0||a===!1}e.isBoolean=f;function h(a){return typeof a>"u"}e.isUndefined=h;function b(a){return!v(a)}e.isDefined=b;function v(a){return h(a)||a===null}e.isUndefinedOrNull=v;function y(a,i){if(!a)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.assertType=y;function g(a){if(v(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.assertIsDefined=g;function m(...a){const i=[];for(let r=0;r<a.length;r++){const c=a[r];if(v(c))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);i.push(c)}return i}e.assertAllDefined=m;const w=Object.prototype.hasOwnProperty;function o(a){if(!n(a))return!1;for(const i in a)if(w.call(a,i))return!1;return!0}e.isEmptyObject=o;function u(a){return typeof a=="function"}e.isFunction=u;function p(...a){return a.length>0&&a.every(u)}e.areFunctions=p;function k(a,i){const r=Math.min(a.length,i.length);for(let c=0;c<r;c++)E(a[c],i[c])}e.validateConstraints=k;function E(a,i){if(I(i)){if(typeof a!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(u(i)){try{if(a instanceof i)return}catch{}if(!v(a)&&a.constructor===i||i.length===1&&i.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=E;function M(a){return a===null?void 0:a}e.withNullAsUndefined=M;function t(a){return typeof a>"u"?null:a}e.withUndefinedAsNull=t}),define(ee[130],te([0,1,10]),function(G,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const A=Object.create(null);function n(P,f){if((0,I.isString)(f)){const h=A[f];if(h===void 0)throw new Error(`${P} references an unknown codicon: ${f}`);f=h}return A[P]=f,{id:P}}function C(){return A}e.getCodiconFontCharacters=C;function D(){return Object.values(e.Codicon)}e.getAllCodicons=D,e.Codicon={add:n("add",6e4),plus:n("plus",6e4),gistNew:n("gist-new",6e4),repoCreate:n("repo-create",6e4),lightbulb:n("lightbulb",60001),lightBulb:n("light-bulb",60001),repo:n("repo",60002),repoDelete:n("repo-delete",60002),gistFork:n("gist-fork",60003),repoForked:n("repo-forked",60003),gitPullRequest:n("git-pull-request",60004),gitPullRequestAbandoned:n("git-pull-request-abandoned",60004),recordKeys:n("record-keys",60005),keyboard:n("keyboard",60005),tag:n("tag",60006),tagAdd:n("tag-add",60006),tagRemove:n("tag-remove",60006),person:n("person",60007),personFollow:n("person-follow",60007),personOutline:n("person-outline",60007),personFilled:n("person-filled",60007),gitBranch:n("git-branch",60008),gitBranchCreate:n("git-branch-create",60008),gitBranchDelete:n("git-branch-delete",60008),sourceControl:n("source-control",60008),mirror:n("mirror",60009),mirrorPublic:n("mirror-public",60009),star:n("star",60010),starAdd:n("star-add",60010),starDelete:n("star-delete",60010),starEmpty:n("star-empty",60010),comment:n("comment",60011),commentAdd:n("comment-add",60011),alert:n("alert",60012),warning:n("warning",60012),search:n("search",60013),searchSave:n("search-save",60013),logOut:n("log-out",60014),signOut:n("sign-out",60014),logIn:n("log-in",60015),signIn:n("sign-in",60015),eye:n("eye",60016),eyeUnwatch:n("eye-unwatch",60016),eyeWatch:n("eye-watch",60016),circleFilled:n("circle-filled",60017),primitiveDot:n("primitive-dot",60017),closeDirty:n("close-dirty",60017),debugBreakpoint:n("debug-breakpoint",60017),debugBreakpointDisabled:n("debug-breakpoint-disabled",60017),debugHint:n("debug-hint",60017),primitiveSquare:n("primitive-square",60018),edit:n("edit",60019),pencil:n("pencil",60019),info:n("info",60020),issueOpened:n("issue-opened",60020),gistPrivate:n("gist-private",60021),gitForkPrivate:n("git-fork-private",60021),lock:n("lock",60021),mirrorPrivate:n("mirror-private",60021),close:n("close",60022),removeClose:n("remove-close",60022),x:n("x",60022),repoSync:n("repo-sync",60023),sync:n("sync",60023),clone:n("clone",60024),desktopDownload:n("desktop-download",60024),beaker:n("beaker",60025),microscope:n("microscope",60025),vm:n("vm",60026),deviceDesktop:n("device-desktop",60026),file:n("file",60027),fileText:n("file-text",60027),more:n("more",60028),ellipsis:n("ellipsis",60028),kebabHorizontal:n("kebab-horizontal",60028),mailReply:n("mail-reply",60029),reply:n("reply",60029),organization:n("organization",60030),organizationFilled:n("organization-filled",60030),organizationOutline:n("organization-outline",60030),newFile:n("new-file",60031),fileAdd:n("file-add",60031),newFolder:n("new-folder",60032),fileDirectoryCreate:n("file-directory-create",60032),trash:n("trash",60033),trashcan:n("trashcan",60033),history:n("history",60034),clock:n("clock",60034),folder:n("folder",60035),fileDirectory:n("file-directory",60035),symbolFolder:n("symbol-folder",60035),logoGithub:n("logo-github",60036),markGithub:n("mark-github",60036),github:n("github",60036),terminal:n("terminal",60037),console:n("console",60037),repl:n("repl",60037),zap:n("zap",60038),symbolEvent:n("symbol-event",60038),error:n("error",60039),stop:n("stop",60039),variable:n("variable",60040),symbolVariable:n("symbol-variable",60040),array:n("array",60042),symbolArray:n("symbol-array",60042),symbolModule:n("symbol-module",60043),symbolPackage:n("symbol-package",60043),symbolNamespace:n("symbol-namespace",60043),symbolObject:n("symbol-object",60043),symbolMethod:n("symbol-method",60044),symbolFunction:n("symbol-function",60044),symbolConstructor:n("symbol-constructor",60044),symbolBoolean:n("symbol-boolean",60047),symbolNull:n("symbol-null",60047),symbolNumeric:n("symbol-numeric",60048),symbolNumber:n("symbol-number",60048),symbolStructure:n("symbol-structure",60049),symbolStruct:n("symbol-struct",60049),symbolParameter:n("symbol-parameter",60050),symbolTypeParameter:n("symbol-type-parameter",60050),symbolKey:n("symbol-key",60051),symbolText:n("symbol-text",60051),symbolReference:n("symbol-reference",60052),goToFile:n("go-to-file",60052),symbolEnum:n("symbol-enum",60053),symbolValue:n("symbol-value",60053),symbolRuler:n("symbol-ruler",60054),symbolUnit:n("symbol-unit",60054),activateBreakpoints:n("activate-breakpoints",60055),archive:n("archive",60056),arrowBoth:n("arrow-both",60057),arrowDown:n("arrow-down",60058),arrowLeft:n("arrow-left",60059),arrowRight:n("arrow-right",60060),arrowSmallDown:n("arrow-small-down",60061),arrowSmallLeft:n("arrow-small-left",60062),arrowSmallRight:n("arrow-small-right",60063),arrowSmallUp:n("arrow-small-up",60064),arrowUp:n("arrow-up",60065),bell:n("bell",60066),bold:n("bold",60067),book:n("book",60068),bookmark:n("bookmark",60069),debugBreakpointConditionalUnverified:n("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:n("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:n("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:n("debug-breakpoint-data-unverified",60072),debugBreakpointData:n("debug-breakpoint-data",60073),debugBreakpointDataDisabled:n("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:n("debug-breakpoint-log-unverified",60074),debugBreakpointLog:n("debug-breakpoint-log",60075),debugBreakpointLogDisabled:n("debug-breakpoint-log-disabled",60075),briefcase:n("briefcase",60076),broadcast:n("broadcast",60077),browser:n("browser",60078),bug:n("bug",60079),calendar:n("calendar",60080),caseSensitive:n("case-sensitive",60081),check:n("check",60082),checklist:n("checklist",60083),chevronDown:n("chevron-down",60084),dropDownButton:n("drop-down-button",60084),chevronLeft:n("chevron-left",60085),chevronRight:n("chevron-right",60086),chevronUp:n("chevron-up",60087),chromeClose:n("chrome-close",60088),chromeMaximize:n("chrome-maximize",60089),chromeMinimize:n("chrome-minimize",60090),chromeRestore:n("chrome-restore",60091),circle:n("circle",60092),circleOutline:n("circle-outline",60092),debugBreakpointUnverified:n("debug-breakpoint-unverified",60092),circleSlash:n("circle-slash",60093),circuitBoard:n("circuit-board",60094),clearAll:n("clear-all",60095),clippy:n("clippy",60096),closeAll:n("close-all",60097),cloudDownload:n("cloud-download",60098),cloudUpload:n("cloud-upload",60099),code:n("code",60100),collapseAll:n("collapse-all",60101),colorMode:n("color-mode",60102),commentDiscussion:n("comment-discussion",60103),compareChanges:n("compare-changes",60157),creditCard:n("credit-card",60105),dash:n("dash",60108),dashboard:n("dashboard",60109),database:n("database",60110),debugContinue:n("debug-continue",60111),debugDisconnect:n("debug-disconnect",60112),debugPause:n("debug-pause",60113),debugRestart:n("debug-restart",60114),debugStart:n("debug-start",60115),debugStepInto:n("debug-step-into",60116),debugStepOut:n("debug-step-out",60117),debugStepOver:n("debug-step-over",60118),debugStop:n("debug-stop",60119),debug:n("debug",60120),deviceCameraVideo:n("device-camera-video",60121),deviceCamera:n("device-camera",60122),deviceMobile:n("device-mobile",60123),diffAdded:n("diff-added",60124),diffIgnored:n("diff-ignored",60125),diffModified:n("diff-modified",60126),diffRemoved:n("diff-removed",60127),diffRenamed:n("diff-renamed",60128),diff:n("diff",60129),discard:n("discard",60130),editorLayout:n("editor-layout",60131),emptyWindow:n("empty-window",60132),exclude:n("exclude",60133),extensions:n("extensions",60134),eyeClosed:n("eye-closed",60135),fileBinary:n("file-binary",60136),fileCode:n("file-code",60137),fileMedia:n("file-media",60138),filePdf:n("file-pdf",60139),fileSubmodule:n("file-submodule",60140),fileSymlinkDirectory:n("file-symlink-directory",60141),fileSymlinkFile:n("file-symlink-file",60142),fileZip:n("file-zip",60143),files:n("files",60144),filter:n("filter",60145),flame:n("flame",60146),foldDown:n("fold-down",60147),foldUp:n("fold-up",60148),fold:n("fold",60149),folderActive:n("folder-active",60150),folderOpened:n("folder-opened",60151),gear:n("gear",60152),gift:n("gift",60153),gistSecret:n("gist-secret",60154),gist:n("gist",60155),gitCommit:n("git-commit",60156),gitCompare:n("git-compare",60157),gitMerge:n("git-merge",60158),githubAction:n("github-action",60159),githubAlt:n("github-alt",60160),globe:n("globe",60161),grabber:n("grabber",60162),graph:n("graph",60163),gripper:n("gripper",60164),heart:n("heart",60165),home:n("home",60166),horizontalRule:n("horizontal-rule",60167),hubot:n("hubot",60168),inbox:n("inbox",60169),issueClosed:n("issue-closed",60324),issueReopened:n("issue-reopened",60171),issues:n("issues",60172),italic:n("italic",60173),jersey:n("jersey",60174),json:n("json",60175),bracket:n("bracket",60175),kebabVertical:n("kebab-vertical",60176),key:n("key",60177),law:n("law",60178),lightbulbAutofix:n("lightbulb-autofix",60179),linkExternal:n("link-external",60180),link:n("link",60181),listOrdered:n("list-ordered",60182),listUnordered:n("list-unordered",60183),liveShare:n("live-share",60184),loading:n("loading",60185),location:n("location",60186),mailRead:n("mail-read",60187),mail:n("mail",60188),markdown:n("markdown",60189),megaphone:n("megaphone",60190),mention:n("mention",60191),milestone:n("milestone",60192),mortarBoard:n("mortar-board",60193),move:n("move",60194),multipleWindows:n("multiple-windows",60195),mute:n("mute",60196),noNewline:n("no-newline",60197),note:n("note",60198),octoface:n("octoface",60199),openPreview:n("open-preview",60200),package_:n("package",60201),paintcan:n("paintcan",60202),pin:n("pin",60203),play:n("play",60204),run:n("run",60204),plug:n("plug",60205),preserveCase:n("preserve-case",60206),preview:n("preview",60207),project:n("project",60208),pulse:n("pulse",60209),question:n("question",60210),quote:n("quote",60211),radioTower:n("radio-tower",60212),reactions:n("reactions",60213),references:n("references",60214),refresh:n("refresh",60215),regex:n("regex",60216),remoteExplorer:n("remote-explorer",60217),remote:n("remote",60218),remove:n("remove",60219),replaceAll:n("replace-all",60220),replace:n("replace",60221),repoClone:n("repo-clone",60222),repoForcePush:n("repo-force-push",60223),repoPull:n("repo-pull",60224),repoPush:n("repo-push",60225),report:n("report",60226),requestChanges:n("request-changes",60227),rocket:n("rocket",60228),rootFolderOpened:n("root-folder-opened",60229),rootFolder:n("root-folder",60230),rss:n("rss",60231),ruby:n("ruby",60232),saveAll:n("save-all",60233),saveAs:n("save-as",60234),save:n("save",60235),screenFull:n("screen-full",60236),screenNormal:n("screen-normal",60237),searchStop:n("search-stop",60238),server:n("server",60240),settingsGear:n("settings-gear",60241),settings:n("settings",60242),shield:n("shield",60243),smiley:n("smiley",60244),sortPrecedence:n("sort-precedence",60245),splitHorizontal:n("split-horizontal",60246),splitVertical:n("split-vertical",60247),squirrel:n("squirrel",60248),starFull:n("star-full",60249),starHalf:n("star-half",60250),symbolClass:n("symbol-class",60251),symbolColor:n("symbol-color",60252),symbolCustomColor:n("symbol-customcolor",60252),symbolConstant:n("symbol-constant",60253),symbolEnumMember:n("symbol-enum-member",60254),symbolField:n("symbol-field",60255),symbolFile:n("symbol-file",60256),symbolInterface:n("symbol-interface",60257),symbolKeyword:n("symbol-keyword",60258),symbolMisc:n("symbol-misc",60259),symbolOperator:n("symbol-operator",60260),symbolProperty:n("symbol-property",60261),wrench:n("wrench",60261),wrenchSubaction:n("wrench-subaction",60261),symbolSnippet:n("symbol-snippet",60262),tasklist:n("tasklist",60263),telescope:n("telescope",60264),textSize:n("text-size",60265),threeBars:n("three-bars",60266),thumbsdown:n("thumbsdown",60267),thumbsup:n("thumbsup",60268),tools:n("tools",60269),triangleDown:n("triangle-down",60270),triangleLeft:n("triangle-left",60271),triangleRight:n("triangle-right",60272),triangleUp:n("triangle-up",60273),twitter:n("twitter",60274),unfold:n("unfold",60275),unlock:n("unlock",60276),unmute:n("unmute",60277),unverified:n("unverified",60278),verified:n("verified",60279),versions:n("versions",60280),vmActive:n("vm-active",60281),vmOutline:n("vm-outline",60282),vmRunning:n("vm-running",60283),watch:n("watch",60284),whitespace:n("whitespace",60285),wholeWord:n("whole-word",60286),window:n("window",60287),wordWrap:n("word-wrap",60288),zoomIn:n("zoom-in",60289),zoomOut:n("zoom-out",60290),listFilter:n("list-filter",60291),listFlat:n("list-flat",60292),listSelection:n("list-selection",60293),selection:n("selection",60293),listTree:n("list-tree",60294),debugBreakpointFunctionUnverified:n("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:n("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:n("debug-breakpoint-function-disabled",60296),debugStackframeActive:n("debug-stackframe-active",60297),circleSmallFilled:n("circle-small-filled",60298),debugStackframeDot:n("debug-stackframe-dot",60298),debugStackframe:n("debug-stackframe",60299),debugStackframeFocused:n("debug-stackframe-focused",60299),debugBreakpointUnsupported:n("debug-breakpoint-unsupported",60300),symbolString:n("symbol-string",60301),debugReverseContinue:n("debug-reverse-continue",60302),debugStepBack:n("debug-step-back",60303),debugRestartFrame:n("debug-restart-frame",60304),callIncoming:n("call-incoming",60306),callOutgoing:n("call-outgoing",60307),menu:n("menu",60308),expandAll:n("expand-all",60309),feedback:n("feedback",60310),groupByRefType:n("group-by-ref-type",60311),ungroupByRefType:n("ungroup-by-ref-type",60312),account:n("account",60313),bellDot:n("bell-dot",60314),debugConsole:n("debug-console",60315),library:n("library",60316),output:n("output",60317),runAll:n("run-all",60318),syncIgnored:n("sync-ignored",60319),pinned:n("pinned",60320),githubInverted:n("github-inverted",60321),debugAlt:n("debug-alt",60305),serverProcess:n("server-process",60322),serverEnvironment:n("server-environment",60323),pass:n("pass",60324),stopCircle:n("stop-circle",60325),playCircle:n("play-circle",60326),record:n("record",60327),debugAltSmall:n("debug-alt-small",60328),vmConnect:n("vm-connect",60329),cloud:n("cloud",60330),merge:n("merge",60331),exportIcon:n("export",60332),graphLeft:n("graph-left",60333),magnet:n("magnet",60334),notebook:n("notebook",60335),redo:n("redo",60336),checkAll:n("check-all",60337),pinnedDirty:n("pinned-dirty",60338),passFilled:n("pass-filled",60339),circleLargeFilled:n("circle-large-filled",60340),circleLarge:n("circle-large",60341),circleLargeOutline:n("circle-large-outline",60341),combine:n("combine",60342),gather:n("gather",60342),table:n("table",60343),variableGroup:n("variable-group",60344),typeHierarchy:n("type-hierarchy",60345),typeHierarchySub:n("type-hierarchy-sub",60346),typeHierarchySuper:n("type-hierarchy-super",60347),gitPullRequestCreate:n("git-pull-request-create",60348),runAbove:n("run-above",60349),runBelow:n("run-below",60350),notebookTemplate:n("notebook-template",60351),debugRerun:n("debug-rerun",60352),workspaceTrusted:n("workspace-trusted",60353),workspaceUntrusted:n("workspace-untrusted",60354),workspaceUnspecified:n("workspace-unspecified",60355),terminalCmd:n("terminal-cmd",60356),terminalDebian:n("terminal-debian",60357),terminalLinux:n("terminal-linux",60358),terminalPowershell:n("terminal-powershell",60359),terminalTmux:n("terminal-tmux",60360),terminalUbuntu:n("terminal-ubuntu",60361),terminalBash:n("terminal-bash",60362),arrowSwap:n("arrow-swap",60363),copy:n("copy",60364),personAdd:n("person-add",60365),filterFilled:n("filter-filled",60366),wand:n("wand",60367),debugLineByLine:n("debug-line-by-line",60368),inspect:n("inspect",60369),layers:n("layers",60370),layersDot:n("layers-dot",60371),layersActive:n("layers-active",60372),compass:n("compass",60373),compassDot:n("compass-dot",60374),compassActive:n("compass-active",60375),azure:n("azure",60376),issueDraft:n("issue-draft",60377),gitPullRequestClosed:n("git-pull-request-closed",60378),gitPullRequestDraft:n("git-pull-request-draft",60379),debugAll:n("debug-all",60380),debugCoverage:n("debug-coverage",60381),runErrors:n("run-errors",60382),folderLibrary:n("folder-library",60383),debugContinueSmall:n("debug-continue-small",60384),beakerStop:n("beaker-stop",60385),graphLine:n("graph-line",60386),graphScatter:n("graph-scatter",60387),pieChart:n("pie-chart",60388),bracketDot:n("bracket-dot",60389),bracketError:n("bracket-error",60390),lockSmall:n("lock-small",60391),azureDevops:n("azure-devops",60392),verifiedFilled:n("verified-filled",60393),newLine:n("newline",60394),layout:n("layout",60395),layoutActivitybarLeft:n("layout-activitybar-left",60396),layoutActivitybarRight:n("layout-activitybar-right",60397),layoutPanelLeft:n("layout-panel-left",60398),layoutPanelCenter:n("layout-panel-center",60399),layoutPanelJustify:n("layout-panel-justify",60400),layoutPanelRight:n("layout-panel-right",60401),layoutPanel:n("layout-panel",60402),layoutSidebarLeft:n("layout-sidebar-left",60403),layoutSidebarRight:n("layout-sidebar-right",60404),layoutStatusbar:n("layout-statusbar",60405),layoutMenubar:n("layout-menubar",60406),layoutCentered:n("layout-centered",60407),layoutSidebarRightOff:n("layout-sidebar-right-off",60416),layoutPanelOff:n("layout-panel-off",60417),layoutSidebarLeftOff:n("layout-sidebar-left-off",60418),target:n("target",60408),indent:n("indent",60409),recordSmall:n("record-small",60410),errorSmall:n("error-small",60411),arrowCircleDown:n("arrow-circle-down",60412),arrowCircleLeft:n("arrow-circle-left",60413),arrowCircleRight:n("arrow-circle-right",60414),arrowCircleUp:n("arrow-circle-up",60415),heartFilled:n("heart-filled",60420),map:n("map",60421),mapFilled:n("map-filled",60422),circleSmall:n("circle-small",60423),bellSlash:n("bell-slash",60424),bellSlashDot:n("bell-slash-dot",60425),commentUnresolved:n("comment-unresolved",60426),gitPullRequestGoToChanges:n("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:n("git-pull-request-new-changes",60428),searchFuzzy:n("search-fuzzy",60429),commentDraft:n("comment-draft",60430),dialogError:n("dialog-error","error"),dialogWarning:n("dialog-warning","warning"),dialogInfo:n("dialog-info","info"),dialogClose:n("dialog-close","close"),treeItemExpanded:n("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:n("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:n("tree-filter-on-type-off","list-selection"),treeFilterClear:n("tree-filter-clear","close"),treeItemLoading:n("tree-item-loading","loading"),menuSelection:n("menu-selection","check"),menuSubmenu:n("menu-submenu","chevron-right"),menuBarMore:n("menubar-more","more"),scrollbarButtonLeft:n("scrollbar-button-left","triangle-left"),scrollbarButtonRight:n("scrollbar-button-right","triangle-right"),scrollbarButtonUp:n("scrollbar-button-up","triangle-up"),scrollbarButtonDown:n("scrollbar-button-down","triangle-down"),toolBarMore:n("toolbar-more","more"),quickInputBack:n("quick-input-back","arrow-left")}}),define(ee[40],te([0,1,10]),function(G,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function A(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const p=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([k,E])=>{p[k]=E&&typeof E=="object"?A(E):E}),p}e.deepClone=A;function n(u){if(!u||typeof u!="object")return u;const p=[u];for(;p.length>0;){const k=p.shift();Object.freeze(k);for(const E in k)if(C.call(k,E)){const M=k[E];typeof M=="object"&&!Object.isFrozen(M)&&!(0,I.isTypedArray)(M)&&p.push(M)}}return u}e.deepFreeze=n;const C=Object.prototype.hasOwnProperty;function D(u,p){return P(u,p,new Set)}e.cloneAndChange=D;function P(u,p,k){if((0,I.isUndefinedOrNull)(u))return u;const E=p(u);if(typeof E<"u")return E;if(Array.isArray(u)){const M=[];for(const t of u)M.push(P(t,p,k));return M}if((0,I.isObject)(u)){if(k.has(u))throw new Error("Cannot clone recursive data-structure");k.add(u);const M={};for(const t in u)C.call(u,t)&&(M[t]=P(u[t],p,k));return k.delete(u),M}return u}function f(u,p,k=!0){return(0,I.isObject)(u)?((0,I.isObject)(p)&&Object.keys(p).forEach(E=>{E in u?k&&((0,I.isObject)(u[E])&&(0,I.isObject)(p[E])?f(u[E],p[E],k):u[E]=p[E]):u[E]=p[E]}),u):p}e.mixin=f;function h(u,p){if(u===p)return!0;if(u==null||p===null||p===void 0||typeof u!=typeof p||typeof u!="object"||Array.isArray(u)!==Array.isArray(p))return!1;let k,E;if(Array.isArray(u)){if(u.length!==p.length)return!1;for(k=0;k<u.length;k++)if(!h(u[k],p[k]))return!1}else{const M=[];for(E in u)M.push(E);M.sort();const t=[];for(E in p)t.push(E);if(t.sort(),!h(M,t))return!1;for(k=0;k<M.length;k++)if(!h(u[M[k]],p[M[k]]))return!1}return!0}e.equals=h;function b(u){const p=new Set;return JSON.stringify(u,(k,E)=>{if((0,I.isObject)(E)||Array.isArray(E)){if(p.has(E))return"[Circular]";p.add(E)}return E})}e.safeStringify=b;function v(u,p){const k=Object.create(null);return!u||!p||Object.keys(p).forEach(M=>{const t=u[M],a=p[M];h(t,a)||(k[M]=a)}),k}e.distinct=v;function y(u,p){const k=p.toLowerCase(),E=Object.keys(u).find(M=>M.toLowerCase()===k);return E?u[E]:u[p]}e.getCaseInsensitive=y;function g(u,p){const k=Object.create(null);for(const[E,M]of Object.entries(u))p(E,M)&&(k[E]=M);return k}e.filter=g;function m(u){let p=[],k=Object.getPrototypeOf(u);for(;Object.prototype!==k;)p=p.concat(Object.getOwnPropertyNames(k)),k=Object.getPrototypeOf(k);return p}e.getAllPropertyNames=m;function w(u){const p=[];for(const k of m(u))typeof u[k]=="function"&&p.push(k);return p}e.getAllMethodNames=w;function o(u,p){const k=M=>function(){const t=Array.prototype.slice.call(arguments,0);return p(M,t)},E={};for(const M of u)E[M]=k(M);return E}e.createProxyObject=o}),define(ee[131],te([0,1,130]),function(G,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var A;(function(D){function P(f){return f&&typeof f=="object"&&typeof f.id=="string"}D.isThemeColor=P})(A=e.ThemeColor||(e.ThemeColor={}));function n(D){return{id:D}}e.themeColorFromId=n;var C;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function f(p){const k=P.exec(p.id);if(!k)return f(I.Codicon.error);const[,E,M]=k,t=["codicon","codicon-"+E];return M&&t.push("codicon-modifier-"+M.substring(1)),t}D.asClassNameArray=f;function h(p){return f(p).join(" ")}D.asClassName=h;function b(p){return"."+f(p).join(".")}D.asCSSSelector=b;function v(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(typeof p.color>"u"||A.isThemeColor(p.color))}D.isThemeIcon=v;const y=new RegExp(`^\\$\\((${D.iconNameExpression}(?:${D.iconModifierExpression})?)\\)$`);function g(p){const k=y.exec(p);if(!k)return;const[,E]=k;return{id:E}}D.fromString=g;function m(p){return{id:p}}D.fromId=m;function w(p,k){let E=p.id;const M=E.lastIndexOf("~");return M!==-1&&(E=E.substring(0,M)),k&&(E=`${E}~${k}`),{id:E}}D.modify=w;function o(p){const k=p.id.lastIndexOf("~");if(k!==-1)return p.id.substring(k+1)}D.getModifier=o;function u(p,k){return p.id===k.id&&p.color?.id===k.color?.id}D.isEqual=u})(C=e.ThemeIcon||(e.ThemeIcon={}))}),define(ee[31],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(n){return I.test(n)}e.isUUID=A,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let n;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?n=crypto.getRandomValues.bind(crypto):n=function(P){for(let f=0;f<P.length;f++)P[f]=Math.floor(Math.random()*256);return P};const C=new Uint8Array(16),D=[];for(let P=0;P<256;P++)D.push(P.toString(16).padStart(2,"0"));return function(){n(C),C[6]=C[6]&15|64,C[8]=C[8]&63|128;let f=0,h="";return h+=D[C[f++]],h+=D[C[f++]],h+=D[C[f++]],h+=D[C[f++]],h+="-",h+=D[C[f++]],h+=D[C[f++]],h+="-",h+=D[C[f++]],h+=D[C[f++]],h+="-",h+=D[C[f++]],h+=D[C[f++]],h+="-",h+=D[C[f++]],h+=D[C[f++]],h+=D[C[f++]],h+=D[C[f++]],h+=D[C[f++]],h+=D[C[f++]],h}}()}),define(ee[132],te([0,1,81,41,50]),function(G,e,I,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function C(D,P){if(await new Promise((b,v)=>{const y=A.createReadStream(D),g=I.createHash("sha1");y.pipe(g);const m=(0,n.once)((w,o)=>{y.removeAllListeners(),g.removeAllListeners(),w?v(w):b(o)});y.once("error",m),y.once("end",m),g.once("error",m),g.once("data",w=>m(void 0,w.toString("hex")))})!==P)throw new Error("Hash mismatch")}e.checksum=C}),define(ee[133],te([0,1,26]),function(G,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const A=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function n(D){const P=D.replace(/\-/g,":").toLowerCase();return!A.has(P)}function C(){const D=(0,I.networkInterfaces)();for(const P in D){const f=D[P];if(f){for(const{mac:h}of f)if(n(h))return h}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=C}),define(ee[100],te([0,1,82]),function(G,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function A(P,f,h,b=1){let v=!1;return new Promise(y=>{const g=setTimeout(()=>{if(!v)return v=!0,y(0)},h);n(P,f,b,m=>{if(!v)return v=!0,clearTimeout(g),y(m)})})}e.findFreePort=A;function n(P,f,h,b){if(f===0)return b(0);const v=new I.Socket;v.once("connect",()=>(D(v),n(P+h,f-1,h,b))),v.once("data",()=>{}),v.once("error",y=>(D(v),y.code!=="ECONNREFUSED"?n(P+h,f-1,h,b):b(P))),v.connect(P,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function C(P,f,h,b="127.0.0.1"){let v=!1,y,g=1;const m=I.createServer({pauseOnConnect:!0});function w(o,u){v||(v=!0,m.removeAllListeners(),m.close(),y&&clearTimeout(y),u(o))}return new Promise(o=>{y=setTimeout(()=>{w(0,o)},h),m.on("listening",()=>{w(P,o)}),m.on("error",u=>{u&&(u.code==="EADDRINUSE"||u.code==="EACCES")&&g<f?(P++,g++,m.listen(P,b)):w(0,o)}),m.on("close",()=>{w(0,o)}),m.listen(P,b)})}e.findFreePortFaster=C;function D(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(f){console.error(f)}}}),define(ee[134],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(ee[135],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class I{constructor(n,C){this.a=n,this.onMessage=C}send(n){try{this.a.send("vscode:message",n.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.Protocol=I}),define(ee[42],te([0,1,14,13]),function(G,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class n{constructor(){this.a=new WeakMap}on(D,P){const f=(h,...b)=>{this.b(D,h)&&P(h,...b)};return this.a.set(P,f),I.ipcMain.on(D,f),this}once(D,P){return I.ipcMain.once(D,(f,...h)=>{this.b(D,f)&&P(f,...h)}),this}handle(D,P){return I.ipcMain.handle(D,(f,...h)=>this.b(D,f)?P(f,...h):Promise.reject(`Invalid channel '${D}' or sender for ipcMain.handle() usage.`)),this}removeHandler(D){return I.ipcMain.removeHandler(D),this}removeListener(D,P){const f=this.a.get(P);return f&&(I.ipcMain.removeListener(D,f),this.a.delete(P)),this}b(D,P){if(!D||!D.startsWith("vscode:"))return(0,A.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because the channel is unknown.`),!1;const f=P.senderFrame,h=f.url;if(!h)return!0;let b="unknown";try{b=new URL(h).host}catch{return(0,A.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because of a malformed URL '${h}'.`),!1}return b!=="vscode-app"?((0,A.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because of a bad origin of '${b}'.`),!1):f.parent!==null?((0,A.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because sender of origin '${b}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new n}),define(ee[136],te([0,1,14,42,10,134]),function(G,e,I,A,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function D(){A.validatedIpcMain.on(C.CONTEXT_MENU_CHANNEL,(f,h,b,v,y)=>{const g=P(f,v,b);g.popup({window:(0,n.withNullAsUndefined)(I.BrowserWindow.fromWebContents(f.sender)),x:y?y.x:void 0,y:y?y.y:void 0,positioningItem:y?y.positioningItem:void 0,callback:()=>{g&&f.sender.send(C.CONTEXT_MENU_CLOSE_CHANNEL,h)}})})}e.registerContextMenuListener=D;function P(f,h,b){const v=new I.Menu;return b.forEach(y=>{let g;y.type==="separator"?g=new I.MenuItem({type:y.type}):Array.isArray(y.submenu)?g=new I.MenuItem({submenu:P(f,h,y.submenu),label:y.label}):g=new I.MenuItem({label:y.label,type:y.type,accelerator:y.accelerator,checked:y.checked,enabled:y.enabled,visible:y.visible,click:(m,w,o)=>f.sender.send(h,y.id,o)}),v.append(g)}),v}}),define(ee[137],te([12,11]),function(G,e){return G.create("vs/base/common/date",e)}),define(ee[138],te([0,1,137]),function(G,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const A=60,n=A*60,C=n*24,D=C*7,P=C*30,f=C*365;function h(v,y,g,m){typeof v!="number"&&(v=v.getTime());const w=Math.round((new Date().getTime()-v)/1e3);if(w<-30)return(0,I.localize)(0,null,h(new Date().getTime()+w*1e3,!1));if(!m&&w<30)return(0,I.localize)(1,null);let o;return w<A?(o=w,y?o===1?g?(0,I.localize)(2,null,o):(0,I.localize)(3,null,o):g?(0,I.localize)(4,null,o):(0,I.localize)(5,null,o):o===1?g?(0,I.localize)(6,null,o):(0,I.localize)(7,null,o):g?(0,I.localize)(8,null,o):(0,I.localize)(9,null,o)):w<n?(o=Math.floor(w/A),y?o===1?g?(0,I.localize)(10,null,o):(0,I.localize)(11,null,o):g?(0,I.localize)(12,null,o):(0,I.localize)(13,null,o):o===1?g?(0,I.localize)(14,null,o):(0,I.localize)(15,null,o):g?(0,I.localize)(16,null,o):(0,I.localize)(17,null,o)):w<C?(o=Math.floor(w/n),y?o===1?g?(0,I.localize)(18,null,o):(0,I.localize)(19,null,o):g?(0,I.localize)(20,null,o):(0,I.localize)(21,null,o):o===1?g?(0,I.localize)(22,null,o):(0,I.localize)(23,null,o):g?(0,I.localize)(24,null,o):(0,I.localize)(25,null,o)):w<D?(o=Math.floor(w/C),y?o===1?(0,I.localize)(26,null,o):(0,I.localize)(27,null,o):o===1?(0,I.localize)(28,null,o):(0,I.localize)(29,null,o)):w<P?(o=Math.floor(w/D),y?o===1?g?(0,I.localize)(30,null,o):(0,I.localize)(31,null,o):g?(0,I.localize)(32,null,o):(0,I.localize)(33,null,o):o===1?g?(0,I.localize)(34,null,o):(0,I.localize)(35,null,o):g?(0,I.localize)(36,null,o):(0,I.localize)(37,null,o)):w<f?(o=Math.floor(w/P),y?o===1?g?(0,I.localize)(38,null,o):(0,I.localize)(39,null,o):g?(0,I.localize)(40,null,o):(0,I.localize)(41,null,o):o===1?g?(0,I.localize)(42,null,o):(0,I.localize)(43,null,o):g?(0,I.localize)(44,null,o):(0,I.localize)(45,null,o)):(o=Math.floor(w/f),y?o===1?g?(0,I.localize)(46,null,o):(0,I.localize)(47,null,o):g?(0,I.localize)(48,null,o):(0,I.localize)(49,null,o):o===1?g?(0,I.localize)(50,null,o):(0,I.localize)(51,null,o):g?(0,I.localize)(52,null,o):(0,I.localize)(53,null,o))}e.fromNow=h;function b(v){return v.getFullYear()+"-"+String(v.getMonth()+1).padStart(2,"0")+"-"+String(v.getDate()).padStart(2,"0")+"T"+String(v.getHours()).padStart(2,"0")+":"+String(v.getMinutes()).padStart(2,"0")+":"+String(v.getSeconds()).padStart(2,"0")+"."+(v.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=b}),define(ee[139],te([12,11]),function(G,e){return G.create("vs/base/common/errorMessage",e)}),define(ee[44],te([0,1,25,10,139]),function(G,e,I,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function C(v,y){return y&&(v.stack||v.stacktrace)?n.localize(0,null,P(v),D(v.stack)||D(v.stacktrace)):P(v)}function D(v){return Array.isArray(v)?v.join(`
`):v}function P(v){return typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?n.localize(1,null,v.message):v.message||n.localize(2,null)}function f(v=null,y=!1){if(!v)return n.localize(3,null);if(Array.isArray(v)){const g=I.coalesce(v),m=f(g[0],y);return g.length>1?n.localize(4,null,m,g.length):m}if(A.isString(v))return v;if(v.detail){const g=v.detail;if(g.error)return C(g.error,y);if(g.exception)return C(g.exception,y)}return v.stack?C(v,y):v.message?v.message:n.localize(5,null)}e.toErrorMessage=f;function h(v){const y=v;return y instanceof Error&&Array.isArray(y.actions)}e.isErrorWithActions=h;function b(v,y){let g;return typeof v=="string"?g=new Error(v):g=v,g.actions=y,g}e.createErrorWithActions=b}),define(ee[140],te([12,11]),function(G,e){return G.create("vs/base/common/jsonErrorMessages",e)}),define(ee[141],te([0,1,140]),function(G,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function A(n){switch(n){case 1:return(0,I.localize)(0,null);case 2:return(0,I.localize)(1,null);case 3:return(0,I.localize)(2,null);case 4:return(0,I.localize)(3,null);case 5:return(0,I.localize)(4,null);case 6:return(0,I.localize)(5,null);case 7:return(0,I.localize)(6,null);case 8:return(0,I.localize)(7,null);case 9:return(0,I.localize)(8,null);default:return""}}e.getParseErrorMessage=A}),define(ee[142],te([12,11]),function(G,e){return G.create("vs/base/common/platform",e)}),define(ee[4],te([0,1,142]),function(G,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let A=!1,n=!1,C=!1,D=!1,P=!1,f=!1,h=!1,b=!1,v=!1,y=!1,g,m=e.LANGUAGE_DEFAULT,w,o;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?u=e.globals.vscode.process:typeof process<"u"&&(u=process);const p=typeof u?.versions?.electron=="string",k=p&&u?.type==="renderer";if(typeof navigator=="object"&&!k)o=navigator.userAgent,A=o.indexOf("Windows")>=0,n=o.indexOf("Macintosh")>=0,b=(o.indexOf("Macintosh")>=0||o.indexOf("iPad")>=0||o.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=o.indexOf("Linux")>=0,y=o?.indexOf("Mobi")>=0,f=!0,g=I.getConfiguredDefaultLocale(I.localize(0,null))||e.LANGUAGE_DEFAULT,m=g;else if(typeof u=="object"){A=u.platform==="win32",n=u.platform==="darwin",C=u.platform==="linux",D=C&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,h=p,v=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,g=e.LANGUAGE_DEFAULT,m=e.LANGUAGE_DEFAULT;const s=u.env.VSCODE_NLS_CONFIG;if(s)try{const d=JSON.parse(s),S=d.availableLanguages["*"];g=d.locale,m=S||e.LANGUAGE_DEFAULT,w=d._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var E;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(E=e.Platform||(e.Platform={}));function M(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=M;let t=0;n?t=1:A?t=3:C&&(t=2),e.isWindows=A,e.isMacintosh=n,e.isLinux=C,e.isLinuxSnap=D,e.isNative=P,e.isElectron=h,e.isWeb=f,e.isWebWorker=f&&typeof e.globals.importScripts=="function",e.isIOS=b,e.isMobile=y,e.isCI=v,e.platform=t,e.userAgent=o,e.language=m;var a;(function(s){function d(){return e.language}s.value=d;function S(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=S;function R(){return e.language==="en"}s.isDefault=R})(a=e.Language||(e.Language={})),e.locale=g,e.translationsConfigFile=w,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const s=[];e.globals.addEventListener("message",S=>{if(S.data&&S.data.vscodeScheduleAsyncWork)for(let R=0,O=s.length;R<O;R++){const N=s[R];if(N.id===S.data.vscodeScheduleAsyncWork){s.splice(R,1),N.callback();return}}});let d=0;return S=>{const R=++d;s.push({id:R,callback:S}),e.globals.postMessage({vscodeScheduleAsyncWork:R},"*")}}return s=>setTimeout(s)})();var i;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(i=e.OperatingSystem||(e.OperatingSystem={})),e.OS=n||b?2:A?1:3;let r=!0,c=!1;function l(){if(!c){c=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,r=new Uint16Array(s.buffer)[0]===(2<<8)+1}return r}e.isLittleEndian=l,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ee[36],te([0,1,4]),function(G,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let A;if(typeof I.globals.vscode<"u"&&typeof I.globals.vscode.process<"u"){const n=I.globals.vscode.process;A={get platform(){return n.platform},get arch(){return n.arch},get env(){return n.env},cwd(){return n.cwd()}}}else typeof process<"u"?A={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:A={get platform(){return I.isWindows?"win32":I.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=A.cwd,e.env=A.env,e.platform=A.platform,e.arch=A.arch}),define(ee[9],te([0,1,36]),function(G,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const A=65,n=97,C=90,D=122,P=46,f=47,h=92,b=58,v=63;class y extends Error{constructor(a,i,r){let c;typeof i=="string"&&i.indexOf("not ")===0?(c="must not be",i=i.replace(/^not /,"")):c="must be";const l=a.indexOf(".")!==-1?"property":"argument";let s=`The "${a}" ${l} ${c} of type ${i}`;s+=`. Received type ${typeof r}`,super(s),this.code="ERR_INVALID_ARG_TYPE"}}function g(t,a){if(t===null||typeof t!="object")throw new y(a,"Object",t)}function m(t,a){if(typeof t!="string")throw new y(a,"string",t)}const w=I.platform==="win32";function o(t){return t===f||t===h}function u(t){return t===f}function p(t){return t>=A&&t<=C||t>=n&&t<=D}function k(t,a,i,r){let c="",l=0,s=-1,d=0,S=0;for(let R=0;R<=t.length;++R){if(R<t.length)S=t.charCodeAt(R);else{if(r(S))break;S=f}if(r(S)){if(!(s===R-1||d===1))if(d===2){if(c.length<2||l!==2||c.charCodeAt(c.length-1)!==P||c.charCodeAt(c.length-2)!==P){if(c.length>2){const O=c.lastIndexOf(i);O===-1?(c="",l=0):(c=c.slice(0,O),l=c.length-1-c.lastIndexOf(i)),s=R,d=0;continue}else if(c.length!==0){c="",l=0,s=R,d=0;continue}}a&&(c+=c.length>0?`${i}..`:"..",l=2)}else c.length>0?c+=`${i}${t.slice(s+1,R)}`:c=t.slice(s+1,R),l=R-s-1;s=R,d=0}else S===P&&d!==-1?++d:d=-1}return c}function E(t,a){g(a,"pathObject");const i=a.dir||a.root,r=a.base||`${a.name||""}${a.ext||""}`;return i?i===a.root?`${i}${r}`:`${i}${t}${r}`:r}e.win32={resolve(...t){let a="",i="",r=!1;for(let c=t.length-1;c>=-1;c--){let l;if(c>=0){if(l=t[c],m(l,"path"),l.length===0)continue}else a.length===0?l=I.cwd():(l=I.env[`=${a}`]||I.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==a.toLowerCase()&&l.charCodeAt(2)===h)&&(l=`${a}\\`));const s=l.length;let d=0,S="",R=!1;const O=l.charCodeAt(0);if(s===1)o(O)&&(d=1,R=!0);else if(o(O))if(R=!0,o(l.charCodeAt(1))){let N=2,K=N;for(;N<s&&!o(l.charCodeAt(N));)N++;if(N<s&&N!==K){const V=l.slice(K,N);for(K=N;N<s&&o(l.charCodeAt(N));)N++;if(N<s&&N!==K){for(K=N;N<s&&!o(l.charCodeAt(N));)N++;(N===s||N!==K)&&(S=`\\\\${V}\\${l.slice(K,N)}`,d=N)}}}else d=1;else p(O)&&l.charCodeAt(1)===b&&(S=l.slice(0,2),d=2,s>2&&o(l.charCodeAt(2))&&(R=!0,d=3));if(S.length>0)if(a.length>0){if(S.toLowerCase()!==a.toLowerCase())continue}else a=S;if(r){if(a.length>0)break}else if(i=`${l.slice(d)}\\${i}`,r=R,R&&a.length>0)break}return i=k(i,!r,"\\",o),r?`${a}\\${i}`:`${a}${i}`||"."},normalize(t){m(t,"path");const a=t.length;if(a===0)return".";let i=0,r,c=!1;const l=t.charCodeAt(0);if(a===1)return u(l)?"\\":t;if(o(l))if(c=!0,o(t.charCodeAt(1))){let d=2,S=d;for(;d<a&&!o(t.charCodeAt(d));)d++;if(d<a&&d!==S){const R=t.slice(S,d);for(S=d;d<a&&o(t.charCodeAt(d));)d++;if(d<a&&d!==S){for(S=d;d<a&&!o(t.charCodeAt(d));)d++;if(d===a)return`\\\\${R}\\${t.slice(S)}\\`;d!==S&&(r=`\\\\${R}\\${t.slice(S,d)}`,i=d)}}}else i=1;else p(l)&&t.charCodeAt(1)===b&&(r=t.slice(0,2),i=2,a>2&&o(t.charCodeAt(2))&&(c=!0,i=3));let s=i<a?k(t.slice(i),!c,"\\",o):"";return s.length===0&&!c&&(s="."),s.length>0&&o(t.charCodeAt(a-1))&&(s+="\\"),r===void 0?c?`\\${s}`:s:c?`${r}\\${s}`:`${r}${s}`},isAbsolute(t){m(t,"path");const a=t.length;if(a===0)return!1;const i=t.charCodeAt(0);return o(i)||a>2&&p(i)&&t.charCodeAt(1)===b&&o(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let a,i;for(let l=0;l<t.length;++l){const s=t[l];m(s,"path"),s.length>0&&(a===void 0?a=i=s:a+=`\\${s}`)}if(a===void 0)return".";let r=!0,c=0;if(typeof i=="string"&&o(i.charCodeAt(0))){++c;const l=i.length;l>1&&o(i.charCodeAt(1))&&(++c,l>2&&(o(i.charCodeAt(2))?++c:r=!1))}if(r){for(;c<a.length&&o(a.charCodeAt(c));)c++;c>=2&&(a=`\\${a.slice(c)}`)}return e.win32.normalize(a)},relative(t,a){if(m(t,"from"),m(a,"to"),t===a)return"";const i=e.win32.resolve(t),r=e.win32.resolve(a);if(i===r||(t=i.toLowerCase(),a=r.toLowerCase(),t===a))return"";let c=0;for(;c<t.length&&t.charCodeAt(c)===h;)c++;let l=t.length;for(;l-1>c&&t.charCodeAt(l-1)===h;)l--;const s=l-c;let d=0;for(;d<a.length&&a.charCodeAt(d)===h;)d++;let S=a.length;for(;S-1>d&&a.charCodeAt(S-1)===h;)S--;const R=S-d,O=s<R?s:R;let N=-1,K=0;for(;K<O;K++){const X=t.charCodeAt(c+K);if(X!==a.charCodeAt(d+K))break;X===h&&(N=K)}if(K!==O){if(N===-1)return r}else{if(R>O){if(a.charCodeAt(d+K)===h)return r.slice(d+K+1);if(K===2)return r.slice(d+K)}s>O&&(t.charCodeAt(c+K)===h?N=K:K===2&&(N=3)),N===-1&&(N=0)}let V="";for(K=c+N+1;K<=l;++K)(K===l||t.charCodeAt(K)===h)&&(V+=V.length===0?"..":"\\..");return d+=N,V.length>0?`${V}${r.slice(d,S)}`:(r.charCodeAt(d)===h&&++d,r.slice(d,S))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const a=e.win32.resolve(t);if(a.length<=2)return t;if(a.charCodeAt(0)===h){if(a.charCodeAt(1)===h){const i=a.charCodeAt(2);if(i!==v&&i!==P)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(p(a.charCodeAt(0))&&a.charCodeAt(1)===b&&a.charCodeAt(2)===h)return`\\\\?\\${a}`;return t},dirname(t){m(t,"path");const a=t.length;if(a===0)return".";let i=-1,r=0;const c=t.charCodeAt(0);if(a===1)return o(c)?t:".";if(o(c)){if(i=r=1,o(t.charCodeAt(1))){let d=2,S=d;for(;d<a&&!o(t.charCodeAt(d));)d++;if(d<a&&d!==S){for(S=d;d<a&&o(t.charCodeAt(d));)d++;if(d<a&&d!==S){for(S=d;d<a&&!o(t.charCodeAt(d));)d++;if(d===a)return t;d!==S&&(i=r=d+1)}}}}else p(c)&&t.charCodeAt(1)===b&&(i=a>2&&o(t.charCodeAt(2))?3:2,r=i);let l=-1,s=!0;for(let d=a-1;d>=r;--d)if(o(t.charCodeAt(d))){if(!s){l=d;break}}else s=!1;if(l===-1){if(i===-1)return".";l=i}return t.slice(0,l)},basename(t,a){a!==void 0&&m(a,"ext"),m(t,"path");let i=0,r=-1,c=!0,l;if(t.length>=2&&p(t.charCodeAt(0))&&t.charCodeAt(1)===b&&(i=2),a!==void 0&&a.length>0&&a.length<=t.length){if(a===t)return"";let s=a.length-1,d=-1;for(l=t.length-1;l>=i;--l){const S=t.charCodeAt(l);if(o(S)){if(!c){i=l+1;break}}else d===-1&&(c=!1,d=l+1),s>=0&&(S===a.charCodeAt(s)?--s===-1&&(r=l):(s=-1,r=d))}return i===r?r=d:r===-1&&(r=t.length),t.slice(i,r)}for(l=t.length-1;l>=i;--l)if(o(t.charCodeAt(l))){if(!c){i=l+1;break}}else r===-1&&(c=!1,r=l+1);return r===-1?"":t.slice(i,r)},extname(t){m(t,"path");let a=0,i=-1,r=0,c=-1,l=!0,s=0;t.length>=2&&t.charCodeAt(1)===b&&p(t.charCodeAt(0))&&(a=r=2);for(let d=t.length-1;d>=a;--d){const S=t.charCodeAt(d);if(o(S)){if(!l){r=d+1;break}continue}c===-1&&(l=!1,c=d+1),S===P?i===-1?i=d:s!==1&&(s=1):i!==-1&&(s=-1)}return i===-1||c===-1||s===0||s===1&&i===c-1&&i===r+1?"":t.slice(i,c)},format:E.bind(null,"\\"),parse(t){m(t,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return a;const i=t.length;let r=0,c=t.charCodeAt(0);if(i===1)return o(c)?(a.root=a.dir=t,a):(a.base=a.name=t,a);if(o(c)){if(r=1,o(t.charCodeAt(1))){let N=2,K=N;for(;N<i&&!o(t.charCodeAt(N));)N++;if(N<i&&N!==K){for(K=N;N<i&&o(t.charCodeAt(N));)N++;if(N<i&&N!==K){for(K=N;N<i&&!o(t.charCodeAt(N));)N++;N===i?r=N:N!==K&&(r=N+1)}}}}else if(p(c)&&t.charCodeAt(1)===b){if(i<=2)return a.root=a.dir=t,a;if(r=2,o(t.charCodeAt(2))){if(i===3)return a.root=a.dir=t,a;r=3}}r>0&&(a.root=t.slice(0,r));let l=-1,s=r,d=-1,S=!0,R=t.length-1,O=0;for(;R>=r;--R){if(c=t.charCodeAt(R),o(c)){if(!S){s=R+1;break}continue}d===-1&&(S=!1,d=R+1),c===P?l===-1?l=R:O!==1&&(O=1):l!==-1&&(O=-1)}return d!==-1&&(l===-1||O===0||O===1&&l===d-1&&l===s+1?a.base=a.name=t.slice(s,d):(a.name=t.slice(s,l),a.base=t.slice(s,d),a.ext=t.slice(l,d))),s>0&&s!==r?a.dir=t.slice(0,s-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const M=(()=>{if(w){const t=/\\/g;return()=>{const a=I.cwd().replace(t,"/");return a.slice(a.indexOf("/"))}}return()=>I.cwd()})();e.posix={resolve(...t){let a="",i=!1;for(let r=t.length-1;r>=-1&&!i;r--){const c=r>=0?t[r]:M();m(c,"path"),c.length!==0&&(a=`${c}/${a}`,i=c.charCodeAt(0)===f)}return a=k(a,!i,"/",u),i?`/${a}`:a.length>0?a:"."},normalize(t){if(m(t,"path"),t.length===0)return".";const a=t.charCodeAt(0)===f,i=t.charCodeAt(t.length-1)===f;return t=k(t,!a,"/",u),t.length===0?a?"/":i?"./":".":(i&&(t+="/"),a?`/${t}`:t)},isAbsolute(t){return m(t,"path"),t.length>0&&t.charCodeAt(0)===f},join(...t){if(t.length===0)return".";let a;for(let i=0;i<t.length;++i){const r=t[i];m(r,"path"),r.length>0&&(a===void 0?a=r:a+=`/${r}`)}return a===void 0?".":e.posix.normalize(a)},relative(t,a){if(m(t,"from"),m(a,"to"),t===a||(t=e.posix.resolve(t),a=e.posix.resolve(a),t===a))return"";const i=1,r=t.length,c=r-i,l=1,s=a.length-l,d=c<s?c:s;let S=-1,R=0;for(;R<d;R++){const N=t.charCodeAt(i+R);if(N!==a.charCodeAt(l+R))break;N===f&&(S=R)}if(R===d)if(s>d){if(a.charCodeAt(l+R)===f)return a.slice(l+R+1);if(R===0)return a.slice(l+R)}else c>d&&(t.charCodeAt(i+R)===f?S=R:R===0&&(S=0));let O="";for(R=i+S+1;R<=r;++R)(R===r||t.charCodeAt(R)===f)&&(O+=O.length===0?"..":"/..");return`${O}${a.slice(l+S)}`},toNamespacedPath(t){return t},dirname(t){if(m(t,"path"),t.length===0)return".";const a=t.charCodeAt(0)===f;let i=-1,r=!0;for(let c=t.length-1;c>=1;--c)if(t.charCodeAt(c)===f){if(!r){i=c;break}}else r=!1;return i===-1?a?"/":".":a&&i===1?"//":t.slice(0,i)},basename(t,a){a!==void 0&&m(a,"ext"),m(t,"path");let i=0,r=-1,c=!0,l;if(a!==void 0&&a.length>0&&a.length<=t.length){if(a===t)return"";let s=a.length-1,d=-1;for(l=t.length-1;l>=0;--l){const S=t.charCodeAt(l);if(S===f){if(!c){i=l+1;break}}else d===-1&&(c=!1,d=l+1),s>=0&&(S===a.charCodeAt(s)?--s===-1&&(r=l):(s=-1,r=d))}return i===r?r=d:r===-1&&(r=t.length),t.slice(i,r)}for(l=t.length-1;l>=0;--l)if(t.charCodeAt(l)===f){if(!c){i=l+1;break}}else r===-1&&(c=!1,r=l+1);return r===-1?"":t.slice(i,r)},extname(t){m(t,"path");let a=-1,i=0,r=-1,c=!0,l=0;for(let s=t.length-1;s>=0;--s){const d=t.charCodeAt(s);if(d===f){if(!c){i=s+1;break}continue}r===-1&&(c=!1,r=s+1),d===P?a===-1?a=s:l!==1&&(l=1):a!==-1&&(l=-1)}return a===-1||r===-1||l===0||l===1&&a===r-1&&a===i+1?"":t.slice(a,r)},format:E.bind(null,"/"),parse(t){m(t,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return a;const i=t.charCodeAt(0)===f;let r;i?(a.root="/",r=1):r=0;let c=-1,l=0,s=-1,d=!0,S=t.length-1,R=0;for(;S>=r;--S){const O=t.charCodeAt(S);if(O===f){if(!d){l=S+1;break}continue}s===-1&&(d=!1,s=S+1),O===P?c===-1?c=S:R!==1&&(R=1):c!==-1&&(R=-1)}if(s!==-1){const O=l===0&&i?1:l;c===-1||R===0||R===1&&c===s-1&&c===l+1?a.base=a.name=t.slice(O,s):(a.name=t.slice(O,c),a.base=t.slice(O,s),a.ext=t.slice(c,s))}return l>0?a.dir=t.slice(0,l-1):i&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=w?e.win32.normalize:e.posix.normalize,e.isAbsolute=w?e.win32.isAbsolute:e.posix.isAbsolute,e.join=w?e.win32.join:e.posix.join,e.resolve=w?e.win32.resolve:e.posix.resolve,e.relative=w?e.win32.relative:e.posix.relative,e.dirname=w?e.win32.dirname:e.posix.dirname,e.basename=w?e.win32.basename:e.posix.basename,e.extname=w?e.win32.extname:e.posix.extname,e.format=w?e.win32.format:e.posix.format,e.parse=w?e.win32.parse:e.posix.parse,e.toNamespacedPath=w?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=w?e.win32.sep:e.posix.sep,e.delimiter=w?e.win32.delimiter:e.posix.delimiter}),define(ee[83],te([0,1,4]),function(G,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var A;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(A=e.Source||(e.Source={}));var n;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(n=e.TerminateResponseCode||(e.TerminateResponseCode={}));function C(P,...f){const h=f.reduce((y,g)=>(y[g]=!0,y),{}),b=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(y=>!h[y]).forEach(y=>{for(let g=0;g<b.length;g++)if(y.search(b[g])!==-1){delete P[y];break}})}e.sanitizeProcessEnvironment=C;function D(P){!P||(delete P.DEBUG,I.isMacintosh&&delete P.DYLD_LIBRARY_PATH,I.isLinux&&delete P.LD_PRELOAD)}e.removeDangerousEnvVariables=D}),define(ee[71],te([0,1,4]),function(G,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const A=I.globals.performance&&typeof I.globals.performance.now=="function";class n{static create(D=!0){return new n(D)}constructor(D){this.a=A&&D,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?I.globals.performance.now():Date.now()}}e.StopWatch=n}),define(ee[3],te([0,1,13,50,2,99,71]),function(G,e,I,A,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const P=!1,f=!1;var h;(function(l){l.None=()=>n.Disposable.None;function s(T){if(f){const{onDidAddListener:B}=T,H=m.create();let j=0;T.onDidAddListener=()=>{++j===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),H.print()),B?.()}}}function d(T,B){return re(T,()=>{},0,void 0,void 0,B)}l.defer=d;function S(T){return(B,H=null,j)=>{let $=!1,q;return q=T(oe=>{if(!$)return q?q.dispose():$=!0,B.call(H,oe)},null,j),$&&q.dispose(),q}}l.once=S;function R(T,B,H){return ie((j,$=null,q)=>T(oe=>j.call($,B(oe)),null,q),H)}l.map=R;function O(T,B,H){return ie((j,$=null,q)=>T(oe=>{B(oe),j.call($,oe)},null,q),H)}l.forEach=O;function N(T,B,H){return ie((j,$=null,q)=>T(oe=>B(oe)&&j.call($,oe),null,q),H)}l.filter=N;function K(T){return T}l.signal=K;function V(...T){return(B,H=null,j)=>(0,n.combinedDisposable)(...T.map($=>$(q=>B.call(H,q),null,j)))}l.any=V;function X(T,B,H,j){let $=H;return R(T,q=>($=B($,q),$),j)}l.reduce=X;function ie(T,B){let H;const j={onWillAddFirstListener(){H=T($.fire,$)},onDidRemoveLastListener(){H?.dispose()}};B||s(j);const $=new o(j);return B?.add($),$.event}function re(T,B,H=100,j=!1,$,q){let oe,de,pe,ye=0;const Le={leakWarningThreshold:$,onWillAddFirstListener(){oe=T(Te=>{ye++,de=B(de,Te),j&&!pe&&(Fe.fire(de),de=void 0);const we=()=>{const Ce=de;de=void 0,pe=void 0,(!j||ye>1)&&Fe.fire(Ce),ye=0};typeof H=="number"?(clearTimeout(pe),pe=setTimeout(we,H)):pe===void 0&&(pe=0,queueMicrotask(we))})},onDidRemoveLastListener(){oe.dispose()}};q||s(Le);const Fe=new o(Le);return q?.add(Fe),Fe.event}l.debounce=re;function ce(T,B=0,H){return l.debounce(T,(j,$)=>j?(j.push($),j):[$],B,void 0,void 0,H)}l.accumulate=ce;function fe(T,B=(j,$)=>j===$,H){let j=!0,$;return N(T,q=>{const oe=j||!B(q,$);return j=!1,$=q,oe},H)}l.latch=fe;function ge(T,B,H){return[l.filter(T,B,H),l.filter(T,j=>!B(j),H)]}l.split=ge;function x(T,B=!1,H=[]){let j=H.slice(),$=T(de=>{j?j.push(de):oe.fire(de)});const q=()=>{j?.forEach(de=>oe.fire(de)),j=null},oe=new o({onWillAddFirstListener(){$||($=T(de=>oe.fire(de)))},onDidAddFirstListener(){j&&(B?setTimeout(q):q())},onDidRemoveLastListener(){$&&$.dispose(),$=null}});return oe.event}l.buffer=x;class F{constructor(B){this.event=B,this.c=new n.DisposableStore}map(B){return new F(R(this.event,B,this.c))}forEach(B){return new F(O(this.event,B,this.c))}filter(B){return new F(N(this.event,B,this.c))}reduce(B,H){return new F(X(this.event,B,H,this.c))}latch(){return new F(fe(this.event,void 0,this.c))}debounce(B,H=100,j=!1,$){return new F(re(this.event,B,H,j,$,this.c))}on(B,H,j){return this.event(B,H,j)}once(B,H,j){return S(this.event)(B,H,j)}dispose(){this.c.dispose()}}function W(T){return new F(T)}l.chain=W;function z(T,B,H=j=>j){const j=(...de)=>oe.fire(H(...de)),$=()=>T.on(B,j),q=()=>T.removeListener(B,j),oe=new o({onWillAddFirstListener:$,onDidRemoveLastListener:q});return oe.event}l.fromNodeEventEmitter=z;function J(T,B,H=j=>j){const j=(...de)=>oe.fire(H(...de)),$=()=>T.addEventListener(B,j),q=()=>T.removeEventListener(B,j),oe=new o({onWillAddFirstListener:$,onDidRemoveLastListener:q});return oe.event}l.fromDOMEventEmitter=J;function ne(T){return new Promise(B=>S(T)(B))}l.toPromise=ne;function se(T,B){return B(void 0),T(H=>B(H))}l.runAndSubscribe=se;function Z(T,B){let H=null;function j(q){H?.dispose(),H=new n.DisposableStore,B(q,H)}j(void 0);const $=T(q=>j(q));return(0,n.toDisposable)(()=>{$.dispose(),H?.dispose()})}l.runAndSubscribeWithStore=Z;class U{constructor(B,H){this.obs=B,this.c=0,this.d=!1;const j={onWillAddFirstListener:()=>{B.addObserver(this)},onDidRemoveLastListener:()=>{B.removeObserver(this)}};H||s(j),this.emitter=new o(j),H&&H.add(this.emitter)}beginUpdate(B){this.c++}handleChange(B,H){this.d=!0}endUpdate(B){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function L(T,B){return new U(T,B).emitter.event}l.fromObservable=L})(h=e.Event||(e.Event={}));class b{constructor(s){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${s}_${b.c++}`,b.all.add(this)}start(s){this.d=new D.StopWatch(!0),this.listenerCount=s}stop(){if(this.d){const s=this.d.elapsed();this.durations.push(s),this.elapsedOverall+=s,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=b,b.all=new Set,b.c=0;let v=-1;function y(l){const s=v;return v=l,{dispose(){v=s}}}e.setGlobalLeakWarningThreshold=y;class g{constructor(s,d=Math.random().toString(18).slice(2,5)){this.threshold=s,this.name=d,this.d=0}dispose(){this.c?.clear()}check(s,d){const S=this.threshold;if(S<=0||d<S)return;this.c||(this.c=new Map);const R=this.c.get(s.value)||0;if(this.c.set(s.value,R+1),this.d-=1,this.d<=0){this.d=S*.5;let O,N=0;for(const[K,V]of this.c)(!O||N<V)&&(O=K,N=V);console.warn(`[${this.name}] potential listener LEAK detected, having ${d} listeners already. MOST frequent listener (${N}):`),console.warn(O)}return()=>{const O=this.c.get(s.value)||0;this.c.set(s.value,O-1)}}}class m{static create(){return new m(new Error().stack??"")}constructor(s){this.value=s}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class w{constructor(s,d,S){this.callback=s,this.callbackThis=d,this.stack=S,this.subscription=new n.SafeDisposable}invoke(s){this.callback.call(this.callbackThis,s)}}class o{constructor(s){this.j=!1,this.d=s,this.f=v>0||this.d?.leakWarningThreshold?new g(this.d?.leakWarningThreshold??v):void 0,this.g=this.d?._profName?new b(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(P){const s=Array.from(this.q);queueMicrotask(()=>{for(const d of s)d.subscription.isset()&&(d.subscription.unset(),d.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(s,d,S)=>{if(this.q||(this.q=new C.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),n.Disposable.None;const R=this.q.isEmpty();R&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let O,N;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(N=m.create(),O=this.f.check(N,this.q.size+1)),P&&(N=N??m.create());const K=new w(s,d,N),V=this.q.push(K);R&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,s,d);const X=K.subscription.set(()=>{O?.(),this.j||(V(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return S instanceof n.DisposableStore?S.add(X):Array.isArray(S)&&S.push(X),X}),this.l}fire(s){if(this.q){this.m||(this.m=new p);for(const d of this.q)this.m.push(this,d,s);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=o;class u{constructor(){this.c=new C.LinkedList}get size(){return this.c.size}push(s,d,S){this.c.push(new k(s,d,S))}clear(s){const d=new C.LinkedList;for(const S of this.c)S.emitter!==s&&d.push(S);this.c=d}deliver(){for(;this.c.size>0;){const s=this.c.shift();try{s.listener.invoke(s.event)}catch(d){(0,I.onUnexpectedError)(d)}}}}e.EventDeliveryQueue=u;class p extends u{clear(s){this.c.clear()}}class k{constructor(s,d,S){this.emitter=s,this.listener=d,this.event=S}}class E extends o{async fireAsync(s,d,S){if(!!this.q){this.c||(this.c=new C.LinkedList);for(const R of this.q)this.c.push([R,s]);for(;this.c.size>0&&!d.isCancellationRequested;){const[R,O]=this.c.shift(),N=[],K={...O,token:d,waitUntil:V=>{if(Object.isFrozen(N))throw new Error("waitUntil can NOT be called asynchronous");S&&(V=S(V,R.callback)),N.push(V)}};try{R.invoke(K)}catch(V){(0,I.onUnexpectedError)(V);continue}Object.freeze(N),await Promise.allSettled(N).then(V=>{for(const X of V)X.status==="rejected"&&(0,I.onUnexpectedError)(X.reason)})}}}}e.AsyncEmitter=E;class M extends o{constructor(s){super(s),this.h=0,this.s=new C.LinkedList,this.t=s?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const s=Array.from(this.s);this.s.clear(),super.fire(this.t(s))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(s){this.q&&(this.h!==0?this.s.push(s):super.fire(s))}}e.PauseableEmitter=M;class t extends M{constructor(s){super(s),this.c=s.delay??100}fire(s){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(s)}}e.DebounceEmitter=t;class a extends o{constructor(s){super(s),this.c=[],this.h=s?.merge}fire(s){!this.hasListeners()||(this.c.push(s),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(d=>super.fire(d)),this.c=[]}))}}e.MicrotaskEmitter=a;class i{constructor(){this.d=!1,this.f=[],this.c=new o({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(s){const d={event:s,listener:null};this.f.push(d),this.d&&this.j(d);const S=()=>{this.d&&this.k(d);const R=this.f.indexOf(d);this.f.splice(R,1)};return(0,n.toDisposable)((0,A.once)(S))}g(){this.d=!0,this.f.forEach(s=>this.j(s))}h(){this.d=!1,this.f.forEach(s=>this.k(s))}j(s){s.listener=s.event(d=>this.c.fire(d))}k(s){s.listener&&s.listener.dispose(),s.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=i;class r{constructor(){this.c=[]}wrapEvent(s){return(d,S,R)=>s(O=>{const N=this.c[this.c.length-1];N?N.push(()=>d.call(S,O)):d.call(S,O)},void 0,R)}bufferEvents(s){const d=[];this.c.push(d);const S=s();return this.c.pop(),d.forEach(R=>R()),S}}e.EventBufferer=r;class c{constructor(){this.c=!1,this.d=h.None,this.f=n.Disposable.None,this.g=new o({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(s){this.d=s,this.c&&(this.f.dispose(),this.f=s(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=c}),define(ee[22],te([0,1,3]),function(G,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const A=Object.freeze(function(P,f){const h=setTimeout(P.bind(f),0);return{dispose(){clearTimeout(h)}}});var n;(function(P){function f(h){return h===P.None||h===P.Cancelled||h instanceof C?!0:!h||typeof h!="object"?!1:typeof h.isCancellationRequested=="boolean"&&typeof h.onCancellationRequested=="function"}P.isCancellationToken=f,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:I.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:A})})(n=e.CancellationToken||(e.CancellationToken={}));class C{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?A:(this.b||(this.b=new I.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class D{constructor(f){this.a=void 0,this.b=void 0,this.b=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new C),this.a}cancel(){this.a?this.a instanceof C&&this.a.cancel():this.a=n.Cancelled}dispose(f=!1){f&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof C&&this.a.dispose():this.a=n.None}}e.CancellationTokenSource=D}),define(ee[143],te([0,1,22]),function(G,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class A{constructor(P){this.b=P,this.a=null}get(){if(this.a)return this.a;const P=new I.CancellationTokenSource,f=this.b(P.token);return this.a={promise:f,dispose:()=>{this.a=null,P.cancel(),P.dispose()}},this.a}}e.Cache=A;class n{constructor(P){this.c=P,this.a=void 0,this.b=void 0}get(P){const f=JSON.stringify(P);return this.b!==f&&(this.b=f,this.a=this.c(P)),this.a}}e.LRUCachedFunction=n;class C{get cachedValues(){return this.a}constructor(P){this.b=P,this.a=new Map}get(P){if(this.a.has(P))return this.a.get(P);const f=this.b(P);return this.a.set(P,f),f}}e.CachedFunction=C}),define(ee[27],te([0,1,143,126]),function(G,e,I,A){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function C(Y){return!Y||typeof Y!="string"?!0:Y.trim().length===0}e.isFalsyOrWhitespace=C;const D=/{(\d+)}/g;function P(Y,...le){return le.length===0?Y:Y.replace(D,function(ue,me){const Se=parseInt(me,10);return isNaN(Se)||Se<0||Se>=le.length?ue:le[Se]})}e.format=P;const f=/{([^}]+)}/g;function h(Y,le){return Y.replace(f,(ue,me)=>le[me]??ue)}e.format2=h;function b(Y){return Y.replace(/[<>&]/g,function(le){switch(le){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return le}})}e.escape=b;function v(Y){return Y.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=v;function y(Y,le){let ue=0;const me=le.charCodeAt(0);for(let Se=Y.length-1;Se>=0;Se--)Y.charCodeAt(Se)===me&&ue++;return ue}e.count=y;function g(Y,le,ue="\u2026"){return Y.length<=le?Y:`${Y.substr(0,le)}${ue}`}e.truncate=g;function m(Y,le=" "){const ue=w(Y,le);return o(ue,le)}e.trim=m;function w(Y,le){if(!Y||!le)return Y;const ue=le.length;if(ue===0||Y.length===0)return Y;let me=0;for(;Y.indexOf(le,me)===me;)me=me+ue;return Y.substring(me)}e.ltrim=w;function o(Y,le){if(!Y||!le)return Y;const ue=le.length,me=Y.length;if(ue===0||me===0)return Y;let Se=me,Oe=-1;for(;Oe=Y.lastIndexOf(le,Se-1),!(Oe===-1||Oe+ue!==Se);){if(Oe===0)return"";Se=Oe}return Y.substring(0,Se)}e.rtrim=o;function u(Y){return Y.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=u;function p(Y){return Y.replace(/\*/g,"")}e.stripWildcards=p;function k(Y,le,ue={}){if(!Y)throw new Error("Cannot create regex from empty string");le||(Y=v(Y)),ue.wholeWord&&(/\B/.test(Y.charAt(0))||(Y="\\b"+Y),/\B/.test(Y.charAt(Y.length-1))||(Y=Y+"\\b"));let me="";return ue.global&&(me+="g"),ue.matchCase||(me+="i"),ue.multiline&&(me+="m"),ue.unicode&&(me+="u"),new RegExp(Y,me)}e.createRegExp=k;function E(Y){return Y.source==="^"||Y.source==="^$"||Y.source==="$"||Y.source==="^\\s*$"?!1:!!(Y.exec("")&&Y.lastIndex===0)}e.regExpLeadsToEndlessLoop=E;function M(Y){return!!Y.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=M;function t(Y){return(Y.global?"g":"")+(Y.ignoreCase?"i":"")+(Y.multiline?"m":"")+(Y.unicode?"u":"")}e.regExpFlags=t;function a(Y){return Y.split(/\r\n|\r|\n/)}e.splitLines=a;function i(Y){for(let le=0,ue=Y.length;le<ue;le++){const me=Y.charCodeAt(le);if(me!==32&&me!==9)return le}return-1}e.firstNonWhitespaceIndex=i;function r(Y,le=0,ue=Y.length){for(let me=le;me<ue;me++){const Se=Y.charCodeAt(me);if(Se!==32&&Se!==9)return Y.substring(le,me)}return Y.substring(le,ue)}e.getLeadingWhitespace=r;function c(Y,le=Y.length-1){for(let ue=le;ue>=0;ue--){const me=Y.charCodeAt(ue);if(me!==32&&me!==9)return ue}return-1}e.lastNonWhitespaceIndex=c;function l(Y,le,ue){const me=[];let Se=0;for(const Oe of Y.matchAll(le)){if(me.push(Y.slice(Se,Oe.index)),Oe.index===void 0)throw new Error("match.index should be defined");Se=Oe.index+Oe[0].length,me.push(ue(Oe[0],...Oe.slice(1),Oe.index,Y,Oe.groups))}return me.push(Y.slice(Se)),Promise.all(me).then(Oe=>Oe.join(""))}e.replaceAsync=l;function s(Y,le){return Y<le?-1:Y>le?1:0}e.compare=s;function d(Y,le,ue=0,me=Y.length,Se=0,Oe=le.length){for(;ue<me&&Se<Oe;ue++,Se++){const Qe=Y.charCodeAt(ue),Ke=le.charCodeAt(Se);if(Qe<Ke)return-1;if(Qe>Ke)return 1}const ze=me-ue,tt=Oe-Se;return ze<tt?-1:ze>tt?1:0}e.compareSubstring=d;function S(Y,le){return R(Y,le,0,Y.length,0,le.length)}e.compareIgnoreCase=S;function R(Y,le,ue=0,me=Y.length,Se=0,Oe=le.length){for(;ue<me&&Se<Oe;ue++,Se++){let Qe=Y.charCodeAt(ue),Ke=le.charCodeAt(Se);if(Qe===Ke)continue;if(Qe>=128||Ke>=128)return d(Y.toLowerCase(),le.toLowerCase(),ue,me,Se,Oe);N(Qe)&&(Qe-=32),N(Ke)&&(Ke-=32);const et=Qe-Ke;if(et!==0)return et}const ze=me-ue,tt=Oe-Se;return ze<tt?-1:ze>tt?1:0}e.compareSubstringIgnoreCase=R;function O(Y){return Y>=48&&Y<=57}e.isAsciiDigit=O;function N(Y){return Y>=97&&Y<=122}e.isLowerAsciiLetter=N;function K(Y){return Y>=65&&Y<=90}e.isUpperAsciiLetter=K;function V(Y,le){return Y.length===le.length&&R(Y,le)===0}e.equalsIgnoreCase=V;function X(Y,le){const ue=le.length;return le.length>Y.length?!1:R(Y,le,0,ue)===0}e.startsWithIgnoreCase=X;function ie(Y,le){const ue=Math.min(Y.length,le.length);let me;for(me=0;me<ue;me++)if(Y.charCodeAt(me)!==le.charCodeAt(me))return me;return ue}e.commonPrefixLength=ie;function re(Y,le){const ue=Math.min(Y.length,le.length);let me;const Se=Y.length-1,Oe=le.length-1;for(me=0;me<ue;me++)if(Y.charCodeAt(Se-me)!==le.charCodeAt(Oe-me))return me;return ue}e.commonSuffixLength=re;function ce(Y){return 55296<=Y&&Y<=56319}e.isHighSurrogate=ce;function fe(Y){return 56320<=Y&&Y<=57343}e.isLowSurrogate=fe;function ge(Y,le){return(Y-55296<<10)+(le-56320)+65536}e.computeCodePoint=ge;function x(Y,le,ue){const me=Y.charCodeAt(ue);if(ce(me)&&ue+1<le){const Se=Y.charCodeAt(ue+1);if(fe(Se))return ge(me,Se)}return me}e.getNextCodePoint=x;function F(Y,le){const ue=Y.charCodeAt(le-1);if(fe(ue)&&le>1){const me=Y.charCodeAt(le-2);if(ce(me))return ge(me,ue)}return ue}class W{get offset(){return this.e}constructor(le,ue=0){this.c=le,this.d=le.length,this.e=ue}setOffset(le){this.e=le}prevCodePoint(){const le=F(this.c,this.e);return this.e-=le>=65536?2:1,le}nextCodePoint(){const le=x(this.c,this.d,this.e);return this.e+=le>=65536?2:1,le}eol(){return this.e>=this.d}}e.CodePointIterator=W;class z{get offset(){return this.c.offset}constructor(le,ue=0){this.c=new W(le,ue)}nextGraphemeLength(){const le=Ae.getInstance(),ue=this.c,me=ue.offset;let Se=le.getGraphemeBreakType(ue.nextCodePoint());for(;!ue.eol();){const Oe=ue.offset,ze=le.getGraphemeBreakType(ue.nextCodePoint());if(Pe(Se,ze)){ue.setOffset(Oe);break}Se=ze}return ue.offset-me}prevGraphemeLength(){const le=Ae.getInstance(),ue=this.c,me=ue.offset;let Se=le.getGraphemeBreakType(ue.prevCodePoint());for(;ue.offset>0;){const Oe=ue.offset,ze=le.getGraphemeBreakType(ue.prevCodePoint());if(Pe(ze,Se)){ue.setOffset(Oe);break}Se=ze}return me-ue.offset}eol(){return this.c.eol()}}e.GraphemeIterator=z;function J(Y,le){return new z(Y,le).nextGraphemeLength()}e.nextCharLength=J;function ne(Y,le){return new z(Y,le).prevGraphemeLength()}e.prevCharLength=ne;function se(Y,le){le>0&&fe(Y.charCodeAt(le))&&le--;const ue=le+J(Y,le);return[ue-ne(Y,ue),ue]}e.getCharContainingOffset=se;function Z(Y){const le=new z(Y);let ue=0;for(;!le.eol();)ue++,le.nextGraphemeLength();return ue}e.charCount=Z;let U;function L(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function T(Y){return U||(U=L()),U.test(Y)}e.containsRTL=T;const B=/^[\t\n\r\x20-\x7E]*$/;function H(Y){return B.test(Y)}e.isBasicASCII=H,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function j(Y){return e.UNUSUAL_LINE_TERMINATORS.test(Y)}e.containsUnusualLineTerminators=j;function $(Y){return Y>=11904&&Y<=55215||Y>=63744&&Y<=64255||Y>=65281&&Y<=65374}e.isFullWidthCharacter=$;function q(Y){return Y>=127462&&Y<=127487||Y===8986||Y===8987||Y===9200||Y===9203||Y>=9728&&Y<=10175||Y===11088||Y===11093||Y>=127744&&Y<=128591||Y>=128640&&Y<=128764||Y>=128992&&Y<=129008||Y>=129280&&Y<=129535||Y>=129648&&Y<=129782}e.isEmojiImprecise=q;function oe(Y,le){if(Y.length<le)return Y;const ue=/\b/g;let me=0;for(;ue.test(Y)&&!(Y.length-ue.lastIndex<le);)me=ue.lastIndex,ue.lastIndex+=1;return Y.substring(me).replace(/^\s/,"")}e.lcut=oe;const de=/\x1B\x5B[12]?K/g,pe=/\x1b\[\d+m/g,ye=/\x1b\[0?m/g;function Le(Y){return Y&&(Y=Y.replace(de,""),Y=Y.replace(pe,""),Y=Y.replace(ye,"")),Y}e.removeAnsiEscapeCodes=Le,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Fe(Y){return!!(Y&&Y.length>0&&Y.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Fe;function Te(Y){return Fe(Y)?Y.substr(1):Y}e.stripUTF8BOM=Te;function we(Y,le){if(!Y||!le||Y.length<le.length)return!1;const ue=le.length,me=Y.toLowerCase();let Se=0,Oe=-1;for(;Se<ue;){const ze=me.indexOf(le[Se],Oe+1);if(ze<0)return!1;Oe=ze,Se++}return!0}e.fuzzyContains=we;function Ce(Y,le=!1){return Y?(le&&(Y=Y.replace(/\\./g,"")),Y.toLowerCase()!==Y):!1}e.containsUppercaseCharacter=Ce;function Re(Y){return Y.charAt(0).toUpperCase()+Y.slice(1)}e.uppercaseFirstLetter=Re;function Q(Y,le=1){if(le===0)return"";let ue=-1;do ue=Y.indexOf(`
`,ue+1),le--;while(le>0&&ue>=0);return ue===-1?Y:(Y[ue-1]==="\r"&&ue--,Y.substr(0,ue))}e.getNLines=Q;function ae(Y){return Y=Y%(2*26),Y<26?String.fromCharCode(97+Y):String.fromCharCode(65+Y-26)}e.singleLetterHash=ae;function he(Y){return Ae.getInstance().getGraphemeBreakType(Y)}e.getGraphemeBreakType=he;function Pe(Y,le){return Y===0?le!==5&&le!==7:Y===2&&le===3?!1:Y===4||Y===2||Y===3||le===4||le===2||le===3?!0:!(Y===8&&(le===8||le===9||le===11||le===12)||(Y===11||Y===9)&&(le===9||le===10)||(Y===12||Y===10)&&le===10||le===5||le===13||le===7||Y===1||Y===13&&le===14||Y===6&&le===6)}var Me;(function(Y){Y[Y.Other=0]="Other",Y[Y.Prepend=1]="Prepend",Y[Y.CR=2]="CR",Y[Y.LF=3]="LF",Y[Y.Control=4]="Control",Y[Y.Extend=5]="Extend",Y[Y.Regional_Indicator=6]="Regional_Indicator",Y[Y.SpacingMark=7]="SpacingMark",Y[Y.L=8]="L",Y[Y.V=9]="V",Y[Y.T=10]="T",Y[Y.LV=11]="LV",Y[Y.LVT=12]="LVT",Y[Y.ZWJ=13]="ZWJ",Y[Y.Extended_Pictographic=14]="Extended_Pictographic"})(Me=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ae{static getInstance(){return Ae.c||(Ae.c=new Ae),Ae.c}constructor(){this.d=Ue()}getGraphemeBreakType(le){if(le<32)return le===10?3:le===13?2:4;if(le<127)return 0;const ue=this.d,me=ue.length/3;let Se=1;for(;Se<=me;)if(le<ue[3*Se])Se=2*Se;else if(le>ue[3*Se+1])Se=2*Se+1;else return ue[3*Se+2];return 0}}Ae.c=null;function Ue(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(Y,le){if(Y===0)return 0;const ue=Ne(Y,le);if(ue!==void 0)return ue;const me=new W(le,Y);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=He;function Ne(Y,le){const ue=new W(le,Y);let me=ue.prevCodePoint();for(;$e(me)||me===65039||me===8419;){if(ue.offset===0)return;me=ue.prevCodePoint()}if(!q(me))return;let Se=ue.offset;return Se>0&&ue.prevCodePoint()===8205&&(Se=ue.offset),Se}function $e(Y){return 127995<=Y&&Y<=127999}var Ge;(function(Y){Y[Y.zwj=8205]="zwj",Y[Y.emojiVariantSelector=65039]="emojiVariantSelector",Y[Y.enclosingKeyCap=8419]="enclosingKeyCap"})(Ge||(Ge={})),e.noBreakWhitespace="\xA0";class We{static getInstance(le){return We.d.get(Array.from(le))}static getLocales(){return We.e.value}constructor(le){this.f=le}isAmbiguous(le){return this.f.has(le)}getPrimaryConfusable(le){return this.f.get(le)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=We,n=We,We.c=new A.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),We.d=new I.LRUCachedFunction(Y=>{function le(Ke){const et=new Map;for(let it=0;it<Ke.length;it+=2)et.set(Ke[it],Ke[it+1]);return et}function ue(Ke,et){const it=new Map(Ke);for(const[ot,ut]of et)it.set(ot,ut);return it}function me(Ke,et){if(!Ke)return et;const it=new Map;for(const[ot,ut]of Ke)et.has(ot)&&it.set(ot,ut);return it}const Se=n.c.value;let Oe=Y.filter(Ke=>!Ke.startsWith("_")&&Ke in Se);Oe.length===0&&(Oe=["_default"]);let ze;for(const Ke of Oe){const et=le(Se[Ke]);ze=me(ze,et)}const tt=le(Se._common),Qe=ue(tt,ze);return new We(Qe)}),We.e=new A.Lazy(()=>Object.keys(We.c.value).filter(Y=>!Y.startsWith("_")));class Ve{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Ve.c())),this.d}static isInvisibleCharacter(le){return Ve.e().has(le)}static get codePoints(){return Ve.e()}}e.InvisibleCharacters=Ve,Ve.d=void 0}),define(ee[32],te([0,1,9,4,27,10]),function(G,e,I,A,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function D(c){return c===47||c===92}e.isPathSeparator=D;function P(c){return c.replace(/[\\/]/g,I.posix.sep)}e.toSlashes=P;function f(c){return c.indexOf("/")===-1&&(c=P(c)),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c),c}e.toPosixPath=f;function h(c,l=I.posix.sep){if(!c)return"";const s=c.length,d=c.charCodeAt(0);if(D(d)){if(D(c.charCodeAt(1))&&!D(c.charCodeAt(2))){let R=3;const O=R;for(;R<s&&!D(c.charCodeAt(R));R++);if(O!==R&&!D(c.charCodeAt(R+1))){for(R+=1;R<s;R++)if(D(c.charCodeAt(R)))return c.slice(0,R+1).replace(/[\\/]/g,l)}}return l}else if(u(d)&&c.charCodeAt(1)===58)return D(c.charCodeAt(2))?c.slice(0,2)+l:c.slice(0,2);let S=c.indexOf("://");if(S!==-1){for(S+=3;S<s;S++)if(D(c.charCodeAt(S)))return c.slice(0,S+1)}return""}e.getRoot=h;function b(c){if(!A.isWindows||!c||c.length<5)return!1;let l=c.charCodeAt(0);if(l!==92||(l=c.charCodeAt(1),l!==92))return!1;let s=2;const d=s;for(;s<c.length&&(l=c.charCodeAt(s),l!==92);s++);return!(d===s||(l=c.charCodeAt(s+1),isNaN(l)||l===92))}e.isUNC=b;const v=/[\\/:\*\?"<>\|]/g,y=/[\\/]/g,g=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(c,l=A.isWindows){const s=l?v:y;return!(!c||c.length===0||/^\s+$/.test(c)||(s.lastIndex=0,s.test(c))||l&&g.test(c)||c==="."||c===".."||l&&c[c.length-1]==="."||l&&c.length!==c.trim().length||c.length>255)}e.isValidBasename=m;function w(c,l,s){const d=c===l;return!s||d?d:!c||!l?!1:(0,n.equalsIgnoreCase)(c,l)}e.isEqual=w;function o(c,l,s,d=I.sep){if(c===l)return!0;if(!c||!l||l.length>c.length)return!1;if(s){if(!(0,n.startsWithIgnoreCase)(c,l))return!1;if(l.length===c.length)return!0;let R=l.length;return l.charAt(l.length-1)===d&&R--,c.charAt(R)===d}return l.charAt(l.length-1)!==d&&(l+=d),c.indexOf(l)===0}e.isEqualOrParent=o;function u(c){return c>=65&&c<=90||c>=97&&c<=122}e.isWindowsDriveLetter=u;function p(c,l){return A.isWindows&&c.endsWith(":")&&(c+=I.sep),(0,I.isAbsolute)(c)||(c=(0,I.join)(l,c)),c=(0,I.normalize)(c),A.isWindows?(c=(0,n.rtrim)(c,I.sep),c.endsWith(":")&&(c+=I.sep)):(c=(0,n.rtrim)(c,I.sep),c||(c=I.sep)),c}e.sanitizeFilePath=p;function k(c){const l=(0,I.normalize)(c);return A.isWindows?c.length>3?!1:E(l)&&(c.length===2||l.charCodeAt(2)===92):l===I.posix.sep}e.isRootOrDriveLetter=k;function E(c,l=A.isWindows){return l?u(c.charCodeAt(0))&&c.charCodeAt(1)===58:!1}e.hasDriveLetter=E;function M(c){return E(c)?c[0]:void 0}e.getDriveLetter=M;function t(c,l,s){return l.length>c.length?-1:c===l?0:(s&&(c=c.toLowerCase(),l=l.toLowerCase()),c.indexOf(l))}e.indexOfPath=t;function a(c){const l=c.split(":");let s,d,S;for(const R of l){const O=Number(R);(0,C.isNumber)(O)?d===void 0?d=O:S===void 0&&(S=O):s=s?[s,R].join(":"):R}if(!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:d!==void 0?d:void 0,column:S!==void 0?S:d!==void 0?1:void 0}}e.parseLineAndColumnAware=a;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function r(c,l,s=8){let d="";for(let R=0;R<s;R++)d+=i.charAt(Math.floor(Math.random()*i.length));let S;return l?S=`${l}-${d}`:S=d,c?(0,I.join)(c,S):S}e.randomPath=r}),define(ee[72],te([0,1,27]),function(G,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function A(u){return n(u,0)}e.hash=A;function n(u,p){switch(typeof u){case"object":return u===null?C(349,p):Array.isArray(u)?f(u,p):h(u,p);case"string":return P(u,p);case"boolean":return D(u,p);case"number":return C(u,p);case"undefined":return C(937,p);default:return C(617,p)}}e.doHash=n;function C(u,p){return(p<<5)-p+u|0}e.numberHash=C;function D(u,p){return C(u?433:863,p)}function P(u,p){p=C(149417,p);for(let k=0,E=u.length;k<E;k++)p=C(u.charCodeAt(k),p);return p}e.stringHash=P;function f(u,p){return p=C(104579,p),u.reduce((k,E)=>n(E,k),p)}function h(u,p){return p=C(181387,p),Object.keys(u).sort().reduce((k,E)=>(k=P(E,k),n(u[E],k)),p)}class b{constructor(){this.g=0}get value(){return this.g}hash(p){return this.g=n(p,this.g),this.g}}e.Hasher=b;var v;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(v||(v={}));function y(u,p,k=32){const E=k-p,M=~((1<<E)-1);return(u<<p|(M&u)>>>E)>>>0}function g(u,p=0,k=u.byteLength,E=0){for(let M=0;M<k;M++)u[p+M]=E}function m(u,p,k="0"){for(;u.length<p;)u=k+u;return u}function w(u,p=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(k=>k.toString(16).padStart(2,"0")).join(""):m((u>>>0).toString(16),p/4)}e.toHexString=w;class o{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(p){const k=p.length;if(k===0)return;const E=this.p;let M=this.r,t=this.u,a,i;for(t!==0?(a=t,i=-1,t=0):(a=p.charCodeAt(0),i=0);;){let r=a;if(I.isHighSurrogate(a))if(i+1<k){const c=p.charCodeAt(i+1);I.isLowSurrogate(c)?(i++,r=I.computeCodePoint(a,c)):r=65533}else{t=a;break}else I.isLowSurrogate(a)&&(r=65533);if(M=this.w(E,M,r),i++,i<k)a=p.charCodeAt(i);else break}this.r=M,this.u=t}w(p,k,E){return E<128?p[k++]=E:E<2048?(p[k++]=192|(E&1984)>>>6,p[k++]=128|(E&63)>>>0):E<65536?(p[k++]=224|(E&61440)>>>12,p[k++]=128|(E&4032)>>>6,p[k++]=128|(E&63)>>>0):(p[k++]=240|(E&1835008)>>>18,p[k++]=128|(E&258048)>>>12,p[k++]=128|(E&4032)>>>6,p[k++]=128|(E&63)>>>0),k>=64&&(this.y(),k-=64,this.t+=64,p[0]=p[64+0],p[1]=p[64+1],p[2]=p[64+2]),k}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),w(this.h)+w(this.l)+w(this.m)+w(this.n)+w(this.o)}x(){this.p[this.r++]=128,g(this.p,this.r),this.r>56&&(this.y(),g(this.p));const p=8*this.t;this.q.setUint32(56,Math.floor(p/4294967296),!1),this.q.setUint32(60,p%4294967296,!1),this.y()}y(){const p=o.g,k=this.q;for(let s=0;s<64;s+=4)p.setUint32(s,k.getUint32(s,!1),!1);for(let s=64;s<320;s+=4)p.setUint32(s,y(p.getUint32(s-12,!1)^p.getUint32(s-32,!1)^p.getUint32(s-56,!1)^p.getUint32(s-64,!1),1),!1);let E=this.h,M=this.l,t=this.m,a=this.n,i=this.o,r,c,l;for(let s=0;s<80;s++)s<20?(r=M&t|~M&a,c=1518500249):s<40?(r=M^t^a,c=1859775393):s<60?(r=M&t|M&a|t&a,c=2400959708):(r=M^t^a,c=3395469782),l=y(E,5)+r+i+c+p.getUint32(s*4,!1)&4294967295,i=a,a=t,t=y(M,30),M=E,E=l;this.h=this.h+E&4294967295,this.l=this.l+M&4294967295,this.m=this.m+t&4294967295,this.n=this.n+a&4294967295,this.o=this.o+i&4294967295}}e.StringSHA1=o,o.g=new DataView(new ArrayBuffer(320))}),define(ee[84],te([0,1,27]),function(G,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var A;(function(n){n[n.Ignore=0]="Ignore",n[n.Info=1]="Info",n[n.Warning=2]="Warning",n[n.Error=3]="Error"})(A||(A={})),function(n){const C="error",D="warning",P="warn",f="info",h="ignore";function b(y){return y?I.equalsIgnoreCase(C,y)?n.Error:I.equalsIgnoreCase(D,y)||I.equalsIgnoreCase(P,y)?n.Warning:I.equalsIgnoreCase(f,y)?n.Info:n.Ignore:n.Ignore}n.fromValue=b;function v(y){switch(y){case n.Error:return C;case n.Warning:return D;case n.Info:return f;default:return h}}n.toString=v}(A||(A={})),e.default=A}),define(ee[61],te([0,1,25,27]),function(G,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class n{constructor(){this.b="",this.c=0}reset(g){return this.b=g,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(g){const m=g.charCodeAt(0),w=this.b.charCodeAt(this.c);return m-w}value(){return this.b[this.c]}}e.StringIterator=n;class C{constructor(g=!0){this.e=g}reset(g){return this.b=g,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let g=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(g)this.c++;else break;else g=!1;return this}cmp(g){return this.e?(0,A.compareSubstring)(g,this.b,0,g.length,this.c,this.d):(0,A.compareSubstringIgnoreCase)(g,this.b,0,g.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=C;class D{constructor(g=!0,m=!0){this.f=g,this.g=m}reset(g){this.d=0,this.e=0,this.b=g,this.c=g.length;for(let m=g.length-1;m>=0;m--,this.c--){const w=this.b.charCodeAt(m);if(!(w===47||this.f&&w===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let g=!0;for(;this.e<this.c;this.e++){const m=this.b.charCodeAt(this.e);if(m===47||this.f&&m===92)if(g)this.d++;else break;else g=!1}return this}cmp(g){return this.g?(0,A.compareSubstring)(g,this.b,0,g.length,this.d,this.e):(0,A.compareSubstringIgnoreCase)(g,this.b,0,g.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=D;var P;(function(y){y[y.Scheme=1]="Scheme",y[y.Authority=2]="Authority",y[y.Path=3]="Path",y[y.Query=4]="Query",y[y.Fragment=5]="Fragment"})(P||(P={}));class f{constructor(g,m){this.f=g,this.g=m,this.d=[],this.e=0}reset(g){return this.c=g,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new D(!1,!this.f(g)),this.b.reset(g.path),this.b.value()&&this.d.push(3)),this.g(g)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(g){if(this.d[this.e]===1)return(0,A.compareIgnoreCase)(g,this.c.scheme);if(this.d[this.e]===2)return(0,A.compareIgnoreCase)(g,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(g);if(this.d[this.e]===4)return(0,A.compare)(g,this.c.query);if(this.d[this.e]===5)return(0,A.compare)(g,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=f;class h{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const g=this.right;return this.right=g.left,g.left=this,this.updateHeight(),g.updateHeight(),g}rotateRight(){const g=this.left;return this.left=g.right,g.right=this,this.updateHeight(),g.updateHeight(),g}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var b;(function(y){y[y.Left=-1]="Left",y[y.Mid=0]="Mid",y[y.Right=1]="Right"})(b||(b={}));class v{static forUris(g=()=>!1,m=()=>!1){return new v(new f(g,m))}static forPaths(g=!1){return new v(new D(void 0,!g))}static forStrings(){return new v(new n)}static forConfigKeys(){return new v(new C)}constructor(g){this.b=g}clear(){this.c=void 0}fill(g,m){if(m){const w=m.slice(0);(0,I.shuffle)(w);for(const o of w)this.set(o,g)}else{const w=g.slice(0);(0,I.shuffle)(w);for(const o of w)this.set(o[0],o[1])}}set(g,m){const w=this.b.reset(g);let o;this.c||(this.c=new h,this.c.segment=w.value());const u=[];for(o=this.c;;){const k=w.cmp(o.segment);if(k>0)o.left||(o.left=new h,o.left.segment=w.value()),u.push([-1,o]),o=o.left;else if(k<0)o.right||(o.right=new h,o.right.segment=w.value()),u.push([1,o]),o=o.right;else if(w.hasNext())w.next(),o.mid||(o.mid=new h,o.mid.segment=w.value()),u.push([0,o]),o=o.mid;else break}const p=o.value;o.value=m,o.key=g;for(let k=u.length-1;k>=0;k--){const E=u[k][1];E.updateHeight();const M=E.balanceFactor();if(M<-1||M>1){const t=u[k][0],a=u[k+1][0];if(t===1&&a===1)u[k][1]=E.rotateLeft();else if(t===-1&&a===-1)u[k][1]=E.rotateRight();else if(t===1&&a===-1)E.right=u[k+1][1]=u[k+1][1].rotateRight(),u[k][1]=E.rotateLeft();else if(t===-1&&a===1)E.left=u[k+1][1]=u[k+1][1].rotateLeft(),u[k][1]=E.rotateRight();else throw new Error;if(k>0)switch(u[k-1][0]){case-1:u[k-1][1].left=u[k][1];break;case 1:u[k-1][1].right=u[k][1];break;case 0:u[k-1][1].mid=u[k][1];break}else this.c=u[0][1]}}return p}get(g){return this.d(g)?.value}d(g){const m=this.b.reset(g);let w=this.c;for(;w;){const o=m.cmp(w.segment);if(o>0)w=w.left;else if(o<0)w=w.right;else if(m.hasNext())m.next(),w=w.mid;else break}return w}has(g){const m=this.d(g);return!(m?.value===void 0&&m?.mid===void 0)}delete(g){return this.e(g,!1)}deleteSuperstr(g){return this.e(g,!0)}e(g,m){const w=this.b.reset(g),o=[];let u=this.c;for(;u;){const p=w.cmp(u.segment);if(p>0)o.push([-1,u]),u=u.left;else if(p<0)o.push([1,u]),u=u.right;else if(w.hasNext())w.next(),o.push([0,u]),u=u.mid;else break}if(!!u){if(m?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const p=this.f(u.right);if(p.key){const{key:k,value:E,segment:M}=p;this.e(p.key,!1),u.key=k,u.value=E,u.segment=M}}else{const p=u.left??u.right;if(o.length>0){const[k,E]=o[o.length-1];switch(k){case-1:E.left=p;break;case 0:E.mid=p;break;case 1:E.right=p;break}}else this.c=p}for(let p=o.length-1;p>=0;p--){const k=o[p][1];k.updateHeight();const E=k.balanceFactor();if(E>1?(k.right.balanceFactor()>=0||(k.right=k.right.rotateRight()),o[p][1]=k.rotateLeft()):E<-1&&(k.left.balanceFactor()<=0||(k.left=k.left.rotateLeft()),o[p][1]=k.rotateRight()),p>0)switch(o[p-1][0]){case-1:o[p-1][1].left=o[p][1];break;case 1:o[p-1][1].right=o[p][1];break;case 0:o[p-1][1].mid=o[p][1];break}else this.c=o[0][1]}}}f(g){for(;g.left;)g=g.left;return g}findSubstr(g){const m=this.b.reset(g);let w=this.c,o;for(;w;){const u=m.cmp(w.segment);if(u>0)w=w.left;else if(u<0)w=w.right;else if(m.hasNext())m.next(),o=w.value||o,w=w.mid;else break}return w&&w.value||o}findSuperstr(g){return this.g(g,!1)}g(g,m){const w=this.b.reset(g);let o=this.c;for(;o;){const u=w.cmp(o.segment);if(u>0)o=o.left;else if(u<0)o=o.right;else if(w.hasNext())w.next(),o=o.mid;else return o.mid?this.h(o.mid):m?o.value:void 0}}hasElementOrSubtree(g){return this.g(g,!0)!==void 0}forEach(g){for(const[m,w]of this)g(w,m)}*[Symbol.iterator](){yield*this.h(this.c)}h(g){const m=[];return this.j(g,m),m[Symbol.iterator]()}j(g,m){!g||(g.left&&this.j(g.left,m),g.value&&m.push([g.key,g.value]),g.mid&&this.j(g.mid,m),g.right&&this.j(g.right,m))}_isBalanced(){const g=m=>{if(!m)return!0;const w=m.balanceFactor();return w<-1||w>1?!1:g(m.left)&&g(m.right)};return g(this.c)}}e.TernarySearchTree=v}),define(ee[7],te([0,1,9,4]),function(G,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const n=/^\w[\w\d+.-]*$/,C=/^\//,D=/^\/\//;function P(i,r){if(!i.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!n.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!C.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(i,r){return!i&&!r?"file":i}function h(i,r){switch(i){case"https":case"http":case"file":r?r[0]!==v&&(r=v+r):r=v;break}return r}const b="",v="/",y=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{static isUri(r){return r instanceof g?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}constructor(r,c,l,s,d,S=!1){typeof r=="object"?(this.scheme=r.scheme||b,this.authority=r.authority||b,this.path=r.path||b,this.query=r.query||b,this.fragment=r.fragment||b):(this.scheme=f(r,S),this.authority=c||b,this.path=h(this.scheme,l||b),this.query=s||b,this.fragment=d||b,P(this,S))}get fsPath(){return k(this,!1)}with(r){if(!r)return this;let{scheme:c,authority:l,path:s,query:d,fragment:S}=r;return c===void 0?c=this.scheme:c===null&&(c=b),l===void 0?l=this.authority:l===null&&(l=b),s===void 0?s=this.path:s===null&&(s=b),d===void 0?d=this.query:d===null&&(d=b),S===void 0?S=this.fragment:S===null&&(S=b),c===this.scheme&&l===this.authority&&s===this.path&&d===this.query&&S===this.fragment?this:new w(c,l,s,d,S)}static parse(r,c=!1){const l=y.exec(r);return l?new w(l[2]||b,a(l[4]||b),a(l[5]||b),a(l[7]||b),a(l[9]||b),c):new w(b,b,b,b,b)}static file(r){let c=b;if(A.isWindows&&(r=r.replace(/\\/g,v)),r[0]===v&&r[1]===v){const l=r.indexOf(v,2);l===-1?(c=r.substring(2),r=v):(c=r.substring(2,l),r=r.substring(l)||v)}return new w("file",c,r,b,b)}static from(r){const c=new w(r.scheme,r.authority,r.path,r.query,r.fragment);return P(c,!0),c}static joinPath(r,...c){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return A.isWindows&&r.scheme==="file"?l=g.file(I.win32.join(k(r,!0),...c)).path:l=I.posix.join(r.path,...c),r.with({path:l})}toString(r=!1){return E(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof g)return r;{const c=new w(r);return c._formatted=r.external,c._fsPath=r._sep===m?r.fsPath:null,c}}else return r}}e.URI=g;const m=A.isWindows?1:void 0;class w extends g{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=k(this,!1)),this._fsPath}toString(r=!1){return r?E(this,!0):(this._formatted||(this._formatted=E(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=m),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const o={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(i,r,c){let l,s=-1;for(let d=0;d<i.length;d++){const S=i.charCodeAt(d);if(S>=97&&S<=122||S>=65&&S<=90||S>=48&&S<=57||S===45||S===46||S===95||S===126||r&&S===47||c&&S===91||c&&S===93||c&&S===58)s!==-1&&(l+=encodeURIComponent(i.substring(s,d)),s=-1),l!==void 0&&(l+=i.charAt(d));else{l===void 0&&(l=i.substr(0,d));const R=o[S];R!==void 0?(s!==-1&&(l+=encodeURIComponent(i.substring(s,d)),s=-1),l+=R):s===-1&&(s=d)}}return s!==-1&&(l+=encodeURIComponent(i.substring(s))),l!==void 0?l:i}function p(i){let r;for(let c=0;c<i.length;c++){const l=i.charCodeAt(c);l===35||l===63?(r===void 0&&(r=i.substr(0,c)),r+=o[l]):r!==void 0&&(r+=i[c])}return r!==void 0?r:i}function k(i,r){let c;return i.authority&&i.path.length>1&&i.scheme==="file"?c=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?r?c=i.path.substr(1):c=i.path[1].toLowerCase()+i.path.substr(2):c=i.path,A.isWindows&&(c=c.replace(/\//g,"\\")),c}e.uriToFsPath=k;function E(i,r){const c=r?p:u;let l="",{scheme:s,authority:d,path:S,query:R,fragment:O}=i;if(s&&(l+=s,l+=":"),(d||s==="file")&&(l+=v,l+=v),d){let N=d.indexOf("@");if(N!==-1){const K=d.substr(0,N);d=d.substr(N+1),N=K.lastIndexOf(":"),N===-1?l+=c(K,!1,!1):(l+=c(K.substr(0,N),!1,!1),l+=":",l+=c(K.substr(N+1),!1,!0)),l+="@"}d=d.toLowerCase(),N=d.lastIndexOf(":"),N===-1?l+=c(d,!1,!0):(l+=c(d.substr(0,N),!1,!0),l+=d.substr(N))}if(S){if(S.length>=3&&S.charCodeAt(0)===47&&S.charCodeAt(2)===58){const N=S.charCodeAt(1);N>=65&&N<=90&&(S=`/${String.fromCharCode(N+32)}:${S.substr(3)}`)}else if(S.length>=2&&S.charCodeAt(1)===58){const N=S.charCodeAt(0);N>=65&&N<=90&&(S=`${String.fromCharCode(N+32)}:${S.substr(2)}`)}l+=c(S,!0,!1)}return R&&(l+="?",l+=c(R,!1,!1)),O&&(l+="#",l+=r?O:u(O,!1,!1)),l}function M(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+M(i.substr(3)):i}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(i){return i.match(t)?i.replace(t,r=>M(r)):i}}),define(ee[144],te([0,1,7]),function(G,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function A(h){const b=h;return b&&typeof b.type=="string"&&typeof b.severity=="string"}e.isRemoteConsoleLog=A;function n(h){const b=[];let v;try{const y=JSON.parse(h.arguments),g=y[y.length-1];g&&g.__$stack&&(y.pop(),v=g.__$stack),b.push(...y)}catch{b.push("Unable to log remote console arguments",h.arguments)}return{args:b,stack:v}}e.parse=n;function C(h){if(typeof h!="string")return C(n(h).stack);const b=h;if(b){const v=D(b),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(v||"");if(y&&y.length===4)return{uri:I.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}e.getFirstFrame=C;function D(h){if(!h)return h;const b=h.indexOf(`
`);return b===-1?h:h.substring(0,b)}function P(h,b){const{args:v,stack:y}=n(h),g=typeof v[0]=="string"&&v.length===1;let m=D(y);m&&(m=`(${m.trim()})`);let w=[];if(typeof v[0]=="string"?m&&g?w=[`%c[${b}] %c${v[0]} %c${m}`,f("blue"),f(""),f("grey")]:w=[`%c[${b}] %c${v[0]}`,f("blue"),f(""),...v.slice(1)]:w=[`%c[${b}]%`,f("blue"),...v],m&&!g&&w.push(m),typeof console[h.severity]!="function")throw new Error("Unknown console method");console[h.severity].apply(console,w)}e.log=P;function f(h){return`color: ${h}`}}),define(ee[73],te([0,1,17,27,7]),function(G,e,I,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function C(h){return JSON.stringify(h,P)}e.stringify=C;function D(h){let b=JSON.parse(h);return b=f(b),b}e.parse=D;function P(h,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:(0,A.regExpFlags)(b)}:b}function f(h,b=0){if(!h||b>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return n.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 16:return new Date(h.source)}if(h instanceof I.VSBuffer||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let v=0;v<h.length;++v)h[v]=f(h[v],b+1);else for(const v in h)Object.hasOwnProperty.call(h,v)&&(h[v]=f(h[v],b+1))}return h}e.revive=f}),define(ee[15],te([0,1,13,4,7]),function(G,e,I,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var C;(function(h){h.inMemory="inmemory",h.vscode="vscode",h.internal="private",h.walkThrough="walkThrough",h.walkThroughSnippet="walkThroughSnippet",h.http="http",h.https="https",h.file="file",h.mailto="mailto",h.untitled="untitled",h.data="data",h.command="command",h.vscodeRemote="vscode-remote",h.vscodeRemoteResource="vscode-remote-resource",h.vscodeUserData="vscode-userdata",h.vscodeCustomEditor="vscode-custom-editor",h.vscodeNotebook="vscode-notebook",h.vscodeNotebookCell="vscode-notebook-cell",h.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",h.vscodeNotebookCellOutput="vscode-notebook-cell-output",h.vscodeInteractive="vscode-interactive",h.vscodeInteractiveInput="vscode-interactive-input",h.vscodeSettings="vscode-settings",h.vscodeWorkspaceTrust="vscode-workspace-trust",h.vscodeTerminal="vscode-terminal",h.webviewPanel="webview-panel",h.vscodeWebview="vscode-webview",h.extension="extension",h.vscodeFileResource="vscode-file",h.tmp="tmp",h.vsls="vsls",h.vscodeSourceControl="vscode-scm"})(C=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class D{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${C.vscodeRemoteResource}`}setPreferredWebSchema(b){this.d=b}setDelegate(b){this.e=b}setServerRootPath(b){this.f=`${b}/${C.vscodeRemoteResource}`}set(b,v,y){this.a[b]=v,this.b[b]=y}setConnectionToken(b,v){this.c[b]=v}getPreferredWebSchema(){return this.d}rewrite(b){if(this.e)try{return this.e(b)}catch(o){return I.onUnexpectedError(o),b}const v=b.authority;let y=this.a[v];y&&y.indexOf(":")!==-1&&y.indexOf("[")===-1&&(y=`[${y}]`);const g=this.b[v],m=this.c[v];let w=`path=${encodeURIComponent(b.path)}`;return typeof m=="string"&&(w+=`&${e.connectionTokenQueryName}=${encodeURIComponent(m)}`),n.URI.from({scheme:A.isWeb?this.d:C.vscodeRemoteResource,authority:`${y}:${g}`,path:this.f,query:w})}}e.RemoteAuthorities=new D,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class P{asBrowserUri(b){const v=this.b(b,G);return this.uriToBrowserUri(v)}uriToBrowserUri(b){return b.scheme===C.vscodeRemote?e.RemoteAuthorities.rewrite(b):b.scheme===C.file&&(A.isNative||A.isWebWorker&&A.globals.origin===`${C.vscodeFileResource}://${P.a}`)?b.with({scheme:C.vscodeFileResource,authority:b.authority||P.a,query:null,fragment:null}):b}asFileUri(b){const v=this.b(b,G);return this.uriToFileUri(v)}uriToFileUri(b){return b.scheme===C.vscodeFileResource?b.with({scheme:C.file,authority:b.authority!==P.a?b.authority:null,query:null,fragment:null}):b}b(b,v){return n.URI.isUri(b)?b:n.URI.parse(v.toUrl(b))}}P.a="vscode-app",e.FileAccess=new P;var f;(function(h){const b=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);h.CoopAndCoep=Object.freeze(b.get("3"));const v="vscode-coi";function y(m){let w;typeof m=="string"?w=new URL(m).searchParams:m instanceof URL?w=m.searchParams:n.URI.isUri(m)&&(w=new URL(m.toString(!0)).searchParams);const o=w?.get(v);if(!!o)return b.get(o)}h.getHeadersFromQuery=y;function g(m,w,o){if(!globalThis.crossOriginIsolated)return;const u=w&&o?"3":o?"2":"1";m instanceof URLSearchParams?m.set(v,u):m[v]=u}h.addSearchParam=g})(f=e.COI||(e.COI={}))}),define(ee[18],te([0,1,32,15,9,4,27,7]),function(G,e,I,A,n,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function f(g){return(0,P.uriToFsPath)(g,!0)}e.originalFSPath=f;class h{constructor(m){this.a=m}compare(m,w,o=!1){return m===w?0:(0,D.compare)(this.getComparisonKey(m,o),this.getComparisonKey(w,o))}isEqual(m,w,o=!1){return m===w?!0:!m||!w?!1:this.getComparisonKey(m,o)===this.getComparisonKey(w,o)}getComparisonKey(m,w=!1){return m.with({path:this.a(m)?m.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(m){return this.a(m)}isEqualOrParent(m,w,o=!1){if(m.scheme===w.scheme){if(m.scheme===A.Schemas.file)return I.isEqualOrParent(f(m),f(w),this.a(m))&&m.query===w.query&&(o||m.fragment===w.fragment);if((0,e.isEqualAuthority)(m.authority,w.authority))return I.isEqualOrParent(m.path,w.path,this.a(m),"/")&&m.query===w.query&&(o||m.fragment===w.fragment)}return!1}joinPath(m,...w){return P.URI.joinPath(m,...w)}basenameOrAuthority(m){return(0,e.basename)(m)||m.authority}basename(m){return n.posix.basename(m.path)}extname(m){return n.posix.extname(m.path)}dirname(m){if(m.path.length===0)return m;let w;return m.scheme===A.Schemas.file?w=P.URI.file(n.dirname(f(m))).path:(w=n.posix.dirname(m.path),m.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),w="/")),m.with({path:w})}normalizePath(m){if(!m.path.length)return m;let w;return m.scheme===A.Schemas.file?w=P.URI.file(n.normalize(f(m))).path:w=n.posix.normalize(m.path),m.with({path:w})}relativePath(m,w){if(m.scheme!==w.scheme||!(0,e.isEqualAuthority)(m.authority,w.authority))return;if(m.scheme===A.Schemas.file){const p=n.relative(f(m),f(w));return C.isWindows?I.toSlashes(p):p}let o=m.path||"/";const u=w.path||"/";if(this.a(m)){let p=0;for(const k=Math.min(o.length,u.length);p<k&&!(o.charCodeAt(p)!==u.charCodeAt(p)&&o.charAt(p).toLowerCase()!==u.charAt(p).toLowerCase());p++);o=u.substr(0,p)+o.substr(p)}return n.posix.relative(o,u)}resolvePath(m,w){if(m.scheme===A.Schemas.file){const o=P.URI.file(n.resolve(f(m),w));return m.with({authority:o.authority,path:o.path})}return w=I.toPosixPath(w),m.with({path:n.posix.resolve(m.path,w)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,w){return m===w||m!==void 0&&w!==void 0&&(0,D.equalsIgnoreCase)(m,w)}hasTrailingPathSeparator(m,w=n.sep){if(m.scheme===A.Schemas.file){const o=f(m);return o.length>I.getRoot(o).length&&o[o.length-1]===w}else{const o=m.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,w=n.sep){return(0,e.hasTrailingPathSeparator)(m,w)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,w=n.sep){let o=!1;if(m.scheme===A.Schemas.file){const u=f(m);o=u!==void 0&&u.length===I.getRoot(u).length&&u[u.length-1]===w}else{w="/";const u=m.path;o=u.length===1&&u.charCodeAt(u.length-1)===47}return!o&&!(0,e.hasTrailingPathSeparator)(m,w)?m.with({path:m.path+"/"}):m}}e.ExtUri=h,e.extUri=new h(()=>!1),e.extUriBiasedIgnorePathCase=new h(g=>g.scheme===A.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new h(g=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function b(g,m){const w=[];for(let o=0;o<g.length;o++){const u=m(g[o]);g.some((p,k)=>k===o?!1:(0,e.isEqualOrParent)(u,m(p)))||w.push(g[o])}return w}e.distinctParents=b;var v;(function(g){g.META_DATA_LABEL="label",g.META_DATA_DESCRIPTION="description",g.META_DATA_SIZE="size",g.META_DATA_MIME="mime";function m(w){const o=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(k=>{const[E,M]=k.split(":");E&&M&&o.set(E,M)});const p=w.path.substring(0,w.path.indexOf(";"));return p&&o.set(g.META_DATA_MIME,p),o}g.parseMetaData=m})(v=e.DataUri||(e.DataUri={}));function y(g,m,w){if(m){let o=g.path;return o&&o[0]!==n.posix.sep&&(o=n.posix.sep+o),g.with({scheme:w,authority:m,path:o})}return g.with({scheme:w})}e.toLocalResource=y}),define(ee[8],te([0,1,22,13,3,2,18,4,129]),function(G,e,I,A,n,C,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function h(Z){return!!Z&&typeof Z.then=="function"}e.isThenable=h;function b(Z){const U=new I.CancellationTokenSource,L=Z(U.token),T=new Promise((B,H)=>{const j=U.token.onCancellationRequested(()=>{j.dispose(),U.dispose(),H(new A.CancellationError)});Promise.resolve(L).then($=>{j.dispose(),U.dispose(),B($)},$=>{j.dispose(),U.dispose(),H($)})});return new class{cancel(){U.cancel()}then(B,H){return T.then(B,H)}catch(B){return this.then(void 0,B)}finally(B){return T.finally(B)}}}e.createCancelablePromise=b;function v(Z,U,L){return new Promise((T,B)=>{const H=U.onCancellationRequested(()=>{H.dispose(),T(L)});Z.then(T,B).finally(()=>H.dispose())})}e.raceCancellation=v;function y(Z,U){return new Promise((L,T)=>{const B=U.onCancellationRequested(()=>{B.dispose(),T(new A.CancellationError)});Z.then(L,T).finally(()=>B.dispose())})}e.raceCancellationError=y;async function g(Z){let U=-1;const L=Z.map((B,H)=>B.then(j=>(U=H,j))),T=await Promise.race(L);return Z.forEach((B,H)=>{H!==U&&B.cancel()}),T}e.raceCancellablePromises=g;function m(Z,U,L){let T;const B=setTimeout(()=>{T?.(void 0),L?.()},U);return Promise.race([Z.finally(()=>clearTimeout(B)),new Promise(H=>T=H)])}e.raceTimeout=m;function w(Z){return new Promise((U,L)=>{const T=Z();h(T)?T.then(U,L):U(T)})}e.asPromise=w;class o{constructor(){this.a=null,this.b=null,this.d=null}queue(U){if(this.a){if(this.d=U,!this.b){const L=()=>{this.b=null;const T=this.queue(this.d);return this.d=null,T};this.b=new Promise(T=>{this.a.then(L,L).then(T)})}return new Promise((L,T)=>{this.b.then(L,T)})}return this.a=U(),new Promise((L,T)=>{this.a.then(B=>{this.a=null,L(B)},B=>{this.a=null,T(B)})})}}e.Throttler=o;class u{constructor(){this.a=Promise.resolve(null)}queue(U){return this.a=this.a.then(()=>U(),()=>U())}}e.Sequencer=u;class p{constructor(){this.a=new Map}queue(U,L){const B=(this.a.get(U)??Promise.resolve()).catch(()=>{}).then(L).finally(()=>{this.a.get(U)===B&&this.a.delete(U)});return this.a.set(U,B),B}}e.SequencerByKey=p;const k=(Z,U)=>{let L=!0;const T=setTimeout(()=>{L=!1,U()},Z);return{isTriggered:()=>L,dispose:()=>{clearTimeout(T),L=!1}}},E=Z=>{let U=!0;return queueMicrotask(()=>{U&&(U=!1,Z())}),{isTriggered:()=>U,dispose:()=>{U=!1}}};class M{constructor(U){this.defaultDelay=U,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(U,L=this.defaultDelay){this.g=U,this.h(),this.b||(this.b=new Promise((B,H)=>{this.d=B,this.f=H}).then(()=>{if(this.b=null,this.d=null,this.g){const B=this.g;return this.g=null,B()}}));const T=()=>{this.a=null,this.d?.(null)};return this.a=L===f.MicrotaskDelay?E(T):k(L,T),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new A.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=M;class t{constructor(U){this.a=new M(U),this.b=new o}trigger(U,L){return this.a.trigger(()=>this.b.queue(U),L)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=t;class a{constructor(){this.a=!1,this.b=new Promise((U,L)=>{this.d=U})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=a;class i extends a{constructor(U){super(),this.f=setTimeout(()=>this.open(),U)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=i;function r(Z,U){return U?new Promise((L,T)=>{const B=setTimeout(()=>{H.dispose(),L()},Z),H=U.onCancellationRequested(()=>{clearTimeout(B),H.dispose(),T(new A.CancellationError)})}):b(L=>r(Z,L))}e.timeout=r;function c(Z,U=0){const L=setTimeout(Z,U);return(0,C.toDisposable)(()=>clearTimeout(L))}e.disposableTimeout=c;function l(Z){const U=[];let L=0;const T=Z.length;function B(){return L<T?Z[L++]():null}function H(j){j!=null&&U.push(j);const $=B();return $?$.then(H):Promise.resolve(U)}return Promise.resolve(null).then(H)}e.sequence=l;function s(Z,U=T=>!!T,L=null){let T=0;const B=Z.length,H=()=>{if(T>=B)return Promise.resolve(L);const j=Z[T++];return Promise.resolve(j()).then(q=>U(q)?Promise.resolve(q):H())};return H()}e.first=s;function d(Z,U=T=>!!T,L=null){if(Z.length===0)return Promise.resolve(L);let T=Z.length;const B=()=>{T=-1;for(const H of Z)H.cancel?.()};return new Promise((H,j)=>{for(const $ of Z)$.then(q=>{--T>=0&&U(q)?(B(),H(q)):T===0&&H(L)}).catch(q=>{--T>=0&&(B(),j(q))})})}e.firstParallel=d;class S{constructor(U){this.a=0,this.d=U,this.f=[],this.b=0,this.g=new n.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(U){return this.a++,new Promise((L,T)=>{this.f.push({factory:U,c:L,e:T}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const U=this.f.shift();this.b++;const L=U.factory();L.then(U.c,U.e),L.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=S;class R extends S{constructor(){super(1)}}e.Queue=R;class O{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const U=new F;return this.b.add(U),U.p}d(){for(const[,U]of this.a)if(U.size>0)return!1;return!0}queueFor(U,L=D.extUri){const T=L.getComparisonKey(U);let B=this.a.get(T);return B||(B=new R,n.Event.once(B.onDrained)(()=>{B?.dispose(),this.a.delete(T),this.f()}),this.a.set(T,B)),B}f(){!this.d()||this.g()}g(){for(const U of this.b)U.complete();this.b.clear()}dispose(){for(const[,U]of this.a)U.dispose();this.a.clear(),this.g()}}e.ResourceQueue=O;class N{constructor(U,L){this.a=-1,typeof U=="function"&&typeof L=="number"&&this.setIfNotSet(U,L)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(U,L){this.cancel(),this.a=setTimeout(()=>{this.a=-1,U()},L)}setIfNotSet(U,L){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,U()},L))}}e.TimeoutTimer=N;class K{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(U,L){this.cancel(),this.a=setInterval(()=>{U()},L)}}e.IntervalTimer=K;class V{constructor(U,L){this.b=-1,this.a=U,this.d=L,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(U=this.d){this.cancel(),this.b=setTimeout(this.f,U)}get delay(){return this.d}set delay(U){this.d=U}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=V;class X{constructor(U,L){L%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${L}ms is not a multiple of 1000ms.`),this.a=U,this.b=L,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(U=this.b){U%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(U/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=X;class ie extends V{constructor(U,L){super(U,L),this.j=[]}work(U){this.j.push(U),this.isScheduled()||this.schedule()}h(){const U=this.j;this.j=[],this.a?.(U)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=ie;class re extends C.Disposable{constructor(U,L){super(),this.g=U,this.h=L,this.a=[],this.b=this.B(new C.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(U){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+U.length>this.g.maxBufferedWork)return!1}else if(this.pending+U.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const L of U)this.a.push(L);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new V(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=re,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=Z=>{(0,P.setTimeout0)(()=>{if(U)return;const L=Date.now()+15;Z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,L-Date.now())}}))});let U=!1;return{dispose(){U||(U=!0)}}}:e.runWhenIdle=(Z,U)=>{const L=requestIdleCallback(Z,typeof U=="number"?{timeout:U}:void 0);let T=!1;return{dispose(){T||(T=!0,cancelIdleCallback(L))}}}}();class ce{constructor(U){this.d=!1,this.a=()=>{try{this.f=U()}catch(L){this.g=L}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=ce;async function fe(Z,U,L){let T;for(let B=0;B<L;B++)try{return await Z()}catch(H){T=H,await r(U)}throw T}e.retry=fe;class ge{hasPending(U){return this.a?typeof U=="number"?this.a.taskId===U:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(U,L,T){return this.a={taskId:U,cancel:()=>T?.(),promise:L},L.then(()=>this.d(U),()=>this.d(U)),L}d(U){this.a&&U===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const U=this.b;this.b=void 0,U.run().then(U.promiseResolve,U.promiseReject)}}setNext(U){if(this.b)this.b.run=U;else{let L,T;const B=new Promise((H,j)=>{L=H,T=j});this.b={run:U,promise:B,promiseResolve:L,promiseReject:T}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=ge;class x{constructor(U,L=()=>Date.now()){this.d=U,this.f=L,this.a=0,this.b=0}increment(){const U=this.f();return U-this.a>this.d&&(this.a=U,this.b=0),this.b++,this.b}}e.IntervalCounter=x;class F{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((U,L)=>{this.a=U,this.b=L})}complete(U){return new Promise(L=>{this.a(U),this.f=!0,L()})}error(U){return new Promise(L=>{this.b(U),this.d=!0,L()})}cancel(){new Promise(U=>{this.b(new A.CancellationError),this.d=!0,U()})}}e.DeferredPromise=F;var W;(function(Z){async function U(T){let B;const H=await Promise.all(T.map(j=>j.then($=>$,$=>{B||(B=$)})));if(typeof B<"u")throw B;return H}Z.settled=U;function L(T){return new Promise(async(B,H)=>{try{await T(B,H)}catch(j){H(j)}})}Z.withAsyncBody=L})(W=e.Promises||(e.Promises={}));var z;(function(Z){Z[Z.Initial=0]="Initial",Z[Z.DoneOK=1]="DoneOK",Z[Z.DoneError=2]="DoneError"})(z||(z={}));class J{static fromArray(U){return new J(L=>{L.emitMany(U)})}static fromPromise(U){return new J(async L=>{L.emitMany(await U)})}static fromPromises(U){return new J(async L=>{await Promise.all(U.map(async T=>L.emitOne(await T)))})}static merge(U){return new J(async L=>{await Promise.all(U.map(async T=>{for await(const B of T)L.emitOne(B)}))})}constructor(U){this.a=0,this.b=[],this.d=null,this.f=new n.Emitter,queueMicrotask(async()=>{const L={emitOne:T=>this.g(T),emitMany:T=>this.h(T),reject:T=>this.k(T)};try{await Promise.resolve(U(L)),this.j()}catch(T){this.k(T)}finally{L.emitOne=void 0,L.emitMany=void 0,L.reject=void 0}})}[Symbol.asyncIterator](){let U=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(U<this.b.length)return{done:!1,value:this.b[U++]};if(this.a===1)return{done:!0,value:void 0};await n.Event.toPromise(this.f.event)}while(!0)}}}static map(U,L){return new J(async T=>{for await(const B of U)T.emitOne(L(B))})}map(U){return J.map(this,U)}static filter(U,L){return new J(async T=>{for await(const B of U)L(B)&&T.emitOne(B)})}filter(U){return J.filter(this,U)}static coalesce(U){return J.filter(U,L=>!!L)}coalesce(){return J.coalesce(this)}static async toPromise(U){const L=[];for await(const T of U)L.push(T);return L}toPromise(){return J.toPromise(this)}g(U){this.a===0&&(this.b.push(U),this.f.fire())}h(U){this.a===0&&(this.b=this.b.concat(U),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(U){this.a===0&&(this.a=2,this.d=U,this.f.fire())}}e.AsyncIterableObject=J,J.EMPTY=J.fromArray([]);class ne extends J{constructor(U,L){super(L),this.l=U}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=ne;function se(Z){const U=new I.CancellationTokenSource,L=Z(U.token);return new ne(U,async T=>{const B=U.token.onCancellationRequested(()=>{B.dispose(),U.dispose(),T.reject(new A.CancellationError)});try{for await(const H of L){if(U.token.isCancellationRequested)return;T.emitOne(H)}B.dispose(),U.dispose()}catch(H){B.dispose(),U.dispose(),T.reject(H)}})}e.createCancelableAsyncIterable=se}),define(ee[101],te([0,1,25,8,32,35,9,4,27]),function(G,e,I,A,n,C,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function h(){return Object.create(null)}e.getEmptyExpression=h,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const b="[/\\\\]",v="[^/\\\\]",y=/\//g;function g(x,F){switch(x){case 0:return"";case 1:return`${v}*?`;default:return`(?:${b}|${v}+${b}${F?`|${b}${v}+`:""})*?`}}function m(x,F){if(!x)return[];const W=[];let z=!1,J=!1,ne="";for(const se of x){switch(se){case F:if(!z&&!J){W.push(ne),ne="";continue}break;case"{":z=!0;break;case"}":z=!1;break;case"[":J=!0;break;case"]":J=!1;break}ne+=se}return ne&&W.push(ne),W}e.splitGlobAware=m;function w(x){if(!x)return"";let F="";const W=m(x,e.GLOB_SPLIT);if(W.every(z=>z===e.GLOBSTAR))F=".*";else{let z=!1;W.forEach((J,ne)=>{if(J===e.GLOBSTAR){if(z)return;F+=g(2,ne===W.length-1)}else{let se=!1,Z="",U=!1,L="";for(const T of J){if(T!=="}"&&se){Z+=T;continue}if(U&&(T!=="]"||!L)){let B;T==="-"?B=T:(T==="^"||T==="!")&&!L?B="^":T===e.GLOB_SPLIT?B="":B=(0,f.escapeRegExpCharacters)(T),L+=B;continue}switch(T){case"{":se=!0;continue;case"[":U=!0;continue;case"}":{F+=`(?:${m(Z,",").map(j=>w(j)).join("|")})`,se=!1,Z="";break}case"]":{F+="["+L+"]",U=!1,L="";break}case"?":F+=v;continue;case"*":F+=g(1);continue;default:F+=(0,f.escapeRegExpCharacters)(T)}}ne<W.length-1&&(W[ne+1]!==e.GLOBSTAR||ne+2<W.length)&&(F+=b)}z=J===e.GLOBSTAR})}return F}const o=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,p=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,k=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,E=/^\*\*((\/[\w\.-]+)+)\/?$/,M=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new C.LRUCache(1e4),a=function(){return!1},i=function(){return null};function r(x,F){if(!x)return i;let W;typeof x!="string"?W=x.pattern:W=x,W=W.trim();const z=`${W}_${!!F.trimForExclusions}`;let J=t.get(z);if(J)return c(J,x);let ne;return o.test(W)?J=s(W.substr(4),W):(ne=u.exec(l(W,F)))?J=d(ne[1],W):(F.trimForExclusions?k:p).test(W)?J=S(W,F):(ne=E.exec(l(W,F)))?J=R(ne[1].substr(1),W,!0):(ne=M.exec(l(W,F)))?J=R(ne[1],W,!1):J=O(W),t.set(z,J),c(J,x)}function c(x,F){if(typeof F=="string")return x;const W=function(z,J){return(0,n.isEqualOrParent)(z,F.base,!P.isLinux)?x((0,f.ltrim)(z.substr(F.base.length),D.sep),J):null};return W.allBasenames=x.allBasenames,W.allPaths=x.allPaths,W.basenames=x.basenames,W.patterns=x.patterns,W}function l(x,F){return F.trimForExclusions&&x.endsWith("/**")?x.substr(0,x.length-2):x}function s(x,F){return function(W,z){return typeof W=="string"&&W.endsWith(x)?F:null}}function d(x,F){const W=`/${x}`,z=`\\${x}`,J=function(se,Z){return typeof se!="string"?null:Z?Z===x?F:null:se===x||se.endsWith(W)||se.endsWith(z)?F:null},ne=[x];return J.basenames=ne,J.patterns=[F],J.allBasenames=ne,J}function S(x,F){const W=fe(x.slice(1,-1).split(",").map(Z=>r(Z,F)).filter(Z=>Z!==i),x),z=W.length;if(!z)return i;if(z===1)return W[0];const J=function(Z,U){for(let L=0,T=W.length;L<T;L++)if(W[L](Z,U))return x;return null},ne=W.find(Z=>!!Z.allBasenames);ne&&(J.allBasenames=ne.allBasenames);const se=W.reduce((Z,U)=>U.allPaths?Z.concat(U.allPaths):Z,[]);return se.length&&(J.allPaths=se),J}function R(x,F,W){const z=D.sep===D.posix.sep,J=z?x:x.replace(y,D.sep),ne=D.sep+J,se=D.posix.sep+x;let Z;return W?Z=function(U,L){return typeof U=="string"&&(U===J||U.endsWith(ne)||!z&&(U===x||U.endsWith(se)))?F:null}:Z=function(U,L){return typeof U=="string"&&(U===J||!z&&U===x)?F:null},Z.allPaths=[(W?"*/":"./")+x],Z}function O(x){try{const F=new RegExp(`^${w(x)}$`);return function(W){return F.lastIndex=0,typeof W=="string"&&F.test(W)?x:null}}catch{return i}}function N(x,F,W){return!x||typeof F!="string"?!1:K(x)(F,void 0,W)}e.match=N;function K(x,F={}){if(!x)return a;if(typeof x=="string"||V(x)){const W=r(x,F);if(W===i)return a;const z=function(J,ne){return!!W(J,ne)};return W.allBasenames&&(z.allBasenames=W.allBasenames),W.allPaths&&(z.allPaths=W.allPaths),z}return re(x,F)}e.parse=K;function V(x){const F=x;return F?typeof F.base=="string"&&typeof F.pattern=="string":!1}e.isRelativePattern=V;function X(x){return x.allBasenames||[]}e.getBasenameTerms=X;function ie(x){return x.allPaths||[]}e.getPathTerms=ie;function re(x,F){const W=fe(Object.getOwnPropertyNames(x).map(Z=>ce(Z,x[Z],F)).filter(Z=>Z!==i)),z=W.length;if(!z)return i;if(!W.some(Z=>!!Z.requiresSiblings)){if(z===1)return W[0];const Z=function(T,B){let H;for(let j=0,$=W.length;j<$;j++){const q=W[j](T,B);if(typeof q=="string")return q;(0,A.isThenable)(q)&&(H||(H=[]),H.push(q))}return H?(async()=>{for(const j of H){const $=await j;if(typeof $=="string")return $}return null})():null},U=W.find(T=>!!T.allBasenames);U&&(Z.allBasenames=U.allBasenames);const L=W.reduce((T,B)=>B.allPaths?T.concat(B.allPaths):T,[]);return L.length&&(Z.allPaths=L),Z}const J=function(Z,U,L){let T,B;for(let H=0,j=W.length;H<j;H++){const $=W[H];$.requiresSiblings&&L&&(U||(U=(0,D.basename)(Z)),T||(T=U.substr(0,U.length-(0,D.extname)(Z).length)));const q=$(Z,U,T,L);if(typeof q=="string")return q;(0,A.isThenable)(q)&&(B||(B=[]),B.push(q))}return B?(async()=>{for(const H of B){const j=await H;if(typeof j=="string")return j}return null})():null},ne=W.find(Z=>!!Z.allBasenames);ne&&(J.allBasenames=ne.allBasenames);const se=W.reduce((Z,U)=>U.allPaths?Z.concat(U.allPaths):Z,[]);return se.length&&(J.allPaths=se),J}function ce(x,F,W){if(F===!1)return i;const z=r(x,W);if(z===i)return i;if(typeof F=="boolean")return z;if(F){const J=F.when;if(typeof J=="string"){const ne=(se,Z,U,L)=>{if(!L||!z(se,Z))return null;const T=J.replace("$(basename)",()=>U),B=L(T);return(0,A.isThenable)(B)?B.then(H=>H?x:null):B?x:null};return ne.requiresSiblings=!0,ne}}return z}function fe(x,F){const W=x.filter(Z=>!!Z.basenames);if(W.length<2)return x;const z=W.reduce((Z,U)=>{const L=U.basenames;return L?Z.concat(L):Z},[]);let J;if(F){J=[];for(let Z=0,U=z.length;Z<U;Z++)J.push(F)}else J=W.reduce((Z,U)=>{const L=U.patterns;return L?Z.concat(L):Z},[]);const ne=function(Z,U){if(typeof Z!="string")return null;if(!U){let T;for(T=Z.length;T>0;T--){const B=Z.charCodeAt(T-1);if(B===47||B===92)break}U=Z.substr(T)}const L=z.indexOf(U);return L!==-1?J[L]:null};ne.basenames=z,ne.patterns=J,ne.allBasenames=z;const se=x.filter(Z=>!Z.basenames);return se.push(ne),se}function ge(x,F){return(0,I.equals)(x,F,(W,z)=>typeof W=="string"&&typeof z=="string"?W===z:typeof W!="string"&&typeof z!="string"?W.base===z.base&&W.pattern===z.pattern:!1)}e.patternsEquals=ge}),define(ee[45],te([0,1,25,32,9,4,18,27]),function(G,e,I,A,n,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function f(i,r){const{os:c,tildify:l,relative:s}=r;if(s){const R=h(i,s,c);if(typeof R=="string")return R}let d=i.fsPath;if(c===1&&!C.isWindows?d=d.replace(/\//g,"\\"):c!==1&&C.isWindows&&(d=d.replace(/\\/g,"/")),c!==1&&l?.userHome){const R=l.userHome.fsPath;let O;i.scheme!==l.userHome.scheme&&i.path.startsWith(n.posix.sep)?O=l.userHome.with({path:i.path}).fsPath:O=i.fsPath,d=y(O,R,c)}return(c===1?n.win32:n.posix).normalize(b(d,c===1))}e.getPathLabel=f;function h(i,r,c){const l=c===1?n.win32:n.posix,s=c===3?D.extUri:D.extUriIgnorePathCase,d=r.getWorkspace(),S=(0,I.firstOrDefault)(d.folders);if(!S)return;i.scheme!==S.uri.scheme&&i.path.startsWith(n.posix.sep)&&(i=S.uri.with({path:i.path}));const R=r.getWorkspaceFolder(i);if(!R)return;let O;if(s.isEqual(R.uri,i)?O="":O=s.relativePath(R.uri,i)??"",O&&(O=l.normalize(O)),d.folders.length>1&&!r.noPrefix){const N=R.name?R.name:s.basenameOrAuthority(R.uri);O=O?`${N} \u2022 ${O}`:N}return O}function b(i,r=C.isWindows){return(0,A.hasDriveLetter)(i,r)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=b;let v=Object.create(null);function y(i,r,c=C.OS){if(c===1||!i||!r)return i;let l=v.original===r?v.normalized:void 0;l||(l=r,C.isWindows&&(l=(0,A.toSlashes)(l)),l=`${(0,P.rtrim)(l,n.posix.sep)}${n.posix.sep}`,v={original:r,normalized:l});let s=i;return C.isWindows&&(s=(0,A.toSlashes)(s)),(c===3?s.startsWith(l):(0,P.startsWithIgnoreCase)(s,l))?`~/${s.substr(l.length)}`:i}e.tildify=y;function g(i,r){return i.replace(/^~($|\/|\\)/,`${r}$1`)}e.untildify=g;const m="\u2026",w="\\\\",o="~";function u(i,r=n.sep){const c=new Array(i.length);let l=!1;for(let s=0;s<i.length;s++){const d=i[s];if(d===""){c[s]=`.${r}`;continue}if(!d){c[s]=d;continue}l=!0;let S="",R=d;R.indexOf(w)===0?(S=R.substr(0,R.indexOf(w)+w.length),R=R.substr(R.indexOf(w)+w.length)):R.indexOf(r)===0?(S=R.substr(0,R.indexOf(r)+r.length),R=R.substr(R.indexOf(r)+r.length)):R.indexOf(o)===0&&(S=R.substr(0,R.indexOf(o)+o.length),R=R.substr(R.indexOf(o)+o.length));const O=R.split(r);for(let N=1;l&&N<=O.length;N++)for(let K=O.length-N;l&&K>=0;K--){l=!1;let V=O.slice(K,K+N).join(r);for(let X=0;!l&&X<i.length;X++)if(X!==s&&i[X]&&i[X].indexOf(V)>-1){const ie=K+N===O.length,re=K>0&&i[X].indexOf(r)>-1?r+V:V,ce=i[X].endsWith(re);l=!ie||ce}if(!l){let X="";(O[0].endsWith(":")||S!=="")&&(K===1&&(K=0,N++,V=O[0]+r+V),K>0&&(X=O[0]+r),X=S+X),K>0&&(X=X+m+r),X=X+V,K+N<O.length&&(X=X+r+m),c[s]=X}}l&&(c[s]=d)}return c}e.shorten=u;var p;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(p||(p={}));function k(i,r=Object.create(null)){const c=[];let l=!1,s="";for(const d of i)if(d==="$"||l&&d==="{")s&&c.push({value:s,type:p.TEXT}),s="",l=!0;else if(d==="}"&&l){const S=r[s];if(typeof S=="string")S.length&&c.push({value:S,type:p.VARIABLE});else if(S){const R=c[c.length-1];(!R||R.type!==p.SEPARATOR)&&c.push({value:S.label,type:p.SEPARATOR})}s="",l=!1}else s+=d;return s&&!l&&c.push({value:s,type:p.TEXT}),c.filter((d,S)=>{if(d.type===p.SEPARATOR){const R=c[S-1],O=c[S+1];return[R,O].every(N=>N&&(N.type===p.VARIABLE||N.type===p.TEXT)&&N.value.length>0)}return!0}).map(d=>d.value).join("")}e.template=k;function E(i,r){return C.isMacintosh||r?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):i.replace(/&&|&/g,c=>c==="&"?"&&":"&")}e.mnemonicMenuLabel=E;function M(i,r){return C.isMacintosh||r?i.replace(/\(&&\w\)|&&/g,""):C.isWindows?i.replace(/&&|&/g,c=>c==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=M;function t(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=t;function a(i){const r=i.indexOf("/")!==-1?n.posix:n.win32,c=r.basename(i),l=r.dirname(i);return c.length?{name:c,parentPath:l}:{name:l,parentPath:""}}e.splitName=a}),define(ee[145],te([0,1,17,7]),function(G,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function n(v){return v.toJSON()}class C{constructor(y){this.a=y}transformIncoming(y){const g=this.a.transformIncoming(y);return g===y?y:n(A.URI.from(g))}transformOutgoing(y){const g=this.a.transformOutgoing(y);return g===y?y:n(A.URI.from(g))}transformOutgoingURI(y){const g=this.a.transformOutgoing(y);return g===y?y:A.URI.from(g)}transformOutgoingScheme(y){return this.a.transformOutgoingScheme(y)}}e.URITransformer=C,e.DefaultURITransformer=new class{transformIncoming(v){return v}transformOutgoing(v){return v}transformOutgoingURI(v){return v}transformOutgoingScheme(v){return v}};function D(v,y,g){if(!v||g>200)return null;if(typeof v=="object"){if(v instanceof A.URI)return y.transformOutgoing(v);for(const m in v)if(Object.hasOwnProperty.call(v,m)){const w=D(v[m],y,g+1);w!==null&&(v[m]=w)}}return null}function P(v,y){const g=D(v,y,0);return g===null?v:g}e.transformOutgoingURIs=P;function f(v,y,g,m){if(!v||m>200)return null;if(typeof v=="object"){if(v.$mid===1)return g?A.URI.revive(y.transformIncoming(v)):y.transformIncoming(v);if(v instanceof I.VSBuffer)return null;for(const w in v)if(Object.hasOwnProperty.call(v,w)){const o=f(v[w],y,g,m+1);o!==null&&(v[w]=o)}}return null}function h(v,y){const g=f(v,y,!1,0);return g===null?v:g}e.transformIncomingURIs=h;function b(v,y){const g=f(v,y,!0,0);return g===null?v:g}e.transformAndReviveIncomingURIs=b}),define(ee[85],te([0,1,26,13,61,31,133]),function(G,e,I,A,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(b){return this.a||(this.a=n.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(b)}value(){if(this.b===void 0){let b=0,v=0;const y=(0,I.networkInterfaces)();for(const g in y){const m=y[g];if(m)for(const{mac:w,internal:o}of m)o||(v+=1,this.c(w.toUpperCase())&&(b+=1))}this.b=v>0?b/v:0}return this.b}};let P;async function f(){return P||(P=(async()=>await h()||C.generateUuid())()),P}e.getMachineId=f;async function h(){try{const b=await new Promise((y,g)=>{G(["crypto"],y,g)}),v=(0,D.getMac)();return b.createHash("sha256").update(v,"utf8").digest("hex")}catch(b){A.onUnexpectedError(b);return}}}),define(ee[23],te([0,1,41,26,146,8,32,80,9,4,18,7]),function(G,e,I,A,n,C,D,P,f,h,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var y;(function(re){re[re.UNLINK=0]="UNLINK",re[re.MOVE=1]="MOVE"})(y=e.RimRafMode||(e.RimRafMode={}));async function g(re,ce=y.UNLINK){if((0,D.isRootOrDriveLetter)(re))throw new Error("rimraf - will refuse to recursively delete root");return ce===y.UNLINK?w(re):m(re)}async function m(re){try{const ce=(0,D.randomPath)((0,A.tmpdir)());try{await I.promises.rename(re,ce)}catch(fe){return fe.code==="ENOENT"?void 0:w(re)}w(ce).catch(fe=>{})}catch(ce){if(ce.code!=="ENOENT")throw ce}}async function w(re){return(0,n.promisify)(I.rm)(re,{recursive:!0,force:!0,maxRetries:3})}function o(re){if((0,D.isRootOrDriveLetter)(re))throw new Error("rimraf - will refuse to recursively delete root");I.rmSync(re,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=o;async function u(re,ce){return E(await(ce?p(re):(0,n.promisify)(I.readdir)(re)))}async function p(re){try{return await(0,n.promisify)(I.readdir)(re,{withFileTypes:!0})}catch(ge){console.warn("[node.js fs] readdir with filetypes failed with error: ",ge)}const ce=[],fe=await u(re);for(const ge of fe){let x=!1,F=!1,W=!1;try{const z=await e.Promises.lstat((0,f.join)(re,ge));x=z.isFile(),F=z.isDirectory(),W=z.isSymbolicLink()}catch(z){console.warn("[node.js fs] unexpected error from lstat after readdir: ",z)}ce.push({name:ge,isFile:()=>x,isDirectory:()=>F,isSymbolicLink:()=>W})}return ce}function k(re){return E(I.readdirSync(re))}e.readdirSync=k;function E(re){return re.map(ce=>typeof ce=="string"?h.isMacintosh?(0,P.normalizeNFC)(ce):ce:(ce.name=h.isMacintosh?(0,P.normalizeNFC)(ce.name):ce.name,ce))}async function M(re){const ce=await u(re),fe=[];for(const ge of ce)await a.existsDirectory((0,f.join)(re,ge))&&fe.push(ge);return fe}function t(re,ce=1e3){return new Promise(fe=>{let ge=!1;const x=setInterval(()=>{ge||(ge=!0,I.access(re,F=>{ge=!1,F&&(clearInterval(x),fe(void 0))}))},ce)})}e.whenDeleted=t;var a;(function(re){async function ce(x){let F;try{if(F=await e.Promises.lstat(x),!F.isSymbolicLink())return{stat:F}}catch{}try{return{stat:await e.Promises.stat(x),symbolicLink:F?.isSymbolicLink()?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};if(h.isWindows&&W.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(z){if(z.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};throw z}throw W}}re.stat=ce;async function fe(x){try{const{stat:F,symbolicLink:W}=await re.stat(x);return F.isFile()&&W?.dangling!==!0}catch{}return!1}re.existsFile=fe;async function ge(x){try{const{stat:F,symbolicLink:W}=await re.stat(x);return F.isDirectory()&&W?.dangling!==!0}catch{}return!1}re.existsDirectory=ge})(a=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new C.ResourceQueue;function r(re,ce,fe){return i.queueFor(v.URI.file(re),b.extUriBiasedIgnorePathCase).queue(()=>{const ge=S(fe);return new Promise((x,F)=>s(re,ce,ge,W=>W?F(W):x()))})}let c=!0;function l(re){c=re}e.configureFlushOnWrite=l;function s(re,ce,fe,ge){if(!c)return I.writeFile(re,ce,{mode:fe.mode,flag:fe.flag},ge);I.open(re,fe.flag,fe.mode,(x,F)=>{if(x)return ge(x);I.writeFile(F,ce,W=>{if(W)return I.close(F,()=>ge(W));I.fdatasync(F,z=>(z&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",z),l(!1)),I.close(F,J=>ge(J))))})})}function d(re,ce,fe){const ge=S(fe);if(!c)return I.writeFileSync(re,ce,{mode:ge.mode,flag:ge.flag});const x=I.openSync(re,ge.flag,ge.mode);try{I.writeFileSync(x,ce);try{I.fdatasyncSync(x)}catch(F){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",F),l(!1)}}finally{I.closeSync(x)}}e.writeFileSync=d;function S(re){return re?{mode:typeof re.mode=="number"?re.mode:438,flag:typeof re.flag=="string"?re.flag:"w"}:{mode:438,flag:"w"}}async function R(re,ce){if(re!==ce)try{await e.Promises.rename(re,ce)}catch(fe){if(re.toLowerCase()!==ce.toLowerCase()&&fe.code==="EXDEV"||re.endsWith("."))await O(re,ce,{preserveSymlinks:!1}),await g(re,y.MOVE);else throw fe}}async function O(re,ce,fe){return K(re,ce,{root:{source:re,target:ce},options:fe,handledSourcePaths:new Set})}const N=511;async function K(re,ce,fe){if(fe.handledSourcePaths.has(re))return;fe.handledSourcePaths.add(re);const{stat:ge,symbolicLink:x}=await a.stat(re);if(x){if(fe.options.preserveSymlinks)try{return await ie(re,ce,fe)}catch(F){console.warn("[node.js fs] copy of symlink failed: ",F)}if(x.dangling)return}return ge.isDirectory()?V(re,ce,ge.mode&N,fe):X(re,ce,ge.mode&N)}async function V(re,ce,fe,ge){await e.Promises.mkdir(ce,{recursive:!0,mode:fe});const x=await u(re);for(const F of x)await K((0,f.join)(re,F),(0,f.join)(ce,F),ge)}async function X(re,ce,fe){await e.Promises.copyFile(re,ce),await e.Promises.chmod(ce,fe)}async function ie(re,ce,fe){let ge=await e.Promises.readlink(re);(0,D.isEqualOrParent)(ge,fe.root.source,!h.isLinux)&&(ge=(0,f.join)(fe.root.target,ge.substr(fe.root.source.length+1))),await e.Promises.symlink(ge,ce)}e.Promises=new class{get access(){return(0,n.promisify)(I.access)}get stat(){return(0,n.promisify)(I.stat)}get lstat(){return(0,n.promisify)(I.lstat)}get utimes(){return(0,n.promisify)(I.utimes)}get read(){return(re,ce,fe,ge,x)=>new Promise((F,W)=>{I.read(re,ce,fe,ge,x,(z,J,ne)=>z?W(z):F({bytesRead:J,buffer:ne}))})}get readFile(){return(0,n.promisify)(I.readFile)}get write(){return(re,ce,fe,ge,x)=>new Promise((F,W)=>{I.write(re,ce,fe,ge,x,(z,J,ne)=>z?W(z):F({bytesWritten:J,buffer:ne}))})}get appendFile(){return(0,n.promisify)(I.appendFile)}get fdatasync(){return(0,n.promisify)(I.fdatasync)}get truncate(){return(0,n.promisify)(I.truncate)}get rename(){return(0,n.promisify)(I.rename)}get copyFile(){return(0,n.promisify)(I.copyFile)}get open(){return(0,n.promisify)(I.open)}get close(){return(0,n.promisify)(I.close)}get symlink(){return(0,n.promisify)(I.symlink)}get readlink(){return(0,n.promisify)(I.readlink)}get chmod(){return(0,n.promisify)(I.chmod)}get mkdir(){return(0,n.promisify)(I.mkdir)}get unlink(){return(0,n.promisify)(I.unlink)}get rmdir(){return(0,n.promisify)(I.rmdir)}get realpath(){return(0,n.promisify)(I.realpath)}async exists(re){try{return await e.Promises.access(re),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return M}get writeFile(){return r}get rm(){return g}get move(){return R}get copy(){return O}}}),define(ee[102],te([0,1,41,9,4,27,23]),function(G,e,I,A,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(y){if(n.isLinux)return y;const g=(0,A.dirname)(y);if(y===g)return y;const m=((0,A.basename)(y)||y).toLowerCase();try{const o=(0,D.readdirSync)(g).filter(u=>u.toLowerCase()===m);if(o.length===1){const u=P(g);if(u)return(0,A.join)(u,o[0])}else if(o.length>1){const u=o.indexOf(m);if(u>=0){const p=P(g);if(p)return(0,A.join)(p,o[u])}}}catch{}return null}e.realcaseSync=P;async function f(y){if(n.isLinux)return y;const g=(0,A.dirname)(y);if(y===g)return y;const m=((0,A.basename)(y)||y).toLowerCase();try{const o=(await D.Promises.readdir(g)).filter(u=>u.toLowerCase()===m);if(o.length===1){const u=await f(g);if(u)return(0,A.join)(u,o[0])}else if(o.length>1){const u=o.indexOf(m);if(u>=0){const p=await f(g);if(p)return(0,A.join)(p,o[u])}}}catch{}return null}e.realcase=f;async function h(y){try{return await D.Promises.realpath(y)}catch{const m=v(y);return await D.Promises.access(m,I.constants.R_OK),m}}e.realpath=h;function b(y){try{return I.realpathSync(y)}catch{const m=v(y);return I.accessSync(m,I.constants.R_OK),m}}e.realpathSync=b;function v(y){return(0,C.rtrim)((0,A.normalize)(y),A.sep)}}),define(ee[147],te([0,1,26,9,23]),function(G,e,I,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const C=/^\d+$/,D=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var f;(function(E){E[E.x64=0]="x64",E[E.x86=1]="x86",E[E.ARM=2]="ARM"})(f||(f={}));let h;switch(process.arch){case"ia32":case"x32":h=1;break;case"arm":case"arm64":h=2;break;default:h=0;break}let b;process.env.PROCESSOR_ARCHITEW6432?b=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?b=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?b=1:b=0;class v{constructor(M,t,a){this.exePath=M,this.displayName=t,this.a=a}async exists(){return this.a===void 0&&(this.a=await n.SymlinkSupport.existsFile(this.exePath)),this.a}}function y({useAlternateBitness:E=!1}={}){return E?h===0?process.env["ProgramFiles(x86)"]||null:b===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function g({useAlternateBitness:E=!1,findPreview:M=!1}={}){const t=y({useAlternateBitness:E});if(!t)return null;const a=A.join(t,"PowerShell");if(!await n.SymlinkSupport.existsDirectory(a))return null;let i=-1,r=null;for(const s of await n.Promises.readdir(a)){let d=-1;if(M){const R=s.indexOf("-");if(R<0)continue;const O=s.substring(0,R);if(!C.test(O)||s.substring(R+1)!=="preview")continue;d=parseInt(O,10)}else{if(!C.test(s))continue;d=parseInt(s,10)}if(d<=i)continue;const S=A.join(a,s,"pwsh.exe");!await n.SymlinkSupport.existsFile(S)||(r=S,i=d)}if(!r)return null;const c=t.includes("x86")?" (x86)":"",l=M?" Preview":"";return new v(r,`PowerShell${l}${c}`,!0)}async function m({findPreview:E}={}){if(!process.env.LOCALAPPDATA)return null;const M=A.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await n.SymlinkSupport.existsDirectory(M))return null;const{pwshMsixDirRegex:t,pwshMsixName:a}=E?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const i of await n.Promises.readdir(M))if(t.test(i)){const r=A.join(M,i,"pwsh.exe");return new v(r,a)}return null}function w(){const E=A.join(I.homedir(),".dotnet","tools","pwsh.exe");return new v(E,".NET Core PowerShell Global Tool")}function o(){const E=A.join(process.env.windir,h===1&&b!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new v(E,"Windows PowerShell",!0)}async function*u(){let E=await g();E&&(yield E),E=await g({useAlternateBitness:!0}),E&&(yield E),E=await m(),E&&(yield E),E=w(),E&&(yield E),E=await g({findPreview:!0}),E&&(yield E),E=await m({findPreview:!0}),E&&(yield E),E=await g({useAlternateBitness:!0,findPreview:!0}),E&&(yield E),E=o(),E&&(yield E)}async function*p(){for await(const E of u())await E.exists()&&(yield E)}e.enumeratePowerShellInstallations=p;async function k(){for await(const E of p())return E;return null}e.getFirstAvailablePowerShellInstallation=k}),define(ee[86],te([0,1,9,4,36,83,10,23]),function(G,e,I,A,n,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return C.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return C.TerminateResponseCode}});function f(v=n.env){return v.comspec||"cmd.exe"}e.getWindowsShell=f;function h(v){let y=[],g=!1;const m=function(w){if(g){y.push(w);return}(!v.send(w,u=>{if(u&&console.error(u),g=!1,y.length>0){const p=y.slice(0);y=[],p.forEach(k=>m(k))}})||A.isWindows)&&(g=!0)};return{send:m}}e.createQueuedSender=h;var b;(function(v){async function y(g,m,w){if(I.isAbsolute(g))return g;if(m===void 0&&(m=n.cwd()),I.dirname(g)!=="."||(w===void 0&&D.isString(n.env.PATH)&&(w=n.env.PATH.split(I.delimiter)),w===void 0||w.length===0))return I.join(m,g);async function u(p){if(await P.Promises.exists(p)){let k;try{k=await P.Promises.stat(p)}catch(E){E.message.startsWith("EACCES")&&(k=await P.Promises.lstat(p))}return k?!k.isDirectory():!1}return!1}for(const p of w){let k;if(I.isAbsolute(p)?k=I.join(p,g):k=I.join(m,p,g),await u(k))return k;let E=k+".com";if(await u(E)||(E=k+".exe",await u(E)))return E}return I.join(m,g)}v.findExecutable=y})(b=e.win32||(e.win32={}))}),define(ee[103],te([0,1,46,15]),function(G,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function n(D){return new Promise((P,f)=>{let h;const b=new Map;function v(g,m,w,o,u){const p=b.get(m);if(g===D||p){const k={name:y(w),cmd:w,pid:g,ppid:m,load:o,mem:u};b.set(g,k),g===D&&(h=k),p&&(p.children||(p.children=[]),p.children.push(k),p.children.length>1&&(p.children=p.children.sort((E,M)=>E.pid-M.pid)))}}function y(g){const m=/--vscode-window-kind=shared-process/,w=/--vscode-window-kind=issue-reporter/,o=/--vscode-window-kind=process-explorer/,u=/--utility-sub-type=network/,p=/--utility-sub-type=node.mojom.NodeService/,k=/--crashes-directory/,E=/\\pipe\\winpty-control/,M=/conhost\.exe/,t=/--type=([a-zA-Z-]+)/;if(k.exec(g))return"electron-crash-reporter";if(E.exec(g))return"winpty-process";if(M.exec(g))return"console-window-host (Windows internal process)";let a=t.exec(g);if(a&&a.length===2){if(a[1]==="renderer")return m.exec(g)?"shared-process":w.exec(g)?"issue-reporter":o.exec(g)?"process-explorer":"window";if(a[1]==="utility"){if(u.exec(g))return"utility-network-service";if(p.exec(g))return"extension-host"}else if(a[1]==="extensionHost")return"extension-host";return a[1]}const i=/[a-zA-Z-]+\.js/g;let r="";do a=i.exec(g),a&&(r+=a+" ");while(a);return r&&g.indexOf("node ")<0&&g.indexOf("node.exe")<0?`electron_node ${r}`:g}if(process.platform==="win32"){const g=m=>m.indexOf("\\\\?\\")===0||m.indexOf("\\??\\")===0?m.substr(4):m.indexOf('"\\\\?\\')===0||m.indexOf('"\\??\\')===0?'"'+m.substr(5):m;new Promise((m,w)=>{G(["windows-process-tree"],m,w)}).then(m=>{m.getProcessList(D,w=>{if(!w){f(new Error(`Root process ${D} not found`));return}m.getProcessCpuUsage(w,o=>{const u=new Map;o.forEach(p=>{const k=g(p.commandLine||"");u.set(p.pid,{name:y(k),cmd:k,pid:p.pid,ppid:p.ppid,load:p.cpu||0,mem:p.memory||0})}),h=u.get(D),h?(u.forEach(p=>{const k=u.get(p.ppid);k&&(k.children||(k.children=[]),k.children.push(p))}),u.forEach(p=>{p.children&&(p.children=p.children.sort((k,E)=>k.pid-E.pid))}),P(h)):f(new Error(`Root process ${D} not found`))})},m.ProcessDataFlag.CommandLine|m.ProcessDataFlag.Memory)})}else{let g=function(){let m=[h];const w=[];for(;m.length;){const u=m.shift();u&&(w.push(u.pid),u.children&&(m=m.concat(u.children)))}let o=JSON.stringify(A.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);o+=" "+w.join(" "),(0,I.exec)(o,{},(u,p,k)=>{if(u||k)f(u||new Error(k.toString()));else{const E=p.toString().split(`
`);for(let M=0;M<w.length;M++){const t=b.get(w[M]);t.load=parseFloat(E[M])}if(!h){f(new Error(`Root process ${D} not found`));return}P(h)}})};(0,I.exec)("which ps",{},(m,w,o)=>{if(m||o)if(process.platform!=="linux")f(m||new Error(o.toString()));else{const u=JSON.stringify(A.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,I.exec)(u,{},(p,k,E)=>{p||E?f(p||new Error(E.toString())):(C(k,v),g())})}else{const u=w.toString().trim(),p="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,I.exec)(`${u} ${p}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(k,E,M)=>{k||M&&!M.includes("screen size is bogus")?f(k||new Error(M.toString())):(C(E,v),process.platform==="linux"?g():h?P(h):f(new Error(`Root process ${D} not found`)))})}})}})}e.listProcesses=n;function C(D,P){const f=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,h=D.toString().split(`
`);for(const b of h){const v=f.exec(b.trim());v&&v.length===6&&P(parseInt(v[1]),parseInt(v[2]),v[5],parseFloat(v[3]),parseFloat(v[4]))}}}),define(ee[148],te([0,1,26,4,147,86]),function(G,e,I,A,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function D(v,y){return v===1?A.isWindows?b():C.getWindowsShell(y):f(v,y)}e.getSystemShell=D;let P=null;function f(v,y){if(A.isLinux&&v===2||A.isMacintosh&&v===3)return"/bin/bash";if(!P){let g;if(A.isWindows)g="/bin/bash";else{if(g=y.SHELL,!g)try{g=(0,I.userInfo)().shell}catch{}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}P=g}return P}let h=null;async function b(){return h||(h=(await(0,n.getFirstAvailablePowerShellInstallation)()).exePath),h}});var ve=this&&this.__decorate||function(G,e,I,A){var n=arguments.length,C=n<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,I):A,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate(G,e,I,A);else for(var P=G.length-1;P>=0;P--)(D=G[P])&&(C=(n<3?D(C):n>3?D(e,I,C):D(e,I))||C);return n>3&&C&&Object.defineProperty(e,I,C),C};define(ee[47],te([0,1,25,8,17,22,55,13,3,2,73,27,10]),function(G,e,I,A,n,C,D,P,f,h,b,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var g;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(g||(g={}));function m(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(w||(w={}));function o(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(u||(u={}));function p(F){let W=0;for(let z=0;;z+=7){const J=F.read(1);if(W|=(J.buffer[0]&127)<<z,!(J.buffer[0]&128))return W}}const k=i(0);function E(F,W){if(W===0){F.write(k);return}let z=0;for(let ne=W;ne!==0;ne=ne>>>7)z++;const J=n.VSBuffer.alloc(z);for(let ne=0;W!==0;ne++)J.buffer[ne]=W&127,W=W>>>7,W>0&&(J.buffer[ne]|=128);F.write(J)}class M{constructor(W){this.b=W,this.a=0}read(W){const z=this.b.slice(this.a,this.a+W);return this.a+=z.byteLength,z}}e.BufferReader=M;class t{constructor(){this.a=[]}get buffer(){return n.VSBuffer.concat(this.a)}write(W){this.a.push(W)}}e.BufferWriter=t;var a;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object",F[F.Int=6]="Int"})(a||(a={}));function i(F){const W=n.VSBuffer.alloc(1);return W.writeUInt8(F,0),W}const r={Undefined:i(a.Undefined),String:i(a.String),Buffer:i(a.Buffer),VSBuffer:i(a.VSBuffer),Array:i(a.Array),Object:i(a.Object),Uint:i(a.Int)},c=typeof Buffer<"u";function l(F,W){if(typeof W>"u")F.write(r.Undefined);else if(typeof W=="string"){const z=n.VSBuffer.fromString(W);F.write(r.String),E(F,z.byteLength),F.write(z)}else if(c&&Buffer.isBuffer(W)){const z=n.VSBuffer.wrap(W);F.write(r.Buffer),E(F,z.byteLength),F.write(z)}else if(W instanceof n.VSBuffer)F.write(r.VSBuffer),E(F,W.byteLength),F.write(W);else if(Array.isArray(W)){F.write(r.Array),E(F,W.length);for(const z of W)l(F,z)}else if(typeof W=="number"&&(W|0)===W)F.write(r.Uint),E(F,W);else{const z=n.VSBuffer.fromString(JSON.stringify(W));F.write(r.Object),E(F,z.byteLength),F.write(z)}}e.serialize=l;function s(F){switch(F.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return F.read(p(F)).toString();case a.Buffer:return F.read(p(F)).buffer;case a.VSBuffer:return F.read(p(F));case a.Array:{const z=p(F),J=[];for(let ne=0;ne<z;ne++)J.push(s(F));return J}case a.Object:return JSON.parse(F.read(p(F)).toString());case a.Int:return p(F)}}e.deserialize=s;class d{constructor(W,z,J=null,ne=1e3){this.h=W,this.j=z,this.k=J,this.l=ne,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(se=>this.q(se)),this.m({type:200})}registerChannel(W,z){this.b.set(W,z),setTimeout(()=>this.w(W),0)}m(W){switch(W.type){case 200:{const z=this.o([W.type]);this.k?.logOutgoing(z,0,1,o(W.type));return}case 201:case 202:case 204:case 203:{const z=this.o([W.type,W.id],W.data);this.k?.logOutgoing(z,W.id,1,o(W.type),W.data);return}}}o(W,z=void 0){const J=new t;return l(J,W),l(J,z),this.p(J.buffer)}p(W){try{return this.h.send(W),W.byteLength}catch{return 0}}q(W){const z=new M(W),J=s(z),ne=s(z),se=J[0];switch(se){case 100:return this.k?.logIncoming(W.byteLength,J[1],1,`${m(se)}: ${J[2]}.${J[3]}`,ne),this.s({type:se,id:J[1],channelName:J[2],name:J[3],arg:ne});case 102:return this.k?.logIncoming(W.byteLength,J[1],1,`${m(se)}: ${J[2]}.${J[3]}`,ne),this.t({type:se,id:J[1],channelName:J[2],name:J[3],arg:ne});case 101:return this.k?.logIncoming(W.byteLength,J[1],1,`${m(se)}`),this.u({type:se,id:J[1]});case 103:return this.k?.logIncoming(W.byteLength,J[1],1,`${m(se)}`),this.u({type:se,id:J[1]})}}s(W){const z=this.b.get(W.channelName);if(!z){this.v(W);return}const J=new C.CancellationTokenSource;let ne;try{ne=z.call(this.j,W.name,W.arg,J.token)}catch(U){ne=Promise.reject(U)}const se=W.id;ne.then(U=>{this.m({id:se,data:U,type:201}),this.d.delete(W.id)},U=>{U instanceof Error?this.m({id:se,data:{message:U.message,name:U.name,stack:U.stack?U.stack.split?U.stack.split(`
`):U.stack:void 0},type:202}):this.m({id:se,data:U,type:203}),this.d.delete(W.id)});const Z=(0,h.toDisposable)(()=>J.cancel());this.d.set(W.id,Z)}t(W){const z=this.b.get(W.channelName);if(!z){this.v(W);return}const J=W.id,se=z.listen(this.j,W.name,W.arg)(Z=>this.m({id:J,data:Z,type:204}));this.d.set(W.id,se)}u(W){const z=this.d.get(W.id);z&&(z.dispose(),this.d.delete(W.id))}v(W){let z=this.g.get(W.channelName);z||(z=[],this.g.set(W.channelName,z));const J=setTimeout(()=>{console.error(`Unknown channel: ${W.channelName}`),W.type===100&&this.m({id:W.id,data:{name:"Unknown channel",message:`Channel name '${W.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);z.push({request:W,timeoutTimer:J})}w(W){const z=this.g.get(W);if(z){for(const J of z)switch(clearTimeout(J.timeoutTimer),J.request.type){case 100:this.s(J.request);break;case 102:this.t(J.request);break}this.g.delete(W)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,h.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=d;var S;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(S=e.RequestInitiator||(e.RequestInitiator={}));class R{constructor(W,z=null){this.l=W,this.a=!1,this.b=u.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new f.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(J=>this.s(J)),this.j=z}getChannel(W){const z=this;return{call(J,ne,se){return z.a?Promise.reject(new P.CancellationError):z.m(W,J,ne,se)},listen(J,ne){return z.a?f.Event.None:z.o(W,J,ne)}}}m(W,z,J,ne=C.CancellationToken.None){const se=this.g++,U={id:se,type:100,channelName:W,name:z,arg:J};if(ne.isCancellationRequested)return Promise.reject(new P.CancellationError);let L;return new Promise((B,H)=>{if(ne.isCancellationRequested)return H(new P.CancellationError);const j=()=>{const de=pe=>{switch(pe.type){case 201:this.f.delete(se),B(pe.data);break;case 202:{this.f.delete(se);const ye=new Error(pe.data.message);ye.stack=Array.isArray(pe.data.stack)?pe.data.stack.join(`
`):pe.data.stack,ye.name=pe.data.name,H(ye);break}case 203:this.f.delete(se),H(pe.data);break}};this.f.set(se,de),this.p(U)};let $=null;this.b===u.Idle?j():($=(0,A.createCancelablePromise)(de=>this.u()),$.then(()=>{$=null,j()}));const q=()=>{$?($.cancel(),$=null):this.p({id:se,type:101}),H(new P.CancellationError)},oe=ne.onCancellationRequested(q);L=(0,h.combinedDisposable)((0,h.toDisposable)(q),oe),this.d.add(L)}).finally(()=>{this.d.delete(L)})}o(W,z,J){const ne=this.g++,Z={id:ne,type:102,channelName:W,name:z,arg:J};let U=null;const L=new f.Emitter({onWillAddFirstListener:()=>{U=(0,A.createCancelablePromise)(B=>this.u()),U.then(()=>{U=null,this.d.add(L),this.p(Z)})},onDidRemoveLastListener:()=>{U?(U.cancel(),U=null):(this.d.delete(L),this.p({id:ne,type:103}))}}),T=B=>L.fire(B.data);return this.f.set(ne,T),L.event}p(W){switch(W.type){case 100:case 102:{const z=this.q([W.type,W.id,W.channelName,W.name],W.arg);this.j?.logOutgoing(z,W.id,0,`${m(W.type)}: ${W.channelName}.${W.name}`,W.arg);return}case 101:case 103:{const z=this.q([W.type,W.id]);this.j?.logOutgoing(z,W.id,0,m(W.type));return}}}q(W,z=void 0){const J=new t;return l(J,W),l(J,z),this.r(J.buffer)}r(W){try{return this.l.send(W),W.byteLength}catch{return 0}}s(W){const z=new M(W),J=s(z),ne=s(z),se=J[0];switch(se){case 200:return this.j?.logIncoming(W.byteLength,0,0,o(se)),this.t({type:J[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(W.byteLength,J[1],0,o(se),ne),this.t({type:J[0],id:J[1],data:ne})}}t(W){if(W.type===200){this.b=u.Idle,this.k.fire();return}this.f.get(W.id)?.(W)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}u(){return this.b===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,h.dispose)(this.d.values()),this.d.clear()}}ve([D.memoize],R.prototype,"onDidInitializePromise",null),e.ChannelClient=R;class O{get connections(){const W=[];return this.f.forEach(z=>W.push(z)),W}constructor(W){this.a=new Map,this.f=new Set,this.g=new f.Emitter,this.onDidAddConnection=this.g.event,this.h=new f.Emitter,this.onDidRemoveConnection=this.h.event,W(({protocol:z,onDidClientDisconnect:J})=>{f.Event.once(z.onMessage)(se=>{const Z=new M(se),U=s(Z),L=new d(z,U),T=new R(z);this.a.forEach((H,j)=>L.registerChannel(j,H));const B={channelServer:L,channelClient:T,ctx:U};this.f.add(B),this.g.fire(B),J(()=>{L.dispose(),T.dispose(),this.f.delete(B),this.h.fire(B)})})})}getChannel(W,z){const J=this;return{call(ne,se,Z){let U;if((0,y.isFunction)(z)){const T=(0,I.getRandomElement)(J.connections.filter(z));U=T?Promise.resolve(T):f.Event.toPromise(f.Event.filter(J.onDidAddConnection,z))}else U=z.routeCall(J,ne,se);const L=U.then(T=>T.channelClient.getChannel(W));return K(L).call(ne,se,Z)},listen(ne,se){if((0,y.isFunction)(z))return J.j(W,z,ne,se);const Z=z.routeEvent(J,ne,se).then(U=>U.channelClient.getChannel(W));return K(Z).listen(ne,se)}}}j(W,z,J,ne){const se=this;let Z=new h.DisposableStore;const U=new f.Emitter({onWillAddFirstListener:()=>{Z=new h.DisposableStore;const L=new f.EventMultiplexer,T=new Map,B=j=>{const q=j.channelClient.getChannel(W).listen(J,ne),oe=L.add(q);T.set(j,oe)},H=j=>{const $=T.get(j);!$||($.dispose(),T.delete(j))};se.connections.filter(z).forEach(B),f.Event.filter(se.onDidAddConnection,z)(B,void 0,Z),se.onDidRemoveConnection(H,void 0,Z),L.event(U.fire,U,Z),Z.add(L)},onDidRemoveLastListener:()=>{Z.dispose()}});return U.event}registerChannel(W,z){this.a.set(W,z),this.f.forEach(J=>{J.channelServer.registerChannel(W,z)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=O;class N{constructor(W,z,J=null){const ne=new t;l(ne,z),W.send(ne.buffer),this.a=new R(W,J),this.d=new d(W,z,J)}getChannel(W){return this.a.getChannel(W)}registerChannel(W,z){this.d.registerChannel(W,z)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=N;function K(F){return{call(W,z,J){return F.then(ne=>ne.call(W,z,J))},listen(W,z){const J=new f.Relay;return F.then(ne=>J.input=ne.listen(W,z)),J.event}}}e.getDelayedChannel=K;function V(F){let W=!1;return{call(z,J,ne){return W?F.call(z,J,ne):(0,A.timeout)(0).then(()=>W=!0).then(()=>F.call(z,J,ne))},listen(z,J){if(W)return F.listen(z,J);const ne=new f.Relay;return(0,A.timeout)(0).then(()=>W=!0).then(()=>ne.input=F.listen(z,J)),ne.event}}}e.getNextTickChannel=V;class X{constructor(W){this.a=W}routeCall(W){return this.b(W)}routeEvent(W){return this.b(W)}async b(W){for(const z of W.connections)if(await Promise.resolve(this.a(z.ctx)))return Promise.resolve(z);return await f.Event.toPromise(W.onDidAddConnection),await this.b(W)}}e.StaticRouter=X;var ie;(function(F){function W(se,Z){const U=se,L=Z&&Z.disableMarshalling,T=new Map;for(const B in U)J(B)&&T.set(B,f.Event.buffer(U[B],!0));return new class{listen(B,H,j){const $=T.get(H);if($)return $;if(ne(H)){const q=U[H];if(typeof q=="function")return q.call(U,j)}throw new Error(`Event not found: ${H}`)}call(B,H,j){const $=U[H];if(typeof $=="function"){if(!L&&Array.isArray(j))for(let q=0;q<j.length;q++)j[q]=(0,b.revive)(j[q]);return $.apply(U,j)}throw new Error(`Method not found: ${H}`)}}}F.fromService=W;function z(se,Z){const U=Z&&Z.disableMarshalling;return new Proxy({},{get(L,T){if(typeof T=="string")return Z?.properties?.has(T)?Z.properties.get(T):ne(T)?function(B){return se.listen(T,B)}:J(T)?se.listen(T):async function(...B){let H;Z&&!(0,y.isUndefinedOrNull)(Z.context)?H=[Z.context,...B]:H=B;const j=await se.call(T,H);return U?j:(0,b.revive)(j)};throw new Error(`Property not found: ${String(T)}`)}})}F.toService=z;function J(se){return se[0]==="o"&&se[1]==="n"&&v.isUpperAsciiLetter(se.charCodeAt(2))}function ne(se){return/^onDynamic/.test(se)&&v.isUpperAsciiLetter(se.charCodeAt(9))}})(ie=e.ProxyChannel||(e.ProxyChannel={}));const re=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ce(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){const W=F.toString();if(W!=="[object Object]")return W}return F}function fe(F){return Array.isArray(F)?F.map(ce):ce(F)}function ge(F,W,z,J,ne,se,Z){Z=fe(Z);const U=re[ne],L=U[J%U.length];let T=[`%c[${F}]%c[${String(W).padStart(7," ")}]%c[len: ${String(z).padStart(5," ")}]%c${String(J).padStart(5," ")} - ${se}`,"color: darkgreen","color: grey","color: grey",`color: ${L}`];/\($/.test(se)?(T=T.concat(Z),T.push(")")):T.push(Z),console.log.apply(console,T)}class x{constructor(W,z){this.d=W,this.f=z,this.a=0,this.b=0}logOutgoing(W,z,J,ne,se){this.b+=W,ge(this.d,this.b,W,z,J,ne,se)}logIncoming(W,z,J,ne,se){this.a+=W,ge(this.f,this.a,W,z,J,ne,se)}}e.IPCLogger=x}),define(ee[149],te([0,1,17,3,47]),function(G,e,I,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class C{constructor(f){this.a=f,this.onMessage=A.Event.fromDOMEventEmitter(this.a,"message",h=>I.VSBuffer.wrap(h.data)),f.start()}send(f){this.a.postMessage(f.buffer)}disconnect(){this.a.close()}}e.Protocol=C;class D extends n.IPCClient{constructor(f,h){const b=new C(f);super(b,h),this.b=b}dispose(){this.b.disconnect()}}e.Client=D}),define(ee[104],te([0,1,8,17,3,2,47]),function(G,e,I,A,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var P;(function(R){R.Created="created",R.Read="read",R.Write="write",R.Open="open",R.Error="error",R.Close="close",R.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",R.NodeEndReceived="nodeEndReceived",R.NodeEndSent="nodeEndSent",R.NodeDrainBegin="nodeDrainBegin",R.NodeDrainEnd="nodeDrainEnd",R.zlibInflateError="zlibInflateError",R.zlibInflateData="zlibInflateData",R.zlibInflateInitialWrite="zlibInflateInitialWrite",R.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",R.zlibInflateWrite="zlibInflateWrite",R.zlibInflateFlushFired="zlibInflateFlushFired",R.zlibDeflateError="zlibDeflateError",R.zlibDeflateData="zlibDeflateData",R.zlibDeflateWrite="zlibDeflateWrite",R.zlibDeflateFlushFired="zlibDeflateFlushFired",R.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",R.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",R.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",R.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",R.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",R.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",R.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",R.ProtocolHeaderRead="protocolHeaderRead",R.ProtocolMessageRead="protocolMessageRead",R.ProtocolHeaderWrite="protocolHeaderWrite",R.ProtocolMessageWrite="protocolMessageWrite",R.ProtocolWrite="protocolWrite"})(P=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var f;(function(R){R.enableDiagnostics=!1,R.records=[];const O=new WeakMap;let N=0;function K(X,ie){if(!O.has(X)){const re=String(++N);O.set(X,re)}return O.get(X)}function V(X,ie,re,ce){if(!R.enableDiagnostics)return;const fe=K(X,ie);if(ce instanceof A.VSBuffer||ce instanceof Uint8Array||ce instanceof ArrayBuffer||ArrayBuffer.isView(ce)){const ge=A.VSBuffer.alloc(ce.byteLength);ge.set(ce),R.records.push({timestamp:Date.now(),id:fe,label:ie,type:re,buff:ge})}else R.records.push({timestamp:Date.now(),id:fe,label:ie,type:re,data:ce})}R.traceSocketEvent=V})(f=e.SocketDiagnostics||(e.SocketDiagnostics={}));var h;(function(R){R[R.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",R[R.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(h=e.SocketCloseEventType||(e.SocketCloseEventType={}));let b=null;function v(){return b||(b=A.VSBuffer.alloc(0)),b}class y{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(O){this.a.push(O),this.b+=O.byteLength}read(O){return this.c(O,!0)}peek(O){return this.c(O,!1)}c(O,N){if(O===0)return v();if(O>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===O){const ie=this.a[0];return N&&(this.a.shift(),this.b-=O),ie}if(this.a[0].byteLength>O){const ie=this.a[0].slice(0,O);return N&&(this.a[0]=this.a[0].slice(O),this.b-=O),ie}const K=A.VSBuffer.alloc(O);let V=0,X=0;for(;O>0;){const ie=this.a[X];if(ie.byteLength>O){const re=ie.slice(0,O);K.set(re,V),V+=O,N&&(this.a[X]=ie.slice(O),this.b-=O),O-=O}else K.set(ie,V),V+=ie.byteLength,N?(this.a.shift(),this.b-=ie.byteLength):X++,O-=ie.byteLength}return K}}e.ChunkStream=y;var g;(function(R){R[R.None=0]="None",R[R.Regular=1]="Regular",R[R.Control=2]="Control",R[R.Ack=3]="Ack",R[R.Disconnect=5]="Disconnect",R[R.ReplayRequest=6]="ReplayRequest",R[R.Pause=7]="Pause",R[R.Resume=8]="Resume",R[R.KeepAlive=9]="KeepAlive",R[R.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",R[R.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(g||(g={}));function m(R){switch(R){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var w;(function(R){R[R.HeaderLength=13]="HeaderLength",R[R.AcknowledgeTime=2e3]="AcknowledgeTime",R[R.TimeoutTime=2e4]="TimeoutTime",R[R.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",R[R.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",R[R.KeepAliveSendTime=5e3]="KeepAliveSendTime",R[R.LatencySampleTime=6e4]="LatencySampleTime",R[R.LatencySampleCount=5]="LatencySampleCount",R[R.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",R[R.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(w=e.ProtocolConstants||(e.ProtocolConstants={}));class o{constructor(O,N,K,V){this.type=O,this.id=N,this.ack=K,this.data=V,this.writtenTime=0}get size(){return this.data.byteLength}}class u extends C.Disposable{constructor(O){super(),this.f=this.B(new n.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=O,this.b=!1,this.c=new y,this.B(this.a.onData(N=>this.acceptChunk(N))),this.lastReadTime=Date.now()}acceptChunk(O){if(!(!O||O.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(O);this.c.byteLength>=this.g.readLen;){const N=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=N.readUInt32BE(9),this.g.messageType=N.readUInt8(0),this.g.id=N.readUInt32BE(1),this.g.ack=N.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:m(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const K=this.g.messageType,V=this.g.id,X=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",N),this.f.fire(new o(K,V,X,N)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class p{constructor(O){this.k=null,this.a=!1,this.b=!1,this.c=O,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(O){if(this.a)return;O.writtenTime=Date.now(),this.lastWriteTime=Date.now();const N=A.VSBuffer.alloc(13);N.writeUInt8(O.type,0),N.writeUInt32BE(O.id,1),N.writeUInt32BE(O.ack,5),N.writeUInt32BE(O.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:m(O.type),id:O.id,ack:O.ack,messageSize:O.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",O.data),this.j(N,O.data)}g(O,N){const K=this.f===0;return this.d.push(O,N),this.f+=O.byteLength+N.byteLength,K}h(){const O=A.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,O}j(O,N){this.g(O,N)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const O=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:O.byteLength}),this.c.write(O)}}class k extends C.Disposable{constructor(O){super(),this.f=new n.Emitter,this.onMessage=this.f.event,this.g=new n.Emitter,this.onDidDispose=this.g.event,this.a=O,this.b=this.B(new p(this.a)),this.c=this.B(new u(this.a)),this.B(this.c.onMessage(N=>{N.type===1&&this.f.fire(N.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(O){this.b.write(new o(1,0,0,O))}}e.Protocol=k;class E extends D.IPCClient{static fromSocket(O,N){return new E(new k(O),N)}get onDidDispose(){return this.b.onDidDispose}constructor(O,N,K=null){super(O,N,K),this.b=O}dispose(){super.dispose();const O=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),O.end()}}e.Client=E;class M{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new n.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(O){this.b?this.d.length>0?this.d.push(O):this.a.fire(O):this.d.push(O)}flushBuffer(){this.d=[]}}e.BufferedEmitter=M;class t{constructor(O){this.data=O,this.next=null}}class a{constructor(){this.a=null,this.b=null}length(){let O=0,N=this.a;for(;N;)N=N.next,O++;return O}peek(){return this.a?this.a.data:null}toArray(){const O=[];let N=0,K=this.a;for(;K;)O[N++]=K.data,K=K.next;return O}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(O){const N=new t(O);if(!this.a){this.a=N,this.b=N;return}this.b.next=N,this.b=N}}class i{static getInstance(){return i.b||(i.b=new i),i.b}constructor(){this.c=[];const O=Date.now();for(let N=0;N<i.a;N++)this.c[N]=O-1e3*N;setInterval(()=>{for(let N=i.a;N>=1;N--)this.c[N]=this.c[N-1];this.c[0]=Date.now()},1e3)}d(){const O=Date.now(),N=(1+i.a)*1e3;let K=0;for(let V=0;V<i.a;V++)O-this.c[V]<=N&&K++;return 1-K/i.a}hasHighLoad(){return this.d()>=.5}}i.a=10,i.b=null;var r;(function(R){R[R.Good=0]="Good",R[R.Poor=1]="Poor"})(r=e.ConnectionHealth||(e.ConnectionHealth={}));function c(R){switch(R){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=c;class l{constructor(O){this.connectionHealth=O}}e.ConnectionHealthChangedEvent=l;class s{constructor(O,N){this.roundTripTime=O,this.recentHighRoundTripCount=N}}e.HighRoundTripTimeEvent=s;class d{get unacknowledgedCount(){return this.c-this.d}constructor(O){this.x=new M,this.onControlMessage=this.x.event,this.y=new M,this.onMessage=this.y.event,this.z=new M,this.onDidDispose=this.z.event,this.A=new M,this.onSocketClose=this.A.event,this.B=new M,this.onSocketTimeout=this.B.event,this.C=new M,this.onHighRoundTripTime=this.C.event,this.D=new M,this.onDidChangeConnectionHealth=this.D.event,this.u=O.loadEstimator??i.getInstance(),this.v=O.measureRoundTripTime??!1,this.w=O.sendKeepAlive??!0,this.a=!1,this.b=new a,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new C.DisposableStore,this.o=O.socket,this.p=this.t.add(new p(this.o)),this.q=this.t.add(new u(this.o)),this.t.add(this.q.onMessage(N=>this.E(N))),this.t.add(this.o.onClose(N=>this.A.fire(N))),this.r=this.t.add(new S),this.t.add(this.r.onSendLatencyRequest(N=>this.J(N))),this.t.add(this.r.onHighRoundTripTime(N=>this.C.fire(N))),this.t.add(this.r.onDidChangeConnectionHealth(N=>this.D.fire(N))),this.v&&this.r.start(),O.initialChunk&&this.q.acceptChunk(O.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const O=new o(5,0,0,v());this.p.write(O),this.p.flush()}sendPause(){const O=new o(7,0,0,v());this.p.write(O)}sendResume(){const O=new o(8,0,0,v());this.p.write(O)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(O,N){this.a=!0,this.t.dispose(),this.t=new C.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=O,this.p=this.t.add(new p(this.o)),this.q=this.t.add(new u(this.o)),this.t.add(this.q.onMessage(K=>this.E(K))),this.t.add(this.o.onClose(K=>this.A.fire(K))),this.r=this.t.add(new S),this.t.add(this.r.onSendLatencyRequest(K=>this.J(K))),this.t.add(this.r.onHighRoundTripTime(K=>this.C.fire(K))),this.t.add(this.r.onDidChangeConnectionHealth(K=>this.D.fire(K))),this.q.acceptChunk(N)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const O=new o(3,0,this.h,v());this.p.write(O);const N=this.b.toArray();for(let K=0,V=N.length;K<V;K++)this.p.write(N[K]);this.G()}acceptDisconnect(){this.z.fire()}E(O){if(O.ack>this.d){this.d=O.ack;do{const N=this.b.peek();if(N&&N.id<=O.ack)this.b.pop();else break}while(!0)}switch(O.type){case 0:break;case 1:{if(O.id>this.g)if(O.id!==this.g+1){const N=Date.now();N-this.m>1e4&&(this.m=N,this.p.write(new o(6,0,0,v())))}else this.g=O.id,this.j=Date.now(),this.F(),this.y.fire(O.data);break}case 2:{this.x.fire(O.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const N=this.b.toArray();for(let K=0,V=N.length;K<V;K++)this.p.write(N[K]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(O.data);break}case 11:{this.r.handleResponse(O.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(O){const N=++this.c;this.h=this.g;const K=new o(1,N,this.h,O);this.b.push(K),this.a||(this.p.write(K),this.G())}sendControl(O){const N=new o(2,0,0,O);this.p.write(N)}F(){if(this.g<=this.h||this.k)return;const O=Date.now()-this.j;if(O>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-O+5)}G(){if(this.c<=this.d||this.f||this.a)return;const O=this.b.peek(),N=Date.now()-O.writtenTime,K=Date.now()-this.q.lastReadTime,V=Date.now()-this.n;if(N>=2e4&&K>=2e4&&V>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:N,timeSinceLastReceivedSomeData:K});return}const X=Math.max(2e4-N,2e4-K,2e4-V,500);this.f=setTimeout(()=>{this.f=null,this.G()},X)}H(){if(this.g<=this.h)return;this.h=this.g;const O=new o(3,0,this.h,v());this.p.write(O)}I(){this.h=this.g;const O=new o(9,0,this.h,v());this.p.write(O)}J(O){this.h=this.g;const N=new o(10,0,this.h,O);this.p.write(N)}K(O){this.h=this.g;const N=new o(11,0,this.h,O);this.p.write(N)}}e.PersistentProtocol=d;class S extends C.Disposable{constructor(){super(),this.a=this.B(new n.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new n.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new n.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new I.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},O=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const O=++this.h,N=A.VSBuffer.alloc(4);N.writeUInt32BE(O,0),this.a.fire(N)},6e4)}handleResponse(O){if(O.byteLength!==4)return;const N=O.readUInt32BE(0);if(this.g<=0||N!==this.h)return;const K=Date.now()-this.g,V=this.k++;this.j[V%this.j.length]=K;const X=this.l,ie=this.j.filter(re=>re>=1e3).length;this.l=ie>=3?1:0,K>1e3&&this.b.fire(new s(K,ie)),X!==this.l&&this.c.fire(this.l)}}}),define(ee[150],te([0,1,42,17,3,2,47,135]),function(G,e,I,A,n,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function f(b,v){const y=n.Event.fromNodeEventEmitter(I.validatedIpcMain,v,(m,w)=>({event:m,message:w})),g=n.Event.filter(y,({event:m})=>m.sender.id===b);return n.Event.map(g,({message:m})=>m&&A.VSBuffer.wrap(m))}class h extends D.IPCServer{static d(){const v=n.Event.fromNodeEventEmitter(I.validatedIpcMain,"vscode:hello",({sender:y})=>y);return n.Event.map(v,y=>{const g=y.id;h.b.get(g)?.dispose();const w=new n.Emitter;h.b.set(g,(0,C.toDisposable)(()=>w.fire()));const o=f(g,"vscode:message"),u=n.Event.any(n.Event.signal(f(g,"vscode:disconnect")),w.event);return{protocol:new P.Protocol(y,o),onDidClientDisconnect:u}})}constructor(){super(h.d())}}e.Server=h,h.b=new Map}),define(ee[105],te([0,1,42,3,31,149]),function(G,e,I,A,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class D extends C.Client{constructor(h,b){super({addEventListener:(v,y)=>h.addListener(v,y),removeEventListener:(v,y)=>h.removeListener(v,y),postMessage:v=>h.postMessage(v),start:()=>h.start(),close:()=>h.close()},b)}}e.Client=D;async function P(f){if(f.isDestroyed()||f.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const h=(0,n.generateUuid)();f.webContents.send("vscode:createMessageChannel",h);const b=A.Event.fromNodeEventEmitter(I.validatedIpcMain,"vscode:createMessageChannelResult",(y,g)=>({nonce:g,port:y.ports[0]})),{port:v}=await A.Event.toPromise(A.Event.once(A.Event.filter(b,y=>y.nonce===h)));return v}e.connect=P}),define(ee[151],te([0,1,46,8,17,22,144,13,3,2,40,86,83,47]),function(G,e,I,A,n,C,D,P,f,h,b,v,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class m extends g.ChannelServer{constructor(u){super({send:p=>{try{process.send?.(p.buffer.toString("base64"))}catch{}},onMessage:f.Event.fromNodeEventEmitter(process,"message",p=>n.VSBuffer.wrap(Buffer.from(p,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.Server=m;class w{constructor(u,p){this.i=u,this.j=p,this.c=new Set,this.g=new Map,this.h=new f.Emitter,this.onDidProcessExit=this.h.event;const k=p&&p.timeout?p.timeout:6e4;this.b=new A.Delayer(k),this.d=null,this.f=null}getChannel(u){const p=this;return{call(k,E,M){return p.k(u,k,E,M)},listen(k,E){return p.l(u,k,E)}}}k(u,p,k,E=C.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(E.isCancellationRequested)return Promise.reject(P.canceled());this.b.cancel();const M=this.n(u),t=(0,A.createCancelablePromise)(r=>M.call(p,k,r)),a=E.onCancellationRequested(()=>t.cancel()),i=(0,h.toDisposable)(()=>t.cancel());return this.c.add(i),t.finally(()=>{a.dispose(),this.c.delete(i),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(u,p,k){if(!this.b)return f.Event.None;this.b.cancel();let E;const M=new f.Emitter({onWillAddFirstListener:()=>{E=this.n(u).listen(p,k)(M.fire,M),this.c.add(E)},onDidRemoveLastListener:()=>{this.c.delete(E),E.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return M.event}get m(){if(!this.f){const u=this.j&&this.j.args?this.j.args:[],p=Object.create(null);p.env={...(0,b.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(p.env={...p.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(p.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(c=>!/^--inspect(-brk)?=/.test(c))),(0,y.removeDangerousEnvVariables)(p.env),this.d=(0,I.fork)(this.i,u,p);const k=new f.Emitter;f.Event.fromNodeEventEmitter(this.d,"message",c=>c)(c=>{if((0,D.isRemoteConsoleLog)(c)){(0,D.log)(c,`IPC Library: ${this.j.serverName}`);return}k.fire(n.VSBuffer.wrap(Buffer.from(c,"base64")))});const M=this.j.useQueue?(0,v.createQueuedSender)(this.d):this.d,t=c=>this.d&&this.d.connected&&M.send(c.buffer.toString("base64")),a=k.event,i={send:t,onMessage:a};this.f=new g.ChannelClient(i);const r=()=>this.o();process.once("exit",r),this.d.on("error",c=>console.warn('IPC "'+this.j.serverName+'" errored with '+c)),this.d.on("exit",(c,l)=>{process.removeListener("exit",r),this.c.forEach(s=>(0,h.dispose)(s)),this.c.clear(),c!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+c+" and signal "+l),this.b?.cancel(),this.o(),this.h.fire({code:c,signal:l})})}return this.f}n(u){let p=this.g.get(u);return p||(p=this.m.getChannel(u),this.g.set(u,p)),p}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=w}),define(ee[87],te([0,1,17,13,3,2,9,4,31,47,104]),function(G,e,I,A,n,C,D,P,f,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function v(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class y{traceSocketEvent(s,d){b.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,s,d)}constructor(s,d=""){this.f=!0,this.debugLabel=d,this.socket=s,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=S=>{if(this.traceSocketEvent("error",{code:S?.code,message:S?.message}),S){if(S.code==="EPIPE")return;(0,A.onUnexpectedError)(S)}},this.socket.on("error",this.a),this.b=S=>{this.traceSocketEvent("close",{hadError:S}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(s){const d=S=>{this.traceSocketEvent("read",S),s(I.VSBuffer.wrap(S))};return this.socket.on("data",d),{dispose:()=>this.socket.off("data",d)}}onClose(s){const d=S=>{s({type:0,hadError:S,error:void 0})};return this.socket.on("close",d),{dispose:()=>this.socket.off("close",d)}}onEnd(s){const d=()=>{s()};return this.socket.on("end",d),{dispose:()=>this.socket.off("end",d)}}write(s){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",s),this.socket.write(s.buffer,d=>{if(d){if(d.code==="EPIPE")return;(0,A.onUnexpectedError)(d)}})}catch(d){if(d.code==="EPIPE")return;(0,A.onUnexpectedError)(d)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((s,d)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),s();return}const S=()=>{this.socket.off("close",S),this.socket.off("end",S),this.socket.off("error",S),this.socket.off("timeout",S),this.socket.off("drain",S),this.traceSocketEvent("nodeDrainEnd"),s()};this.socket.on("close",S),this.socket.on("end",S),this.socket.on("error",S),this.socket.on("timeout",S),this.socket.on("drain",S)})}}e.NodeSocket=y;var g;(function(l){l[l.MinHeaderByteSize=2]="MinHeaderByteSize"})(g||(g={}));var m;(function(l){l[l.PeekHeader=1]="PeekHeader",l[l.ReadHeader=2]="ReadHeader",l[l.ReadBody=3]="ReadBody",l[l.Fin=4]="Fin"})(m||(m={}));class w extends C.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(s,d){this.socket.traceSocketEvent(s,d)}constructor(s,d,S,R){super(),this.f=this.B(new n.Emitter),this.g=this.B(new n.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=s,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:d,inflateBytesLength:S?.byteLength||0,recordInflateBytes:R}),this.a=this.B(new o(this,d,S,R,this.f,(O,N)=>this.k(O,N))),this.B(this.a.onError(O=>{console.error(O),(0,A.onUnexpectedError)(O),this.g.fire({type:0,hadError:!0,error:O})})),this.b=new b.ChunkStream,this.B(this.socket.onData(O=>this.l(O))),this.B(this.socket.onClose(O=>this.g.fire(O)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(s){return this.f.event(s)}onClose(s){return this.g.event(s)}onEnd(s){return this.socket.onEnd(s)}write(s){this.a.writeMessage(s)}k(s,d){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",s);let S=2;s.byteLength<126?S+=0:s.byteLength<2**16?S+=2:S+=8;const R=I.VSBuffer.alloc(S);if(d?R.writeUInt8(194,0):R.writeUInt8(130,0),s.byteLength<126)R.writeUInt8(s.byteLength,1);else if(s.byteLength<2**16){R.writeUInt8(126,1);let O=1;R.writeUInt8(s.byteLength>>>8&255,++O),R.writeUInt8(s.byteLength>>>0&255,++O)}else{R.writeUInt8(127,1);let O=1;R.writeUInt8(0,++O),R.writeUInt8(0,++O),R.writeUInt8(0,++O),R.writeUInt8(0,++O),R.writeUInt8(s.byteLength>>>24&255,++O),R.writeUInt8(s.byteLength>>>16&255,++O),R.writeUInt8(s.byteLength>>>8&255,++O),R.writeUInt8(s.byteLength>>>0&255,++O)}this.socket.write(I.VSBuffer.concat([R,s]))}end(){this.h=!0,this.socket.end()}l(s){if(s.byteLength!==0){for(this.b.acceptChunk(s);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const d=this.b.peek(this.j.readLen),S=d.readUInt8(0),R=(S&128)>>>7,O=(S&64)>>>6,N=d.readUInt8(1),K=(N&128)>>>7,V=N&127;this.j.state=2,this.j.readLen=2+(K?4:0)+(V===126?2:0)+(V===127?8:0),this.j.fin=R,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(O)),this.j.firstFrameOfMessage=Boolean(R),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const d=this.b.read(this.j.readLen),S=d.readUInt8(1),R=(S&128)>>>7;let O=S&127,N=1;O===126?O=d.readUInt8(++N)*2**8+d.readUInt8(++N):O===127&&(O=d.readUInt8(++N)*0+d.readUInt8(++N)*0+d.readUInt8(++N)*0+d.readUInt8(++N)*0+d.readUInt8(++N)*2**24+d.readUInt8(++N)*2**16+d.readUInt8(++N)*2**8+d.readUInt8(++N));let K=0;R&&(K=d.readUInt8(++N)*2**24+d.readUInt8(++N)*2**16+d.readUInt8(++N)*2**8+d.readUInt8(++N)),this.j.state=3,this.j.readLen=O,this.j.mask=K,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const d=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",d),k(d,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",d),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(d,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await n.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=w;class o extends C.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:I.VSBuffer.alloc(0)}constructor(s,d,S,R,O,N){super(),this.k=s,this.l=O,this.m=N,this.a=this.B(new n.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new n.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,d?(this.b=this.B(new u(this.k,R,S,{windowBits:15})),this.f=this.B(new p(this.k,{windowBits:15})),this.B(this.b.onError(K=>this.a.fire(K))),this.B(this.f.onError(K=>this.a.fire(K)))):(this.b=null,this.f=null)}writeMessage(s){this.g.push(s),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const s=this.g.shift();if(this.f){const d=await this.r(this.f,s);this.m(d,!0)}else this.m(s,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(s,d){return new Promise((S,R)=>{s.write(d),s.flush(O=>S(O))})}acceptFrame(s,d,S){this.h.push({data:s,isCompressed:d,isLastFrameOfMessage:S}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const s=this.h.shift();if(this.b&&s.isCompressed){const d=await this.u(this.b,s.data,s.isLastFrameOfMessage);this.l.fire(d)}else this.l.fire(s.data)}this.s=!1}}u(s,d,S){return new Promise((R,O)=>{s.write(d),S&&s.write(I.VSBuffer.fromByteArray([0,0,255,255])),s.flush(N=>R(N))})}}class u extends C.Disposable{get recordedInflateBytes(){return this.j?I.VSBuffer.concat(this.f):I.VSBuffer.alloc(0)}constructor(s,d,S,R){super(),this.h=s,this.j=d,this.a=this.B(new n.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=v().zlib.createInflateRaw(R),this.b.on("error",O=>{this.h.traceSocketEvent("zlibInflateError",{message:O?.message,code:O?.code}),this.a.fire(O)}),this.b.on("data",O=>{this.h.traceSocketEvent("zlibInflateData",O),this.g.push(I.VSBuffer.wrap(O))}),S&&(this.h.traceSocketEvent("zlibInflateInitialWrite",S.buffer),this.b.write(S.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(s){this.j&&this.f.push(s.clone()),this.h.traceSocketEvent("zlibInflateWrite",s),this.b.write(s.buffer)}flush(s){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const d=I.VSBuffer.concat(this.g);this.g.length=0,s(d)})}}class p extends C.Disposable{constructor(s,d){super(),this.g=s,this.a=this.B(new n.Emitter),this.onError=this.a.event,this.f=[],this.b=v().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",S=>{this.g.traceSocketEvent("zlibDeflateError",{message:S?.message,code:S?.code}),this.a.fire(S)}),this.b.on("data",S=>{this.g.traceSocketEvent("zlibDeflateData",S),this.f.push(I.VSBuffer.wrap(S))})}write(s){this.g.traceSocketEvent("zlibDeflateWrite",s.buffer),this.b.write(s.buffer)}flush(s){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let d=I.VSBuffer.concat(this.f);this.f.length=0,d=d.slice(0,d.byteLength-4),s(d)})}}function k(l,s){if(s===0)return;const d=l.byteLength>>>2;for(let V=0;V<d;V++){const X=l.readUInt32BE(V*4);l.writeUInt32BE(X^s,V*4)}const S=d*4,R=l.byteLength-S,O=s>>>24&255,N=s>>>16&255,K=s>>>8&255;R>=1&&l.writeUInt8(l.readUInt8(S)^O,S),R>=2&&l.writeUInt8(l.readUInt8(S+1)^N,S+1),R>=3&&l.writeUInt8(l.readUInt8(S+2)^K,S+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const E={[2]:107,[1]:103};function M(){const l=(0,f.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${l}-sock`;let s;return e.XDG_RUNTIME_DIR?s=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${l}.sock`):s=(0,D.join)(v().os.tmpdir(),`vscode-ipc-${l}.sock`),a(s),s}e.createRandomIPCHandle=M;function t(l,s,d){const S=v().crypto.createHash("md5").update(l).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${S}-${d}-${s}-sock`;let R;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?R=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-${S.substr(0,8)}-${d}-${s}.sock`):R=(0,D.join)(l,`${d}-${s}.sock`),a(R),R}e.createStaticIPCHandle=t;function a(l){const s=E[P.platform];typeof s=="number"&&l.length>=s&&console.warn(`WARNING: IPC handle "${l}" is longer than ${s} chars, try a shorter --user-data-dir`)}class i extends h.IPCServer{static b(s){const d=n.Event.fromNodeEventEmitter(s,"connection");return n.Event.map(d,S=>({protocol:new b.Protocol(new y(S,"ipc-server-connection")),onDidClientDisconnect:n.Event.once(n.Event.fromNodeEventEmitter(S,"close"))}))}constructor(s){super(i.b(s)),this.d=s}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=i;function r(l){return new Promise((s,d)=>{const S=v().net.createServer();S.on("error",d),S.listen(l,()=>{S.removeListener("error",d),s(new i(S))})})}e.serve=r;function c(l,s){return new Promise((d,S)=>{const R=v().net.createConnection(l,()=>{R.removeListener("error",S),d(b.Client.fromSocket(new y(R,`ipc-client${s}`),s))});R.once("error",S)})}e.connect=c}),define(ee[106],te([0,1,8,3,2,10]),function(G,e,I,A,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var D;(function(v){v[v.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",v[v.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(D=e.StorageHint||(e.StorageHint={}));function P(v){const y=v;return y?.changed instanceof Map||y?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var f;(function(v){v[v.None=0]="None",v[v.Initialized=1]="Initialized",v[v.Closed=2]="Closed"})(f=e.StorageState||(e.StorageState={}));class h extends n.Disposable{constructor(y,g=Object.create(null)){super(),this.m=y,this.n=g,this.b=this.B(new A.Emitter),this.onDidChangeStorage=this.b.event,this.c=f.None,this.f=new Map,this.g=new I.ThrottledDelayer(h.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(y=>this.r(y)))}r(y){y.changed?.forEach((g,m)=>this.s(m,g)),y.deleted?.forEach(g=>this.s(g,void 0))}s(y,g){if(this.c===f.Closed)return;let m=!1;(0,C.isUndefinedOrNull)(g)?m=this.f.delete(y):this.f.get(y)!==g&&(this.f.set(y,g),m=!0),m&&this.b.fire(y)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===f.None&&(this.c=f.Initialized,this.n.hint!==D.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(y,g){const m=this.f.get(y);return(0,C.isUndefinedOrNull)(m)?g:m}getBoolean(y,g){const m=this.get(y);return(0,C.isUndefinedOrNull)(m)?g:m==="true"}getNumber(y,g){const m=this.get(y);return(0,C.isUndefinedOrNull)(m)?g:parseInt(m,10)}async set(y,g){if(this.c===f.Closed)return;if((0,C.isUndefinedOrNull)(g))return this.delete(y);const m=String(g);if(this.f.get(y)!==m)return this.f.set(y,m),this.j.set(y,m),this.h.delete(y),this.b.fire(y),this.w()}async delete(y){if(!(this.c===f.Closed||!this.f.delete(y)))return this.h.has(y)||this.h.add(y),this.j.delete(y),this.b.fire(y),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=f.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const y={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(y).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(y){if(!!this.u)return this.w(y)}async w(y){return this.g.trigger(()=>this.v(),y)}async whenFlushed(){if(!!this.u)return new Promise(y=>this.l.push(y))}isInMemory(){return this.n.hint===D.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.Storage=h,h.a=100;class b{constructor(){this.onDidChangeItemsExternal=A.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(y){y.insert?.forEach((g,m)=>this.a.set(m,g)),y.delete?.forEach(g=>this.a.delete(g))}async close(){}}e.InMemoryStorageDatabase=b}),define(ee[152],te([0,1,8,3,35,9,23]),function(G,e,I,A,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class P{get onDidChangeItemsExternal(){return A.Event.None}constructor(b,v=Object.create(null)){this.g=b,this.h=v,this.c=(0,C.basename)(this.g),this.d=new f(this.h.logging),this.f=this.n(this.g)}async getItems(){const b=await this.f,v=new Map;return(await this.s(b,"SELECT * FROM ItemTable")).forEach(g=>v.set(g.key,g.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${v.size} rows`),v}async updateItems(b){const v=await this.f;return this.j(v,b)}j(b,v){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${v.insert?(0,n.mapToString)(v.insert):"0"}), delete(${v.delete?(0,n.setToString)(v.delete):"0"})`),this.t(b,()=>{const y=v.insert,g=v.delete;if(y&&y.size>0){const m=[];m.push([]);let w=0;y.forEach((o,u)=>{let p=m[w];p.length>P.b&&(w++,p=[],m.push(p)),p.push(u,o)}),m.forEach(o=>{this.u(b,`INSERT INTO ItemTable VALUES ${new Array(o.length/2).fill("(?,?)").join(",")}`,u=>u.run(o),()=>{const u=[];let p=0;return y.forEach((k,E)=>{u.push(E),p+=k.length}),`Keys: ${u.join(", ")} Length: ${p}`})})}if(g&&g.size){const m=[];m.push([]);let w=0;g.forEach(o=>{let u=m[w];u.length>P.b&&(w++,u=[],m.push(u)),u.push(o)}),m.forEach(o=>{this.u(b,`DELETE FROM ItemTable WHERE key IN (${new Array(o.length).fill("?").join(",")})`,u=>u.run(o),()=>{const u=[];return g.forEach(p=>{u.push(p)}),`Keys: ${u.join(", ")}`})})}})}async close(b){this.d.trace(`[storage ${this.c}] close()`);const v=await this.f;return this.k(v,b)}k(b,v){return new Promise((y,g)=>{b.db.close(m=>(m&&this.o(b,`[storage ${this.c}] close(): ${m}`),this.g===P.IN_MEMORY_PATH?y():!b.isErroneous&&!b.isInMemory?this.l().then(y,w=>(this.d.error(`[storage ${this.c}] backup(): ${w}`),y())):typeof v=="function"?D.Promises.unlink(this.g).then(()=>this.p(this.g).then(w=>{const o=()=>this.k(w,void 0);return this.j(w,{insert:v()}).then(()=>o(),u=>(o(),Promise.reject(u)))})).then(y,g):g(m||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const b=this.m(this.g);return D.Promises.copy(this.g,b,{preserveSymlinks:!1})}m(b){return`${b}.backup`}async checkIntegrity(b){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${b})`);const v=await this.f,y=await this.r(v,b?"PRAGMA integrity_check":"PRAGMA quick_check"),g=b?y.integrity_check:y.quick_check;return v.isErroneous?`${g} (last error: ${v.lastError})`:v.isInMemory?`${g} (in-memory!)`:g}async n(b,v=!0){this.d.trace(`[storage ${this.c}] open(${b}, retryOnBusy: ${v})`);try{return await this.p(b)}catch(y){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${y}`),y.code==="SQLITE_BUSY"&&v)return await(0,I.timeout)(P.a),this.n(b,!1);try{await D.Promises.unlink(b);try{await D.Promises.rename(this.m(b),b)}catch{}return await this.p(b)}catch(g){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${g}`),this.p(P.IN_MEMORY_PATH)}}}o(b,v){b.isErroneous=!0,b.lastError=v,this.d.error(v)}p(b){return new Promise((v,y)=>{new Promise((g,m)=>{G(["@vscode/sqlite3"],g,m)}).then(g=>{const m={db:new(this.d.isTracing?g.verbose().Database:g.Database)(b,w=>w?m.db&&w.code!=="SQLITE_CANTOPEN"?m.db.close(()=>y(w)):y(w):this.q(m,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>v(m),o=>m.db.close(()=>y(o)))),isInMemory:b===P.IN_MEMORY_PATH};m.db.on("error",w=>this.o(m,`[storage ${this.c}] Error (event): ${w}`)),this.d.isTracing&&m.db.on("trace",w=>this.d.trace(`[storage ${this.c}] Trace (event): ${w}`))},y)})}q(b,v){return new Promise((y,g)=>{b.db.exec(v,m=>m?(this.o(b,`[storage ${this.c}] exec(): ${m}`),g(m)):y())})}r(b,v){return new Promise((y,g)=>{b.db.get(v,(m,w)=>m?(this.o(b,`[storage ${this.c}] get(): ${m}`),g(m)):y(w))})}s(b,v){return new Promise((y,g)=>{b.db.all(v,(m,w)=>m?(this.o(b,`[storage ${this.c}] all(): ${m}`),g(m)):y(w))})}t(b,v){return new Promise((y,g)=>{b.db.serialize(()=>{b.db.run("BEGIN TRANSACTION"),v(),b.db.run("END TRANSACTION",m=>m?(this.o(b,`[storage ${this.c}] transaction(): ${m}`),g(m)):y())})})}u(b,v,y,g){const m=b.db.prepare(v),w=o=>{this.o(b,`[storage ${this.c}] prepare(): ${o} (${v}). Details: ${g()}`)};m.on("error",w),y(m),m.finalize(o=>{o&&w(o),m.removeListener("error",w)})}}e.SQLiteStorageDatabase=P,P.IN_MEMORY_PATH=":memory:",P.a=2e3,P.b=256;class f{constructor(b){b&&typeof b.logTrace=="function"&&process.env[f.VSCODE_TRACE_STORAGE]&&(this.a=b.logTrace),b&&typeof b.logError=="function"&&(this.b=b.logError)}get isTracing(){return!!this.a}trace(b){this.a?.(b)}error(b){this.b?.(b)}}f.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(ee[153],te([12,11]),function(G,e){return G.create("vs/code/electron-main/app",e)}),define(ee[154],te([12,11]),function(G,e){return G.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ee[155],te([12,11]),function(G,e){return G.create("vs/platform/dialogs/common/dialogs",e)}),define(ee[156],te([12,11]),function(G,e){return G.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(ee[157],te([12,11]),function(G,e){return G.create("vs/platform/environment/node/argv",e)}),define(ee[158],te([12,11]),function(G,e){return G.create("vs/platform/environment/node/argvHelper",e)}),define(ee[159],te([12,11]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ee[160],te([12,11]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ee[161],te([12,11]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ee[162],te([12,11]),function(G,e){return G.create("vs/platform/extensions/common/extensionValidator",e)}),define(ee[163],te([12,11]),function(G,e){return G.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ee[164],te([12,11]),function(G,e){return G.create("vs/platform/files/common/fileService",e)}),define(ee[165],te([12,11]),function(G,e){return G.create("vs/platform/files/common/files",e)}),define(ee[166],te([12,11]),function(G,e){return G.create("vs/platform/files/common/io",e)}),define(ee[167],te([12,11]),function(G,e){return G.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(ee[168],te([12,11]),function(G,e){return G.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ee[169],te([12,11]),function(G,e){return G.create("vs/platform/issue/electron-main/issueMainService",e)}),define(ee[170],te([12,11]),function(G,e){return G.create("vs/platform/menubar/electron-main/menubar",e)}),define(ee[171],te([12,11]),function(G,e){return G.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(ee[172],te([12,11]),function(G,e){return G.create("vs/platform/request/common/request",e)}),define(ee[173],te([12,11]),function(G,e){return G.create("vs/platform/shell/node/shellEnv",e)}),define(ee[174],te([12,11]),function(G,e){return G.create("vs/platform/telemetry/common/telemetryService",e)}),define(ee[175],te([12,11]),function(G,e){return G.create("vs/platform/update/common/update.config.contribution",e)}),define(ee[176],te([12,11]),function(G,e){return G.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ee[177],te([12,11]),function(G,e){return G.create("vs/platform/windows/electron-main/windowImpl",e)}),define(ee[178],te([12,11]),function(G,e){return G.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(ee[179],te([12,11]),function(G,e){return G.create("vs/platform/workspace/common/workspace",e)}),define(ee[180],te([12,11]),function(G,e){return G.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(ee[181],te([12,11]),function(G,e){return G.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(ee[182],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function I(n){return n&&n.hasOwnProperty("folderUri")}e.isFolderBackupInfo=I;function A(n){return n&&n.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=A}),define(ee[183],te([0,1,7]),function(G,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeFolderInfos=e.deserializeWorkspaceInfos=e.isEmptyWindowBackupInfo=void 0;function A(D){return typeof D?.backupFolder=="string"}e.isEmptyWindowBackupInfo=A;function n(D){let P=[];try{Array.isArray(D.workspaces)&&(P=D.workspaces.map(f=>({workspace:{id:f.id,configPath:I.URI.parse(f.configURIPath)},remoteAuthority:f.remoteAuthority})))}catch{}return P}e.deserializeWorkspaceInfos=n;function C(D){let P=[];try{Array.isArray(D.folders)&&(P=D.folders.map(f=>({folderUri:I.URI.parse(f.folderUri),remoteAuthority:f.remoteAuthority})))}catch{}return P}e.deserializeFolderInfos=C}),define(ee[184],te([0,1,3,2]),function(G,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class n{constructor(){this.a=new I.Emitter,this.b=new I.Emitter,this.c=new I.Emitter,this.d=new I.Emitter}call(P,f,h){switch(f){case"close":return Promise.resolve(this.a.fire({sessionId:h[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:h[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:h[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:h[0],port:h[1],subId:h[2]}))}throw new Error("Method not implemented.")}listen(P,f,h){switch(f){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=n,n.ChannelName="extensionhostdebugservice";class C extends A.Disposable{constructor(P){super(),this.b=P}reload(P){this.b.call("reload",[P])}get onReload(){return this.b.listen("reload")}close(P){this.b.call("close",[P])}get onClose(){return this.b.listen("close")}attachSession(P,f,h){this.b.call("attach",[P,f,h])}get onAttachSession(){return this.b.listen("attach")}terminateSession(P,f){this.b.call("terminate",[P,f])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(P,f){return this.b.call("openExtensionDevelopmentHostWindow",[P,f])}}e.ExtensionHostDebugChannelClient=C}),define(ee[185],te([0,1,138,55,15,9,36,18,7]),function(G,e,I,A,n,C,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class h{get appRoot(){return(0,C.dirname)(n.FileAccess.asFileUri("").fsPath)}get userHome(){return f.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return f.URI.file((0,C.join)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.b.tmpDir)}get cacheHome(){return f.URI.file(this.userDataPath)}get stateResource(){return(0,P.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const m=(0,I.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,C.join)(this.userDataPath,"logs",m)}return this.args.logsPath}get userDataSyncLogResource(){return f.URI.file((0,C.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return f.URI.file((0,C.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(f.URI.file((0,C.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const m=D.env.VSCODE_PORTABLE;return m?f.URI.file((0,C.join)(m,"argv.json")):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,C.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,C.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const m=this.args["builtin-extensions-dir"];return m?(0,C.resolve)(m):(0,C.normalize)((0,C.join)(n.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const m=this.args["extensions-download-dir"];return m?f.URI.file((0,C.resolve)(m)):f.URI.file((0,C.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const m=this.args["extensions-dir"];if(m)return(0,C.resolve)(m);const w=D.env.VSCODE_EXTENSIONS;if(w)return w;const o=D.env.VSCODE_PORTABLE;return o?(0,C.join)(o,"extensions"):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const m=this.args.extensionDevelopmentPath;if(Array.isArray(m))return m.map(w=>/^[^:/?#]+?:\/\//.test(w)?f.URI.parse(w):f.URI.file((0,C.normalize)(w)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(m=>m==="ui"||m==="workspace"||m==="web"?m:"workspace")}get extensionTestsLocationURI(){const m=this.args.extensionTestsPath;if(m)return/^[^:/?#]+?:\/\//.test(m)?f.URI.parse(m):f.URI.file((0,C.normalize)(m))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const m=this.args["disable-extension"];if(m){if(typeof m=="string")return[m];if(Array.isArray(m)&&m.length>0)return m}return!1}get debugExtensionHost(){return b(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(m=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(m))}get extensionLogLevel(){const m=[];for(const w of this.args.log||[]){const o=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(w);o&&o[1]&&o[2]&&m.push([o[1],o[2]])}return m.length?m:void 0}get serviceMachineIdResource(){return(0,P.joinPath)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return f.URI.file((0,C.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const m=D.env.VSCODE_PORTABLE;return m?f.URI.file((0,C.join)(m,"policy.json")):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(m){this.args.continueOn=m}get args(){return this.a}constructor(m,w,o){this.a=m,this.b=w,this.c=o,this.editSessionId=this.args.editSessionId}}ve([A.memoize],h.prototype,"appRoot",null),ve([A.memoize],h.prototype,"userHome",null),ve([A.memoize],h.prototype,"userDataPath",null),ve([A.memoize],h.prototype,"appSettingsHome",null),ve([A.memoize],h.prototype,"tmpDir",null),ve([A.memoize],h.prototype,"cacheHome",null),ve([A.memoize],h.prototype,"stateResource",null),ve([A.memoize],h.prototype,"userRoamingDataHome",null),ve([A.memoize],h.prototype,"userDataSyncHome",null),ve([A.memoize],h.prototype,"userDataSyncLogResource",null),ve([A.memoize],h.prototype,"editSessionsLogResource",null),ve([A.memoize],h.prototype,"sync",null),ve([A.memoize],h.prototype,"machineSettingsResource",null),ve([A.memoize],h.prototype,"workspaceStorageHome",null),ve([A.memoize],h.prototype,"localHistoryHome",null),ve([A.memoize],h.prototype,"keyboardLayoutResource",null),ve([A.memoize],h.prototype,"argvResource",null),ve([A.memoize],h.prototype,"isExtensionDevelopment",null),ve([A.memoize],h.prototype,"untitledWorkspacesHome",null),ve([A.memoize],h.prototype,"installSourcePath",null),ve([A.memoize],h.prototype,"builtinExtensionsPath",null),ve([A.memoize],h.prototype,"extensionsPath",null),ve([A.memoize],h.prototype,"extensionDevelopmentLocationURI",null),ve([A.memoize],h.prototype,"extensionDevelopmentKind",null),ve([A.memoize],h.prototype,"extensionTestsLocationURI",null),ve([A.memoize],h.prototype,"debugExtensionHost",null),ve([A.memoize],h.prototype,"logLevel",null),ve([A.memoize],h.prototype,"extensionLogLevel",null),ve([A.memoize],h.prototype,"serviceMachineIdResource",null),ve([A.memoize],h.prototype,"telemetryLogResource",null),ve([A.memoize],h.prototype,"disableWorkspaceTrust",null),ve([A.memoize],h.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=h;function b(g,m){return y(g["inspect-extensions"],g["inspect-brk-extensions"],5870,m,g.debugId,g.extensionEnvironment)}e.parseExtensionHostPort=b;function v(g,m){return y(g["inspect-ptyhost"],g["inspect-brk-ptyhost"],5877,m,g.extensionEnvironment)}e.parsePtyHostPort=v;function y(g,m,w,o,u,p){const E=Number(m||g)||(o?null:w),M=E?Boolean(!!m):!1;let t;if(p)try{t=JSON.parse(p)}catch{}return{port:E,break:M,debugId:u,env:t}}}),define(ee[107],te([0,1,287,4,157]),function(G,e,I,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const C={o:(0,n.localize)(0,null),e:(0,n.localize)(1,null),t:(0,n.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,n.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,n.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,n.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,n.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,n.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,n.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,n.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,n.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,n.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,n.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,n.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,n.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,n.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,n.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,n.localize)(17,null)},category:{type:"string",cat:"e",description:(0,n.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,n.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,n.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,n.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,n.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,n.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,n.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,n.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,n.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,n.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,n.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,n.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,n.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,n.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,n.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,n.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,n.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,n.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const D={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(w,o,u=D){const p=w.find(l=>l.length>0&&l[0]!=="-"),k={},E=["_"],M=[],t={};let a;for(const l in o){const s=o[l];s.type==="subcommand"?l===p&&(a=s):(s.alias&&(k[l]=s.alias),s.type==="string"||s.type==="string[]"?(E.push(l),s.deprecates&&E.push(...s.deprecates)):s.type==="boolean"&&(M.push(l),s.deprecates&&M.push(...s.deprecates)),s.global&&(t[l]=s))}if(a&&p){const l=t;for(const R in a.options)l[R]=a.options[R];const s=w.filter(R=>R!==p),d=u.getSubcommandReporter?u.getSubcommandReporter(p):void 0,S=P(s,l,d);return{[p]:S,_:[]}}const i=I(w,{string:E,boolean:M,alias:k}),r={},c=i;r._=i._.map(l=>String(l)).filter(l=>l.length>0),delete c._;for(const l in o){const s=o[l];if(s.type==="subcommand")continue;s.alias&&delete c[s.alias];let d=c[l];if(s.deprecates)for(const S of s.deprecates)c.hasOwnProperty(S)&&(d||(d=c[S],d&&u.onDeprecatedOption(S,s.deprecationMessage||(0,n.localize)(36,null,l))),delete c[S]);if(typeof d<"u"){if(s.type==="string[]"){if(Array.isArray(d)||(d=[d]),!s.allowEmptyValue){const S=d.filter(R=>R.length>0);S.length!==d.length&&(u.onEmptyValue(l),d=S.length>0?S:void 0)}}else s.type==="string"&&(Array.isArray(d)?(d=d.pop(),u.onMultipleValues(l,d)):!d&&!s.allowEmptyValue&&(u.onEmptyValue(l),d=void 0));r[l]=d,s.deprecationMessage&&u.onDeprecatedOption(l,s.deprecationMessage)}delete c[l]}for(const l in c)u.onUnknownOption(l);return r}e.parseArgs=P;function f(w,o){let u="";return o.args&&(Array.isArray(o.args)?u=` <${o.args.join("> <")}>`:u=` <${o.args}>`),o.alias?`-${o.alias} --${w}${u}`:`--${w}${u}`}function h(w,o){const u=[];for(const p in w){const k=w[p],E=f(p,k);u.push([E,k.description])}return b(u,o)}e.formatOptions=h;function b(w,o){const p=w.reduce((M,t)=>Math.max(M,t[0].length),12)+2+1;if(o-p<25)return w.reduce((M,t)=>M.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const k=o-p-1,E=[];for(const M of w){const t=M[0],a=y(M[1],k),i=v(p-t.length-2);E.push("  "+t+i+a[0]);for(let r=1;r<a.length;r++)E.push(v(p)+a[r])}return E}function v(w){return" ".repeat(w)}function y(w,o){const u=[];for(;w.length;){const p=w.length<o?w.length:w.lastIndexOf(" ",o),k=w.slice(0,p).trim();w=w.slice(p),u.push(k)}return u}function g(w,o,u,p,k){const E=process.stdout.isTTY&&process.stdout.columns||80,M=k?.noInputFiles!==!0?`[${(0,n.localize)(37,null)}...]`:"",t=[`${w} ${u}`];t.push(""),t.push(`${(0,n.localize)(38,null)}: ${o} [${(0,n.localize)(39,null)}]${M}`),t.push(""),k?.noPipe!==!0&&(A.isWindows?t.push((0,n.localize)(40,null,o)):t.push((0,n.localize)(41,null,o)),t.push(""));const a={},i=[];for(const r in p){const c=p[r];if(c.type==="subcommand")c.description&&i.push({command:r,description:c.description});else if(c.description&&c.cat){let l=a[c.cat];l||(a[c.cat]=l={}),l[r]=c}}for(const r in a){const c=r,l=a[c];l&&(t.push(C[c]),t.push(...h(l,E)),t.push(""))}return i.length&&(t.push((0,n.localize)(42,null)),t.push(...b(i.map(r=>[r.command,r.description]),E)),t.push("")),t.join(`
`)}e.buildHelpMessage=g;function m(w,o){return`${w||(0,n.localize)(43,null)}
${o||(0,n.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=m}),define(ee[186],te([0,1,82,184,107]),function(G,e,I,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class C extends A.ExtensionHostDebugBroadcastChannel{constructor(P){super(),this.f=P}call(P,f,h){return f==="openExtensionDevelopmentHostWindow"?this.g(h[0],h[1]):super.call(P,f,h)}async g(P,f){const h=(0,n.parseArgs)(P,n.OPTIONS);h.debugRenderer=f;const b=h.extensionDevelopmentPath;if(!b)return{success:!1};const[v]=await this.f.openExtensionDevelopmentHostWindow(b,{context:5,cli:h,forceProfile:h.profile,forceTempProfile:h["profile-temp"]});if(!f)return{success:!0};const y=v.win;if(!y)return{success:!0};const g=y.webContents.debugger;let m=g.isAttached()?1/0:0;const w=(0,I.createServer)(o=>{m++===0&&g.attach();let u=!1;const p=M=>{u||o.write(JSON.stringify(M)+"\0")},k=(M,t,a,i)=>p({method:t,params:a,sessionId:i});y.on("close",()=>{g.removeListener("message",k),o.end(),u=!0}),g.addListener("message",k);let E=Buffer.alloc(0);o.on("data",M=>{E=Buffer.concat([E,M]);for(let t=E.indexOf(0);t!==-1;t=E.indexOf(0)){let a;try{const i=E.slice(0,t).toString("utf8");E=E.slice(t+1),a=JSON.parse(i)}catch(i){console.error("error reading cdp line",i)}g.sendCommand(a.method,a.params,a.sessionId).then(i=>p({id:a.id,sessionId:a.sessionId,result:i})).catch(i=>p({id:a.id,sessionId:a.sessionId,error:{code:0,message:i.message}}))}}),o.on("error",M=>{console.error("error on cdp pipe:",M)}),o.on("close",()=>{u=!0,--m===0&&g.detach()})});return await new Promise(o=>w.listen(0,o)),y.on("close",()=>w.close()),{rendererDebugPort:w.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=C}),define(ee[62],te([0,1,288,158,107]),function(G,e,I,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const C=2048;function D(y,g){const m=(E,M)=>{console.warn((0,A.localize)(0,null,E,M))},w=E=>{console.warn((0,A.localize)(1,null,E))},o=(E,M)=>{console.warn((0,A.localize)(2,null,E,M))},u=E=>({onUnknownOption:M=>{E!=="tunnel"&&console.warn((0,A.localize)(3,null,M,E))},onMultipleValues:m,onEmptyValue:w,onDeprecatedOption:o,getSubcommandReporter:E!=="tunnel"?u:void 0}),p={onUnknownOption:E=>{console.warn((0,A.localize)(4,null,E))},onMultipleValues:m,onEmptyValue:w,onDeprecatedOption:o,getSubcommandReporter:u},k=(0,n.parseArgs)(y,n.OPTIONS,g?p:void 0);return k.goto&&k._.forEach(E=>I(/^(\w:)?[^:]+(:\d*){0,2}$/.test(E),(0,A.localize)(5,null))),k["max-memory"]&&I(parseInt(k["max-memory"])>=C,`The max-memory argument cannot be specified lower than ${C} MB.`),k}function P(y){const g=y.findIndex(m=>!/^-/.test(m));if(g>-1)return[...y.slice(0,g),...y.slice(g+1)]}function f(y){let[,...g]=y;process.env.VSCODE_DEV&&(g=P(g)||[]);const m=!v(process.env);return D(g,m)}e.parseMainProcessArgv=f;function h(y){let[,,...g]=y;return process.env.VSCODE_DEV&&(g=P(g)||[]),D(g,!0)}e.parseCLIProcessArgv=h;function b(y,...g){const m=y.indexOf("--");return m===-1?y.push(...g):y.splice(m,0,...g),y}e.addArg=b;function v(y){return y.VSCODE_CLI==="1"}e.isLaunchedFromCli=v}),function(){"use strict";function G(e,I,A){function n(D,P){const f=C(D,P),h=[f];return e.isAbsolute(f)||h.unshift(A),e.resolve(...h)}function C(D,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let h=process.env.VSCODE_APPDATA;if(h)return e.join(h,P);const b=D["user-data-dir"];if(b)return b;switch(process.platform){case"win32":if(h=process.env.APPDATA,!h){const v=process.env.USERPROFILE;if(typeof v!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");h=e.join(v,"AppData","Roaming")}break;case"darwin":h=e.join(I.homedir(),"Library","Application Support");break;case"linux":h=process.env.XDG_CONFIG_HOME||e.join(I.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(h,P)}return{getUserDataPath:n}}if(typeof define=="function")define(ee[187],te([188,26,36]),function(e,I,A){return G(e,I,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),I=require("os");module.exports=G(e,I,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ee[189],te([0,1,26,185,187]),function(G,e,I,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class C extends A.AbstractNativeEnvironmentService{constructor(P,f){super(P,{homeDir:(0,I.homedir)(),tmpDir:(0,I.tmpdir)(),userDataDir:(0,n.getUserDataPath)(P,f.nameShort)},f)}}e.NativeEnvironmentService=C}),define(ee[190],te([0,1,41,26,32]),function(G,e,I,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=void 0;function C(D){const P=(0,n.randomPath)((0,A.tmpdir)());try{return(0,I.writeFileSync)(P,""),D&&console.log(`Marker file for --wait created: ${P}`),P}catch(f){D&&console.error(`Failed to create marker file for --wait: ${f}`);return}}e.createWaitMarkerFileSync=C}),define(ee[191],te([0,1,10,160]),function(G,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function n(D,P,f){try{C(D,P,f)}catch(h){console.error(h?.message??h)}return D}e.localizeManifest=n;function C(D,P,f){const h=(b,v,y)=>{const g=b[v];if((0,I.isString)(g)){const m=g,w=m.length;if(w>1&&m[0]==="%"&&m[w-1]==="%"){const o=m.substr(1,w-2);let u=P[o];u===void 0&&f&&(u=f[o]);const p=typeof u=="string"?u:u?.message,k=f?.[o],E=typeof k=="string"?k:k?.message;if(!p){E||console.warn(`[${D.name}]: ${(0,A.localize)(0,null,o)}`);return}if(y&&(v==="title"||v==="category")&&E&&E!==p){const M={value:p,original:E};b[v]=M}else b[v]=p}}else if((0,I.isObject)(g))for(const m in g)g.hasOwnProperty(m)&&(m==="commands"?h(g,m,!0):h(g,m,y));else if(Array.isArray(g))for(let m=0;m<g.length;m++)h(g,m,y)};for(const b in D)D.hasOwnProperty(b)&&h(D,b)}}),define(ee[192],te([0,1,13]),function(G,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class A{constructor(){this.a=new Map}register(C,D){this.a.set(C,D)}updateManifest(C){if(!(typeof C.main>"u"&&typeof C.browser>"u")&&(C.activationEvents===void 0&&Object.assign(C,{activationEvents:[]}),!(!Array.isArray(C.activationEvents)||!C.contributes)))for(const D in C.contributes){const P=this.a.get(D);if(!P)continue;const f=C.contributes[D],h=Array.isArray(f)?f:[f];try{P(h,C.activationEvents)}catch(b){(0,I.onUnexpectedError)(b)}}}}e.ImplicitActivationEventsImpl=A,e.ImplicitActivationEvents=new A}),define(ee[193],te([0,1,18,84,162,194]),function(G,e,I,A,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function f(u){return u=u.trim(),u==="*"||D.test(u)}e.isValidVersionStr=f;function h(u){if(!f(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const p=u.match(D);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=h;function b(u){if(!u)return null;const p=u.majorBase,k=u.majorMustEqual,E=u.minorBase;let M=u.minorMustEqual;const t=u.patchBase;let a=u.patchMustEqual;u.hasCaret&&(p===0||(M=!1),a=!1);let i=0;if(u.preRelease){const r=P.exec(u.preRelease);if(r){const[,c,l,s]=r;i=Date.UTC(Number(c),Number(l)-1,Number(s))}}return{majorBase:p,majorMustEqual:k,minorBase:E,minorMustEqual:M,patchBase:t,patchMustEqual:a,isMinimum:u.hasGreaterEquals,notBefore:i}}e.normalizeVersion=b;function v(u,p,k){let E;typeof u=="string"?E=b(h(u)):E=u;let M;p instanceof Date?M=p.getTime():typeof p=="string"&&(M=new Date(p).getTime());let t;if(typeof k=="string"?t=b(h(k)):t=k,!E||!t)return!1;const a=E.majorBase,i=E.minorBase,r=E.patchBase;let c=t.majorBase,l=t.minorBase,s=t.patchBase;const d=t.notBefore;let S=t.majorMustEqual,R=t.minorMustEqual,O=t.patchMustEqual;return t.isMinimum?a>c?!0:a<c?!1:i>l?!0:i<l||M&&M<d?!1:r>=s:(a===1&&c===0&&(!S||!R||!O)&&(c=1,l=0,s=0,S=!0,R=!1,O=!1),a<c?!1:a>c?!S:i<l?!1:i>l?!R:r<s?!1:r>s?!O:!(M&&M<d))}e.isValidVersion=v;function y(u,p,k,E,M){const t=[];if(typeof E.publisher<"u"&&typeof E.publisher!="string")return t.push([A.default.Error,n.localize(0,null)]),t;if(typeof E.name!="string")return t.push([A.default.Error,n.localize(1,null,"name")]),t;if(typeof E.version!="string")return t.push([A.default.Error,n.localize(2,null,"version")]),t;if(!E.engines)return t.push([A.default.Error,n.localize(3,null,"engines")]),t;if(typeof E.engines.vscode!="string")return t.push([A.default.Error,n.localize(4,null,"engines.vscode")]),t;if(typeof E.extensionDependencies<"u"&&!o(E.extensionDependencies))return t.push([A.default.Error,n.localize(5,null,"extensionDependencies")]),t;if(typeof E.activationEvents<"u"){if(!o(E.activationEvents))return t.push([A.default.Error,n.localize(6,null,"activationEvents")]),t;if(typeof E.main>"u"&&typeof E.browser>"u")return t.push([A.default.Error,n.localize(7,null,"activationEvents","main")]),t}if(typeof E.extensionKind<"u"&&typeof E.main>"u"&&t.push([A.default.Warning,n.localize(8,null,"extensionKind")]),typeof E.main<"u"){if(typeof E.main!="string")return t.push([A.default.Error,n.localize(9,null,"main")]),t;{const r=(0,I.joinPath)(k,E.main);(0,I.isEqualOrParent)(r,k)||t.push([A.default.Warning,n.localize(10,null,r.path,k.path)])}if(typeof E.activationEvents>"u")return t.push([A.default.Error,n.localize(11,null,"activationEvents","main")]),t}if(typeof E.browser<"u"){if(typeof E.browser!="string")return t.push([A.default.Error,n.localize(12,null,"browser")]),t;{const r=(0,I.joinPath)(k,E.browser);(0,I.isEqualOrParent)(r,k)||t.push([A.default.Warning,n.localize(13,null,r.path,k.path)])}if(typeof E.activationEvents>"u")return t.push([A.default.Error,n.localize(14,null,"activationEvents","browser")]),t}if(!C.valid(E.version))return t.push([A.default.Error,n.localize(15,null)]),t;const a=[];if(!g(u,p,E,M,a))for(const r of a)t.push([A.default.Error,r]);return t}e.validateExtensionManifest=y;function g(u,p,k,E,M){return E||typeof k.main>"u"&&typeof k.browser>"u"?!0:w(u,p,k.engines.vscode,M)}e.isValidExtensionVersion=g;function m(u,p,k){return u==="*"||w(p,k,u)}e.isEngineValid=m;function w(u,p,k,E=[]){const M=b(h(k));if(!M)return E.push(n.localize(16,null,k)),!1;if(M.majorBase===0){if(!M.majorMustEqual||!M.minorMustEqual)return E.push(n.localize(17,null,k)),!1}else if(!M.majorMustEqual)return E.push(n.localize(18,null,k)),!1;return v(u,p,M)?!0:(E.push(n.localize(19,null,u,k)),!1)}function o(u){if(!Array.isArray(u))return!1;for(let p=0,k=u.length;p<k;p++)if(typeof u[p]!="string")return!1;return!0}}),define(ee[195],te([0,1,17,31]),function(G,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function n(C,D,P){let f=P&&P.get("storage.serviceMachineId",-1)||null;if(f)return f;try{const b=(await D.readFile(C.serviceMachineIdResource)).value.toString();f=(0,A.isUUID)(b)?b:null}catch{f=null}if(!f){f=(0,A.generateUuid)();try{await D.writeFile(C.serviceMachineIdResource,I.VSBuffer.fromString(f))}catch{}}return P?.store("storage.serviceMachineId",f,-1,1),f}e.getServiceMachineId=n}),define(ee[74],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class I{constructor(n,C=[],D=!1){this.ctor=n,this.staticArguments=C,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=I}),define(ee[196],te([0,1,74]),function(G,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const A=[];var n;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(n=e.InstantiationType||(e.InstantiationType={}));function C(P,f,h){f instanceof I.SyncDescriptor||(f=new I.SyncDescriptor(f,[],Boolean(h))),A.push([P,f])}e.registerSingleton=C;function D(){return A}e.getSingletonServiceDescriptors=D}),define(ee[197],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class I{constructor(C,D){this.key=C,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.Node=I;class A{constructor(C){this.b=C,this.a=new Map}roots(){const C=[];for(const D of this.a.values())D.outgoing.size===0&&C.push(D);return C}insertEdge(C,D){const P=this.lookupOrInsertNode(C),f=this.lookupOrInsertNode(D);P.outgoing.set(f.key,f),f.incoming.set(P.key,P)}removeNode(C){const D=this.b(C);this.a.delete(D);for(const P of this.a.values())P.outgoing.delete(D),P.incoming.delete(D)}lookupOrInsertNode(C){const D=this.b(C);let P=this.a.get(D);return P||(P=new I(D,C),this.a.set(D,P)),P}lookup(C){return this.a.get(this.b(C))}isEmpty(){return this.a.size===0}toString(){const C=[];for(const[D,P]of this.a)C.push(`${D}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return C.join(`
`)}findCycleSlow(){for(const[C,D]of this.a){const P=new Set([C]),f=this.c(D,P);if(f)return f}}c(C,D){for(const[P,f]of C.outgoing){if(D.has(P))return[...D,P].join(" -> ");D.add(P);const h=this.c(f,D);if(h)return h;D.delete(P)}}}e.Graph=A}),define(ee[6],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var I;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function P(f){return f[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=P})(I=e._util||(e._util={})),e.IInstantiationService=n("instantiationService");function A(D,P,f){P[I.DI_TARGET]===P?P[I.DI_DEPENDENCIES].push({id:D,index:f}):(P[I.DI_DEPENDENCIES]=[{id:D,index:f}],P[I.DI_TARGET]=P)}function n(D){if(I.serviceIds.has(D))return I.serviceIds.get(D);const P=function(f,h,b){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(P,f,b)};return P.toString=()=>D,I.serviceIds.set(D,P),P}e.createDecorator=n;function C(D){return D}e.refineServiceDecorator=C}),define(ee[63],te([0,1,6]),function(G,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,I.createDecorator)("backupMainService")}),define(ee[19],te([0,1,10,7,6]),function(G,e,I,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,n.createDecorator)("configurationService");function C(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof A.URI)}e.isConfigurationOverrides=C;function D(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof A.URI)}e.isConfigurationUpdateOverrides=D;var P;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function f(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=f;function h(o,u){const p=Object.create(null);for(const k in o)b(p,k,o[k],u);return p}e.toValuesTree=h;function b(o,u,p,k){const E=u.split("."),M=E.pop();let t=o;for(let a=0;a<E.length;a++){const i=E[a];let r=t[i];switch(typeof r){case"undefined":r=t[i]=Object.create(null);break;case"object":break;default:k(`Ignoring ${u} as ${E.slice(0,a+1).join(".")} is ${JSON.stringify(r)}`);return}t=r}if(typeof t=="object"&&t!==null)try{t[M]=p}catch{k(`Ignoring ${u} as ${E.join(".")} is ${JSON.stringify(t)}`)}else k(`Ignoring ${u} as ${E.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=b;function v(o,u){const p=u.split(".");y(o,p)}e.removeFromValueTree=v;function y(o,u){const p=u.shift();if(u.length===0){delete o[p];return}if(Object.keys(o).indexOf(p)!==-1){const k=o[p];typeof k=="object"&&!Array.isArray(k)&&(y(k,u),Object.keys(k).length===0&&delete o[p])}}function g(o,u,p){function k(t,a){let i=t;for(const r of a){if(typeof i!="object"||i===null)return;i=i[r]}return i}const E=u.split("."),M=k(o,E);return typeof M>"u"?p:M}e.getConfigurationValue=g;function m(o,u,p){Object.keys(u).forEach(k=>{k!=="__proto__"&&(k in o?I.isObject(o[k])&&I.isObject(u[k])?m(o[k],u[k],p):p&&(o[k]=u[k]):o[k]=u[k])})}e.merge=m;function w(o){return o.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=w}),define(ee[75],te([0,1,6]),function(G,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,I.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,I.createDecorator)("credentialsMainService");class A{constructor(){this.a={}}async getPassword(C,D){return this.a[C]?.[D]??null}async setPassword(C,D,P){this.a[C]=this.a[C]??{},this.a[C][D]=P}async deletePassword(C,D){return this.a[C]?.[D]?(delete this.a[C][D],Object.keys(this.a[C]).length===0&&delete this.a[C],!0):!1}async findPassword(C){return JSON.stringify(this.a[C])??null}async findCredentials(C){const D=[];for(const P of Object.keys(this.a[C]||{}))D.push({account:P,password:this.a[C][P]});return D}async clear(){this.a={}}}e.InMemoryCredentialsProvider=A}),define(ee[88],te([0,1,6]),function(G,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,I.createDecorator)(e.ID);function A(C){return!!C.hostName&&!!C.errorMessage}e.isRemoteDiagnosticError=A;class n{async getPerformanceInfo(D,P){return{}}async getSystemInfo(D,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,P){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.NullDiagnosticsService=n}),define(ee[48],te([0,1,18,155,6,45,4,40]),function(G,e,I,A,n,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.massageMessageBoxOptions=e.getFileNamesMessage=e.ConfirmResult=e.IFileDialogService=e.IDialogService=void 0,e.IDialogService=(0,n.createDecorator)("dialogService"),e.IFileDialogService=(0,n.createDecorator)("fileDialogService");var f;(function(y){y[y.SAVE=0]="SAVE",y[y.DONT_SAVE=1]="DONT_SAVE",y[y.CANCEL=2]="CANCEL"})(f=e.ConfirmResult||(e.ConfirmResult={}));const h=10;function b(y){const g=[];return g.push(...y.slice(0,h).map(m=>typeof m=="string"?m:(0,I.basename)(m))),y.length>h&&(y.length-h===1?g.push((0,A.localize)(0,null)):g.push((0,A.localize)(1,null,y.length-h))),g.push(""),g.join(`
`)}e.getFileNamesMessage=b;function v(y,g){const m=(0,P.deepClone)(y);let w=(m.buttons??[]).map(k=>(0,C.mnemonicButtonLabel)(k)),o=(y.buttons||[]).map((k,E)=>E),u=0,p=m.cancelId??w.length-1;if(w.length>1)if(D.isLinux){const k=typeof p=="number"?w[p]:void 0;if(w=w.reverse(),o=o.reverse(),u=w.length-1,typeof k=="string"&&(p=w.indexOf(k),p!==w.length-2)){w.splice(p,1),w.splice(w.length-1,0,k);const E=o[p];o.splice(p,1),o.splice(o.length-1,0,E),p=w.length-2}}else if(D.isWindows){const k=typeof p=="number"?w[p]:void 0;if(typeof k=="string"&&(p=w.indexOf(k),p!==w.length-1)){w.splice(p,1),w.push(k);const E=o[p];o.splice(p,1),o.push(E),p=w.length-1}}else D.isMacintosh;return m.buttons=w,m.defaultId=u,m.cancelId=p,m.noLink=!0,m.title=m.title||g.nameLong,{options:m,buttonIndeces:o}}e.massageMessageBoxOptions=v}),define(ee[108],te([0,1,6]),function(G,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,I.createDecorator)("encryptionMainService")}),define(ee[33],te([0,1,6]),function(G,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,I.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,I.refineServiceDecorator)(e.IEnvironmentService)}),define(ee[28],te([0,1,55,9,87,33,189,6]),function(G,e,I,A,n,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,P.refineServiceDecorator)(C.IEnvironmentService);class f extends D.NativeEnvironmentService{get cachedLanguagesPath(){return(0,A.join)(this.userDataPath,"clp")}get backupHome(){return(0,A.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,n.createStaticIPCHandle)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,A.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}ve([I.memoize],f.prototype,"cachedLanguagesPath",null),ve([I.memoize],f.prototype,"backupHome",null),ve([I.memoize],f.prototype,"mainIPCHandle",null),ve([I.memoize],f.prototype,"mainLockfile",null),ve([I.memoize],f.prototype,"disableUpdates",null),ve([I.memoize],f.prototype,"disableKeytar",null),ve([I.memoize],f.prototype,"crossOriginIsolated",null),ve([I.memoize],f.prototype,"codeCachePath",null),ve([I.memoize],f.prototype,"useCodeCache",null),e.EnvironmentMainService=f}),define(ee[198],te([0,1,159,6]),function(G,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough";function n(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=n;function C(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=C;function D(u,p){switch(u){case 3:return p==="x64"?"win32-x64":p==="ia32"?"win32-ia32":p==="arm64"?"win32-arm64":"unknown";case 2:return p==="x64"?"linux-x64":p==="arm64"?"linux-arm64":p==="arm"?"linux-armhf":"unknown";case"alpine":return p==="x64"?"alpine-x64":p==="arm64"?"alpine-arm64":"unknown";case 1:return p==="x64"?"darwin-x64":p==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=D;function P(u,p){return p==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function f(u,p,k){return P(p,k)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===k?!0:h(k).includes(u)}e.isTargetPlatformCompatible=f;function h(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=h;function b(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=b;var v;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(v=e.SortBy||(e.SortBy={}));var y;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(y=e.SortOrder||(e.SortOrder={}));var g;(function(u){u.Install="install",u.Uninstall="uninstall"})(g=e.StatisticType||(e.StatisticType={}));var m;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(m=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,A.createDecorator)("extensionGalleryService");var w;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal",u.Signature="Signature"})(w=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class o extends Error{constructor(p,k){super(p),this.code=k,this.name=k}}e.ExtensionManagementError=o,e.IExtensionManagementService=(0,A.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,A.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,A.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,I.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,I.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(ee[199],te([0,1,6]),function(G,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,I.createDecorator)("extensionUrlTrustService")}),define(ee[200],te([0,1,6]),function(G,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,I.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(ee[109],te([0,1,6]),function(G,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,I.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,I.createDecorator)("externalTerminal")}),define(ee[201],te([0,1,46,15,9,4,83,23,86,163,109]),function(G,e,I,A,n,C,D,P,f,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const v=h.localize(0,null);class y{async getDefaultTerminalForPlatforms(){return{windows:g.getDefaultTerminalWindows(),linux:await w.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class g extends y{openTerminal(E,M){return this.spawnTerminal(I,E,f.getWindowsShell(),M)}spawnTerminal(E,M,t,a){const i=M.windowsExec||g.getDefaultTerminalWindows();a&&a[1]===":"&&(a=a[0].toUpperCase()+a.substr(1));const r=n.basename(i,".exe").toLowerCase();if(r==="cmder")return E.spawn(i,a?[a]:void 0),Promise.resolve(void 0);const c=["/c","start","/wait"];return i.indexOf(" ")>=0&&c.push('""'),c.push(i),r==="wt"&&c.push("-d ."),new Promise((l,s)=>{const d=o(process),S=E.spawn(t,c,{cwd:a,env:d});S.on("error",s),S.on("exit",()=>l())})}runInTerminal(E,M,t,a,i){const r="windowsExec"in i&&i.windowsExec?i.windowsExec:g.getDefaultTerminalWindows();return new Promise((c,l)=>{const s=`"${M} - ${v}"`,d=`""${t.join('" "')}" & pause"`,S=Object.assign({},o(process),a);Object.keys(S).filter(V=>S[V]===null).forEach(V=>delete S[V]);const R={cwd:M,env:S,windowsVerbatimArguments:!0};let O,N;n.basename(r,".exe")==="wt"?(O=r,N=["-d",".",g.b,"/c",d]):(O=g.b,N=["/c","start",s,"/wait",r,"/c",d]),I.spawn(O,N,R).on("error",V=>{l(u(V))}),c(void 0)})}static getDefaultTerminalWindows(){if(!g.d){const E=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");g.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${E?"Sysnative":"System32"}\\cmd.exe`}return g.d}}e.WindowsExternalTerminalService=g,g.b="cmd.exe";class m extends y{openTerminal(E,M){return this.spawnTerminal(I,E,M)}runInTerminal(E,M,t,a,i){const r=i.osxExec||b.DEFAULT_TERMINAL_OSX;return new Promise((c,l)=>{if(r===b.DEFAULT_TERMINAL_OSX||r==="iTerm.app"){const s=r===b.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",S=[A.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${s}.scpt`).fsPath,"-t",E||v,"-w",M];for(const N of t)S.push("-a"),S.push(N);if(a){const N=Object.assign({},o(process),a);for(const K in N){const V=N[K];V===null?(S.push("-u"),S.push(K)):(S.push("-e"),S.push(`${K}=${V}`))}}let R="";const O=I.spawn(m.b,S);O.on("error",N=>{l(u(N))}),O.stderr.on("data",N=>{R+=N.toString()}),O.on("exit",N=>{if(N===0)c(void 0);else if(R){const K=R.split(`
`,1);l(new Error(K[0]))}else l(new Error(h.localize(1,null,s,N)))})}else l(new Error(h.localize(2,null,r)))})}spawnTerminal(E,M,t){const a=M.osxExec||b.DEFAULT_TERMINAL_OSX;return new Promise((i,r)=>{const c=["-a",a];t&&c.push(t);const l=o(process),s=E.spawn("/usr/bin/open",c,{cwd:t,env:l});s.on("error",r),s.on("exit",()=>i())})}}e.MacExternalTerminalService=m,m.b="/usr/bin/osascript";class w extends y{openTerminal(E,M){return this.spawnTerminal(I,E,M)}runInTerminal(E,M,t,a,i){const r=i.linuxExec?Promise.resolve(i.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((c,l)=>{const s=[];r.then(d=>{d.indexOf("gnome-terminal")>=0?s.push("-x"):s.push("-e"),s.push("bash"),s.push("-c");const S=`${p(t)}; echo; read -p "${w.b}" -n1;`;s.push(`''${S}''`);const R=Object.assign({},o(process),a);Object.keys(R).filter(V=>R[V]===null).forEach(V=>delete R[V]);const O={cwd:M,env:R};let N="";const K=I.spawn(d,s,O);K.on("error",V=>{l(u(V))}),K.stderr.on("data",V=>{N+=V.toString()}),K.on("exit",V=>{if(V===0)c(void 0);else if(N){const X=N.split(`
`,1);l(new Error(X[0]))}else l(new Error(h.localize(4,null,d,V)))})})})}static async getDefaultTerminalLinuxReady(){if(!w.d)if(!C.isLinux)w.d=Promise.resolve("xterm");else{const E=await P.Promises.exists("/etc/debian_version");w.d=new Promise(M=>{E?M("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?M("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?M("konsole"):process.env.COLORTERM?M(process.env.COLORTERM):process.env.TERM?M(process.env.TERM):M("xterm")})}return w.d}spawnTerminal(E,M,t){const a=M.linuxExec?Promise.resolve(M.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((i,r)=>{a.then(c=>{const l=o(process),s=E.spawn(c,[],{cwd:t,env:l});s.on("error",r),s.on("exit",()=>i())})})}}e.LinuxExternalTerminalService=w,w.b=h.localize(3,null);function o(k){const E={...k.env};return(0,D.sanitizeProcessEnvironment)(E),E}function u(k){return"errno"in k&&k.errno==="ENOENT"&&"path"in k&&typeof k.path=="string"?new Error(h.localize(5,null,k.path)):k}function p(k){let E="";for(const M of k)M.indexOf(" ")>=0?E+='"'+M+'"':E+=M,E+=" ";return E}}),define(ee[16],te([0,1,61,9,27,10,7,165,6,4]),function(G,e,I,A,n,C,D,P,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,f.createDecorator)("fileService");function b(F){return F.create===!0}e.isFileOpenForWriteOptions=b;var v;(function(F){F[F.Unknown=0]="Unknown",F[F.File=1]="File",F[F.Directory=2]="Directory",F[F.SymbolicLink=64]="SymbolicLink"})(v=e.FileType||(e.FileType={}));var y;(function(F){F[F.Readonly=1]="Readonly"})(y=e.FilePermission||(e.FilePermission={}));var g;(function(F){F[F.None=0]="None",F[F.FileReadWrite=2]="FileReadWrite",F[F.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",F[F.FileReadStream=16]="FileReadStream",F[F.FileFolderCopy=8]="FileFolderCopy",F[F.PathCaseSensitive=1024]="PathCaseSensitive",F[F.Readonly=2048]="Readonly",F[F.Trash=4096]="Trash",F[F.FileWriteUnlock=8192]="FileWriteUnlock",F[F.FileAtomicRead=16384]="FileAtomicRead",F[F.FileClone=32768]="FileClone"})(g=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function m(F){return!!(F.capabilities&2)}e.hasReadWriteCapability=m;function w(F){return!!(F.capabilities&8)}e.hasFileFolderCopyCapability=w;function o(F){return!!(F.capabilities&32768)}e.hasFileCloneCapability=o;function u(F){return!!(F.capabilities&4)}e.hasOpenReadWriteCloseCapability=u;function p(F){return!!(F.capabilities&16)}e.hasFileReadStreamCapability=p;function k(F){return m(F)?!!(F.capabilities&16384):!1}e.hasFileAtomicReadCapability=k;var E;(function(F){F.FileExists="EntryExists",F.FileNotFound="EntryNotFound",F.FileNotADirectory="EntryNotADirectory",F.FileIsADirectory="EntryIsADirectory",F.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",F.FileTooLarge="EntryTooLarge",F.FileWriteLocked="EntryWriteLocked",F.NoPermissions="NoPermissions",F.Unavailable="Unavailable",F.Unknown="Unknown"})(E=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class M extends Error{constructor(W,z){super(W),this.code=z}}e.FileSystemProviderError=M;function t(F,W){const z=new M(F.toString(),W);return i(z,W),z}e.createFileSystemProviderError=t;function a(F){return F||t((0,P.localize)(0,null),E.Unknown)}e.ensureFileSystemProviderError=a;function i(F,W){return F.name=W?`${W} (FileSystemError)`:"FileSystemError",F}e.markAsFileSystemProviderError=i;function r(F){if(!F)return E.Unknown;if(F instanceof M)return F.code;const W=/^(.+) \(FileSystemError\)$/.exec(F.name);if(!W)return E.Unknown;switch(W[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileExceedsMemoryLimit:return E.FileExceedsMemoryLimit;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}e.toFileSystemProviderErrorCode=r;function c(F){if(F instanceof O)return F.fileOperationResult;switch(r(F)){case E.FileNotFound:return 1;case E.FileIsADirectory:return 0;case E.FileNotADirectory:return 10;case E.FileWriteLocked:return 5;case E.NoPermissions:return 6;case E.FileExists:return 4;case E.FileExceedsMemoryLimit:return 9;case E.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=c;var l;(function(F){F[F.CREATE=0]="CREATE",F[F.DELETE=1]="DELETE",F[F.MOVE=2]="MOVE",F[F.COPY=3]="COPY",F[F.WRITE=4]="WRITE"})(l=e.FileOperation||(e.FileOperation={}));class s{constructor(W,z,J){this.resource=W,this.operation=z,this.target=J}isOperation(W){return this.operation===W}}e.FileOperationEvent=s;var d;(function(F){F[F.UPDATED=0]="UPDATED",F[F.ADDED=1]="ADDED",F[F.DELETED=2]="DELETED"})(d=e.FileChangeType||(e.FileChangeType={}));class S{constructor(W,z){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const J=new Map;for(const ne of W){const se=J.get(ne.type);switch(se?se.push([ne.resource,ne]):J.set(ne.type,[[ne.resource,ne]]),ne.type){case 1:this.rawAdded.push(ne.resource);break;case 0:this.rawUpdated.push(ne.resource);break;case 2:this.rawDeleted.push(ne.resource);break}}for(const[ne,se]of J)switch(ne){case 1:this.a=I.TernarySearchTree.forUris(()=>z),this.a.fill(se);break;case 0:this.b=I.TernarySearchTree.forUris(()=>z),this.b.fill(se);break;case 2:this.c=I.TernarySearchTree.forUris(()=>z),this.c.fill(se);break}}contains(W,...z){return this.d(W,{includeChildren:!1},...z)}affects(W,...z){return this.d(W,{includeChildren:!0},...z)}d(W,z,...J){if(!W)return!1;const ne=J.length>0;return!!((!ne||J.includes(1))&&(this.a?.get(W)||z.includeChildren&&this.a?.findSuperstr(W))||(!ne||J.includes(0))&&(this.b?.get(W)||z.includeChildren&&this.b?.findSuperstr(W))||(!ne||J.includes(2))&&(this.c?.findSubstr(W)||z.includeChildren&&this.c?.findSuperstr(W)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=S;function R(F,W,z){return!F||!W||F===W||W.length>F.length?!1:(W.charAt(W.length-1)!==A.sep&&(W+=A.sep),z?(0,n.startsWithIgnoreCase)(F,W):F.indexOf(W)===0)}e.isParent=R;class O extends Error{constructor(W,z,J){super(W),this.fileOperationResult=z,this.options=J}}e.FileOperationError=O;class N extends O{constructor(W,z,J,ne){super(W,z,ne),this.fileOperationResult=z,this.size=J}}e.TooLargeFileOperationError=N;class K extends O{constructor(W,z,J){super(W,2,J),this.stat=z}}e.NotModifiedSinceFileOperationError=K;var V;(function(F){F[F.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",F[F.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",F[F.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",F[F.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",F[F.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",F[F.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",F[F.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",F[F.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",F[F.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",F[F.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",F[F.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",F[F.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(V=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var X;(function(F){F[F.FILE=0]="FILE",F[F.FOLDER=1]="FOLDER",F[F.ROOT_FOLDER=2]="ROOT_FOLDER"})(X=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function ie(F){if(!(typeof F.size!="number"||typeof F.mtime!="number"))return F.mtime.toString(29)+F.size.toString(31)}e.etag=ie;async function re(F,W){if(!W.hasProvider(D.URI.from({scheme:F.scheme})))return new Promise(z=>{const J=W.onDidChangeFileSystemProviderRegistrations(ne=>{ne.scheme===F.scheme&&ne.added&&(J.dispose(),z())})})}e.whenProviderRegistered=re,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ce{static formatSize(W){return(0,C.isNumber)(W)||(W=0),W<ce.KB?(0,P.localize)(1,null,W.toFixed(0)):W<ce.MB?(0,P.localize)(2,null,(W/ce.KB).toFixed(2)):W<ce.GB?(0,P.localize)(3,null,(W/ce.MB).toFixed(2)):W<ce.TB?(0,P.localize)(4,null,(W/ce.GB).toFixed(2)):(0,P.localize)(5,null,(W/ce.TB).toFixed(2))}}e.ByteSize=ce,ce.KB=1024,ce.MB=ce.KB*ce.KB,ce.GB=ce.MB*ce.KB,ce.TB=ce.GB*ce.KB;var fe;(function(F){F[F.IA32=0]="IA32",F[F.OTHER=1]="OTHER"})(fe=e.Arch||(e.Arch={}));function ge(F){return{maxFileSize:F===0?300*ce.MB:16*ce.GB,maxHeapSize:F===0?700*ce.MB:2*700*ce.MB}}e.getPlatformFileLimits=ge;function x(F){return h.isWeb?F?10*ce.MB:50*ce.MB:F?100*ce.MB:1024*ce.MB}e.getLargeFileConfirmationLimit=x}),define(ee[202],te([0,1,17,44,13,3,2,60,7,31,16]),function(G,e,I,A,n,C,D,P,f,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class v extends D.Disposable{constructor(g,m){super(),this.a=g,this.b=m,this.onDidChangeCapabilities=C.Event.None,this.f=this.B(new C.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new C.Emitter),this.onDidWatchError=this.g.event,this.h=(0,h.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(g){return this.a.call("stat",[g])}readdir(g){return this.a.call("readdir",[g])}async readFile(g,m){const{buffer:w}=await this.a.call("readFile",[g,m]);return w}readFileStream(g,m,w){const o=(0,P.newWriteableStream)(p=>I.VSBuffer.concat(p.map(k=>I.VSBuffer.wrap(k))).buffer),u=this.a.listen("readFileStream",[g,m])(p=>{if(p instanceof I.VSBuffer)o.write(p.buffer);else{if(p==="end")o.end();else{let k;if(p instanceof Error)k=p;else{const E=p;k=(0,b.createFileSystemProviderError)(E.message??(0,A.toErrorMessage)(E),E.code??b.FileSystemProviderErrorCode.Unknown)}o.error(k),o.end()}u.dispose()}});return w.onCancellationRequested(()=>{o.error((0,n.canceled)()),o.end(),u.dispose()}),o}writeFile(g,m,w){return this.a.call("writeFile",[g,I.VSBuffer.wrap(m),w])}open(g,m){return this.a.call("open",[g,m])}close(g){return this.a.call("close",[g])}async read(g,m,w,o,u){const[p,k]=await this.a.call("read",[g,m,u]);return w.set(p.buffer.slice(0,k),o),k}write(g,m,w,o,u){return this.a.call("write",[g,m,I.VSBuffer.wrap(w),o,u])}mkdir(g){return this.a.call("mkdir",[g])}delete(g,m){return this.a.call("delete",[g,m])}rename(g,m,w){return this.a.call("rename",[g,m,w])}copy(g,m,w){return this.a.call("copy",[g,m,w])}cloneFile(g,m){return this.a.call("cloneFile",[g,m])}i(){this.B(this.a.listen("fileChange",[this.h])(g=>{if(Array.isArray(g)){const m=g;this.f.fire(m.map(w=>({resource:f.URI.revive(w.resource),type:w.type})))}else{const m=g;this.g.fire(m)}}))}watch(g,m){const w=(0,h.generateUuid)();return this.a.call("watch",[this.h,w,g,m]),(0,D.toDisposable)(()=>this.a.call("unwatch",[this.h,w]))}}e.DiskFileSystemProviderClient=v}),define(ee[110],te([0,1,17,13,166,16]),function(G,e,I,A,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function D(b,v,y,g,m,w){let o;try{await P(b,v,y,g,m,w)}catch(u){o=u}finally{o&&m.errorTransformer&&(o=m.errorTransformer(o)),typeof o<"u"&&y.error(o),y.end()}}e.readFileIntoStream=D;async function P(b,v,y,g,m,w){f(w);const o=await b.open(v,{create:!1});try{f(w);let u=0,p=0,k=m&&typeof m.length=="number"?m.length:void 0,E=I.VSBuffer.alloc(Math.min(m.bufferSize,typeof k=="number"?k:m.bufferSize)),M=m&&typeof m.position=="number"?m.position:0,t=0;do p=await b.read(o,M,E.buffer,t,E.byteLength-t),M+=p,t+=p,u+=p,typeof k=="number"&&(k-=p),t===E.byteLength&&(await y.write(g(E)),E=I.VSBuffer.alloc(Math.min(m.bufferSize,typeof k=="number"?k:m.bufferSize)),t=0);while(p>0&&(typeof k!="number"||k>0)&&f(w)&&h(u,m));if(t>0){let a=t;typeof k=="number"&&(a=Math.min(t,k)),y.write(g(E.slice(0,a)))}}catch(u){throw(0,C.ensureFileSystemProviderError)(u)}finally{await b.close(o)}}function f(b){if(b.isCancellationRequested)throw(0,A.canceled)();return!0}function h(b,v){if(v?.limits){if(typeof v.limits.memory=="number"&&b>v.limits.memory)throw(0,C.createFileSystemProviderError)((0,n.localize)(0,null),C.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof v.limits.size=="number"&&b>v.limits.size)throw(0,C.createFileSystemProviderError)((0,n.localize)(1,null),C.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ee[76],te([0,1,101,2,9,4,7,16]),function(G,e,I,A,n,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function f(u){return u.recursive===!0}e.isRecursiveWatchRequest=f;class h extends A.Disposable{constructor(p,k,E,M){super(),this.h=p,this.i=k,this.j=E,this.k=M,this.c=this.B(new A.MutableDisposable),this.f=void 0,this.g=0}m(){const p=new A.DisposableStore;this.c.value=p,this.b=this.l(p),this.b.setVerboseLogging(this.j),p.add(this.b.onDidChangeFile(k=>this.h(k))),p.add(this.b.onDidLogMessage(k=>this.i(k))),p.add(this.b.onDidError(k=>this.n(k)))}n(p){this.k.restartOnError?this.g<h.a&&this.f?(this.r(`restarting watcher after error: ${p}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${p}`):this.r(p)}p(p){this.g++,this.m(),this.watch(p)}async watch(p){this.f=p,await this.b?.watch(p)}async setVerboseLogging(p){this.j=p,await this.b?.setVerboseLogging(p)}r(p){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${p}`})}dispose(){return this.b=void 0,super.dispose()}}e.AbstractWatcherClient=h,h.a=5;class b extends h{constructor(p,k,E){super(p,k,E,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=b;class v extends h{constructor(p,k,E){super(p,k,E,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=v;function y(u){return u.map(p=>({type:p.type,resource:D.URI.file(p.path)}))}e.toFileChanges=y;function g(u){const p=new o;for(const k of u)p.processEvent(k);return p.coalesce()}e.coalesceEvents=g;function m(u,p){return typeof p=="string"&&!p.startsWith(I.GLOBSTAR)&&!(0,n.isAbsolute)(p)?{base:u,pattern:p}:p}e.normalizeWatcherPattern=m;function w(u,p){const k=[];for(const E of p)k.push((0,I.parse)(m(u,E)));return k}e.parseWatcherPatterns=w;class o{constructor(){this.a=new Set,this.b=new Map}c(p){return C.isLinux?p.path:p.path.toLowerCase()}processEvent(p){const k=this.b.get(this.c(p));let E=!1;if(k){const M=k.type,t=p.type;k.path!==p.path&&(p.type===2||p.type===1)?E=!0:M===1&&t===2?(this.b.delete(this.c(p)),this.a.delete(k)):M===2&&t===1?k.type=0:M===1&&t===0||(k.type=t)}else E=!0;E&&(this.a.add(p),this.b.set(this.c(p),p))}coalesce(){const p=[],k=[];return Array.from(this.a).filter(E=>E.type!==2?(p.push(E),!1):!0).sort((E,M)=>E.path.length-M.path.length).filter(E=>k.some(M=>(0,P.isParent)(E.path,M,!C.isLinux))?!1:(k.push(E.path),!0)).concat(p)}}}),define(ee[203],te([0,1,41,8,22,32,2,80,9,4,102,23,76]),function(G,e,I,A,n,C,D,P,f,h,b,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class g extends D.Disposable{constructor(o,u,p,k){super(),this.j=o,this.k=u,this.l=p,this.m=k,this.c=this.B(new A.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},E=>this.k(E))),this.f=this.B(new A.RunOnceWorker(E=>this.u(E),g.b)),this.g=(0,y.parseWatcherPatterns)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,y.parseWatcherPatterns)(this.j.path,this.j.includes):void 0,this.i=new n.CancellationTokenSource,this.ready=this.n()}async n(){try{const o=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const u=await v.Promises.stat(o);this.B(await this.s(o,u.isDirectory()))}catch(o){o.code!=="ENOENT"?this.w(o):this.z(o)}}async r(o){let u=o.path;try{u=await v.Promises.realpath(o.path),o.path===u&&(u=await(0,b.realcase)(o.path)??o.path),o.path!==u&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${o.path}, real: ${u})`)}catch{}return u}async s(o,u){if(h.isMacintosh&&(0,C.isEqualOrParent)(o,"/Volumes/",!0))return this.w(`Refusing to watch ${o} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.Disposable.None;const p=new n.CancellationTokenSource(this.i.token),k=new D.DisposableStore;try{const E=(0,f.basename)(o),M=(0,I.watch)(o);k.add((0,D.toDisposable)(()=>{M.removeAllListeners(),M.close()})),this.z(`Started watching: '${o}'`);const t=new Set;if(u)try{for(const i of await v.Promises.readdir(o))t.add(i)}catch(i){this.w(i)}const a=new Map;k.add((0,D.toDisposable)(()=>{for(const[,i]of a)i.dispose();a.clear()})),M.on("error",(i,r)=>{this.w(`Failed to watch ${o} for changes using fs.watch() (${i}, ${r})`),this.dispose()}),M.on("change",(i,r)=>{if(p.token.isCancellationRequested)return;this.z(`[raw] ["${i}"] ${r}`);let c="";if(r&&(c=r.toString(),h.isMacintosh&&(c=(0,P.normalizeNFC)(c))),!(!c||i!=="change"&&i!=="rename"))if(u)if(i==="rename"){a.get(c)?.dispose();const l=setTimeout(async()=>{if(a.delete(c),c===E&&!await v.Promises.exists(o)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const s=await this.v((0,f.join)(o,c));if(p.token.isCancellationRequested)return;let d;s?t.has(c)?d=0:(d=1,t.add(c)):(t.delete(c),d=2),this.t({path:(0,f.join)(this.j.path,c),type:d})},g.a);a.set(c,(0,D.toDisposable)(()=>clearTimeout(l)))}else{let l;t.has(c)?l=0:(l=1,t.add(c)),this.t({path:(0,f.join)(this.j.path,c),type:l})}else if(i==="rename"||c!==E){const l=setTimeout(async()=>{const s=await v.Promises.exists(o);p.token.isCancellationRequested||(s?(this.t({path:this.j.path,type:0},!0),k.add(await this.s(o,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},g.a);k.clear(),k.add((0,D.toDisposable)(()=>clearTimeout(l)))}else this.t({path:this.j.path,type:0},!0)})}catch(E){await v.Promises.exists(o)&&!p.token.isCancellationRequested&&this.w(`Failed to watch ${o} for changes using fs.watch() (${E.toString()})`)}return(0,D.toDisposable)(()=>{p.dispose(!0),k.dispose()})}t(o,u=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${o.type===1?"[ADDED]":o.type===2?"[DELETED]":"[CHANGED]"} ${o.path}`),!u&&this.g.some(p=>p(o.path))?this.m&&this.z(` >> ignored (excluded) ${o.path}`):!u&&this.h&&this.h.length>0&&!this.h.some(p=>p(o.path))?this.m&&this.z(` >> ignored (not included) ${o.path}`):this.f.work(o))}u(o){const u=(0,y.coalesceEvents)(o);if(u.length>0){if(this.m)for(const k of u)this.z(`>> normalized ${k.type===1?"[ADDED]":k.type===2?"[DELETED]":"[CHANGED]"} ${k.path}`);this.c.work(u)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(o){if(h.isLinux)return v.Promises.exists(o);try{const u=(0,f.basename)(o);return(await v.Promises.readdir((0,f.dirname)(o))).some(k=>k===u)}catch(u){return this.z(u),!1}}setVerboseLogging(o){this.m=o}w(o){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${o}`})}y(o){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${o}`})}z(o){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${o}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=g,g.a=100,g.b=75;async function m(w,o,u,p,k=512){const E=await v.Promises.open(w,"r"),M=Buffer.allocUnsafe(k),t=new n.CancellationTokenSource(p);let a,i=!1;const r={path:w,excludes:[],recursive:!1},c=new g(r,l=>{(async()=>{for(const{type:s}of l)if(s===0){if(i)return;i=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:d}=await v.Promises.read(E,M,0,k,null);if(!d||t.token.isCancellationRequested)break;o(M.slice(0,d))}}catch(d){a=new Error(d),t.dispose(!0)}finally{i=!1}}})()});return await c.ready,u(),new Promise((l,s)=>{t.token.onCancellationRequested(async()=>{c.dispose();try{await v.Promises.close(E)}catch(d){a=new Error(d)}a?s(a):l()})})}e.watchFileContents=m}),define(ee[204],te([0,1,3,101,2,4,203]),function(G,e,I,A,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class P extends n.Disposable{constructor(){super(...arguments),this.a=this.B(new I.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new I.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=I.Event.None,this.c=new Map,this.f=!1}async watch(h){const b=this.i(h),v=b.filter(g=>{const m=this.c.get(g.path);return m?!(0,A.patternsEquals)(m.request.excludes,g.excludes)||!(0,A.patternsEquals)(m.request.includes,g.includes):!0}),y=Array.from(this.c.values()).filter(({request:g})=>!b.find(m=>m.path===g.path&&(0,A.patternsEquals)(m.excludes,g.excludes)&&(0,A.patternsEquals)(m.includes,g.includes))).map(({request:g})=>g.path);v.length&&this.j(`Request to start watching: ${v.map(g=>`${g.path} (excludes: ${g.excludes.length>0?g.excludes:"<none>"}, includes: ${g.includes&&g.includes.length>0?JSON.stringify(g.includes):"<all>"})`).join(",")}`),y.length&&this.j(`Request to stop watching: ${y.join(",")}`);for(const g of y)this.h(g);for(const g of v)this.g(g)}g(h){const b=new D.NodeJSFileWatcherLibrary(h,y=>this.a.fire(y),y=>this.b.fire(y),this.f),v={request:h,instance:b};this.c.set(h.path,v)}async stop(){for(const[h]of this.c)this.h(h);this.c.clear()}h(h){const b=this.c.get(h);b&&(this.c.delete(h),b.instance.dispose())}i(h){const b=new Map;for(const v of h){const y=C.isLinux?v.path:v.path.toLowerCase();b.set(y,v)}return Array.from(b.values())}async setVerboseLogging(h){this.f=h;for(const[,b]of this.c)b.instance.setVerboseLogging(h)}j(h){this.f&&this.b.fire({type:"trace",message:this.k(h)})}k(h,b){return b?`[File Watcher (node.js)] ${h} (path: ${b.request.path})`:`[File Watcher (node.js)] ${h}`}}e.NodeJSWatcher=P}),define(ee[205],te([0,1,76,204]),function(G,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class n extends I.AbstractNonRecursiveWatcherClient{constructor(D,P,f){super(D,P,f),this.m()}l(){return new A.NodeJSWatcher}}e.NodeJSWatcherClient=n}),define(ee[206],te([0,1,15,47,151,76]),function(G,e,I,A,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class D extends C.AbstractUniversalWatcherClient{constructor(f,h,b){super(f,h,b),this.m()}l(f){const h=f.add(new n.Client(I.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return f.add(h.onDidProcessExit(({code:b,signal:v})=>this.n(`terminated by itself with code ${b}, signal: ${v}`))),A.ProxyChannel.toService((0,A.getNextTickChannel)(h.getChannel("watcher")))}}e.UniversalWatcherClient=D}),define(ee[89],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class I{constructor(...n){this.a=new Map;for(const[C,D]of n)this.set(C,D)}set(n,C){const D=this.a.get(n);return this.a.set(n,C),D}has(n){return this.a.has(n)}get(n){return this.a.get(n)}}e.ServiceCollection=I}),define(ee[207],te([0,1,8,13,2,74,197,6,89,99]),function(G,e,I,A,n,C,D,P,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const b=!1;class v extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class y{constructor(o=new f.ServiceCollection,u=!1,p,k=b){this.f=o,this.g=u,this.h=p,this.i=k,this.o=new Set,this.f.set(P.IInstantiationService,this),this._globalGraph=k?p?._globalGraph??new D.Graph(E=>E):void 0}createChild(o){return new y(o,this.g,this,this.i)}invokeFunction(o,...u){const p=m.traceInvocation(this.i,o);let k=!1;try{return o({get:M=>{if(k)throw(0,A.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(M,p);if(!t)throw new Error(`[invokeFunction] unknown service '${M}'`);return t}},...u)}finally{k=!0,p.stop()}}createInstance(o,...u){let p,k;return o instanceof C.SyncDescriptor?(p=m.traceCreation(this.i,o.ctor),k=this.j(o.ctor,o.staticArguments.concat(u),p)):(p=m.traceCreation(this.i,o),k=this.j(o,u,p)),p.stop(),k}j(o,u=[],p){const k=P._util.getServiceDependencies(o).sort((t,a)=>t.index-a.index),E=[];for(const t of k){const a=this.m(t.id,p);a||this.u(`[createInstance] ${o.name} depends on UNKNOWN service ${t.id}.`,!1),E.push(a)}const M=k.length>0?k[0].index:u.length;if(u.length!==M){console.trace(`[createInstance] First service dependency of ${o.name} at position ${M+1} conflicts with ${u.length} static arguments`);const t=M-u.length;t>0?u=u.concat(new Array(t)):u=u.slice(0,M)}return Reflect.construct(o,u.concat(E))}k(o,u){if(this.f.get(o)instanceof C.SyncDescriptor)this.f.set(o,u);else if(this.h)this.h.k(o,u);else throw new Error("illegalState - setting UNKNOWN service instance")}l(o){const u=this.f.get(o);return!u&&this.h?this.h.l(o):u}m(o,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const p=this.l(o);return p instanceof C.SyncDescriptor?this.q(o,p,u.branch(o,!0)):(u.branch(o,!1),p)}q(o,u,p){if(this.o.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.o.add(o);try{return this.r(o,u,p)}finally{this.o.delete(o)}}r(o,u,p){const k=new D.Graph(t=>t.id.toString());let E=0;const M=[{id:o,desc:u,_trace:p}];for(;M.length;){const t=M.pop();if(k.lookupOrInsertNode(t),E++>1e3)throw new v(k);for(const a of P._util.getServiceDependencies(t.desc.ctor)){const i=this.l(a.id);if(i||this.u(`[createInstance] ${o} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(a.id)),i instanceof C.SyncDescriptor){const r={id:a.id,desc:i,_trace:t._trace.branch(a.id,!0)};k.insertEdge(t,r),M.push(r)}}}for(;;){const t=k.roots();if(t.length===0){if(!k.isEmpty())throw new v(k);break}for(const{data:a}of t){if(this.l(a.id)instanceof C.SyncDescriptor){const r=this.s(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this.k(a.id,r)}k.removeNode(a)}}return this.l(o)}s(o,u,p=[],k,E){if(this.f.get(o)instanceof C.SyncDescriptor)return this.t(o,u,p,k,E);if(this.h)return this.h.s(o,u,p,k,E);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}t(o,u,p=[],k,E){if(k){const M=new y(void 0,this.g,this,this.i);M.c=String(o);const t=new Map,a=new I.IdleValue(()=>{const i=M.j(u,p,E);for(const[r,c]of t){const l=i[r];if(typeof l=="function")for(const s of c)l.apply(i,s)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,r){if(!a.isInitialized&&typeof r=="string"&&(r.startsWith("onDid")||r.startsWith("onWill"))){let s=t.get(r);return s||(s=new h.LinkedList,t.set(r,s)),(S,R,O)=>{const N=s.push([S,R,O]);return(0,n.toDisposable)(N)}}if(r in i)return i[r];const c=a.value;let l=c[r];return typeof l!="function"||(l=l.bind(c),i[r]=l),l},set(i,r,c){return a.value[r]=c,!0},getPrototypeOf(i){return u.prototype}})}else return this.j(u,p,E)}u(o,u){if(u&&console.warn(o),this.g)throw new Error(o)}}e.InstantiationService=y;var g;(function(w){w[w.None=0]="None",w[w.Creation=1]="Creation",w[w.Invocation=2]="Invocation",w[w.Branch=3]="Branch"})(g||(g={}));class m{static traceInvocation(o,u){return o?new m(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m.c}static traceCreation(o,u){return o?new m(1,u.name):m.c}constructor(o,u){this.type=o,this.name=u,this.g=Date.now(),this.h=[]}branch(o,u){const p=new m(3,o.toString());return this.h.push([o,u,p]),p}stop(){const o=Date.now()-this.g;m.f+=o;let u=!1;function p(E,M){const t=[],a=new Array(E+1).join("	");for(const[i,r,c]of M.h)if(r&&c){u=!0,t.push(`${a}CREATES -> ${i}`);const l=p(E+1,c);l&&t.push(l)}else t.push(`${a}uses -> ${i}`);return t.join(`
`)}const k=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${m.f.toFixed(2)}ms)`];(o>2||u)&&m.all.add(k.join(`
`))}}e.Trace=m,m.all=new Set,m.c=new class extends m{constructor(){super(0,null)}stop(){}branch(){return this}},m.f=0}),define(ee[5],te([0,1,44,3,2,35,4,10,7,6]),function(G,e,I,A,n,C,D,P,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.setLogLevel=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,h.createDecorator)("logService"),e.ILoggerService=(0,h.createDecorator)("loggerService");function b(){return new Date().toISOString()}function v(d){return(0,P.isNumber)(d)}e.isLogLevel=v;var y;(function(d){d[d.Off=0]="Off",d[d.Trace=1]="Trace",d[d.Debug=2]="Debug",d[d.Info=3]="Info",d[d.Warning=4]="Warning",d[d.Error=5]="Error"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;function g(d,S,R){switch(S){case y.Trace:d.trace(R);break;case y.Debug:d.debug(R);break;case y.Info:d.info(R);break;case y.Warning:d.warn(R);break;case y.Error:d.error(R);break;case y.Off:break;default:throw new Error(`Invalid log level ${S}`)}}e.log=g;function m(d){let S="";for(let R=0;R<d.length;R++){let O=d[R];if(typeof O=="object")try{O=JSON.stringify(O)}catch{}S+=(R>0?" ":"")+O}return S}e.format=m;class w extends n.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new A.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(S){this.b!==S&&(this.b=S,this.c.fire(this.b))}getLevel(){return this.b}f(S){return this.b!==y.Off&&this.b<=S}}e.AbstractLogger=w;class o extends w{constructor(S){super(),this.h=S}f(S){return this.h||super.f(S)}trace(S,...R){this.f(y.Trace)&&this.g(y.Trace,m([S,...R]))}debug(S,...R){this.f(y.Debug)&&this.g(y.Debug,m([S,...R]))}info(S,...R){this.f(y.Info)&&this.g(y.Info,m([S,...R]))}warn(S,...R){this.f(y.Warning)&&this.g(y.Warning,m([S,...R]))}error(S,...R){if(this.f(y.Error))if(S instanceof Error){const O=Array.prototype.slice.call(arguments);O[0]=S.stack,this.g(y.Error,m(O))}else this.g(y.Error,m([S,...R]))}flush(){}}e.AbstractMessageLogger=o;class u extends w{constructor(S=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(S),this.g=!D.isWindows}trace(S,...R){this.f(y.Trace)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,S,...R):console.log(`[main ${b()}]`,S,...R))}debug(S,...R){this.f(y.Debug)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,S,...R):console.log(`[main ${b()}]`,S,...R))}info(S,...R){this.f(y.Info)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,S,...R):console.log(`[main ${b()}]`,S,...R))}warn(S,...R){this.f(y.Warning)&&(this.g?console.warn(`\x1B[93m[main ${b()}]\x1B[0m`,S,...R):console.warn(`[main ${b()}]`,S,...R))}error(S,...R){this.f(y.Error)&&(this.g?console.error(`\x1B[91m[main ${b()}]\x1B[0m`,S,...R):console.error(`[main ${b()}]`,S,...R))}dispose(){}flush(){}}e.ConsoleMainLogger=u;class p extends w{constructor(S=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(S)}trace(S,...R){this.f(y.Trace)&&console.log("%cTRACE","color: #888",S,...R)}debug(S,...R){this.f(y.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",S,...R)}info(S,...R){this.f(y.Info)&&console.log("%c INFO","color: #33f",S,...R)}warn(S,...R){this.f(y.Warning)&&console.log("%c WARN","color: #993",S,...R)}error(S,...R){this.f(y.Error)&&console.log("%c  ERR","color: #f33",S,...R)}dispose(){}flush(){}}e.ConsoleLogger=p;class k extends w{constructor(S,R=e.DEFAULT_LOG_LEVEL){super(),this.g=S,this.setLevel(R)}trace(S,...R){this.f(y.Trace)&&this.g.log(y.Trace,[this.h(S),...R])}debug(S,...R){this.f(y.Debug)&&this.g.log(y.Debug,[this.h(S),...R])}info(S,...R){this.f(y.Info)&&this.g.log(y.Info,[this.h(S),...R])}warn(S,...R){this.f(y.Warning)&&this.g.log(y.Warning,[this.h(S),...R])}error(S,...R){this.f(y.Error)&&this.g.log(y.Error,[this.h(S),...R])}h(S){return typeof S=="string"?S:(0,I.toErrorMessage)(S,this.f(y.Trace))}dispose(){}flush(){}}e.AdapterLogger=k;class E extends w{constructor(S){super(),this.g=S,S.length&&this.setLevel(S[0].getLevel())}setLevel(S){for(const R of this.g)R.setLevel(S);super.setLevel(S)}trace(S,...R){for(const O of this.g)O.trace(S,...R)}debug(S,...R){for(const O of this.g)O.debug(S,...R)}info(S,...R){for(const O of this.g)O.info(S,...R)}warn(S,...R){for(const O of this.g)O.warn(S,...R)}error(S,...R){for(const O of this.g)O.error(S,...R)}flush(){for(const S of this.g)S.flush()}dispose(){for(const S of this.g)S.dispose()}}e.MultiplexLogger=E;class M extends n.Disposable{constructor(S,R){if(super(),this.j=S,this.b=new C.ResourceMap,this.c=new C.ResourceMap,this.f=this.B(new A.Emitter),this.onDidChangeLoggers=this.f.event,this.g=this.B(new A.Emitter),this.onDidChangeLogLevel=this.g.event,this.h=this.B(new A.Emitter),this.onDidChangeVisibility=this.h.event,R)for(const O of R)this.c.set(O.resource,O)}getLogger(S){return this.b.get(S)}createLogger(S,R){let O=this.b.get(S);const N=R?.logLevel==="always"?y.Trace:R?.logLevel;return O||(O=this.k(S,N??this.getLogLevel(S)??this.j,R),this.b.set(S,O)),this.registerLogger({resource:S,id:R?.id??S.toString(),logLevel:N,name:R?.name,hidden:R?.hidden,extensionId:R?.extensionId}),O}setLogLevel(S,R){if(f.URI.isUri(S)){const O=S,N=R,K=this.c.get(O);K&&N!==K.logLevel&&(K.logLevel=N===this.j?void 0:N,this.b.get(O)?.setLevel(N),this.c.set(K.resource,K),this.g.fire([O,N]))}else{this.j=S;for(const[O,N]of this.b.entries())this.c.get(O)?.logLevel===void 0&&N.setLevel(this.j);this.g.fire(this.j)}}setVisibility(S,R){const O=this.c.get(S);O&&R!==!O.hidden&&(O.hidden=!R,this.c.set(O.resource,O),this.h.fire([S,R]))}getLogLevel(S){let R;return S&&(R=this.c.get(S)?.logLevel),R??this.j}registerLogger(S){const R=this.c.get(S.resource);R?R.hidden!==S.hidden&&this.setVisibility(S.resource,!S.hidden):(this.c.set(S.resource,S),this.f.fire({added:[S],removed:[]}))}deregisterLogger(S){const R=this.c.get(S);if(R){this.c.delete(S);const O=this.b.get(S);O&&(this.b.delete(S),O.dispose()),this.f.fire({added:[],removed:[R]})}}getRegisteredLoggers(){return this.c.values()}getRegisteredLogger(S){return this.c.get(S)}dispose(){this.b.forEach(S=>S.dispose()),this.b.clear(),this.c.clear(),super.dispose()}}e.AbstractLoggerService=M;class t{constructor(){this.onDidChangeLogLevel=new A.Emitter().event}setLevel(S){}getLevel(){return y.Info}trace(S,...R){}debug(S,...R){}info(S,...R){}warn(S,...R){}error(S,...R){}critical(S,...R){}dispose(){}flush(){}}e.NullLogger=t;class a extends t{}e.NullLogService=a;class i extends M{constructor(){super(y.Info)}k(S,R,O){return new t}}e.NullLoggerService=i;function r(d){if(d.verbose)return y.Trace;if(typeof d.logLevel=="string"){const S=l(d.logLevel.toLowerCase());if(S!==void 0)return S}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=r;function c(d){switch(d){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Off:return"off"}}e.LogLevelToString=c;function l(d){switch(d){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Error;case"off":return y.Off}}e.parseLogLevel=l;function s(d,S){v(S)?d.setLogLevel(S):d.setLogLevel(S[0],S[1])}e.setLogLevel=s});var _=this&&this.__param||function(G,e){return function(I,A){e(I,A,G)}};define(ee[208],te([0,1,75,3,2,5,4,8]),function(G,e,I,A,n,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let f=class dt extends n.Disposable{constructor(b){super(),this.g=b,this.c=this.B(new A.Emitter),this.onDidChangePassword=this.c.event}async getPassword(b,v){this.g.trace("Getting password from keytar:",b,v);let y;try{y=await this.h()}catch{return null}const g=await(0,P.retry)(()=>y.getPassword(b,v),50,3);if(!g)return this.g.trace("Did not get a password from keytar for account:",v),g;let m,w;try{const o=JSON.parse(g);m=o.content,w=o.hasNextChunk}catch{}if(!m||!w)return this.g.trace("Got password from keytar for account:",v),g;try{let o=1;for(;w;){const u=await(0,P.retry)(()=>y.getPassword(b,`${v}-${o}`),50,3),p=JSON.parse(u);m+=p.content,w=p.hasNextChunk,o++}return this.g.trace(`Got ${o}-chunked password from keytar for account:`,v),m}catch(o){return this.g.error(o),g}}async setPassword(b,v,y){this.g.trace("Setting password using keytar:",b,v);let g;try{g=await this.h()}catch(m){throw this.i?.(m),m}if(D.isWindows&&y.length>dt.a){let m=0,w=0,o=!0;for(;o;){const u=y.substring(m,m+dt.b);m+=dt.b,o=y.length-m>0;const p={content:u,hasNextChunk:o};await(0,P.retry)(()=>g.setPassword(b,w?`${v}-${w}`:v,JSON.stringify(p)),50,3),w++}this.g.trace(`Got${w?` ${w}-chunked`:""} password from keytar for account:`,v)}else await(0,P.retry)(()=>g.setPassword(b,v,y),50,3),this.g.trace("Got password from keytar for account:",v);this.c.fire({service:b,account:v})}async deletePassword(b,v){this.g.trace("Deleting password using keytar:",b,v);let y;try{y=await this.h()}catch(u){throw this.i?.(u),u}const g=await y.getPassword(b,v);if(!g)return this.g.trace("Did not get a password to delete from keytar for account:",v),!1;let m,w;try{const u=JSON.parse(g);m=u.content,w=u.hasNextChunk}catch{}let o=0;if(m&&w)try{for(o++;w;){const u=`${v}-${o}`,p=await y.getPassword(b,u);await y.deletePassword(b,u),w=JSON.parse(p).hasNextChunk,o++}}catch(u){this.g.error(u)}return await y.deletePassword(b,v)?(this.c.fire({service:b,account:v}),this.g.trace(`Deleted${o?` ${o}-chunked`:""} password from keytar for account:`,v),!0):(this.g.trace(`Keytar failed to delete${o?` ${o}-chunked`:""} password for account:`,v),!1)}async findPassword(b){let v;try{v=await this.h()}catch{return null}return await v.findPassword(b)}async findCredentials(b){let v;try{v=await this.h()}catch{return[]}return await v.findCredentials(b)}clear(){return this.f instanceof I.InMemoryCredentialsProvider?this.f.clear():Promise.resolve()}};f.a=2500,f.b=f.a-100,f=ve([_(0,C.ILogService)],f),e.BaseCredentialsMainService=f}),define(ee[209],te([0,1,5]),function(G,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;let A=class{constructor(C,D){this.a=C,this.b=D}c(){return new Promise((C,D)=>G(["vscode-encrypt"],C,D))}async encrypt(C){let D;try{D=await this.c()}catch{return C}try{return D.encrypt(this.a,C)}catch(P){return this.b.error(P),C}}async decrypt(C){let D;try{D=await this.c()}catch{return C}try{return D.decrypt(this.a,C)}catch(P){return this.b.error(P),C}}};A=ve([_(1,I.ILogService)],A),e.EncryptionMainService=A}),define(ee[210],te([0,1,25,8,13,3,2,9,76,5]),function(G,e,I,A,n,C,D,P,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class b extends D.Disposable{constructor(y,g){super(),this.a=y,this.b=g,this.c=this.B(new C.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new C.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new A.ThrottledDelayer(0)),this.s=[],this.t=this.B(new A.ThrottledDelayer(0))}watch(y,g){return g.recursive||this.b?.watcher?.forceUniversal?this.l(y,g):this.u(y,g)}l(y,g){const m={path:this.C(y),excludes:g.excludes,includes:g.includes,recursive:g.recursive},w=(0,I.insert)(this.j,m);return this.m(),(0,D.toDisposable)(()=>{w(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(y=>(0,n.onUnexpectedError)(y))}n(){this.h||(this.h=this.B(this.p(g=>this.c.fire((0,f.toFileChanges)(g)),g=>this.z(g),this.a.getLevel()===h.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===h.LogLevel.Trace)})));const y=this.b?.watcher?.recursive?.usePolling;if(y===!0)for(const g of this.j)(0,f.isRecursiveWatchRequest)(g)&&(g.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(y))for(const g of this.j)(0,f.isRecursiveWatchRequest)(g)&&y.includes(g.path)&&(g.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(y,g){const m={path:this.C(y),excludes:g.excludes,includes:g.includes,recursive:!1},w=(0,I.insert)(this.s,m);return this.v(),(0,D.toDisposable)(()=>{w(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(y=>(0,n.onUnexpectedError)(y))}w(){return this.r||(this.r=this.B(this.y(y=>this.c.fire((0,f.toFileChanges)(y)),y=>this.z(y),this.a.getLevel()===h.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===h.LogLevel.Trace)}))),this.r.watch(this.s)}z(y){y.type==="error"&&this.g.fire(y.message),this.a[y.type](y.message)}C(y){return(0,P.normalize)(y.fsPath)}}e.AbstractDiskFileSystemProvider=b}),define(ee[211],te([0,1,25,8,17,22,3,72,70,2,61,15,64,18,60,164,16,110,5,13]),function(G,e,I,A,n,C,D,P,f,h,b,v,y,g,m,w,o,u,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let E=class extends h.Disposable{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new D.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new D.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new D.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new D.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new D.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new D.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new A.ResourceQueue)}registerProvider(t,a){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,y.mark)(`code/registerFilesystem/${t}`);const i=new h.DisposableStore;return this.h.set(t,a),this.c.fire({added:!0,scheme:t,provider:a}),i.add(a.onDidChangeFile(r=>this.R.fire(new o.FileChangesEvent(r,!this.O(a))))),typeof a.onDidWatchError=="function"&&i.add(a.onDidWatchError(r=>this.S.fire(new Error(r)))),i.add(a.onDidChangeCapabilities(()=>this.g.fire({provider:a,scheme:t}))),(0,h.toDisposable)(()=>{this.c.fire({added:!1,scheme:t,provider:a}),this.h.delete(t),(0,h.dispose)(i)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const a=[];this.f.fire({scheme:t,join(i){a.push(i)}}),!this.h.has(t)&&await A.Promises.settled(a)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,a){const i=this.h.get(t.scheme);return!!(i&&i.capabilities&a)}listCapabilities(){return f.Iterable.map(this.h,([t,a])=>({scheme:t,capabilities:a.capabilities}))}async j(t){if(!(0,g.isAbsolutePath)(t))throw new o.FileOperationError((0,w.localize)(0,null,this.nb(t)),8);await this.activateProvider(t.scheme);const a=this.h.get(t.scheme);if(!a){const i=new k.ErrorNoTelemetry;throw i.message=(0,w.localize)(1,null,t.toString()),i}return a}async k(t){const a=await this.j(t);if((0,o.hasOpenReadWriteCloseCapability)(a)||(0,o.hasReadWriteCapability)(a)||(0,o.hasFileReadStreamCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const a=await this.j(t);if((0,o.hasOpenReadWriteCloseCapability)(a)||(0,o.hasReadWriteCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,a){try{return await this.n(t,a)}catch(i){throw(0,o.toFileSystemProviderErrorCode)(i)===o.FileSystemProviderErrorCode.FileNotFound?new o.FileOperationError((0,w.localize)(2,null,this.nb(t)),1):(0,o.ensureFileSystemProviderError)(i)}}async n(t,a){const i=await this.j(t),r=this.O(i),c=a?.resolveTo,l=a?.resolveSingleChildDescendants,s=a?.resolveMetadata,d=await i.stat(t);let S;return this.p(i,t,d,void 0,!!s,(R,O)=>(S||(S=b.TernarySearchTree.forUris(()=>!r),S.set(t,!0),c&&S.fill(!0,c)),S.get(R.resource)||S.findSuperstr(R.resource.with({query:null,fragment:null}))?!0:R.isDirectory&&l?O===1:!1))}async p(t,a,i,r,c,l){const{providerExtUri:s}=this.N(t),d={resource:a,name:s.basename(a),isFile:(i.type&o.FileType.File)!==0,isDirectory:(i.type&o.FileType.Directory)!==0,isSymbolicLink:(i.type&o.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:Boolean((i.permissions??0)&o.FilePermission.Readonly)||Boolean(t.capabilities&2048),etag:(0,o.etag)({mtime:i.mtime,size:i.size}),children:void 0};if(d.isDirectory&&l(d,r)){try{const S=await t.readdir(a),R=await A.Promises.settled(S.map(async([O,N])=>{try{const K=s.joinPath(a,O),V=c?await t.stat(K):{type:N};return await this.p(t,K,V,S.length,c,l)}catch(K){return this.b.trace(K),null}}));d.children=(0,I.coalesce)(R)}catch(S){this.b.trace(S),d.children=[]}return d}return d}async resolveAll(t){return A.Promises.settled(t.map(async a=>{try{return{stat:await this.n(a.resource,a.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(t){const a=await this.j(t),i=await a.stat(t);return this.p(a,t,i,void 0,!0,()=>!1)}async exists(t){const a=await this.j(t);try{return!!await a.stat(t)}catch{return!1}}async canCreateFile(t,a){try{await this.r(t,a)}catch(i){return i}return!0}async r(t,a){if(!a?.overwrite&&await this.exists(t))throw new o.FileOperationError((0,w.localize)(3,null,this.nb(t)),3,a)}async createFile(t,a=n.VSBuffer.fromString(""),i){await this.r(t,i);const r=await this.writeFile(t,a);return this.m.fire(new o.FileOperationEvent(t,0,r)),r}async writeFile(t,a,i){const r=this.lb(await this.l(t),t),{providerExtUri:c}=this.N(r);try{await this.s(r,t,i)||await this.P(r,c.dirname(t));let s;if((0,o.hasReadWriteCapability)(r)&&!(a instanceof n.VSBuffer))if((0,m.isReadableStream)(a)){const d=await(0,m.peekStream)(a,3);d.ended?s=n.VSBuffer.concat(d.buffer):s=d}else s=(0,m.peekReadable)(a,d=>n.VSBuffer.concat(d),3);else s=a;!(0,o.hasOpenReadWriteCloseCapability)(r)||(0,o.hasReadWriteCapability)(r)&&s instanceof n.VSBuffer?await this.cb(r,t,i,s):await this.Y(r,t,i,s instanceof n.VSBuffer?(0,n.bufferToReadable)(s):s),this.m.fire(new o.FileOperationEvent(t,4))}catch(l){throw new o.FileOperationError((0,w.localize)(4,null,this.nb(t),(0,o.ensureFileSystemProviderError)(l).toString()),(0,o.toFileOperationResult)(l),i)}return this.resolve(t,{resolveMetadata:!0})}async s(t,a,i){if(!!i?.unlock&&!(t.capabilities&8192))throw new Error((0,w.localize)(5,null,this.nb(a)));let c;try{c=await t.stat(a)}catch{return}if((c.type&o.FileType.Directory)!==0)throw new o.FileOperationError((0,w.localize)(6,null,this.nb(a)),0,i);if(this.mb(a,c),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==o.ETAG_DISABLED&&typeof c.mtime=="number"&&typeof c.size=="number"&&i.mtime<c.mtime&&i.etag!==(0,o.etag)({mtime:i.mtime,size:c.size}))throw new o.FileOperationError((0,w.localize)(7,null),3,i);return c}async readFile(t,a,i){const r=await this.k(t);return a?.atomic?this.t(r,t,a,i):this.u(r,t,a,i)}async t(t,a,i,r){return new Promise((c,l)=>{this.X.queueFor(a,this.N(t).providerExtUri).queue(async()=>{try{const s=await this.u(t,a,i,r);c(s)}catch(s){l(s)}})})}async u(t,a,i,r){const c=await this.v(t,a,{...i,preferUnbuffered:!0},r);return{...c,value:await(0,n.streamToBuffer)(c.value)}}async readFileStream(t,a,i){const r=await this.k(t);return this.v(r,t,a,i)}async v(t,a,i,r){const c=new C.CancellationTokenSource(r),l=this.F(a,i).then(d=>d,d=>{throw c.cancel(),d});let s;try{return typeof i?.etag=="string"&&i.etag!==o.ETAG_DISABLED&&await l,i?.atomic&&(0,o.hasFileAtomicReadCapability)(t)||!((0,o.hasOpenReadWriteCloseCapability)(t)||(0,o.hasFileReadStreamCapability)(t))||(0,o.hasReadWriteCapability)(t)&&i?.preferUnbuffered?s=this.D(t,a,i):(0,o.hasFileReadStreamCapability)(t)?s=this.z(t,a,c.token,i):s=this.C(t,a,c.token,i),{...await l,value:s}}catch(d){throw s&&await(0,m.consumeStream)(s),this.w(d,a,i)}}w(t,a,i){const r=(0,w.localize)(8,null,this.nb(a),(0,o.ensureFileSystemProviderError)(t).toString());return t instanceof o.NotModifiedSinceFileOperationError?new o.NotModifiedSinceFileOperationError(r,t.stat,i):t instanceof o.TooLargeFileOperationError?new o.TooLargeFileOperationError(r,t.fileOperationResult,t.size,t.options):new o.FileOperationError(r,(0,o.toFileOperationResult)(t),i)}z(t,a,i,r=Object.create(null)){const c=t.readFileStream(a,r,i);return(0,m.transform)(c,{data:l=>l instanceof n.VSBuffer?l:n.VSBuffer.wrap(l),error:l=>this.w(l,a,r)},l=>n.VSBuffer.concat(l))}C(t,a,i,r=Object.create(null)){const c=(0,n.newWriteableBufferStream)();return(0,u.readFileIntoStream)(t,a,c,l=>l,{...r,bufferSize:this.a,errorTransformer:l=>this.w(l,a,r)},i),c}D(t,a,i){const r=(0,m.newWriteableStream)(c=>n.VSBuffer.concat(c));return(async()=>{try{let c;i?.atomic&&(0,o.hasFileAtomicReadCapability)(t)?c=await t.readFile(a,{atomic:!0}):c=await t.readFile(a),typeof i?.position=="number"&&(c=c.slice(i.position)),typeof i?.length=="number"&&(c=c.slice(0,i.length)),this.G(a,c.byteLength,i),r.end(n.VSBuffer.wrap(c))}catch(c){r.error(c),r.end()}})(),r}async F(t,a){const i=await this.resolve(t,{resolveMetadata:!0});if(i.isDirectory)throw new o.FileOperationError((0,w.localize)(9,null,this.nb(t)),0,a);if(typeof a?.etag=="string"&&a.etag!==o.ETAG_DISABLED&&a.etag===i.etag)throw new o.NotModifiedSinceFileOperationError((0,w.localize)(10,null),i,a);return this.G(t,i.size,a),i}G(t,a,i){if(i?.limits){let r;if(typeof i.limits.memory=="number"&&a>i.limits.memory&&(r=9),typeof i.limits.size=="number"&&a>i.limits.size&&(r=7),typeof r=="number")throw new o.TooLargeFileOperationError((0,w.localize)(11,null,this.nb(t)),r,a,i)}}async canMove(t,a,i){return this.H(t,a,"move",i)}async canCopy(t,a,i){return this.H(t,a,"copy",i)}async H(t,a,i,r){if(t.toString()!==a.toString())try{const c=i==="move"?this.lb(await this.l(t),t):await this.k(t),l=this.lb(await this.l(a),a);await this.M(c,t,l,a,i,r)}catch(c){return c}return!0}async move(t,a,i){const r=this.lb(await this.l(t),t),c=this.lb(await this.l(a),a),l=await this.I(r,t,c,a,"move",!!i),s=await this.resolve(a,{resolveMetadata:!0});return this.m.fire(new o.FileOperationEvent(t,l==="move"?2:3,s)),s}async copy(t,a,i){const r=await this.k(t),c=this.lb(await this.l(a),a),l=await this.I(r,t,c,a,"copy",!!i),s=await this.resolve(a,{resolveMetadata:!0});return this.m.fire(new o.FileOperationEvent(t,l==="copy"?3:2,s)),s}async I(t,a,i,r,c,l){if(a.toString()===r.toString())return c;const{exists:s,isSameResourceWithDifferentPathCase:d}=await this.M(t,a,i,r,c,l);if(s&&!d&&l&&await this.del(r,{recursive:!0}),await this.P(i,this.N(i).providerExtUri.dirname(r)),c==="copy"){if(t===i&&(0,o.hasFileFolderCopyCapability)(t))await t.copy(a,r,{overwrite:l});else{const S=await this.resolve(a);S.isDirectory?await this.L(t,S,i,r):await this.J(t,a,i,r)}return c}else return t===i?(await t.rename(a,r,{overwrite:l}),c):(await this.I(t,a,i,r,"copy",l),await this.del(a,{recursive:!0}),"copy")}async J(t,a,i,r){if((0,o.hasOpenReadWriteCloseCapability)(t)&&(0,o.hasOpenReadWriteCloseCapability)(i))return this.eb(t,a,i,r);if((0,o.hasOpenReadWriteCloseCapability)(t)&&(0,o.hasReadWriteCapability)(i))return this.kb(t,a,i,r);if((0,o.hasReadWriteCapability)(t)&&(0,o.hasOpenReadWriteCloseCapability)(i))return this.ib(t,a,i,r);if((0,o.hasReadWriteCapability)(t)&&(0,o.hasReadWriteCapability)(i))return this.gb(t,a,i,r)}async L(t,a,i,r){await i.mkdir(r),Array.isArray(a.children)&&await A.Promises.settled(a.children.map(async c=>{const l=this.N(i).providerExtUri.joinPath(r,c.name);return c.isDirectory?this.L(t,await this.resolve(c.resource),i,l):this.J(t,c.resource,i,l)}))}async M(t,a,i,r,c,l){let s=!1;if(t===i){const{providerExtUri:S,isPathCaseSensitive:R}=this.N(t);if(R||(s=S.isEqual(a,r)),s&&c==="copy")throw new Error((0,w.localize)(12,null,this.nb(a),this.nb(r)));if(!s&&S.isEqualOrParent(r,a))throw new Error((0,w.localize)(13,null,this.nb(a),this.nb(r)))}const d=await this.exists(r);if(d&&!s){if(!l)throw new o.FileOperationError((0,w.localize)(14,null,this.nb(a),this.nb(r)),4);if(t===i){const{providerExtUri:S}=this.N(t);if(S.isEqualOrParent(a,r))throw new Error((0,w.localize)(15,null,this.nb(a),this.nb(r)))}}return{exists:d,isSameResourceWithDifferentPathCase:s}}N(t){const a=this.O(t);return{providerExtUri:a?g.extUri:g.extUriIgnorePathCase,isPathCaseSensitive:a}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const a=this.lb(await this.j(t),t);await this.P(a,t);const i=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new o.FileOperationEvent(t,0,i)),i}async P(t,a){const i=[],{providerExtUri:r}=this.N(t);for(;!r.isEqual(a,r.dirname(a));)try{if(((await t.stat(a)).type&o.FileType.Directory)===0)throw new Error((0,w.localize)(16,null,this.nb(a)));break}catch(c){if((0,o.toFileSystemProviderErrorCode)(c)!==o.FileSystemProviderErrorCode.FileNotFound)throw c;i.push(r.basename(a)),a=r.dirname(a)}for(let c=i.length-1;c>=0;c--){a=r.joinPath(a,i[c]);try{await t.mkdir(a)}catch(l){if((0,o.toFileSystemProviderErrorCode)(l)!==o.FileSystemProviderErrorCode.FileExists)throw l}}}async canDelete(t,a){try{await this.Q(t,a)}catch(i){return i}return!0}async Q(t,a){const i=this.lb(await this.j(t),t);if(!!a?.useTrash&&!(i.capabilities&4096))throw new Error((0,w.localize)(17,null,this.nb(t)));let c;try{c=await i.stat(t)}catch{}if(c)this.mb(t,c);else throw new o.FileOperationError((0,w.localize)(18,null,this.nb(t)),1);if(!!!a?.recursive){const s=await this.resolve(t);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error((0,w.localize)(19,null,this.nb(t)))}return i}async del(t,a){const i=await this.Q(t,a),r=!!a?.useTrash,c=!!a?.recursive;await i.delete(t,{recursive:c,useTrash:r}),this.m.fire(new o.FileOperationEvent(t,1))}async cloneFile(t,a){const i=await this.j(t),r=this.lb(await this.l(a),a);if(i===r&&this.N(i).providerExtUri.isEqual(t,a))return;if(i===r&&(0,o.hasFileCloneCapability)(i))return i.cloneFile(t,a);await this.P(r,this.N(r).providerExtUri.dirname(a));const c=this.X.queueFor(t,this.N(i).providerExtUri);return i===r&&(0,o.hasFileFolderCopyCapability)(i)?c.queue(()=>i.copy(t,a,{overwrite:!0})):c.queue(()=>this.J(i,t,r,a))}watch(t,a={recursive:!1,excludes:[]}){const i=new h.DisposableStore;let r=!1,c=()=>{r=!0};return i.add((0,h.toDisposable)(()=>c())),(async()=>{try{const l=await this.W(t,a);r?(0,h.dispose)(l):c=()=>(0,h.dispose)(l)}catch(l){this.b.error(l)}})(),i}async W(t,a){const i=await this.j(t),r=(0,P.hash)([this.N(i).providerExtUri.getComparisonKey(t),a]);let c=this.U.get(r);return c||(c={count:0,disposable:i.watch(t,a)},this.U.set(r,c)),c.count+=1,(0,h.toDisposable)(()=>{c&&(c.count--,c.count===0&&((0,h.dispose)(c.disposable),this.U.delete(r)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,h.dispose)(t.disposable);this.U.clear()}async Y(t,a,i,r){return this.X.queueFor(a,this.N(t).providerExtUri).queue(async()=>{const c=await t.open(a,{create:!0,unlock:i?.unlock??!1});try{(0,m.isReadableStream)(r)||(0,m.isReadableBufferedStream)(r)?await this.Z(t,c,r):await this.ab(t,c,r)}catch(l){throw(0,o.ensureFileSystemProviderError)(l)}finally{await t.close(c)}})}async Z(t,a,i){let r=0,c;if((0,m.isReadableBufferedStream)(i)){if(i.buffer.length>0){const l=n.VSBuffer.concat(i.buffer);await this.bb(t,a,l,l.byteLength,r,0),r+=l.byteLength}if(i.ended)return;c=i.stream}else c=i;return new Promise((l,s)=>{(0,m.listenStream)(c,{onData:async d=>{c.pause();try{await this.bb(t,a,d,d.byteLength,r,0)}catch(S){return s(S)}r+=d.byteLength,setTimeout(()=>c.resume())},onError:d=>s(d),onEnd:()=>l()})})}async ab(t,a,i){let r=0,c;for(;(c=i.read())!==null;)await this.bb(t,a,c,c.byteLength,r,0),r+=c.byteLength}async bb(t,a,i,r,c,l){let s=0;for(;s<r;)s+=await t.write(a,c+s,i.buffer,l+s,r-s)}async cb(t,a,i,r){return this.X.queueFor(a,this.N(t).providerExtUri).queue(()=>this.db(t,a,i,r))}async db(t,a,i,r){let c;r instanceof n.VSBuffer?c=r:(0,m.isReadableStream)(r)?c=await(0,n.streamToBuffer)(r):(0,m.isReadableBufferedStream)(r)?c=await(0,n.bufferedStreamToBuffer)(r):c=(0,n.readableToBuffer)(r),await t.writeFile(a,c.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1})}async eb(t,a,i,r){return this.X.queueFor(r,this.N(i).providerExtUri).queue(()=>this.fb(t,a,i,r))}async fb(t,a,i,r){let c,l;try{c=await t.open(a,{create:!1}),l=await i.open(r,{create:!0,unlock:!1});const s=n.VSBuffer.alloc(this.a);let d=0,S=0,R=0;do R=await t.read(c,d,s.buffer,S,s.byteLength-S),await this.bb(i,l,s,R,d,S),d+=R,S+=R,S===s.byteLength&&(S=0);while(R>0)}catch(s){throw(0,o.ensureFileSystemProviderError)(s)}finally{await A.Promises.settled([typeof c=="number"?t.close(c):Promise.resolve(),typeof l=="number"?i.close(l):Promise.resolve()])}}async gb(t,a,i,r){return this.X.queueFor(r,this.N(i).providerExtUri).queue(()=>this.hb(t,a,i,r))}async hb(t,a,i,r){return i.writeFile(r,await t.readFile(a),{create:!0,overwrite:!0,unlock:!1})}async ib(t,a,i,r){return this.X.queueFor(r,this.N(i).providerExtUri).queue(()=>this.jb(t,a,i,r))}async jb(t,a,i,r){const c=await i.open(r,{create:!0,unlock:!1});try{const l=await t.readFile(a);await this.bb(i,c,n.VSBuffer.wrap(l),l.byteLength,0,0)}catch(l){throw(0,o.ensureFileSystemProviderError)(l)}finally{await i.close(c)}}async kb(t,a,i,r){const c=await(0,n.streamToBuffer)(this.C(t,a,C.CancellationToken.None));await this.cb(i,r,void 0,c)}lb(t,a){if(t.capabilities&2048)throw new o.FileOperationError((0,w.localize)(20,null,this.nb(a)),6);return t}mb(t,a){if((a.permissions??0)&o.FilePermission.Readonly)throw new o.FileOperationError((0,w.localize)(21,null,this.nb(t)),6)}nb(t){return t.scheme===v.Schemas.file?t.fsPath:t.toString(!0)}};E=ve([_(0,p.ILogService)],E),e.FileService=E}),define(ee[90],te([0,1,41,289,8,35,17,3,32,2,9,4,18,60,23,168,16,110,210,44,206,205]),function(G,e,I,A,n,C,D,P,f,h,b,v,y,g,m,w,o,u,p,k,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,A.gracefulify)(I)}catch(a){console.error(`Error enabling graceful-fs: ${(0,k.toErrorMessage)(a)}`)}})();class t extends p.AbstractDiskFileSystemProvider{constructor(i,r){super(i,r),this.onDidChangeCapabilities=P.Event.None,this.H=new C.ResourceMap(c=>y.extUriBiasedIgnorePathCase.getComparisonKey(c)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,v.isLinux&&(this.F|=1024)),this.F}async stat(i){try{const{stat:r,symbolicLink:c}=await m.SymlinkSupport.stat(this.C(i));return{type:this.G(r,c),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size}}catch(r){throw this.Y(r)}}async readdir(i){try{const r=await m.Promises.readdir(this.C(i),{withFileTypes:!0}),c=[];return await Promise.all(r.map(async l=>{try{let s;l.isSymbolicLink()?s=(await this.stat((0,y.joinPath)(i,l.name))).type:s=this.G(l),c.push([l.name,s])}catch(s){this.a.trace(s)}})),c}catch(r){throw this.Y(r)}}G(i,r){let c;return r?.dangling?c=o.FileType.Unknown:i.isFile()?c=o.FileType.File:i.isDirectory()?c=o.FileType.Directory:c=o.FileType.Unknown,r&&(c|=o.FileType.SymbolicLink),c}async I(i){const r=this.C(i);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let c;for(;c=this.H.get(i);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await c.wait();const l=new n.Barrier;return this.H.set(i,l),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,h.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.H.get(i)===l&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.H.delete(i)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),l.open()})}async readFile(i,r){let c;try{r?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(i)})`),c=await this.I(i));const l=this.C(i);return await m.Promises.readFile(l)}catch(l){throw this.Y(l)}finally{c?.dispose()}}J(i){t.D&&this.a.trace(i)}readFileStream(i,r,c){const l=(0,g.newWriteableStream)(s=>D.VSBuffer.concat(s.map(d=>D.VSBuffer.wrap(d))).buffer);return(0,u.readFileIntoStream)(this,i,l,s=>s.buffer,{...r,bufferSize:256*1024},c),l}async writeFile(i,r,c){let l;try{const s=this.C(i);if(!c.create||!c.overwrite){if(await m.Promises.exists(s)){if(!c.overwrite)throw(0,o.createFileSystemProviderError)((0,w.localize)(0,null),o.FileSystemProviderErrorCode.FileExists)}else if(!c.create)throw(0,o.createFileSystemProviderError)((0,w.localize)(1,null),o.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(i,{create:!0,unlock:c.unlock}),await this.write(l,0,r,0,r.byteLength)}catch(s){throw await this.Z(i,s)}finally{typeof l=="number"&&await this.close(l)}}static configureFlushOnWrite(i){t.O=i}async open(i,r){const c=this.C(i);let l;(0,o.isFileOpenForWriteOptions)(r)&&(l=await this.I(i));let s;try{if((0,o.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:S}=await m.SymlinkSupport.stat(c);S.mode&128||await m.Promises.chmod(c,S.mode|128)}catch(S){this.a.trace(S)}let d;if((0,o.isFileOpenForWriteOptions)(r)){if(v.isWindows)try{await m.Promises.truncate(c,0),d="r+"}catch(S){S.code!=="ENOENT"&&this.a.trace(S)}d||(d="w")}else d="r";s=await m.Promises.open(c,d)}catch(d){throw l?.dispose(),(0,o.isFileOpenForWriteOptions)(r)?await this.Z(i,d):this.Y(d)}if(this.L.set(s,0),(0,o.isFileOpenForWriteOptions)(r)&&this.N.set(s,i),l){const d=this.M.get(s);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${s} (${c})`),this.M.set(s,l),d&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${s} (${c})`),d.dispose())}return s}async close(i){const r=this.M.get(i);try{if(this.L.delete(i),this.N.delete(i)&&t.O)try{await m.Promises.fdatasync(i)}catch(c){t.configureFlushOnWrite(!1),this.a.error(c)}return await m.Promises.close(i)}catch(c){throw this.Y(c)}finally{r&&(this.M.get(i)===r&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.M.delete(i)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),r.dispose())}}async read(i,r,c,l,s){const d=this.P(i,r);let S=null;try{S=(await m.Promises.read(i,c,l,s,d)).bytesRead}catch(R){throw this.Y(R)}finally{this.Q(i,d,S)}return S}P(i,r){return r===this.L.get(i)?null:r}Q(i,r,c){const l=this.L.get(i);typeof l=="number"&&(typeof r=="number"||(typeof c=="number"?this.L.set(i,l+c):this.L.delete(i)))}async write(i,r,c,l,s){return(0,n.retry)(()=>this.R(i,r,c,l,s),100,3)}async R(i,r,c,l,s){const d=this.P(i,r);let S=null;try{S=(await m.Promises.write(i,c,l,s,d)).bytesWritten}catch(R){throw await this.Z(this.N.get(i),R)}finally{this.Q(i,d,S)}return S}async mkdir(i){try{await m.Promises.mkdir(this.C(i))}catch(r){throw this.Y(r)}}async delete(i,r){try{const c=this.C(i);r.recursive?await m.Promises.rm(c,m.RimRafMode.MOVE):await m.Promises.unlink(c)}catch(c){throw this.Y(c)}}async rename(i,r,c){const l=this.C(i),s=this.C(r);if(l!==s)try{await this.S(i,r,"move",c.overwrite),await m.Promises.move(l,s)}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,w.localize)(2,null,(0,b.basename)(l),(0,b.basename)((0,b.dirname)(s)),d.toString()))),this.Y(d)}}async copy(i,r,c){const l=this.C(i),s=this.C(r);if(l!==s)try{await this.S(i,r,"copy",c.overwrite),await m.Promises.copy(l,s,{preserveSymlinks:!0})}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,w.localize)(3,null,(0,b.basename)(l),(0,b.basename)((0,b.dirname)(s)),d.toString()))),this.Y(d)}}async S(i,r,c,l){const s=this.C(i),d=this.C(r);let S=!1;if(!!(this.capabilities&1024)||(S=(0,f.isEqual)(s,d,!0)),S&&c==="copy")throw(0,o.createFileSystemProviderError)((0,w.localize)(4,null),o.FileSystemProviderErrorCode.FileExists);if(!S&&await m.Promises.exists(d)){if(!l)throw(0,o.createFileSystemProviderError)((0,w.localize)(5,null),o.FileSystemProviderErrorCode.FileExists);await this.delete(r,{recursive:!0,useTrash:!1})}}async cloneFile(i,r){return this.U(i,r,!1)}async U(i,r,c){const l=this.C(i),s=this.C(r),d=!!(this.capabilities&1024);if((0,f.isEqual)(l,s,!d))return;const S=new h.DisposableStore;try{const[R,O]=await Promise.all([this.I(i),this.I(r)]);S.add(R),S.add(O),c&&await m.Promises.mkdir((0,b.dirname)(s),{recursive:!0}),await m.Promises.copyFile(l,s)}catch(R){if(R.code==="ENOENT"&&!c)return this.U(i,r,!0);throw this.Y(R)}finally{S.dispose()}}p(i,r,c){return new E.UniversalWatcherClient(l=>i(l),l=>r(l),c)}y(i,r,c){return new M.NodeJSWatcherClient(l=>i(l),l=>r(l),c)}Y(i){if(i instanceof o.FileSystemProviderError)return i;let r;switch(i.code){case"ENOENT":r=o.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=o.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=o.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=o.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=o.FileSystemProviderErrorCode.NoPermissions;break;default:r=o.FileSystemProviderErrorCode.Unknown}return(0,o.createFileSystemProviderError)(i,r)}async Z(i,r){let c=this.Y(r);if(i&&c.code===o.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await m.SymlinkSupport.stat(this.C(i));l.mode&128||(c=(0,o.createFileSystemProviderError)(r,o.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.a.trace(l)}return c}}e.DiskFileSystemProvider=t,t.D=!1,t.O=!0}),define(ee[212],te([0,1,3,90,2,17,60,22]),function(G,e,I,A,n,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class f extends n.Disposable{constructor(v,y){super(),this.a=v,this.b=y,this.w=new Map,this.y=new Map}call(v,y,g){const m=this.c(v);switch(y){case"stat":return this.g(m,g[0]);case"readdir":return this.h(m,g[0]);case"open":return this.l(m,g[0],g[1]);case"close":return this.m(g[0]);case"read":return this.n(g[0],g[1],g[2]);case"readFile":return this.i(m,g[0],g[1]);case"write":return this.p(g[0],g[1],g[2],g[3],g[4]);case"writeFile":return this.k(m,g[0],g[1],g[2]);case"rename":return this.t(m,g[0],g[1],g[2]);case"copy":return this.u(m,g[0],g[1],g[2]);case"cloneFile":return this.v(m,g[0],g[1]);case"mkdir":return this.r(m,g[0]);case"delete":return this.s(m,g[0],g[1]);case"watch":return this.C(m,g[0],g[1],g[2],g[3]);case"unwatch":return this.D(g[0],g[1])}throw new Error(`IPC Command ${y} not found`)}listen(v,y,g){const m=this.c(v);switch(y){case"fileChange":return this.z(m,g[0]);case"readFileStream":return this.j(m,g[0],g[1])}throw new Error(`Unknown event ${y}`)}g(v,y){const g=this.f(v,y,!0);return this.a.stat(g)}h(v,y){const g=this.f(v,y);return this.a.readdir(g)}async i(v,y,g){const m=this.f(v,y,!0),w=await this.a.readFile(m,g);return C.VSBuffer.wrap(w)}j(v,y,g){const m=this.f(v,y,!0),w=new P.CancellationTokenSource,o=new I.Emitter({onDidRemoveLastListener:()=>{w.cancel()}}),u=this.a.readFileStream(m,g,w.token);return(0,D.listenStream)(u,{onData:p=>o.fire(C.VSBuffer.wrap(p)),onError:p=>o.fire(p),onEnd:()=>{o.fire("end"),o.dispose(),w.dispose()}}),o.event}k(v,y,g,m){const w=this.f(v,y);return this.a.writeFile(w,g.buffer,m)}l(v,y,g){const m=this.f(v,y,!0);return this.a.open(m,g)}m(v){return this.a.close(v)}async n(v,y,g){const m=C.VSBuffer.alloc(g),w=0,o=await this.a.read(v,y,m.buffer,w,g);return[m,o]}p(v,y,g,m,w){return this.a.write(v,y,g.buffer,m,w)}r(v,y){const g=this.f(v,y);return this.a.mkdir(g)}s(v,y,g){const m=this.f(v,y);return this.a.delete(m,g)}t(v,y,g,m){const w=this.f(v,y),o=this.f(v,g);return this.a.rename(w,o,m)}u(v,y,g,m){const w=this.f(v,y),o=this.f(v,g);return this.a.copy(w,o,m)}v(v,y,g){const m=this.f(v,y),w=this.f(v,g);return this.a.cloneFile(m,w)}z(v,y){const g=new I.Emitter({onWillAddFirstListener:()=>{this.w.set(y,this.F(v,g))},onDidRemoveLastListener:()=>{(0,n.dispose)(this.w.get(y)),this.w.delete(y)}});return g.event}async C(v,y,g,m,w){const o=this.w.get(y);if(o){const u=this.f(v,m),p=o.watch(g,u,w);this.y.set(y+g,p)}}async D(v,y){const g=v+y,m=this.y.get(g);m&&((0,n.dispose)(m),this.y.delete(g))}dispose(){super.dispose();for(const[,v]of this.y)v.dispose();this.y.clear();for(const[,v]of this.w)v.dispose();this.w.clear()}}e.AbstractDiskFileSystemProviderChannel=f;class h extends n.Disposable{constructor(v,y,g,m){super(),this.c=v,this.f=g,this.g=m,this.a=new Map,this.b=this.B(new A.DiskFileSystemProvider(this.f,{watcher:{recursive:this.i(this.g)}})),this.h(y)}h(v){const y=this.B(new I.Emitter);this.B(y.event(g=>{v.fire(g.map(m=>({resource:this.c.transformOutgoingURI(m.resource),type:m.type})))})),this.B(this.b.onDidChangeFile(g=>y.fire(g))),this.B(this.b.onDidWatchError(g=>v.fire(g)))}i(v){}j(v){}watch(v,y,g){const m=this.j(this.g);return Array.isArray(m)&&(g.excludes=[...g.excludes,...m]),this.a.set(v,this.b.watch(y,g)),(0,n.toDisposable)(()=>{(0,n.dispose)(this.a.get(v)),this.a.delete(v)})}dispose(){super.dispose();for(const[,v]of this.a)v.dispose();this.a.clear()}}e.AbstractSessionFileWatcher=h}),define(ee[213],te([0,1,14,167,4,7,16,9,212,145]),function(G,e,I,A,n,C,D,P,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class b extends f.AbstractDiskFileSystemProviderChannel{constructor(g,m,w){super(g,m),this.G=w}c(g){return h.DefaultURITransformer}f(g,m){return C.URI.revive(m)}async s(g,m,w){if(!w.useTrash)return super.s(g,m,w);const o=this.f(g,m),u=(0,P.normalize)(o.fsPath);try{await I.shell.trashItem(u)}catch{throw(0,D.createFileSystemProviderError)(n.isWindows?(0,A.localize)(0,null,(0,P.basename)(u)):(0,A.localize)(1,null,(0,P.basename)(u)),D.FileSystemProviderErrorCode.Unknown)}}F(g,m){return new v(g,m,this.b,this.G)}}e.DiskFileSystemProviderChannel=b;class v extends f.AbstractSessionFileWatcher{watch(g,m,w){if(w.recursive)throw(0,D.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",D.FileSystemProviderErrorCode.Unavailable);return super.watch(g,m,w)}}}),define(ee[214],te([0,1,5]),function(G,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogger=void 0;class A extends I.AbstractMessageLogger{constructor(C=I.DEFAULT_LOG_LEVEL){super(),this.k=[],this.l=void 0,this.setLevel(C),this.B(this.onDidChangeLogLevel(D=>{this.l?.setLevel(D)}))}set logger(C){this.l=C;for(const{level:D,message:P}of this.k)(0,I.log)(C,D,P);this.k=[]}g(C,D){this.l?(0,I.log)(this.l,C,D):this.getLevel()<=C&&this.k.push({level:C,message:D})}dispose(){this.l?.dispose()}flush(){this.l?.flush()}}e.BufferLogger=A}),define(ee[215],te([0,1,2,5]),function(G,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class n extends I.Disposable{constructor(D,P=[]){super(),this.a=new A.MultiplexLogger([D,...P]),this.B(D.onDidChangeLogLevel(f=>this.setLevel(f)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(D){this.a.setLevel(D)}getLevel(){return this.a.getLevel()}trace(D,...P){this.a.trace(D,...P)}debug(D,...P){this.a.debug(D,...P)}info(D,...P){this.a.info(D,...P)}warn(D,...P){this.a.warn(D,...P)}error(D,...P){this.a.error(D,...P)}flush(){this.a.flush()}}e.LogService=n}),define(ee[216],te([0,1,35,7,5]),function(G,e,I,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerChannel=void 0;class C{constructor(P){this.b=P,this.a=new I.ResourceMap}listen(P,f,h){switch(f){case"onDidChangeLoggers":return h?this.b.getOnDidChangeLoggersEvent(h):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return h?this.b.getOnDidChangeLogLevelEvent(h):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return h?this.b.getOnDidChangeVisibilityEvent(h):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${f}`)}async call(P,f,h){switch(f){case"createLogger":this.c(A.URI.revive(h[0]),h[1],h[2]);return;case"log":return this.e(A.URI.revive(h[0]),h[1]);case"consoleLog":return this.d(h[0],h[1]);case"setLogLevel":return this.b.setLogLevel(A.URI.revive(h[0]),h[1]);case"setVisibility":return this.b.setVisibility(A.URI.revive(h[0]),h[1]);case"registerLogger":return this.b.registerLogger({...h[0],resource:A.URI.revive(h[0].resource)},h[1]);case"deregisterLogger":return this.b.deregisterLogger(A.URI.revive(h[0]))}throw new Error(`Call not found: ${f}`)}c(P,f,h){this.a.set(P,this.b.createLogger(P,f,h))}d(P,f){let h=console.log;switch(P){case n.LogLevel.Error:h=console.error;break;case n.LogLevel.Warning:h=console.warn;break;case n.LogLevel.Info:h=console.info;break}h.call(console,...f)}e(P,f){const h=this.a.get(P);if(!h)throw new Error("Create the logger before logging");for(const[b,v]of f)(0,n.log)(h,b,v)}}e.LoggerChannel=C}),define(ee[217],te([0,1,16,5]),function(G,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var n;(function(h){h[h.Trace=0]="Trace",h[h.Debug=1]="Debug",h[h.Info=2]="Info",h[h.Warning=3]="Warning",h[h.Error=4]="Error",h[h.Critical=5]="Critical",h[h.Off=6]="Off"})(n||(n={}));async function C(h,b,v,y,g){try{const m=await new Promise((o,u)=>{G(["spdlog"],o,u)});m.setFlushOn(n.Trace);const w=await m.createAsyncRotatingLogger(h,b,v,y);return g?w.clearFormatters():w.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),w}catch(m){console.error(m)}return null}function D(h,b,v){switch(b){case A.LogLevel.Trace:h.trace(v);break;case A.LogLevel.Debug:h.debug(v);break;case A.LogLevel.Info:h.info(v);break;case A.LogLevel.Warning:h.warn(v);break;case A.LogLevel.Error:h.error(v);break;case A.LogLevel.Off:break;default:throw new Error(`Invalid log level ${b}`)}}function P(h,b){switch(b){case A.LogLevel.Trace:h.setLevel(n.Trace);break;case A.LogLevel.Debug:h.setLevel(n.Debug);break;case A.LogLevel.Info:h.setLevel(n.Info);break;case A.LogLevel.Warning:h.setLevel(n.Warning);break;case A.LogLevel.Error:h.setLevel(n.Error);break;case A.LogLevel.Off:h.setLevel(n.Off);break;default:throw new Error(`Invalid log level ${b}`)}}class f extends A.AbstractMessageLogger{constructor(b,v,y,g,m){super(),this.k=[],this.setLevel(m),this.l=this.n(b,v,y,g),this.B(this.onDidChangeLogLevel(w=>{this.m&&P(this.m,w)}))}async n(b,v,y,g){const m=y?6:1,w=30/m*I.ByteSize.MB,o=await C(b,v,w,m,g);if(o){this.m=o,P(this.m,this.getLevel());for(const{level:u,message:p}of this.k)D(this.m,u,p);this.k=[]}}g(b,v){this.m?D(this.m,b,v):this.getLevel()<=b&&this.k.push({level:b,message:v})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=f}),define(ee[218],te([0,1,31,5,217]),function(G,e,I,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class C extends A.AbstractLoggerService{k(P,f,h){return new n.SpdLogLogger((0,I.generateUuid)(),P.fsPath,!h?.donotRotate,!!h?.donotUseFormatters,f)}}e.LoggerService=C}),define(ee[65],te([0,1,35,3,6,5,218]),function(G,e,I,A,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerMainService=e.ILoggerMainService=void 0,e.ILoggerMainService=(0,n.refineServiceDecorator)(C.ILoggerService);class P extends D.LoggerService{constructor(){super(...arguments),this.m=new I.ResourceMap}createLogger(h,b,v){v!==void 0&&this.m.set(h,v);try{return super.createLogger(h,b)}catch(y){throw this.m.delete(h),y}}registerLogger(h,b){b!==void 0&&this.m.set(h.resource,b),super.registerLogger(h)}deregisterLogger(h){this.m.delete(h),super.deregisterLogger(h)}getRegisteredLoggers(h){const b=[];for(const v of super.getRegisteredLoggers())h===this.m.get(v.resource)&&b.push(v);return b}getOnDidChangeLogLevelEvent(h){return A.Event.filter(this.onDidChangeLogLevel,b=>(0,C.isLogLevel)(b)||this.n(b[0],h))}getOnDidChangeVisibilityEvent(h){return A.Event.filter(this.onDidChangeVisibility,([b])=>this.n(b,h))}getOnDidChangeLoggersEvent(h){return A.Event.filter(A.Event.map(this.onDidChangeLoggers,b=>({added:[...b.added].filter(y=>this.n(y.resource,h)),removed:[...b.removed].filter(y=>this.n(y.resource,h))})),b=>b.added.length>0||b.removed.length>0)}deregisterLoggers(h){for(const[b,v]of this.m)v===h&&this.deregisterLogger(b)}n(h,b){const v=this.m.get(h);return v===void 0||v===b}dispose(){super.dispose(),this.m.clear()}}e.LoggerMainService=P}),define(ee[219],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function I(D){return D.submenu!==void 0}e.isMenubarMenuItemSubmenu=I;function A(D){return D.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=A;function n(D){return D.uri!==void 0}e.isMenubarMenuItemRecentAction=n;function C(D){return!I(D)&&!A(D)&&!n(D)}e.isMenubarMenuItemAction=C}),define(ee[37],te([0,1,3,70,2,6]),function(G,e,I,A,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,C.createDecorator)("policy");class D extends n.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new I.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(h){const b=Object.keys(this.f).length;return this.f={...h,...this.f},b!==Object.keys(this.f).length&&await this.i(h),A.Iterable.reduce(this.g.entries(),(v,[y,g])=>({...v,[y]:g}),{})}getPolicyValue(h){return this.g.get(h)}serialize(){return A.Iterable.reduce(Object.entries(this.f),(h,[b,v])=>({...h,[b]:{definition:v,value:this.g.get(b)}}),{})}}e.AbstractPolicyService=D;class P{constructor(){this.onDidChange=I.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=P}),define(ee[220],te([0,1,8,3,70,10,16,5,37]),function(G,e,I,A,n,C,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function h(v,y){const g=[];for(const m of new Set(n.Iterable.concat(v.keys(),y.keys())))v.get(m)!==y.get(m)&&g.push(m);return g}let b=class extends f.AbstractPolicyService{constructor(y,g,m){super(),this.j=y,this.k=g,this.l=m,this.c=this.B(new I.ThrottledDelayer(500));const w=A.Event.filter(g.onDidFilesChange,o=>o.affects(y));this.B(g.watch(y)),this.B(w(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const y=new Map;try{const g=await this.k.readFile(this.j),m=JSON.parse(g.value.toString());if(!(0,C.isObject)(m))throw new Error("Policy file isn't a JSON object");for(const w of Object.keys(m))this.f[w]&&y.set(w,m[w])}catch(g){g.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",g)}return y}async p(){const y=await this.n(),g=h(this.g,y);this.g=y,g.length>0&&this.h.fire(g)}};b=ve([_(1,D.IFileService),_(2,P.ILogService)],b),e.FilePolicyService=b}),define(ee[221],te([0,1,3,2,37]),function(G,e,I,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class C{constructor(f){this.b=f,this.a=new A.DisposableStore}listen(f,h){switch(h){case"onDidChange":return I.Event.map(this.b.onDidChange,b=>b.reduce((v,y)=>({...v,[y]:this.b.getPolicyValue(y)??null}),{}),this.a)}throw new Error(`Event not found: ${h}`)}call(f,h,b){switch(h){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(b)}throw new Error(`Call not found: ${h}`)}dispose(){this.a.dispose()}}e.PolicyChannel=C;class D extends n.AbstractPolicyService{constructor(f,h){super(),this.a=h;for(const b in f){const{definition:v,value:y}=f[b];this.f[b]=v,y!==void 0&&this.g.set(b,y)}this.a.listen("onDidChange")(b=>{for(const v in b){const y=b[v];y===null?this.g.delete(v):this.g.set(v,y)}this.h.fire(Object.keys(b))})}async i(f){const h=await this.a.call("updatePolicyDefinitions",f);for(const b in h)this.g.set(b,h[b])}}e.PolicyChannelClient=D}),define(ee[66],te([0,1,4,36]),function(G,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let n;if(typeof I.globals.vscode<"u"&&typeof I.globals.vscode.context<"u"){const C=I.globals.vscode.context.configuration();if(C)n=C.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(n=globalThis._VSCODE_PRODUCT_JSON,A.env.VSCODE_DEV&&Object.assign(n,{nameShort:`${n.nameShort} Dev`,nameLong:`${n.nameLong} Dev`,dataFolderName:`${n.dataFolderName}-dev`,serverDataFolderName:n.serverDataFolderName?`${n.serverDataFolderName}-dev`:void 0}),!n.version){const C=globalThis._VSCODE_PACKAGE_JSON;Object.assign(n,{version:C.version})}}else n={},Object.keys(n).length===0&&Object.assign(n,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=n}),define(ee[20],te([0,1,6]),function(G,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,I.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ee[222],te([0,1,81,5,20]),function(G,e,I,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let C=class{constructor(P,f){this.b=P,this.c=f,this.a=new Map}async isExtensionUrlTrusted(P,f){if(!this.b.trustedExtensionUrlPublicKeys)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const h=/^(.*)#([^#]+)$/.exec(f);if(!h)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",f),!1;const[,b,v]=h;let y=this.a.get(P);if(!y){if(y=this.b.trustedExtensionUrlPublicKeys[P],!y||y.length===0)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",P),!1;this.a.set(P,[...y])}const g=Buffer.from(decodeURIComponent(v),"base64");if(g.length<=6)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",f),!1;const m=g.slice(0,6),w=g.readUIntBE(0,6),o=Date.now()-w;if(o<0||o>36e5)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",f),!1;const u=g.slice(6),p=I.createVerify("SHA256");p.write(m),p.write(Buffer.from(b)),p.end();for(let k=0;k<y.length;k++){let E=y[k];if(E!==null){if(typeof E=="string")try{E=I.createPublicKey({key:Buffer.from(E,"base64"),format:"der",type:"spki"}),y[k]=E}catch(M){this.c.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${k+1} for ${P}:`,M),y[k]=null;continue}if(p.verify(E,u))return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",f),!0}}return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",f),!1}};C=ve([_(0,n.IProductService),_(1,A.ILogService)],C),e.ExtensionUrlTrustService=C}),define(ee[223],te([0,1,8,5]),function(G,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=void 0;let n=class{constructor(D,P,f){this.a=D,this.b=P,this.c=f}async inspect(D){await this.d();const P=this.a.webContents.debugger;await P.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,I.timeout)(D);const f=await P.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),f.profile}async d(){const D=this.a.webContents.debugger;D.attach(),await D.sendCommand("Profiler.enable")}async e(){const D=this.a.webContents.debugger;await D.sendCommand("Profiler.disable"),D.detach()}};n=ve([_(2,A.ILogService)],n),e.WindowProfiler=n}),define(ee[67],te([0,1,6]),function(G,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,I.createDecorator)("protocolMainService")}),define(ee[51],te([0,1,123,10]),function(G,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class n{constructor(){this.a=new Map}add(D,P){I.ok(A.isString(D)),I.ok(A.isObject(P)),I.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,P)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}e.Registry=new n}),define(ee[224],te([0,1,3,51]),function(G,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function n(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class C{constructor(){this.b=new I.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(f,h){this.a[n(f)]=h,this.b.fire(f)}notifySchemaChanged(f){this.b.fire(f)}getSchemaContributions(){return{schemas:this.a}}}const D=new C;A.Registry.add(e.Extensions.JSONContribution,D)}),define(ee[68],te([0,1,25,3,10,154,19,224,51]),function(G,e,I,A,n,C,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var h;(function(M){M.Multiline="multilineText",M.Singleline="singlelineText"})(h=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var b;(function(M){M[M.APPLICATION=1]="APPLICATION",M[M.MACHINE=2]="MACHINE",M[M.WINDOW=3]="WINDOW",M[M.RESOURCE=4]="RESOURCE",M[M.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",M[M.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(b=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const v=f.Registry.as(P.Extensions.JSONContribution);class y{constructor(){this.h=new Set,this.i=new A.Emitter,this.onDidSchemaChange=this.i.event,this.j=new A.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:C.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},v.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,a=!0){this.registerConfigurations([t],a)}registerConfigurations(t,a=!0){const i=new Set;this.n(t,a,i),v.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(t){const a=new Set;this.o(t,a),v.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:a})}updateConfigurations({add:t,remove:a}){const i=new Set;this.o(a,i),this.n(t,!1,i),v.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}registerDefaultConfigurations(t){const a=new Set;this.k(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}k(t,a){const i=[];for(const{overrides:r,source:c}of t)for(const l in r)if(a.add(l),e.OVERRIDE_PROPERTY_REGEX.test(l)){const s=this.a.get(l),d=s?.valuesSources??new Map;if(c)for(const N of Object.keys(r[l]))d.set(N,c);const S={...s?.value||{},...r[l]};this.a.set(l,{source:c,value:S,valuesSources:d});const R=(0,D.getLanguageTagSettingPlainKey)(l),O={type:"object",default:S,description:C.localize(1,null,R),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:S,source:n.isString(c)?void 0:c,defaultValueSource:c};i.push(...w(l)),this.d[l]=O,this.b.properties[l]=O}else{this.a.set(l,{value:r[l],source:c});const s=this.d[l];s&&(this.w(l,s),this.r(l,s))}this.m(i)}deregisterDefaultConfigurations(t){const a=new Set;this.l(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}l(t,a){for(const{overrides:i,source:r}of t)for(const c in i){const l=this.a.get(c),s=n.isString(r)?r:r?.id,d=n.isString(l?.source)?l?.source:l?.source?.id;if(s===d)if(a.add(c),this.a.delete(c),e.OVERRIDE_PROPERTY_REGEX.test(c))delete this.d[c],delete this.b.properties[c];else{const S=this.d[c];S&&(this.w(c,S),this.r(c,S))}}this.u()}deltaConfiguration(t){let a=!1;const i=new Set;t.removedDefaults&&(this.l(t.removedDefaults,i),a=!0),t.addedDefaults&&(this.k(t.addedDefaults,i),a=!0),t.removedConfigurations&&this.o(t.removedConfigurations,i),t.addedConfigurations&&this.n(t.addedConfigurations,!1,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const a of t)this.h.add(a);this.u()}n(t,a,i){t.forEach(r=>{this.p(r,a,r.extensionInfo,r.restrictedProperties,void 0,i),this.c.push(r),this.q(r)})}o(t,a){const i=r=>{if(r.properties)for(const c in r.properties){a.add(c);const l=this.d[c];l?.policy?.name&&this.e.delete(l.policy.name),delete this.d[c],this.s(c,r.properties[c])}r.allOf?.forEach(c=>i(c))};for(const r of t){i(r);const c=this.c.indexOf(r);c!==-1&&this.c.splice(c,1)}}p(t,a=!0,i,r,c=3,l){c=n.isUndefinedOrNull(t.scope)?c:t.scope;const s=t.properties;if(s)for(const S in s){const R=s[S];if(a&&k(S,R)){delete s[S];continue}if(R.source=i,R.defaultDefaultValue=s[S].default,this.w(S,R),e.OVERRIDE_PROPERTY_REGEX.test(S)?R.scope=void 0:(R.scope=n.isUndefinedOrNull(R.scope)?c:R.scope,R.restricted=n.isUndefinedOrNull(R.restricted)?!!r?.includes(S):R.restricted),s[S].hasOwnProperty("included")&&!s[S].included){this.f[S]=s[S],delete s[S];continue}else this.d[S]=s[S],s[S].policy?.name&&this.e.set(s[S].policy.name,S);!s[S].deprecationMessage&&s[S].markdownDeprecationMessage&&(s[S].deprecationMessage=s[S].markdownDeprecationMessage),l.add(S)}const d=t.allOf;if(d)for(const S of d)this.p(S,a,i,r,c,l)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const a=i=>{const r=i.properties;if(r)for(const l in r)this.r(l,r[l]);i.allOf?.forEach(a)};a(t)}r(t,a){switch(e.allSettings.properties[t]=a,a.scope){case 1:e.applicationSettings.properties[t]=a;break;case 2:e.machineSettings.properties[t]=a;break;case 6:e.machineOverridableSettings.properties[t]=a;break;case 3:e.windowSettings.properties[t]=a;break;case 4:e.resourceSettings.properties[t]=a;break;case 5:e.resourceSettings.properties[t]=a,this.g.properties[t]=a;break}}s(t,a){switch(delete e.allSettings.properties[t],a.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const a=`[${t}]`,i={type:"object",description:C.localize(2,null),errorMessage:C.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(a,i),e.allSettings.properties[a]=i,e.applicationSettings.properties[a]=i,e.machineSettings.properties[a]=i,e.machineOverridableSettings.properties[a]=i,e.windowSettings.properties[a]=i,e.resourceSettings.properties[a]=i}}v(){const t={type:"object",description:C.localize(4,null),errorMessage:C.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,a){const i=this.a.get(t);let r=i?.value,c=i?.source;n.isUndefined(r)&&(r=a.defaultDefaultValue,c=void 0),n.isUndefined(r)&&(r=u(a.type)),a.default=r,a.defaultValueSource=c}}const g="\\[([^\\]]+)\\]",m=new RegExp(g,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${g})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function w(M){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(M)){let a=m.exec(M);for(;a?.length;){const i=a[1].trim();i&&t.push(i),a=m.exec(M)}}return(0,I.distinct)(t)}e.overrideIdentifiersFromKey=w;function o(M){return M.reduce((t,a)=>`${t}[${a}]`,"")}e.keyFromOverrideIdentifiers=o;function u(M){switch(Array.isArray(M)?M[0]:M){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const p=new y;f.Registry.add(e.Extensions.Configuration,p);function k(M,t){return M.trim()?e.OVERRIDE_PROPERTY_REGEX.test(M)?C.localize(7,null,M):p.getConfigurationProperties()[M]!==void 0?C.localize(8,null,M):t.policy?.name&&p.getPolicyConfigurations().get(t.policy?.name)!==void 0?C.localize(9,null,M,t.policy?.name,p.getPolicyConfigurations().get(t.policy?.name)):null:C.localize(6,null)}e.validateProperty=k;function E(){const M=[],t=p.getConfigurationProperties();for(const a of Object.keys(t))M.push([a,t[a].scope]);return M.push(["launch",4]),M.push(["task",4]),M}e.getScopes=E}),define(ee[111],te([0,1,25,3,43,2,35,40,10,7,19,68,51]),function(G,e,I,A,n,C,D,P,f,h,b,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function g(a){return Object.isFrozen(a)?a:P.deepFreeze(a)}class m{constructor(i={},r=[],c=[],l){this.b=i,this.c=r,this.d=c,this.raw=l,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const i=this.raw.map(r=>{if(r instanceof m)return r;const c=new w("");return c.parseRaw(r),c.configurationModel});this.f=i.reduce((r,c)=>c===r?c:r.merge(c),i[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,b.getConfigurationValue)(this.contents,i):this.contents}inspect(i,r){const c=this.rawConfiguration.getValue(i),l=r?this.rawConfiguration.getOverrideValue(i,r):void 0,s=r?this.rawConfiguration.override(r).getValue(i):c;return{value:c,override:l,merged:s}}getOverrideValue(i,r){const c=this.i(r);return c?i?(0,b.getConfigurationValue)(c,i):c:void 0}getKeysForOverrideIdentifier(i){const r=[];for(const c of this.overrides)c.identifiers.includes(i)&&r.push(...c.keys);return I.distinct(r)}getAllOverrideIdentifiers(){const i=[];for(const r of this.overrides)i.push(...r.identifiers);return I.distinct(i)}override(i){let r=this.a.get(i);return r||(r=this.g(i),this.a.set(i,r)),r}merge(...i){const r=P.deepClone(this.contents),c=P.deepClone(this.overrides),l=[...this.keys],s=this.raw?.length?[...this.raw]:[this];for(const d of i)if(s.push(...d.raw?.length?d.raw:[d]),!d.isEmpty()){this.h(r,d.contents);for(const S of d.overrides){const[R]=c.filter(O=>I.equals(O.identifiers,S.identifiers));R?(this.h(R.contents,S.contents),R.keys.push(...S.keys),R.keys=I.distinct(R.keys)):c.push(P.deepClone(S))}for(const S of d.keys)l.indexOf(S)===-1&&l.push(S)}return new m(r,l,c,s.every(d=>d instanceof m)?void 0:s)}g(i){const r=this.i(i);if(!r||typeof r!="object"||!Object.keys(r).length)return this;const c={};for(const l of I.distinct([...Object.keys(this.contents),...Object.keys(r)])){let s=this.contents[l];const d=r[l];d&&(typeof s=="object"&&typeof d=="object"?(s=P.deepClone(s),this.h(s,d)):s=d),c[l]=s}return new m(c,this.keys,this.overrides)}h(i,r){for(const c of Object.keys(r)){if(c in i&&f.isObject(i[c])&&f.isObject(r[c])){this.h(i[c],r[c]);continue}i[c]=P.deepClone(r[c])}}i(i){let r=null,c=null;const l=s=>{s&&(c?this.h(c,s):c=P.deepClone(s))};for(const s of this.overrides)I.equals(s.identifiers,[i])?r=s.contents:s.identifiers.includes(i)&&l(s.contents);return l(r),c}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,r){this.j(i,r,!0)}setValue(i,r){this.j(i,r,!1)}removeValue(i){const r=this.keys.indexOf(i);r!==-1&&(this.keys.splice(r,1),(0,b.removeFromValueTree)(this.contents,i),v.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.splice(this.overrides.findIndex(c=>I.equals(c.identifiers,(0,v.overrideIdentifiersFromKey)(i))),1))}j(i,r,c){(0,b.addToValueTree)(this.contents,i,r,l=>console.error(l)),c=c||this.keys.indexOf(i)===-1,c&&this.keys.push(i),v.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.push({identifiers:(0,v.overrideIdentifiersFromKey)(i),keys:Object.keys(this.contents[i]),contents:(0,b.toValuesTree)(this.contents[i],l=>console.error(l))})}}e.ConfigurationModel=m;class w{constructor(i){this.f=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new m}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,r){if(!f.isUndefinedOrNull(i)){const c=this.g(i);this.parseRaw(c,r)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,r){this.a=i;const{contents:c,keys:l,overrides:s,restricted:d,hasExcludedProperties:S}=this.h(i,r);this.b=new m(c,l,s,S?[i]:void 0),this.c=d||[]}g(i){let r={},c=null,l=[];const s=[],d=[];function S(O){Array.isArray(l)?l.push(O):c!==null&&(l[c]=O)}const R={onObjectBegin:()=>{const O={};S(O),s.push(l),l=O,c=null},onObjectProperty:O=>{c=O},onObjectEnd:()=>{l=s.pop()},onArrayBegin:()=>{const O=[];S(O),s.push(l),l=O,c=null},onArrayEnd:()=>{l=s.pop()},onLiteralValue:S,onError:(O,N,K)=>{d.push({error:O,offset:N,length:K})}};if(i)try{n.visit(i,R),r=l[0]||{}}catch(O){console.error(`Error while parsing settings file ${this.f}: ${O}`),this.d=[O]}return r}h(i,r){const c=y.Registry.as(v.Extensions.Configuration).getConfigurationProperties(),l=this.i(i,c,!0,r);i=l.raw;const s=(0,b.toValuesTree)(i,R=>console.error(`Conflict in settings file ${this.f}: ${R}`)),d=Object.keys(i),S=this.j(i,R=>console.error(`Conflict in settings file ${this.f}: ${R}`));return{contents:s,keys:d,overrides:S,restricted:l.restricted,hasExcludedProperties:l.hasExcludedProperties}}i(i,r,c,l){let s=!1;if(!l?.scopes&&!l?.skipRestricted)return{raw:i,restricted:[],hasExcludedProperties:s};const d={},S=[];for(const R in i)if(v.OVERRIDE_PROPERTY_REGEX.test(R)&&c){const O=this.i(i[R],r,!1,l);d[R]=O.raw,s=s||O.hasExcludedProperties,S.push(...O.restricted)}else{const O=r[R],N=O?typeof O.scope<"u"?O.scope:3:void 0;O?.restricted&&S.push(R),(N===void 0||l.scopes===void 0||l.scopes.includes(N))&&!(l.skipRestricted&&O?.restricted)?d[R]=i[R]:s=!0}return{raw:d,restricted:S,hasExcludedProperties:s}}j(i,r){const c=[];for(const l of Object.keys(i))if(v.OVERRIDE_PROPERTY_REGEX.test(l)){const s={};for(const d in i[l])s[d]=i[l][d];c.push({identifiers:(0,v.overrideIdentifiersFromKey)(l),keys:Object.keys(s),contents:(0,b.toValuesTree)(s,r)})}return c}}e.ConfigurationModelParser=w;class o extends C.Disposable{constructor(i,r,c,l){super(),this.f=i,this.g=r,this.h=l,this.c=this.B(new A.Emitter),this.onDidChange=this.c.event,this.a=new w(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(c.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(A.Event.any(A.Event.filter(this.h.onDidFilesChange,s=>s.contains(this.f)),A.Event.filter(this.h.onDidRunOperation,s=>(s.isOperation(0)||s.isOperation(3)||s.isOperation(1)||s.isOperation(4))&&c.isEqual(s.resource,i)))(()=>this.c.fire()))}async loadConfiguration(){try{const i=await this.h.readFile(this.f);return this.a.parse(i.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new m}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=o;class u{constructor(i,r,c,l,s,d,S,R,O,N,K,V,X){this.a=i,this.b=r,this.c=c,this.overrideIdentifiers=l,this.d=s,this.f=d,this.g=S,this.h=R,this.i=O,this.j=N,this.k=K,this.l=V,this.m=X}get value(){return g(this.c)}n(i,r,c){const l=i.inspect(r,c);return{get value(){return g(l.value)},get override(){return g(l.override)},get merged(){return g(l.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class p{constructor(i,r,c,l,s=new m,d=new m,S=new D.ResourceMap,R=new m,O=new D.ResourceMap){this.c=i,this.d=r,this.f=c,this.g=l,this.h=s,this.i=d,this.j=S,this.l=R,this.m=O,this.a=null,this.b=new D.ResourceMap,this.n=null}getValue(i,r,c){return this.q(i,r,c).getValue(i)}updateValue(i,r,c={}){let l;c.resource?(l=this.m.get(c.resource),l||(l=new m,this.m.set(c.resource,l))):l=this.l,r===void 0?l.removeValue(i):l.setValue(i,r),c.resource||(this.a=null)}inspect(i,r,c){const l=this.q(i,r,c),s=this.u(r.resource,c),d=r.resource?this.m.get(r.resource)||this.l:this.l,S=new Set;for(const R of l.overrides)for(const O of R.identifiers)l.getOverrideValue(i,O)!==void 0&&S.add(O);return new u(i,r,l.getValue(i),S.size?[...S]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,c?this.i:void 0,s||void 0,d)}keys(i){const r=this.u(void 0,i);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:r?r.keys.slice(0):[]}}updateDefaultConfiguration(i){this.c=i,this.a=null,this.b.clear()}updatePolicyConfiguration(i){this.d=i}updateApplicationConfiguration(i){this.f=i,this.a=null,this.b.clear()}updateLocalUserConfiguration(i){this.g=i,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(i){this.h=i,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(i){this.i=i,this.a=null,this.b.clear()}updateFolderConfiguration(i,r){this.j.set(i,r),this.b.delete(i)}deleteFolderConfiguration(i){this.p.delete(i),this.b.delete(i)}compareAndUpdateDefaultConfiguration(i,r){const c=[];if(!r){const{added:l,updated:s,removed:d}=M(this.c,i);r=[...l,...s,...d]}for(const l of r)for(const s of(0,v.overrideIdentifiersFromKey)(l)){const d=this.c.getKeysForOverrideIdentifier(s),S=i.getKeysForOverrideIdentifier(s),R=[...S.filter(O=>d.indexOf(O)===-1),...d.filter(O=>S.indexOf(O)===-1),...d.filter(O=>!P.equals(this.c.override(s).getValue(O),i.override(s).getValue(O)))];c.push([s,R])}return this.updateDefaultConfiguration(i),{keys:r,overrides:c}}compareAndUpdatePolicyConfiguration(i){const{added:r,updated:c,removed:l}=M(this.d,i),s=[...r,...c,...l];return s.length&&this.updatePolicyConfiguration(i),{keys:s,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:r,updated:c,removed:l,overrides:s}=M(this.applicationConfiguration,i),d=[...r,...c,...l];return d.length&&this.updateApplicationConfiguration(i),{keys:d,overrides:s}}compareAndUpdateLocalUserConfiguration(i){const{added:r,updated:c,removed:l,overrides:s}=M(this.localUserConfiguration,i),d=[...r,...c,...l];return d.length&&this.updateLocalUserConfiguration(i),{keys:d,overrides:s}}compareAndUpdateRemoteUserConfiguration(i){const{added:r,updated:c,removed:l,overrides:s}=M(this.remoteUserConfiguration,i),d=[...r,...c,...l];return d.length&&this.updateRemoteUserConfiguration(i),{keys:d,overrides:s}}compareAndUpdateWorkspaceConfiguration(i){const{added:r,updated:c,removed:l,overrides:s}=M(this.workspaceConfiguration,i),d=[...r,...c,...l];return d.length&&this.updateWorkspaceConfiguration(i),{keys:d,overrides:s}}compareAndUpdateFolderConfiguration(i,r){const c=this.p.get(i),{added:l,updated:s,removed:d,overrides:S}=M(c,r),R=[...l,...s,...d];return(R.length||!c)&&this.updateFolderConfiguration(i,r),{keys:R,overrides:S}}compareAndDeleteFolderConfiguration(i){const r=this.p.get(i);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:c,updated:l,removed:s,overrides:d}=M(r,void 0);return{keys:[...c,...l,...s],overrides:d}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(i,r,c){let l=this.r(r,c);return r.overrideIdentifier&&(l=l.override(r.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(i)!==void 0&&(l=l.merge(this.d)),l}r({resource:i},r){let c=this.s();if(r&&i){const l=r.getFolder(i);l&&(c=this.t(l.uri)||c);const s=this.m.get(i);s&&(c=c.merge(s))}return c}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(i){let r=this.b.get(i);if(!r){const c=this.s(),l=this.j.get(i);l?(r=c.merge(l),this.b.set(i,r)):r=c}return r}u(i,r){if(r&&i){const c=r.getFolder(i);if(c)return this.j.get(c.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((i,r)=>{const{contents:c,overrides:l,keys:s}=this.j.get(r);return i.push([r,{contents:c,overrides:l,keys:s}]),i},[])}}allKeys(){const i=new Set;return this.c.keys.forEach(r=>i.add(r)),this.userConfiguration.keys.forEach(r=>i.add(r)),this.i.keys.forEach(r=>i.add(r)),this.j.forEach(r=>r.keys.forEach(c=>i.add(c))),[...i.values()]}v(){const i=new Set;return this.c.getAllOverrideIdentifiers().forEach(r=>i.add(r)),this.userConfiguration.getAllOverrideIdentifiers().forEach(r=>i.add(r)),this.i.getAllOverrideIdentifiers().forEach(r=>i.add(r)),this.j.forEach(r=>r.getAllOverrideIdentifiers().forEach(c=>i.add(c))),[...i.values()]}w(i){const r=new Set;return this.c.getKeysForOverrideIdentifier(i).forEach(c=>r.add(c)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(c=>r.add(c)),this.i.getKeysForOverrideIdentifier(i).forEach(c=>r.add(c)),this.j.forEach(c=>c.getKeysForOverrideIdentifier(i).forEach(l=>r.add(l))),[...r.values()]}static parse(i){const r=this.x(i.defaults),c=this.x(i.policy),l=this.x(i.application),s=this.x(i.user),d=this.x(i.workspace),S=i.folders.reduce((R,O)=>(R.set(h.URI.revive(O[0]),this.x(O[1])),R),new D.ResourceMap);return new p(r,c,l,s,new m,d,S,new m,new D.ResourceMap)}static x(i){return new m(i.contents,i.keys,i.overrides)}}e.Configuration=p;function k(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const i=new Set,r=new Map;for(const l of a)l.keys.forEach(s=>i.add(s)),l.overrides.forEach(([s,d])=>{const S=(0,D.getOrSet)(r,s,new Set);d.forEach(R=>S.add(R))});const c=[];return r.forEach((l,s)=>c.push([s,[...l.values()]])),{keys:[...i.values()],overrides:c}}e.mergeChanges=k;class E{constructor(i,r,c,l){this.change=i,this.f=r,this.g=c,this.h=l,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const s of i.keys)this.affectedKeys.add(s);for(const[,s]of i.overrides)for(const d of s)this.affectedKeys.add(d);this.d=this.a;for(const s of this.affectedKeys)this.d+=s+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=p.parse(this.f.data)),this.i}affectsConfiguration(i,r){const c=this.a+i,l=this.d.indexOf(c);if(l<0)return!1;const s=l+c.length;if(s>=this.d.length)return!1;const d=this.d.charCodeAt(s);if(d!==this.b&&d!==this.c)return!1;if(r){const S=this.previousConfiguration?this.previousConfiguration.getValue(i,r,this.f?.workspace):void 0,R=this.g.getValue(i,r,this.h);return!P.equals(S,R)}return!0}}e.ConfigurationChangeEvent=E;function M(a,i){const{added:r,removed:c,updated:l}=t(i?.rawConfiguration,a?.rawConfiguration),s=[],d=a?.getAllOverrideIdentifiers()||[],S=i?.getAllOverrideIdentifiers()||[];if(i){const R=S.filter(O=>!d.includes(O));for(const O of R)s.push([O,i.getKeysForOverrideIdentifier(O)])}if(a){const R=d.filter(O=>!S.includes(O));for(const O of R)s.push([O,a.getKeysForOverrideIdentifier(O)])}if(i&&a){for(const R of d)if(S.includes(R)){const O=t({contents:a.getOverrideValue(void 0,R)||{},keys:a.getKeysForOverrideIdentifier(R)},{contents:i.getOverrideValue(void 0,R)||{},keys:i.getKeysForOverrideIdentifier(R)});s.push([R,[...O.added,...O.removed,...O.updated]])}}return{added:r,removed:c,updated:l,overrides:s}}function t(a,i){const r=a?i?a.keys.filter(s=>i.keys.indexOf(s)===-1):[...a.keys]:[],c=i?a?i.keys.filter(s=>a.keys.indexOf(s)===-1):[...i.keys]:[],l=[];if(a&&i){for(const s of i.keys)if(a.keys.indexOf(s)!==-1){const d=(0,b.getConfigurationValue)(i.contents,s),S=(0,b.getConfigurationValue)(a.contents,s);P.equals(d,S)||l.push(s)}}return{added:r,removed:c,updated:l}}}),define(ee[225],te([0,1,25,3,2,40,10,111,68,5,37,51]),function(G,e,I,A,n,C,D,P,f,h,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class y extends n.Disposable{constructor(){super(...arguments),this.a=this.B(new A.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new P.ConfigurationModel}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(v.Registry.as(f.Extensions.Configuration).onDidUpdateConfiguration(({properties:o,defaultsOverrides:u})=>this.c(Array.from(o),u))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(o,u){this.h(o,v.Registry.as(f.Extensions.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:o})}f(){return{}}g(){this.b=new P.ConfigurationModel;const o=v.Registry.as(f.Extensions.Configuration).getConfigurationProperties();this.h(Object.keys(o),o)}h(o,u){const p=this.f();for(const k of o){const E=p[k],M=u[k];E!==void 0?this.b.addValue(k,E):M?this.b.addValue(k,M.default):this.b.removeValue(k)}}}e.DefaultConfiguration=y;class g{constructor(){this.onDidChangeConfiguration=A.Event.None,this.configurationModel=new P.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=g;let m=class extends n.Disposable{get configurationModel(){return this.b}constructor(o,u,p){super(),this.c=o,this.f=u,this.g=p,this.a=this.B(new A.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new P.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(o=>this.i(o))),this.B(this.c.onDidChangeConfiguration(async({properties:o})=>this.j(await this.h(o),!0))),this.b}async h(o){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",o);const u={},p=[],k=v.Registry.as(f.Extensions.Configuration).getConfigurationProperties();for(const E of o){const M=k[E];if(!M){p.push(E);continue}if(M.policy){if(M.type!=="string"&&M.type!=="number"){this.g.warn(`Policy ${M.policy.name} has unsupported type ${M.type}`);continue}p.push(E),u[M.policy.name]={type:M.type}}}return(0,D.isEmptyObject)(u)||await this.f.updatePolicyDefinitions(u),p}i(o){this.g.trace("PolicyConfiguration#onDidChangePolicies",o);const u=v.Registry.as(f.Extensions.Configuration).getPolicyConfigurations(),p=(0,I.coalesce)(o.map(k=>u.get(k)));this.j(p,!0)}j(o,u){this.g.trace("PolicyConfiguration#update",o);const p=v.Registry.as(f.Extensions.Configuration).getConfigurationProperties(),k=[],E=this.b.isEmpty();for(const M of o){const t=p[M]?.policy?.name;if(t){const a=this.f.getPolicyValue(t);(E?a!==void 0:!(0,C.equals)(this.b.getValue(M),a))&&k.push([M,a])}else this.b.getValue(M)!==void 0&&k.push([M,void 0])}if(k.length){this.g.trace("PolicyConfiguration#changed",k);const M=this.b;this.b=new P.ConfigurationModel;for(const t of M.keys)this.b.setValue(t,M.getValue(t));for(const[t,a]of k)a===void 0?this.b.removeValue(t):this.b.setValue(t,a);u&&this.a.fire(this.b)}}};m=ve([_(1,b.IPolicyService),_(2,h.ILogService)],m),e.PolicyConfiguration=m}),define(ee[226],te([0,1,8,3,2,18,19,111,225,37]),function(G,e,I,A,n,C,D,P,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class b extends n.Disposable{constructor(y,g,m,w){super(),this.i=y,this.h=this.B(new A.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new f.DefaultConfiguration),this.c=m instanceof h.NullPolicyService?new f.NullPolicyConfiguration:this.B(new f.PolicyConfiguration(this.b,m,w)),this.f=this.B(new P.UserSettings(this.i,void 0,C.extUriBiasedIgnorePathCase,g)),this.a=new P.Configuration(this.b.configurationModel,this.c.configurationModel,new P.ConfigurationModel,new P.ConfigurationModel),this.g=this.B(new I.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:o,properties:u})=>this.k(o,u))),this.B(this.c.onDidChangeConfiguration(o=>this.l(o))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[y,g,m]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new P.Configuration(y,g,new P.ConfigurationModel,m)}getConfigurationData(){return this.a.toData()}getValue(y,g){const m=typeof y=="string"?y:void 0,w=(0,D.isConfigurationOverrides)(y)?y:(0,D.isConfigurationOverrides)(g)?g:{};return this.a.getValue(m,w,void 0)}updateValue(y,g,m,w){return Promise.reject(new Error("not supported"))}inspect(y){return this.a.inspect(y,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const y=await this.f.loadConfiguration();this.j(y)}j(y){const g=this.a.toData(),m=this.a.compareAndUpdateLocalUserConfiguration(y);this.m(m,g,2)}k(y,g){const m=this.a.toData(),w=this.a.compareAndUpdateDefaultConfiguration(y,g);this.m(w,m,7)}l(y){const g=this.a.toData(),m=this.a.compareAndUpdatePolicyConfiguration(y);this.m(m,g,7)}m(y,g,m){const w=new P.ConfigurationChangeEvent(y,{data:g},this.a);w.source=m,w.sourceConfig=this.n(m),this.h.fire(w)}n(y){switch(y){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=b}),define(ee[227],te([0,1,13,6]),function(G,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,A.createDecorator)("remoteAuthorityResolverService");var n;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound"})(n=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class C extends I.ErrorNoTelemetry{static isNotAvailable(f){return f instanceof C&&f._code===n.NotAvailable}static isTemporarilyNotAvailable(f){return f instanceof C&&f._code===n.TemporarilyNotAvailable}static isNoResolverFound(f){return f instanceof C&&f._code===n.NoResolverFound}static isHandled(f){return f instanceof C&&f.isHandled}constructor(f,h=n.Unknown,b){super(f),this._message=f,this._code=h,this._detail=b,this.isHandled=h===n.NotAvailable&&b===!0,Object.setPrototypeOf(this,C.prototype)}}e.RemoteAuthorityResolverError=C;function D(P){const f=P.indexOf("+");return f===-1?P:P.substring(0,f)}e.getRemoteAuthorityPrefix=D}),define(ee[56],te([0,1,15]),function(G,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function A(h){return h.scheme===I.Schemas.vscodeRemote?h.authority:void 0}e.getRemoteAuthority=A;function n(h){if(!h)return;const b=h.indexOf("+");return b<0?h:h.substr(0,b)}e.getRemoteName=n;function C(h){return`/${h.quality??"oss"}-${h.commit??"dev"}`}e.getRemoteServerRootPath=C;function D(h){const{host:b,port:v}=f(h);if(typeof v>"u")throw new Error("Remote authority doesn't contain a port!");return{host:b,port:v}}e.parseAuthorityWithPort=D;function P(h,b){let{host:v,port:y}=f(h);return typeof y>"u"&&(y=b),{host:v,port:y}}e.parseAuthorityWithOptionalPort=P;function f(h){const b=h.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(b)return{host:b[1],port:parseInt(b[2],10)};const v=h.match(/^(\[[0-9a-z:]+\])$/);if(v)return{host:v[1],port:void 0};const y=h.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:h,port:void 0}}}),define(ee[91],te([0,1,27,6,56]),function(G,e,I,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function C(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}e.getWorkspaceSupportTypeMessage=C;function D(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));var f;(function(m){m.WIN32_X64="win32-x64",m.WIN32_IA32="win32-ia32",m.WIN32_ARM64="win32-arm64",m.LINUX_X64="linux-x64",m.LINUX_ARM64="linux-arm64",m.LINUX_ARMHF="linux-armhf",m.ALPINE_X64="alpine-x64",m.ALPINE_ARM64="alpine-arm64",m.DARWIN_X64="darwin-x64",m.DARWIN_ARM64="darwin-arm64",m.WEB="web",m.UNIVERSAL="universal",m.UNKNOWN="unknown",m.UNDEFINED="undefined"})(f=e.TargetPlatform||(e.TargetPlatform={}));class h{constructor(w){this.value=w,this.c=w.toLowerCase()}static equals(w,o){if(typeof w>"u"||w===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof w=="string"||typeof o=="string"){const u=typeof w=="string"?w:w.value,p=typeof o=="string"?o:o.value;return I.equalsIgnoreCase(u,p)}return w.c===o.c}static toKey(w){return typeof w=="string"?w.toLowerCase():w.c}}e.ExtensionIdentifier=h;function b(m){return v(m)}e.isApplicationScopedExtension=b;function v(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}e.isLanguagePackExtension=v;function y(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=y;function g(m,w){if(w){const o=`onResolveRemoteAuthority:${(0,n.getRemoteName)(w)}`;return m.activationEvents?.indexOf(o)!==-1}return!1}e.isResolverExtension=g,e.IBuiltinExtensionsScannerService=(0,A.createDecorator)("IBuiltinExtensionsScannerService")}),define(ee[228],te([0,1,8,17,22,13,3,2,64,71,31,104,227,56]),function(G,e,I,A,n,C,D,P,f,h,b,v,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionHealthChangedEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const m=30*1e3;var w;(function(L){L[L.Management=1]="Management",L[L.ExtensionHost=2]="ExtensionHost",L[L.Tunnel=3]="Tunnel"})(w=e.ConnectionType||(e.ConnectionType={}));function o(L){switch(L){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function u(L){const T=new n.CancellationTokenSource;return setTimeout(()=>T.cancel(),L),T.token}function p(L,T){if(L.isCancellationRequested||T.isCancellationRequested)return n.CancellationToken.Cancelled;const B=new n.CancellationTokenSource;return L.onCancellationRequested(()=>B.cancel()),T.onCancellationRequested(()=>B.cancel()),B.token}class k{get didTimeout(){return this.c==="timedout"}constructor(T){this.c="pending",this.d=new P.DisposableStore,this.promise=new Promise((B,H)=>{this.f=B,this.g=H}),T.isCancellationRequested?this.h():this.d.add(T.onCancellationRequested(()=>this.h()))}registerDisposable(T){this.c==="pending"?this.d.add(T):T.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const T=new Error("Time limit reached");return T.code="ETIMEDOUT",T.syscall="connect",T}resolve(T){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(T))}reject(T){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(T))}}function E(L,T){const B=new k(T);return B.registerDisposable(L.onControlMessage(H=>{const j=JSON.parse(H.toString()),$=z(j);$?B.reject($):B.resolve(j)})),B.promise}function M(L,T,B,H,j,$,q,oe,de){const pe=new k(de),ye=h.StopWatch.create(!1);return L.info(`Creating a socket (${oe})...`),f.mark(`code/willCreateSocket/${q}`),T.connect(B,H,j,$,oe,(Le,Fe)=>{pe.didTimeout?(f.mark(`code/didCreateSocketError/${q}`),L.info(`Creating a socket (${oe}) finished after ${ye.elapsed()} ms, but this is too late and has timed out already.`),Le&&L.error(Le),Fe?.dispose()):Le||!Fe?(f.mark(`code/didCreateSocketError/${q}`),L.info(`Creating a socket (${oe}) returned an error after ${ye.elapsed()} ms.`),pe.reject(Le)):(f.mark(`code/didCreateSocketOK/${q}`),L.info(`Creating a socket (${oe}) was successful after ${ye.elapsed()} ms.`),pe.resolve(Fe))}),pe.promise}function t(L,T){const B=new k(T);return L.then(H=>{B.didTimeout||B.resolve(H)},H=>{B.didTimeout||B.reject(H)}),B.promise}async function a(L,T,B,H){const j=Z(L,T);L.logService.trace(`${j} 1/6. invoking socketFactory.connect().`);let $;try{$=await M(L.logService,L.socketFactory,L.host,L.port,(0,g.getRemoteServerRootPath)(L),`reconnectionToken=${L.reconnectionToken}&reconnection=${L.reconnectionProtocol?"true":"false"}`,o(T),`renderer-${o(T)}-${L.reconnectionToken}`,H)}catch(ye){throw L.logService.error(`${j} socketFactory.connect() failed or timed out. Error:`),L.logService.error(ye),ye}L.logService.trace(`${j} 2/6. socketFactory.connect() was successful.`);let q,oe;L.reconnectionProtocol?(L.reconnectionProtocol.beginAcceptReconnection($,null),q=L.reconnectionProtocol,oe=!1):(q=new v.PersistentProtocol({socket:$,measureRoundTripTime:!0}),oe=!0),L.logService.trace(`${j} 3/6. sending AuthRequest control message.`);const de=await t(L.signService.createNewMessage((0,b.generateUuid)()),H),pe={type:"auth",auth:L.connectionToken||"00000000000000000000",data:de.data};q.sendControl(A.VSBuffer.fromString(JSON.stringify(pe)));try{const ye=await E(q,p(H,u(1e4)));if(ye.type!=="sign"||typeof ye.data!="string"){const we=new Error("Unexpected handshake message");throw we.code="VSCODE_CONNECTION_ERROR",we}if(L.logService.trace(`${j} 4/6. received SignRequest control message.`),!await t(L.signService.validate(de,ye.signedData),H)){const we=new Error("Refused to connect to unsupported server");throw we.code="VSCODE_CONNECTION_ERROR",we}const Fe=await t(L.signService.sign(ye.data),H),Te={type:"connectionType",commit:L.commit,signedData:Fe,desiredConnectionType:T};return B&&(Te.args=B),L.logService.trace(`${j} 5/6. sending ConnectionTypeRequest control message.`),q.sendControl(A.VSBuffer.fromString(JSON.stringify(Te))),{protocol:q,ownsProtocol:oe}}catch(ye){throw ye&&ye.code==="ETIMEDOUT"&&(L.logService.error(`${j} the handshake timed out. Error:`),L.logService.error(ye)),ye&&ye.code==="VSCODE_CONNECTION_ERROR"&&(L.logService.error(`${j} received error control message when negotiating connection. Error:`),L.logService.error(ye)),oe&&W(q),ye}}async function i(L,T,B,H){const j=Date.now(),$=Z(L,T),{protocol:q,ownsProtocol:oe}=await a(L,T,B,H),de=new k(H);return de.registerDisposable(q.onControlMessage(pe=>{const ye=JSON.parse(pe.toString()),Le=z(ye);Le?(L.logService.error(`${$} received error control message when negotiating connection. Error:`),L.logService.error(Le),oe&&W(q),de.reject(Le)):(L.reconnectionProtocol?.endAcceptReconnection(),L.logService.trace(`${$} 6/6. handshake finished, connection is up and running after ${U(j)}!`),de.resolve({protocol:q,firstMessage:ye}))})),de.promise}async function r(L,T){const{protocol:B}=await i(L,1,void 0,T);return{protocol:B}}async function c(L,T,B){const{protocol:H,firstMessage:j}=await i(L,2,T,B),$=j&&j.debugPort;return{protocol:H,debugPort:$}}async function l(L,T,B){const H=Date.now(),j=Z(L,3),{protocol:$}=await a(L,3,T,B);return L.logService.trace(`${j} 6/6. handshake finished, connection is up and running after ${U(H)}!`),$}async function s(L,T,B){const{host:H,port:j,connectionToken:$}=await L.addressProvider.getAddress();return{commit:L.commit,quality:L.quality,host:H,port:j,connectionToken:$,reconnectionToken:T,reconnectionProtocol:B,socketFactory:L.socketFactory,signService:L.signService,logService:L.logService}}async function d(L,T,B){return R(L,async H=>{const{protocol:j}=await r(H,n.CancellationToken.None);return new x(L,T,B,H.reconnectionToken,j)})}e.connectRemoteAgentManagement=d;async function S(L,T){return R(L,async B=>{const{protocol:H,debugPort:j}=await c(B,T,n.CancellationToken.None);return new F(L,T,B.reconnectionToken,H,j)})}e.connectRemoteAgentExtensionHost=S;async function R(L,T){for(let H=1;;H++)try{const j=(0,b.generateUuid)(),$=await s(L,j,null);return await T($)}catch(j){if(H<5)L.logService.error(`[remote-connection][attempt ${H}] An error occurred in initial connection! Will retry... Error:`),L.logService.error(j);else throw L.logService.error(`[remote-connection][attempt ${H}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),L.logService.error(j),ge.triggerPermanentFailure(0,0,y.RemoteAuthorityResolverError.isHandled(j)),j}}async function O(L,T,B){const H=await s(L,(0,b.generateUuid)(),null);return await l(H,{host:T,port:B},n.CancellationToken.None)}e.connectRemoteAgentTunnel=O;function N(L){return(0,I.createCancelablePromise)(T=>new Promise((B,H)=>{const j=setTimeout(B,L*1e3);T.onCancellationRequested(()=>{clearTimeout(j),B()})}))}var K;(function(L){L[L.ConnectionLost=0]="ConnectionLost",L[L.ReconnectionWait=1]="ReconnectionWait",L[L.ReconnectionRunning=2]="ReconnectionRunning",L[L.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",L[L.ConnectionGain=4]="ConnectionGain",L[L.ConnectionHealthChanged=5]="ConnectionHealthChanged"})(K=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class V{constructor(T,B){this.reconnectionToken=T,this.millisSinceLastIncomingData=B,this.type=0}}e.ConnectionLostEvent=V;class X{constructor(T,B,H,j){this.reconnectionToken=T,this.millisSinceLastIncomingData=B,this.durationSeconds=H,this.c=j,this.type=1}skipWait(){this.c.cancel()}}e.ReconnectionWaitEvent=X;class ie{constructor(T,B,H){this.reconnectionToken=T,this.millisSinceLastIncomingData=B,this.attempt=H,this.type=2}}e.ReconnectionRunningEvent=ie;class re{constructor(T,B,H){this.reconnectionToken=T,this.millisSinceLastIncomingData=B,this.attempt=H,this.type=4}}e.ConnectionGainEvent=re;class ce{constructor(T,B){this.reconnectionToken=T,this.connectionHealth=B,this.type=5}}e.ConnectionHealthChangedEvent=ce;class fe{constructor(T,B,H,j){this.reconnectionToken=T,this.millisSinceLastIncomingData=B,this.attempt=H,this.handled=j,this.type=3}}e.ReconnectionPermanentFailureEvent=fe;class ge extends P.Disposable{static triggerPermanentFailure(T,B,H){this._permanentFailure=!0,this.f=T,this.g=B,this.h=H,this.i.forEach(j=>j.u(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(T=>T.r())}static debugPauseSocketWriting(){this.i.forEach(T=>T.v())}get k(){return this.c||ge._permanentFailure}constructor(T,B,H,j,$){super(),this.m=T,this.n=B,this.reconnectionToken=H,this.protocol=j,this.p=$,this.j=this.B(new D.Emitter),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.j.fire(new re(this.reconnectionToken,0,0)),this.B(j.onSocketClose(q=>{const oe=se(this.m,this.reconnectionToken,!0);q?q.type===0?(this.n.logService.info(`${oe} received socket close event (hadError: ${q.hadError}).`),q.error&&this.n.logService.error(q.error)):(this.n.logService.info(`${oe} received socket close event (wasClean: ${q.wasClean}, code: ${q.code}, reason: ${q.reason}).`),q.event&&this.n.logService.error(q.event)):this.n.logService.info(`${oe} received socket close event.`),this.r()})),this.B(j.onSocketTimeout(q=>{const oe=se(this.m,this.reconnectionToken,!0);this.n.logService.info(`${oe} received socket timeout event (unacknowledgedMsgCount: ${q.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${q.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${q.timeSinceLastReceivedSomeData}).`),this.r()})),this.B(j.onHighRoundTripTime(q=>{const oe=ne(this.m,this.reconnectionToken);this.n.logService.info(`${oe} high roundtrip time: ${q.roundTripTime}ms (${q.recentHighRoundTripCount} of ${5} recent samples)`)})),this.B(j.onDidChangeConnectionHealth(q=>{this.j.fire(new ce(this.reconnectionToken,q))})),ge.i.push(this),this.B((0,P.toDisposable)(()=>{const q=ge.i.indexOf(this);q>=0&&ge.i.splice(q,1)})),this.k&&this.u(ge.f,ge.g,ge.h)}async r(){if(!this.l)try{this.l=!0,await this.s()}finally{this.l=!1}}async s(){if(this.k)return;const T=se(this.m,this.reconnectionToken,!0);this.n.logService.info(`${T} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new V(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const B=[0,5,5,10,10,10,10,10,30];let H=-1;do{H++;const j=H<B.length?B[H]:B[B.length-1];try{if(j>0){const q=N(j);this.j.fire(new X(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),j,q)),this.n.logService.info(`${T} waiting for ${j} seconds before reconnecting...`);try{await q}catch{}}if(this.k){this.n.logService.error(`${T} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new ie(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),H+1)),this.n.logService.info(`${T} resolving connection...`);const $=await s(this.n,this.reconnectionToken,this.protocol);this.n.logService.info(`${T} connecting to ${$.host}:${$.port}...`),await this.w($,u(m)),this.n.logService.info(`${T} reconnected!`),this.j.fire(new re(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),H+1));break}catch($){if($.code==="VSCODE_CONNECTION_ERROR"){this.n.logService.error(`${T} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.n.logService.error($),this.t(this.protocol.getMillisSinceLastIncomingData(),H+1,!1);break}if(H>360){this.n.logService.error(`${T} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.n.logService.error($),this.t(this.protocol.getMillisSinceLastIncomingData(),H+1,!1);break}if(y.RemoteAuthorityResolverError.isTemporarilyNotAvailable($)){this.n.logService.info(`${T} A temporarily not available error occurred while trying to reconnect, will try again...`),this.n.logService.trace($);continue}if(($.code==="ETIMEDOUT"||$.code==="ENETUNREACH"||$.code==="ECONNREFUSED"||$.code==="ECONNRESET")&&$.syscall==="connect"){this.n.logService.info(`${T} A network error occurred while trying to reconnect, will try again...`),this.n.logService.trace($);continue}if((0,C.isCancellationError)($)){this.n.logService.info(`${T} A promise cancelation error occurred while trying to reconnect, will try again...`),this.n.logService.trace($);continue}if($ instanceof y.RemoteAuthorityResolverError){this.n.logService.error(`${T} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.n.logService.error($),this.t(this.protocol.getMillisSinceLastIncomingData(),H+1,y.RemoteAuthorityResolverError.isHandled($));break}this.n.logService.error(`${T} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.n.logService.error($),this.t(this.protocol.getMillisSinceLastIncomingData(),H+1,!1);break}}while(!this.k)}t(T,B,H){this.p?ge.triggerPermanentFailure(T,B,H):this.u(T,B,H)}u(T,B,H){this.j.fire(new fe(this.reconnectionToken,T,B,H)),W(this.protocol)}v(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=ge,ge._permanentFailure=!1,ge.f=0,ge.g=0,ge.h=!1,ge.i=[];class x extends ge{constructor(T,B,H,j,$){super(1,T,j,$,!0),this.client=this.B(new v.Client($,{remoteAuthority:B,clientId:H},T.ipcLogger))}async w(T,B){await r(T,B)}}e.ManagementPersistentConnection=x;class F extends ge{constructor(T,B,H,j,$){super(2,T,H,j,!1),this.y=B,this.debugPort=$}async w(T,B){await c(T,this.y,B)}}e.ExtensionHostPersistentConnection=F;function W(L){try{L.acceptDisconnect();const T=L.getSocket();L.dispose(),T.dispose()}catch(T){(0,C.onUnexpectedError)(T)}}function z(L){if(L&&L.type==="error"){const T=new Error(`Connection error: ${L.reason}`);return T.code="VSCODE_CONNECTION_ERROR",T}return null}function J(L,T){for(;L.length<T;)L+=" ";return L}function ne(L,T){return`[remote-connection][${J(o(L),13)}][${T.substr(0,5)}\u2026]`}function se(L,T,B){return`${ne(L,T)}[${B?"reconnect":"initial"}]`}function Z(L,T){return`${se(T,L.reconnectionToken,!!L.reconnectionProtocol)}[${L.host}:${L.port}]`}function U(L){return`${Date.now()-L} ms`}}),define(ee[229],te([0,1,82,87]),function(G,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(n,C,D,P,f,h){const b=y=>h(y,void 0),v=I.createConnection({host:n,port:C},()=>{v.removeListener("error",b);const y=Buffer.alloc(16);for(let o=0;o<16;o++)y[o]=Math.round(Math.random()*256);const g=y.toString("base64"),m=[`GET ws://${/:/.test(n)?`[${n}]`:n}:${C}${D}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${g}`];v.write(m.join(`\r
`)+`\r
\r
`);const w=o=>{o.toString().indexOf(`\r
\r
`)>=0&&(v.off("data",w),h(void 0,new A.NodeSocket(v,f)))};v.on("data",w)});v.setNoDelay(!0),v.once("error",b)}}}),define(ee[230],te([0,1,26,46,41,188]),function(G,e,I,A,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=void 0;let D;async function P(g=!1){return(D===void 0||g)&&(D=f()),D}e.hasWSLFeatureInstalled=P;async function f(){const g=h();if(g===void 0)return!1;if(g>=22e3){const m=v();if(m)return new Promise(w=>{A.execFile(m,["--status"],o=>w(!o))})}else{const m=y();if(m)try{if((await n.promises.stat(m)).isFile())return!0}catch{}}return!1}function h(){const g=/(\d+)\.(\d+)\.(\d+)/g.exec(I.release());if(g)return parseInt(g[3])}function b(g){const m=process.env.SystemRoot;if(m){const w=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return C.join(m,w?"Sysnative":"System32",g)}}function v(){return b("wsl.exe")}function y(){return b("lxss\\LxssManager.dll")}}),define(ee[57],te([0,1,17,172,68,6,51]),function(G,e,I,A,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,C.createDecorator)("requestService");function P(w){return w.res.statusCode&&w.res.statusCode>=200&&w.res.statusCode<300||w.res.statusCode===1223}e.isSuccess=P;function f(w){return w.res.statusCode===204}async function h(w){return f(w)?null:(await(0,I.streamToBuffer)(w.stream)).toString()}e.asText=h;async function b(w){if(!P(w))throw new Error("Server returned "+w.res.statusCode);return h(w)}e.asTextOrError=b;async function v(w){if(!P(w))throw new Error("Server returned "+w.res.statusCode);if(f(w))return null;const u=(await(0,I.streamToBuffer)(w.stream)).toString();try{return JSON.parse(u)}catch(p){throw p.message+=`:
`+u,p}}e.asJson=v;function y(w){m(w)}e.updateProxyConfigurationsScope=y;let g;function m(w){const o=D.Registry.as(n.Extensions.Configuration),u=g;g={id:"http",order:15,title:(0,A.localize)(0,null),type:"object",scope:w,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(4,null),(0,A.localize)(5,null),(0,A.localize)(6,null),(0,A.localize)(7,null)],default:"override",description:(0,A.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(9,null),restricted:!0}}},o.updateConfigurations({add:[g],remove:u?[u]:[]})}m(2)}),define(ee[231],te([0,1,17,22]),function(G,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class n{constructor(P){this.a=P}listen(P,f){throw new Error("Invalid listen")}call(P,f,h,b=A.CancellationToken.None){switch(f){case"request":return this.a.request(h[0],b).then(async({res:v,stream:y})=>{const g=await(0,I.streamToBuffer)(y);return[{statusCode:v.statusCode,headers:v.headers},g]});case"resolveProxy":return this.a.resolveProxy(h[0])}throw new Error("Invalid call")}}e.RequestChannel=n;class C{constructor(P){this.a=P}async request(P,f){const[h,b]=await this.a.call("request",[P],f);return{res:h,stream:(0,I.bufferToStream)(b)}}async resolveProxy(P){return this.a.call("resolveProxy",[P])}}e.RequestChannelClient=C}),define(ee[232],te([0,1,233,10]),function(G,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function n(D,P){return D.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:D.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function C(D,P,f={}){const h=(0,I.parse)(D),b=f.proxyUrl||n(h,P);if(!b)return null;const v=(0,I.parse)(b);if(!/^https?:$/.test(v.protocol||""))return null;const y={host:v.hostname||"",port:v.port||(v.protocol==="https"?"443":"80"),auth:v.auth,rejectUnauthorized:(0,A.isBoolean)(f.strictSSL)?f.strictSSL:!0};return h.protocol==="http:"?new(await new Promise((g,m)=>{G(["http-proxy-agent"],g,m)}))(y):new(await new Promise((g,m)=>{G(["https-proxy-agent"],g,m)}))(y)}e.getProxyAgent=C}),define(ee[112],te([0,1,46,9,173,22,44,13,4,31,148,62,8,127]),function(G,e,I,A,n,C,D,P,f,h,b,v,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let m;async function w(u,p,k,E){return k["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):f.isWindows?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,v.isLaunchedFromCli)(E)&&!k["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,v.isLaunchedFromCli)(E)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),m||(m=y.Promises.withAsyncBody(async(M,t)=>{const a=new C.CancellationTokenSource;let i=1e4;const r=u.getValue("application.shellEnvironmentResolutionTimeout");typeof r=="number"&&(i=(0,g.clamp)(r,1,120)*1e3);const c=setTimeout(()=>{a.dispose(!0),t(new Error((0,n.localize)(0,null)))},i);try{M(await o(p,a.token))}catch(l){!(0,P.isCancellationError)(l)&&!a.token.isCancellationRequested?t(new Error((0,n.localize)(1,null,(0,D.toErrorMessage)(l)))):M({})}finally{clearTimeout(c),a.dispose()}})),m)}e.getResolvedShellEnv=w;async function o(u,p){const k=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",k);const E=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",E);const M=(0,h.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(M+"({.*})"+M),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};u.trace("getUnixShellEnvironment#env",a);const i=await(0,b.getSystemShell)(f.OS,a);return u.trace("getUnixShellEnvironment#shell",i),new Promise((r,c)=>{if(p.isCancellationRequested)return c(new P.CancellationError);const l=(0,A.basename)(i);let s,d;const S=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(l)?(s=`& '${process.execPath}' ${S} -p '''${M}'' + JSON.stringify(process.env) + ''${M}'''`,d=["-Login","-Command"]):(s=`'${process.execPath}' ${S} -p '"${M}" + JSON.stringify(process.env) + "${M}"'`,l==="tcsh"||l==="csh"?d=["-ic"]:d=["-i","-l","-c"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(d),s);const R=(0,I.spawn)(i,[...d,s],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});p.onCancellationRequested(()=>(R.kill(),c(new P.CancellationError))),R.on("error",K=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,D.toErrorMessage)(K)),c(K)});const O=[];R.stdout.on("data",K=>O.push(K));const N=[];R.stderr.on("data",K=>N.push(K)),R.on("close",(K,V)=>{const X=Buffer.concat(O).toString("utf8");u.trace("getUnixShellEnvironment#raw",X);const ie=Buffer.concat(N).toString("utf8");if(ie.trim()&&u.trace("getUnixShellEnvironment#stderr",ie),K||V)return c(new Error((0,n.localize)(2,null,K,V)));const re=t.exec(X),ce=re?re[1]:"{}";try{const fe=JSON.parse(ce);k?fe.ELECTRON_RUN_AS_NODE=k:delete fe.ELECTRON_RUN_AS_NODE,E?fe.ELECTRON_NO_ATTACH_CONSOLE=E:delete fe.ELECTRON_NO_ATTACH_CONSOLE,delete fe.VSCODE_RESOLVING_ENVIRONMENT,delete fe.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",fe),r(fe)}catch(fe){u.error("getUnixShellEnvironment#errorCaught",(0,D.toErrorMessage)(fe)),c(fe)}})})}}),define(ee[92],te([0,1,6]),function(G,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,I.createDecorator)(e.SIGN_SERVICE_ID)}),define(ee[234],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class I{constructor(){this.b=new Map}c(){return new Promise((n,C)=>G(["vsda"],n,C))}async createNewMessage(n){try{const C=await this.c(),D=new C.validator;if(D){const P=String(I.a++);return this.b.set(P,D),{id:P,data:D.createNewMessage(n)}}}catch{}return{id:"",data:n}}async validate(n,C){if(!n.id)return!0;const D=this.b.get(n.id);if(!D)return!1;this.b.delete(n.id);try{return D.validate(C)==="ok"}catch{return!1}}async sign(n){try{const C=await this.c(),D=new C.signer;if(D)return D.sign(n)}catch{}return n}}e.SignService=I,I.a=1}),define(ee[34],te([0,1,6]),function(G,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,I.createDecorator)("stateMainService")}),define(ee[21],te([0,1,14,42,8,3,2,4,36,10,6,5,34,28]),function(G,e,I,A,n,C,D,P,f,h,b,v,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,b.createDecorator)("lifecycleMainService");var m;(function(u){u[u.QUIT=1]="QUIT",u[u.KILL=2]="KILL"})(m=e.ShutdownReason||(e.ShutdownReason={}));var w;(function(u){u[u.Starting=1]="Starting",u[u.Ready=2]="Ready",u[u.AfterWindowOpen=3]="AfterWindowOpen",u[u.Eventually=4]="Eventually"})(w=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let o=class ft extends D.Disposable{get quitRequested(){return this.i}get wasRestarted(){return this.j}get phase(){return this.k}constructor(p,k,E){super(),this.v=p,this.w=k,this.y=E,this.c=this.B(new C.Emitter),this.onBeforeShutdown=this.c.event,this.f=this.B(new C.Emitter),this.onWillShutdown=this.f.event,this.g=this.B(new C.Emitter),this.onWillLoadWindow=this.g.event,this.h=this.B(new C.Emitter),this.onBeforeCloseWindow=this.h.event,this.i=!1,this.j=!1,this.k=1,this.l=new Set,this.m=0,this.n=0,this.p=void 0,this.r=void 0,this.s=void 0,this.t=new Map,this.u=new Map,this.z(),this.when(2).then(()=>this.C())}z(){this.j=!!this.w.getItem(ft.b),this.j&&this.w.removeItem(ft.b)}C(){const p=()=>{this.i||(this.L("Lifecycle#app.on(before-quit)"),this.i=!0,this.L("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),P.isMacintosh&&this.n===0&&this.D(1))};I.app.addListener("before-quit",p);const k=()=>{this.L("Lifecycle#app.on(window-all-closed)"),(this.i||!P.isMacintosh)&&I.app.quit()};I.app.addListener("window-all-closed",k),I.app.once("will-quit",E=>{this.L("Lifecycle#app.on(will-quit)"),E.preventDefault(),this.D(1).finally(()=>{this.H(!1),I.app.removeListener("before-quit",p),I.app.removeListener("window-all-closed",k),I.app.quit()})})}D(p){if(this.s)return this.s;this.L("Lifecycle#onWillShutdown.fire()");const k=[];return this.f.fire({reason:p,join(E){k.push(E)}}),this.s=(async()=>{try{await n.Promises.settled(k)}catch(E){this.v.error(E)}try{await this.w.close()}catch(E){this.v.error(E)}})(),this.s}set phase(p){if(p<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.k===p)return;this.L(`lifecycle (main): phase changed (value: ${p})`),this.k=p;const k=this.u.get(this.k);k&&(k.open(),this.u.delete(this.k))}async when(p){if(p<=this.k)return;let k=this.u.get(p);k||(k=new n.Barrier,this.u.set(p,k)),await k.wait()}registerWindow(p){const k=new D.DisposableStore;this.n++,k.add(p.onWillLoad(M=>this.g.fire({window:p,workspace:M.workspace,reason:M.reason})));const E=(0,h.assertIsDefined)(p.win);E.on("close",M=>{const t=p.id;if(this.l.has(t)){this.l.delete(t);return}this.L(`Lifecycle#window.on('close') - window ID ${p.id}`),M.preventDefault(),this.unload(p,1).then(a=>{if(a){this.l.delete(t);return}this.l.add(t),this.L(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${t}`),this.h.fire(p),p.close()})}),E.on("closed",()=>{this.L(`Lifecycle#window.on('closed') - window ID ${p.id}`),this.n--,k.dispose(),this.n===0&&(!P.isMacintosh||this.i)&&this.D(1)})}async reload(p,k){await this.unload(p,3)||p.reload(k)}unload(p,k){const E=this.t.get(p.id);if(E)return E;const M=this.F(p,k).finally(()=>{this.t.delete(p.id)});return this.t.set(p.id,M),M}async F(p,k){if(!p.isReady)return!1;this.L(`Lifecycle#unload() - window ID ${p.id}`);const E=this.i?2:k,M=await this.I(p,E);return M?(this.L(`Lifecycle#unload() - veto in renderer (window ID ${p.id})`),this.G(M)):(await this.J(p,E),!1)}G(p){return p?(this.H(!0),this.i=!1,!0):!1}H(p){this.r&&(this.r(p),this.r=void 0,this.p=void 0)}I(p,k){return new Promise(E=>{const M=this.m++,t=`vscode:ok${M}`,a=`vscode:cancel${M}`;A.validatedIpcMain.once(t,()=>{E(!1)}),A.validatedIpcMain.once(a,()=>{E(!0)}),p.send("vscode:onBeforeUnload",{okChannel:t,cancelChannel:a,reason:k})})}J(p,k){return new Promise(E=>{const t=`vscode:reply${this.m++}`;A.validatedIpcMain.once(t,()=>E()),p.send("vscode:onWillUnload",{replyChannel:t,reason:k})})}quit(p){return this.L(`Lifecycle#quit() - begin (willRestart: ${p})`),this.p?(this.L("Lifecycle#quit() - returning pending quit promise"),this.p):(p&&this.w.setItem(ft.b,!0),this.p=new Promise(k=>{this.r=k,this.L("Lifecycle#quit() - calling app.quit()"),I.app.quit()}),this.p)}L(p){this.y.args["enable-smoke-test-driver"]?this.v.info(p):this.v.trace(p)}async relaunch(p){this.L("Lifecycle#relaunch()");const k=process.argv.slice(1);if(p?.addArgs&&k.push(...p.addArgs),p?.removeArgs)for(const t of p.removeArgs){const a=k.indexOf(t);a>=0&&k.splice(a,1)}const E=()=>{try{if(P.isWindows){const t=(0,f.cwd)();t!==process.cwd()&&process.chdir(t)}}catch(t){this.v.error(t)}this.L("Lifecycle#relaunch() - calling app.relaunch()"),I.app.relaunch({args:k})};I.app.once("quit",E),await this.quit(!0)&&I.app.removeListener("quit",E)}async kill(p){this.L("Lifecycle#kill()"),await this.D(2),await Promise.race([(0,n.timeout)(1e3),(async()=>{for(const k of I.BrowserWindow.getAllWindows())if(k&&!k.isDestroyed()){let E;k.webContents&&!k.webContents.isDestroyed()?E=new Promise(M=>k.once("closed",M)):E=Promise.resolve(),k.destroy(),await E}})()]),I.app.exit(p)}};o.b="lifecycle.quitAndRestart",o=ve([_(0,v.ILogService),_(1,y.IStateMainService),_(2,g.IEnvironmentMainService)],o),e.LifecycleMainService=o}),define(ee[235],te([0,1,4,3,2,6,21]),function(G,e,I,A,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,C.createDecorator)("keyboardLayoutMainService");let P=class extends n.Disposable{constructor(b){super(),this.a=this.B(new A.Emitter),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,b.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const b=await new Promise((v,y)=>{G(["native-keymap"],v,y)});this.c=f(b),I.isCI||b.onDidChangeKeyboardLayout(()=>{this.c=f(b),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};P=ve([_(0,D.ILifecycleMainService)],P),e.KeyboardLayoutMainService=P;function f(h){const b=h.getKeyMap(),v=h.getCurrentKeyboardLayout();return{keyboardMapping:b,keyboardLayoutInfo:v}}}),define(ee[236],te([0,1,6]),function(G,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,I.createDecorator)("stateService")}),define(ee[237],te([0,1,8,17,10,33,16,5]),function(G,e,I,A,n,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class f{constructor(v,y,g){this.f=v,this.g=y,this.h=g,this.a=Object.create(null),this.b="",this.c=new I.ThrottledDelayer(100),this.d=void 0,this.e=void 0}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(v){v.fileOperationResult!==1&&this.g.error(v)}}getItem(v,y){const g=this.a[v];return(0,n.isUndefinedOrNull)(g)?y:g}setItem(v,y){this.setItems([{key:v,data:y}])}setItems(v){let y=!1;for(const{key:g,data:m}of v)this.a[g]!==m&&((0,n.isUndefinedOrNull)(m)?(0,n.isUndefined)(this.a[g])||(this.a[g]=void 0,y=!0):(this.a[g]=m,y=!0));y&&this.j()}removeItem(v){(0,n.isUndefined)(this.a[v])||(this.a[v]=void 0,this.j())}async j(){if(!this.e)return this.c.trigger(()=>this.k())}async k(){if(!this.d)return;await this.d;const v=JSON.stringify(this.a,null,4);if(v!==this.b)try{await this.h.writeFile(this.f,A.VSBuffer.fromString(v)),this.b=v}catch(y){this.g.error(y)}}async close(){return this.e||(this.e=this.c.trigger(()=>this.k(),0)),this.e}}e.FileStorage=f;let h=class{constructor(v,y,g){this.a=new f(v.stateResource,y,g)}async init(){await this.a.init()}getItem(v,y){return this.a.getItem(v,y)}};h=ve([_(0,C.IEnvironmentService),_(1,P.ILogService),_(2,D.IFileService)],h),e.StateService=h}),define(ee[238],te([0,1,237]),function(G,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=void 0;class A extends I.StateService{setItem(C,D){this.a.setItem(C,D)}setItems(C){this.a.setItems(C)}removeItem(C){this.a.removeItem(C)}close(){return this.a.close()}}e.StateMainService=A}),define(ee[93],te([0,1,4,36,7,31]),function(G,e,I,A,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function D(h){if(I.platform===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}async function P(h,b,v,y,g,m,w,o,u,p){const k=Object.create(null);k["common.machineId"]=w,k.sessionID=(0,C.generateUuid)()+Date.now(),k.commitHash=g,k.version=m,k["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),k["common.platform"]=(0,I.PlatformToString)(I.platform),k["common.nodePlatform"]=A.platform,k["common.nodeArch"]=y,k["common.product"]=p||"desktop",o&&(k["common.msftInternal"]=o);let E=0;const M=Date.now();Object.defineProperties(k,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-M,enumerable:!0},"common.sequence":{get:()=>E++,enumerable:!0}}),I.isLinuxSnap&&(k["common.snap"]="true");const t=D(v);t&&(k["common.platformDetail"]=t);try{const a=await h.readFile(n.URI.file(u));k["common.source"]=a.value.toString().slice(0,30)}catch{}return k}e.resolveCommonProperties=P;function f(h){const b=A.env.USERDNSDOMAIN;if(!b)return!1;const v=b.toLowerCase();return h.some(y=>v===y)}e.verifyMicrosoftInternalDomain=f}),define(ee[24],te([0,1,6]),function(G,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,I.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,I.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var A;(function(C){C[C.NONE=0]="NONE",C[C.CRASH=1]="CRASH",C[C.ERROR=2]="ERROR",C[C.USAGE=3]="USAGE"})(A=e.TelemetryLevel||(e.TelemetryLevel={}));var n;(function(C){C.OFF="off",C.CRASH="crash",C.ERROR="error",C.ON="all"})(n=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ee[239],te([0,1,26,8,43,15,9,4,7,85,23,103,88,16,20,24]),function(G,e,I,A,n,C,D,P,f,h,b,v,y,g,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const o=new Map;async function u(t,a){const i=`${t}::${a.join(":")}`,r=o.get(i);if(r)return r;const c=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],l=new Map,s=new Map,d=2e4;function S(O,N,K,V){const X=N.substring(O.length+1);return A.Promises.withAsyncBody(async ie=>{let re;try{re=await b.Promises.readdir(N,{withFileTypes:!0})}catch{ie();return}if(V.count>=d){V.count+=re.length,V.maxReached=!0,ie();return}let ce=re.length;if(ce===0){ie();return}let fe=re;V.count+re.length>d&&(V.maxReached=!0,ce=d-V.count,fe=re.slice(0,ce)),V.count+=re.length;for(const ge of fe)if(ge.isDirectory()){if(K.includes(ge.name)||await S(O,(0,D.join)(N,ge.name),K,V),--ce===0){ie();return}}else{const x=ge.name.lastIndexOf(".");if(x>=0){const F=ge.name.substring(x+1);F&&l.set(F,(l.get(F)??0)+1)}for(const F of c)F.relativePathPattern?.test(X)!==!1&&F.filePattern.test(ge.name)&&s.set(F.tag,(s.get(F.tag)??0)+1);if(--ce===0){ie();return}}})}const R=A.Promises.withAsyncBody(async O=>{const N={count:0,maxReached:!1};await S(t,t,a,N);const K=await E(t);O({configFiles:p(s),fileTypes:p(l),fileCount:N.count,maxFilesReached:N.maxReached,launchConfigFiles:K})});return o.set(i,R),R}e.collectWorkspaceStats=u;function p(t){return Array.from(t.entries(),([a,i])=>({name:a,count:i})).sort((a,i)=>i.count-a.count)}function k(){const t={os:`${I.type()} ${I.arch()} ${I.release()}`,memory:`${(I.totalmem()/g.ByteSize.GB).toFixed(2)}GB (${(I.freemem()/g.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(h.virtualMachineHint.value()*100)}%`},a=I.cpus();return a&&a.length>0&&(t.cpus=`${a[0].model} (${a.length} x ${a[0].speed})`),t}e.getMachineInfo=k;async function E(t){try{const a=new Map,i=(0,D.join)(t,".vscode","launch.json"),r=await b.Promises.readFile(i),c=[],l=(0,n.parse)(r.toString(),c);if(c.length)return console.log(`Unable to parse ${i}`),[];if((0,n.getNodeType)(l)==="object"&&l.configurations)for(const s of l.configurations){const d=s.type;d&&(a.has(d)?a.set(d,a.get(d)+1):a.set(d,1))}return p(a)}catch{return[]}}e.collectLaunchConfigs=E;let M=class{constructor(a,i){this.c=a,this.d=i}f(a){const i=[];return i.push(`OS Version:       ${a.os}`),i.push(`CPUs:             ${a.cpus}`),i.push(`Memory (System):  ${a.memory}`),i.push(`VM:               ${a.vmHint}`),i.join(`
`)}g(a){const i=[];i.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),i.push(`OS Version:       ${I.type()} ${I.arch()} ${I.release()}`);const r=I.cpus();return r&&r.length>0&&i.push(`CPUs:             ${r[0].model} (${r.length} x ${r[0].speed})`),i.push(`Memory (System):  ${(I.totalmem()/g.ByteSize.GB).toFixed(2)}GB (${(I.freemem()/g.ByteSize.GB).toFixed(2)}GB free)`),P.isWindows||i.push(`Load (avg):       ${I.loadavg().map(c=>Math.round(c)).join(", ")}`),i.push(`VM:               ${Math.round(h.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${a.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${a.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.j(a.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(a,i){return Promise.all([(0,v.listProcesses)(a.mainPID),this.k(a)]).then(async r=>{let[c,l]=r,s=this.m(a,c);return i.forEach(d=>{if((0,y.isRemoteDiagnosticError)(d))s+=`
${d.errorMessage}`,l+=`
${d.errorMessage}`;else if(s+=`

Remote: ${d.hostName}`,d.processes&&(s+=`
${this.m(a,d.processes)}`),d.workspaceMetadata){l+=`
|  Remote: ${d.hostName}`;for(const S of Object.keys(d.workspaceMetadata)){const R=d.workspaceMetadata[S];let O=`${R.fileCount} files`;R.maxFilesReached&&(O=`more than ${O}`),l+=`|    Folder (${S}): ${O}`,l+=this.h(R)}}}),{processInfo:s,workspaceInfo:l}})}async getSystemInfo(a,i){const{memory:r,vmHint:c,os:l,cpus:s}=k(),d={os:l,memory:r,cpus:s,vmHint:c,processArgs:`${a.mainArguments.join(" ")}`,gpuStatus:a.gpuFeatureStatus,screenReader:`${a.screenReader?"yes":"no"}`,remoteData:i};return P.isWindows||(d.load=`${I.loadavg().map(S=>Math.round(S)).join(", ")}`),P.isLinux&&(d.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(d)}async getDiagnostics(a,i){const r=[];return(0,v.listProcesses)(a.mainPID).then(async c=>(r.push(""),r.push(this.g(a)),r.push(""),r.push(this.m(a,c)),a.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(r.push(""),r.push("Workspace Stats: "),r.push(await this.k(a))),i.forEach(l=>{if((0,y.isRemoteDiagnosticError)(l))r.push(`
${l.errorMessage}`);else if(r.push(`

`),r.push(`Remote:           ${l.hostName}`),r.push(this.f(l.machineInfo)),l.processes&&r.push(this.m(a,l.processes)),l.workspaceMetadata)for(const s of Object.keys(l.workspaceMetadata)){const d=l.workspaceMetadata[s];let S=`${d.fileCount} files`;d.maxFilesReached&&(S=`more than ${S}`),r.push(`Folder (${s}): ${S}`),r.push(this.h(d))}}),r.push(""),r.push(""),r.join(`
`)))}h(a){const i=[];let c=0;const l=(R,O)=>{const N=` ${R}(${O})`;c+N.length>60?(i.push(s),s="|                 ",c=s.length):c+=N.length,s+=N};let s="|      File types:";const d=10,S=a.fileTypes.length>d?d:a.fileTypes.length;for(let R=0;R<S;R++){const O=a.fileTypes[R];l(O.name,O.count)}if(i.push(s),a.configFiles.length>=0&&(s="|      Conf files:",c=0,a.configFiles.forEach(R=>{l(R.name,R.count)}),i.push(s)),a.launchConfigFiles.length>0){let R="|      Launch Configs:";a.launchConfigFiles.forEach(O=>{R+=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`}),i.push(R)}return i.join(`
`)}j(a){const i=Math.max(...Object.keys(a).map(r=>r.length));return Object.keys(a).map(r=>`${r}:  ${" ".repeat(i-r.length)}  ${a[r]}`).join(`
                  `)}k(a){const i=[],r=[];return a.windows.forEach(c=>{c.folderURIs.length===0||!!c.remoteAuthority||(i.push(`|  Window (${c.title})`),c.folderURIs.forEach(l=>{const s=f.URI.revive(l);if(s.scheme===C.Schemas.file){const d=s.fsPath;r.push(u(d,["node_modules",".git"]).then(S=>{let R=`${S.fileCount} files`;S.maxFilesReached&&(R=`more than ${R}`),i.push(`|    Folder (${(0,D.basename)(d)}): ${R}`),i.push(this.h(S))}).catch(S=>{i.push(`|      Error: Unable to collect workspace stats for folder ${d} (${S.toString()})`)}))}else i.push(`|    Folder (${s.toString()}): Workspace stats not available.`)}))}),Promise.all(r).then(c=>i.join(`
`)).catch(c=>`Unable to collect workspace stats: ${c}`)}m(a,i){const r=new Map;a.windows.forEach(l=>r.set(l.pid,l.title));const c=[];return c.push("CPU %	Mem MB	   PID	Process"),i&&this.n(a.mainPID,r,c,i,0),c.join(`
`)}n(a,i,r,c,l){const s=l===0;let d;s?d=c.pid===a?`${this.d.applicationName} main`:"remote agent":(d=`${"  ".repeat(l)} ${c.name}`,c.name==="window"&&(d=`${d} (${i.get(c.pid)})`));const S=process.platform==="win32"?c.mem:I.totalmem()*(c.mem/100);r.push(`${c.load.toFixed(0).padStart(5," ")}	${(S/g.ByteSize.MB).toFixed(0).padStart(6," ")}	${c.pid.toFixed(0).padStart(6," ")}	${d}`),Array.isArray(c.children)&&c.children.forEach(R=>this.n(a,i,r,R,l+1))}async getWorkspaceFileExtensions(a){const i=new Set;for(const{uri:r}of a.folders){const c=f.URI.revive(r);if(c.scheme!==C.Schemas.file)continue;const l=c.fsPath;try{(await u(l,["node_modules",".git"])).fileTypes.forEach(d=>i.add(d.name))}catch{}}return{extensions:[...i]}}async reportWorkspaceStats(a){for(const{uri:i}of a.folders){const r=f.URI.revive(i);if(r.scheme!==C.Schemas.file)continue;const c=r.fsPath;try{const l=await u(c,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":a.telemetryId,rendererSessionId:a.rendererSessionId}),l.fileTypes.forEach(s=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:a.rendererSessionId,type:s.name,count:s.count})}),l.launchConfigFiles.forEach(s=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:a.rendererSessionId,type:s.name,count:s.count})}),l.configFiles.forEach(s=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:a.rendererSessionId,type:s.name,count:s.count})})}catch{}}}};M=ve([_(0,w.ITelemetryService),_(1,m.IProductService)],M),e.DiagnosticsService=M}),define(ee[240],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class I{constructor(C){this.b=C}listen(C,D){throw new Error(`Event not found: ${D}`)}call(C,D,{eventName:P,data:f}){return this.b.forEach(h=>h.log(P,f)),Promise.resolve(null)}}e.TelemetryAppenderChannel=I;class A{constructor(C){this.b=C}log(C,D){return this.b.call("log",{eventName:C,data:D}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=A}),define(ee[52],te([0,1,40,10,3,19,56,93,24]),function(G,e,I,A,n,C,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogChannelId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class h{constructor(s){this.value=s}}e.TelemetryTrustedValue=h;class b{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(s,d){return Promise.resolve(void 0)}publicLog2(s,d){return this.publicLog(s,d)}publicLogError(s,d){return Promise.resolve(void 0)}publicLogError2(s,d){return this.publicLogError(s,d)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=b,e.NullTelemetryService=new b;class v{async publicLog(s,d,S){}async publicLogError(s,d,S){}}e.NullEndpointTelemetryService=v,e.telemetryLogChannelId="telemetryLog",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function y(l,s){return n.Event.debounce(s.onDidChangeConfiguration,(S,R)=>{const O=S?new Set([...S.affectedKeys,...R.affectedKeys]):R.affectedKeys;return{...R,affectedKeys:O}},1e3,!0)(S=>{S.source!==7&&l.publicLog2("updateConfiguration",{configurationSource:(0,C.ConfigurationTargetToString)(S.source),configurationKeys:E(S.affectedKeys)})})}e.configurationTelemetry=y;function g(l,s){return!s.isBuilt&&!s.disableTelemetry?!0:!(s.disableTelemetry||!l.enableTelemetry||s.extensionTestsLocationURI)}e.supportsTelemetry=g;function m(l,s){return!(s.isBuilt||s.disableTelemetry||l.enableTelemetry&&l.aiConfig?.ariaKey)}e.isLoggingOnly=m;function w(l){const s=l.getValue(f.TELEMETRY_SETTING_ID),d=l.getValue(f.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(l.getValue(f.TELEMETRY_OLD_SETTING_ID)===!1||d===!1)return 0;switch(s??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=w;function o(l){const s={},d={},S={};k(l,S);for(let R in S){R=R.length>150?R.substr(R.length-149):R;const O=S[R];typeof O=="number"?d[R]=O:typeof O=="boolean"?d[R]=O?1:0:typeof O=="string"?(O.length>8192&&console.warn(`Telemetry property: ${R} has been trimmed to 8192, the original length is ${O.length}`),s[R]=O.substring(0,8191)):typeof O<"u"&&O!==null&&(s[R]=O)}return{properties:s,measurements:d}}e.validateTelemetryData=o;const u=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function p(l){if(!l)return"none";const s=(0,D.getRemoteName)(l);return u.has(s)?s:"other"}e.cleanRemoteAuthority=p;function k(l,s,d=0,S){if(!!l)for(const R of Object.getOwnPropertyNames(l)){const O=l[R],N=S?S+R:R;Array.isArray(O)?s[N]=(0,I.safeStringify)(O):O instanceof Date?s[N]=O.toISOString():(0,A.isObject)(O)?d<2?k(O,s,d+1,N+"."):s[N]=(0,I.safeStringify)(O):s[N]=O}}function E(l){if(!l)return[];const s=[];return M(s,"",l),s}function M(l,s,d){d&&typeof d=="object"&&!Array.isArray(d)?Object.keys(d).forEach(S=>M(l,s?`${s}.${S}`:S,d[S])):l.push(s)}function t(l,s){const d=l.msftInternalDomains||[],S=s.getValue("telemetry.internalTesting");return(0,P.verifyMicrosoftInternalDomain)(d)||S}e.isInternalTelemetry=t;function a(l){return[l.appRoot,l.extensionsPath,l.userHome.fsPath,l.tmpDir.fsPath,l.userDataPath]}e.getPiiPathsFromEnvironment=a;function i(l,s){if(!l||!l.includes("/")&&!l.includes("\\"))return l;let d=l;const S=[];for(const K of s)for(;;){const V=K.exec(l);if(!V)break;S.push([V.index,K.lastIndex])}const R=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,O=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let N=0;for(d="";;){const K=O.exec(l);if(!K)break;const V=S.some(([X,ie])=>K.index<ie&&X<O.lastIndex);!R.test(K[0])&&!V&&(d+=l.substring(N,K.index)+"<REDACTED: user-file-path>",N=O.lastIndex)}return N<l.length&&(d+=l.substr(N)),d}function r(l){if(!l)return l;const s=l.toLowerCase(),d=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const S of d)if(S.regex.test(s))return`<REDACTED: ${S.label}>`;return l}function c(l,s){return(0,I.cloneAndChange)(l,d=>{if(d instanceof h)return d.value;if(typeof d=="string"){let S=d.replaceAll("%20"," ");S=i(S,s);for(const R of s)S=S.replace(R,"");return S=r(S),S}})}e.cleanData=c}),define(ee[113],te([0,1,27,198,91,4,7,13,36,52]),function(G,e,I,A,n,C,D,P,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function b(i,r){return i.uuid&&r.uuid?i.uuid===r.uuid:i.id===r.id?!0:(0,I.compareIgnoreCase)(i.id,r.id)===0}e.areSameExtensions=b;const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class y{static create(r){const c=r.manifest?r.manifest.version:r.version,l=r.manifest?r.targetPlatform:r.properties.targetPlatform;return new y(r.identifier,c,l)}static parse(r){const c=v.exec(r);return c&&c[1]&&c[2]?new y({id:c[1]},c[2],c[4]||void 0):null}constructor(r,c,l="undefined"){this.version=c,this.targetPlatform=l,this.id=r.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(r){return r instanceof y?b(this,r)&&this.version===r.version&&this.targetPlatform===r.targetPlatform:!1}}e.ExtensionKey=y;const g=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function m(i){const r=g.exec(i);return r&&r[1]?[o(r[1]),r[2]]:[o(i),void 0]}e.getIdAndVersion=m;function w(i,r){return`${i}.${r}`}e.getExtensionId=w;function o(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=o;function u(i,r){return o(w(i,r))}e.getGalleryExtensionId=u;function p(i,r){const c=[],l=s=>{for(const d of c)if(d.some(S=>b(r(S),r(s))))return d;return null};for(const s of i){const d=l(s);d?d.push(s):c.push([s])}return c}e.groupByExtension=p;function k(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=k;function E(i){return{id:new h.TelemetryTrustedValue(i.identifier.id),name:new h.TelemetryTrustedValue(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.getGalleryExtensionTelemetryData=E,e.BetterMergeId=new n.ExtensionIdentifier("pprice.better-merge");function M(i,r){const c=[],l=r.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const s=l.shift();if(s&&c.every(d=>!b(d.identifier,{id:s}))){const d=i.filter(S=>b(S.identifier,{id:s}));d.length===1&&(c.push(d[0]),l.push(...d[0].manifest.extensionDependencies?.slice(0)??[]))}}return c}e.getExtensionDependencies=M;async function t(i,r){if(!C.isLinux)return!1;let c;try{c=(await i.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{c=(await i.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(s){r.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(s))}}return!!c&&(c.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=t;async function a(i,r){const c=await t(i,r),l=(0,A.getTargetPlatform)(c?"alpine":C.platform,f.arch);return r.debug("ComputeTargetPlatform:",l),l}e.computeTargetPlatform=a}),define(ee[241],te([0,1,195,52]),function(G,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function n(C,D,P,f,h,b,v){const y={"X-Market-Client-Id":`VSCode ${C}`,"User-Agent":`VSCode ${C} (${D.nameShort})`};if((0,A.supportsTelemetry)(D,P)&&(0,A.getTelemetryLevel)(f)===3){const g=await(0,I.getServiceMachineId)(P,h,b),{machineId:m}=await v.getTelemetryInfo();y["X-Market-User-Id"]=g,y["VSCode-SessionId"]=m||g}return y}e.resolveMarketplaceHeaders=n}),define(ee[242],te([0,1,13,40,52]),function(G,e,I,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const C="https://mobile.events.data.microsoft.com/OneCollector/1.0",D="https://mobile.events.data.microsoft.com/ping";async function P(h,b,v){const y=await new Promise((u,p)=>{G(["@microsoft/1ds-core-js"],u,p)}),g=await new Promise((u,p)=>{G(["@microsoft/1ds-post-js"],u,p)}),m=new y.AppInsightsCore,w=new g.PostChannel,o={instrumentationKey:h,endpointUrl:C,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[w]]};if(v){o.extensionConfig={};const u={alwaysUseXhrOverride:!0,httpXHROverride:v};o.extensionConfig[w.identifier]=u}return m.initialize(o,[]),m.addTelemetryInitializer(u=>{b&&(u.ext=u.ext??{},u.ext.utc=u.ext.utc??{},u.ext.utc.flags=8462029)}),m}class f{constructor(b,v,y,g,m){this.e=b,this.f=v,this.g=y,this.h=m,this.c=C,this.d=D,this.g||(this.g={}),typeof g=="function"?this.a=g():this.a=g,this.b=null}i(b){if(!!this.a){if(typeof this.a!="string"){b(this.a);return}this.b||(this.b=P(this.a,this.e,this.h)),this.b.then(v=>{b(v)},v=>{(0,I.onUnexpectedError)(v),console.error(v)})}}log(b,v){if(!this.a)return;v=(0,A.mixin)(v,this.g),v=(0,n.validateTelemetryData)(v);const y=this.f+"/"+b;try{this.i(g=>{g.pluginVersionString=v?.properties.version??"Unknown",g.track({name:y,baseData:{name:y,properties:v?.properties,measurements:v?.measurements}})})}catch{}}flush(){return this.a?new Promise(b=>{this.i(v=>{v.unload(!0,()=>{this.a=void 0,b(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=f}),define(ee[114],te([0,1,2,40,4,27,174,19,68,66,20,51,24,52]),function(G,e,I,A,n,C,D,P,f,h,b,v,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let m=class{constructor(u,p,k){this.k=p,this.l=k,this.d={},this.i=new I.DisposableStore,this.j=[],this.b=u.appenders,this.c=u.commonProperties||Promise.resolve({}),this.f=u.piiPaths||[],this.g=3,this.h=!!u.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const E of this.f)this.j.push(new RegExp((0,C.escapeRegExpCharacters)(E),"gi")),E.indexOf("\\")>=0&&this.j.push(new RegExp((0,C.escapeRegExpCharacters)(E.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(E=>{(E.affectsConfiguration(y.TELEMETRY_SETTING_ID)||E.affectsConfiguration(y.TELEMETRY_OLD_SETTING_ID)||E.affectsConfiguration(y.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(u,p){this.d[u]=p}m(){let u=(0,g.getTelemetryLevel)(this.k);const p=this.l.enabledTelemetryLevels;if(p){this.h=this.sendErrorTelemetry?p.error:!1;const k=p.usage?3:p.error?2:0;u=Math.min(u,k)}this.g=u}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const u=await this.c,p=u.sessionID,k=u["common.machineId"],E=u["common.firstSessionDate"],M=u["common.msftInternal"];return{sessionId:p,machineId:k,firstSessionDate:E,msftInternal:M}}dispose(){this.i.dispose()}n(u,p,k){return this.g<p?Promise.resolve(void 0):this.c.then(E=>{k=(0,A.mixin)(k,this.d),k=(0,g.cleanData)(k,this.j),k=(0,A.mixin)(k,E),this.b.forEach(M=>M.log(u,k))},E=>{console.error(E)})}publicLog(u,p){return this.n(u,3,p)}publicLog2(u,p){return this.publicLog(u,p)}publicLogError(u,p){return this.h?this.n(u,2,p):Promise.resolve(void 0)}publicLogError2(u,p){return this.publicLogError(u,p)}};m.IDLE_START_EVENT_NAME="UserIdleStart",m.IDLE_STOP_EVENT_NAME="UserIdleStop",m=ve([_(1,P.IConfigurationService),_(2,b.IProductService)],m),e.TelemetryService=m;function w(){const o=(0,D.localize)(0,null,h.default.nameLong),u=h.default.privacyStatementUrl?(0,D.localize)(2,null,"https://aka.ms/vscode-telemetry",h.default.privacyStatementUrl):(0,D.localize)(1,null,"https://aka.ms/vscode-telemetry"),p=n.isWeb?"":(0,D.localize)(3,null),k=(0,D.localize)(4,null),E=(0,D.localize)(5,null),M=(0,D.localize)(6,null),t=(0,D.localize)(7,null),a=`
|       | ${k} | ${E} | ${M} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,D.localize)(8,null);return`
${o} ${u} ${p}

&nbsp;

${t}
${a}

&nbsp;

${i}
`}v.Registry.as(f.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,D.localize)(9,null),properties:{[y.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,D.localize)(10,null),(0,D.localize)(11,null),(0,D.localize)(12,null),(0,D.localize)(13,null)],markdownDescription:w(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),v.Registry.as(f.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,D.localize)(14,null),properties:{[y.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:h.default.privacyStatementUrl?(0,D.localize)(16,null,h.default.nameLong,h.default.privacyStatementUrl):(0,D.localize)(15,null,h.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,D.localize)(17,null,`\`#${y.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ee[243],te([0,1,290,242]),function(G,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class n extends A.AbstractOneDataSystemAppender{constructor(D,P,f,h){const b={sendPOST:(v,y)=>{const g={method:"POST",headers:{...v.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(v.data)}};try{const m=I.request(v.urlString,g,w=>{w.on("data",function(o){y(w.statusCode??200,w.headers,o.toString())}),w.on("error",function(o){y(0,{})})});m.write(v.data),m.end()}catch{y(0,{})}}};super(D,P,f,h,b)}}e.OneDataSystemAppender=n}),define(ee[244],te([0,1,4,85,24]),function(G,e,I,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function C(D){let P=D.getItem(n.machineIdKey);return(typeof P!="string"||I.isMacintosh&&P==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(P=await(0,A.getMachineId)()),P}e.resolveMachineId=C}),define(ee[115],te([0,1,24,244]),function(G,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function n(C){const D=await(0,A.resolveMachineId)(C);return C.setItem(I.machineIdKey,D),D}e.resolveMachineId=n}),define(ee[69],te([0,1,14,3,2,4,19,6,34]),function(G,e,I,A,n,C,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const h="#FFFFFF",b="#1E1E1E",v="#000000",y="#FFFFFF",g="theme",m="themeBackground",w="windowSplash";e.IThemeMainService=(0,P.createDecorator)("themeMainService");let o=class extends n.Disposable{constructor(p,k){super(),this.b=p,this.c=k,this.a=this.B(new A.Emitter),this.onDidChangeColorScheme=this.a.event,I.nativeTheme.on("updated",()=>{this.a.fire(this.getColorScheme())})}getColorScheme(){if(C.isWindows){if(I.nativeTheme.shouldUseHighContrastColors)return{dark:I.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(C.isMacintosh){if(I.nativeTheme.shouldUseInvertedColorScheme||I.nativeTheme.shouldUseHighContrastColors)return{dark:I.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(C.isLinux&&I.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:I.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const p=this.getColorScheme();if(p.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return p.dark?v:y;let k=this.b.getItem(m,null);if(!k)switch(this.b.getItem(g,"vs-dark").split(" ")[0]){case"vs":k=h;break;case"hc-black":k=v;break;case"hc-light":k=y;break;default:k=b}return C.isMacintosh&&k.toUpperCase()===b&&(k="#171717"),k}saveWindowSplash(p,k){this.b.setItems([{key:g,data:k.baseTheme},{key:m,data:k.colorInfo.background},{key:w,data:k}]),typeof p=="number"&&this.f(p,k)}f(p,k){for(const E of I.BrowserWindow.getAllWindows())if(E.id===p){E.setBackgroundColor(k.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(w)}};o=ve([_(0,f.IStateMainService),_(1,D.IConfigurationService)],o),e.ThemeMainService=o}),define(ee[116],te([0,1,3,19,6,5]),function(G,e,I,A,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,n.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,n.createDecorator)("sharedTunnelsService");var D;(function(w){w.Http="http",w.Https="https"})(D=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(w){w.ConstantPrivate="constantPrivate",w.Private="private",w.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var f;(function(w){w[w.Notify=1]="Notify",w[w.OpenBrowser=2]="OpenBrowser",w[w.OpenPreview=3]="OpenPreview",w[w.Silent=4]="Silent",w[w.Ignore=5]="Ignore",w[w.OpenBrowserOnce=6]="OpenBrowserOnce"})(f=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function h(w){if(w.scheme!=="http"&&w.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(w.authority);if(!!o)return{address:o[1],port:+o[2]}}e.extractLocalHostUriMetaDataForPortMapping=h,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function b(w){return e.LOCALHOST_ADDRESSES.indexOf(w)>=0}e.isLocalhost=b,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(w){return e.ALL_INTERFACES_ADDRESSES.indexOf(w)>=0}e.isAllInterfaces=v;function y(w,o,u,p){if(u===1)return!1;if(u===2&&v(o)){const k=/(\d+)\.(\d+)\.(\d+)/g.exec(p);if(k?.length===4&&parseInt(k[1])>=18)return!1}return w<1024}e.isPortPrivileged=y;class g{constructor(o,u,p){this.remoteAddress=o,this.localAddress=u,this.b=p,this.a=new I.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=g;let m=class{constructor(o,u){this.i=o,this.j=u,this.a=new I.Emitter,this.onTunnelOpened=this.a.event,this.b=new I.Emitter,this.onTunnelClosed=this.b.event,this.c=new I.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const o=this.j.getValue("remote.localPortHost");return!o||o==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(o){return this.e=o,o?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this.f=o.elevation,this.g=o.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const o=[],u=Array.from(this.d.values());for(const p of u){const k=Array.from(p.values());for(const E of k){const M=await E.value;M&&o.push(M)}}return o}async dispose(){for(const o of this.d.values()){for(const{value:u}of o.values())await u.then(p=>p?.dispose());o.clear()}this.d.clear()}setEnvironmentTunnel(o,u,p,k,E){this.o(o,u,Promise.resolve({tunnelRemoteHost:o,tunnelRemotePort:u,localAddress:p,privacy:k,protocol:E,dispose:()=>Promise.resolve()}))}async getExistingTunnel(o,u){(v(o)||b(o))&&(o=e.LOCALHOST_ADDRESSES[0]);const p=this.q(o,u);if(p)return++p.refcount,p.value}openTunnel(o,u,p,k,E,M=!1,t,a){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${p} on local port ${E}.`),!o)return;if(u||(u="localhost"),k||(k=this.k),this.e&&this.h.has(p)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const i=this.r(o,u,p,k,E,M,t,a);return i?i.then(r=>{if(!r){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(u,p);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const c=this.m(r);return(r.tunnelRemoteHost!==u||r.tunnelRemotePort!==p)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(c),c}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}m(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const u=this.d.get(o.tunnelRemoteHost);if(u){const p=u.get(o.tunnelRemotePort);p&&(p.refcount--,await this.n(o.tunnelRemoteHost,o.tunnelRemotePort,p))}}}}async n(o,u,p){if(p.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${u}.`);const k=p.value.then(async E=>{E&&(await E.dispose(!0),this.b.fire({host:E.tunnelRemoteHost,port:E.tunnelRemotePort}))});return this.d.has(o)&&this.d.get(o).delete(u),k}}async closeTunnel(o,u){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${u} `);const p=this.d.get(o);if(p&&p.has(u)){const k=p.get(u);k.refcount=0,await this.n(o,u,k)}}o(o,u,p){this.d.has(o)||this.d.set(o,new Map),this.d.get(o).set(u,{refcount:1,value:p})}async p(o,u){const p=this.d.get(o);p&&(await p.get(u)||p.delete(u),p.size===0&&this.d.delete(o))}q(o,u){const p=[o];b(o)?(p.push(...e.LOCALHOST_ADDRESSES),p.push(...e.ALL_INTERFACES_ADDRESSES)):v(o)&&p.push(...e.ALL_INTERFACES_ADDRESSES);const k=p.map(E=>this.d.get(E));for(const E of k){const M=E?.get(u);if(M)return M}}canTunnel(o){return!!h(o)}s(o,u,p,k,E,M,t){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${p} on local port ${k}.`);const a=p;this.h.add(a);const i=k===void 0?p:k,r={elevationRequired:E?this.isPortPrivileged(i):!1},c={remoteAddress:{host:u,port:p},localAddressPort:k,privacy:M,public:M?M!==P.Private:void 0,protocol:t},l=o.forwardPort(c,r);return l?(this.o(u,p,l),l.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(a)})):this.h.delete(a),l}};m=ve([_(0,C.ILogService),_(1,A.IConfigurationService)],m),e.AbstractTunnelService=m}),define(ee[245],te([0,1,82,26,100,229,8,2,19,5,20,228,116,92,4]),function(G,e,I,A,n,C,D,P,f,h,b,v,y,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function w(E,M,t,a,i){let r;for(let c=3;c&&(r?.dispose(),r=await new o(E,M,t,a,i).waitForReady(),!(i&&n.BROWSER_RESTRICTED_PORTS[i]||!n.BROWSER_RESTRICTED_PORTS[r.tunnelLocalPort]));c--);return r}class o extends P.Disposable{constructor(M,t,a,i,r){super(),this.j=t,this.k=r,this.privacy=y.TunnelPrivacyId.Private,this.i=new Map,this.a=M,this.b=I.createServer(),this.c=new D.Barrier,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=c=>this.l(c),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=i,this.tunnelRemoteHost=a}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(t=>{t()})}async waitForReady(){const M=this.k??this.tunnelRemotePort,t=(0,y.isAllInterfaces)(this.j)?"0.0.0.0":"127.0.0.1";let a=await(0,n.findFreePortFaster)(M,2,1e3,t),i=null;return this.b.listen(a,this.j),await this.c.wait(),i=this.b.address(),i||(a=0,this.b.listen(a,this.j),await this.c.wait(),i=this.b.address()),this.tunnelLocalPort=i.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${i.port}`,this}async l(M){M.pause();const t=(0,y.isLocalhost)(this.tunnelRemoteHost)||(0,y.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,a=await(0,v.connectRemoteAgentTunnel)(this.a,t,this.tunnelRemotePort),i=a.getSocket().socket,r=a.readEntireBuffer();a.dispose(),r.byteLength>0&&M.write(r.buffer),M.on("end",()=>{M.localAddress&&this.i.delete(M.localAddress),i.end()}),M.on("close",()=>i.end()),M.on("error",()=>{M.localAddress&&this.i.delete(M.localAddress),i.destroy()}),i.on("end",()=>M.end()),i.on("close",()=>M.end()),i.on("error",()=>{M.destroy()}),M.pipe(i),i.pipe(M),M.localAddress&&this.i.set(M.localAddress,()=>{M.end(),i.end()})}}let u=class extends y.AbstractTunnelService{constructor(M,t,a,i,r){super(t,r),this.t=M,this.u=a,this.v=i}isPortPrivileged(M){return(0,y.isPortPrivileged)(M,this.k,m.OS,A.release())}r(M,t,a,i,r,c,l,s){const d=this.q(t,a);if(d)return++d.refcount,d.value;if(this.e)return this.s(this.e,t,a,r,c,l,s);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${t}:${a} on local port ${r}.`);const S={commit:this.v.commit,quality:this.v.quality,socketFactory:this.t,addressProvider:M,signService:this.u,logService:this.i,ipcLogger:null},R=w(S,i,t,a,r);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(t,a,R),R}}};u=ve([_(1,h.ILogService),_(2,g.ISignService),_(3,b.IProductService),_(4,f.IConfigurationService)],u),e.BaseTunnelService=u;let p=class extends u{constructor(M,t,a,i){super(C.nodeSocketFactory,M,t,a,i)}};p=ve([_(0,h.ILogService),_(1,g.ISignService),_(2,b.IProductService),_(3,f.IConfigurationService)],p),e.TunnelService=p;let k=class extends P.Disposable{constructor(M,t,a,i){super(),this.b=M,this.c=t,this.f=a,this.g=i,this.a=new Map}async openTunnel(M,t,a,i,r,c,l,s,d){if(this.b.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${a}:${i} on local port ${c}.`),!this.a.has(M)){const S=new p(this.b,this.f,this.c,this.g);this.B(S),this.a.set(M,S),S.onTunnelClosed(async()=>{(await S.tunnels).length===0&&(S.dispose(),this.a.delete(M))})}return this.a.get(M).openTunnel(t,a,i,r,c,l,s,d)}};k=ve([_(0,h.ILogService),_(1,b.IProductService),_(2,g.ISignService),_(3,f.IConfigurationService)],k),e.SharedTunnelsService=k}),define(ee[49],te([0,1,6]),function(G,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var A;(function(C){C.Uninitialized="uninitialized",C.Idle="idle",C.CheckingForUpdates="checking for updates",C.AvailableForDownload="available for download",C.Downloading="downloading",C.Downloaded="downloaded",C.Updating="updating",C.Ready="ready"})(A=e.StateType||(e.StateType={}));var n;(function(C){C[C.Setup=0]="Setup",C[C.Archive=1]="Archive",C[C.Snap=2]="Snap"})(n=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(C,D)=>({type:"idle",updateType:C,error:D}),CheckingForUpdates:C=>({type:"checking for updates",explicit:C}),AvailableForDownload:C=>({type:"available for download",update:C}),Downloading:C=>({type:"downloading",update:C}),Downloaded:C=>({type:"downloaded",update:C}),Updating:C=>({type:"updating",update:C}),Ready:C=>({type:"ready",update:C})},e.IUpdateService=(0,I.createDecorator)("updateService")}),define(ee[246],te([0,1,4,175,68,51]),function(G,e,I,A,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),C.Registry.as(n.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,A.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,A.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,A.localize)(2,null),(0,A.localize)(3,null),(0,A.localize)(4,null),(0,A.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,A.localize)(6,null),deprecationMessage:(0,A.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,A.localize)(8,null),description:(0,A.localize)(9,null),included:I.isWindows&&!I.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,A.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(ee[247],te([0,1,3,49]),function(G,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class n{constructor(P){this.a=P}listen(P,f){switch(f){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${f}`)}call(P,f,h){switch(f){case"checkForUpdates":return this.a.checkForUpdates(h);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(h)}throw new Error(`Call not found: ${f}`)}}e.UpdateChannel=n;class C{get state(){return this.b}set state(P){this.b=P,this.a.fire(P)}constructor(P){this.c=P,this.a=new I.Emitter,this.onStateChange=this.a.event,this.b=A.State.Uninitialized,this.c.listen("onStateChange")(f=>this.state=f),this.c.call("_getInitialState").then(f=>this.state=f)}checkForUpdates(P){return this.c.call("checkForUpdates",P)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(P){return this.c.call("_applySpecificUpdate",P)}}e.UpdateChannelClient=C}),define(ee[94],te([0,1,8,22,3,19,28,21,5,20,57,49]),function(G,e,I,A,n,C,D,P,f,h,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function y(m,w,o){return`${o.updateUrl}/api/update/${m}/${w}/${o.commit}`}e.createUpdateURL=y;let g=class{get state(){return this.b}d(w){this.j.info("update#setState",w.type),this.b=w,this.c.fire(w)}constructor(w,o,u,p,k,E){this.f=w,this.g=o,this.h=u,this.i=p,this.j=k,this.k=E,this.b=v.State.Uninitialized,this.c=new n.Emitter,this.onStateChange=this.c.event}async initialize(){if(!this.h.isBuilt)return;if(this.h.disableUpdates){this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.j.info("update#ctor - updates are disabled as there is no update URL");return}const w=this.g.getValue("update.mode"),o=this.l(w);if(!o){this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.r(o),!this.a){this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.d(v.State.Idle(this.p())),w==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}w==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.m(30*1e3).then(void 0,u=>this.j.error(u))}l(w){return w==="none"?void 0:this.k.quality}m(w=60*60*1e3){return(0,I.timeout)(w).then(()=>this.checkForUpdates(!1)).then(()=>this.m(60*60*1e3))}async checkForUpdates(w){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.s(w)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.n(this.state)}async n(w){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.o()}async o(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(w=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.q())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},A.CancellationToken.None)).res.statusCode===204}catch(o){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(o);return}}async _applySpecificUpdate(w){}p(){return 1}q(){}};g=ve([_(0,P.ILifecycleMainService),_(1,C.IConfigurationService),_(2,D.IEnvironmentMainService),_(3,b.IRequestService),_(4,f.ILogService),_(5,h.IProductService)],g),e.AbstractUpdateService=g}),define(ee[248],te([0,1,14,55,3,2,19,28,21,5,20,57,24,49,94]),function(G,e,I,A,n,C,D,P,f,h,b,v,y,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let w=class extends m.AbstractUpdateService{get u(){return n.Event.fromNodeEventEmitter(I.autoUpdater,"error",(u,p)=>p)}get v(){return n.Event.fromNodeEventEmitter(I.autoUpdater,"update-not-available")}get w(){return n.Event.fromNodeEventEmitter(I.autoUpdater,"update-available",(u,p,k)=>({url:p,version:k,productVersion:k}))}get x(){return n.Event.fromNodeEventEmitter(I.autoUpdater,"update-downloaded",(u,p,k,E)=>({releaseNotes:p,version:k,productVersion:k,date:E}))}constructor(u,p,k,E,M,t,a){super(u,p,E,M,t,a),this.y=k,this.t=new C.DisposableStore}async initialize(){await super.initialize(),this.u(this.z,this,this.t),this.w(this.C,this,this.t),this.x(this.D,this,this.t),this.v(this.E,this,this.t)}z(u){this.j.error("UpdateService error:",u);const k=(this.state.type==="checking for updates"?this.state.explicit:!0)?u:void 0;this.d(g.State.Idle(1,k))}r(u){let p;this.k.darwinUniversalAssetId?p=this.k.darwinUniversalAssetId:p=process.arch==="x64"?"darwin":"darwin-arm64";const k=(0,m.createUpdateURL)(p,u,this.k);try{I.autoUpdater.setFeedURL({url:k})}catch(E){this.j.error("Failed to set update feed URL",E);return}return k}s(u){this.d(g.State.CheckingForUpdates(u)),I.autoUpdater.checkForUpdates()}C(u){this.state.type==="checking for updates"&&this.d(g.State.Downloading(u))}D(u){this.state.type==="downloading"&&(this.y.publicLog2("update:downloaded",{version:u.version}),this.d(g.State.Ready(u)))}E(){this.state.type==="checking for updates"&&(this.y.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(g.State.Idle(1)))}q(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),I.autoUpdater.quitAndInstall()}dispose(){this.t.dispose()}};ve([A.memoize],w.prototype,"u",null),ve([A.memoize],w.prototype,"v",null),ve([A.memoize],w.prototype,"w",null),ve([A.memoize],w.prototype,"x",null),w=ve([_(0,f.ILifecycleMainService),_(1,D.IConfigurationService),_(2,y.ITelemetryService),_(3,P.IEnvironmentMainService),_(4,v.IRequestService),_(5,h.ILogService),_(6,b.IProductService)],w),e.DarwinUpdateService=w}),define(ee[249],te([0,1,46,41,8,3,9,28,21,5,24,49]),function(G,e,I,A,n,C,D,P,f,h,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let y=class{get state(){return this.a}d(w){this.g.info("update#setState",w.type),this.a=w,this.b.fire(w)}constructor(w,o,u){if(this.f=w,this.g=u,this.a=v.State.Uninitialized,this.b=new C.Emitter,this.onStateChange=this.b.event,o.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(v.State.Idle(this.k())),this.h(30*1e3).then(void 0,p=>this.g.error(p))}h(w=60*60*1e3){return(0,n.timeout)(w).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(w){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(w)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(w){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(w=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(w){}};y=ve([_(0,f.ILifecycleMainService),_(1,P.IEnvironmentMainService),_(2,h.ILogService)],y);let g=class extends y{constructor(w,o,u,p,k,E){super(u,p,k),this.o=w,this.p=o,this.q=E;const M=(0,A.watch)(D.dirname(this.o)),t=C.Event.fromNodeEventEmitter(M,"change",(c,l)=>l),a=C.Event.filter(t,c=>c==="current"),r=C.Event.debounce(a,(c,l)=>l,2e3)(()=>this.checkForUpdates(!1));u.onWillShutdown(()=>{r.dispose(),M.close()})}m(){this.d(v.State.CheckingForUpdates(!1)),this.u().then(w=>{w?this.d(v.State.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(v.State.Idle(2)))},w=>{this.g.error(w),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(v.State.Idle(2,w.message||w))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,I.spawn)("sleep 3 && "+D.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const w=await new Promise((u,p)=>(0,A.realpath)(`${D.dirname(this.o)}/current`,(k,E)=>k?p(k):u(E))),o=D.basename(w);return this.p!==o}isLatestVersion(){return this.u().then(void 0,w=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};g=ve([_(2,f.ILifecycleMainService),_(3,P.IEnvironmentMainService),_(4,h.ILogService),_(5,b.ITelemetryService)],g),e.SnapUpdateService=g}),define(ee[38],te([0,1,6]),function(G,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,I.createDecorator)("IUriIdentityService")}),define(ee[250],te([0,1,38,196,16,18,128,3,2]),function(G,e,I,A,n,C,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class h{constructor(y){this.uri=y,this.time=h._clock++}touch(){return this.time=h._clock++,this}}h._clock=0;let b=class{constructor(y){this.g=y,this.c=new f.DisposableStore,this.f=2**16;const g=new Map,m=w=>{let o=g.get(w.scheme);return o===void 0&&(o=y.hasProvider(w)&&!this.g.hasCapability(w,1024),g.set(w.scheme,o)),o};this.c.add(P.Event.any(y.onDidChangeFileSystemProviderRegistrations,y.onDidChangeFileSystemProviderCapabilities)(w=>{g.delete(w.scheme)})),this.extUri=new C.ExtUri(m),this.d=new D.SkipList((w,o)=>this.extUri.compare(w,o,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(y){this.g.hasProvider(y)&&(y=(0,C.normalizePath)(y));const g=this.d.get(y);return g?g.touch().uri.with({fragment:y.fragment}):(this.d.set(y,new h(y)),this.h(),y)}h(){if(this.d.size<this.f)return;const y=[...this.d.entries()].sort((m,w)=>m[1].touch<w[1].touch?1:m[1].touch>w[1].touch?-1:0);h._clock=0,this.d.clear();const g=this.f*.5;for(let m=0;m<g;m++)this.d.set(y[m][0],y[m][1].touch())}};b=ve([_(0,n.IFileService)],b),e.UriIdentityService=b,(0,A.registerSingleton)(I.IUriIdentityService,b,1)}),define(ee[117],te([0,1,6]),function(G,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,I.createDecorator)("urlService")}),define(ee[251],te([0,1,7]),function(G,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class A{constructor(P){this.a=P}listen(P,f){throw new Error(`Event not found: ${f}`)}call(P,f,h){switch(f){case"handleURL":return this.a.handleURL(I.URI.revive(h[0]),h[1])}throw new Error(`Call not found: ${f}`)}}e.URLHandlerChannel=A;class n{constructor(P){this.a=P}handleURL(P,f){return this.a.call("handleURL",[P.toJSON(),f])}}e.URLHandlerChannelClient=n;class C{constructor(P,f){this.a=P,this.b=f}async routeCall(P,f,h,b){if(f!=="handleURL")throw new Error(`Call not found: ${f}`);if(Array.isArray(h)&&h.length>0){const v=I.URI.revive(h[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",v.toString(!0)),v.query){const y=/\bwindowId=(\d+)/.exec(v.query);if(y){const g=y[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${g}"`,v.toString(!0));const m=new RegExp(`window:${g}`),w=P.connections.find(o=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",o.ctx),m.test(o.ctx)));if(w)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",v.toString(!0)),w;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",v.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",v.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(P,f,h,b)}routeEvent(P,f){throw new Error(`Event not found: ${f}`)}}e.URLHandlerRouter=C}),define(ee[252],te([0,1,8,2,7,20]),function(G,e,I,A,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class D extends A.Disposable{constructor(){super(...arguments),this.a=new Set}open(h,b){const v=[...this.a.values()];return(0,I.first)(v.map(y=>()=>y.handleURL(h,b)),void 0,!1).then(y=>y||!1)}registerHandler(h){return this.a.add(h),(0,A.toDisposable)(()=>this.a.delete(h))}}e.AbstractURLService=D;let P=class extends D{constructor(h){super(),this.b=h}create(h){let{authority:b,path:v,query:y,fragment:g}=h||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return b&&v&&v.indexOf("/")!==0&&(v=`/${v}`),n.URI.from({scheme:this.b.urlProtocol,authority:b,path:v,query:y,fragment:g})}};P=ve([_(0,C.IProductService)],P),e.NativeURLService=P}),define(ee[253],te([0,1,14,8,3,2,4,7]),function(G,e,I,A,n,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;class f{constructor(b,v,y,g,m,w){if(this.f=v,this.g=w,this.a=[],this.b=0,this.c=C.Disposable.None,this.d=new C.DisposableStore,b&&(w.trace("ElectronURLListener initialUrisToHandle:",b.map(p=>p.originalUrl)),this.a=b),D.isWindows){const p=g.isBuilt?[]:[`"${g.appRoot}"`];p.push("--open-url","--"),I.app.setAsDefaultProtocolClient(m.urlProtocol,process.execPath,p)}const o=n.Event.map(n.Event.fromNodeEventEmitter(I.app,"open-url",(p,k)=>({event:p,url:k})),({event:p,url:k})=>(p.preventDefault(),k));this.d.add(o(p=>{const k=this.h(p);!k||this.f.open(k,{originalUrl:p})})),y.getWindows().filter(p=>p.isReady).length>0?(w.trace("ElectronURLListener: window is ready to handle URLs"),this.i()):(w.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),n.Event.once(y.onDidSignalReadyWindow)(this.i,this,this.d))}h(b){try{return P.URI.parse(b)}catch{return}}async i(){if(this.b++>10){this.g.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.g.trace("ElectronURLListener#flush(): flushing URLs");const b=[];for(const v of this.a)await this.f.open(v.uri,{originalUrl:v.originalUrl})?this.g.trace("ElectronURLListener#flush(): URL was handled",v.originalUrl):(this.g.trace("ElectronURLListener#flush(): URL was not yet handled",v.originalUrl),b.push(v));b.length!==0&&(this.a=b,this.c=(0,A.disposableTimeout)(()=>this.i(),500))}dispose(){this.d.dispose(),this.c.dispose()}}e.ElectronURLListener=f}),define(ee[254],te([0,1,6]),function(G,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,I.createDecorator)("webviewManagerService")}),define(ee[255],te([0,1,14,2,15,7]),function(G,e,I,A,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class D extends A.Disposable{constructor(){super();const f=this.b.bind(this);I.protocol.registerFileProtocol(n.Schemas.vscodeWebview,f)}b(f,h){try{const b=C.URI.parse(f.url),v=D.a.get(b.path);if(typeof v=="string"){const y=`vs/workbench/contrib/webview/browser/pre/${v}`,g=n.FileAccess.asFileUri(y);return h({path:decodeURIComponent(g.fsPath),headers:{...n.COI.getHeadersFromQuery(f.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return h({error:-10})}catch{}return h({error:-2})}}e.WebviewProtocolProvider=D,D.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}),define(ee[77],te([0,1,4]),function(G,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function A(b){return!!b.workspaceUri}e.isWorkspaceToOpen=A;function n(b){return!!b.folderUri}e.isFolderToOpen=n;function C(b){return!!b.fileUri}e.isFileToOpen=C;function D(b){const v=P(b),y=b.getValue("window.menuBarVisibility");return y==="default"||v==="native"&&y==="compact"||I.isMacintosh&&I.isNative?"classic":y}e.getMenuBarVisibility=D;function P(b){if(I.isWeb)return"custom";const v=b.getValue("window");if(v){if(I.isMacintosh&&v.nativeTabs===!0||I.isMacintosh&&v.nativeFullScreen===!1)return"native";const m=v.titleBarStyle;if(m==="native"||m==="custom")return m}return I.isLinux?"native":"custom"}e.getTitleBarStyle=P;function f(b){if(!I.isWindows||I.isWeb||P(b)==="native")return!1;const v=b.getValue("window.experimental.windowControlsOverlay.enabled");return typeof v=="boolean"?v:!0}e.useWindowControlsOverlay=f;function h(b=0){return Math.pow(1.2,b)}e.zoomLevelToZoomFactor=h}),define(ee[118],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var I;(function(P){P[P.INITIAL=1]="INITIAL",P[P.LOAD=2]="LOAD",P[P.RELOAD=3]="RELOAD"})(I=e.LoadReason||(e.LoadReason={}));var A;(function(P){P[P.CLOSE=1]="CLOSE",P[P.QUIT=2]="QUIT",P[P.RELOAD=3]="RELOAD",P[P.LOAD=4]="LOAD"})(A=e.UnloadReason||(e.UnloadReason={}));const n=function(P=1){return{width:1024,height:768,mode:P}};e.defaultWindowState=n;var C;(function(P){P[P.Maximized=0]="Maximized",P[P.Normal=1]="Normal",P[P.Minimized=2]="Minimized",P[P.Fullscreen=3]="Fullscreen"})(C=e.WindowMode||(e.WindowMode={}));var D;(function(P){P[P.UNRESPONSIVE=1]="UNRESPONSIVE",P[P.PROCESS_GONE=2]="PROCESS_GONE",P[P.LOAD=3]="LOAD"})(D=e.WindowError||(e.WindowError={}))}),define(ee[30],te([0,1,6]),function(G,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,I.createDecorator)("windowsMainService");var A;(function(n){n[n.CLI=0]="CLI",n[n.DOCK=1]="DOCK",n[n.MENU=2]="MENU",n[n.DIALOG=3]="DIALOG",n[n.DESKTOP=4]="DESKTOP",n[n.API=5]="API"})(A=e.OpenContext||(e.OpenContext={}))}),define(ee[256],te([0,1,14,22,3,72,2,31,75,108,5,20,30]),function(G,e,I,A,n,C,D,P,f,h,b,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var g;(function(w){w[w.Initial=1]="Initial",w[w.StoredCredentialsUsed=2]="StoredCredentialsUsed",w[w.LoginDialogShown=3]="LoginDialogShown"})(g||(g={}));let m=class extends D.Disposable{constructor(o,u,p,k,E){super(),this.g=o,this.h=u,this.i=p,this.j=k,this.k=E,this.a=`${this.k.urlProtocol}.proxy-credentials`,this.b=void 0,this.c=g.Initial,this.f=void 0,this.l()}l(){const o=n.Event.fromNodeEventEmitter(I.app,"login",(u,p,k,E,M)=>({event:u,webContents:p,req:k,authInfo:E,callback:M}));this.B(o(this.m,this))}async m({event:o,authInfo:u,req:p,callback:k}){if(!u.isProxy)return;if(!this.b&&this.c===g.LoginDialogShown&&p.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}o.preventDefault();let E;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),E=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.n(u);try{E=await this.b}finally{this.b=void 0}}k(E?.username,E?.password)}async n(o){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const u=await this.p(o);if(u)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),u;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async p(o){this.g.trace("auth#doResolveProxyCredentials - enter",o);const u=String((0,C.hash)({scheme:o.scheme,host:o.host,port:o.port}));let p,k;try{const a=await this.i.getPassword(this.a,u);if(a){const i=JSON.parse(await this.j.decrypt(a));p=i.username,k=i.password}}catch(a){this.g.error(a)}if(this.c!==g.StoredCredentialsUsed&&typeof p=="string"&&typeof k=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=g.StoredCredentialsUsed,{username:p,password:k};const E=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!E){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${E.id} to handle proxy login`);const M={authInfo:o,username:this.f?.username??p,password:this.f?.password??k,replyChannel:`vscode:proxyAuthResponse:${(0,P.generateUuid)()}`};E.sendWhenReady("vscode:openProxyAuthenticationDialog",A.CancellationToken.None,M),this.c=g.LoginDialogShown;const t=await new Promise(a=>{const i=async(r,c,l)=>{if(c===M.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${E.id}`),E.win?.webContents.off("ipc-message",i),l){const s={username:l.username,password:l.password};try{if(l.remember){const d=await this.j.encrypt(JSON.stringify(s));await this.i.setPassword(this.a,u,d)}else await this.i.deletePassword(this.a,u)}catch(d){this.g.error(d)}a({username:s.username,password:s.password})}else a(void 0)};E.win?.webContents.on("ipc-message",i)});return this.f=t,t}};m=ve([_(0,b.ILogService),_(1,y.IWindowsMainService),_(2,f.ICredentialsMainService),_(3,h.IEncryptionMainService),_(4,v.IProductService)],m),e.ProxyAuthHandler=m}),define(ee[257],te([0,1,75,5,33,20,30,208]),function(G,e,I,A,n,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let f=class extends P.BaseCredentialsMainService{constructor(b,v,y,g){super(b),this.j=v,this.k=y,this.l=g,this.i=m=>{this.l.sendToFocused("vscode:showCredentialsError",m.message??m)}}async getSecretStoragePrefix(){return Promise.resolve(this.k.urlProtocol)}async h(){if(this.f)return this.f;if(this.j.disableKeytar)return this.g.info("Keytar is disabled. Using in-memory credential store instead."),this.f=new I.InMemoryCredentialsProvider,this.f;const b=await new Promise((v,y)=>{G(["keytar"],v,y)});return await b.findCredentials("test-keytar-loads"),this.f=b,this.f}};f=ve([_(0,A.ILogService),_(1,n.INativeEnvironmentService),_(2,C.IProductService),_(3,D.IWindowsMainService)],f),e.CredentialsNativeMainService=f}),define(ee[258],te([0,1,14,25,4,7,23,19,62,6,5,117,30]),function(G,e,I,A,n,C,D,P,f,h,b,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,h.createDecorator)(e.ID);let g=class{constructor(w,o,u,p){this.a=w,this.b=o,this.c=u,this.d=p}async start(w,o){this.a.trace("Received data from other instance: ",w,o),n.isMacintosh&&I.app.focus({steal:!0});const u=this.e(w);if(u.length){let p=Promise.resolve();if(this.b.getWindowCount()===0){const k=(0,A.firstOrDefault)(await this.b.openEmptyWindow({context:4}));k&&(p=k.ready())}p.then(()=>{for(const{uri:k,originalUrl:E}of u)this.c.open(k,{originalUrl:E})})}else return this.f(w,o)}e(w){return w["open-url"]&&w._urls&&w._urls.length>0?(0,A.coalesce)(w._urls.map(o=>{try{return{uri:C.URI.parse(o),originalUrl:o}}catch{return null}})):[]}async f(w,o){const u=(0,f.isLaunchedFromCli)(o)?0:4;let p=[];const k=w.wait&&w.waitMarkerFilePath?C.URI.file(w.waitMarkerFilePath):void 0,E=w.remote||void 0,M={context:u,cli:w,userEnv:o,waitMarkerFileURI:k,remoteAuthority:E,forceProfile:w.profile,forceTempProfile:w["profile-temp"]};if(w.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(w.extensionDevelopmentPath,M);else if(!w._.length&&!w["folder-uri"]&&!w["file-uri"]){let t=!1;if(w["new-window"]||w["unity-launch"]||M.forceProfile||M.forceTempProfile)t=!0;else if(w["reuse-window"])t=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!n.isMacintosh}if(t)p=await this.b.open({...M,forceNewWindow:!0,forceEmpty:!0});else{const a=this.b.getLastActiveWindow();a?(this.b.openExistingWindow(a,M),p=[a]):p=await this.b.open({...M,forceEmpty:!0})}}else p=await this.b.open({...M,forceNewWindow:w["new-window"],preferNewWindow:!w["reuse-window"]&&!w.wait,forceReuseWindow:w["reuse-window"],diffMode:w.diff,mergeMode:w.merge,addMode:w.add,noRecentEntry:!!w["skip-add-to-recently-opened"],gotoLineMode:w.goto});if(k&&p.length===1&&p[0])return Promise.race([p[0].whenClosedOrLoaded,(0,D.whenDeleted)(k.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};g=ve([_(0,b.ILogService),_(1,y.IWindowsMainService),_(2,v.IURLService),_(3,P.IConfigurationService)],g),e.LaunchMainService=g}),define(ee[259],te([0,1,14,2,3,5,260,8,15,30,84,24]),function(G,e,I,A,n,C,D,P,f,h,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UtilityProcess=void 0;let y=class It extends A.Disposable{constructor(m,w,o){super(),this.n=m,this.p=w,this.r=o,this.b=String(++It.a),this.c=this.B(new n.Emitter),this.onStdout=this.c.event,this.f=this.B(new n.Emitter),this.onStderr=this.f.event,this.g=this.B(new n.Emitter),this.onMessage=this.g.event,this.h=this.B(new n.Emitter),this.onExit=this.h.event,this.i=this.B(new n.Emitter),this.onCrash=this.i.event,this.j=void 0,this.k=void 0,this.l=void 0,this.m=!1}s(m,w){let o;switch(this.l?.correlationId?o=`[UtilityProcess id: ${this.l?.correlationId}, type: ${this.l?.type}, pid: ${this.k??"<none>"}]: ${m}`:o=`[UtilityProcess type: ${this.l?.type}, pid: ${this.k??"<none>"}]: ${m}`,w){case b.default.Error:this.n.error(o);break;case b.default.Warning:this.n.warn(o);break;case b.default.Info:this.n.info(o);break}}t(m){if(this.j){this.s("Cannot start utility process because it is already running...",b.default.Error);return}const w=this.p.getWindowById(m.responseWindowId)?.win;if(!w||w.isDestroyed()||w.webContents.isDestroyed()){this.s("Refusing to start utility process because requesting window cannot be found or is destroyed...",b.default.Error);return}return w}start(m){const w=this.t(m);if(!w)return;this.l=m;const o=`${this.l.type}-${this.b}`,u=f.FileAccess.asFileUri("bootstrap-fork.js").fsPath,p=[...this.l.args??[],`--type=${this.l.type}`],k=this.l.execArgv,E=this.l.allowLoadingUnsignedLibraries,M="pipe";let t=this.l.env;if(t){t={...t};for(const a of Object.keys(t))t[a]=String(t[a])}this.s("creating new...",b.default.Info),this.j=I.utilityProcess.fork(u,p,{serviceName:o,env:t,execArgv:k,allowLoadingUnsignedLibraries:E,stdio:M}),this.u(this.j,this.l,o),this.v(this.j,this.l,w)}u(m,w,o){if(m.stdout){const u=new D.StringDecoder("utf-8");this.B(n.Event.fromNodeEventEmitter(m.stdout,"data")(p=>this.c.fire(typeof p=="string"?p:u.write(p))))}if(m.stderr){const u=new D.StringDecoder("utf-8");this.B(n.Event.fromNodeEventEmitter(m.stderr,"data")(p=>this.f.fire(typeof p=="string"?p:u.write(p))))}this.B(n.Event.fromNodeEventEmitter(m,"message")(u=>this.g.fire(u))),this.B(n.Event.fromNodeEventEmitter(m,"spawn")(()=>{this.k=m.pid,this.s("successfully created",b.default.Info)})),this.B(n.Event.fromNodeEventEmitter(m,"exit")(u=>{this.s(`received exit event with code ${u}`,b.default.Info),this.m=!0,this.h.fire({pid:this.k,code:u,signal:"unknown"})})),this.B(n.Event.fromNodeEventEmitter(I.app,"child-process-gone",(u,p)=>({event:u,details:p}))(({details:u})=>{u.type==="Utility"&&u.name===o&&(this.s(`crashed with code ${u.exitCode} and reason '${u.reason}'`,b.default.Error),this.r.publicLog2("utilityprocesscrash",{type:w.type,reason:u.reason,code:u.exitCode}),this.i.fire({pid:this.k,code:u.exitCode,reason:u.reason}))}))}v(m,w,o){const{port1:u,port2:p}=new I.MessageChannelMain;m.postMessage("null",[p]),o.webContents.postMessage(w.responseChannel,w.responseNonce,[u])}enableInspectPort(){if(typeof this.k!="number")return!1;this.s("enabling inspect port",b.default.Info);const m=process;return typeof m._debugProcess=="function"?(m._debugProcess(this.k),!0):!1}kill(){if(!this.j){this.s("no running process to kill",b.default.Warning);return}this.s("attempting to kill the process...",b.default.Info),this.j.kill()?this.s("successfully killed the process",b.default.Info):this.s("unable to kill the process",b.default.Warning)}async waitForExit(m){if(!this.j){this.s("no running process to wait for exit",b.default.Warning);return}this.m||(this.s("waiting to exit...",b.default.Info),await Promise.race([n.Event.toPromise(this.onExit),(0,P.timeout)(m)]),this.m||(this.s("did not exit within ${maxWaitTimeMs}ms, will kill it now...",b.default.Info),this.kill()))}};y.a=0,y=ve([_(0,C.ILogService),_(1,h.IWindowsMainService),_(2,v.ITelemetryService)],y),e.UtilityProcess=y}),define(ee[261],te([0,1,13,2,3,5,21,71,46,260,8,15,40,4,36,259,30,24]),function(G,e,I,A,n,C,D,P,f,h,b,v,y,g,m,w,o,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;let p=class Pt{constructor(M,t,a,i){this.d=M,this.f=a,this.g=i,this.c=!1,this.b=new Map,t.onWillShutdown(r=>{this.c=!0,r.join(this._waitForAllExit(6e3))})}dispose(){}h(M){const t=this.b.get(M);if(!t)throw new Error("Unknown extension host!");return t}onDynamicStdout(M){return this.h(M).onStdout}onDynamicStderr(M){return this.h(M).onStderr}onDynamicMessage(M){return this.h(M).onMessage}onDynamicError(M){const t=this.h(M);return t instanceof w.UtilityProcess?n.Event.None:t.onError}onDynamicExit(M){return this.h(M).onExit}async createExtensionHost(M){if(this.c)throw(0,I.canceled)();const t=String(++Pt.a);let a;return M?a=new w.UtilityProcess(this.d,this.f,this.g):a=new k(t,this.d),this.b.set(t,a),a.onExit(({pid:i,code:r,signal:c})=>{this.d.info(`Extension host with pid ${i} exited with code: ${r}, signal: ${c}.`),setTimeout(()=>{a.dispose(),this.b.delete(t)})}),{id:t}}async start(M,t){if(this.c)throw(0,I.canceled)();return this.h(M).start({...t,type:"extensionHost",args:["--skipWorkspaceStorageLock"],execArgv:t.execArgv??[],allowLoadingUnsignedLibraries:!1,correlationId:M})}async enableInspectPort(M){if(this.c)throw(0,I.canceled)();const t=this.b.get(M);return t?t.enableInspectPort():!1}async kill(M){if(this.c)throw(0,I.canceled)();const t=this.b.get(M);!t||t.kill()}async _killAllNow(){for(const[,M]of this.b)M.kill()}async _waitForAllExit(M){const t=[];for(const[,a]of this.b)t.push(a.waitForExit(M));return b.Promises.settled(t).then(()=>{})}};p.a=0,p=ve([_(0,C.ILogService),_(1,D.ILifecycleMainService),_(2,o.IWindowsMainService),_(3,u.ITelemetryService)],p),e.ExtensionHostStarter=p;let k=class extends A.Disposable{constructor(M,t){super(),this.id=M,this.c=t,this._onStdout=this.B(new n.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this.B(new n.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this.B(new n.Emitter),this.onMessage=this._onMessage.event,this._onError=this.B(new n.Emitter),this.onError=this._onError.event,this._onExit=this.B(new n.Emitter),this.onExit=this._onExit.event,this.a=null,this.b=!1}start(M){g.isCI&&this.c.info("Calling fork to start extension host...");const t=P.StopWatch.create(!1);this.a=(0,f.fork)(v.FileAccess.asFileUri("bootstrap-fork").fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,y.mixin)({cwd:(0,m.cwd)()},M));const a=t.elapsed(),i=this.a.pid;this.c.info(`Starting extension host with pid ${i} (fork() took ${a} ms).`);const r=new h.StringDecoder("utf-8");this.a.stdout?.on("data",l=>{const s=typeof l=="string"?l:r.write(l);this._onStdout.fire(s)});const c=new h.StringDecoder("utf-8");this.a.stderr?.on("data",l=>{const s=typeof l=="string"?l:c.write(l);this._onStderr.fire(s)}),this.a.on("message",l=>{this._onMessage.fire(l)}),this.a.on("error",l=>{this._onError.fire({error:(0,I.transformErrorForSerialization)(l)})}),this.a.on("exit",(l,s)=>{this.b=!0,this._onExit.fire({pid:i,code:l,signal:s})})}enableInspectPort(){return this.a?(this.c.info(`Enabling inspect port on extension host with pid ${this.a.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this.a.pid),!0):g.isWindows?!1:(this.a.kill("SIGUSR1"),!0)):!1}kill(){!this.a||(this.c.info(`Killing extension host with pid ${this.a.pid}.`),this.a.kill())}async waitForExit(M){if(!this.a)return;const t=this.a.pid;this.c.info(`Waiting for extension host with pid ${t} to exit.`),await Promise.race([n.Event.toPromise(this.onExit),(0,b.timeout)(M)]),this.b||(this.c.info(`Extension host with pid ${t} did not exit within ${M}ms.`),this.a.kill())}};k=ve([_(1,C.ILogService)],k)}),define(ee[262],te([0,1,14,3,2,255,30]),function(G,e,I,A,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let P=class extends n.Disposable{constructor(h){super(),this.b=h,this.a=this.B(new A.Emitter),this.onFoundInFrame=this.a.event,this.B(new C.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(h,b){let v;if(typeof h.windowId=="number"){const{windowId:y}=h,g=this.b.getWindowById(y);if(!g?.win)throw new Error(`Invalid windowId: ${y}`);v=g.win.webContents}else{const{webContentsId:y}=h;if(v=I.webContents.fromId(y),!v)throw new Error(`Invalid webContentsId: ${y}`)}v.isDestroyed()||v.setIgnoreMenuShortcuts(b)}async findInFrame(h,b,v,y){const m=this.c(h,b);if(typeof m.findInFrame=="function"){m.findInFrame(v,{findNext:y.findNext,forward:y.forward});const w=(o,u)=>{u.finalUpdate&&(this.a.fire(u),m.removeListener("found-in-frame",w))};m.on("found-in-frame",w)}}async stopFindInFrame(h,b,v){const g=this.c(h,b);typeof g.stopFindInFrame=="function"&&g.stopFindInFrame(v.keepSelection?"keepSelection":"clearSelection")}c(h,b){const v=this.b.getWindowById(h.windowId);if(!v?.win)throw new Error(`Invalid windowId: ${h}`);const y=v.win.webContents.mainFrame.framesInSubtree.find(g=>g.name===b);if(!y)throw new Error(`Unknown frame: ${b}`);return y}};P=ve([_(0,D.IWindowsMainService)],P),e.WebviewMainService=P}),define(ee[263],te([0,1,8,3,2]),function(G,e,I,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class C extends n.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:f,getActiveWindowId:h}){super(),this.a=this.B(new n.DisposableStore),A.Event.latch(A.Event.any(P,f))(this.f,this,this.a),this.b=(0,I.createCancelablePromise)(()=>h()),(async()=>{try{const v=await this.b;this.c=typeof this.c=="number"?this.c:v}catch{}finally{this.b=void 0}})()}f(P){this.b&&(this.b.cancel(),this.b=void 0),this.c=P}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.ActiveWindowManager=C}),define(ee[29],te([0,1,179,9,61,18,7,6,15]),function(G,e,I,A,n,C,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function h(i){const r=i;return typeof r?.id=="string"&&D.URI.isUri(r.uri)}e.isSingleFolderWorkspaceIdentifier=h;function b(i){return typeof i?.id=="string"&&!h(i)&&!y(i)}e.isEmptyWorkspaceIdentifier=b,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function v(i,r){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,A.basename)(i)}:r?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const c=i;return c.configuration?{id:c.id,configPath:c.configuration}:c.folders.length===1?{id:c.id,uri:c.folders[0].uri}:{id:c.id}}e.toWorkspaceIdentifier=v;function y(i){const r=i;return typeof r?.id=="string"&&D.URI.isUri(r.configPath)}e.isWorkspaceIdentifier=y;function g(i){const r=i;if(r?.uri)return{id:r.id,uri:D.URI.revive(r.uri)};const c=i;if(c?.configPath)return{id:c.id,configPath:D.URI.revive(c.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=g;var m;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(m=e.WorkbenchState||(e.WorkbenchState={}));function w(i){const r=i;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&Array.isArray(r.folders))}e.isWorkspace=w;function o(i){const r=i;return!!(r&&typeof r=="object"&&D.URI.isUri(r.uri)&&typeof r.name=="string"&&typeof r.toResource=="function")}e.isWorkspaceFolder=o;class u{constructor(r,c,l,s,d){this.h=r,this.j=l,this.k=s,this.l=d,this.c=n.TernarySearchTree.forUris(this.l,()=>!0),this.folders=c}update(r){this.h=r.id,this.k=r.configuration,this.j=r.transient,this.l=r.l,this.folders=r.folders}get folders(){return this.g}set folders(r){this.g=r,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(r){this.k=r}getFolder(r){return r&&this.c.findSubstr(r)||null}n(){this.c=n.TernarySearchTree.forUris(this.l,()=>!0);for(const r of this.folders)this.c.set(r.uri,r)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=u;class p{constructor(r,c){this.raw=c,this.uri=r.uri,this.index=r.index,this.name=r.name}toResource(r){return(0,C.joinPath)(this.uri,r)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=p;function k(i){return new p({uri:i,index:0,name:(0,C.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=k,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E(i,r){return C.extUriBiasedIgnorePathCase.isEqualOrParent(i,r.untitledWorkspacesHome)}e.isUntitledWorkspace=E;function M(i){let r;return D.URI.isUri(i)?r=i:r=i.configuration,r?.scheme===f.Schemas.tmp}e.isTemporaryWorkspace=M;function t(i,r){return!E(i,r)&&!M(i)}e.isSavedWorkspace=t;function a(i){return(typeof i=="string"?(0,A.extname)(i):(0,C.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=a}),define(ee[58],te([0,1,14,8,72,45,2,80,4,10,23,156,6,5,29]),function(G,e,I,A,n,C,D,P,f,h,b,v,y,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,y.createDecorator)("dialogMainService");let w=class{constructor(u){this.d=u,this.a=new Map,this.b=new Map,this.c=new A.Queue}pickFileFolder(u,p){return this.e({...u,pickFolders:!0,pickFiles:!0,title:(0,v.localize)(0,null)},p)}pickFolder(u,p){return this.e({...u,pickFolders:!0,title:(0,v.localize)(1,null)},p)}pickFile(u,p){return this.e({...u,pickFiles:!0,title:(0,v.localize)(2,null)},p)}pickWorkspace(u,p){const k=(0,v.localize)(3,null),E=(0,C.mnemonicButtonLabel)((0,v.localize)(4,null)),M=m.WORKSPACE_FILTER;return this.e({...u,pickFiles:!0,title:k,filters:M,buttonLabel:E},p)}async e(u,p){const k={title:u.title,buttonLabel:u.buttonLabel,filters:u.filters,defaultPath:u.defaultPath};(typeof u.pickFiles=="boolean"||typeof u.pickFolders=="boolean")&&(k.properties=void 0,u.pickFiles&&u.pickFolders&&(k.properties=["multiSelections","openDirectory","openFile","createDirectory"])),k.properties||(k.properties=["multiSelections",u.pickFolders?"openDirectory":"openFile","createDirectory"]),f.isMacintosh&&k.properties.push("treatPackageAsDirectory");const E=await this.showOpenDialog(k,(0,h.withNullAsUndefined)(p||I.BrowserWindow.getFocusedWindow()));if(E&&E.filePaths&&E.filePaths.length>0)return E.filePaths}f(u){if(u){let p=this.b.get(u.id);return p||(p=new A.Queue,this.b.set(u.id,p)),p}else return this.c}showMessageBox(u,p){return this.f(p).queue(async()=>p?I.dialog.showMessageBox(p,u):I.dialog.showMessageBox(u))}async showSaveDialog(u,p){const k=this.i(u,p);if(!k)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.f(p).queue(async()=>{let E;return p?E=await I.dialog.showSaveDialog(p,u):E=await I.dialog.showSaveDialog(u),E.filePath=this.g(E.filePath),E})}finally{(0,D.dispose)(k)}}g(u){return u&&f.isMacintosh&&(u=(0,P.normalizeNFC)(u)),u}h(u){return u.map(p=>this.g(p))}async showOpenDialog(u,p){u.defaultPath&&(await b.Promises.exists(u.defaultPath)||(u.defaultPath=void 0));const k=this.i(u,p);if(!k)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.f(p).queue(async()=>{let E;return p?E=await I.dialog.showOpenDialog(p,u):E=await I.dialog.showOpenDialog(u),E.filePaths=this.h(E.filePaths),E})}finally{(0,D.dispose)(k)}}i(u,p){if(!p)return D.Disposable.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",u);let k=this.a.get(p.id);k||(k=new Set,this.a.set(p.id,k));const E=(0,n.hash)(u);if(!k.has(E))return this.d.trace("[DialogMainService]: new file dialog lock created",u),k.add(E),(0,D.toDisposable)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",u),k?.delete(E),k?.size===0&&this.a.delete(p.id)})}};w=ve([_(0,g.ILogService)],w),e.DialogMainService=w}),define(ee[264],te([0,1,3,2,73,29]),function(G,e,I,A,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class D extends A.Disposable{constructor(f,h){super(),this.f=f,this.g=h,this.b=this.B(new I.Emitter),this.c=new Map,this.h(h.applicationStorage,this.b)}h(f,h){this.B(I.Event.debounce(f.onDidChangeStorage,(b,v)=>(b?b.push(v):b=[v],b),D.a)(b=>{b.length&&h.fire(this.i(b,f))}))}i(f,h){const b=new Map,v=new Set;return f.forEach(y=>{const g=h.get(y.key);typeof g=="string"?b.set(y.key,g):v.add(y.key)}),{changed:Array.from(b.entries()),deleted:Array.from(v.values())}}listen(f,h,b){switch(h){case"onDidChangeStorage":{const v=b.profile?(0,n.revive)(b.profile):void 0;if(!v)return this.b.event;let y=this.c.get(v.id);return y||(y=this.B(new I.Emitter),this.h(this.g.profileStorage(v),y),this.c.set(v.id,y)),y.event}}throw new Error(`Event not found: ${h}`)}async call(f,h,b){const v=b.profile?(0,n.revive)(b.profile):void 0,y=(0,C.reviveIdentifier)(b.workspace),g=await this.j(v,y);switch(h){case"getItems":return Array.from(g.items.entries());case"updateItems":{const m=b;if(m.insert)for(const[w,o]of m.insert)g.set(w,o);m.delete?.forEach(w=>g.delete(w));break}case"isUsed":{const m=b.payload;if(typeof m=="string")return this.g.isUsed(m)}default:throw new Error(`Call not found: ${h}`)}}async j(f,h){let b;h?b=this.g.workspaceStorage(h):f?b=this.g.profileStorage(f):b=this.g.applicationStorage;try{await b.init()}catch(v){this.f.error(`StorageIPC#init: Unable to init ${h?"workspace":f?"profile":"application"} storage due to ${v}`)}return b}}e.StorageDatabaseChannel=D,D.a=100}),define(ee[39],te([0,1,72,3,2,18,7,176,33,16,6,5,29,35,38,8,31,27,10]),function(G,e,I,A,n,C,D,P,f,h,b,v,y,g,m,w,o,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function k(i){const r=i;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&typeof r.isDefault=="boolean"&&typeof r.name=="string"&&D.URI.isUri(r.location)&&D.URI.isUri(r.globalStorageHome)&&D.URI.isUri(r.settingsResource)&&D.URI.isUri(r.keybindingsResource)&&D.URI.isUri(r.tasksResource)&&D.URI.isUri(r.snippetsHome)&&D.URI.isUri(r.extensionsResource))}e.isUserDataProfile=k,e.IUserDataProfilesService=(0,b.createDecorator)("IUserDataProfilesService");function E(i,r){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:D.URI.revive(i.location).with({scheme:r}),globalStorageHome:D.URI.revive(i.globalStorageHome).with({scheme:r}),settingsResource:D.URI.revive(i.settingsResource).with({scheme:r}),keybindingsResource:D.URI.revive(i.keybindingsResource).with({scheme:r}),tasksResource:D.URI.revive(i.tasksResource).with({scheme:r}),snippetsHome:D.URI.revive(i.snippetsHome).with({scheme:r}),extensionsResource:D.URI.revive(i.extensionsResource)?.with({scheme:r}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=E;function M(i,r,c,l){return{id:i,name:r,location:c,isDefault:!1,shortName:l?.shortName,globalStorageHome:(0,C.joinPath)(c,"globalStorage"),settingsResource:(0,C.joinPath)(c,"settings.json"),keybindingsResource:(0,C.joinPath)(c,"keybindings.json"),tasksResource:(0,C.joinPath)(c,"tasks.json"),snippetsHome:(0,C.joinPath)(c,"snippets"),extensionsResource:(0,C.joinPath)(c,"extensions.json"),useDefaultFlags:l?.useDefaultFlags,isTransient:l?.transient}}e.toUserDataProfile=M;let t=class extends n.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(r,c,l,s){super(),this.m=r,this.n=c,this.r=l,this.s=s,this.f=!0,this.g=this.B(new A.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new A.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new A.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new A.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new g.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,C.joinPath)(this.m.userRoamingDataHome,"profiles")}init(){this.t=void 0}setEnablement(r){this.f!==r&&(this.t=void 0,this.f=r)}isEnabled(){return this.f}get u(){if(!this.t){const r=[];if(this.f)for(const d of this.G()){if(!d.name||!(0,p.isString)(d.name)||!d.location){this.s.warn("Skipping the invalid stored profile",d.location||d.name);continue}r.push(M((0,C.basename)(d.location),d.name,d.location,{shortName:d.shortName,useDefaultFlags:d.useDefaultFlags}))}const c=new g.ResourceMap,l=new Map,s=M((0,I.hash)(this.m.userRoamingDataHome.path).toString(16),(0,P.localize)(0,null),this.m.userRoamingDataHome);if(r.unshift({...s,extensionsResource:this.L()??s.extensionsResource,isDefault:!0}),r.length){const d=this.I();if(d.workspaces)for(const[S,R]of Object.entries(d.workspaces)){const O=D.URI.parse(S),N=D.URI.parse(R),K=r.find(V=>this.r.extUri.isEqual(V.location,N));K&&c.set(O,K)}if(d.emptyWindows)for(const[S,R]of Object.entries(d.emptyWindows)){const O=D.URI.parse(R),N=r.find(K=>this.r.extUri.isEqual(K.location,O));N&&l.set(S,N)}}this.t={profiles:r,workspaces:c,emptyWindows:l}}return this.t}async createTransientProfile(r){const c="Temp",l=new RegExp(`${(0,u.escapeRegExpCharacters)(c)}\\s(\\d+)`);let s=0;for(const S of this.profiles){const R=l.exec(S.name),O=R?parseInt(R[1]):0;s=O>s?O:s}const d=`${c} ${s+1}`;return this.createProfile((0,I.hash)((0,o.generateUuid)()).toString(16),d,{transient:!0},r)}async createNamedProfile(r,c,l){return this.createProfile((0,I.hash)((0,o.generateUuid)()).toString(16),r,c,l)}async createProfile(r,c,l,s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const d=await this.v(r,c,l);return s&&await this.setProfileForWorkspace(s,d),d}async v(r,c,l){if(!(0,p.isString)(c)||!c)throw new Error("Name of the profile is mandatory and must be of type `string`");let s=this.k.get(c);return s||(s=(async()=>{try{const d=this.profiles.find(O=>O.name===c||O.id===r);if(d)return d;const S=M(r,c,(0,C.joinPath)(this.profilesHome,r),l);await this.n.createFolder(S.location);const R=[];return this.h.fire({profile:S,join(O){R.push(O)}}),await w.Promises.settled(R),this.z([S],[],[]),S}finally{this.k.delete(c)}})(),this.k.set(c,s)),s}async updateProfile(r,c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let l=this.profiles.find(s=>s.id===r.id);if(!l)throw new Error(`Profile '${r.name}' does not exist`);return l=M(l.id,c.name??l.name,l.location,{shortName:c.shortName??l.shortName,transient:c.transient??l.isTransient,useDefaultFlags:c.useDefaultFlags??l.useDefaultFlags}),this.z([],[],[l]),l}async removeProfile(r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(r.isDefault)throw new Error("Cannot remove default profile");const c=this.profiles.find(s=>s.id===r.id);if(!c)throw new Error(`Profile '${r.name}' does not exist`);const l=[];this.i.fire({profile:c,join(s){l.push(s)}});try{await Promise.allSettled(l)}catch(s){this.s.error(s)}for(const s of[...this.u.emptyWindows.keys()])c.id===this.u.emptyWindows.get(s)?.id&&this.u.emptyWindows.delete(s);for(const s of[...this.u.workspaces.keys()])c.id===this.u.workspaces.get(s)?.id&&this.u.workspaces.delete(s);this.F(),this.z([],[c],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(c.location,{recursive:!0})}catch(s){this.s.error(s)}}async setProfileForWorkspace(r,c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const l=this.profiles.find(s=>s.id===c.id);if(!l)throw new Error(`Profile '${c.name}' does not exist`);this.D(r,l)}unsetWorkspace(r,c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.D(r,void 0,c)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindows.clear(),this.u.workspaces.clear(),this.u.emptyWindows.clear(),this.F(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const r=await this.n.resolve(this.profilesHome);await Promise.all((r.children||[]).filter(c=>c.isDirectory&&this.profiles.every(l=>!this.r.extUri.isEqual(l.location,c.resource))).map(c=>this.n.del(c.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const r=this.l.profiles.filter(c=>!this.y(c));await Promise.allSettled(r.map(c=>this.removeProfile(c)))}getProfileForWorkspace(r){const c=this.w(r);return D.URI.isUri(c)?this.l.workspaces.get(c)??this.u.workspaces.get(c):this.l.emptyWindows.get(c)??this.u.emptyWindows.get(c)}w(r){return(0,y.isSingleFolderWorkspaceIdentifier)(r)?r.uri:(0,y.isWorkspaceIdentifier)(r)?r.configPath:r.id}y(r){return!!([...this.l.emptyWindows.values()].some(c=>this.r.extUri.isEqual(c.location,r.location))||[...this.l.workspaces.values()].some(c=>this.r.extUri.isEqual(c.location,r.location))||[...this.u.emptyWindows.values()].some(c=>this.r.extUri.isEqual(c.location,r.location))||[...this.u.workspaces.values()].some(c=>this.r.extUri.isEqual(c.location,r.location)))}z(r,c,l){const s=[...this.profiles,...r],d=[];this.l.profiles=[];for(let S of s)S.isDefault||c.some(R=>S.id===R.id)||(S=l.find(R=>S.id===R.id)??S,S.isTransient?this.l.profiles.push(S):d.push({location:S.location,name:S.name,shortName:S.shortName,useDefaultFlags:S.useDefaultFlags}));this.H(d),this.t=void 0,this.C(r,c,l)}C(r,c,l){this.g.fire({added:r,removed:c,updated:l,all:this.profiles})}D(r,c,l){l=c?.isTransient?!0:l,l||this.D(r,void 0,!0);const s=this.w(r),d=l?this.l:this.u;D.URI.isUri(s)?(d.workspaces.delete(s),c&&d.workspaces.set(s,c)):(d.emptyWindows.delete(s),c&&d.emptyWindows.set(s,c)),l||this.F()}F(){const r={};for(const[l,s]of this.u.workspaces.entries())r[l.toString()]=s.location.toString();const c={};for(const[l,s]of this.u.emptyWindows.entries())c[l.toString()]=s.location.toString();this.J({workspaces:r,emptyWindows:c}),this.t=void 0}G(){return[]}H(r){throw new Error("not implemented")}I(){return{}}J(r){throw new Error("not implemented")}L(){}};t.b="userDataProfiles",t.c="profileAssociations",t=ve([_(0,f.IEnvironmentService),_(1,h.IFileService),_(2,m.IUriIdentityService),_(3,v.ILogService)],t),e.UserDataProfilesService=t;class a extends t{constructor(){super(...arguments),this.a=[],this.O={}}G(){return this.a}H(r){this.a=r}I(){return this.O}J(r){this.O=r}}e.InMemoryUserDataProfilesService=a}),define(ee[78],te([0,1,8,17,2,3,35,7,113,91,16,6,5,39,38,10,13,24]),function(G,e,I,A,n,C,D,P,f,h,b,v,y,g,m,w,o,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var p;(function(a){a.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",a.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(p=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class k extends Error{constructor(i,r){super(i),this.code=r}}e.ExtensionsProfileScanningError=k,e.IExtensionsProfileScannerService=(0,v.createDecorator)("IExtensionsProfileScannerService");let E=class extends n.Disposable{constructor(i,r,c,l,s,d){super(),this.h=i,this.i=r,this.j=c,this.k=l,this.l=s,this.m=d,this.a=this.B(new C.Emitter),this.onAddExtensions=this.a.event,this.b=this.B(new C.Emitter),this.onDidAddExtensions=this.b.event,this.c=this.B(new C.Emitter),this.onRemoveExtensions=this.c.event,this.f=this.B(new C.Emitter),this.onDidRemoveExtensions=this.f.event,this.g=new D.ResourceMap}scanProfileExtensions(i,r){return this.n(i,void 0,r)}async addExtensionsToProfile(i,r){const c=[],l=[];try{return await this.n(r,s=>{const d=[];for(const S of s)i.some(([R])=>(0,f.areSameExtensions)(R.identifier,S.identifier)&&R.manifest.version!==S.version)?c.push(S):d.push(S);for(const[S,R]of i)if(!d.some(O=>(0,f.areSameExtensions)(O.identifier,S.identifier)&&O.version===S.manifest.version)){const O={identifier:S.identifier,version:S.manifest.version,location:S.location,metadata:R};l.push(O),d.push(O)}return l.length&&this.a.fire({extensions:l,profileLocation:r}),c.length&&this.c.fire({extensions:c,profileLocation:r}),d}),l.length&&this.b.fire({extensions:l,profileLocation:r}),c.length&&this.f.fire({extensions:c,profileLocation:r}),l}catch(s){throw l.length&&this.b.fire({extensions:l,error:s,profileLocation:r}),c.length&&this.f.fire({extensions:c,error:s,profileLocation:r}),s}}async updateMetadata(i,r){const c=[];return await this.n(r,l=>{const s=[];for(const d of l){const S=i.find(([R])=>(0,f.areSameExtensions)(R.identifier,d.identifier)&&R.manifest.version===d.version);S&&(d.metadata={...d.metadata,...S[1]},c.push(d)),s.push(d)}return s}),c}async removeExtensionFromProfile(i,r){const c=[];this.c.fire({extensions:c,profileLocation:r});try{await this.n(r,l=>{const s=[];for(const d of l)(0,f.areSameExtensions)(d.identifier,i.identifier)?c.push(d):s.push(d);return c.length&&this.c.fire({extensions:c,profileLocation:r}),s}),c.length&&this.f.fire({extensions:c,profileLocation:r})}catch(l){throw c.length&&this.f.fire({extensions:c,error:l,profileLocation:r}),l}}async n(i,r,c){return this.v(i).queue(async()=>{let l=[],s;try{const d=await this.i.readFile(i);s=JSON.parse(d.value.toString())}catch(d){if((0,b.toFileOperationResult)(d)!==1)throw d;if(this.k.extUri.isEqual(i,this.j.defaultProfile.extensionsResource)&&(s=await this.u()),!s&&c?.bailOutWhenFileNotFound)throw new k((0,o.getErrorMessage)(d),"ERROR_PROFILE_NOT_FOUND")}if(s){Array.isArray(s)||this.p(i);let d=!1;for(const S of s){M(S)||this.p(i);let R;if((0,w.isString)(S.location))R=this.s(S.location);else{R=P.URI.revive(S.location);const O=this.r(R);O&&(d=!0,S.location=O)}l.push({identifier:S.identifier,location:R,version:S.version,metadata:S.metadata})}d&&await this.i.writeFile(i,A.VSBuffer.fromString(JSON.stringify(s)))}if(r){l=r(l);const d=l.map(S=>({identifier:S.identifier,version:S.version,location:this.r(S.location)??S.location.toJSON(),metadata:S.metadata}));await this.i.writeFile(i,A.VSBuffer.fromString(JSON.stringify(d)))}return l})}p(i){const r=new k(`Invalid extensions content in ${i.toString()}`,"ERROR_INVALID_CONTENT");throw this.l.publicLogError2("extensionsProfileScanningError",{code:r.code}),r}r(i){return this.k.extUri.isEqualOrParent(i,this.h)?this.k.extUri.relativePath(this.h,i):void 0}s(i){return this.k.extUri.joinPath(this.h,i)}async u(){return this.t||(this.t=(async()=>{const i=this.k.extUri.joinPath(this.j.defaultProfile.location,"extensions.json");let r;try{r=(await this.i.readFile(i)).value.toString()}catch(l){if((0,b.toFileOperationResult)(l)===1)return;throw l}this.m.info("Migrating extensions from old default profile location",i.toString());let c;try{const l=JSON.parse(r);Array.isArray(l)&&l.every(s=>M(s))?c=l:this.m.warn("Skipping migrating from old default profile locaiton: Found invalid data",l)}catch(l){this.m.error(l)}if(c)try{await this.i.createFile(this.j.defaultProfile.extensionsResource,A.VSBuffer.fromString(JSON.stringify(c)),{overwrite:!1}),this.m.info("Migrated extensions from old default profile location to new location",i.toString(),this.j.defaultProfile.extensionsResource.toString())}catch(l){if((0,b.toFileOperationResult)(l)===3)this.m.info("Migration from old default profile location to new location is done by another window",i.toString(),this.j.defaultProfile.extensionsResource.toString());else throw l}try{await this.i.del(i)}catch(l){(0,b.toFileOperationResult)(l)!==1&&this.m.error(l)}return c})()),this.t}v(i){let r=this.g.get(i);return r||(r=new I.Queue,this.g.set(i,r)),r}};E=ve([_(1,b.IFileService),_(2,g.IUserDataProfilesService),_(3,m.IUriIdentityService),_(4,u.ITelemetryService),_(5,y.ILogService)],E),e.AbstractExtensionsProfileScannerService=E;function M(a){return(0,w.isObject)(a)&&(0,h.isIExtensionIdentifier)(a.identifier)&&(t(a.location)||(0,w.isString)(a.location))&&a.version&&(0,w.isString)(a.version)}function t(a){return a?(0,w.isString)(a.path)&&(0,w.isString)(a.scheme):!1}}),define(ee[119],te([0,1,25,8,40,17,13,43,141,2,15,9,4,18,194,84,10,7,161,33,113,91,193,16,6,5,20,3,73,78,39,38,191,192]),function(G,e,I,A,n,C,D,P,f,h,b,v,y,g,m,w,o,u,p,k,E,M,t,a,i,r,c,l,s,d,S,R,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var K;(function(ge){function x(F,W){if(F===W)return!0;const z=Object.keys(F),J=new Set;for(const ne of Object.keys(W))J.add(ne);if(z.length!==J.size)return!1;for(const ne of z){if(F[ne]!==W[ne])return!1;J.delete(ne)}return J.size===0}ge.equals=x})(K=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let V=class extends h.Disposable{constructor(x,F,W,z,J,ne,se,Z,U,L,T,B){super(),this.systemExtensionsLocation=x,this.userExtensionsLocation=F,this.l=W,this.m=z,this.n=J,this.p=ne,this.r=se,this.s=Z,this.t=U,this.u=L,this.v=T,this.w=B,this.g=this.B(new l.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,g.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(re,(0,g.joinPath)(this.m,M.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(re,(0,g.joinPath)(this.m,M.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(ie,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,E.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(x,F,W){const[z,J]=await Promise.all([this.scanSystemExtensions(x),this.scanUserExtensions(F)]),ne=W?await this.scanExtensionsUnderDevelopment(x,[...z,...J]):[];return this.F(z,J,ne,await this.getTargetPlatform(),!0)}async scanSystemExtensions(x){const F=[];F.push(this.G(!!x.useCache,x.language)),F.push(this.H(x.language,!!x.checkControlFile));const[W,z]=await Promise.all(F);return this.D([...W,...z],0,x,!1)}async scanUserExtensions(x){const F=x.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",F);const W=this.v.extUri.isEqual(x.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,z=await this.J(F,!!x.profileLocation,1,!x.includeUninstalled,x.language,!0,W),J=x.useCache&&!z.devMode&&z.excludeObsolete?this.j:this.k;let ne;try{ne=await J.scanExtensions(z)}catch(se){if(se instanceof d.ExtensionsProfileScanningError&&se.code==="ERROR_PROFILE_NOT_FOUND")await this.C(),ne=await J.scanExtensions(z);else throw se}return ne=await this.D(ne,1,x,!0),this.s.trace("Scanned user extensions:",ne.length),ne}async scanExtensionsUnderDevelopment(x,F){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const W=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(z=>z.scheme===b.Schemas.file).map(async z=>{const J=await this.J(z,!1,1,!0,x.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(J)).map(se=>(se.type=F.find(Z=>(0,E.areSameExtensions)(Z.identifier,se.identifier))?.type??se.type,this.k.validate(se,J)))}))).flat();return this.D(W,"development",x,!0)}return[]}async scanExistingExtension(x,F,W){const z=await this.J(x,!1,F,!0,W.language,!0,void 0),J=await this.k.scanExtension(z);return!J||!W.includeInvalid&&!J.isValid?null:J}async scanOneOrMultipleExtensions(x,F,W){const z=await this.J(x,!1,F,!0,W.language,!0,void 0),J=await this.k.scanOneOrMultipleExtensions(z);return this.D(J,F,W,!0)}async scanMetadata(x){const F=(0,g.joinPath)(x,"package.json"),W=(await this.r.readFile(F)).value.toString();return JSON.parse(W).__metadata}async updateMetadata(x,F){const W=(0,g.joinPath)(x,"package.json"),z=(await this.r.readFile(W)).value.toString(),J=JSON.parse(z);F.isMachineScoped=F.isMachineScoped||void 0,F.isBuiltin=F.isBuiltin||void 0,F.installedTimestamp=F.installedTimestamp||void 0,J.__metadata={...J.__metadata,...F},await this.r.writeFile((0,g.joinPath)(x,"package.json"),C.VSBuffer.fromString(JSON.stringify(J,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.p.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(x){if(x instanceof d.ExtensionsProfileScanningError&&x.code==="ERROR_PROFILE_NOT_FOUND")await this.C();else throw x}}async C(){return this.z||(this.z=(async()=>{try{this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const x=await this.scanUserExtensions({includeInvalid:!0});if(x.length)await this.p.addExtensionsToProfile(x.map(F=>[F,F.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.r.createFile(this.n.defaultProfile.extensionsResource,C.VSBuffer.fromString(JSON.stringify([])))}catch(F){(0,a.toFileOperationResult)(F)!==1&&this.s.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,D.getErrorMessage)(F))}this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(x){this.s.error(x)}finally{this.z=void 0}})()),this.z}async D(x,F,W,z){return W.includeAllVersions||(x=this.F(F===0?x:void 0,F===1?x:void 0,F==="development"?x:void 0,await this.getTargetPlatform(),z)),W.includeInvalid||(x=x.filter(J=>J.isValid)),x.sort((J,ne)=>{const se=v.basename(J.location.fsPath),Z=v.basename(ne.location.fsPath);return se<Z?-1:se>Z?1:0})}F(x,F,W,z,J){const ne=(Z,U,L)=>{if(Z.isValid&&!U.isValid)return!1;if(Z.isValid===U.isValid){if(J&&m.gt(Z.manifest.version,U.manifest.version))return this.s.debug(`Skipping extension ${U.location.path} with lower version ${U.manifest.version} in favour of ${Z.location.path} with version ${Z.manifest.version}`),!1;if(m.eq(Z.manifest.version,U.manifest.version)){if(Z.type===0)return this.s.debug(`Skipping extension ${U.location.path} in favour of system extension ${Z.location.path} with same version`),!1;if(Z.targetPlatform===z)return this.s.debug(`Skipping extension ${U.location.path} from different target platform ${U.targetPlatform}`),!1}}return L?this.s.warn(`Overwriting user extension ${Z.location.path} with ${U.location.path}.`):this.s.debug(`Overwriting user extension ${Z.location.path} with ${U.location.path}.`),!0},se=new Map;return x?.forEach(Z=>{const U=M.ExtensionIdentifier.toKey(Z.identifier.id),L=se.get(U);(!L||ne(L,Z,!1))&&se.set(U,Z)}),F?.forEach(Z=>{const U=M.ExtensionIdentifier.toKey(Z.identifier.id),L=se.get(U);if(!L&&x&&Z.type===0){this.s.debug(`Skipping obsolete system extension ${Z.location.path}.`);return}(!L||ne(L,Z,!1))&&se.set(U,Z)}),W?.forEach(Z=>{const U=M.ExtensionIdentifier.toKey(Z.identifier.id),L=se.get(U);(!L||ne(L,Z,!0))&&se.set(U,Z),se.set(U,Z)}),[...se.values()]}async G(x,F){this.s.trace("Started scanning system extensions");const W=await this.J(this.systemExtensionsLocation,!1,0,!0,F,!0,void 0),J=await(x&&!W.devMode?this.i:this.k).scanExtensions(W);return this.s.trace("Scanned system extensions:",J.length),J}async H(x,F){const W=this.t.isBuilt?[]:this.u.builtInExtensions;if(!W?.length)return[];this.s.trace("Started scanning dev system extensions");const z=F?await this.I():{},J=[],ne=u.URI.file(v.normalize(v.join(b.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const Z of W){const U=z[Z.name]||"marketplace";switch(U){case"disabled":break;case"marketplace":J.push((0,g.joinPath)(ne,Z.name));break;default:J.push(u.URI.file(U));break}}const se=await Promise.all(J.map(async Z=>this.k.scanExtension(await this.J(Z,!1,0,!0,x,!0,void 0))));return this.s.trace("Scanned dev system extensions:",se.length),(0,I.coalesce)(se)}async I(){try{const x=await this.r.readFile(this.l);return JSON.parse(x.value.toString())}catch{return{}}}async J(x,F,W,z,J,ne,se){const Z=await this.f(J??y.language),U=await this.L(x),L=F&&!this.v.extUri.isEqual(x,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,T=L?await this.L(L):void 0;return new X(x,U,L,T,F,se,W,z,ne,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,J,Z)}async L(x){try{const F=await this.r.stat(x);if(typeof F.mtime=="number")return F.mtime}catch{}}};V=ve([_(4,S.IUserDataProfilesService),_(5,d.IExtensionsProfileScannerService),_(6,a.IFileService),_(7,r.ILogService),_(8,k.IEnvironmentService),_(9,c.IProductService),_(10,R.IUriIdentityService),_(11,i.IInstantiationService)],V),e.AbstractExtensionsScannerService=V;class X{constructor(x,F,W,z,J,ne,se,Z,U,L,T,B,H,j,$){this.location=x,this.mtime=F,this.applicationExtensionslocation=W,this.applicationExtensionslocationMtime=z,this.profile=J,this.profileScanOptions=ne,this.type=se,this.excludeObsolete=Z,this.validate=U,this.productVersion=L,this.productDate=T,this.productCommit=B,this.devMode=H,this.language=j,this.translations=$}static createNlsConfiguration(x){return{language:x.language,pseudo:x.language==="pseudo",devMode:x.devMode,translations:x.translations}}static equals(x,F){return(0,g.isEqual)(x.location,F.location)&&x.mtime===F.mtime&&(0,g.isEqual)(x.applicationExtensionslocation,F.applicationExtensionslocation)&&x.applicationExtensionslocationMtime===F.applicationExtensionslocationMtime&&x.profile===F.profile&&n.equals(x.profileScanOptions,F.profileScanOptions)&&x.type===F.type&&x.excludeObsolete===F.excludeObsolete&&x.validate===F.validate&&x.productVersion===F.productVersion&&x.productDate===F.productDate&&x.productCommit===F.productCommit&&x.devMode===F.devMode&&x.language===F.language&&K.equals(x.translations,F.translations)}}e.ExtensionScannerInput=X;let ie=class extends h.Disposable{constructor(x,F,W,z,J){super(),this.f=x,this.g=F,this.h=W,this.i=z,this.j=J}async scanExtensions(x){const F=x.profile?await this.l(x):await this.k(x);let W={};if(x.excludeObsolete&&x.type===1)try{const z=(await this.i.readFile(this.f)).value.toString();W=JSON.parse(z)}catch{}return(0,o.isEmptyObject)(W)?F:F.filter(z=>!W[E.ExtensionKey.create(z).toString()])}async k(x){const F=await this.i.resolve(x.location);if(!F.children?.length)return[];const W=await Promise.all(F.children.map(async z=>{if(!z.isDirectory||x.type===1&&(0,g.basename)(z.resource).indexOf(".")===0)return null;const J=new X(z.resource,x.mtime,x.applicationExtensionslocation,x.applicationExtensionslocationMtime,x.profile,x.profileScanOptions,x.type,x.excludeObsolete,x.validate,x.productVersion,x.productDate,x.productCommit,x.devMode,x.language,x.translations);return this.scanExtension(J)}));return(0,I.coalesce)(W).sort((z,J)=>z.location.path<J.location.path?-1:1)}async l(x){let F=await this.m(x.location,()=>!0,x);if(x.applicationExtensionslocation&&!this.h.extUri.isEqual(x.location,x.applicationExtensionslocation)){F=F.filter(z=>!z.metadata?.isApplicationScoped);const W=await this.m(x.applicationExtensionslocation,z=>!!z.metadata?.isApplicationScoped,x);F.push(...W)}return F}async m(x,F,W){const z=await this.g.scanProfileExtensions(x,W.profileScanOptions);if(!z.length)return[];const J=await Promise.all(z.map(async ne=>{if(F(ne)){const se=new X(ne.location,W.mtime,W.applicationExtensionslocation,W.applicationExtensionslocationMtime,W.profile,W.profileScanOptions,W.type,W.excludeObsolete,W.validate,W.productVersion,W.productDate,W.productCommit,W.devMode,W.language,W.translations);return this.scanExtension(se,ne.metadata)}return null}));return(0,I.coalesce)(J)}async scanOneOrMultipleExtensions(x){try{if(await this.i.exists((0,g.joinPath)(x.location,"package.json"))){const F=await this.scanExtension(x);return F?[F]:[]}else return await this.scanExtensions(x)}catch(F){return this.j.error(`Error scanning extensions at ${x.location.path}:`,(0,D.getErrorMessage)(F)),[]}}async scanExtension(x,F){try{let W=await this.scanExtensionManifest(x.location);if(W){W.publisher||(W.publisher=M.UNDEFINED_PUBLISHER),F=F??W.__metadata,delete W.__metadata;const z=(0,E.getGalleryExtensionId)(W.publisher,W.name),J=F?.id?{id:z,uuid:F.id}:{id:z},ne=F?.isSystem?0:x.type,se=ne===0||!!F?.isBuiltin;N.ImplicitActivationEvents.updateManifest(W),W=await this.n(x.location,W,X.createNlsConfiguration(x));const Z={type:ne,identifier:J,manifest:W,location:x.location,isBuiltin:se,targetPlatform:F?.targetPlatform??"undefined",metadata:F,isValid:!0,validations:[]};return x.validate?this.validate(Z,x):Z}}catch(W){x.type!==0&&this.j.error(W)}return null}validate(x,F){let W=!0;const z=(0,t.validateExtensionManifest)(F.productVersion,F.productDate,F.location,x.manifest,x.isBuiltin);for(const[J,ne]of z)J===w.default.Error&&(W=!1,this.j.error(this.t(F.location,ne)));return x.isValid=W,x.validations=z,x}async scanExtensionManifest(x){const F=(0,g.joinPath)(x,"package.json");let W;try{W=(await this.i.readFile(F)).value.toString()}catch(J){return(0,a.toFileOperationResult)(J)!==1&&this.j.error(this.t(x,(0,p.localize)(0,null,F.path,J.message))),null}let z;try{z=JSON.parse(W)}catch{const ne=[];(0,P.parse)(W,ne);for(const se of ne)this.j.error(this.t(x,(0,p.localize)(1,null,F.path,se.offset,se.length,(0,f.getParseErrorMessage)(se.error))));return null}return(0,P.getNodeType)(z)!=="object"?(this.j.error(this.t(x,(0,p.localize)(2,null,F.path))),null):z}async n(x,F,W){const z=await this.p(x,F,W);if(z)try{const J=[],ne=await this.r(z.default,J);if(J.length>0)return J.forEach(Z=>{this.j.error(this.t(x,(0,p.localize)(3,null,z.default?.path,(0,f.getParseErrorMessage)(Z.error))))}),F;if((0,P.getNodeType)(z)!=="object")return this.j.error(this.t(x,(0,p.localize)(4,null,z.default?.path))),F;const se=z.values||Object.create(null);return(0,O.localizeManifest)(F,se,ne)}catch{}return F}async p(x,F,W){const z=(0,g.joinPath)(x,"package.nls.json"),J=(U,L)=>{L.forEach(T=>{this.j.error(this.t(x,(0,p.localize)(5,null,U?.path,(0,f.getParseErrorMessage)(T.error))))})},ne=U=>{this.j.error(this.t(x,(0,p.localize)(6,null,U?.path)))},se=`${F.publisher}.${F.name}`,Z=W.translations[se];if(Z)try{const U=u.URI.file(Z),L=(await this.i.readFile(U)).value.toString(),T=[],B=(0,P.parse)(L,T);return T.length>0?(J(U,T),{values:void 0,default:z}):(0,P.getNodeType)(B)!=="object"?(ne(U),{values:void 0,default:z}):{values:B.contents?B.contents.package:void 0,default:z}}catch{return{values:void 0,default:z}}else{if(!await this.i.exists(z))return;let L;try{L=await this.s(x,W)}catch{return}if(!L.localized)return{values:void 0,default:L.original};try{const T=(await this.i.readFile(L.localized)).value.toString(),B=[],H=(0,P.parse)(T,B);return B.length>0?(J(L.localized,B),{values:void 0,default:L.original}):(0,P.getNodeType)(H)!=="object"?(ne(L.localized),{values:void 0,default:L.original}):{values:H,default:L.original}}catch{return{values:void 0,default:L.original}}}}async r(x,F){if(x)try{const W=(await this.i.readFile(x)).value.toString();return(0,P.parse)(W,F)}catch{}}s(x,F){return new Promise((W,z)=>{const J=ne=>{const se=(0,g.joinPath)(x,`package.nls.${ne}.json`);this.i.exists(se).then(Z=>{Z&&W({localized:se,original:(0,g.joinPath)(x,"package.nls.json")});const U=ne.lastIndexOf("-");U===-1?W({localized:(0,g.joinPath)(x,"package.nls.json"),original:null}):(ne=ne.substring(0,U),J(ne))})};if(F.devMode||F.pseudo||!F.language)return W({localized:(0,g.joinPath)(x,"package.nls.json"),original:null});J(F.language)})}t(x,F){return`[${x.path}]: ${F}`}};ie=ve([_(1,d.IExtensionsProfileScannerService),_(2,R.IUriIdentityService),_(3,a.IFileService),_(4,r.ILogService)],ie);let re=class extends ie{constructor(x,F,W,z,J,ne){super(F,W,z,J,ne),this.y=x,this.v=this.B(new A.ThrottledDelayer(3e3)),this.w=this.B(new l.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(x){const F=await this.z();if(this.u=x,F&&F.input&&X.equals(F.input,this.u))return this.j.debug("Using cached extensions scan result",x.location.toString()),this.v.trigger(()=>this.D()),F.result.map(z=>(z.location=u.URI.revive(z.location),z));const W=await super.scanExtensions(x);return await this.C({input:x,result:W}),W}async z(){try{const x=await this.i.readFile(this.y),F=JSON.parse(x.value.toString());return{result:F.result,input:(0,s.revive)(F.input)}}catch(x){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,D.getErrorMessage)(x))}return null}async C(x){try{await this.i.writeFile(this.y,C.VSBuffer.fromString(JSON.stringify(x)))}catch(F){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,D.getErrorMessage)(F))}}async D(){if(!this.u)return;const x=await this.z();if(!x)return;const F=x.result,W=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!n.equals(W,F))try{await this.i.del(this.y),this.w.fire()}catch(z){this.j.error(z)}}};re=ve([_(2,d.IExtensionsProfileScannerService),_(3,R.IUriIdentityService),_(4,a.IFileService),_(5,r.ILogService)],re);function ce(ge,x){const F=(0,E.getExtensionId)(ge.manifest.publisher,ge.manifest.name);return{id:F,identifier:new M.ExtensionIdentifier(F),isBuiltin:ge.type===0,isUserBuiltin:ge.type===1&&ge.isBuiltin,isUnderDevelopment:x,extensionLocation:ge.location,uuid:ge.identifier.uuid,targetPlatform:ge.targetPlatform,...ge.manifest}}e.toExtensionDescription=ce;class fe extends V{constructor(x,F,W,z,J,ne,se,Z,U,L,T,B){super(x,F,(0,g.joinPath)(W,".vscode-oss-dev","extensions","control.json"),(0,g.joinPath)(z,M.MANIFEST_CACHE_FOLDER),J,ne,se,Z,U,L,T,B),this.M=(async()=>{if(y.translationsConfigFile)try{const H=await this.r.readFile(u.URI.file(y.translationsConfigFile));return JSON.parse(H.value.toString())}catch{}return Object.create(null)})()}f(x){return this.M}}e.NativeExtensionsScannerService=fe}),define(ee[265],te([0,1,5,39,38,24,78,16,33,7]),function(G,e,I,A,n,C,D,P,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let b=class extends D.AbstractExtensionsProfileScannerService{constructor(y,g,m,w,o,u){super(h.URI.file(y.extensionsPath),g,m,w,o,u)}};b=ve([_(0,f.INativeEnvironmentService),_(1,P.IFileService),_(2,A.IUserDataProfilesService),_(3,n.IUriIdentityService),_(4,C.ITelemetryService),_(5,I.ILogService)],b),e.ExtensionsProfileScannerService=b}),define(ee[266],te([0,1,7,33,78,119,16,6,5,20,38,39]),function(G,e,I,A,n,C,D,P,f,h,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let y=class extends C.NativeExtensionsScannerService{constructor(m,w,o,u,p,k,E,M){super(I.URI.file(p.builtinExtensionsPath),I.URI.file(p.extensionsPath),p.userHome,I.URI.file(p.userDataPath),m,w,o,u,p,k,E,M)}};y=ve([_(0,v.IUserDataProfilesService),_(1,n.IExtensionsProfileScannerService),_(2,D.IFileService),_(3,f.ILogService),_(4,A.INativeEnvironmentService),_(5,h.IProductService),_(6,b.IUriIdentityService),_(7,P.IInstantiationService)],y),e.ExtensionsScannerService=y}),define(ee[267],te([0,1,14,2,15,9,4,61,7,31,42,33,5,39]),function(G,e,I,A,n,C,D,P,f,h,b,v,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let m=class extends A.Disposable{constructor(o,u,p){super(),this.c=o,this.f=p,this.a=P.TernarySearchTree.forPaths(!D.isLinux),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(o.appRoot),this.addValidFileRoot(o.extensionsPath),this.addValidFileRoot(u.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(o.workspaceStorageHome.fsPath),this.g()}g(){const{defaultSession:o}=I.session;o.protocol.registerFileProtocol(n.Schemas.vscodeFileResource,(u,p)=>this.i(u,p)),o.protocol.interceptFileProtocol(n.Schemas.file,(u,p)=>this.h(u,p)),this.B((0,A.toDisposable)(()=>{o.protocol.unregisterProtocol(n.Schemas.vscodeFileResource),o.protocol.uninterceptProtocol(n.Schemas.file)}))}addValidFileRoot(o){const u=(0,C.normalize)(o);return this.a.get(u)?A.Disposable.None:(this.a.set(u,!0),(0,A.toDisposable)(()=>this.a.delete(u)))}h(o,u){const p=f.URI.parse(o.url);return this.f.error(`Refused to load resource ${p.fsPath} from ${n.Schemas.file}: protocol (original URL: ${o.url})`),u({error:-3})}i(o,u){const p=this.j(o);let k;return this.c.crossOriginIsolated&&((0,C.basename)(p)==="workbench.html"||(0,C.basename)(p)==="workbench-dev.html"?k=n.COI.CoopAndCoep:k=n.COI.getHeadersFromQuery(o.url)),this.a.findSubstr(p)?u({path:p,headers:k}):this.b.has((0,C.extname)(p).toLowerCase())?u({path:p}):(this.f.error(`${n.Schemas.vscodeFileResource}: Refused to load resource ${p} from ${n.Schemas.vscodeFileResource}: protocol (original URL: ${o.url})`),u({error:-3}))}j(o){const u=f.URI.parse(o.url),p=n.FileAccess.uriToFileUri(u);return(0,C.normalize)(p.fsPath)}createIPCObjectUrl(){let o;const u=f.URI.from({scheme:"vscode",path:(0,h.generateUuid)()}),p=u.toString(),k=async()=>o;return b.validatedIpcMain.handle(p,k),this.f.trace(`IPC Object URL: Registered new channel ${p}.`),{resource:u,update:E=>o=E,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${p}.`),b.validatedIpcMain.removeHandler(p)}}}};m=ve([_(0,v.INativeEnvironmentService),_(1,g.IUserDataProfilesService),_(2,y.ILogService)],m),e.ProtocolMainService=m}),define(ee[268],te([0,1,14,42,8,3,2,15,10,105,28,21,5,66,67,69,44,39,37,65]),function(G,e,I,A,n,C,D,P,f,h,b,v,y,g,m,w,o,u,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let E=class extends D.Disposable{constructor(t,a,i,r,c,l,s,d,S,R){super(),this.g=t,this.h=a,this.i=i,this.j=r,this.k=c,this.l=l,this.m=s,this.n=d,this.p=S,this.r=R,this.a=new n.Barrier,this.b=void 0,this.c=void 0,this.f=this.B(new C.Emitter),this.onDidError=C.Event.buffer(this.f.event),this.y=void 0,this.z=void 0,this.s()}s(){A.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(t,a)=>this.t(t,a)),A.validatedIpcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(t,a)=>this.u(t,a)),this.B(this.k.onWillShutdown(()=>this.v()))}async t(t,a){this.l.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.a.isOpen()||this.a.open(),await this.whenReady();const i=await this.connect();if(t.sender.isDestroyed())return i.close();t.sender.postMessage("vscode:createSharedProcessMessageChannelResult",a,[i])}u(t,a){this.l.trace("SharedProcess: onWorkerConnection",a);const i=new D.DisposableStore,r=l=>{!this.G()||(this.l.trace(`SharedProcess: disposing worker (reason: '${l}')`,a),i.dispose(),this.w("vscode:electron-main->shared-process=disposeWorker",a))},c=I.BrowserWindow.fromId(a.reply.windowId);if(!c||c.isDestroyed()||c.webContents.isDestroyed()||!a.reply.channel){r("unavailable");return}i.add(C.Event.filter(this.k.onWillLoadWindow,l=>l.window.win===c)(()=>r("load"))),i.add(C.Event.fromNodeEventEmitter(c,"closed")(()=>r("closed"))),c.webContents.postMessage(a.reply.channel,a.reply.nonce,t.ports)}v(){const t=this.b;!t||(this.w("vscode:electron-main->shared-process=exit"),this.c&&(t.removeListener("close",this.c),this.c=void 0),setTimeout(()=>{try{t.close()}catch{}this.b=void 0},0))}w(t,...a){if(!this.G()){this.l.warn(`Sending IPC message to channel '${t}' for shared process window that is destroyed`);return}try{this.b?.webContents.send(t,...a)}catch(i){this.l.warn(`Error sending IPC message to channel '${t}' of shared process: ${(0,o.toErrorMessage)(i)}`)}}whenReady(){return this.y||(this.y=new Promise(t=>A.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.l.trace("SharedProcess: Overall ready"),t()}))),this.y}get C(){return this.z||(this.z=(async()=>{await this.a.wait(),this.D(),this.F(),await new Promise(t=>A.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.l.trace("SharedProcess: IPC ready"),t()}))})()),this.z}D(){const t=this.B(this.r.createIPCObjectUrl());this.b=new I.BrowserWindow({show:!1,backgroundColor:this.p.getBackgroundColor(),webPreferences:{preload:P.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${t.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.i.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,images:!1,webgl:!1}}),t.update({machineId:this.g,windowId:this.b.id,appRoot:this.i.appRoot,codeCachePath:this.i.codeCachePath,profiles:this.j.profiles,userEnv:this.h,args:this.i.args,logLevel:this.l.getLevel(),loggers:this.m.getRegisteredLoggers(),product:g.default,policiesData:this.n.serialize()}),this.b.loadURL(P.FileAccess.asBrowserUri(`vs/code/electron-browser/sharedProcess/sharedProcess${this.i.isBuilt?"":"-dev"}.html`).toString(!0))}F(){!this.b||(this.c=t=>{this.l.trace("SharedProcess#close prevented"),t.preventDefault(),this.b?.isVisible()&&this.b.hide()},this.b.on("close",this.c),this.b.webContents.on("render-process-gone",(t,a)=>this.f.fire({type:2,details:a})),this.b.on("unresponsive",()=>this.f.fire({type:1})),this.b.webContents.on("did-fail-load",(t,a,i)=>this.f.fire({type:3,details:{reason:i,exitCode:a}})))}async connect(){await this.C;const t=(0,f.assertIsDefined)(this.b);return(0,h.connect)(t)}async toggle(){await this.C,this.b&&(this.b.isVisible()?(this.b.webContents.closeDevTools(),this.b.hide()):(this.b.show(),this.b.webContents.openDevTools()))}isVisible(){return this.b?.isVisible()??!1}G(){const t=this.b;return t?!t.isDestroyed()&&!t.webContents.isDestroyed():!1}};E=ve([_(2,b.IEnvironmentMainService),_(3,u.IUserDataProfilesService),_(4,v.ILifecycleMainService),_(5,y.ILogService),_(6,k.ILoggerMainService),_(7,p.IPolicyService),_(8,w.IThemeMainService),_(9,m.IProtocolMainService)],E),e.SharedProcess=E}),define(ee[95],te([0,1,8,3,2,64,10,106,6,39]),function(G,e,I,A,n,C,D,P,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,f.createDecorator)("storageService");var b;(function(p){p[p.NONE=0]="NONE",p[p.SHUTDOWN=1]="SHUTDOWN"})(b=e.WillSaveStateReason||(e.WillSaveStateReason={}));var v;(function(p){p[p.APPLICATION=-1]="APPLICATION",p[p.PROFILE=0]="PROFILE",p[p.WORKSPACE=1]="WORKSPACE"})(v=e.StorageScope||(e.StorageScope={}));var y;(function(p){p[p.USER=0]="USER",p[p.MACHINE=1]="MACHINE"})(y=e.StorageTarget||(e.StorageTarget={}));function g(p){const k=p.get(e.TARGET_KEY);if(k)try{return JSON.parse(k)}catch{}return Object.create(null)}e.loadKeyTargets=g;class m extends n.Disposable{constructor(k={flushInterval:m.a}){super(),this.j=k,this.b=this.B(new A.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new A.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new A.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new I.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new n.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,I.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,n.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,C.mark)("code/willInitStorage");try{await this.J()}finally{(0,C.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(k,E){if(E===e.TARGET_KEY){switch(k){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:k})}else this.b.fire({scope:k,key:E,target:this.F(k)[E]})}r(k){this.f.fire({reason:k})}get(k,E,M){return this.L(E)?.get(k,M)}getBoolean(k,E,M){return this.L(E)?.getBoolean(k,M)}getNumber(k,E,M){return this.L(E)?.getNumber(k,M)}store(k,E,M,t){if((0,D.isUndefinedOrNull)(E)){this.remove(k,M);return}this.t(()=>{this.u(k,M,t),this.L(M)?.set(k,E)})}remove(k,E){this.t(()=>{this.u(k,E,void 0),this.L(E)?.delete(k)})}t(k){this.b.pause(),this.c.pause();try{k()}finally{this.b.resume(),this.c.resume()}}keys(k,E){const M=[],t=this.F(k);for(const a of Object.keys(t))t[a]===E&&M.push(a);return M}u(k,E,M){const t=this.F(E);typeof M=="number"?t[k]!==M&&(t[k]=M,this.L(E)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[k]=="number"&&(delete t[k],this.L(E)?.set(e.TARGET_KEY,JSON.stringify(t)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(k){switch(k){case-1:return this.D;case 0:return this.z;default:return this.w}}G(k){const E=this.L(k);return E?g(E):Object.create(null)}isNew(k){return this.getBoolean(e.IS_NEW_KEY,k)===!0}async flush(k=b.NONE){this.f.fire({reason:k});const E=this.L(-1),M=this.L(0),t=this.L(1);switch(k){case b.NONE:await I.Promises.settled([E?.whenFlushed()??Promise.resolve(),M?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case b.SHUTDOWN:await I.Promises.settled([E?.flush(0)??Promise.resolve(),M?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const k=this.L(-1)?.items??new Map,E=this.L(0)?.items??new Map,M=this.L(1)?.items??new Map;return u(k,E,M,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(k,E){return this.r(b.NONE),(0,h.isUserDataProfile)(k)?this.N(k,E):this.O(k,E)}H(k,E){return!(k.id===E.id||w(E)&&w(k))}I(k,E,M,t){this.t(()=>{if(t)for(const[a,i]of k)E.set(a,i);else{const a=new Set;for(const[i,r]of k)a.add(i),E.get(i)!==r&&this.n(M,i);for(const[i]of E.items)a.has(i)||this.n(M,i)}})}}e.AbstractStorageService=m,m.a=60*1e3;function w(p){return p.isDefault||!!p.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=w;class o extends m{constructor(){super(),this.p=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(k=>this.n(1,k))),this.B(this.P.onDidChangeStorage(k=>this.n(0,k))),this.B(this.p.onDidChangeStorage(k=>this.n(-1,k)))}L(k){switch(k){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(k){switch(k){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(k){return!1}}e.InMemoryStorageService=o;async function u(p,k,E,M,t,a){const i=N=>{try{return JSON.parse(N)}catch{return N}},r=new Map,c=new Map;p.forEach((N,K)=>{r.set(K,N),c.set(K,i(N))});const l=new Map,s=new Map;k.forEach((N,K)=>{l.set(K,N),s.set(K,i(N))});const d=new Map,S=new Map;E.forEach((N,K)=>{d.set(K,N),S.set(K,i(N))}),console.group(M!==t?`Storage: Application (path: ${M})`:`Storage: Application & Profile (path: ${M}, default profile)`);const R=[];if(r.forEach((N,K)=>{R.push({key:K,value:N})}),console.table(R),console.groupEnd(),console.log(c),M!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const N=[];l.forEach((K,V)=>{N.push({key:V,value:K})}),console.table(N),console.groupEnd(),console.log(s)}console.group(`Storage: Workspace (path: ${a})`);const O=[];d.forEach((N,K)=>{O.push({key:K,value:N})}),console.table(O),console.groupEnd(),console.log(S)}e.logStorage=u}),define(ee[269],te([0,1,25,8,3,2,9,71,7,23,106,152,5,95,24,29]),function(G,e,I,A,n,C,D,P,f,h,b,v,y,g,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class o extends C.Disposable{get storage(){return this.f}constructor(a,i){super(),this.j=a,this.k=i,this.b=this.B(new n.Emitter),this.onDidChangeStorage=this.b.event,this.c=this.B(new n.Emitter),this.onDidCloseStorage=this.c.event,this.f=new b.Storage(new b.InMemoryStorageDatabase,{hint:b.StorageHint.STORAGE_IN_MEMORY}),this.g=void 0,this.h=new A.DeferredPromise,this.whenInit=this.h.p,this.i=b.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.i===b.StorageState.None)try{const a=await this.n();this.f.dispose(),this.f=a,this.B(a.onDidChangeStorage(r=>this.b.fire({key:r}))),await this.m(a);const i=a.getBoolean(g.IS_NEW_KEY);i===void 0?a.set(g.IS_NEW_KEY,!0):i&&a.set(g.IS_NEW_KEY,!1)}catch(a){this.j.error(`[storage main] initialize(): Unable to init storage due to ${a}`)}finally{this.i=b.StorageState.Initialized,this.h.complete()}})()),this.g}l(){return{logTrace:this.j.getLevel()===y.LogLevel.Trace?a=>this.j.trace(a):void 0,logError:a=>this.j.error(a)}}m(a){return a.init()}get items(){return this.f.items}get(a,i){return this.f.get(a,i)}set(a,i){return this.f.set(a,i)}delete(a){return this.f.delete(a)}async close(){const a=new P.StopWatch(!1);await this.s(),a.stop(),a.elapsed()>o.a&&await this.r(a),this.c.fire()}async r(a){if(!!this.path)try{const i=(0,I.top)(Array.from(this.f.items.entries()).map(([c,l])=>({key:c,length:l.length})),(c,l)=>l.length-c.length,5).map(c=>`${c.key}:${c.length}`).join(", "),r=(await this.k.stat(f.URI.file(this.path))).size;this.j.warn(`[storage main] detected slow close() operation: Time: ${a.elapsed()}ms, DB size: ${r}b, Large Keys: ${i}`)}catch(i){this.j.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async s(){this.g&&await this.g,this.i=b.StorageState.Closed,await this.f.close()}}o.a=2e3;class u extends o{get path(){if(!this.v.useInMemoryStorage)return(0,D.join)(this.u.globalStorageHome.fsPath,u.t)}constructor(a,i,r,c){super(r,c),this.u=a,this.v=i}async n(){return new b.Storage(new v.SQLiteStorageDatabase(this.path??v.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.l()}),this.path?void 0:{hint:b.StorageHint.STORAGE_IN_MEMORY})}}u.t="state.vscdb";class p extends u{constructor(a,i,r,c){super(a,i,r,c)}}e.ProfileStorageMain=p;class k extends u{constructor(a,i,r,c){super(i.defaultProfile,a,r,c)}async m(a){await super.m(a),this.z(a)}z(a){a.get(m.firstSessionDateStorageKey,void 0)===void 0&&a.set(m.firstSessionDateStorageKey,new Date().toUTCString());const r=a.get(m.currentSessionDateStorageKey,void 0),c=new Date().toUTCString();a.set(m.lastSessionDateStorageKey,typeof r>"u"?null:r),a.set(m.currentSessionDateStorageKey,c)}}e.ApplicationStorageMain=k;class E extends o{get path(){if(!this.w.useInMemoryStorage)return(0,D.join)(this.y.workspaceStorageHome.fsPath,this.v.id,E.t)}constructor(a,i,r,c,l){super(r,l),this.v=a,this.w=i,this.y=c}async n(){const{storageFilePath:a,wasCreated:i}=await this.C();return new b.Storage(new v.SQLiteStorageDatabase(a,{logging:this.l()}),{hint:this.w.useInMemoryStorage?b.StorageHint.STORAGE_IN_MEMORY:i?b.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async C(){if(this.w.useInMemoryStorage)return{storageFilePath:v.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const a=(0,D.join)(this.y.workspaceStorageHome.fsPath,this.v.id),i=(0,D.join)(a,E.t);return await h.Promises.exists(a)?{storageFilePath:i,wasCreated:!1}:(await h.Promises.mkdir(a,{recursive:!0}),this.D(a),{storageFilePath:i,wasCreated:!0})}async D(a){let i;if((0,w.isSingleFolderWorkspaceIdentifier)(this.v)?i={folder:this.v.uri.toString()}:(0,w.isWorkspaceIdentifier)(this.v)&&(i={workspace:this.v.configPath.toString()}),i)try{const r=(0,D.join)(a,E.u);await h.Promises.exists(r)||await h.Promises.writeFile(r,JSON.stringify(i,void 0,2))}catch(r){this.j.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${r}`)}}}e.WorkspaceStorageMain=E,E.t="state.vscdb",E.u="workspace.json";class M extends o{get path(){}async n(){return new b.Storage(new b.InMemoryStorageDatabase,{hint:b.StorageHint.STORAGE_IN_MEMORY})}}e.InMemoryStorageMain=M}),define(ee[270],te([0,1,3,2,95]),function(G,e,I,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class C extends A.Disposable{constructor(P,f,h){super(),this.b=P,this.c=f,this.f=h;const b=this.B(new A.MutableDisposable);this.a=this.B(new I.Emitter({onWillAddFirstListener:()=>b.value=this.g(),onDidRemoveLastListener:()=>b.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const P=new A.DisposableStore;return P.add(I.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(f,h)=>(f?f.push(h.key):f=[h.key],f),100)(f=>this.h(f))),P.add(I.Event.debounce(this.b.onDidChangeProfileStorage,(f,h)=>{f||(f=new Map);let b=f.get(h.profile.id);return b||f.set(h.profile.id,b={profile:h.profile,keys:[],storage:h.storage}),b.keys.push(h.key),f},100)(f=>this.i(f))),P}h(P){const f=P.includes(n.TARGET_KEY)?[this.c.defaultProfile]:[],h=[];if(P=P.filter(b=>b!==n.TARGET_KEY),P.length){const b=(0,n.loadKeyTargets)(this.b.applicationStorage.storage);h.push({profile:this.c.defaultProfile,changes:P.map(v=>({key:v,scope:0,target:b[v]}))})}this.j(f,h)}i(P){const f=[],h=new Map;for(const[b,v]of P.entries()){v.keys.includes(n.TARGET_KEY)&&f.push(v.profile);const y=v.keys.filter(g=>g!==n.TARGET_KEY);if(y.length){const g=(0,n.loadKeyTargets)(v.storage.storage);h.set(b,{profile:v.profile,changes:y.map(m=>({key:m,scope:0,target:g[m]}))})}}this.j(f,[...h.values()])}j(P,f){(P.length||f.length)&&this.a.fire({valueChanges:f,targetChanges:P})}listen(P,f,h){switch(f){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${f}`)}async call(P,f){throw new Error(`Call not found: ${f}`)}}e.ProfileStorageChangesListenerChannel=C}),define(ee[271],te([0,1,73,7,33,16,5,236,38,39]),function(G,e,I,A,n,C,D,P,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.ServerUserDataProfilesService=void 0;let b=class extends h.UserDataProfilesService{constructor(g,m,w,o){super(m,w,g,o),this.a=m}L(){return this.r.extUri.joinPath(A.URI.file(this.a.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};b=ve([_(0,f.IUriIdentityService),_(1,n.INativeEnvironmentService),_(2,C.IFileService),_(3,D.ILogService)],b),e.ServerUserDataProfilesService=b;let v=class pt extends b{constructor(g,m,w,o,u){super(m,w,o,u),this.N=g}G(){return(0,I.revive)(this.N.getItem(pt.b,[]))}I(){return(0,I.revive)(this.N.getItem(pt.c,{}))}L(){return this.r.extUri.joinPath(A.URI.file(this.a.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};v=ve([_(0,P.IStateService),_(1,f.IUriIdentityService),_(2,n.INativeEnvironmentService),_(3,C.IFileService),_(4,D.ILogService)],v),e.UserDataProfilesService=v}),define(ee[53],te([0,1,7,33,16,6,5,34,38,39,271]),function(G,e,I,A,n,C,D,P,f,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,C.refineServiceDecorator)(h.IUserDataProfilesService);let v=class at extends b.UserDataProfilesService{constructor(g,m,w,o,u){super(g,m,w,o,u),this.R=g}getAssociatedEmptyWindows(){const g=[];for(const m of this.u.emptyWindows.keys())g.push({id:m});return g}H(g){g.length?this.R.setItem(at.b,g):this.R.removeItem(at.b)}J(g){g.emptyWindows||g.workspaces?this.R.setItem(at.c,g):this.R.removeItem(at.c)}I(){const g="workspaceAndProfileInfo",m=this.R.getItem(g,void 0);if(m){this.R.removeItem(g);const w=m.reduce((o,{workspace:u,profile:p})=>(o[I.URI.revive(u).toString()]=I.URI.revive(p).toString(),o),{});this.R.setItem(at.c,{workspaces:w})}return super.I()}};v=ve([_(0,P.IStateMainService),_(1,f.IUriIdentityService),_(2,A.INativeEnvironmentService),_(3,n.IFileService),_(4,D.ILogService)],v),e.UserDataProfilesMainService=v}),define(ee[96],te([0,1,7,50,3,2,33,16,6,21,5,95,269,39,53,38]),function(G,e,I,A,n,C,D,P,f,h,b,v,y,g,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,f.createDecorator)("storageMainService");let o=class extends C.Disposable{constructor(k,E,M,t,a,i){super(),this.c=k,this.f=E,this.g=M,this.h=t,this.i=a,this.j=i,this.a=void 0,this.b=this.B(new n.Emitter),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.m(),this.n=new Map,this.r=new Map,this.l()}k(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}l(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(k=>{k.window.profile&&this.profileStorage(k.window.profile).init(),k.workspace&&this.workspaceStorage(k.workspace).init()})),this.B(this.h.onWillShutdown(k=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=k.reason,k.join(this.applicationStorage.close());for(const[,E]of this.n)k.join(E.close());for(const[,E]of this.r)k.join(E.close())})),this.B(this.g.onWillCreateProfile(k=>{k.join((async()=>{await this.i.exists(k.profile.globalStorageHome)||await this.i.createFolder(k.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(k=>{const E=this.n.get(k.profile.id);E&&k.join(E.close())}))}m(){this.c.trace("StorageMainService: creating application storage");const k=new y.ApplicationStorageMain(this.k(),this.g,this.c,this.i);return(0,A.once)(k.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")}),k}profileStorage(k){if((0,v.isProfileUsingDefaultStorage)(k))return this.applicationStorage;let E=this.n.get(k.id);if(!E){this.c.trace(`StorageMainService: creating profile storage (${k.name})`),E=this.p(k),this.n.set(k.id,E);const M=this.B(E.onDidChangeStorage(t=>this.b.fire({...t,storage:E,profile:k})));(0,A.once)(E.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${k.name})`),this.n.delete(k.id),M.dispose()})}return E}p(k){return this.a===2?new y.InMemoryStorageMain(this.c,this.i):new y.ProfileStorageMain(k,this.k(),this.c,this.i)}workspaceStorage(k){let E=this.r.get(k.id);return E||(this.c.trace(`StorageMainService: creating workspace storage (${k.id})`),E=this.s(k),this.r.set(k.id,E),(0,A.once)(E.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${k.id})`),this.r.delete(k.id)})),E}s(k){return this.a===2?new y.InMemoryStorageMain(this.c,this.i):new y.WorkspaceStorageMain(k,this.k(),this.c,this.f,this.i)}isUsed(k){const E=I.URI.file(k);for(const M of[this.applicationStorage,...this.n.values(),...this.r.values()])if(!!M.path&&this.j.extUri.isEqualOrParent(I.URI.file(M.path),E))return!0;return!1}};o=ve([_(0,b.ILogService),_(1,D.IEnvironmentService),_(2,m.IUserDataProfilesMainService),_(3,h.ILifecycleMainService),_(4,P.IFileService),_(5,w.IUriIdentityService)],o),e.StorageMainService=o,e.IApplicationStorageMainService=(0,f.createDecorator)("applicationStorageMainService");let u=class extends v.AbstractStorageService{constructor(k,E){super(),this.p=k,this.s=E,this.whenReady=this.s.applicationStorage.whenInit}J(){return this.s.applicationStorage.whenInit}L(k){if(k===-1)return this.s.applicationStorage.storage}M(k){if(k===-1)return this.p.defaultProfile.globalStorageHome.fsPath}l(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}N(){throw new Error("Switching storage profile is unsupported from main process")}O(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};u=ve([_(0,g.IUserDataProfilesService),_(1,e.IStorageMainService)],u),e.ApplicationStorageMainService=u}),define(ee[272],te([0,1,2,21,53,29,8,30]),function(G,e,I,A,n,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesHandler=void 0;let f=class extends I.Disposable{constructor(b,v,y){super(),this.a=v,this.b=y,this.B(b.onWillLoadWindow(g=>{g.reason===2&&this.c(g.window)})),this.B(b.onBeforeCloseWindow(g=>this.c(g))),this.B(new D.RunOnceScheduler(()=>this.g(),30*1e3)).schedule()}async c(b){const v=this.f(b),y=this.a.getProfileForWorkspace(v);y&&((0,C.isEmptyWorkspaceIdentifier)(v)||y.isTransient)&&(this.a.unsetWorkspace(v,y.isTransient),y.isTransient&&await this.a.cleanUpTransientProfiles())}f(b){return b.openedWorkspace??(0,C.toWorkspaceIdentifier)(b.backupPath,b.isExtensionDevelopmentHost)}g(){const b=this.a.getAssociatedEmptyWindows();if(b.length===0)return;const v=this.b.getWindows().map(y=>this.f(y));for(const y of b)v.some(g=>g.id===y.id)||this.a.unsetWorkspace(y,!1)}};f=ve([_(0,A.ILifecycleMainService),_(1,n.IUserDataProfilesMainService),_(2,P.IWindowsMainService)],f),e.UserDataProfilesHandler=f}),define(ee[120],te([0,1,18,7,29]),function(G,e,I,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;async function C(f,h,b){for(const y of f){const g=y.openedWorkspace;if((0,n.isWorkspaceIdentifier)(g)){const m=await b(g);if(m){if(m.folders.some(w=>I.extUriBiasedIgnorePathCase.isEqualOrParent(h,w.uri)))return y}else if(I.extUriBiasedIgnorePathCase.isEqualOrParent(h,g.configPath))return y}}const v=f.filter(y=>(0,n.isSingleFolderWorkspaceIdentifier)(y.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqualOrParent(h,y.openedWorkspace.uri));if(v.length)return v.sort((y,g)=>-(y.openedWorkspace.uri.path.length-g.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=C;function D(f,h){for(const b of f)if((0,n.isWorkspaceIdentifier)(b.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqual(b.openedWorkspace.configPath,h)||(0,n.isSingleFolderWorkspaceIdentifier)(b.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqual(b.openedWorkspace.uri,h))return b}e.findWindowOnWorkspaceOrFolder=D;function P(f,h){const b=v=>h.some(y=>I.extUriBiasedIgnorePathCase.isEqual(A.URI.file(y),A.URI.file(v)));for(const v of f)if(v.config?.extensionDevelopmentPath?.some(y=>b(y)))return v}e.findWindowOnExtensionDevelopmentPath=P}),define(ee[273],te([0,1,14,2,4,18,7,19,21,5,34,30,118,29]),function(G,e,I,A,n,C,D,P,f,h,b,v,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let m=class wt extends A.Disposable{get state(){return this.b}constructor(E,M,t,a,i){super(),this.g=E,this.h=M,this.i=t,this.j=a,this.k=i,this.b=w(this.h.getItem(wt.a)),this.c=void 0,this.f=!1,this.l()}l(){I.app.on("browser-window-blur",()=>{this.f||this.n()}),this.i.onBeforeCloseWindow(E=>this.p(E)),this.i.onBeforeShutdown(()=>this.m()),this.g.onDidChangeWindowsCount(E=>{E.newCount-E.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(E=>this.p(E))}m(){this.f=!0,this.n()}n(){const E=new Set,M={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!M.lastActiveWindow){let i=this.g.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.g.getWindows().find(r=>!r.isExtensionDevelopmentHost)),i&&(M.lastActiveWindow=this.r(i),M.lastActiveWindow.uiState.mode===3&&E.add(M.lastActiveWindow.uiState.display))}const t=this.g.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);t&&(M.lastPluginDevelopmentHostWindow=this.r(t),M.lastPluginDevelopmentHostWindow.uiState.mode===3&&(E.has(M.lastPluginDevelopmentHostWindow.uiState.display)?n.isMacintosh&&!t.win?.isSimpleFullScreen()&&(M.lastPluginDevelopmentHostWindow.uiState.mode=1):E.add(M.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(M.openedWindows=this.g.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const r=this.r(i);return r.uiState.mode===3&&(E.has(r.uiState.display)?n.isMacintosh&&r.windowId!==M.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(r.uiState.mode=1):E.add(r.uiState.display)),r}));const a=u(M);this.h.setItem(wt.a,a),this.f&&this.j.trace("[WindowsStateHandler] onBeforeShutdown",a)}p(E){if(this.i.quitRequested)return;const M=this.r(E);E.isExtensionDevelopmentHost&&!E.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=M:!E.isExtensionDevelopmentHost&&E.openedWorkspace&&this.b.openedWindows.forEach(t=>{const a=(0,g.isWorkspaceIdentifier)(E.openedWorkspace)&&t.workspace?.id===E.openedWorkspace.id,i=(0,g.isSingleFolderWorkspaceIdentifier)(E.openedWorkspace)&&t.folderUri&&C.extUriBiasedIgnorePathCase.isEqual(t.folderUri,E.openedWorkspace.uri);(a||i)&&(t.uiState=M.uiState)}),this.g.getWindowCount()===1&&(this.c=M)}r(E){return{windowId:E.id,workspace:(0,g.isWorkspaceIdentifier)(E.openedWorkspace)?E.openedWorkspace:void 0,folderUri:(0,g.isSingleFolderWorkspaceIdentifier)(E.openedWorkspace)?E.openedWorkspace.uri:void 0,backupPath:E.backupPath,remoteAuthority:E.remoteAuthority,uiState:E.serializeWindowState()}}getNewWindowState(E){const M=this.s(E),t=this.k.getValue("window");if(M.mode===3){let a;M.hasDefaultState?a=!!(t?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(t.newWindowDimensions)>=0):a=!!(this.i.wasRestarted||t?.restoreFullscreen),a||(M.mode=1)}return M}s(E){const M=this.g.getLastActiveWindow();if(!E.extensionTestsPath){if(!!E.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const l=E.workspace;if((0,g.isWorkspaceIdentifier)(l)){const d=this.state.openedWindows.filter(S=>S.workspace&&S.workspace.id===l.id).map(S=>S.uiState);if(d.length)return d[0]}if((0,g.isSingleFolderWorkspaceIdentifier)(l)){const d=this.state.openedWindows.filter(S=>S.folderUri&&C.extUriBiasedIgnorePathCase.isEqual(S.folderUri,l.uri)).map(S=>S.uiState);if(d.length)return d[0]}else if(E.backupPath){const d=this.state.openedWindows.filter(S=>S.backupPath===E.backupPath).map(S=>S.uiState);if(d.length)return d[0]}const s=this.c||this.state.lastActiveWindow;if(!M&&s)return s.uiState}let t;const a=I.screen.getAllDisplays();if(a.length===1)t=a[0];else{if(n.isMacintosh){const l=I.screen.getCursorScreenPoint();t=I.screen.getDisplayNearestPoint(l)}!t&&M&&(t=I.screen.getDisplayMatching(M.getBounds())),t||(t=I.screen.getPrimaryDisplay()||a[0])}let i=(0,y.defaultWindowState)();i.x=Math.round(t.bounds.x+t.bounds.width/2-i.width/2),i.y=Math.round(t.bounds.y+t.bounds.height/2-i.height/2);const r=this.k.getValue("window");let c=!0;if(r?.newWindowDimensions){if(r.newWindowDimensions==="maximized")i.mode=0,c=!1;else if(r.newWindowDimensions==="fullscreen")i.mode=3,c=!1;else if((r.newWindowDimensions==="inherit"||r.newWindowDimensions==="offset")&&M){const l=M.serializeWindowState();l.mode===3?i.mode=3:i=l,c=i.mode!==3&&r.newWindowDimensions==="offset"}}return c&&(i=this.t(i)),i.hasDefaultState=!0,i}t(E){if(this.g.getWindows().length===0)return E;E.x=typeof E.x=="number"?E.x:0,E.y=typeof E.y=="number"?E.y:0;const M=this.g.getWindows().map(t=>t.getBounds());for(;M.some(t=>t.x===E.x||t.y===E.y);)E.x+=30,E.y+=30;return E}};m.a="windowsState",m=ve([_(0,v.IWindowsMainService),_(1,b.IStateMainService),_(2,f.ILifecycleMainService),_(3,h.ILogService),_(4,P.IConfigurationService)],m),e.WindowsStateHandler=m;function w(k){const E={openedWindows:[]},M=k||{openedWindows:[]};return M.lastActiveWindow&&(E.lastActiveWindow=o(M.lastActiveWindow)),M.lastPluginDevelopmentHostWindow&&(E.lastPluginDevelopmentHostWindow=o(M.lastPluginDevelopmentHostWindow)),Array.isArray(M.openedWindows)&&(E.openedWindows=M.openedWindows.map(t=>o(t))),E}e.restoreWindowsState=w;function o(k){const E={uiState:k.uiState};return k.backupPath&&(E.backupPath=k.backupPath),k.remoteAuthority&&(E.remoteAuthority=k.remoteAuthority),k.folder&&(E.folderUri=D.URI.parse(k.folder)),k.workspaceIdentifier&&(E.workspace={id:k.workspaceIdentifier.id,configPath:D.URI.parse(k.workspaceIdentifier.configURIPath)}),E}function u(k){return{lastActiveWindow:k.lastActiveWindow&&p(k.lastActiveWindow),lastPluginDevelopmentHostWindow:k.lastPluginDevelopmentHostWindow&&p(k.lastPluginDevelopmentHostWindow),openedWindows:k.openedWindows.map(E=>p(E))}}e.getWindowsStateStoreData=u;function p(k){return{workspaceIdentifier:k.workspace&&{id:k.workspace.id,configURIPath:k.workspace.configPath.toString()},folder:k.folderUri&&k.folderUri.toString(),backupPath:k.backupPath,remoteAuthority:k.remoteAuthority,uiState:k.uiState}}}),define(ee[97],te([0,1,32,43,125,45,15,9,4,18,7,6,56,29]),function(G,e,I,A,n,C,D,P,f,h,b,v,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,v.createDecorator)("workspacesService");function m(S){return S.hasOwnProperty("workspace")}e.isRecentWorkspace=m;function w(S){return S.hasOwnProperty("folderUri")}e.isRecentFolder=w;function o(S){return S.hasOwnProperty("fileUri")}e.isRecentFile=o;function u(S){return p(S)||k(S)}e.isStoredWorkspaceFolder=u;function p(S){const R=S;return typeof R?.path=="string"&&(!R.name||typeof R.name=="string")}function k(S){const R=S;return typeof R?.uri=="string"&&(!R.name||typeof R.name=="string")}function E(S,R,O,N,K){if(S.scheme!==N.scheme)return{name:O,uri:S.toString(!0)};let V=R?void 0:K.relativePath(N,S);if(V!==void 0)V.length===0?V=".":f.isWindows&&(V=M(V));else if(S.scheme===D.Schemas.file)V=S.fsPath,f.isWindows&&(V=M(V));else if(K.isEqualAuthority(S.authority,N.authority))V=S.path;else return{name:O,uri:S.toString(!0)};return{name:O,path:V}}e.getStoredWorkspaceFolder=E;function M(S){return S=(0,C.normalizeDriveLetter)(S),(0,I.isUNC)(S)||(S=(0,I.toSlashes)(S)),S}function t(S,R,O){const N=[],K=new Set,V=O.dirname(R);for(const X of S){let ie;if(p(X))X.path&&(ie=O.resolvePath(V,X.path));else if(k(X))try{ie=b.URI.parse(X.uri),ie.path[0]!==P.posix.sep&&(ie=ie.with({path:P.posix.sep+ie.path}))}catch(re){console.warn(re)}if(ie){const re=O.getComparisonKey(ie);if(!K.has(re)){K.add(re);const ce=X.name||O.basenameOrAuthority(ie);N.push(new g.WorkspaceFolder({uri:ie,name:ce,index:N.length},X))}}}return N}e.toWorkspaceFolders=t;function a(S,R,O,N,K){const V=i(R,S),X=K.dirname(R),ie=K.dirname(N),re=[];for(const x of V.folders){const F=p(x)?K.resolvePath(X,x.path):b.URI.parse(x.uri);let W;O?W=!1:W=!p(x)||(0,P.isAbsolute)(x.path),re.push(E(F,W,x.name,ie,K))}const ce={insertSpaces:!1,tabSize:4,eol:f.isLinux||f.isMacintosh?`
`:`\r
`},fe=n.setProperty(S,["folders"],re,ce);let ge=n.applyEdits(S,fe);return(0,h.isEqualAuthority)(V.remoteAuthority,(0,y.getRemoteAuthority)(N))&&(ge=n.applyEdits(ge,n.removeProperty(ge,["remoteAuthority"],ce))),ge}e.rewriteWorkspaceFileForNewLocation=a;function i(S,R){const O=A.parse(R);if(O&&Array.isArray(O.folders))O.folders=O.folders.filter(N=>u(N));else throw new Error(`${S} looks like an invalid workspace file.`);return O}function r(S){return S.workspace&&typeof S.workspace=="object"&&typeof S.workspace.id=="string"&&typeof S.workspace.configPath=="string"}function c(S){return typeof S.folderUri=="string"}function l(S){return typeof S.fileUri=="string"}function s(S,R){const O={workspaces:[],files:[]};if(S){const N=function(V,X){for(let ie=0;ie<V.length;ie++)try{X(V[ie],ie)}catch(re){R.warn(`Error restoring recent entry ${JSON.stringify(V[ie])}: ${re.toString()}. Skip entry.`)}},K=S;Array.isArray(K.entries)&&N(K.entries,V=>{const X=V.label,ie=V.remoteAuthority;r(V)?O.workspaces.push({label:X,remoteAuthority:ie,workspace:{id:V.workspace.id,configPath:b.URI.parse(V.workspace.configPath)}}):c(V)?O.workspaces.push({label:X,remoteAuthority:ie,folderUri:b.URI.parse(V.folderUri)}):l(V)&&O.files.push({label:X,remoteAuthority:ie,fileUri:b.URI.parse(V.fileUri)})})}return O}e.restoreRecentlyOpened=s;function d(S){const R={entries:[]};for(const O of S.workspaces)w(O)?R.entries.push({folderUri:O.folderUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority}):R.entries.push({workspace:{id:O.workspace.id,configPath:O.workspace.configPath.toString()},label:O.label,remoteAuthority:O.remoteAuthority});for(const O of S.files)R.entries.push({fileUri:O.fileUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority});return R}e.toStoreData=d}),define(ee[98],te([0,1,81,15,4,18]),function(G,e,I,A,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function D(h){function b(){let v=h.scheme===A.Schemas.file?(0,C.originalFSPath)(h):h.toString();return n.isLinux||(v=v.toLowerCase()),(0,I.createHash)("md5").update(v).digest("hex")}return{id:b(),configPath:h}}e.getWorkspaceIdentifier=D;function P(h,b){function v(){if(h.scheme!==A.Schemas.file)return(0,I.createHash)("md5").update(h.toString()).digest("hex");if(!b)return;let g;return n.isLinux?g=b.ino:n.isMacintosh?g=b.birthtime.getTime():n.isWindows&&(typeof b.birthtimeMs=="number"?g=Math.floor(b.birthtimeMs):g=b.birthtime.getTime()),(0,I.createHash)("md5").update(h.fsPath).update(g?String(g):"").digest("hex")}const y=v();if(typeof y=="string")return{id:y,uri:h}}e.getSingleFolderWorkspaceIdentifier=P;function f(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=f}),define(ee[274],te([0,1,81,32,15,9,4,18,23,183,19,28,34,16,5,182,29,98]),function(G,e,I,A,n,C,D,P,f,h,b,v,y,g,m,w,o,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let p=class vt{constructor(E,M,t,a){this.j=E,this.k=M,this.l=t,this.m=a,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=P.extUriBiasedIgnorePathCase,this.i={isEqual:(i,r)=>(0,A.isEqual)(i,r,!D.isLinux)}}async initialize(){const E=this.m.getItem(vt.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(E.emptyWindows),this.d=await this.u((0,h.deserializeWorkspaceInfos)(E)),this.e=await this.v((0,h.deserializeFolderInfos)(E)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==g.HotExitConfiguration.OFF}q(){return this.s()===g.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||g.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(E,M){this.d.some(a=>E.workspace.id===a.workspace.id)||(this.d.push(E),this.C());const t=(0,C.join)(this.c,E.workspace.id);return M?this.t(t,M).then(()=>t):t}async t(E,M){if(await f.Promises.exists(E)&&await this.z(E),await f.Promises.exists(M))try{await f.Promises.rename(M,E)}catch(t){this.l.error(`Backup: Could not move backup folder to new location: ${t.toString()}`)}}registerFolderBackup(E){return this.e.some(M=>this.h.isEqual(E.folderUri,M.folderUri))||(this.e.push(E),this.C()),(0,C.join)(this.c,this.D(E))}registerEmptyWindowBackup(E){return this.g.some(M=>!!M.backupFolder&&this.i.isEqual(M.backupFolder,E.backupFolder))||(this.g.push(E),this.C()),(0,C.join)(this.c,E.backupFolder)}async u(E){if(!Array.isArray(E))return[];const M=new Set,t=[];for(const a of E){const i=a.workspace;if(!(0,o.isWorkspaceIdentifier)(i))return[];if(!M.has(i.id)){M.add(i.id);const r=(0,C.join)(this.c,i.id);await this.B(r)?i.configPath.scheme!==n.Schemas.file||await f.Promises.exists(i.configPath.fsPath)?t.push(a):await this.z(r):await this.x(r)}}return t}async v(E){if(!Array.isArray(E))return[];const M=[],t=new Set;for(const a of E){const i=a.folderUri,r=this.h.getComparisonKey(i);if(!t.has(r)){t.add(r);const c=(0,C.join)(this.c,this.D(a));await this.B(c)?i.scheme!==n.Schemas.file||await f.Promises.exists(i.fsPath)?M.push(a):await this.z(c):await this.x(c)}}return M}async w(E){if(!Array.isArray(E))return[];const M=[],t=new Set;for(const a of E){const i=a.backupFolder;if(typeof i!="string")return[];if(!t.has(i)){t.add(i);const r=(0,C.join)(this.c,i);await this.B(r)?M.push(a):await this.x(r)}}return M}async x(E){try{await f.Promises.rm(E,f.RimRafMode.MOVE)}catch(M){this.l.error(`Backup: Could not delete stale backup: ${M.toString()}`)}}y(){let E=(0,u.createEmptyWorkspaceIdentifier)();for(;this.g.some(M=>!!M.backupFolder&&this.i.isEqual(M.backupFolder,E.id));)E=(0,u.createEmptyWorkspaceIdentifier)();return{backupFolder:E.id}}async z(E){const M=this.y(),t=(0,C.join)(this.c,M.backupFolder);try{await f.Promises.rename(E,t)}catch(a){return this.l.error(`Backup: Could not rename backup folder: ${a.toString()}`),!1}return this.g.push(M),!0}async getDirtyWorkspaces(){const E=[];for(const M of this.d)await this.A(M)&&E.push(M);for(const M of this.e)await this.A(M)&&E.push(M);return E}A(E){let M;return(0,h.isEmptyWindowBackupInfo)(E)?M=(0,C.join)(this.c,E.backupFolder):(0,w.isFolderBackupInfo)(E)?M=(0,C.join)(this.c,this.D(E)):M=(0,C.join)(this.c,E.workspace.id),this.B(M)}async B(E){try{const M=await f.Promises.readdir(E);for(const t of M)try{if((await f.Promises.readdir((0,C.join)(E,t))).length>0)return!0}catch{}}catch{}return!1}C(){const E={workspaces:this.d.map(({workspace:M,remoteAuthority:t})=>{const a={id:M.id,configURIPath:M.configPath.toString()};return t&&(a.remoteAuthority=t),a}),folders:this.e.map(({folderUri:M,remoteAuthority:t})=>{const a={folderUri:M.toString()};return t&&(a.remoteAuthority=t),a}),emptyWindows:this.g.map(({backupFolder:M,remoteAuthority:t})=>{const a={backupFolder:M};return t&&(a.remoteAuthority=t),a})};this.m.setItem(vt.a,E)}D(E){const M=E.folderUri;let t;return M.scheme===n.Schemas.file?t=D.isLinux?M.fsPath:M.fsPath.toLowerCase():t=M.toString().toLowerCase(),(0,I.createHash)("md5").update(t).digest("hex")}};p.a="backupWorkspaces",p=ve([_(0,v.IEnvironmentMainService),_(1,b.IConfigurationService),_(2,m.ILogService),_(3,y.IStateMainService)],p),e.BackupMainService=p}),define(ee[54],te([0,1,14,3,43,2,15,9,18,10,23,181,63,48,58,28,6,5,20,53,120,29,97,98]),function(G,e,I,A,n,C,D,P,f,h,b,v,y,g,m,w,o,u,p,k,E,M,t,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,o.createDecorator)("workspacesManagementMainService");let i=class extends C.Disposable{constructor(c,l,s,d,S,R){super(),this.g=c,this.h=l,this.i=s,this.j=d,this.k=S,this.l=R,this.a=this.B(new A.Emitter),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new A.Emitter),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const c=(await b.Promises.readdir(this.c.fsPath)).map(l=>(0,f.joinPath)(this.c,l,M.UNTITLED_WORKSPACE_NAME));for(const l of c){const s=(0,a.getWorkspaceIdentifier)(l),d=await this.resolveLocalWorkspace(l);d?this.f.push({workspace:s,remoteAuthority:d.remoteAuthority}):await this.deleteUntitledWorkspace(s)}}catch(c){c.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${c}).`)}}resolveLocalWorkspace(c){return this.m(c,l=>b.Promises.readFile(l,"utf8"))}m(c,l){if(!!this.n(c)&&c.scheme===D.Schemas.file)try{const s=l(c.fsPath);return s instanceof Promise?s.then(d=>this.p(c,d),d=>{}):this.p(c,s)}catch{return}}n(c){return(0,M.isUntitledWorkspace)(c,this.g)||(0,M.hasWorkspaceFileExtension)(c)}p(c,l){try{const s=this.r(c,l),d=(0,a.getWorkspaceIdentifier)(c);return{id:d.id,configPath:d.configPath,folders:(0,t.toWorkspaceFolders)(s.folders,d.configPath,f.extUriBiasedIgnorePathCase),remoteAuthority:s.remoteAuthority,transient:s.transient}}catch(s){this.h.warn(s.toString())}}r(c,l){const s=(0,n.parse)(l);if(s&&Array.isArray(s.folders))s.folders=s.folders.filter(d=>(0,t.isStoredWorkspaceFolder)(d));else throw new Error(`${c.toString(!0)} looks like an invalid workspace file.`);return s}async createUntitledWorkspace(c,l){const{workspace:s,storedWorkspace:d}=this.s(c,l),S=s.configPath.fsPath;return await b.Promises.mkdir((0,P.dirname)(S),{recursive:!0}),await b.Promises.writeFile(S,JSON.stringify(d,null,"	")),this.f.push({workspace:s,remoteAuthority:l}),s}s(c=[],l){const s=(Date.now()+Math.round(Math.random()*1e3)).toString(),d=(0,f.joinPath)(this.c,s),S=(0,f.joinPath)(d,M.UNTITLED_WORKSPACE_NAME),R=[];for(const O of c)R.push((0,t.getStoredWorkspaceFolder)(O.uri,!0,O.name,d,f.extUriBiasedIgnorePathCase));return{workspace:(0,a.getWorkspaceIdentifier)(S),storedWorkspace:{folders:R,remoteAuthority:l}}}async getWorkspaceIdentifier(c){return(0,a.getWorkspaceIdentifier)(c)}isUntitledWorkspace(c){return(0,M.isUntitledWorkspace)(c.configPath,this.g)}async deleteUntitledWorkspace(c){!this.isUntitledWorkspace(c)||(await this.t(c),this.i.isEnabled()&&this.i.unsetWorkspace(c),this.a.fire(c))}async t(c){const l=(0,f.originalFSPath)(c.configPath);try{await b.Promises.rm((0,P.dirname)(l));const s=(0,P.join)(this.g.workspaceStorageHome.fsPath,c.id);await b.Promises.exists(s)&&await b.Promises.writeFile((0,P.join)(s,"obsolete"),""),this.f=this.f.filter(d=>d.workspace.id!==c.id)}catch(s){this.h.warn(`Unable to delete untitled workspace ${l} (${s}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(c,l,s){if(!c||!c.win||!c.isReady||!await this.u(c,l,s))return;const S=await this.v(c,(0,a.getWorkspaceIdentifier)(s));if(!!S)return this.b.fire({window:c,workspace:S.workspace}),S}async u(c,l,s){return s?(0,M.isWorkspaceIdentifier)(c.openedWorkspace)&&f.extUriBiasedIgnorePathCase.isEqual(c.openedWorkspace.configPath,s)?!1:(0,E.findWindowOnWorkspaceOrFolder)(l,s)?(await this.k.showMessageBox((0,g.massageMessageBoxOptions)({type:"info",buttons:[(0,v.localize)(0,null)],message:(0,v.localize)(1,null,(0,f.basename)(s)),detail:(0,v.localize)(2,null)},this.l).options,(0,h.withNullAsUndefined)(I.BrowserWindow.getFocusedWindow())),!1):!0:!0}async v(c,l){if(!c.config)return;c.focus();let s;return c.config.extensionDevelopmentPath||(c.config.backupPath?s=await this.j.registerWorkspaceBackup({workspace:l,remoteAuthority:c.remoteAuthority},c.config.backupPath):s=this.j.registerWorkspaceBackup({workspace:l,remoteAuthority:c.remoteAuthority})),(0,M.isWorkspaceIdentifier)(c.openedWorkspace)&&this.isUntitledWorkspace(c.openedWorkspace)&&await this.deleteUntitledWorkspace(c.openedWorkspace),c.config.workspace=l,c.config.backupPath=s,{workspace:l,backupPath:s}}};i=ve([_(0,w.IEnvironmentMainService),_(1,u.ILogService),_(2,k.IUserDataProfilesMainService),_(3,y.IBackupMainService),_(4,m.IDialogMainService),_(5,p.IProductService)],i),e.WorkspacesManagementMainService=i}),define(ee[121],te([0,1,14,42,22,6,30,29,54,10,5]),function(G,e,I,A,n,C,D,P,f,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,C.createDecorator)(e.ID);let v=class{constructor(g,m,w){this.a=g,this.b=m,this.c=w}async getRemoteDiagnostics(g){const m=this.a.getWindows();return(await Promise.all(m.map(async o=>{const u=o.remoteAuthority;if(!u)return;const p=`vscode:getDiagnosticInfoResponse${o.id}`,k={includeProcesses:g.includeProcesses,folders:g.includeWorkspaceMetadata?await this.f(o):void 0};return new Promise(E=>{o.sendWhenReady("vscode:getDiagnosticInfo",n.CancellationToken.None,{replyChannel:p,args:k}),A.validatedIpcMain.once(p,(M,t)=>{t||E({hostName:u,errorMessage:`Unable to resolve connection to '${u}'.`}),E(t)}),setTimeout(()=>{E({hostName:u,errorMessage:`Connection to '${u}' could not be established`})},5e3)})}))).filter(o=>!!o)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const g=[];for(const m of I.BrowserWindow.getAllWindows()){const w=this.a.getWindowById(m.id);w?g.push(await this.d(w)):g.push(this.e(m))}return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:g,screenReader:!!I.app.accessibilitySupportEnabled,gpuFeatureStatus:I.app.getGPUFeatureStatus()}}async d(g){const m=await this.f(g),w=(0,h.assertIsDefined)(g.win);return this.e(w,m,g.remoteAuthority)}e(g,m=[],w){return{pid:g.webContents.getOSProcessId(),title:g.getTitle(),folderURIs:m,remoteAuthority:w}}async f(g){const m=[],w=g.openedWorkspace;if((0,P.isSingleFolderWorkspaceIdentifier)(w))m.push(w.uri);else if((0,P.isWorkspaceIdentifier)(w)){const o=await this.b.resolveLocalWorkspace(w.configPath);o&&o.folders.forEach(p=>{m.push(p.uri)})}return m}};v=ve([_(0,D.IWindowsMainService),_(1,f.IWorkspacesManagementMainService),_(2,b.ILogService)],v),e.DiagnosticsMainService=v}),define(ee[59],te([0,1,46,14,26,146,55,3,2,15,9,4,7,102,85,23,100,171,48,58,28,6,21,5,20,69,30,29,54,17,230,223,34]),function(G,e,I,A,n,C,D,P,f,h,b,v,y,g,m,w,o,u,p,k,E,M,t,a,i,r,c,l,s,d,S,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,M.createDecorator)("nativeHostMainService");let N=class extends f.Disposable{constructor(V,X,ie,re,ce,fe,ge,x,F,W){super(),this.a=V,this.b=X,this.c=ie,this.f=re,this.g=ce,this.h=fe,this.i=ge,this.j=x,this.k=F,this.l=W,this.onDidOpenWindow=P.Event.map(this.b.onDidOpenWindow,z=>z.id),this.onDidTriggerSystemContextMenu=P.Event.filter(P.Event.map(this.b.onDidTriggerSystemContextMenu,({window:z,x:J,y:ne})=>({windowId:z.id,x:J,y:ne})),({windowId:z})=>!!this.b.getWindowById(z)),this.onDidMaximizeWindow=P.Event.filter(P.Event.fromNodeEventEmitter(A.app,"browser-window-maximize",(z,J)=>J.id),z=>!!this.b.getWindowById(z)),this.onDidUnmaximizeWindow=P.Event.filter(P.Event.fromNodeEventEmitter(A.app,"browser-window-unmaximize",(z,J)=>J.id),z=>!!this.b.getWindowById(z)),this.onDidBlurWindow=P.Event.filter(P.Event.fromNodeEventEmitter(A.app,"browser-window-blur",(z,J)=>J.id),z=>!!this.b.getWindowById(z)),this.onDidFocusWindow=P.Event.any(P.Event.map(P.Event.filter(P.Event.map(this.b.onDidChangeWindowsCount,()=>this.b.getLastActiveWindow()),z=>!!z),z=>z.id),P.Event.filter(P.Event.fromNodeEventEmitter(A.app,"browser-window-focus",(z,J)=>J.id),z=>!!this.b.getWindowById(z))),this.onDidResumeOS=P.Event.fromNodeEventEmitter(A.powerMonitor,"resume"),this.onDidChangeColorScheme=this.j.onDidChangeColorScheme,this.m=this.B(new P.Emitter),this.onDidChangePassword=this.m.event,this.onDidChangeDisplay=P.Event.debounce(P.Event.any(P.Event.filter(P.Event.fromNodeEventEmitter(A.screen,"display-metrics-changed",(z,J,ne)=>ne),z=>!(Array.isArray(z)&&z.length===1&&z[0]==="workArea")),P.Event.fromNodeEventEmitter(A.screen,"display-added"),P.Event.fromNodeEventEmitter(A.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.b.getWindows().map(X=>({id:X.id,workspace:X.openedWorkspace??(0,l.toWorkspaceIdentifier)(X.backupPath,X.isExtensionDevelopmentHost),title:X.win?.getTitle()??"",filename:X.getRepresentedFilename(),dirty:X.isDocumentEdited()}))}async getWindowCount(V){return this.b.getWindowCount()}async getActiveWindowId(V){const X=A.BrowserWindow.getFocusedWindow()||this.b.getLastActiveWindow();if(X)return X.id}openWindow(V,X,ie){return Array.isArray(X)?this.n(V,X,ie):this.p(V,X)}async n(V,X,ie=Object.create(null)){X.length>0&&await this.b.open({context:5,contextWindowId:V,urisToOpen:X,cli:this.g.args,forceNewWindow:ie.forceNewWindow,forceReuseWindow:ie.forceReuseWindow,preferNewWindow:ie.preferNewWindow,diffMode:ie.diffMode,mergeMode:ie.mergeMode,addMode:ie.addMode,gotoLineMode:ie.gotoLineMode,noRecentEntry:ie.noRecentEntry,waitMarkerFileURI:ie.waitMarkerFileURI,remoteAuthority:ie.remoteAuthority||void 0,forceProfile:ie.forceProfile,forceTempProfile:ie.forceTempProfile})}async p(V,X){await this.b.openEmptyWindow({context:5,contextWindowId:V},X)}async toggleFullScreen(V){this.w(V)?.toggleFullScreen()}async handleTitleDoubleClick(V){this.w(V)?.handleTitleDoubleClick()}async isMaximized(V){const X=this.w(V);return X?.win?X.win.isMaximized():!1}async maximizeWindow(V){const X=this.w(V);X?.win&&X.win.maximize()}async unmaximizeWindow(V){const X=this.w(V);X?.win&&X.win.unmaximize()}async minimizeWindow(V){const X=this.w(V);X?.win&&X.win.minimize()}async updateWindowControls(V,X){const ie=this.w(V);ie&&ie.updateWindowControls(X)}async focusWindow(V,X){X&&typeof X.windowId=="number"&&(V=X.windowId),this.w(V)?.focus({force:X?.force??!1})}async setMinimumSize(V,X,ie){const re=this.w(V);if(re?.win){const[ce,fe]=re.win.getSize(),[ge,x]=re.win.getMinimumSize(),[F,W]=[X??ge,ie??x],[z,J]=[Math.max(ce,F),Math.max(fe,W)];(ge!==F||x!==W)&&re.win.setMinimumSize(F,W),(ce!==z||fe!==J)&&re.win.setSize(z,J)}}async saveWindowSplash(V,X){this.j.saveWindowSplash(V,X)}async installShellCommand(V){const{source:X,target:ie}=await this.r();try{const{symbolicLink:re}=await w.SymlinkSupport.stat(X);if(re&&!re.dangling){const ce=await(0,g.realpath)(X);if(ie===ce)return}await w.Promises.unlink(X)}catch(re){if(re.code!=="ENOENT")throw re}try{await w.Promises.symlink(ie,X)}catch(re){if(re.code!=="EACCES"&&re.code!=="ENOENT")throw re;const{options:ce,buttonIndeces:fe}=(0,p.massageMessageBoxOptions)({type:"info",message:(0,u.localize)(0,null,this.i.nameShort),buttons:[(0,u.localize)(1,null),(0,u.localize)(2,null)]},this.i),{response:ge}=await this.showMessageBox(V,ce);if(fe[ge]===0)try{const x=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${ie}' '${X}'\\" with administrator privileges"`;await(0,C.promisify)(I.exec)(x)}catch{throw new Error((0,u.localize)(3,null,X))}}}async uninstallShellCommand(V){const{source:X}=await this.r();try{await w.Promises.unlink(X)}catch(ie){switch(ie.code){case"EACCES":{const{options:re,buttonIndeces:ce}=(0,p.massageMessageBoxOptions)({type:"info",message:(0,u.localize)(4,null,this.i.nameShort),buttons:[(0,u.localize)(5,null),(0,u.localize)(6,null)]},this.i),{response:fe}=await this.showMessageBox(V,re);if(ce[fe]===0)try{const ge=`osascript -e "do shell script \\"rm '${X}'\\" with administrator privileges"`;await(0,C.promisify)(I.exec)(ge)}catch{throw new Error((0,u.localize)(7,null,X))}break}case"ENOENT":break;default:throw ie}}}async r(){const V=(0,b.resolve)(this.g.appRoot,"bin","code"),X=`/usr/local/bin/${this.i.applicationName}`;if(!await w.Promises.exists(V))throw new Error((0,u.localize)(8,null,V));return{source:X,target:V}}async showMessageBox(V,X){return this.c.showMessageBox(X,this.s(V))}async showSaveDialog(V,X){return this.c.showSaveDialog(X,this.s(V))}async showOpenDialog(V,X){return this.c.showOpenDialog(X,this.s(V))}s(V){const X=this.w(V);if(X?.win)return X.win}async pickFileFolderAndOpen(V,X){const ie=await this.c.pickFileFolder(X);ie&&await this.t(await Promise.all(ie.map(async re=>await w.SymlinkSupport.existsDirectory(re)?{folderUri:y.URI.file(re)}:{fileUri:y.URI.file(re)})),X,V)}async pickFolderAndOpen(V,X){const ie=await this.c.pickFolder(X);ie&&await this.t(ie.map(re=>({folderUri:y.URI.file(re)})),X,V)}async pickFileAndOpen(V,X){const ie=await this.c.pickFile(X);ie&&await this.t(ie.map(re=>({fileUri:y.URI.file(re)})),X,V)}async pickWorkspaceAndOpen(V,X){const ie=await this.c.pickWorkspace(X);ie&&await this.t(ie.map(re=>({workspaceUri:y.URI.file(re)})),X,V)}async t(V,X,ie){await this.b.open({context:3,contextWindowId:ie,cli:this.g.args,urisToOpen:V,forceNewWindow:X.forceNewWindow})}async showItemInFolder(V,X){A.shell.showItemInFolder(X)}async setRepresentedFilename(V,X){this.w(V)?.setRepresentedFilename(X)}async setDocumentEdited(V,X){this.w(V)?.setDocumentEdited(X)}async openExternal(V,X){return v.isLinuxSnap?this.u(X):A.shell.openExternal(X),!0}u(V){const X=process.env.GDK_PIXBUF_MODULE_FILE,ie=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,A.shell.openExternal(V),process.env.GDK_PIXBUF_MODULE_FILE=X,process.env.GDK_PIXBUF_MODULEDIR=ie}moveItemToTrash(V,X){return A.shell.trashItem(X)}async isAdmin(){let V;return v.isWindows?V=(await new Promise((X,ie)=>{G(["native-is-elevated"],X,ie)}))():V=process.getuid()===0,V}async writeElevated(V,X,ie,re){const ce=await new Promise((fe,ge)=>{G(["@vscode/sudo-prompt"],fe,ge)});return new Promise((fe,ge)=>{const x=[`"${this.v}"`];re?.unlock&&x.push("--file-chmod"),x.push("--file-write",`"${X.fsPath}"`,`"${ie.fsPath}"`);const F={name:this.i.nameLong.replace("-",""),icns:v.isMacintosh&&this.g.isBuilt?(0,b.join)((0,b.dirname)(this.g.appRoot),`${this.i.nameShort}.icns`):void 0};ce.exec(x.join(" "),F,(W,z,J)=>{z&&this.h.trace(`[sudo-prompt] received stdout: ${z}`),J&&this.h.trace(`[sudo-prompt] received stderr: ${J}`),W?ge(W):fe(void 0)})})}get v(){return v.isWindows?this.g.isBuilt?(0,b.join)((0,b.dirname)(process.execPath),"bin",`${this.i.applicationName}.cmd`):(0,b.join)(this.g.appRoot,"scripts","code-cli.bat"):v.isLinux?this.g.isBuilt?(0,b.join)((0,b.dirname)(process.execPath),"bin",`${this.i.applicationName}`):(0,b.join)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,b.join)(this.g.appRoot,"bin","code"):(0,b.join)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,n.totalmem)(),freemem:(0,n.freemem)(),loadavg:(0,n.loadavg)()}}async getOSProperties(){return{arch:(0,n.arch)(),platform:(0,n.platform)(),release:(0,n.release)(),type:(0,n.type)(),cpus:(0,n.cpus)()}}async getOSVirtualMachineHint(){return m.virtualMachineHint.value()}async getOSColorScheme(){return this.j.getColorScheme()}async hasWSLFeatureInstalled(){return v.isWindows&&(0,S.hasWSLFeatureInstalled)()}async killProcess(V,X,ie){process.kill(X,ie)}async readClipboardText(V,X){return A.clipboard.readText(X)}async writeClipboardText(V,X,ie){return A.clipboard.writeText(X,ie)}async readClipboardFindText(V){return A.clipboard.readFindText()}async writeClipboardFindText(V,X){return A.clipboard.writeFindText(X)}async writeClipboardBuffer(V,X,ie,re){return A.clipboard.writeBuffer(X,Buffer.from(ie.buffer),re)}async readClipboardBuffer(V,X){return d.VSBuffer.wrap(A.clipboard.readBuffer(X))}async hasClipboard(V,X,ie){return A.clipboard.has(X,ie)}async newWindowTab(){await this.b.open({context:5,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){A.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){A.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){A.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){A.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){A.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(V,X){this.w(V)?.updateTouchBar(X)}async notifyReady(V){this.w(V)?.setReady()}async relaunch(V,X){return this.f.relaunch(X)}async reload(V,X){const ie=this.w(V);if(ie){if((0,l.isWorkspaceIdentifier)(ie.openedWorkspace)){const re=ie.openedWorkspace.configPath;if(re.scheme===h.Schemas.file&&(await this.l.resolveLocalWorkspace(re))?.transient)return this.openWindow(ie.id,{forceReuseWindow:!0})}return this.f.reload(ie,X?.disableExtensions!==void 0?{_:[],"disable-extensions":X.disableExtensions}:void 0)}}async closeWindow(V){this.closeWindowById(V,V)}async closeWindowById(V,X){const ie=this.w(X);if(ie?.win)return ie.win.close()}async quit(V){const X=this.b.getLastActiveWindow();X?.isExtensionDevelopmentHost&&this.b.getWindowCount()>1&&X.win?X.win.close():this.f.quit()}async exit(V,X){await this.f.kill(X)}async resolveProxy(V,X){const re=this.w(V)?.win?.webContents?.session;if(re)return re.resolveProxy(X)}findFreePort(V,X,ie,re,ce=1){return(0,o.findFreePort)(X,ie,re,ce)}async openDevTools(V,X){const ie=this.w(V);ie?.win&&ie.win.webContents.openDevTools(X)}async toggleDevTools(V){const X=this.w(V);X?.win&&X.win.webContents.toggleDevTools()}async sendInputEvent(V,X){const ie=this.w(V);ie?.win&&(X.type==="mouseDown"||X.type==="mouseUp")&&ie.win.webContents.sendInputEvent(X)}async enableSandbox(V,X){X?this.k.setItem("window.experimental.useSandbox",!0):this.k.removeItem("window.experimental.useSandbox")}async toggleSharedProcessWindow(){return this.a.toggle()}async profileRenderer(V,X,ie){const re=this.w(V);if(!re||!re.win)throw new Error;return await new R.WindowProfiler(re.win,X,this.h).inspect(ie)}async windowsGetStringRegKey(V,X,ie,re){if(!v.isWindows)return;const ce=await new Promise((fe,ge)=>{G(["@vscode/windows-registry"],fe,ge)});try{return ce.GetStringRegKey(X,ie,re)}catch{return}}w(V){if(typeof V=="number")return this.b.getWindowById(V)}};ve([D.memoize],N.prototype,"v",null),N=ve([_(1,c.IWindowsMainService),_(2,k.IDialogMainService),_(3,t.ILifecycleMainService),_(4,E.IEnvironmentMainService),_(5,a.ILogService),_(6,i.IProductService),_(7,r.IThemeMainService),_(8,O.IStateMainService),_(9,s.IWorkspacesManagementMainService)],N),e.NativeHostMainService=N}),define(ee[275],te([0,1,14,42,26,2,15,4,103,169,88,121,58,28,6,5,59,66,20,67,77,32,10,34,48]),function(G,e,I,A,n,C,D,P,f,h,b,v,y,g,m,w,o,u,p,k,E,M,t,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,m.createDecorator)("issueMainService");const r="issue.processExplorerWindowState";let c=class kt{constructor(d,S,R,O,N,K,V,X,ie,re){this.g=d,this.h=S,this.i=R,this.j=O,this.k=N,this.l=K,this.m=V,this.n=X,this.o=ie,this.p=re,this.b=null,this.c=null,this.d=null,this.f=null,this.q()}q(){A.validatedIpcMain.on("vscode:issueSystemInfoRequest",async d=>{const[S,R]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),O=await this.j.getSystemInfo(S,R);this.r(d,"vscode:issueSystemInfoResponse",O)}),A.validatedIpcMain.on("vscode:listProcesses",async d=>{const S=[];try{S.push({name:(0,h.localize)(0,null),rootProcess:await(0,f.listProcesses)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(O=>{(0,b.isRemoteDiagnosticError)(O)?S.push({name:O.hostName,rootProcess:O}):O.processes&&S.push({name:O.hostName,rootProcess:O.processes})})}catch(R){this.i.error(`Listing processes failed: ${R}`)}this.r(d,"vscode:listProcessesResponse",S)}),A.validatedIpcMain.on("vscode:issueReporterClipboard",async d=>{if(this.b){const{options:S,buttonIndeces:R}=(0,i.massageMessageBoxOptions)({message:(0,h.localize)(1,null),type:"warning",buttons:[(0,h.localize)(2,null),(0,h.localize)(3,null)]},this.o),O=await this.l.showMessageBox(S,this.b);this.r(d,"vscode:issueReporterClipboardResponse",R[O.response]===0)}}),A.validatedIpcMain.on("vscode:issuePerformanceInfoRequest",async d=>{const S=await this.v();this.r(d,"vscode:issuePerformanceInfoResponse",S)}),A.validatedIpcMain.on("vscode:issueReporterConfirmClose",async()=>{if(this.b){const{options:d,buttonIndeces:S}=(0,i.massageMessageBoxOptions)({message:(0,h.localize)(4,null),type:"warning",buttons:[(0,h.localize)(5,null),(0,h.localize)(6,null)]},this.o),R=await this.l.showMessageBox(d,this.b);S[R.response]===0&&this.b&&(this.b.destroy(),this.b=null)}}),A.validatedIpcMain.on("vscode:workbenchCommand",(d,S)=>{const{id:R,from:O,args:N}=S;let K;switch(O){case"issueReporter":K=this.c;break;case"processExplorer":K=this.f;break;default:throw new Error(`Unexpected command source: ${O}`)}K?.webContents.send("vscode:runAction",{id:R,from:O,args:N})}),A.validatedIpcMain.on("vscode:openExternal",(d,S)=>{this.m.openExternal(void 0,S)}),A.validatedIpcMain.on("vscode:closeIssueReporter",d=>{this.b?.close()}),A.validatedIpcMain.on("vscode:closeProcessExplorer",d=>{this.d?.close()}),A.validatedIpcMain.on("vscode:windowsInfoRequest",async d=>{const S=await this.k.getMainDiagnostics();this.r(d,"vscode:windowsInfoResponse",S.windows)})}r(d,S,...R){d.sender.isDestroyed()||d.sender.send(S,...R)}async openReporter(d){if(!this.b&&(this.c=I.BrowserWindow.getFocusedWindow(),this.c)){const S=new C.DisposableStore,R=S.add(this.n.createIPCObjectUrl()),O=this.u(this.c,700,800);this.b=this.t(O,R,{backgroundColor:d.styles.backgroundColor,title:(0,h.localize)(7,null),zoomLevel:d.zoomLevel,alwaysOnTop:!1},"issue-reporter"),R.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:d,disableExtensions:!!this.h.disableExtensions,os:{type:(0,n.type)(),arch:(0,n.arch)(),release:(0,n.release)()},product:u.default}),this.b.loadURL(D.FileAccess.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,S.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,S.dispose())})}this.b&&this.s(this.b)}async openProcessExplorer(d){if(!this.d&&(this.f=I.BrowserWindow.getFocusedWindow(),this.f)){const S=new C.DisposableStore,R=S.add(this.n.createIPCObjectUrl()),O=this.p.getItem(r,void 0),N=l(O)?O:this.u(this.f,800,500),K=I.screen.getDisplayNearestPoint({x:N.x,y:N.y});N.width/=K.scaleFactor,N.height/=K.scaleFactor,this.d=this.t(N,R,{backgroundColor:d.styles.backgroundColor,title:(0,h.localize)(8,null),zoomLevel:d.zoomLevel,alwaysOnTop:!0},"process-explorer"),R.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:d,product:u.default}),this.d.loadURL(D.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,S.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,S.dispose())});const V=()=>{if(!this.d)return;const X=this.d.getSize(),ie=this.d.getPosition();if(!X||!ie)return;const re={width:X[0],height:X[1],x:ie[0],y:ie[1]};this.p.setItem(r,re)};this.d.on("moved",V),this.d.on("resized",V)}this.d&&this.s(this.d)}s(d){d.isMinimized()&&d.restore(),d.focus()}t(d,S,R,O){const N=new I.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:d.width,height:d.height,minWidth:300,minHeight:200,x:d.x,y:d.y,title:R.title,backgroundColor:R.backgroundColor||kt.a,webPreferences:{preload:D.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${S.resource.toString()}`,`--vscode-window-kind=${O}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,E.zoomLevelToZoomFactor)(R.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:R.alwaysOnTop,experimentalDarkMode:!0});return N.setMenuBarVisibility(!1),N}async getSystemStatus(){const[d,S]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(d,S)}u(d,S,R){let O;const N=I.screen.getAllDisplays();if(N.length===1)O=N[0];else{if(P.isMacintosh){const X=I.screen.getCursorScreenPoint();O=I.screen.getDisplayNearestPoint(X)}!O&&d&&(O=I.screen.getDisplayMatching(d.getBounds())),O||(O=I.screen.getPrimaryDisplay()||N[0])}const K=O.bounds,V={width:S,height:R,x:K.x+K.width/2-S/2,y:K.y+K.height/2-R/2};return K.width>0&&K.height>0&&(V.x<K.x&&(V.x=K.x),V.y<K.y&&(V.y=K.y),V.x>K.x+K.width&&(V.x=K.x),V.y>K.y+K.height&&(V.y=K.y),V.width>K.width&&(V.width=K.width),V.height>K.height&&(V.height=K.height)),V}async v(){try{const[d,S]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(d,S)}catch(d){throw this.i.warn("issueService#getPerformanceInfo ",d.message),d}}async stopTracing(){if(!this.h.args.trace)return;const d=await I.contentTracing.stopRecording(`${(0,M.randomPath)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`),{options:S}=(0,i.massageMessageBoxOptions)({type:"info",message:(0,h.localize)(9,null),detail:(0,h.localize)(10,null,d),buttons:[(0,h.localize)(11,null)]},this.o);await this.l.showMessageBox(S,(0,t.withNullAsUndefined)(I.BrowserWindow.getFocusedWindow())),this.m.showItemInFolder(void 0,d)}};c.a="#1E1E1E",c=ve([_(1,g.IEnvironmentMainService),_(2,w.ILogService),_(3,b.IDiagnosticsService),_(4,v.IDiagnosticsMainService),_(5,y.IDialogMainService),_(6,o.INativeHostMainService),_(7,k.IProtocolMainService),_(8,p.IProductService),_(9,a.IStateMainService)],c),e.IssueMainService=c;function l(s){return typeof s!="object"||s===null?!1:"x"in s&&"y"in s&&"width"in s&&"height"in s}}),define(ee[276],te([0,1,22,19,28,21,5,59,20,57,24,49,94]),function(G,e,I,A,n,C,D,P,f,h,b,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let g=class extends y.AbstractUpdateService{constructor(w,o,u,p,k,E,M,t){super(w,o,p,k,E,t),this.e=u,this.t=M}r(w){return(0,y.createUpdateURL)(`linux-${process.arch}`,w,this.k)}s(w){!this.a||(this.d(v.State.CheckingForUpdates(w)),this.i.request({url:this.a},I.CancellationToken.None).then(h.asJson).then(o=>{!o||!o.url||!o.version||!o.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!w}),this.d(v.State.Idle(1))):this.d(v.State.AvailableForDownload(o))}).then(void 0,o=>{this.j.error(o),this.e.publicLog2("update:notAvailable",{explicit:!!w});const u=w?o.message||o:void 0;this.d(v.State.Idle(1,u))}))}async n(w){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.t.openExternal(void 0,this.k.downloadUrl):w.update.url&&this.t.openExternal(void 0,w.update.url),this.d(v.State.Idle(1))}};g=ve([_(0,C.ILifecycleMainService),_(1,A.IConfigurationService),_(2,b.ITelemetryService),_(3,n.IEnvironmentMainService),_(4,h.IRequestService),_(5,D.ILogService),_(6,P.INativeHostMainService),_(7,f.IProductService)],g),e.LinuxUpdateService=g}),define(ee[277],te([0,1,46,41,26,8,22,55,9,7,132,23,19,28,16,21,5,59,20,57,24,49,94]),function(G,e,I,A,n,C,D,P,f,h,b,v,y,g,m,w,o,u,p,k,E,M,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function a(l,s=1e3){for(;!l();)await(0,C.timeout)(s)}let i;function r(){return typeof i>"u"&&(i=A.existsSync(f.join(f.dirname(process.execPath),"unins000.exe"))?0:1),i}let c=class extends t.AbstractUpdateService{get cachePath(){const s=f.join((0,n.tmpdir)(),`vscode-update-${this.k.target}-${process.arch}`);return v.Promises.mkdir(s,{recursive:!0}).then(()=>s)}constructor(s,d,S,R,O,N,K,V,X){super(s,d,R,O,N,X),this.t=S,this.u=K,this.v=V}async initialize(){if(this.k.target==="user"&&await this.v.isAdmin(void 0)){this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}super.initialize()}r(s){let d="win32";return process.arch!=="ia32"&&(d+=`-${process.arch}`),r()===1?d+="-archive":this.k.target==="user"&&(d+="-user"),(0,t.createUpdateURL)(d,s,this.k)}s(s){!this.a||(this.d(M.State.CheckingForUpdates(s)),this.i.request({url:this.a},D.CancellationToken.None).then(k.asJson).then(d=>{const S=r();return!d||!d.url||!d.version||!d.productVersion?(this.t.publicLog2("update:notAvailable",{explicit:!!s}),this.d(M.State.Idle(S)),Promise.resolve(null)):S===1?(this.d(M.State.AvailableForDownload(d)),Promise.resolve(null)):(this.d(M.State.Downloading(d)),this.A(d.version).then(()=>this.z(d.version).then(R=>v.Promises.exists(R).then(O=>{if(O)return Promise.resolve(R);const N=d.url,K=d.hash,V=`${R}.tmp`;return this.i.request({url:N},D.CancellationToken.None).then(X=>this.u.writeFile(h.URI.file(V),X.stream)).then(K?()=>(0,b.checksum)(V,d.hash):()=>{}).then(()=>v.Promises.rename(V,R)).then(()=>R)})).then(R=>{const O=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:R},O&&d.supportsFastUpdate?this.k.target==="user"?this.o():this.d(M.State.Downloaded(d)):this.d(M.State.Ready(d))})))}).then(void 0,d=>{this.j.error(d),this.t.publicLog2("update:notAvailable",{explicit:!!s});const S=s?d.message||d:void 0;this.d(M.State.Idle(r(),S))}))}async n(s){s.update.url&&this.v.openExternal(void 0,s.update.url),this.d(M.State.Idle(r()))}async z(s){const d=await this.cachePath;return f.join(d,`CodeSetup-${this.k.quality}-${s}.exe`)}async A(s=null){const d=s?N=>!new RegExp(`${this.k.quality}-${s}\\.exe$`).test(N):()=>!0,S=await this.cachePath,O=(await v.Promises.readdir(S)).filter(d).map(async N=>{try{await v.Promises.unlink(f.join(S,N))}catch{}});await Promise.all(O)}async o(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const s=this.state.update;this.d(M.State.Updating(s));const d=await this.cachePath;this.e.updateFilePath=f.join(d,`CodeSetup-${this.k.quality}-${s.version}.flag`),await v.Promises.writeFile(this.e.updateFilePath,"flag"),(0,I.spawn)(this.e.packagePath,["/verysilent",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(M.State.Idle(r()))});const R=`${this.k.win32MutexName}-ready`,O=await new Promise((N,K)=>{G(["windows-mutex"],N,K)});a(()=>O.isActive(R)).then(()=>this.d(M.State.Ready(s)))}q(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.e.updateFilePath?A.unlinkSync(this.e.updateFilePath):(0,I.spawn)(this.e.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}p(){return r()}async _applySpecificUpdate(s){if(this.state.type!=="idle")return;const d=this.g.getValue("update.enableWindowsBackgroundUpdates"),S={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!d};this.d(M.State.Downloading(S)),this.e={packagePath:s},d?this.k.target==="user"?this.o():this.d(M.State.Downloaded(S)):this.d(M.State.Ready(S))}};ve([P.memoize],c.prototype,"cachePath",null),c=ve([_(0,w.ILifecycleMainService),_(1,y.IConfigurationService),_(2,E.ITelemetryService),_(3,g.IEnvironmentMainService),_(4,k.IRequestService),_(5,o.ILogService),_(6,m.IFileService),_(7,u.INativeHostMainService),_(8,p.IProductService)],c),e.Win32UpdateService=c}),define(ee[278],te([0,1,14,8,22,44,3,2,15,9,64,4,7,177,63,19,58,28,62,16,21,5,20,67,241,96,24,131,69,77,30,29,54,118,122,37,34,53,59,243,114,52,93,26,115,65,48]),function(G,e,I,A,n,C,D,P,f,h,b,v,y,g,m,w,o,u,p,k,E,M,t,a,i,r,c,l,s,d,S,R,O,N,K,V,X,ie,re,ce,fe,ge,x,F,W,z,J){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var ne;(function(Z){Z[Z.NONE=0]="NONE",Z[Z.NAVIGATING=1]="NAVIGATING",Z[Z.READY=2]="READY"})(ne||(ne={}));let se=class ct extends P.Disposable{get id(){return this.k}get win(){return this.l}get lastFocusTime(){return this.m}get backupPath(){return this.n?.backupPath}get openedWorkspace(){return this.n?.workspace}get profile(){if(!this.config)return;const U=this.P.profiles.find(L=>L.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&U?U:this.P.getProfileForWorkspace(this.config.workspace??(0,R.toWorkspaceIdentifier)(this.backupPath,this.isExtensionDevelopmentHost))??this.P.defaultProfile}get remoteAuthority(){return this.n?.remoteAuthority}get config(){return this.n}get isExtensionDevelopmentHost(){return!!this.n?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.n?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.n?.debugId}constructor(U,L,T,B,H,j,$,q,oe,de,pe,ye,Le,Fe,Te,we,Ce,Re,Q,ae,he){super(),this.L=L,this.M=T,this.N=B,this.O=H,this.P=j,this.Q=$,this.R=q,this.S=oe,this.U=de,this.W=pe,this.X=ye,this.Y=Le,this.Z=Fe,this.ab=Te,this.bb=we,this.db=Ce,this.eb=Re,this.fb=Q,this.gb=ae,this.hb=he,this.c=this.B(new D.Emitter),this.onWillLoad=this.c.event,this.f=this.B(new D.Emitter),this.onDidSignalReady=this.f.event,this.g=this.B(new D.Emitter),this.onDidTriggerSystemContextMenu=this.g.event,this.h=this.B(new D.Emitter),this.onDidClose=this.h.event,this.j=this.B(new D.Emitter),this.onDidDestroy=this.j.event,this.m=-1,this.t=void 0,this.u=void 0,this.z=!1,this.C=[],this.D=[],this.F=void 0,this.G=void 0,this.H=this.B(this.eb.createIPCObjectUrl()),this.J=!1,this.ib=0;{const[Pe,Me]=this.tb(U.state);this.r=Pe,this.L.trace("window#ctor: using window state",Pe);const Ae=this.r.mode===0||this.r.mode===3;typeof ct.b>"u"&&(ct.b=this.gb.getItem("window.experimental.useSandbox",!1));const Ue=this.U.getValue("window");let He=!1;typeof Ue?.experimental?.useSandbox=="boolean"?He=Ue.experimental.useSandbox:this.db.quality==="stable"&&ct.b?He=!0:He=typeof this.db.quality=="string"&&this.db.quality!=="stable";const Ne={width:this.r.width,height:this.r.height,x:this.r.x,y:this.r.y,backgroundColor:this.W.getBackgroundColor(),minWidth:d.WindowMinimumSize.WIDTH,minHeight:d.WindowMinimumSize.HEIGHT,show:!Ae,title:this.db.nameLong,webPreferences:{preload:f.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.H.resource.toString()}`],v8CacheOptions:this.N.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,d.zoomLevelToZoomFactor)(Ue?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...He?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};v.isLinux?Ne.icon=(0,h.join)(this.N.appRoot,"resources/linux/code.png"):v.isWindows&&!this.N.isBuilt&&(Ne.icon=(0,h.join)(this.N.appRoot,"resources/win32/code_150x150.png")),v.isMacintosh&&!this.Ab()&&(Ne.fullscreenable=!1),v.isMacintosh&&(Ne.acceptFirstMouse=!0,Ue?.clickThroughInactive===!1&&(Ne.acceptFirstMouse=!1));const $e=v.isMacintosh&&Ue?.nativeTabs===!0;$e&&(Ne.tabbingIdentifier=this.db.nameShort);const Ge=(0,d.getTitleBarStyle)(this.U)==="custom";if(Ge&&(Ne.titleBarStyle="hidden",v.isMacintosh||(Ne.frame=!1),(0,d.useWindowControlsOverlay)(this.U))){const We=this.W.getWindowSplash()?.colorInfo.titleBarBackground??this.W.getBackgroundColor(),Ve=K.Color.fromHex(We).isDarker()?"#FFFFFF":"#000000";Ne.titleBarOverlay={height:29,color:We,symbolColor:Ve},this.z=!0}if((0,b.mark)("code/willCreateCodeBrowserWindow"),this.l=new I.BrowserWindow(Ne),(0,b.mark)("code/didCreateCodeBrowserWindow"),this.k=this.l.id,v.isMacintosh&&Ge&&this.l.setSheetOffset(22),Ge&&(v.isWindows&&(0,d.useWindowControlsOverlay)(this.U)||v.isMacintosh)){const We=this.gb.getItem(ct.a);We&&this.updateWindowControls({height:We})}v.isWindows&&Ge&&this.l.hookWindowMessage(278,()=>{const[Ve,Y]=this.l.getPosition(),le=I.screen.getCursorScreenPoint(),ue=le.x-Ve,me=le.y-Y;return(()=>!(ue>30&&me>=0&&me<=Math.max(this.l.getBounds().height*.15,35)))()||(this.l.setEnabled(!1),this.l.setEnabled(!0),this.g.fire({x:ue,y:me})),0}),(v.isMacintosh||v.isWindows)&&Me&&(!$e||I.BrowserWindow.getAllWindows().length===1)&&[this.r.width,this.r.height,this.r.x,this.r.y].every(We=>typeof We=="number")&&this.l.setBounds({width:this.r.width,height:this.r.height,x:this.r.x,y:this.r.y}),Ae&&((0,b.mark)("code/willMaximizeCodeWindow"),this.l.maximize(),this.r.mode===3&&this.wb(!0),this.l.show(),(0,b.mark)("code/didMaximizeCodeWindow")),this.m=Date.now()}this.N.args["open-devtools"]===!0&&this.l.webContents.openDevTools(),this.qb(),this.Eb(),this.jb()}setRepresentedFilename(U){v.isMacintosh?this.l.setRepresentedFilename(U):this.v=U}getRepresentedFilename(){return v.isMacintosh?this.l.getRepresentedFilename():this.v}setDocumentEdited(U){v.isMacintosh&&this.l.setDocumentEdited(U),this.w=U}isDocumentEdited(){return v.isMacintosh?this.l.isDocumentEdited():!!this.w}focus(U){v.isMacintosh&&U?.force&&I.app.focus({steal:!0}),this.l&&(this.l.isMinimized()&&this.l.restore(),this.l.focus())}setReady(){for(this.L.trace(`window#load: window reported ready (id: ${this.k})`),this.ib=2;this.C.length;)this.C.pop()(this);this.f.fire()}ready(){return new Promise(U=>{if(this.isReady)return U(this);this.C.push(U)})}get isReady(){return this.ib===2}get whenClosedOrLoaded(){return new Promise(U=>{function L(){T.dispose(),B.dispose(),U()}const T=this.onDidClose(()=>L()),B=this.onWillLoad(()=>L())})}jb(){this.l.on("unresponsive",()=>this.mb(1)),this.l.webContents.on("render-process-gone",(L,T)=>this.mb(2,T)),this.l.webContents.on("did-fail-load",(L,T,B)=>this.mb(3,{reason:B,exitCode:T})),this.l.webContents.on("will-prevent-unload",L=>{L.preventDefault()}),this.l.on("closed",()=>{this.h.fire(),this.dispose()}),this.l.webContents.on("did-finish-load",()=>{this.I&&(this.n=this.I,this.I=void 0)}),this.l.on("focus",()=>{this.m=Date.now()}),this.l.on("maximize",L=>{this.n&&(this.n.maximized=!0),I.app.emit("browser-window-maximize",L,this.l)}),this.l.on("unmaximize",L=>{this.n&&(this.n.maximized=!1),I.app.emit("browser-window-unmaximize",L,this.l)}),this.l.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",n.CancellationToken.None),this.u?.complete(),this.u=void 0}),this.l.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",n.CancellationToken.None),this.u?.complete(),this.u=void 0}),this.B(this.U.onDidChangeConfiguration(L=>this.qb(L))),this.B(this.X.onDidDeleteUntitledWorkspace(L=>this.pb(L)));const U=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.l.webContents.session.webRequest.onBeforeSendHeaders({urls:U},async(L,T)=>{const B=await this.lb();T({cancel:!1,requestHeaders:Object.assign(L.requestHeaders,B)})})}lb(){return this.kb||(this.kb=(0,i.resolveMarketplaceHeaders)(this.db.version,this.db,this.N,this.U,this.Q,this.R,this.Z)),this.kb}async mb(U,L){switch(U){case 2:this.L.error(`CodeWindow: renderer process gone (reason: ${L?.reason||"<unknown>"}, code: ${L?.exitCode||"<unknown>"})`);break;case 1:this.L.error("CodeWindow: detected unresponsive");break;case 3:this.L.error(`CodeWindow: failed to load (reason: ${L?.reason||"<unknown>"}, code: ${L?.exitCode||"<unknown>"})`);break}switch(this.Z.publicLog2("windowerror",{type:U,reason:L?.reason,code:L?.exitCode}),U){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.bb.kill(1);return}if(this.N.args["enable-smoke-test-driver"]){await this.ob(!1,!1),this.bb.quit();return}if(U===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.l&&this.l.webContents&&this.l.webContents.isDevToolsOpened())return;const{options:T,buttonIndeces:B}=(0,J.massageMessageBoxOptions)({type:"warning",buttons:[(0,g.localize)(0,null),(0,g.localize)(1,null),(0,g.localize)(2,null)],message:(0,g.localize)(3,null),detail:(0,g.localize)(4,null),checkboxLabel:this.n?.workspace?(0,g.localize)(5,null):void 0},this.db),H=await this.ab.showMessageBox(T,this.l),j=B[H.response];if(j!==1){const $=j===0;await this.ob($,H.checkboxChecked)}}else if(U===2)if(v.isWindows&&L?.reason==="launch-failed"&&L.exitCode===18&&await this.hb.isAdmin(void 0))await this.nb(L);else{let T;L?T=(0,g.localize)(7,null,L.reason,L.exitCode??"<unknown>"):T=(0,g.localize)(6,null);const{options:B,buttonIndeces:H}=(0,J.massageMessageBoxOptions)({type:"warning",buttons:[this.n?.workspace?(0,g.localize)(8,null):(0,g.localize)(9,null),(0,g.localize)(10,null)],message:T,detail:this.n?.workspace?(0,g.localize)(11,null):(0,g.localize)(12,null),checkboxLabel:this.n?.workspace?(0,g.localize)(13,null):void 0},this.db),j=await this.ab.showMessageBox(B,this.l),$=H[j.response]===0;await this.ob($,j.checkboxChecked)}break}}async nb(U){const L=[],T=(0,ge.isInternalTelemetry)(this.db,this.U);if((0,ge.supportsTelemetry)(this.db,this.N)){this.db.aiConfig&&this.db.aiConfig.ariaKey&&L.push(new ce.OneDataSystemAppender(T,"monacoworkbench",null,this.db.aiConfig.ariaKey));const{installSourcePath:$}=this.N,q=await(0,W.resolveMachineId)(this.gb),oe={appenders:L,sendErrorTelemetry:!1,commonProperties:(0,x.resolveCommonProperties)(this.Q,(0,F.release)(),(0,F.hostname)(),process.arch,this.db.commit,this.db.version,q,T,$),piiPaths:(0,ge.getPiiPathsFromEnvironment)(this.N)};await new fe.TelemetryService(oe,this.U,this.db).publicLog2("windowadminerror",{reason:U.reason,code:U.exitCode})}const{options:B,buttonIndeces:H}=(0,J.massageMessageBoxOptions)({type:"error",buttons:[(0,g.localize)(14,null),(0,g.localize)(15,null)],message:(0,g.localize)(16,null),detail:(0,g.localize)(17,null,this.db.nameLong)},this.db),j=await this.ab.showMessageBox(B,this.l);H[j.response]===0&&await this.hb.openExternal(void 0,"https://go.microsoft.com/fwlink/?linkid=2220179"),await Promise.all(L.map($=>$.flush())),await this.ob(!1,!1)}async ob(U,L){const T=this.n?.workspace;if(L&&T)try{const B=this.S.workspaceStorage(T);await B.init(),B.delete("memento/workbench.parts.editor"),await B.close()}catch(B){this.L.error(B)}if(this.j.fire(),this.l?.destroy(),U&&this.n){let B,H;(0,R.isSingleFolderWorkspaceIdentifier)(T)?B={folderUri:T.uri}:(0,R.isWorkspaceIdentifier)(T)?B={workspaceUri:T.configPath}:H=!0;const[j]=await this.fb.open({context:5,userEnv:this.n.userEnv,cli:{...this.N.args,_:[]},urisToOpen:B?[B]:void 0,forceEmpty:H,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});j.focus()}}pb(U){this.n?.workspace?.id===U.id&&(this.n.workspace=void 0)}qb(U){if(!U||U.affectsConfiguration("window.menuBarVisibility")){const L=this.Bb();L!==this.s&&(this.s=L,this.Cb(L))}if(!U||U.affectsConfiguration("http.proxy")){let L=(this.U.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;L?.endsWith("/")&&(L=L.substr(0,L.length-1));const T=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((L||"").indexOf("@")===-1&&(L!==this.F||T!==this.G)){this.F=L,this.G=T;const B=L||"",H=T?`${T},<local>`:"<local>";this.L.trace(`Setting proxy to '${B}', bypassing '${H}'`),this.l.webContents.session.setProxy({proxyRules:B,proxyBypassRules:H,pacScript:""})}}}addTabbedWindow(U){v.isMacintosh&&U.win&&this.l.addTabbedWindow(U.win)}load(U,L=Object.create(null)){this.L.trace(`window#load: attempt to load window (id: ${this.k})`),this.isDocumentEdited()&&(!L.isReload||!this.Y.isHotExitEnabled())&&this.setDocumentEdited(!1),L.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.l.setTitle(this.db.nameLong)),this.rb(U,L),this.ib===0?this.n=U:this.I=U,this.ib=1,this.l.loadURL(f.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.N.isBuilt?"":"-dev"}.html`).toString(!0));const T=this.J;this.J=!0,!this.N.isBuilt&&!this.N.extensionTestsLocationURI&&this.B(new A.RunOnceScheduler(()=>{this.l&&!this.l.isVisible()&&!this.l.isMinimized()&&(this.l.show(),this.focus({force:!0}),this.l.webContents.openDevTools())},1e4)).schedule(),this.c.fire({workspace:U.workspace,reason:L.isReload?3:T?2:1})}rb(U,L){const T=(this.n??this.I)?.userEnv;if(T){const B=(0,p.isLaunchedFromCli)(T)&&!(0,p.isLaunchedFromCli)(U.userEnv),H=this.isExtensionDevelopmentHost;(B||H)&&(U.userEnv={...T,...U.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(U.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),L.disableExtensions!==void 0&&(U["disable-extensions"]=L.disableExtensions),U.fullscreen=this.isFullScreen,U.maximized=this.l.isMaximized(),U.partsSplash=this.W.getWindowSplash(),(0,b.mark)("code/willOpenNewWindow"),U.perfMarks=(0,b.getMarks)(),this.H.update(U)}async reload(U){const L=Object.assign({},this.n);L.workspace=await this.sb(L),delete L.filesToOpenOrCreate,delete L.filesToDiff,delete L.filesToMerge,delete L.filesToWait,this.isExtensionDevelopmentHost&&U&&(L.verbose=U.verbose,L.debugId=U.debugId,L.extensionEnvironment=U.extensionEnvironment,L["inspect-extensions"]=U["inspect-extensions"],L["inspect-brk-extensions"]=U["inspect-brk-extensions"],L["extensions-dir"]=U["extensions-dir"]),L.accessibilitySupport=I.app.isAccessibilitySupportEnabled(),L.isInitialStartup=!1,L.policiesData=this.O.serialize(),L.continueOn=this.N.continueOn,L.profiles={all:this.P.profiles,profile:this.profile||this.P.defaultProfile},L.logLevel=this.L.getLevel(),L.loggers={window:this.M.getRegisteredLoggers(this.id),global:this.M.getRegisteredLoggers()},this.load(L,{isReload:!0,disableExtensions:U?.["disable-extensions"]})}async sb(U){if((0,R.isWorkspaceIdentifier)(U.workspace)){const L=U.workspace.configPath;if(L.scheme===f.Schemas.file&&!await this.Q.exists(L))return}else if((0,R.isSingleFolderWorkspaceIdentifier)(U.workspace)){const L=U.workspace.uri;if(L.scheme===f.Schemas.file&&!await this.Q.exists(L))return}return U.workspace}serializeWindowState(){if(!this.l)return(0,N.defaultWindowState)();if(this.isFullScreen){let T;try{T=I.screen.getDisplayMatching(this.getBounds())}catch{}const B=(0,N.defaultWindowState)();return{mode:3,display:T?T.id:void 0,width:this.r.width||B.width,height:this.r.height||B.height,x:this.r.x||0,y:this.r.y||0}}const U=Object.create(null);let L;if(!v.isMacintosh&&this.l.isMaximized()?L=0:L=1,L===0?U.mode=0:U.mode=1,L===1||L===0){let T;L===1?T=this.getBounds():T=this.l.getNormalBounds(),U.x=T.x,U.y=T.y,U.width=T.width,U.height=T.height}return U}updateWindowControls(U){if(U.height&&this.gb.setItem(ct.a,U.height),v.isWindows&&this.z)this.l.setTitleBarOverlay({color:U.backgroundColor?.trim()===""?void 0:U.backgroundColor,symbolColor:U.foregroundColor?.trim()===""?void 0:U.foregroundColor,height:U.height?U.height-1:void 0});else if(v.isMacintosh&&U.height!==void 0){const L=(U.height-15)/2;this.l.setTrafficLightPosition({x:L,y:L})}}tb(U){(0,b.mark)("code/willRestoreCodeWindowState");let L=!1;if(U)try{const T=I.screen.getAllDisplays();L=T.length>1,U=this.ub(U,T)}catch(T){this.L.warn(`Unexpected error validating window state: ${T}
${T.stack}`)}return(0,b.mark)("code/didRestoreCodeWindowState"),[U||(0,N.defaultWindowState)(),L]}ub(U,L){if(this.L.trace(`window#validateWindowState: validating window state on ${L.length} display(s)`,U),typeof U.x!="number"||typeof U.y!="number"||typeof U.width!="number"||typeof U.height!="number"){this.L.trace("window#validateWindowState: unexpected type of state values");return}if(U.width<=0||U.height<=0){this.L.trace("window#validateWindowState: unexpected negative values");return}if(L.length===1){const H=this.vb(L[0]);if(H){let j=function(){!U||typeof U.x!="number"||typeof U.y!="number"||!H||(U.x<H.x&&(U.x=H.x),U.y<H.y&&(U.y=H.y))};this.L.trace("window#validateWindowState: 1 monitor working area",H),j(),U.width>H.width&&(U.width=H.width),U.height>H.height&&(U.height=H.height),U.x>H.x+H.width-128&&(U.x=H.x+H.width-U.width),U.y>H.y+H.height-128&&(U.y=H.y+H.height-U.height),j()}return U}if(U.display&&U.mode===3){const H=L.find(j=>j.id===U.display);if(H&&typeof H.bounds?.x=="number"&&typeof H.bounds?.y=="number"){this.L.trace("window#validateWindowState: restoring fullscreen to previous display");const j=(0,N.defaultWindowState)(3);return j.x=H.bounds.x,j.y=H.bounds.y,j}}let T,B;try{T=I.screen.getDisplayMatching({x:U.x,y:U.y,width:U.width,height:U.height}),B=this.vb(T)}catch{}if(T&&B&&U.x+U.width>B.x&&U.y+U.height>B.y&&U.x<B.x+B.width&&U.y<B.y+B.height)return this.L.trace("window#validateWindowState: multi-monitor working area",B),U}vb(U){if(U.workArea.width>0&&U.workArea.height>0)return U.workArea;if(U.bounds.width>0&&U.bounds.height>0)return U.bounds}getBounds(){const[U,L]=this.l.getPosition(),[T,B]=this.l.getSize();return{x:U,y:L,width:T,height:B}}toggleFullScreen(){this.wb(!this.isFullScreen)}wb(U){this.Ab()?this.xb(U):this.zb(U),this.sendWhenReady(U?"vscode:enterFullScreen":"vscode:leaveFullScreen",n.CancellationToken.None),this.s&&this.Cb(this.s,!1)}get isFullScreen(){return v.isMacintosh&&typeof this.t=="boolean"?this.t:this.l.isFullScreen()||this.l.isSimpleFullScreen()}xb(U){this.l.isSimpleFullScreen()&&this.l.setSimpleFullScreen(!1),this.yb(U)}yb(U){v.isMacintosh&&(this.t=U,this.u=new A.DeferredPromise,Promise.race([this.u.p,(0,A.timeout)(1e3)]).finally(()=>this.t=void 0)),this.l.setFullScreen(U)}zb(U){this.l.isFullScreen()&&this.yb(!1),this.l.setSimpleFullScreen(U),this.l.webContents.focus()}Ab(){const U=this.U.getValue("window");return!U||typeof U.nativeFullScreen!="boolean"||U.nativeTabs?!0:U.nativeFullScreen!==!1}isMinimized(){return this.l.isMinimized()}Bb(){let U=(0,d.getMenuBarVisibility)(this.U);return["visible","toggle","hidden"].indexOf(U)<0&&(U="classic"),U}Cb(U,L=!0){v.isMacintosh||(U==="toggle"&&L&&this.send("vscode:showInfoMessage",(0,g.localize)(18,null)),U==="hidden"?setTimeout(()=>{this.Db(U)}):this.Db(U))}Db(U){const L=this.isFullScreen;switch(U){case"classic":this.l.setMenuBarVisibility(!L),this.l.autoHideMenuBar=L;break;case"visible":this.l.setMenuBarVisibility(!0),this.l.autoHideMenuBar=!1;break;case"toggle":this.l.setMenuBarVisibility(!1),this.l.autoHideMenuBar=!0;break;case"hidden":this.l.setMenuBarVisibility(!1),this.l.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(v.isMacintosh)switch(I.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this.l.minimize();break;case"None":break;case"Maximize":default:this.l.isMaximized()?this.l.unmaximize():this.l.maximize()}else this.l.isMaximized()?this.l.unmaximize():this.l.maximize()}close(){this.l?.close()}sendWhenReady(U,L,...T){this.isReady?this.send(U,...T):this.ready().then(()=>{L.isCancellationRequested||this.send(U,...T)})}send(U,...L){if(this.l){if(this.l.isDestroyed()||this.l.webContents.isDestroyed()){this.L.warn(`Sending IPC message to channel '${U}' for window that is destroyed`);return}try{this.l.webContents.send(U,...L)}catch(T){this.L.warn(`Error sending IPC message to channel '${U}' of window ${this.k}: ${(0,C.toErrorMessage)(T)}`)}}}updateTouchBar(U){!v.isMacintosh||this.D.forEach((L,T)=>{const B=U[T];L.segments=this.Gb(B)})}Eb(){if(!!v.isMacintosh){for(let U=0;U<10;U++){const L=this.Fb();this.D.push(L)}this.l.setTouchBar(new I.TouchBar({items:this.D}))}}Fb(U=[]){const L=this.Gb(U),T=new I.TouchBar.TouchBarSegmentedControl({segments:L,mode:"buttons",segmentStyle:"automatic",change:B=>{this.sendWhenReady("vscode:runAction",n.CancellationToken.None,{id:T.segments[B].id,from:"touchbar"})}});return T}Gb(U=[]){return U.map(T=>{let B;T.icon&&!l.ThemeIcon.isThemeIcon(T.icon)&&T.icon?.dark?.scheme===f.Schemas.file&&(B=I.nativeImage.createFromPath(y.URI.revive(T.icon.dark).fsPath),B.isEmpty()&&(B=void 0));let H;return typeof T.title=="string"?H=T.title:H=T.title.value,{id:T.id,label:B?void 0:H,icon:B}})}dispose(){super.dispose(),this.M.deregisterLoggers(this.id),this.l=null}};se.a="windowControlHeight",se.b=void 0,se=ve([_(1,M.ILogService),_(2,z.ILoggerMainService),_(3,u.IEnvironmentMainService),_(4,V.IPolicyService),_(5,ie.IUserDataProfilesMainService),_(6,k.IFileService),_(7,r.IApplicationStorageMainService),_(8,r.IStorageMainService),_(9,w.IConfigurationService),_(10,s.IThemeMainService),_(11,O.IWorkspacesManagementMainService),_(12,m.IBackupMainService),_(13,c.ITelemetryService),_(14,o.IDialogMainService),_(15,E.ILifecycleMainService),_(16,t.IProductService),_(17,a.IProtocolMainService),_(18,S.IWindowsMainService),_(19,X.IStateMainService),_(20,re.INativeHostMainService)],se),e.CodeWindow=se}),define(ee[79],te([0,1,14,25,8,3,45,2,15,4,18,7,23,180,6,21,5,96,97,29,54,35]),function(G,e,I,A,n,C,D,P,f,h,b,v,y,g,m,w,o,u,p,k,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,m.createDecorator)("workspacesHistoryMainService");let t=class nt extends P.Disposable{constructor(i,r,c,l){super(),this.f=i,this.g=r,this.h=c,this.j=l,this.c=this.B(new C.Emitter),this.onDidChangeRecentlyOpened=this.c.event,this.z=this.B(new n.ThrottledDelayer(800)),this.k()}k(){this.h.when(4).then(()=>this.C()),this.B(this.g.onDidEnterWorkspace(i=>this.addRecentlyOpened([{workspace:i.workspace,remoteAuthority:i.window.remoteAuthority}])))}async addRecentlyOpened(i){let r=[],c=[];for(const s of i)if((0,p.isRecentWorkspace)(s))!this.g.isUntitledWorkspace(s.workspace)&&!this.r(r,s.workspace)&&r.push(s);else if((0,p.isRecentFolder)(s))this.s(r,s.folderUri)||r.push(s);else{const d=this.t(c,s.fileUri),S=s.fileUri.scheme===f.Schemas.file&&nt.y.indexOf((0,b.basename)(s.fileUri))>=0;!d&&!S&&(c.push(s),h.isWindows&&s.fileUri.scheme===f.Schemas.file&&I.app.addRecentDocument(s.fileUri.fsPath))}const l=await this.l({workspaces:r,files:c});r=l.workspaces,c=l.files,r.length>nt.a&&(r.length=nt.a),c.length>nt.a&&(c.length=nt.a),await this.n({workspaces:r,files:c}),this.c.fire(),h.isMacintosh&&this.z.trigger(()=>this.H())}async removeRecentlyOpened(i){const r=d=>{const S=this.p(d);for(const R of i)if(b.extUriBiasedIgnorePathCase.isEqual(R,S))return!1;return!0},c=await this.getRecentlyOpened(),l=c.workspaces.filter(r),s=c.files.filter(r);(l.length!==c.workspaces.length||s.length!==c.files.length)&&(await this.n({files:s,workspaces:l}),this.c.fire(),h.isMacintosh&&this.z.trigger(()=>this.H()))}async clearRecentlyOpened(){await this.n({workspaces:[],files:[]}),I.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.l()}async l(i){const r=new M.ResourceMap(s=>b.extUriBiasedIgnorePathCase.getComparisonKey(s));if(i?.workspaces)for(const s of i.workspaces)r.set(this.p(s),s);const c=new M.ResourceMap(s=>b.extUriBiasedIgnorePathCase.getComparisonKey(s));if(i?.files)for(const s of i.files)c.set(this.p(s),s);const l=await this.m();for(const s of l.workspaces){const d=r.get(this.p(s));d?d.label=d.label??s.label:r.set(this.p(s),s)}for(const s of l.files){const d=c.get(this.p(s));d?d.label=d.label??s.label:c.set(this.p(s),s)}return{workspaces:[...r.values()],files:[...c.values()]}}async m(){await this.j.whenReady;let i;const r=this.j.get(nt.b,-1);if(typeof r=="string")try{i=JSON.parse(r)}catch(c){this.f.error("Unexpected error parsing opened paths list",c)}return(0,p.restoreRecentlyOpened)(i,this.f)}async n(i){await this.j.whenReady,this.j.store(nt.b,JSON.stringify((0,p.toStoreData)(i)),-1,1)}p(i){return(0,p.isRecentFolder)(i)?i.folderUri:(0,p.isRecentFile)(i)?i.fileUri:i.workspace.configPath}r(i,r){return!!i.find(c=>(0,p.isRecentWorkspace)(c)&&c.workspace.id===r.id)}s(i,r){return!!i.find(c=>(0,p.isRecentFolder)(c)&&b.extUriBiasedIgnorePathCase.isEqual(c.folderUri,r))}t(i,r){return!!i.find(c=>b.extUriBiasedIgnorePathCase.isEqual(c.fileUri,r))}async C(){!h.isWindows||(await this.D(),this.B(this.onDidChangeRecentlyOpened(()=>this.D())))}async D(){if(!h.isWindows)return;const i=[];if(i.push({type:"tasks",items:[{type:"task",title:(0,g.localize)(0,null),description:(0,g.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const r=[];for(const s of I.app.getJumpListSettings().removedItems){const d=s.args;if(d){const S=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(d);S&&r.push(v.URI.parse(S[2]))}}await this.removeRecentlyOpened(r);let c=!1;const l=(0,A.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,nt.w).map(s=>{const d=(0,p.isRecentWorkspace)(s)?s.workspace:s.folderUri,{title:S,description:R}=this.F(d,s.label);let O;return v.URI.isUri(d)?O=`--folder-uri "${d.toString()}"`:(c=!0,O=`--file-uri "${d.configPath.toString()}"`),{type:"task",title:S.substr(0,255),description:R.substr(0,255),program:process.execPath,args:O,iconPath:"explorer.exe",iconIndex:0}}));l.length>0&&i.push({type:"custom",name:c?(0,g.localize)(2,null):(0,g.localize)(3,null),items:l})}i.push({type:"recent"});try{const r=I.app.setJumpList(i);r&&r!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${r}`)}catch(r){this.f.warn("updateWindowsJumpList#setJumpList",r)}}F(i,r){if(r)return{title:(0,D.splitName)(r).name,description:r};if(v.URI.isUri(i))return{title:(0,b.basename)(i),description:this.G(i)};if(this.g.isUntitledWorkspace(i))return{title:(0,g.localize)(4,null),description:""};let c=(0,b.basename)(i.configPath);return c.endsWith(k.WORKSPACE_EXTENSION)&&(c=c.substr(0,c.length-k.WORKSPACE_EXTENSION.length-1)),{title:(0,g.localize)(5,null,c),description:this.G(i.configPath)}}G(i){return i.scheme==="file"?(0,D.normalizeDriveLetter)(i.fsPath):i.toString()}async H(){if(!h.isMacintosh)return;I.app.clearRecentDocuments();const i=await this.getRecentlyOpened(),r=[];let c=0;for(let s=0;s<i.workspaces.length&&c<nt.u;s++){const d=this.p(i.workspaces[s]);if(d.scheme===f.Schemas.file){const S=(0,b.originalFSPath)(d);await y.Promises.exists(S)&&(r.push(S),c++)}}const l=[];for(let s=0;s<i.files.length&&c<nt.v;s++){const d=this.p(i.files[s]);if(d.scheme===f.Schemas.file){const S=(0,b.originalFSPath)(d);if(nt.y.includes((0,b.basename)(d))||r.includes(S))continue;await y.Promises.exists(S)&&(l.push(S),c++)}}l.reverse().forEach(s=>I.app.addRecentDocument(s)),r.reverse().forEach(s=>I.app.addRecentDocument(s))}};t.a=500,t.b="history.recentlyOpenedPathsList",t.u=7,t.v=10,t.w=7,t.y=["COMMIT_EDITMSG","MERGE_MSG"],t=ve([_(0,o.ILogService),_(1,E.IWorkspacesManagementMainService),_(2,w.ILifecycleMainService),_(3,u.IApplicationStorageMainService)],t),e.WorkspacesHistoryMainService=t}),define(ee[279],te([0,1,14,8,22,45,4,7,170,19,48,28,21,5,219,59,20,34,24,49,77,30,79]),function(G,e,I,A,n,C,D,P,f,h,b,v,y,g,m,w,o,u,p,k,E,M,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const a="menu";let i=class bt{constructor(l,s,d,S,R,O,N,K,V,X,ie){this.n=l,this.o=s,this.p=d,this.q=S,this.r=R,this.s=O,this.t=N,this.u=K,this.v=V,this.w=X,this.x=ie,this.m=Object.create(null),this.g=new A.RunOnceScheduler(()=>this.E(),0),this.h=new A.RunOnceScheduler(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(D.isMacintosh||(0,E.getTitleBarStyle)(this.o)==="native")&&this.y(),this.z(),this.d=!1,this.f=!1,this.j=[],this.H(),this.A()}y(){const l=this.t.getItem(bt.a);l&&(l.menus&&(this.k=l.menus),l.keybindings&&(this.l=l.keybindings))}z(){this.m["workbench.action.files.newUntitledFile"]=(O,N,K)=>this.p.openEmptyWindow({context:2,contextWindowId:N?.id}),this.m["workbench.action.newWindow"]=(O,N,K)=>this.p.openEmptyWindow({context:2,contextWindowId:N?.id}),this.m["workbench.action.files.openFileFolder"]=(O,N,K)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.P(K),telemetryExtraData:{from:a}}),this.m["workbench.action.files.openFolder"]=(O,N,K)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.P(K),telemetryExtraData:{from:a}}),this.m["workbench.action.openWorkspace"]=(O,N,K)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.P(K),telemetryExtraData:{from:a}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened();const l=this.x.twitterUrl;l&&(this.m["workbench.action.openTwitterUrl"]=()=>this.Z(l,"openTwitterUrl"));const s=this.x.requestFeatureUrl;s&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.Z(s,"openUserVoiceUrl"));const d=this.x.reportIssueUrl;d&&(this.m["workbench.action.openIssueReporter"]=()=>this.Z(d,"openReportIssues"));const S=this.x.licenseUrl;S&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(D.language){const O=S.indexOf("?")>0?"&":"?";this.Z(`${S}${O}lang=${D.language}`,"openLicenseUrl")}else this.Z(S,"openLicenseUrl")});const R=this.x.privacyStatementUrl;R&&S&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.Z(R,"openPrivacyStatement")})}A(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(l=>this.F(l)),this.w.onDidBlurWindow(()=>this.G()),this.w.onDidFocusWindow(()=>this.G())}get B(){const l=this.o.getValue("window.enableMenuBarMnemonics");return typeof l!="boolean"?!0:l}get C(){if(!D.isMacintosh)return!1;const l=this.o.getValue("window.nativeTabs");return typeof l!="boolean"?!1:l}updateMenu(l,s){this.k=l.menus,this.l=l.keybindings,this.t.setItem(bt.a,l),this.D()}D(){this.g.schedule()}E(){this.b||setTimeout(()=>{this.b||this.H()},10)}F(l){!D.isMacintosh||(l.oldCount===0&&l.newCount>0||l.oldCount>0&&l.newCount===0)&&(this.d=l.newCount===0,this.D())}G(){!D.isMacintosh||(this.f=!I.BrowserWindow.getFocusedWindow(),this.D())}H(){const l=I.Menu.getApplicationMenu();if(l&&this.j.push(l),Object.keys(this.k).length===0){I.Menu.setApplicationMenu(D.isMacintosh?new I.Menu:null);return}const s=new I.Menu;let d;if(D.isMacintosh){const R=new I.Menu;d=new I.MenuItem({label:this.x.nameShort,submenu:R}),this.I(R),s.append(d)}if(D.isMacintosh&&!this.c){this.c=!0;const R=new I.Menu;R.append(new I.MenuItem({label:this.bb(f.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),I.app.dock.setMenu(R)}if(this.K("File")){const R=new I.Menu,O=new I.MenuItem({label:this.bb(f.localize(1,null)),submenu:R});this.M(R,"File"),s.append(O)}if(this.K("Edit")){const R=new I.Menu,O=new I.MenuItem({label:this.bb(f.localize(2,null)),submenu:R});this.M(R,"Edit"),s.append(O)}if(this.K("Selection")){const R=new I.Menu,O=new I.MenuItem({label:this.bb(f.localize(3,null)),submenu:R});this.M(R,"Selection"),s.append(O)}if(this.K("View")){const R=new I.Menu,O=new I.MenuItem({label:this.bb(f.localize(4,null)),submenu:R});this.M(R,"View"),s.append(O)}if(this.K("Go")){const R=new I.Menu,O=new I.MenuItem({label:this.bb(f.localize(5,null)),submenu:R});this.M(R,"Go"),s.append(O)}if(this.K("Run")){const R=new I.Menu,O=new I.MenuItem({label:this.bb(f.localize(6,null)),submenu:R});this.M(R,"Run"),s.append(O)}if(this.K("Terminal")){const R=new I.Menu,O=new I.MenuItem({label:this.bb(f.localize(7,null)),submenu:R});this.M(R,"Terminal"),s.append(O)}let S;if(this.K("Window")){const R=new I.Menu;S=new I.MenuItem({label:this.bb(f.localize(8,null)),submenu:R,role:"window"}),this.S(R)}if(S&&s.append(S),this.K("Help")){const R=new I.Menu,O=new I.MenuItem({label:this.bb(f.localize(9,null)),submenu:R,role:"help"});this.M(R,"Help"),s.append(O)}s.items&&s.items.length>0?I.Menu.setApplicationMenu(s):I.Menu.setApplicationMenu(null),this.h.schedule()}I(l){const s=this.U(f.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),d=this.T();let S;if(this.K("Preferences")){const re=new I.Menu;this.M(re,"Preferences"),S=new I.MenuItem({label:this.bb(f.localize(11,null)),submenu:re})}const R=new I.Menu,O=new I.MenuItem({label:f.localize(12,null),role:"services",submenu:R}),N=new I.MenuItem({label:f.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),K=new I.MenuItem({label:f.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),V=new I.MenuItem({label:f.localize(15,null),role:"unhide"}),X=new I.MenuItem(this.Y("workbench.action.quit",{label:f.localize(16,null,this.x.nameLong),click:async(re,ce,fe)=>{const ge=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||!!I.BrowserWindow.getFocusedWindow()||ge?.isMinimized())&&await this.J(fe)&&this.w.quit(void 0)}})),ie=[s];ie.push(...d),S&&ie.push(r(),S),ie.push(r(),O,r(),N,K,V,r(),X),ie.forEach(re=>l.append(re))}async J(l){if(this.p.getWindowCount()===0)return!0;const s=this.o.getValue("window.confirmBeforeClose");if(s==="always"||s==="keyboardOnly"&&this.Q(l)){const{options:d,buttonIndeces:S}=(0,b.massageMessageBoxOptions)({type:"question",buttons:[f.localize(17,null),f.localize(18,null)],message:f.localize(19,null)},this.x),{response:R}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,d);return S[R]===0}return!0}K(l){if(!D.isMacintosh&&(0,E.getTitleBarStyle)(this.o)==="custom")return!1;switch(l){case"File":case"Help":if(D.isMacintosh)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[l];case"Window":if(D.isMacintosh)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[l]}}L(l,s){s.forEach(d=>{if((0,m.isMenubarMenuItemSeparator)(d))l.append(r());else if((0,m.isMenubarMenuItemSubmenu)(d)){const S=new I.Menu,R=new I.MenuItem({label:this.bb(d.label),submenu:S});this.L(S,d.submenu.items),l.append(R)}else(0,m.isMenubarMenuItemRecentAction)(d)?l.append(this.O(d)):(0,m.isMenubarMenuItemAction)(d)&&(d.id==="workbench.action.showAboutDialog"&&this.N(l),D.isMacintosh?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[d.id]?l.append(new I.MenuItem(this.Y(d.id,{label:this.bb(d.label),click:this.m[d.id]}))):l.append(this.U(d.label,d.id,!1,d.checked)):l.append(this.U(d.label,d.id,d.enabled!==!1,!!d.checked)):l.append(this.U(d.label,d.id,d.enabled!==!1,!!d.checked)))})}M(l,s){this.k&&this.k[s]&&this.L(l,this.k[s].items)}N(l){const s=this.T();s.length&&(s.forEach(d=>l.append(d)),l.append(r()))}O(l){const s=P.URI.revive(l.uri),d=l.id,S=d==="openRecentFile"?{fileUri:s}:d==="openRecentWorkspace"?{workspaceUri:s}:{folderUri:s};return new I.MenuItem(this.Y(d,{label:l.label,click:async(R,O,N)=>{const K=this.P(N);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[S],forceNewWindow:K,gotoLineMode:!1,remoteAuthority:l.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([s])}},!1))}P(l){return!!(l&&(!D.isMacintosh&&(l.ctrlKey||l.shiftKey)||D.isMacintosh&&(l.metaKey||l.altKey)))}Q(l){return!!(l.triggeredByAccelerator||l.altKey||l.ctrlKey||l.metaKey||l.shiftKey)}R(l,s,d){const S={label:this.bb(l),role:d,enabled:!0};return new I.MenuItem(this.X(s,S))}S(l){const s=new I.MenuItem({label:f.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),d=new I.MenuItem({label:f.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),S=new I.MenuItem({label:f.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),R=this.U(f.localize(23,null),"workbench.action.switchWindow"),O=[];this.C&&(O.push(r()),O.push(this.U(f.localize(24,null),"workbench.action.newWindowTab")),O.push(this.R(f.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),O.push(this.R(f.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),O.push(this.R(f.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),O.push(this.R(f.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[s,d,r(),R,...O,r(),S].forEach(N=>l.append(N))}T(){switch(this.n.state.type){case"uninitialized":return[];case"idle":return[new I.MenuItem({label:this.bb(f.localize(29,null)),click:()=>setTimeout(()=>{this.ab("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new I.MenuItem({label:f.localize(30,null),enabled:!1})];case"available for download":return[new I.MenuItem({label:this.bb(f.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new I.MenuItem({label:f.localize(32,null),enabled:!1})];case"downloaded":return[new I.MenuItem({label:this.bb(f.localize(33,null)),click:()=>{this.ab("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new I.MenuItem({label:f.localize(34,null),enabled:!1})];case"ready":return[new I.MenuItem({label:this.bb(f.localize(35,null)),click:()=>{this.ab("RestartToUpdate"),this.n.quitAndInstall()}})]}}U(l,s,d,S){const R=this.bb(l),O=typeof s=="function"?s:(ie,re,ce)=>{const fe=ie?ie.userSettingsLabel:null;let ge=s;Array.isArray(s)&&(ge=this.P(ce)?s[1]:s[0]),fe&&ce.triggeredByAccelerator?this.W({type:"keybinding",userSettingsLabel:fe}):this.W({type:"commandId",commandId:ge})},N=typeof d=="boolean"?d:this.p.getWindowCount()>0,K=typeof S=="boolean"?S:!1,V={label:R,click:O,enabled:N};K&&(V.type="checkbox",V.checked=K);let X;return typeof s=="string"?X=s:Array.isArray(s)&&(X=s[0]),D.isMacintosh&&(X==="editor.action.clipboardCutAction"?V.role="cut":X==="editor.action.clipboardCopyAction"?V.role="copy":X==="editor.action.clipboardPasteAction"&&(V.role="paste"),X==="undo"?V.click=this.V(O,{inDevTools:ie=>ie.undo(),inNoWindow:()=>I.Menu.sendActionToFirstResponder("undo:")}):X==="redo"?V.click=this.V(O,{inDevTools:ie=>ie.redo(),inNoWindow:()=>I.Menu.sendActionToFirstResponder("redo:")}):X==="editor.action.selectAll"&&(V.click=this.V(O,{inDevTools:ie=>ie.selectAll(),inNoWindow:()=>I.Menu.sendActionToFirstResponder("selectAll:")}))),new I.MenuItem(this.X(X,V))}V(l,s){return(d,S,R)=>{const O=I.BrowserWindow.getFocusedWindow();if(!O)return s.inNoWindow();if(O.webContents.isDevToolsFocused()&&O.webContents.devToolsWebContents)return s.inDevTools(O.webContents.devToolsWebContents);l(d,S||O,R)}}W(l){let s=I.BrowserWindow.getFocusedWindow();if(!s){const S=this.p.getLastActiveWindow();S?.isMinimized()&&(s=S.win)}const d=s?this.p.getWindowById(s.id):void 0;if(d){if(this.v.trace("menubar#runActionInRenderer",l),D.isMacintosh&&!this.q.isBuilt&&!d.isReady&&(l.type==="commandId"&&l.commandId==="workbench.action.toggleDevTools"||l.type!=="commandId"&&l.userSettingsLabel==="alt+cmd+i"))return;if(l.type==="commandId"){const S={id:l.commandId,from:"menu"};d.sendWhenReady("vscode:runAction",n.CancellationToken.None,S)}else{const S={userSettingsLabel:l.userSettingsLabel};d.sendWhenReady("vscode:runKeybinding",n.CancellationToken.None,S)}}else this.v.trace("menubar#runActionInRenderer: no active window found",l)}X(l,s){const d=typeof l=="string"?this.l[l]:void 0;if(d?.label){if(d.isNative!==!1)s.accelerator=d.label,s.userSettingsLabel=d.userSettingsLabel;else if(typeof s.label=="string"){const S=s.label.indexOf("[");S>=0?s.label=`${s.label.substr(0,S)} [${d.label}]`:s.label=`${s.label} [${d.label}]`}}else s.accelerator=void 0;return s}Y(l,s,d=!s.accelerator){d&&(s=this.X(l,s));const S=s.click;return s.click=(R,O,N)=>{this.ab(l),S?.(R,O,N)},s}Z(l,s){this.w.openExternal(void 0,l),this.ab(s)}ab(l){this.r.publicLog2("workbenchActionExecuted",{id:l,from:a})}bb(l){return(0,C.mnemonicMenuLabel)(l,!this.B)}};i.a="lastKnownMenubarData",i=ve([_(0,k.IUpdateService),_(1,h.IConfigurationService),_(2,M.IWindowsMainService),_(3,v.IEnvironmentMainService),_(4,p.ITelemetryService),_(5,t.IWorkspacesHistoryMainService),_(6,u.IStateMainService),_(7,y.ILifecycleMainService),_(8,g.ILogService),_(9,w.INativeHostMainService),_(10,o.IProductService)],i),e.Menubar=i;function r(){return new I.MenuItem({type:"separator"})}}),define(ee[280],te([0,1,6,21,5,279]),function(G,e,I,A,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,I.createDecorator)("menubarMainService");let D=class{constructor(f,h,b){this.b=f,this.c=h,this.d=b,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(C.Menubar)}async updateMenubar(f,h){this.d.trace("menubarService#updateMenubar",f),(await this.a).updateMenu(h,f)}};D=ve([_(0,I.IInstantiationService),_(1,A.ILifecycleMainService),_(2,n.ILogService)],D),e.MenubarMainService=D}),define(ee[281],te([0,1,14,23,26,25,22,3,32,50,45,2,15,9,64,4,36,18,10,7,178,63,19,58,28,16,6,21,5,66,20,67,56,34,77,278,120,273,29,98,79,54,69,37,53,65,48]),function(G,e,I,A,n,C,D,P,f,h,b,v,y,g,m,w,o,u,p,k,E,M,t,a,i,r,c,l,s,d,S,R,O,N,K,V,X,ie,re,ce,fe,ge,x,F,W,z,J){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function ne(U){return(0,re.isWorkspaceIdentifier)(U?.workspace)}function se(U){return(0,re.isSingleFolderWorkspaceIdentifier)(U?.workspace)}let Z=class lt extends v.Disposable{constructor(L,T,B,H,j,$,q,oe,de,pe,ye,Le,Fe,Te,we,Ce,Re,Q,ae){super(),this.k=L,this.l=T,this.m=B,this.n=H,this.r=j,this.s=$,this.t=q,this.u=oe,this.v=de,this.w=pe,this.z=ye,this.C=Le,this.D=Fe,this.F=Te,this.G=we,this.H=Ce,this.I=Re,this.J=Q,this.L=ae,this.b=this.B(new P.Emitter),this.onDidOpenWindow=this.b.event,this.c=this.B(new P.Emitter),this.onDidSignalReadyWindow=this.c.event,this.f=this.B(new P.Emitter),this.onDidDestroyWindow=this.f.event,this.g=this.B(new P.Emitter),this.onDidChangeWindowsCount=this.g.event,this.h=this.B(new P.Emitter),this.onDidTriggerSystemContextMenu=this.h.event,this.j=this.B(new ie.WindowsStateHandler(this,this.r,this.v,this.m,this.z)),this.M()}M(){this.B(this.D.onDidEnterWorkspace(L=>this.c.fire(L.window))),this.B(this.onDidSignalReadyWindow(L=>{if(L.config?.extensionDevelopmentPath||L.config?.extensionTestsPath){const T=new v.DisposableStore;if(T.add(P.Event.any(L.onDidClose,L.onDidDestroy)(()=>T.dispose())),L.config.extensionDevelopmentPath)for(const B of L.config.extensionDevelopmentPath)T.add(this.J.addValidFileRoot(B));L.config.extensionTestsPath&&T.add(this.J.addValidFileRoot(L.config.extensionTestsPath))}}))}openEmptyWindow(L,T){const B=this.t.args,H=T?.remoteAuthority||void 0,j=!0,$=T?.forceReuseWindow,q=!$;return this.open({...L,cli:B,forceEmpty:j,forceNewWindow:q,forceReuseWindow:$,remoteAuthority:H})}openExistingWindow(L,T){L.focus(),this.N(T,[L])}async open(L){this.m.trace("windowsManager#open"),L.addMode&&(L.initialStartup||!this.getLastActiveWindow())&&(L.addMode=!1);const T=[],B=[],H=[],j=[],$=[];let q,oe=0;const de=await this.U(L);this.m.trace("windowsManager#open pathsToOpen",de);for(const Te of de)se(Te)?L.addMode?T.push(Te):B.push(Te):ne(Te)?H.push(Te):Te.fileUri?(q||(q={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Te.remoteAuthority}),q.filesToOpenOrCreate.push(Te)):Te.backupPath?$.push({backupFolder:(0,g.basename)(Te.backupPath),remoteAuthority:Te.remoteAuthority}):oe++;L.diffMode&&q&&q.filesToOpenOrCreate.length>=2&&(q.filesToDiff=q.filesToOpenOrCreate.slice(0,2),q.filesToOpenOrCreate=[]),L.mergeMode&&q&&q.filesToOpenOrCreate.length===4&&(q.filesToMerge=q.filesToOpenOrCreate.slice(0,4),q.filesToOpenOrCreate=[],q.filesToDiff=[]),q&&L.waitMarkerFileURI&&(q.filesToWait={paths:(0,C.coalesce)([...q.filesToDiff,q.filesToMerge[3],...q.filesToOpenOrCreate]),waitMarkerFileUri:L.waitMarkerFileURI}),L.initialStartup?(j.push(...this.D.getUntitledWorkspaces()),H.push(...j),$.push(...this.w.getEmptyWindowBackups())):$.length=0;const{windows:pe,filesOpenedInWindow:ye}=await this.O(L,H,B,$,oe,q,T);if(this.m.trace(`windowsManager#open used window count ${pe.length} (workspacesToOpen: ${H.length}, foldersToOpen: ${B.length}, emptyToRestore: ${$.length}, emptyToOpen: ${oe})`),pe.length>1)if(ye)ye.focus();else{const Te=this.j.state.lastActiveWindow&&!L.forceEmpty&&!L.cli._.length&&!L.cli["file-uri"]&&!L.cli["folder-uri"]&&!(L.urisToOpen&&L.urisToOpen.length);let we=!0,Ce=!0;if(Te){const Re=pe.filter(Q=>this.j.state.lastActiveWindow&&Q.backupPath===this.j.state.lastActiveWindow.backupPath);Re.length&&(Re[0].focus(),we=!1,Ce=!1)}if(we)for(let Re=pe.length-1;Re>=0;Re--){const Q=pe[Re];if(!(Q.openedWorkspace&&j.some(ae=>Q.openedWorkspace&&ae.workspace.id===Q.openedWorkspace.id)||Q.backupPath&&$.some(ae=>Q.backupPath&&ae.backupFolder===(0,g.basename)(Q.backupPath)))){Q.focus(),Ce=!1;break}}Ce&&pe[pe.length-1].focus()}const Le=q&&q.filesToDiff.length>0,Fe=q&&q.filesToMerge.length>0;if(!pe.some(Te=>Te.isExtensionDevelopmentHost)&&!Le&&!Fe&&!L.noRecentEntry){const Te=[];for(const we of de)ne(we)&&!we.transient?Te.push({label:we.label,workspace:we.workspace,remoteAuthority:we.remoteAuthority}):se(we)?Te.push({label:we.label,folderUri:we.workspace.uri,remoteAuthority:we.remoteAuthority}):we.fileUri&&Te.push({label:we.label,fileUri:we.fileUri,remoteAuthority:we.remoteAuthority});this.C.addRecentlyOpened(Te)}return this.N(L,pe),pe}N(L,T){const B=L.waitMarkerFileURI;L.context===0&&B&&T.length===1&&T[0]&&(async()=>{await T[0].whenClosedOrLoaded;try{await this.H.del(B)}catch{}})()}async O(L,T,B,H,j,$,q){const oe=[];let de;function pe(Re,Q){oe.push(Re),Q&&(de=Re,$=void 0)}let{openFolderInNewWindow:ye,openFilesInNewWindow:Le}=this.gb(L);if(!L.initialStartup&&q.length>0){const Re=q[0].remoteAuthority,Q=this.lb(Re);Q&&pe(this.Q(Q,q.map(ae=>ae.workspace.uri)))}const Fe=B.length+T.length+H.length;if($&&Fe===0){const Re=$.filesToOpenOrCreate[0]||$.filesToDiff[0]||$.filesToMerge[3],Q=this.getWindows().filter(he=>$&&(0,u.isEqualAuthority)(he.remoteAuthority,$.remoteAuthority));let ae;Re?.fileUri&&!Le&&((L.context===4||L.context===0||L.context===1)&&(ae=await(0,X.findWindowOnFile)(Q,Re.fileUri,async he=>he.configPath.scheme===y.Schemas.file?this.D.resolveLocalWorkspace(he.configPath):void 0)),ae||(ae=this.mb(Q))),ae?(0,re.isWorkspaceIdentifier)(ae.openedWorkspace)?T.push({workspace:ae.openedWorkspace,remoteAuthority:ae.remoteAuthority}):(0,re.isSingleFolderWorkspaceIdentifier)(ae.openedWorkspace)?B.push({workspace:ae.openedWorkspace,remoteAuthority:ae.remoteAuthority}):pe(this.P(L,ae,$),!0):pe(await this.hb({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,filesToOpen:$,forceNewWindow:!0,remoteAuthority:$.remoteAuthority,forceNewTabbedWindow:L.forceNewTabbedWindow,forceProfile:L.forceProfile,forceTempProfile:L.forceTempProfile}),!0)}const Te=(0,C.distinct)(T,Re=>Re.workspace.id);if(Te.length>0){const Re=(0,C.coalesce)(Te.map(Q=>(0,X.findWindowOnWorkspaceOrFolder)(this.getWindows(),Q.workspace.configPath)));if(Re.length>0){const Q=Re[0],ae=(0,u.isEqualAuthority)($?.remoteAuthority,Q.remoteAuthority)?$:void 0;pe(this.P(L,Q,ae),!!ae),ye=!0}for(const Q of Te){if(Re.some(Pe=>Pe.openedWorkspace&&Pe.openedWorkspace.id===Q.workspace.id))continue;const ae=Q.remoteAuthority,he=(0,u.isEqualAuthority)($?.remoteAuthority,ae)?$:void 0;pe(await this.S(L,Q,ye,he),!!he),ye=!0}}const we=(0,C.distinct)(B,Re=>u.extUriBiasedIgnorePathCase.getComparisonKey(Re.workspace.uri));if(we.length>0){const Re=(0,C.coalesce)(we.map(Q=>(0,X.findWindowOnWorkspaceOrFolder)(this.getWindows(),Q.workspace.uri)));if(Re.length>0){const Q=Re[0],ae=(0,u.isEqualAuthority)($?.remoteAuthority,Q.remoteAuthority)?$:void 0;pe(this.P(L,Q,ae),!!ae),ye=!0}for(const Q of we){if(Re.some(Pe=>(0,re.isSingleFolderWorkspaceIdentifier)(Pe.openedWorkspace)&&u.extUriBiasedIgnorePathCase.isEqual(Pe.openedWorkspace.uri,Q.workspace.uri)))continue;const ae=Q.remoteAuthority,he=(0,u.isEqualAuthority)($?.remoteAuthority,ae)?$:void 0;pe(await this.S(L,Q,ye,he),!!he),ye=!0}}const Ce=(0,C.distinct)(H,Re=>Re.backupFolder);if(Ce.length>0)for(const Re of Ce){const Q=Re.remoteAuthority,ae=(0,u.isEqualAuthority)($?.remoteAuthority,Q)?$:void 0;pe(await this.R(L,!0,Q,ae,Re),!!ae),ye=!0}if(oe.length===0||$){$&&!j&&j++;const Re=$?$.remoteAuthority:L.remoteAuthority;for(let Q=0;Q<j;Q++)pe(await this.R(L,ye,Re,$),!!$),ye=!0}return{windows:(0,C.distinct)(oe),filesOpenedInWindow:de}}P(L,T,B){this.m.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:B}),T.focus();const H={filesToOpenOrCreate:B?.filesToOpenOrCreate,filesToDiff:B?.filesToDiff,filesToMerge:B?.filesToMerge,filesToWait:B?.filesToWait,termProgram:L?.userEnv?.TERM_PROGRAM};return T.sendWhenReady("vscode:openFiles",D.CancellationToken.None,H),T}Q(L,T){this.m.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:T}),L.focus();const B={foldersToAdd:T};return L.sendWhenReady("vscode:addFolders",D.CancellationToken.None,B),L}R(L,T,B,H,j){this.m.trace("windowsManager#doOpenEmpty",{restore:!!j,remoteAuthority:B,filesToOpen:H,forceNewWindow:T});let $;return!T&&typeof L.contextWindowId=="number"&&($=this.getWindowById(L.contextWindowId)),this.hb({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:B,forceNewWindow:T,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:H,windowToUse:$,emptyWindowBackupInfo:j,forceProfile:L.forceProfile,forceTempProfile:L.forceTempProfile})}S(L,T,B,H,j){return this.m.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:T,filesToOpen:H}),!B&&!j&&typeof L.contextWindowId=="number"&&(j=this.getWindowById(L.contextWindowId)),this.hb({workspace:T.workspace,userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:T.remoteAuthority,forceNewWindow:B,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:H,windowToUse:j,forceProfile:L.forceProfile,forceTempProfile:L.forceTempProfile})}async U(L){let T,B=!1,H=!1;if(L.urisToOpen&&L.urisToOpen.length>0?(T=await this.W(L),B=!0):L.forceEmpty?T=[Object.create(null)]:L.cli._.length||L.cli["folder-uri"]||L.cli["file-uri"]?(T=await this.X(L.cli),T.length===0&&T.push(Object.create(null)),B=!0):(T=await this.Z(),T.length===0&&T.push(Object.create(null)),H=!0),!L.addMode&&B){const j=T.filter($=>se($));if(j.length>1){const $=j[0].remoteAuthority;if(j.every(q=>(0,u.isEqualAuthority)(q.remoteAuthority,$))){const q=await this.D.createUntitledWorkspace(j.map(oe=>({uri:oe.workspace.uri})));T.push({workspace:q,remoteAuthority:$}),T=T.filter(oe=>!se(oe))}}}if(L.initialStartup&&!H&&this.z.getValue("window")?.restoreWindows==="preserve"){const j=await this.Z();T.unshift(...j.filter($=>ne($)||se($)||$.backupPath))}return T}async W(L){const T={gotoLineMode:L.gotoLineMode,remoteAuthority:L.remoteAuthority},B=await Promise.all((0,C.coalesce)(L.urisToOpen||[]).map(async H=>{const j=await this.bb(H,T);if(j)return j.label=H.label,j;const $=this.db(H);this.G.showMessageBox((0,J.massageMessageBoxOptions)({type:"info",buttons:[(0,E.localize)(0,null)],message:$.scheme===y.Schemas.file?(0,E.localize)(1,null):(0,E.localize)(2,null),detail:$.scheme===y.Schemas.file?(0,E.localize)(3,null,(0,b.getPathLabel)($,{os:w.OS,tildify:this.t})):(0,E.localize)(4,null,$.toString(!0))},this.I).options,(0,p.withNullAsUndefined)(I.BrowserWindow.getFocusedWindow()))}));return(0,C.coalesce)(B)}async X(L){const T=[],B={ignoreFileNotFound:!0,gotoLineMode:L.goto,remoteAuthority:L.remote||void 0,forceOpenWorkspaceAsFile:L.diff&&L._.length===2||L.merge&&L._.length===4},H=L["folder-uri"];if(H){const q=await Promise.all(H.map(oe=>{const de=this.Y(oe);if(!!de)return this.bb({folderUri:de},B)}));T.push(...(0,C.coalesce)(q))}const j=L["file-uri"];if(j){const q=await Promise.all(j.map(oe=>{const de=this.Y(oe);if(!!de)return this.bb((0,re.hasWorkspaceFileExtension)(oe)?{workspaceUri:de}:{fileUri:de},B)}));T.push(...(0,C.coalesce)(q))}const $=await Promise.all(L._.map(q=>B.remoteAuthority?this.fb(q,B):this.eb(q,B)));return T.push(...(0,C.coalesce)($)),T}Y(L){try{const T=k.URI.parse(L);if(!T.scheme){this.m.error(`Invalid URI input string, scheme missing: ${L}`);return}return T}catch(T){this.m.error(`Invalid URI input string: ${L}, ${T.message}`)}}async Z(){const L=this.ab();switch(L){case"none":return[];case"one":case"all":case"preserve":case"folders":{const T=[];L!=="one"&&T.push(...this.j.state.openedWindows),this.j.state.lastActiveWindow&&T.push(this.j.state.lastActiveWindow);const B=await Promise.all(T.map(async H=>{if(H.workspace){const j=await this.bb({workspaceUri:H.workspace.configPath},{remoteAuthority:H.remoteAuthority,rejectTransientWorkspaces:!0});if(ne(j))return j}else if(H.folderUri){const j=await this.bb({folderUri:H.folderUri},{remoteAuthority:H.remoteAuthority});if(se(j))return j}else if(L!=="folders"&&H.backupPath)return{backupPath:H.backupPath,remoteAuthority:H.remoteAuthority}}));return(0,C.coalesce)(B)}}}ab(){let L;return this.v.wasRestarted?L="all":(L=this.z.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(L)||(L="all")),L}async bb(L,T=Object.create(null)){const B=this.db(L);return B.scheme===y.Schemas.file?((0,K.isFileToOpen)(L)&&(T={...T,forceOpenWorkspaceAsFile:!0}),this.eb(B.fsPath,T)):this.cb(L,T)}cb(L,T){let B=this.db(L);const H=(0,O.getRemoteAuthority)(B)||T.remoteAuthority;if(B=(0,u.removeTrailingPathSeparator)((0,u.normalizePath)(B)),(0,K.isFileToOpen)(L)){if(T.gotoLineMode){const{path:j,line:$,column:q}=(0,f.parseLineAndColumnAware)(B.path);return{fileUri:B.with({path:j}),options:{selection:$?{startLineNumber:$,startColumn:q||1}:void 0},remoteAuthority:H}}return{fileUri:B,remoteAuthority:H}}else if((0,K.isWorkspaceToOpen)(L))return{workspace:(0,ce.getWorkspaceIdentifier)(B),remoteAuthority:H};return{workspace:(0,ce.getSingleFolderWorkspaceIdentifier)(B),remoteAuthority:H}}db(L){return(0,K.isWorkspaceToOpen)(L)?L.workspaceUri:(0,K.isFolderToOpen)(L)?L.folderUri:L.fileUri}async eb(L,T){let B,H;T.gotoLineMode&&({path:L,line:B,column:H}=(0,f.parseLineAndColumnAware)(L)),L=(0,f.sanitizeFilePath)((0,g.normalize)(L),(0,o.cwd)());try{const j=await A.Promises.stat(L);if(j.isFile()){if(!T.forceOpenWorkspaceAsFile){const $=await this.D.resolveLocalWorkspace(k.URI.file(L));if($)return $.transient&&T.rejectTransientWorkspaces?void 0:{workspace:{id:$.id,configPath:$.configPath},type:r.FileType.File,exists:!0,remoteAuthority:$.remoteAuthority,transient:$.transient}}return{fileUri:k.URI.file(L),type:r.FileType.File,exists:!0,options:{selection:B?{startLineNumber:B,startColumn:H||1}:void 0}}}else{if(j.isDirectory())return{workspace:(0,ce.getSingleFolderWorkspaceIdentifier)(k.URI.file(L),j),type:r.FileType.Directory,exists:!0};if(!w.isWindows&&L==="/dev/null")return{fileUri:k.URI.file(L),type:r.FileType.File,exists:!0}}}catch{const $=k.URI.file(L);if(this.C.removeRecentlyOpened([$]),T.ignoreFileNotFound)return{fileUri:$,type:r.FileType.File,exists:!1}}}fb(L,T){const B=L.charCodeAt(0),H=T.remoteAuthority;let j,$;T.gotoLineMode&&({path:L,line:j,column:$}=(0,f.parseLineAndColumnAware)(L)),B!==47&&((0,f.isWindowsDriveLetter)(B)&&L.charCodeAt(L.charCodeAt(1))===58&&(L=(0,f.toSlashes)(L)),L=`/${L}`);const q=k.URI.from({scheme:y.Schemas.vscodeRemote,authority:H,path:L});if(L.charCodeAt(L.length-1)!==47){if((0,re.hasWorkspaceFileExtension)(L))return T.forceOpenWorkspaceAsFile?{fileUri:q,options:{selection:j?{startLineNumber:j,startColumn:$||1}:void 0},remoteAuthority:T.remoteAuthority}:{workspace:(0,ce.getWorkspaceIdentifier)(q),remoteAuthority:H};if(T.gotoLineMode||g.posix.basename(L).indexOf(".")!==-1)return{fileUri:q,options:{selection:j?{startLineNumber:j,startColumn:$||1}:void 0},remoteAuthority:H}}return{workspace:(0,ce.getSingleFolderWorkspaceIdentifier)(q),remoteAuthority:H}}gb(L){const T=this.z.getValue("window"),B=T?.openFoldersInNewWindow||"default",H=T?.openFilesInNewWindow||"off";let j=(L.preferNewWindow||L.forceNewWindow)&&!L.forceReuseWindow;!L.forceNewWindow&&!L.forceReuseWindow&&(B==="on"||B==="off")&&(j=B==="on");let $=!1;return L.forceNewWindow||L.forceReuseWindow?$=!!L.forceNewWindow&&!L.forceReuseWindow:(w.isMacintosh?L.context===1&&($=!0):L.context!==3&&L.context!==2&&!(L.userEnv&&L.userEnv.TERM_PROGRAM==="vscode")&&($=!0),!L.cli.extensionDevelopmentPath&&(H==="on"||H==="off")&&($=H==="on")),{openFolderInNewWindow:!!j,openFilesInNewWindow:$}}async openExtensionDevelopmentHostWindow(L,T){const B=(0,X.findWindowOnExtensionDevelopmentPath)(this.getWindows(),L);if(B)return this.v.reload(B,T.cli),B.focus(),[B];let H=T.cli["folder-uri"]||[],j=T.cli["file-uri"]||[],$=T.cli._;if(!$.length&&!H.length&&!j.length&&!T.cli.extensionTestsPath){const de=this.j.state.lastPluginDevelopmentHostWindow,pe=de?.workspace??de?.folderUri;pe&&(k.URI.isUri(pe)?pe.scheme===y.Schemas.file?$=[pe.fsPath]:H=[pe.toString()]:pe.configPath.scheme===y.Schemas.file?$=[(0,u.originalFSPath)(pe.configPath)]:j=[pe.configPath.toString()])}let q=T.remoteAuthority;for(const de of L)if(de.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const pe=k.URI.parse(de),ye=(0,O.getRemoteAuthority)(pe);ye&&(q?(0,u.isEqualAuthority)(ye,q)||this.m.error("more than one extension development path authority"):q=ye)}$=$.filter(de=>{const pe=k.URI.file(de);return(0,X.findWindowOnWorkspaceOrFolder)(this.getWindows(),pe)?!1:(0,u.isEqualAuthority)((0,O.getRemoteAuthority)(pe),q)}),H=H.filter(de=>{const pe=this.Y(de);return pe&&!!(0,X.findWindowOnWorkspaceOrFolder)(this.getWindows(),pe)?!1:pe?(0,u.isEqualAuthority)((0,O.getRemoteAuthority)(pe),q):!1}),j=j.filter(de=>{const pe=this.Y(de);return pe&&!!(0,X.findWindowOnWorkspaceOrFolder)(this.getWindows(),pe)?!1:pe?(0,u.isEqualAuthority)((0,O.getRemoteAuthority)(pe),q):!1}),T.cli._=$,T.cli["folder-uri"]=H,T.cli["file-uri"]=j;const oe={context:T.context,cli:T.cli,forceNewWindow:!0,forceEmpty:!$.length&&!H.length&&!j.length,userEnv:T.userEnv,noRecentEntry:!0,waitMarkerFileURI:T.waitMarkerFileURI,remoteAuthority:q,forceProfile:T.forceProfile,forceTempProfile:T.forceTempProfile};return this.open(oe)}async hb(L){const T=this.z.getValue("window"),B=this.getLastActiveWindow(),H=B?.profile??this.u.defaultProfile;let j;!L.forceNewWindow&&!L.forceNewTabbedWindow&&(j=L.windowToUse||B,j&&j.focus());const $={...this.t.args,...L.cli,machineId:this.k,windowId:-1,mainPid:process.pid,appRoot:this.t.appRoot,execPath:process.execPath,codeCachePath:this.t.codeCachePath,backupPath:L.emptyWindowBackupInfo?(0,g.join)(this.t.backupHome,L.emptyWindowBackupInfo.backupFolder):void 0,profiles:{all:this.u.profiles,profile:H},homeDir:this.t.userHome.fsPath,tmpDir:this.t.tmpDir.fsPath,userDataDir:this.t.userDataPath,remoteAuthority:L.remoteAuthority,workspace:L.workspace,userEnv:{...this.l,...L.userEnv},filesToOpenOrCreate:L.filesToOpen?.filesToOpenOrCreate,filesToDiff:L.filesToOpen?.filesToDiff,filesToMerge:L.filesToOpen?.filesToMerge,filesToWait:L.filesToOpen?.filesToWait,logLevel:this.m.getLevel(),loggers:{window:[],global:this.n.getRegisteredLoggers()},logsPath:this.t.logsPath,product:d.default,isInitialStartup:L.initialStartup,perfMarks:(0,m.getMarks)(),os:{release:(0,n.release)(),hostname:(0,n.hostname)()},zoomLevel:typeof T?.zoomLevel=="number"?T.zoomLevel:void 0,autoDetectHighContrast:T?.autoDetectHighContrast??!0,autoDetectColorScheme:T?.autoDetectColorScheme??!1,accessibilitySupport:I.app.accessibilitySupportEnabled,colorScheme:this.L.getColorScheme(),policiesData:this.s.serialize(),continueOn:this.t.continueOn};if(j){const q=j.config;!$.extensionDevelopmentPath&&q?.extensionDevelopmentPath&&($.extensionDevelopmentPath=q.extensionDevelopmentPath,$.extensionDevelopmentKind=q.extensionDevelopmentKind,$["enable-proposed-api"]=q["enable-proposed-api"],$.verbose=q.verbose,$["inspect-extensions"]=q["inspect-extensions"],$["inspect-brk-extensions"]=q["inspect-brk-extensions"],$.debugId=q.debugId,$.extensionEnvironment=q.extensionEnvironment,$["extensions-dir"]=q["extensions-dir"],$["disable-extensions"]=q["disable-extensions"]),$.loggers=q?.loggers??$.loggers}else{const q=this.j.getNewWindowState($);(0,m.mark)("code/willCreateCodeWindow");const oe=j=this.F.createInstance(V.CodeWindow,{state:q,extensionDevelopmentPath:$.extensionDevelopmentPath,isExtensionTestHost:!!$.extensionTestsPath});(0,m.mark)("code/didCreateCodeWindow"),L.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(oe),lt.a.push(oe),this.b.fire(oe),this.g.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,h.once)(oe.onDidSignalReady)(()=>this.c.fire(oe)),(0,h.once)(oe.onDidClose)(()=>this.kb(oe)),(0,h.once)(oe.onDidDestroy)(()=>this.f.fire(oe)),oe.onDidTriggerSystemContextMenu(({x:pe,y:ye})=>this.h.fire({window:oe,x:pe,y:ye}));const de=(0,p.assertIsDefined)(oe.win?.webContents);de.removeAllListeners("devtools-reload-page"),de.on("devtools-reload-page",()=>this.v.reload(oe)),this.v.registerWindow(oe)}return $.windowId=j.id,j.isReady?this.v.unload(j,4).then(async q=>{q||await this.ib(j,$,L,H)}):await this.ib(j,$,L,H),j}async ib(L,T,B,H){if(T.extensionDevelopmentPath||((0,re.isWorkspaceIdentifier)(T.workspace)?T.backupPath=this.w.registerWorkspaceBackup({workspace:T.workspace,remoteAuthority:T.remoteAuthority}):(0,re.isSingleFolderWorkspaceIdentifier)(T.workspace)?T.backupPath=this.w.registerFolderBackup({folderUri:T.workspace.uri,remoteAuthority:T.remoteAuthority}):T.backupPath=this.w.registerEmptyWindowBackup({backupFolder:B.emptyWindowBackupInfo?.backupFolder??(0,ce.createEmptyWorkspaceIdentifier)().id,remoteAuthority:T.remoteAuthority})),this.u.isEnabled()){const j=T.workspace??(0,re.toWorkspaceIdentifier)(T.backupPath,!1),$=this.jb(B,j,H),q=$ instanceof Promise?await $:$;T.profiles.profile=q,T.extensionDevelopmentPath||await this.u.setProfileForWorkspace(j,q)}L.load(T)}jb(L,T,B){return L.forceProfile?this.u.profiles.find(H=>H.name===L.forceProfile)??this.u.createNamedProfile(L.forceProfile):L.forceTempProfile?this.u.createTransientProfile():this.u.getProfileForWorkspace(T)??B}kb(L){const T=lt.a.indexOf(L);lt.a.splice(T,1),this.g.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const L=I.BrowserWindow.getFocusedWindow();if(L)return this.getWindowById(L.id)}getLastActiveWindow(){return this.mb(this.getWindows())}lb(L){return this.mb(this.getWindows().filter(T=>(0,u.isEqualAuthority)(T.remoteAuthority,L)))}mb(L){const T=Math.max.apply(Math,L.map(B=>B.lastFocusTime));return L.find(B=>B.lastFocusTime===T)}sendToFocused(L,...T){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(L,D.CancellationToken.None,...T)}sendToAll(L,T,B){for(const H of this.getWindows())B&&B.indexOf(H.id)>=0||H.sendWhenReady(L,D.CancellationToken.None,T)}getWindows(){return lt.a}getWindowCount(){return lt.a.length}getWindowById(L){const T=this.getWindows().filter(B=>B.id===L);return(0,C.firstOrDefault)(T)}getWindowByWebContents(L){const T=I.BrowserWindow.fromWebContents(L);if(!!T)return this.getWindowById(T.id)}};Z.a=[],Z=ve([_(2,s.ILogService),_(3,z.ILoggerMainService),_(4,N.IStateMainService),_(5,F.IPolicyService),_(6,i.IEnvironmentMainService),_(7,W.IUserDataProfilesMainService),_(8,l.ILifecycleMainService),_(9,M.IBackupMainService),_(10,t.IConfigurationService),_(11,fe.IWorkspacesHistoryMainService),_(12,ge.IWorkspacesManagementMainService),_(13,c.IInstantiationService),_(14,a.IDialogMainService),_(15,r.IFileService),_(16,S.IProductService),_(17,R.IProtocolMainService),_(18,x.IThemeMainService)],Z),e.WindowsMainService=Z}),define(ee[282],te([0,1,63,30,79,54]),function(G,e,I,A,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let D=class{constructor(f,h,b,v){this.a=f,this.b=h,this.c=b,this.d=v,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(f,h){const b=this.b.getWindowById(f);if(b)return this.a.enterWorkspace(b,this.b.getWindows(),h)}createUntitledWorkspace(f,h,b){return this.a.createUntitledWorkspace(h,b)}deleteUntitledWorkspace(f,h){return this.a.deleteUntitledWorkspace(h)}getWorkspaceIdentifier(f,h){return this.a.getWorkspaceIdentifier(h)}getRecentlyOpened(f){return this.c.getRecentlyOpened()}addRecentlyOpened(f,h){return this.c.addRecentlyOpened(h)}removeRecentlyOpened(f,h){return this.c.removeRecentlyOpened(h)}clearRecentlyOpened(f){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};D=ve([_(0,C.IWorkspacesManagementMainService),_(1,A.IWindowsMainService),_(2,n.IWorkspacesHistoryMainService),_(3,I.IBackupMainService)],D),e.WorkspacesMainService=D}),define(ee[283],te([0,1,14,42,26,17,44,13,32,50,43,45,2,15,9,4,10,7,31,136,47,150,105,256,153,63,274,19,75,186,88,121,58,108,209,28,62,112,199,222,200,261,109,201,202,16,213,90,74,6,89,275,235,258,21,5,280,59,20,56,268,92,34,264,96,93,24,240,114,52,49,247,248,276,249,277,117,251,252,253,254,262,30,281,263,29,97,79,282,54,257,37,221,53,231,57,78,119,266,272,270,8,115,265,216,65,48]),function(G,e,I,A,n,C,D,P,f,h,b,v,y,g,m,w,o,u,p,k,E,M,t,a,i,r,c,l,s,d,S,R,O,N,K,V,X,ie,re,ce,fe,ge,x,F,W,z,J,ne,se,Z,U,L,T,B,H,j,$,q,oe,de,pe,ye,Le,Fe,Te,we,Ce,Re,Q,ae,he,Pe,Me,Ae,Ue,He,Ne,$e,Ge,We,Ve,Y,le,ue,me,Se,Oe,ze,tt,Qe,Ke,et,it,ot,ut,Dt,Ct,Rt,Mt,At,Lt,gt,Ot,Tt,Ft,Ut,Wt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let mt=class extends y.Disposable{constructor(ke,Ie,be,Ee,De,je,Xe,Ye,qe,Be,xe){super(),this.c=ke,this.f=Ie,this.g=be,this.h=Ee,this.i=De,this.j=je,this.k=Xe,this.l=Ye,this.m=qe,this.n=Be,this.p=xe,this.r(),this.s()}r(){const ke=qe=>qe?.startsWith(`${g.Schemas.vscodeWebview}://`),Ie=new Set(["clipboard-read","clipboard-sanitized-write"]);I.session.defaultSession.setPermissionRequestHandler((qe,Be,xe,Je)=>ke(Je.requestingUrl)?xe(Ie.has(Be)):xe(!1)),I.session.defaultSession.setPermissionCheckHandler((qe,Be,xe,Je)=>ke(Je.requestingUrl)?Ie.has(Be):!1);const be=new Set([g.Schemas.file,g.Schemas.vscodeFileResource,g.Schemas.vscodeRemoteResource,"devtools"]),Ee=qe=>{for(let Be=qe;Be;Be=Be.parent)if(Be.url.startsWith(`${g.Schemas.vscodeWebview}://`))return!0;return!1},De=qe=>qe.resourceType==="xhr"||Ee(qe.frame),je=qe=>{const Be=qe.frame;if(!Be||!this.a)return!1;const xe=I.BrowserWindow.getAllWindows();for(const Je of xe)if(Be.processId===Je.webContents.mainFrame.processId)return!0;return!1},Xe=(qe,Be)=>{if(qe.path!=="/index.html")return!0;const xe=Be.frame;if(!xe||!this.a)return!1;for(const Je of this.a.getWindows())if(Je.win&&xe.processId===Je.win.webContents.mainFrame.processId)return!0;return!1};I.session.defaultSession.webRequest.onBeforeRequest((qe,Be)=>{const xe=u.URI.parse(qe.url);return xe.scheme===g.Schemas.vscodeWebview&&!Xe(xe,qe)?(this.h.error("Blocked vscode-webview request",qe.url),Be({cancel:!0})):xe.scheme===g.Schemas.vscodeFileResource&&!je(qe)?(this.h.error("Blocked vscode-file request",qe.url),Be({cancel:!0})):xe.path.endsWith(".svg")&&!be.has(xe.scheme)?Be({cancel:!De(qe)}):Be({cancel:!1})}),I.session.defaultSession.webRequest.onHeadersReceived((qe,Be)=>{const xe=qe.responseHeaders,Je=xe["content-type"]||xe["Content-Type"];if(Je&&Array.isArray(Je)){const Ze=u.URI.parse(qe.url);if(Ze.path.endsWith(".svg")&&be.has(Ze.scheme))return xe["Content-Type"]=["image/svg+xml"],Be({cancel:!1,responseHeaders:xe});if(!Ze.path.endsWith(g.Schemas.vscodeRemoteResource)&&Je.some(st=>st.toLowerCase().includes("image/svg")))return Be({cancel:!De(qe)})}return Be({cancel:!1})});const Ye=I.session.defaultSession;typeof Ye.setCodeCachePath=="function"&&this.i.codeCachePath&&Ye.setCodeCachePath((0,m.join)(this.i.codeCachePath,"chrome"))}s(){(0,P.setUnexpectedErrorHandler)(be=>this.u(be)),process.on("uncaughtException",be=>(0,P.onUnexpectedError)(be)),process.on("unhandledRejection",be=>(0,P.onUnexpectedError)(be)),this.j.onWillShutdown(()=>this.dispose()),(0,k.registerContextMenuListener)(),I.app.on("accessibility-support-changed",(be,Ee)=>{this.a?.sendToAll("vscode:accessibilitySupportChanged",Ee)}),I.app.on("activate",async(be,Ee)=>{this.h.trace("app#activate"),Ee||await this.a?.openEmptyWindow({context:1})}),I.app.on("web-contents-created",(be,Ee)=>{Ee.on("will-navigate",De=>{this.h.error("webContents#will-navigate: Prevented webcontent navigation"),De.preventDefault()}),Ee.setWindowOpenHandler(({url:De})=>(this.b?.openExternal(void 0,De),{action:"deny"}))});let ke=[],Ie;I.app.on("open-file",(be,Ee)=>{this.h.trace("app#open-file: ",Ee),be.preventDefault(),ke.push((0,Se.hasWorkspaceFileExtension)(Ee)?{workspaceUri:u.URI.file(Ee)}:{fileUri:u.URI.file(Ee)}),Ie!==void 0&&(clearTimeout(Ie),Ie=void 0),Ie=setTimeout(async()=>{await this.a?.open({context:1,cli:this.i.args,urisToOpen:ke,gotoLineMode:!1,preferNewWindow:!0}),ke=[],Ie=void 0},100)}),I.app.on("new-window-for-tab",async()=>{await this.a?.openEmptyWindow({context:4})}),A.validatedIpcMain.handle("vscode:fetchShellEnv",be=>{const Ee=this.a?.getWindowByWebContents(be.sender);let De,je;return Ee?.config?(De=Ee.config,je={...process.env,...Ee.config.userEnv}):(De=this.i.args,je=process.env),this.M(De,je,!1)}),A.validatedIpcMain.handle("vscode:writeNlsFile",(be,Ee,De)=>{const je=this.t([Ee]);if(!je||typeof De!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.m.writeFile(je,C.VSBuffer.fromString(De))}),A.validatedIpcMain.handle("vscode:readNlsFile",async(be,...Ee)=>{const De=this.t(Ee);if(!De)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.m.readFile(De)).value.toString()}),A.validatedIpcMain.on("vscode:toggleDevTools",be=>be.sender.toggleDevTools()),A.validatedIpcMain.on("vscode:openDevTools",be=>be.sender.openDevTools()),A.validatedIpcMain.on("vscode:reloadWindow",be=>be.sender.reload())}t(ke){let Ie;for(const be of ke)typeof be=="string"&&(typeof Ie!="string"?Ie=be:Ie=(0,m.join)(Ie,be));if(!(typeof Ie!="string"||!(0,m.isAbsolute)(Ie)||!(0,f.isEqualOrParent)(Ie,this.i.cachedLanguagesPath,!w.isLinux)))return u.URI.file(Ie)}u(ke){if(ke){const Ie={message:`[uncaught exception in main]: ${ke.message}`,stack:ke.stack};this.a?.sendToFocused("vscode:reportError",JSON.stringify(Ie))}this.h.error(`[uncaught exception in main]: ${ke}`),ke.stack&&this.h.error(ke.stack)}async startup(){this.h.debug("Starting VS Code"),this.h.debug(`from: ${this.i.appRoot}`),this.h.debug("args:",this.i.args);const ke=this.n.win32AppUserModelId;w.isWindows&&ke&&I.app.setAppUserModelId(ke);try{w.isMacintosh&&this.k.getValue("window.nativeTabs")===!0&&!I.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&I.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Be){this.h.error(Be)}const Ie=new M.Server;this.j.onWillShutdown(Be=>{Be.reason===2&&Ie.dispose()}),this.h.trace("Resolving machine identifier...");const be=await(0,Ot.resolveMachineId)(this.l);this.h.trace(`Resolved machine identifier: ${be}`);const{sharedProcess:Ee,sharedProcessReady:De,sharedProcessClient:je}=this.D(be),Xe=await this.F(be,Ee,De);this.B(Xe.createInstance(a.ProxyAuthHandler)),this.B(Xe.createInstance(At.UserDataProfilesHandler)),Xe.invokeFunction(Be=>this.G(Be,Ie,je));const Ye=Xe.invokeFunction(Be=>this.v(Be,Ie));this.j.phase=2,await Xe.invokeFunction(Be=>this.H(Be,Ye)),this.j.phase=3,Xe.invokeFunction(Be=>this.I(Be,Ee)),this.B(new gt.RunOnceScheduler(()=>{this.B((0,gt.runWhenIdle)(()=>this.j.phase=4,2500))},2500)).schedule()}v(ke,Ie){const be=this.a=ke.get(le.IWindowsMainService),Ee=ke.get(Ne.IURLService),De=this.b=ke.get(q.INativeHostMainService),je=this;Ee.registerHandler({async handleURL(Je,Ze){return je.C(be,Ee,Je,Ze)}});const Xe=this.B(new me.ActiveWindowManager({onDidOpenWindow:De.onDidOpenWindow,onDidFocusWindow:De.onDidFocusWindow,getActiveWindowId:()=>De.getActiveWindowId(-1)})),Ye=new E.StaticRouter(Je=>Xe.getActiveClientId().then(Ze=>Je===Ze)),qe=new $e.URLHandlerRouter(Ye,this.h),Be=Ie.getChannel("urlHandler",qe);Ee.registerHandler(new $e.URLHandlerChannelClient(Be));const xe=this.w();return this.B(new We.ElectronURLListener(xe?.urls,Ee,be,this.i,this.n,this.h)),xe}w(){const ke=this.i.args["open-url"]?this.i.args._urls||[]:[];ke.length>0&&this.h.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",ke);const Ie=global.getOpenUrls()||[];if(Ie.length>0&&this.h.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",Ie),ke.length+Ie.length===0)return;const be=[];return{urls:[...ke,...Ie].map(De=>{try{return{uri:u.URI.parse(De),originalUrl:De}}catch{this.h.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",De);return}}).filter(De=>{if(!De)return!1;if(this.y(De.uri))return this.h.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",De.uri.toString(!0)),!1;const je=this.z(De.uri);return je?(this.h.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",De.uri.toString(!0),je),be.push(je),!1):(this.h.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",De.uri.toString(!0)),!0)}),openables:be}}y(ke){if(ke.authority===g.Schemas.file&&w.isWindows){const{options:Ie,buttonIndeces:be}=(0,Wt.massageMessageBoxOptions)({type:"question",buttons:[(0,i.localize)(0,null),(0,i.localize)(1,null)],message:(0,i.localize)(2,null,(0,v.getPathLabel)(ke,{os:w.OS,tildify:this.i}),this.n.nameShort),detail:(0,i.localize)(3,null)},this.n);if(be[I.dialog.showMessageBoxSync(Ie)]===1)return!0}return!1}z(ke){if(!!ke.path){if(ke.authority===g.Schemas.file){const Ie=u.URI.file(ke.fsPath);return(0,Se.hasWorkspaceFileExtension)(Ie)?{workspaceUri:Ie}:{fileUri:Ie}}else if(ke.authority===g.Schemas.vscodeRemote){const Ie=ke.path.indexOf(m.posix.sep,1);if(Ie!==-1){const be=ke.path.substring(1,Ie),Ee=ke.path.substring(Ie),De=u.URI.from({scheme:g.Schemas.vscodeRemote,authority:be,path:Ee,query:ke.query,fragment:ke.fragment});return(0,Se.hasWorkspaceFileExtension)(Ee)?{workspaceUri:De}:/:[\d]+$/.test(Ee)?{fileUri:De}:{folderUri:De}}}}}async C(ke,Ie,be,Ee){if(this.h.trace("app#handleProtocolUrl():",be.toString(!0),Ee),be.scheme===this.n.urlProtocol&&be.path==="workspace"&&(be=be.with({authority:"file",path:u.URI.parse(be.query).path,query:""})),this.y(be))return this.h.trace("app#handleProtocolUrl() protocol url was blocked:",be.toString(!0)),!0;let De=!1;const je=new URLSearchParams(be.query);je.get("windowId")==="_blank"?(this.h.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",be.toString(!0)),je.delete("windowId"),be=be.with({query:je.toString()}),De=!0):w.isMacintosh&&ke.getWindowCount()===0&&(this.h.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",be.toString(!0)),De=!0);const Xe=je.get("continueOn");Xe!==null&&(this.h.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",be.toString(!0)),je.delete("continueOn"),be=be.with({query:je.toString()}),this.i.continueOn=Xe??void 0);const Ye=this.z(be);if(Ye){this.h.trace("app#handleProtocolUrl() opening protocol url as window:",Ye,be.toString(!0));const[qe]=await ke.open({context:5,cli:{...this.i.args},urisToOpen:[Ye],forceNewWindow:De,gotoLineMode:!0});return qe.focus(),!0}if(De){this.h.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",be.toString(!0));const[qe]=await ke.open({context:5,cli:{...this.i.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,de.getRemoteAuthority)(be)});return await qe.ready(),Ie.open(be,Ee)}return this.h.trace("app#handleProtocolUrl(): not handled",be.toString(!0),Ee),!1}D(ke){const Ie=this.B(this.g.createInstance(pe.SharedProcess,ke,this.f)),be=(async()=>{this.h.trace("Main->SharedProcess#connect");const De=await Ie.connect();return this.h.trace("Main->SharedProcess#connect: connection established"),new t.Client(De,"main")})(),Ee=(async()=>(await Ie.whenReady(),be))();return{sharedProcess:Ie,sharedProcessReady:Ee,sharedProcessClient:be}}async F(ke,Ie,be){const Ee=new U.ServiceCollection;switch(process.platform){case"win32":Ee.set(he.IUpdateService,new se.SyncDescriptor(He.Win32UpdateService));break;case"linux":w.isLinuxSnap?Ee.set(he.IUpdateService,new se.SyncDescriptor(Ue.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):Ee.set(he.IUpdateService,new se.SyncDescriptor(Ae.LinuxUpdateService));break;case"darwin":Ee.set(he.IUpdateService,new se.SyncDescriptor(Me.DarwinUpdateService));break}Ee.set(le.IWindowsMainService,new se.SyncDescriptor(ue.WindowsMainService,[ke,this.f],!1));const De=new O.DialogMainService(this.h);Ee.set(O.IDialogMainService,De),Ee.set(B.ILaunchMainService,new se.SyncDescriptor(B.LaunchMainService,void 0,!1)),Ee.set(R.IDiagnosticsMainService,new se.SyncDescriptor(R.DiagnosticsMainService,void 0,!1)),Ee.set(S.IDiagnosticsService,E.ProxyChannel.toService((0,E.getDelayedChannel)(be.then(Ye=>Ye.getChannel("diagnostics"))))),Ee.set(L.IIssueMainService,new se.SyncDescriptor(L.IssueMainService,[this.f])),Ee.set(N.IEncryptionMainService,new se.SyncDescriptor(K.EncryptionMainService,[ke])),Ee.set(T.IKeyboardLayoutMainService,new se.SyncDescriptor(T.KeyboardLayoutMainService)),Ee.set(q.INativeHostMainService,new se.SyncDescriptor(q.NativeHostMainService,[Ie],!1)),Ee.set(s.ICredentialsMainService,new se.SyncDescriptor(Ke.CredentialsNativeMainService)),Ee.set(Ve.IWebviewManagerService,new se.SyncDescriptor(Y.WebviewMainService)),Ee.set($.IMenubarMainService,new se.SyncDescriptor($.MenubarMainService)),Ee.set(re.IExtensionUrlTrustService,new se.SyncDescriptor(ce.ExtensionUrlTrustService)),Ee.set(fe.IExtensionHostStarter,new se.SyncDescriptor(ge.ExtensionHostStarter)),Ee.set(Te.IStorageMainService,new se.SyncDescriptor(Te.StorageMainService)),Ee.set(Te.IApplicationStorageMainService,new se.SyncDescriptor(Te.ApplicationStorageMainService)),w.isWindows?Ee.set(x.IExternalTerminalMainService,new se.SyncDescriptor(F.WindowsExternalTerminalService)):w.isMacintosh?Ee.set(x.IExternalTerminalMainService,new se.SyncDescriptor(F.MacExternalTerminalService)):w.isLinux&&Ee.set(x.IExternalTerminalMainService,new se.SyncDescriptor(F.LinuxExternalTerminalService));const je=new c.BackupMainService(this.i,this.k,this.h,this.l);Ee.set(r.IBackupMainService,je);const Xe=new Qe.WorkspacesManagementMainService(this.i,this.h,this.p,je,De,this.n);if(Ee.set(Qe.IWorkspacesManagementMainService,Xe),Ee.set(Oe.IWorkspacesService,new se.SyncDescriptor(tt.WorkspacesMainService,void 0,!1)),Ee.set(ze.IWorkspacesHistoryMainService,new se.SyncDescriptor(ze.WorkspacesHistoryMainService,void 0,!1)),Ee.set(Ne.IURLService,new se.SyncDescriptor(Ge.NativeURLService,void 0,!1)),(0,ae.supportsTelemetry)(this.n,this.i)){const Ye=(0,ae.isInternalTelemetry)(this.n,this.k),qe=(0,E.getDelayedChannel)(be.then(st=>st.getChannel("telemetryAppender"))),Be=new Re.TelemetryAppenderClient(qe),xe=(0,we.resolveCommonProperties)(this.m,(0,n.release)(),(0,n.hostname)(),process.arch,this.n.commit,this.n.version,ke,Ye,this.i.installSourcePath),Je=(0,ae.getPiiPathsFromEnvironment)(this.i),Ze={appenders:[Be],commonProperties:xe,piiPaths:Je,sendErrorTelemetry:!0};Ee.set(Ce.ITelemetryService,new se.SyncDescriptor(Q.TelemetryService,[Ze],!1))}else Ee.set(Ce.ITelemetryService,ae.NullTelemetryService);return Ee.set(Ct.IExtensionsProfileScannerService,new se.SyncDescriptor(Tt.ExtensionsProfileScannerService,void 0,!0)),Ee.set(Rt.IExtensionsScannerService,new se.SyncDescriptor(Mt.ExtensionsScannerService,void 0,!0)),await gt.Promises.settled([je.initialize(),Xe.initialize()]),this.g.createChild(Ee)}G(ke,Ie,be){const Ee=E.ProxyChannel.fromService(ke.get(B.ILaunchMainService),{disableMarshalling:!0});this.c.registerChannel("launch",Ee);const De=E.ProxyChannel.fromService(ke.get(R.IDiagnosticsMainService),{disableMarshalling:!0});this.c.registerChannel("diagnostics",De);const je=new it.PolicyChannel(ke.get(et.IPolicyService));Ie.registerChannel("policy",je),be.then(_e=>_e.registerChannel("policy",je));const Xe=this.m.getProvider(g.Schemas.file);(0,o.assertType)(Xe instanceof ne.DiskFileSystemProvider);const Ye=new J.DiskFileSystemProviderChannel(Xe,this.h,this.i);Ie.registerChannel(W.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Ye),be.then(_e=>_e.registerChannel(W.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Ye));const qe=E.ProxyChannel.fromService(ke.get(ot.IUserDataProfilesMainService));Ie.registerChannel("userDataProfiles",qe),be.then(_e=>_e.registerChannel("userDataProfiles",qe));const Be=new ut.RequestChannel(ke.get(Dt.IRequestService));be.then(_e=>_e.registerChannel("request",Be));const xe=new Pe.UpdateChannel(ke.get(he.IUpdateService));Ie.registerChannel("update",xe);const Je=E.ProxyChannel.fromService(ke.get(L.IIssueMainService));Ie.registerChannel("issue",Je);const Ze=E.ProxyChannel.fromService(ke.get(N.IEncryptionMainService));Ie.registerChannel("encryption",Ze);const st=E.ProxyChannel.fromService(ke.get(s.ICredentialsMainService));Ie.registerChannel("credentials",st);const rt=E.ProxyChannel.fromService(ke.get(ye.ISignService));Ie.registerChannel("sign",rt);const ht=E.ProxyChannel.fromService(ke.get(T.IKeyboardLayoutMainService));Ie.registerChannel("keyboardLayout",ht),this.b=ke.get(q.INativeHostMainService);const yt=E.ProxyChannel.fromService(this.b);Ie.registerChannel("nativeHost",yt),be.then(_e=>_e.registerChannel("nativeHost",yt));const Nt=E.ProxyChannel.fromService(ke.get(Oe.IWorkspacesService));Ie.registerChannel("workspaces",Nt);const jt=E.ProxyChannel.fromService(ke.get($.IMenubarMainService));Ie.registerChannel("menubar",jt);const Bt=E.ProxyChannel.fromService(ke.get(Ne.IURLService));Ie.registerChannel("url",Bt);const $t=E.ProxyChannel.fromService(ke.get(re.IExtensionUrlTrustService));Ie.registerChannel("extensionUrlTrust",$t);const zt=E.ProxyChannel.fromService(ke.get(Ve.IWebviewManagerService));Ie.registerChannel("webview",zt);const St=this.B(new Fe.StorageDatabaseChannel(this.h,ke.get(Te.IStorageMainService)));Ie.registerChannel("storage",St),be.then(_e=>_e.registerChannel("storage",St));const qt=this.B(new Lt.ProfileStorageChangesListenerChannel(ke.get(Te.IStorageMainService),ke.get(ot.IUserDataProfilesMainService),this.h));be.then(_e=>_e.registerChannel("profileStorageListener",qt));const Ht=E.ProxyChannel.fromService(ke.get(x.IExternalTerminalMainService));Ie.registerChannel("externalTerminal",Ht);const Et=new Ft.LoggerChannel(ke.get(Ut.ILoggerMainService));Ie.registerChannel("logger",Et),be.then(_e=>_e.registerChannel("logger",Et));const Vt=new d.ElectronExtensionHostDebugBroadcastChannel(ke.get(le.IWindowsMainService));Ie.registerChannel("extensionhostdebugservice",Vt);const xt=E.ProxyChannel.fromService(ke.get(fe.IExtensionHostStarter));Ie.registerChannel(fe.ipcExtensionHostStarterChannelName,xt)}async H(ke,Ie){const be=this.a=ke.get(le.IWindowsMainService),Ee=(0,X.isLaunchedFromCli)(process.env)?0:4,De=this.i.args;if(Ie){if(Ie.openables.length>0)return be.open({context:Ee,cli:De,urisToOpen:Ie.openables,gotoLineMode:!0,initialStartup:!0});if(Ie.urls.length>0)for(const rt of Ie.urls){const ht=new URLSearchParams(rt.uri.query);if(ht.get("windowId")==="_blank")return ht.delete("windowId"),rt.originalUrl=rt.uri.toString(!0),rt.uri=rt.uri.with({query:ht.toString()}),be.open({context:Ee,cli:De,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const je=global.macOpenFiles,Xe=De._.length,Ye=!!De["folder-uri"],qe=!!De["file-uri"],Be=De["skip-add-to-recently-opened"]===!0,xe=De.wait&&De.waitMarkerFilePath?u.URI.file(De.waitMarkerFilePath):void 0,Je=De.remote||void 0,Ze=De.profile,st=De["profile-temp"];if(!Xe&&!Ye&&!qe){if(De["new-window"]||Ze||st)return be.open({context:Ee,cli:De,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Be,waitMarkerFileURI:xe,initialStartup:!0,remoteAuthority:Je,forceProfile:Ze,forceTempProfile:st});if(je.length)return be.open({context:1,cli:De,urisToOpen:je.map(rt=>(0,Se.hasWorkspaceFileExtension)(rt)?{workspaceUri:u.URI.file(rt)}:{fileUri:u.URI.file(rt)}),noRecentEntry:Be,waitMarkerFileURI:xe,initialStartup:!0})}return be.open({context:Ee,cli:De,forceNewWindow:De["new-window"]||!Xe&&De["unity-launch"],diffMode:De.diff,mergeMode:De.merge,noRecentEntry:Be,waitMarkerFileURI:xe,gotoLineMode:De.goto,initialStartup:!0,remoteAuthority:Je,forceProfile:Ze,forceTempProfile:st})}I(ke,Ie){const be=ke.get(Ce.ITelemetryService),Ee=ke.get(he.IUpdateService);this.L(be,Ie),this.J(),I.protocol.registerHttpProtocol(g.Schemas.vscodeRemoteResource,(De,je)=>{je({url:De.url.replace(/^vscode-remote-resource:/,"http:"),method:De.method})}),(Ee instanceof He.Win32UpdateService||Ee instanceof Ae.LinuxUpdateService||Ee instanceof Me.DarwinUpdateService)&&Ee.initialize(),this.M(this.i.args,process.env,!0),this.N()}async J(){const ke=this.n.win32MutexName;if(w.isWindows&&ke)try{const Ie=await new Promise((Ee,De)=>{G(["windows-mutex"],Ee,De)}),be=new Ie.Mutex(ke);(0,h.once)(this.j.onWillShutdown)(()=>be.release())}catch(Ie){this.h.error(Ie)}}L(ke,Ie){let be=!1;(0,h.once)(this.j.onWillShutdown)(()=>be=!0),this.B(Ie.onDidError(({type:Ee,details:De})=>{let je;switch(Ee){case 1:je="SharedProcess: detected unresponsive window";break;case 2:je=`SharedProcess: renderer process gone (detail: ${De?.reason??"<unknown>"}, code: ${De?.exitCode??"<unknown>"})`;break;case 3:je=`SharedProcess: failed to load (detail: ${De?.reason??"<unknown>"}, code: ${De?.exitCode??"<unknown>"})`;break}(0,P.onUnexpectedError)(new Error(je)),ke.publicLog2("sharedprocesserror",{type:Ee,reason:De?.reason,code:De?.exitCode,visible:Ie.isVisible(),shuttingdown:be})}))}async M(ke,Ie,be){try{return await(0,ie.getResolvedShellEnv)(this.k,this.h,ke,Ie)}catch(Ee){const De=(0,D.toErrorMessage)(Ee);be?this.a?.sendToFocused("vscode:showResolveShellEnvError",De):this.h.error(De)}return{}}async N(){try{const Ie=(await this.m.readFile(this.i.argvResource)).value.toString(),be=JSON.parse((0,b.stripComments)(Ie)),De=(0,ae.getTelemetryLevel)(this.k)>=1;if(be["enable-crash-reporter"]===void 0){const je=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${De},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,p.generateUuid)()}"`,"}"],Xe=Ie.substring(0,Ie.length-2).concat(`,
`,je.join(`
`));await this.m.writeFile(this.i.argvResource,C.VSBuffer.fromString(Xe))}else{const je=Ie.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${De},`);je!==Ie&&await this.m.writeFile(this.i.argvResource,C.VSBuffer.fromString(je))}}catch(ke){this.h.error(ke)}}};mt=ve([_(2,Z.IInstantiationService),_(3,j.ILogService),_(4,V.IEnvironmentMainService),_(5,H.ILifecycleMainService),_(6,l.IConfigurationService),_(7,Le.IStateMainService),_(8,z.IFileService),_(9,oe.IProductService),_(10,ot.IUserDataProfilesMainService)],mt),e.CodeApplication=mt}),define(ee[284],te([0,1,37,8,291,2,5]),function(G,e,I,A,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let P=class extends I.AbstractPolicyService{constructor(h,b){super(),this.j=h,this.k=b,this.a=new A.Throttler,this.b=this.B(new C.MutableDisposable)}async i(h){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(h).length} policy definitions`),await this.a.queue(()=>new Promise((b,v)=>{try{this.b.value=(0,n.createWatcher)(this.k,h,y=>{this.m(y),b()})}catch(y){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",y),v(y)}}))}m(h){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(h)}`);for(const b in h){const v=h[b];v===void 0?this.g.delete(b):this.g.set(b,v)}this.h.fire(Object.keys(h))}};P=ve([_(0,D.ILogService)],P),e.NativePolicyService=P}),define(ee[285],te([0,1,233,8,17,13,2,10,19,33,112,5,232,292]),function(G,e,I,A,n,C,D,P,f,h,b,v,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let m=class extends D.Disposable{constructor(o,u,p){super(),this.h=o,this.i=u,this.j=p,this.k(),this.B(o.onDidChangeConfiguration(k=>{k.affectsConfiguration("http")&&this.k()}))}k(){const o=this.h.getValue("http");this.a=o?.proxy,this.b=!!o?.proxyStrictSSL,this.f=o?.proxyAuthorization}async request(o,u){this.j.trace("RequestService#request (node) - begin",o.url);const{a:p,b:k}=this;let E;try{E=await(0,b.getResolvedShellEnv)(this.h,this.j,this.i.args,process.env)}catch(a){this.g||(this.g=!0,this.j.error("RequestService#request (node) resolving shell environment failed",a))}const M={...process.env,...E},t=o.agent?o.agent:await(0,y.getProxyAgent)(o.url||"",M,{proxyUrl:p,strictSSL:k});o.agent=t,o.strictSSL=k,this.f&&(o.headers={...o.headers||{},"Proxy-Authorization":this.f});try{const a=await this.m(o,u);return this.j.trace("RequestService#request (node) - success",o.url),a}catch(a){throw this.j.trace("RequestService#request (node) - error",o.url,a),a}}async l(o){return((0,I.parse)(o.url).protocol==="https:"?await new Promise((k,E)=>{G(["https"],k,E)}):await new Promise((k,E)=>{G(["http"],k,E)})).request}m(o,u){return A.Promises.withAsyncBody(async(p,k)=>{const E=(0,I.parse)(o.url),M=o.getRawRequest?o.getRawRequest(o):await this.l(o),t={hostname:E.hostname,port:E.port?parseInt(E.port):E.protocol==="https:"?443:80,protocol:E.protocol,path:E.path,method:o.type||"GET",headers:o.headers,agent:o.agent,rejectUnauthorized:(0,P.isBoolean)(o.strictSSL)?o.strictSSL:!0};o.user&&o.password&&(t.auth=o.user+":"+o.password);const a=M(t,i=>{const r=(0,P.isNumber)(o.followRedirects)?o.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&r>0&&i.headers.location)this.m({...o,url:i.headers.location,followRedirects:r-1},u).then(p,k);else{let c=i;!o.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(c=i.pipe((0,g.createGunzip)())),p({res:i,stream:(0,n.streamToBufferReadableStream)(c)})}});a.on("error",k),o.timeout&&a.setTimeout(o.timeout),o.isChromiumNetwork&&a.removeHeader("Content-Length"),o.data&&typeof o.data=="string"&&a.write(o.data),a.end(),u.onCancellationRequested(()=>{a.abort(),k(new C.CancellationError)})})}async resolveProxy(o){}};m=ve([_(0,f.IConfigurationService),_(1,h.INativeEnvironmentService),_(2,v.ILogService)],m),e.RequestService=m}),define(ee[286],te([0,1,14,285]),function(G,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function n(D){return I.net.request}class C extends A.RequestService{request(P,f){return super.request({...P||{},getRawRequest:n,isChromiumNetwork:!0},f)}}e.RequestMainService=C}),define(ee[293],te([0,1,14,41,7,25,8,44,13,32,50,45,15,9,64,4,36,27,23,47,87,283,11,19,226,239,28,62,190,16,211,90,74,207,89,21,214,5,66,20,67,267,116,245,57,286,92,234,34,238,52,69,53,37,284,220,2,38,250,65,215,48,246]),function(G,e,I,A,n,C,D,P,f,h,b,v,y,g,m,w,o,u,p,k,E,M,t,a,i,r,c,l,s,d,S,R,O,N,K,V,X,ie,re,ce,fe,ge,x,F,W,z,J,ne,se,Z,U,L,T,B,H,j,$,q,oe,de,pe,ye){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Le{main(){try{this.a()}catch(we){console.error(we.message),I.app.exit(1)}}async a(){(0,f.setUnexpectedErrorHandler)(Ae=>console.error(Ae));const[we,Ce,Re,Q,ae,he,Pe,Me]=this.b();try{try{await this.d(Re,Me,Q,ae,Pe)}catch(Ae){throw this.f(Re,Pe,Ae),Ae}await we.invokeFunction(async Ae=>{const Ue=Ae.get(ie.ILogService),He=Ae.get(V.ILifecycleMainService),Ne=Ae.get(d.IFileService),$e=Ae.get(ie.ILoggerService),Ge=await this.e(Ue,Re,He,we,Pe,!0);return p.Promises.writeFile(Re.mainLockfile,String(process.pid)).catch(We=>{Ue.warn(`Error writing main lockfile: ${We.stack}`)}),he.logger=$e.createLogger(n.URI.file((0,g.join)(Re.logsPath,"main.log")),{id:"mainLog",name:(0,t.localize)(0,null)}),(0,b.once)(He.onWillShutdown)(We=>{Ne.dispose(),Q.dispose(),We.join(p.Promises.unlink(Re.mainLockfile).catch(()=>{}))}),we.createInstance(M.CodeApplication,Ge,Ce).startup()})}catch(Ae){we.invokeFunction(this.i,Ae)}}b(){const we=new K.ServiceCollection,Ce=new $.DisposableStore;process.once("exit",()=>Ce.dispose());const Re={_serviceBrand:void 0,...re.default};we.set(ce.IProductService,Re);const Q=new c.EnvironmentMainService(this.j(),Re),ae=this.c(Q);we.set(c.IEnvironmentMainService,Q);const he=new de.LoggerMainService((0,ie.getLogLevel)(Q));we.set(de.ILoggerMainService,he);const Pe=new X.BufferLogger(he.getLogLevel()),Me=Ce.add(new pe.LogService(Pe,[new ie.ConsoleMainLogger(he.getLogLevel())]));we.set(ie.ILogService,Me);const Ae=new S.FileService(Me);we.set(d.IFileService,Ae);const Ue=new R.DiskFileSystemProvider(Me);Ae.registerProvider(y.Schemas.file,Ue);const He=new oe.UriIdentityService(Ae);we.set(q.IUriIdentityService,He);const Ne=new Z.StateMainService(Q,Me,Ae);we.set(se.IStateMainService,Ne);const $e=new T.UserDataProfilesMainService(Ne,He,Q,Ae,Me);we.set(T.IUserDataProfilesMainService,$e);const Ge=w.isWindows&&Re.win32RegValueName?Ce.add(new H.NativePolicyService(Me,Re.win32RegValueName)):Q.policyFile?Ce.add(new j.FilePolicyService(Q.policyFile,Ae,Me)):new B.NullPolicyService;we.set(B.IPolicyService,Ge);const We=new i.ConfigurationService($e.defaultProfile.settingsResource,Ae,Ge,Me);return we.set(a.IConfigurationService,We),we.set(V.ILifecycleMainService,new O.SyncDescriptor(V.LifecycleMainService,void 0,!1)),we.set(W.IRequestService,new O.SyncDescriptor(z.RequestMainService,void 0,!0)),we.set(L.IThemeMainService,new O.SyncDescriptor(L.ThemeMainService)),we.set(J.ISignService,new O.SyncDescriptor(ne.SignService,void 0,!1)),we.set(x.ITunnelService,new O.SyncDescriptor(F.TunnelService)),we.set(fe.IProtocolMainService,new ge.ProtocolMainService(Q,$e,Me)),[new N.InstantiationService(we,!0),ae,Q,We,Ne,Pe,Re,$e]}c(we){const Ce={VSCODE_IPC_HOOK:we.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(Re=>{const Q=process.env[Re];typeof Q=="string"&&(Ce[Re]=Q)}),Object.assign(process.env,Ce),Ce}async d(we,Ce,Re,Q,ae){await D.Promises.settled([Promise.all([we.extensionsPath,we.codeCachePath,we.logsPath,Ce.defaultProfile.globalStorageHome.fsPath,we.workspaceStorageHome.fsPath,we.localHistoryHome.fsPath,we.backupHome].map(he=>he?p.Promises.mkdir(he,{recursive:!0}):void 0)),Q.init(),Re.initialize()]),Ce.init()}async e(we,Ce,Re,Q,ae,he){let Pe;try{(0,m.mark)("code/willStartMainServer"),Pe=await(0,E.serve)(Ce.mainIPCHandle),(0,m.mark)("code/didStartMainServer"),(0,b.once)(Re.onWillShutdown)(()=>Pe.dispose())}catch(Me){if(Me.code!=="EADDRINUSE")throw this.f(Ce,ae,Me),Me;let Ae;try{Ae=await(0,E.connect)(Ce.mainIPCHandle,"main")}catch($e){if(!he||w.isWindows||$e.code!=="ECONNREFUSED")throw $e.code==="EPERM"&&this.g((0,t.localize)(1,null,ae.nameShort),(0,t.localize)(2,null),ae),$e;try{(0,A.unlinkSync)(Ce.mainIPCHandle)}catch(Ge){throw we.warn("Could not delete obsolete instance handle",Ge),Ge}return this.e(we,Ce,Re,Q,ae,!1)}if(Ce.extensionTestsLocationURI&&!Ce.debugExtensionHost.break){const $e=`Running extension tests from the command line is currently only supported if no other instance of ${ae.nameShort} is running.`;throw we.error($e),Ae.dispose(),new Error($e)}let Ue;!Ce.args.wait&&!Ce.args.status&&(Ue=setTimeout(()=>{this.g((0,t.localize)(3,null,ae.nameShort),(0,t.localize)(4,null),ae)},1e4));const He=k.ProxyChannel.toService(Ae.getChannel("launch"),{disableMarshalling:!0}),Ne=k.ProxyChannel.toService(Ae.getChannel("diagnostics"),{disableMarshalling:!0});if(Ce.args.status)return Q.invokeFunction(async()=>{const $e=new r.DiagnosticsService(U.NullTelemetryService,ae),Ge=await Ne.getMainDiagnostics(),We=await Ne.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Ve=await $e.getDiagnostics(Ge,We);throw console.log(Ve),new f.ExpectedError});throw w.isWindows&&await this.h(He,we),we.trace("Sending env to running instance..."),await He.start(Ce.args,process.env),Ae.dispose(),Ue&&clearTimeout(Ue),new f.ExpectedError("Sent env to running instance. Terminating...")}if(Ce.args.status)throw we.warn(`Warning: The --status argument can only be used if ${ae.nameShort} is already running. Please run it again after {0} has started.`),new f.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Pe}f(we,Ce,Re){if(Re.code==="EACCES"||Re.code==="EPERM"){const Q=(0,C.coalesce)([we.userDataPath,we.extensionsPath,E.XDG_RUNTIME_DIR]).map(ae=>(0,v.getPathLabel)(n.URI.file(ae),{os:w.OS,tildify:we}));this.g((0,t.localize)(5,null),(0,t.localize)(6,null,(0,P.toErrorMessage)(Re),Q.join(`
`)),Ce)}}g(we,Ce,Re){I.dialog.showMessageBoxSync((0,ye.massageMessageBoxOptions)({type:"warning",buttons:[(0,t.localize)(7,null)],message:we,detail:Ce},Re).options)}async h(we,Ce){if(w.isWindows){const Re=await we.getMainProcessId();Ce.trace("Sending some foreground love to the running instance:",Re);try{(await new Promise((Q,ae)=>{G(["windows-foreground-love"],Q,ae)})).allowSetForegroundWindow(Re)}catch(Q){Ce.error(Q)}}}i(we,Ce){const Re=we.get(ie.ILogService),Q=we.get(V.ILifecycleMainService);let ae=0;Ce&&(Ce.isExpected?Ce.message&&Re.trace(Ce.message):(ae=1,Ce.stack?Re.error(Ce.stack):Re.error(`Startup error: ${Ce.toString()}`))),Q.kill(ae)}j(){const we=this.k((0,l.parseMainProcessArgv)(process.argv));if(we.wait&&!we.waitMarkerFilePath){const Ce=(0,s.createWaitMarkerFileSync)(we.verbose);Ce&&((0,l.addArg)(process.argv,"--waitMarkerFilePath",Ce),we.waitMarkerFilePath=Ce)}return we}k(we){if(we["open-url"]&&(we._urls=we._,we._=[]),!we.remote){const Ce=this.l(we._,we.goto);we._=Ce}return we}l(we,Ce){const Re=(0,o.cwd)(),Q=we.map(Pe=>{let Me=String(Pe),Ae;Ce&&(Ae=(0,h.parseLineAndColumnAware)(Me),Me=Ae.path),Me&&(Me=this.m(Re,Me));const Ue=(0,h.sanitizeFilePath)(Me,Re),He=(0,g.basename)(Ue);return He&&!(0,h.isValidBasename)(He)?null:Ce&&Ae?(Ae.path=Ue,this.n(Ae)):Ue}),ae=w.isWindows||w.isMacintosh,he=(0,C.distinct)(Q,Pe=>Pe&&ae?Pe.toLowerCase():Pe||"");return(0,C.coalesce)(he)}m(we,Ce){return w.isWindows&&(Ce=(0,u.rtrim)(Ce,'"')),Ce=(0,u.trim)((0,u.trim)(Ce," "),"	"),w.isWindows&&(Ce=(0,g.resolve)(we,Ce),Ce=(0,u.rtrim)(Ce,".")),Ce}n(we){const Ce=[we.path];return typeof we.line=="number"&&Ce.push(String(we.line)),typeof we.column=="number"&&Ce.push(String(we.column)),Ce.join(":")}}new Le().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/5625ecc99a2a591640eab01e8fd2c308e439f0a2/core/vs/code/electron-main/main.js.map
